/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/platform/log/common/log","vs/base/node/pfs","vs/base/common/errors","fs","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/configuration/common/configurationRegistry","vs/base/common/errorMessage","vs/base/common/uuid","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","child_process","vs/base/common/process","vs/platform/extensions/common/extensions","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/map","vs/base/node/decoder","vs/base/parts/ipc/node/ipc.cp","os","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/request/common/request","vs/platform/product/common/product","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","path","vs/base/common/performance","vs/base/common/iterator","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function(q){for(var t=[],p=0,C=q.length;p<C;p++)t[p]=Q[q[p]];return t};define(Q[55],Z([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function p(C,L){if(!C)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}t.ok=p}),define(Q[56],Z([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0;function p(h){return(f,O,d)=>{let E=null,y=null;if(typeof d.value=="function"?(E="value",y=d.value):typeof d.get=="function"&&(E="get",y=d.get),!y)throw new Error("not supported");d[E]=h(y,O)}}t.createDecorator=p;let C=0;function L(){const h=`$memoize${C++}`;let f;const O=function(E,y,u){let w=null,v=null;if(typeof u.value=="function"?(w="value",v=u.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(w="get",v=u.get),!v)throw new Error("not supported");const m=`${h}:${y}`;u[w]=function(...I){return f=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:v.apply(this,I)}),this[m]}};return O.clear=()=>{typeof f!="undefined"&&Object.getOwnPropertyNames(f).forEach(d=>{d.indexOf(h)===0&&delete f[d]})},O}t.createMemoizer=L;function b(h,f,O){return L()(h,f,O)}t.memoize=b;function T(h,f,O){return p((d,E)=>{const y=`$debounce$${E}`,u=`$debounce$result$${E}`;return function(...w){this[u]||(this[u]=O?O():void 0),clearTimeout(this[y]),f&&(this[u]=f(this[u],...w),w=[this[u]]),this[y]=setTimeout(()=>{d.apply(this,w),this[u]=O?O():void 0},h)}})}t.debounce=T;function R(h,f,O){return p((d,E)=>{const y=`$throttle$timer$${E}`,u=`$throttle$result$${E}`,w=`$throttle$lastRun$${E}`,v=`$throttle$pending$${E}`;return function(...m){if(this[u]||(this[u]=O?O():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),f&&(this[u]=f(this[u],...m)),!this[v]){const I=this[w]+h;I<=Date.now()?(this[w]=Date.now(),d.apply(this,[this[u]]),this[u]=O?O():void 0):(this[v]=!0,this[y]=setTimeout(()=>{this[v]=!1,this[w]=Date.now(),d.apply(this,[this[u]]),this[u]=O?O():void 0},I-Date.now()))}}})}t.throttle=R}),define(Q[23],Z([0,1,14]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function C(_,G=0){return _[_.length-(1+G)]}t.tail=C;function L(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}t.tail2=L;function b(_,G,B=(l,c)=>l===c){if(_===G)return!0;if(!_||!G||_.length!==G.length)return!1;for(let l=0,c=_.length;l<c;l++)if(!B(_[l],G[l]))return!1;return!0}t.equals=b;function T(_,G,B){let l=0,c=_.length-1;for(;l<=c;){const S=(l+c)/2|0,P=B(_[S],G);if(P<0)l=S+1;else if(P>0)c=S-1;else return S}return-(l+1)}t.binarySearch=T;function R(_,G){let B=0,l=_.length;if(l===0)return 0;for(;B<l;){const c=Math.floor((B+l)/2);G(_[c])?l=c:B=c+1}return B}t.findFirstInSorted=R;function h(_,G,B){if(_=_|0,_>=G.length)throw new TypeError("invalid index");let l=G[Math.floor(G.length*Math.random())],c=[],S=[],P=[];for(let A of G){const M=B(A,l);M<0?c.push(A):M>0?S.push(A):P.push(A)}return _<c.length?h(_,c,B):_<c.length+P.length?P[0]:h(_-(c.length+P.length),S,B)}t.quickSelect=h;function f(_,G){const B=[];let l;for(const c of _.slice(0).sort(G))!l||G(l[0],c)!==0?(l=[c],B.push(l)):l.push(c);return B}t.groupBy=f;function O(_,G,B){const l=[];function c(A,M,U){if(!(M===0&&U.length===0)){const W=l[l.length-1];W&&W.start+W.deleteCount===A?(W.deleteCount+=M,W.toInsert.push(...U)):l.push({start:A,deleteCount:M,toInsert:U})}}let S=0,P=0;for(;;){if(S===_.length){c(S,0,G.slice(P));break}if(P===G.length){c(S,_.length-S,[]);break}const A=_[S],M=G[P],U=B(A,M);U===0?(S+=1,P+=1):U<0?(c(S,1,[]),S+=1):U>0&&(c(S,0,[M]),P+=1)}return l}t.sortedDiff=O;function d(_,G,B){const l=O(_,G,B),c=[],S=[];for(const P of l)c.push(..._.slice(P.start,P.start+P.deleteCount)),S.push(...P.toInsert);return{removed:c,added:S}}t.delta=d;function E(_,G,B){if(B===0)return[];const l=_.slice(0,B).sort(G);return u(_,G,l,B,_.length),l}t.top=E;function y(_,G,B,l,c){return B===0?Promise.resolve([]):new Promise((S,P)=>{(async()=>{const A=_.length,M=_.slice(0,B).sort(G);for(let U=B,W=Math.min(B+l,A);U<A;U=W,W=Math.min(W+l,A)){if(U>B&&await new Promise(x=>setTimeout(x)),c&&c.isCancellationRequested)throw(0,p.canceled)();u(_,G,M,U,W)}return M})().then(S,P)})}t.topAsync=y;function u(_,G,B,l,c){for(const S=B.length;l<c;l++){const P=_[l];if(G(P,B[S-1])<0){B.pop();const A=R(B,M=>G(P,M)<0);B.splice(A,0,P)}}}function w(_){return _.filter(G=>!!G)}t.coalesce=w;function v(_){let G=0;for(let B=0;B<_.length;B++)_[B]&&(_[G]=_[B],G+=1);_.length=G}t.coalesceInPlace=v;function m(_,G,B){_.splice(B,0,_.splice(G,1)[0])}t.move=m;function I(_){return!Array.isArray(_)||_.length===0}t.isFalsyOrEmpty=I;function D(_){return Array.isArray(_)&&_.length>0}t.isNonEmptyArray=D;function o(_,G){if(!G)return _.filter((l,c)=>_.indexOf(l)===c);const B=Object.create(null);return _.filter(l=>{const c=G(l);return B[c]?!1:(B[c]=!0,!0)})}t.distinct=o;function i(_){const G=new Set;return _.filter(B=>G.has(B)?!1:(G.add(B),!0))}t.distinctES6=i;function e(_){const G=Object.create(null);return B=>{const l=_(B);return G[l]?!1:(G[l]=!0,!0)}}t.uniqueFilter=e;function n(_,G){for(let B=_.length-1;B>=0;B--){const l=_[B];if(G(l))return B}return-1}t.lastIndex=n;function s(_,G){return _.length>0?_[0]:G}t.firstOrDefault=s;function a(_,G,B=(l,c)=>l===c){let l=0;for(let c=0,S=Math.min(_.length,G.length);c<S&&B(_[c],G[c]);c++)l++;return l}t.commonPrefixLength=a;function r(_){return[].concat(..._)}t.flatten=r;function g(_,G){let B=typeof G=="number"?_:0;typeof G=="number"?B=_:(B=0,G=_);const l=[];if(B<=G)for(let c=B;c<G;c++)l.push(c);else for(let c=B;c>G;c--)l.push(c);return l}t.range=g;function k(_,G,B){return _.reduce((l,c)=>(l[G(c)]=B?B(c):c,l),Object.create(null))}t.index=k;function z(_,G){return _.push(G),()=>N(_,G)}t.insert=z;function N(_,G){const B=_.indexOf(G);if(B>-1)return _.splice(B,1),G}t.remove=N;function F(_,G,B){const l=_.slice(0,G),c=_.slice(G);return l.concat(B,c)}t.arrayInsert=F;function j(_,G){let B;if(typeof G=="number"){let l=G;B=()=>{const c=Math.sin(l++)*179426549;return c-Math.floor(c)}}else B=Math.random;for(let l=_.length-1;l>0;l-=1){const c=Math.floor(B()*(l+1)),S=_[l];_[l]=_[c],_[c]=S}}t.shuffle=j;function $(_,G){const B=_.indexOf(G);B>-1&&(_.splice(B,1),_.unshift(G))}t.pushToStart=$;function X(_,G){const B=_.indexOf(G);B>-1&&(_.splice(B,1),_.push(G))}t.pushToEnd=X;function ne(_,G){return Array.isArray(_)?_.map(G):G(_)}t.mapArrayOrNot=ne;function ee(_){return Array.isArray(_)?_:[_]}t.asArray=ee;function te(_){return _[Math.floor(Math.random()*_.length)]}t.getRandomElement=te;function ae(_,G){for(const B of _){const l=G(B);if(l!==void 0)return l}}t.mapFind=ae}),define(Q[57],Z([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var p;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(p=t.ScanError||(t.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=t.SyntaxKind||(t.SyntaxKind={}));var L;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(L=t.ParseErrorCode||(t.ParseErrorCode={}));var b;(function(e){e.DEFAULT={allowTrailingComma:!0}})(b=t.ParseOptions||(t.ParseOptions={}));function T(e,n=!1){let s=0,a=e.length,r="",g=0,k=16,z=0;function N(te){let ae=0,_=0;for(;ae<te;){const G=e.charCodeAt(s);if(G>=48&&G<=57)_=_*16+G-48;else if(G>=65&&G<=70)_=_*16+G-65+10;else if(G>=97&&G<=102)_=_*16+G-97+10;else break;s++,ae++}return ae<te&&(_=-1),_}function F(te){s=te,r="",g=0,k=16,z=0}function j(){const te=s;if(e.charCodeAt(s)===48)s++;else for(s++;s<e.length&&f(e.charCodeAt(s));)s++;if(s<e.length&&e.charCodeAt(s)===46)if(s++,s<e.length&&f(e.charCodeAt(s)))for(s++;s<e.length&&f(e.charCodeAt(s));)s++;else return z=3,e.substring(te,s);let ae=s;if(s<e.length&&(e.charCodeAt(s)===69||e.charCodeAt(s)===101))if(s++,(s<e.length&&e.charCodeAt(s)===43||e.charCodeAt(s)===45)&&s++,s<e.length&&f(e.charCodeAt(s))){for(s++;s<e.length&&f(e.charCodeAt(s));)s++;ae=s}else z=3;return e.substring(te,ae)}function $(){let te="",ae=s;for(;;){if(s>=a){te+=e.substring(ae,s),z=2;break}const _=e.charCodeAt(s);if(_===34){te+=e.substring(ae,s),s++;break}if(_===92){if(te+=e.substring(ae,s),s++,s>=a){z=2;break}switch(e.charCodeAt(s++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const B=N(4);B>=0?te+=String.fromCharCode(B):z=4;break;default:z=5}ae=s;continue}if(_>=0&&_<=31)if(h(_)){te+=e.substring(ae,s),z=2;break}else z=6;s++}return te}function X(){if(r="",z=0,g=s,s>=a)return g=a,k=17;let te=e.charCodeAt(s);if(R(te)){do s++,r+=String.fromCharCode(te),te=e.charCodeAt(s);while(R(te));return k=15}if(h(te))return s++,r+=String.fromCharCode(te),te===13&&e.charCodeAt(s)===10&&(s++,r+=`
`),k=14;switch(te){case 123:return s++,k=1;case 125:return s++,k=2;case 91:return s++,k=3;case 93:return s++,k=4;case 58:return s++,k=6;case 44:return s++,k=5;case 34:return s++,r=$(),k=10;case 47:const ae=s-1;if(e.charCodeAt(s+1)===47){for(s+=2;s<a&&!h(e.charCodeAt(s));)s++;return r=e.substring(ae,s),k=12}if(e.charCodeAt(s+1)===42){s+=2;const _=a-1;let G=!1;for(;s<_;){if(e.charCodeAt(s)===42&&e.charCodeAt(s+1)===47){s+=2,G=!0;break}s++}return G||(s++,z=1),r=e.substring(ae,s),k=13}return r+=String.fromCharCode(te),s++,k=16;case 45:if(r+=String.fromCharCode(te),s++,s===a||!f(e.charCodeAt(s)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=j(),k=11;default:for(;s<a&&ne(te);)s++,te=e.charCodeAt(s);if(g!==s){switch(r=e.substring(g,s),r){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return r+=String.fromCharCode(te),s++,k=16}}function ne(te){if(R(te)||h(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let te;do te=X();while(te>=12&&te<=15);return te}return{setPosition:F,getPosition:()=>s,scan:n?ee:X,getToken:()=>k,getTokenValue:()=>r,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>z}}t.createScanner=T;function R(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function h(e){return e===10||e===13||e===8232||e===8233}function f(e){return e>=48&&e<=57}var O;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(O||(O={}));function d(e,n){const s=[],a=new Object;let r;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function z(N,F,j,$){g.value=N,g.offset=F,g.length=j,g.type=$,g.colonOffset=void 0,r=g}try{D(e,{onObjectBegin:(N,F)=>{if(n<=N)throw a;r=void 0,k=n>N,s.push("")},onObjectProperty:(N,F,j)=>{if(n<F||(z(N,F,j,"property"),s[s.length-1]=N,n<=F+j))throw a},onObjectEnd:(N,F)=>{if(n<=N)throw a;r=void 0,s.pop()},onArrayBegin:(N,F)=>{if(n<=N)throw a;r=void 0,s.push(0)},onArrayEnd:(N,F)=>{if(n<=N)throw a;r=void 0,s.pop()},onLiteralValue:(N,F,j)=>{if(n<F||(z(N,F,j,i(N)),n<=F+j))throw a},onSeparator:(N,F,j)=>{if(n<=F)throw a;if(N===":"&&r&&r.type==="property")r.colonOffset=F,k=!1,r=void 0;else if(N===","){const $=s[s.length-1];typeof $=="number"?s[s.length-1]=$+1:(k=!0,s[s.length-1]=""),r=void 0}}})}catch(N){if(N!==a)throw N}return{path:s,previousNode:r,isAtPropertyKey:k,matches:N=>{let F=0;for(let j=0;F<N.length&&j<s.length;j++)if(N[F]===s[j]||N[F]==="*")F++;else if(N[F]!=="**")return!1;return F===N.length}}}t.getLocation=d;function E(e,n=[],s=b.DEFAULT){let a=null,r=[];const g=[];function k(N){Array.isArray(r)?r.push(N):a!==null&&(r[a]=N)}return D(e,{onObjectBegin:()=>{const N={};k(N),g.push(r),r=N,a=null},onObjectProperty:N=>{a=N},onObjectEnd:()=>{r=g.pop()},onArrayBegin:()=>{const N=[];k(N),g.push(r),r=N,a=null},onArrayEnd:()=>{r=g.pop()},onLiteralValue:k,onError:(N,F,j)=>{n.push({error:N,offset:F,length:j})}},s),r[0]}t.parse=E;function y(e,n=[],s=b.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(N){a.type==="property"&&(a.length=N-a.offset,a=a.parent)}function g(N){return a.children.push(N),N}D(e,{onObjectBegin:N=>{a=g({type:"object",offset:N,length:-1,parent:a,children:[]})},onObjectProperty:(N,F,j)=>{a=g({type:"property",offset:F,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:N,offset:F,length:j,parent:a})},onObjectEnd:(N,F)=>{a.length=N+F-a.offset,a=a.parent,r(N+F)},onArrayBegin:(N,F)=>{a=g({type:"array",offset:N,length:-1,parent:a,children:[]})},onArrayEnd:(N,F)=>{a.length=N+F-a.offset,a=a.parent,r(N+F)},onLiteralValue:(N,F,j)=>{g({type:i(N),offset:F,length:j,parent:a,value:N}),r(F+j)},onSeparator:(N,F,j)=>{a.type==="property"&&(N===":"?a.colonOffset=F:N===","&&r(F))},onError:(N,F,j)=>{n.push({error:N,offset:F,length:j})}},s);const z=a.children[0];return z&&delete z.parent,z}t.parseTree=y;function u(e,n){if(!!e){let s=e;for(let a of n)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===a){s=g.children[1],r=!0;break}if(!r)return}else{const r=a;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}}t.findNodeAtLocation=u;function w(e){if(!e.parent||!e.parent.children)return[];const n=w(e.parent);if(e.parent.type==="property"){const s=e.parent.children[0].value;n.push(s)}else if(e.parent.type==="array"){const s=e.parent.children.indexOf(e);s!==-1&&n.push(s)}return n}t.getNodePath=w;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const n=Object.create(null);for(let s of e.children){const a=s.children[1];a&&(n[s.children[0].value]=v(a))}return n;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function m(e,n,s=!1){return n>=e.offset&&n<e.offset+e.length||s&&n===e.offset+e.length}t.contains=m;function I(e,n,s=!1){if(m(e,n,s)){const a=e.children;if(Array.isArray(a))for(let r=0;r<a.length&&a[r].offset<=n;r++){const g=I(a[r],n,s);if(g)return g}return e}}t.findNodeAtOffset=I;function D(e,n,s=b.DEFAULT){const a=T(e,!1);function r(M){return M?()=>M(a.getTokenOffset(),a.getTokenLength()):()=>!0}function g(M){return M?U=>M(U,a.getTokenOffset(),a.getTokenLength()):()=>!0}const k=r(n.onObjectBegin),z=g(n.onObjectProperty),N=r(n.onObjectEnd),F=r(n.onArrayBegin),j=r(n.onArrayEnd),$=g(n.onLiteralValue),X=g(n.onSeparator),ne=r(n.onComment),ee=g(n.onError),te=s&&s.disallowComments,ae=s&&s.allowTrailingComma;function _(){for(;;){const M=a.scan();switch(a.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:te||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(M){case 12:case 13:te?G(10):ne();break;case 16:G(1);break;case 15:case 14:break;default:return M}}}function G(M,U=[],W=[]){if(ee(M),U.length+W.length>0){let x=a.getToken();for(;x!==17;){if(U.indexOf(x)!==-1){_();break}else if(W.indexOf(x)!==-1)break;x=_()}}}function B(M){const U=a.getTokenValue();return M?$(U):z(U),_(),!0}function l(){switch(a.getToken()){case 11:let M=0;try{M=JSON.parse(a.getTokenValue()),typeof M!="number"&&(G(2),M=0)}catch(U){G(2)}$(M);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return _(),!0}function c(){return a.getToken()!==10?(G(3,[],[2,5]),!1):(B(!1),a.getToken()===6?(X(":"),_(),A()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function S(){k(),_();let M=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(M||G(4,[],[]),X(","),_(),a.getToken()===2&&ae)break}else M&&G(6,[],[]);c()||G(4,[],[2,5]),M=!0}return N(),a.getToken()!==2?G(7,[2],[]):_(),!0}function P(){F(),_();let M=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(M||G(4,[],[]),X(","),_(),a.getToken()===4&&ae)break}else M&&G(6,[],[]);A()||G(4,[],[4,5]),M=!0}return j(),a.getToken()!==4?G(8,[4],[]):_(),!0}function A(){switch(a.getToken()){case 3:return P();case 1:return S();case 10:return B(!0);default:return l()}}return _(),a.getToken()===17?s.allowEmptyContent?!0:(G(4,[],[]),!1):A()?(a.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=D;function o(e,n){let s=T(e),a=[],r,g=0,k;do switch(k=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:g!==k&&a.push(e.substring(g,k)),n!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,n)),g=s.getPosition();break}while(r!==17);return a.join("")}t.stripComments=o;function i(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=i});"use strict";(function(){function q(L){const b=[];typeof L=="number"&&b.push("code/timeOrigin",L);function T(h){b.push(h,Date.now())}function R(){const h=[];for(let f=0;f<b.length;f+=2)h.push({name:b[f],startTime:b[f+1]});return h}return{mark:T,getMarks:R}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const T of performance.getEntriesByType("mark"))b.push({name:T.name,startTime:Math.round(L+T.startTime)});return b}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function p(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=t()),L.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=p(C))})(),function(q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var p=t();for(var C in p)(typeof exports=="object"?exports:q)[C]=p[C]}}(typeof self!="undefined"?self:this,function(){return function(q){var t={};function p(C){if(t[C])return t[C].exports;var L=t[C]={i:C,l:!1,exports:{}};return q[C].call(L.exports,L,L.exports,p),L.l=!0,L.exports}return p.m=q,p.c=t,p.d=function(C,L,b){p.o(C,L)||Object.defineProperty(C,L,{enumerable:!0,get:b})},p.r=function(C){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},p.t=function(C,L){if(1&L&&(C=p(C)),8&L||4&L&&typeof C=="object"&&C&&C.__esModule)return C;var b=Object.create(null);if(p.r(b),Object.defineProperty(b,"default",{enumerable:!0,value:C}),2&L&&typeof C!="string")for(var T in C)p.d(b,T,function(R){return C[R]}.bind(null,T));return b},p.n=function(C){var L=C&&C.__esModule?function(){return C.default}:function(){return C};return p.d(L,"a",L),L},p.o=function(C,L){return Object.prototype.hasOwnProperty.call(C,L)},p.p="",p(p.s=0)}([function(q,t,p){(function(C){var L;t=q.exports=W,L=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var b=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=t.re=[],h=t.src=[],f=0,O=f++;h[O]="0|[1-9]\\d*";var d=f++;h[d]="[0-9]+";var E=f++;h[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=f++;h[y]="("+h[O]+")\\.("+h[O]+")\\.("+h[O]+")";var u=f++;h[u]="("+h[d]+")\\.("+h[d]+")\\.("+h[d]+")";var w=f++;h[w]="(?:"+h[O]+"|"+h[E]+")";var v=f++;h[v]="(?:"+h[d]+"|"+h[E]+")";var m=f++;h[m]="(?:-("+h[w]+"(?:\\."+h[w]+")*))";var I=f++;h[I]="(?:-?("+h[v]+"(?:\\."+h[v]+")*))";var D=f++;h[D]="[0-9A-Za-z-]+";var o=f++;h[o]="(?:\\+("+h[D]+"(?:\\."+h[D]+")*))";var i=f++,e="v?"+h[y]+h[m]+"?"+h[o]+"?";h[i]="^"+e+"$";var n="[v=\\s]*"+h[u]+h[I]+"?"+h[o]+"?",s=f++;h[s]="^"+n+"$";var a=f++;h[a]="((?:<|>)?=?)";var r=f++;h[r]=h[d]+"|x|X|\\*";var g=f++;h[g]=h[O]+"|x|X|\\*";var k=f++;h[k]="[v=\\s]*("+h[g]+")(?:\\.("+h[g]+")(?:\\.("+h[g]+")(?:"+h[m]+")?"+h[o]+"?)?)?";var z=f++;h[z]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[I]+")?"+h[o]+"?)?)?";var N=f++;h[N]="^"+h[a]+"\\s*"+h[k]+"$";var F=f++;h[F]="^"+h[a]+"\\s*"+h[z]+"$";var j=f++;h[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=f++;h[$]="(?:~>?)";var X=f++;h[X]="(\\s*)"+h[$]+"\\s+",R[X]=new RegExp(h[X],"g");var ne=f++;h[ne]="^"+h[$]+h[k]+"$";var ee=f++;h[ee]="^"+h[$]+h[z]+"$";var te=f++;h[te]="(?:\\^)";var ae=f++;h[ae]="(\\s*)"+h[te]+"\\s+",R[ae]=new RegExp(h[ae],"g");var _=f++;h[_]="^"+h[te]+h[k]+"$";var G=f++;h[G]="^"+h[te]+h[z]+"$";var B=f++;h[B]="^"+h[a]+"\\s*("+n+")$|^$";var l=f++;h[l]="^"+h[a]+"\\s*("+e+")$|^$";var c=f++;h[c]="(\\s*)"+h[a]+"\\s*("+n+"|"+h[k]+")",R[c]=new RegExp(h[c],"g");var S=f++;h[S]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var P=f++;h[P]="^\\s*("+h[z]+")\\s+-\\s+("+h[z]+")\\s*$";var A=f++;h[A]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)L(M,h[M]),R[M]||(R[M]=new RegExp(h[M]));function U(V,H){if(V instanceof W)return V;if(typeof V!="string"||V.length>b||!(H?R[s]:R[i]).test(V))return null;try{return new W(V,H)}catch(K){return null}}function W(V,H){if(V instanceof W){if(V.loose===H)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>b)throw new TypeError("version is longer than "+b+" characters");if(!(this instanceof W))return new W(V,H);L("SemVer",V,H),this.loose=H;var K=V.trim().match(H?R[s]:R[i]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var oe=+se;if(oe>=0&&oe<T)return oe}return se}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}t.parse=U,t.valid=function(V,H){var K=U(V,H);return K?K.version:null},t.clean=function(V,H){var K=U(V.trim().replace(/^[=v]+/,""),H);return K?K.version:null},t.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(V){return L("SemVer.compare",this.version,this.loose,V),V instanceof W||(V=new W(V,this.loose)),this.compareMain(V)||this.comparePre(V)},W.prototype.compareMain=function(V){return V instanceof W||(V=new W(V,this.loose)),J(this.major,V.major)||J(this.minor,V.minor)||J(this.patch,V.patch)},W.prototype.comparePre=function(V){if(V instanceof W||(V=new W(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var H=0;do{var K=this.prerelease[H],se=V.prerelease[H];if(L("prerelease compare",H,K,se),K===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(K===void 0)return-1;if(K!==se)return J(K,se)}while(++H)},W.prototype.inc=function(V,H){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},t.inc=function(V,H,K,se){typeof K=="string"&&(se=K,K=void 0);try{return new W(V,K).inc(H,se).version}catch(oe){return null}},t.diff=function(V,H){if(he(V,H))return null;var K=U(V),se=U(H);if(K.prerelease.length||se.prerelease.length){for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return"pre"+oe;return"prerelease"}for(var oe in K)if((oe==="major"||oe==="minor"||oe==="patch")&&K[oe]!==se[oe])return oe},t.compareIdentifiers=J;var x=/^[0-9]+$/;function J(V,H){var K=x.test(V),se=x.test(H);return K&&se&&(V=+V,H=+H),K&&!se?-1:se&&!K?1:V<H?-1:V>H?1:0}function Y(V,H,K){return new W(V,K).compare(new W(H,K))}function ie(V,H,K){return Y(V,H,K)>0}function re(V,H,K){return Y(V,H,K)<0}function he(V,H,K){return Y(V,H,K)===0}function ge(V,H,K){return Y(V,H,K)!==0}function Pe(V,H,K){return Y(V,H,K)>=0}function Le(V,H,K){return Y(V,H,K)<=0}function Te(V,H,K,se){var oe;switch(H){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),oe=V!==K;break;case"":case"=":case"==":oe=he(V,K,se);break;case"!=":oe=ge(V,K,se);break;case">":oe=ie(V,K,se);break;case">=":oe=Pe(V,K,se);break;case"<":oe=re(V,K,se);break;case"<=":oe=Le(V,K,se);break;default:throw new TypeError("Invalid operator: "+H)}return oe}function Oe(V,H){if(V instanceof Oe){if(V.loose===H)return V;V=V.value}if(!(this instanceof Oe))return new Oe(V,H);L("comparator",V,H),this.loose=H,this.parse(V),this.semver===ke?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}t.rcompareIdentifiers=function(V,H){return J(H,V)},t.major=function(V,H){return new W(V,H).major},t.minor=function(V,H){return new W(V,H).minor},t.patch=function(V,H){return new W(V,H).patch},t.compare=Y,t.compareLoose=function(V,H){return Y(V,H,!0)},t.rcompare=function(V,H,K){return Y(H,V,K)},t.sort=function(V,H){return V.sort(function(K,se){return t.compare(K,se,H)})},t.rsort=function(V,H){return V.sort(function(K,se){return t.rcompare(K,se,H)})},t.gt=ie,t.lt=re,t.eq=he,t.neq=ge,t.gte=Pe,t.lte=Le,t.cmp=Te,t.Comparator=Oe;var ke={};function ve(V,H){if(V instanceof ve)return V.loose===H?V:new ve(V.raw,H);if(V instanceof Oe)return new ve(V.value,H);if(!(this instanceof ve))return new ve(V,H);if(this.loose=H,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function we(V){return!V||V.toLowerCase()==="x"||V==="*"}function Be(V,H,K,se,oe,Se,de,Re,ye,De,Ae,Ee,be){return((H=we(K)?"":we(se)?">="+K+".0.0":we(oe)?">="+K+"."+se+".0":">="+H)+" "+(Re=we(ye)?"":we(De)?"<"+(+ye+1)+".0.0":we(Ae)?"<"+ye+"."+(+De+1)+".0":Ee?"<="+ye+"."+De+"."+Ae+"-"+Ee:"<="+Re)).trim()}function We(V,H){for(var K=0;K<V.length;K++)if(!V[K].test(H))return!1;if(H.prerelease.length){for(K=0;K<V.length;K++)if(L(V[K].semver),V[K].semver!==ke&&V[K].semver.prerelease.length>0){var se=V[K].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function je(V,H,K){try{H=new ve(H,K)}catch(se){return!1}return H.test(V)}function ze(V,H,K,se){var oe,Se,de,Re,ye;switch(V=new W(V,se),H=new ve(H,se),K){case">":oe=ie,Se=Le,de=re,Re=">",ye=">=";break;case"<":oe=re,Se=Pe,de=ie,Re="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(V,H,se))return!1;for(var De=0;De<H.set.length;++De){var Ae=H.set[De],Ee=null,be=null;if(Ae.forEach(function(Ce){Ce.semver===ke&&(Ce=new Oe(">=0.0.0")),Ee=Ee||Ce,be=be||Ce,oe(Ce.semver,Ee.semver,se)?Ee=Ce:de(Ce.semver,be.semver,se)&&(be=Ce)}),Ee.operator===Re||Ee.operator===ye||(!be.operator||be.operator===Re)&&Se(V,be.semver)||be.operator===ye&&de(V,be.semver))return!1}return!0}Oe.prototype.parse=function(V){var H=this.loose?R[B]:R[l],K=V.match(H);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new W(K[2],this.loose):this.semver=ke},Oe.prototype.toString=function(){return this.value},Oe.prototype.test=function(V){return L("Comparator.test",V,this.loose),this.semver===ke||(typeof V=="string"&&(V=new W(V,this.loose)),Te(V,this.operator,this.semver,this.loose))},Oe.prototype.intersects=function(V,H){if(!(V instanceof Oe))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ve(V.value,H),je(this.value,K,H);if(V.operator==="")return K=new ve(this.value,H),je(V.semver,K,H);var se=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),oe=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Se=this.semver.version===V.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Re=Te(this.semver,"<",V.semver,H)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),ye=Te(this.semver,">",V.semver,H)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return se||oe||Se&&de||Re||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(V){var H=this.loose;V=V.trim(),L("range",V,H);var K=H?R[P]:R[S];V=V.replace(K,Be),L("hyphen replace",V),V=V.replace(R[c],"$1$2$3"),L("comparator trim",V,R[c]),V=(V=(V=V.replace(R[X],"$1~")).replace(R[ae],"$1^")).split(/\s+/).join(" ");var se=H?R[B]:R[l],oe=V.split(" ").map(function(Se){return function(de,Re){return L("comp",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){L("caret",Ee,be);var Ce=be?R[G]:R[_];return Ee.replace(Ce,function(Fe,le,fe,me,pe){var Ie;return L("caret",Ee,Fe,le,fe,me,pe),we(le)?Ie="":we(fe)?Ie=">="+le+".0.0 <"+(+le+1)+".0.0":we(me)?Ie=le==="0"?">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+".0 <"+(+le+1)+".0.0":pe?(L("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ie=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+pe+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+pe+" <"+(+le+1)+".0.0"):(L("no pr"),Ie=le==="0"?fe==="0"?">="+le+"."+fe+"."+me+" <"+le+"."+fe+"."+(+me+1):">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0":">="+le+"."+fe+"."+me+" <"+(+le+1)+".0.0"),L("caret return",Ie),Ie})}(Ae,De)}).join(" ")}(de,Re),L("caret",de),de=function(ye,De){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){var Ce=be?R[ee]:R[ne];return Ee.replace(Ce,function(Fe,le,fe,me,pe){var Ie;return L("tilde",Ee,Fe,le,fe,me,pe),we(le)?Ie="":we(fe)?Ie=">="+le+".0.0 <"+(+le+1)+".0.0":we(me)?Ie=">="+le+"."+fe+".0 <"+le+"."+(+fe+1)+".0":pe?(L("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),Ie=">="+le+"."+fe+"."+me+pe+" <"+le+"."+(+fe+1)+".0"):Ie=">="+le+"."+fe+"."+me+" <"+le+"."+(+fe+1)+".0",L("tilde return",Ie),Ie})}(Ae,De)}).join(" ")}(de,Re),L("tildes",de),de=function(ye,De){return L("replaceXRanges",ye,De),ye.split(/\s+/).map(function(Ae){return function(Ee,be){Ee=Ee.trim();var Ce=be?R[F]:R[N];return Ee.replace(Ce,function(Fe,le,fe,me,pe,Ie){L("xRange",Ee,Fe,le,fe,me,pe,Ie);var Ue=we(fe),Me=Ue||we(me),Ne=Me||we(pe);return le==="="&&Ne&&(le=""),Ue?Fe=le===">"||le==="<"?"<0.0.0":"*":le&&Ne?(Me&&(me=0),Ne&&(pe=0),le===">"?(le=">=",Me?(fe=+fe+1,me=0,pe=0):Ne&&(me=+me+1,pe=0)):le==="<="&&(le="<",Me?fe=+fe+1:me=+me+1),Fe=le+fe+"."+me+"."+pe):Me?Fe=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ne&&(Fe=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0"),L("xRange return",Fe),Fe})}(Ae,De)}).join(" ")}(de,Re),L("xrange",de),de=function(ye,De){return L("replaceStars",ye,De),ye.trim().replace(R[A],"")}(de,Re),L("stars",de),de}(Se,H)}).join(" ").split(/\s+/);return this.loose&&(oe=oe.filter(function(Se){return!!Se.match(se)})),oe=oe.map(function(Se){return new Oe(Se,H)})},ve.prototype.intersects=function(V,H){if(!(V instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(se){return V.set.some(function(oe){return oe.every(function(Se){return se.intersects(Se,H)})})})})},t.toComparators=function(V,H){return new ve(V,H).set.map(function(K){return K.map(function(se){return se.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new W(V,this.loose));for(var H=0;H<this.set.length;H++)if(We(this.set[H],V))return!0;return!1},t.satisfies=je,t.maxSatisfying=function(V,H,K){var se=null,oe=null;try{var Se=new ve(H,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==-1||(oe=new W(se=de,K)))}),se},t.minSatisfying=function(V,H,K){var se=null,oe=null;try{var Se=new ve(H,K)}catch(de){return null}return V.forEach(function(de){Se.test(de)&&(se&&oe.compare(de)!==1||(oe=new W(se=de,K)))}),se},t.validRange=function(V,H){try{return new ve(V,H).range||"*"}catch(K){return null}},t.ltr=function(V,H,K){return ze(V,H,"<",K)},t.gtr=function(V,H,K){return ze(V,H,">",K)},t.outside=ze,t.prerelease=function(V,H){var K=U(V,H);return K&&K.prerelease.length?K.prerelease:null},t.intersects=function(V,H,K){return V=new ve(V,K),H=new ve(H,K),V.intersects(H)},t.coerce=function(V){if(V instanceof W)return V;if(typeof V!="string")return null;var H=V.match(R[j]);return H==null?null:U((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,p(1))},function(q,t){var p,C,L=q.exports={};function b(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(v){if(p===setTimeout)return setTimeout(v,0);if((p===b||!p)&&setTimeout)return p=setTimeout,setTimeout(v,0);try{return p(v,0)}catch(m){try{return p.call(null,v,0)}catch(I){return p.call(this,v,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:b}catch(v){p=b}try{C=typeof clearTimeout=="function"?clearTimeout:T}catch(v){C=T}})();var h,f=[],O=!1,d=-1;function E(){O&&h&&(O=!1,h.length?f=h.concat(f):d=-1,f.length&&y())}function y(){if(!O){var v=R(E);O=!0;for(var m=f.length;m;){for(h=f,f=[];++d<m;)h&&h[d].run();d=-1,m=f.length}h=null,O=!1,function(I){if(C===clearTimeout)return clearTimeout(I);if((C===T||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(I);try{C(I)}catch(D){try{return C.call(null,I)}catch(o){return C.call(this,I)}}}(v)}}function u(v,m){this.fun=v,this.array=m}function w(){}L.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)m[I-1]=arguments[I];f.push(new u(v,m)),f.length!==1||O||R(y)},u.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=w,L.addListener=w,L.once=w,L.off=w,L.removeListener=w,L.removeAllListeners=w,L.emit=w,L.prependListener=w,L.prependOnceListener=w,L.listeners=function(v){return[]},L.binding=function(v){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(v){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Q[32],Z([0,1,14,2]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function L(v){const m=v;return m&&[m.on,m.pause,m.resume,m.destroy].every(I=>typeof I=="function")}t.isReadableStream=L;function b(v){const m=v;return m&&L(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean"}t.isReadableBufferedStream=b;function T(v,m){return new R(v,m)}t.newWriteableStream=T;class R{constructor(m,I){this.reducer=m,this.options=I,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var I;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((I=this.options)===null||I===void 0?void 0:I.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(D=>this.pendingWritePromises.push(D))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(I=>I(m))}emitError(m){this.listeners.error.length===0?(0,p.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(I=>I(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,I){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(I),this.resume();break;case"end":this.listeners.end.push(I),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(I),this.state.flowing&&this.flowErrors();break}}removeListener(m,I){if(!this.state.destroyed){let D;switch(m){case"data":D=this.listeners.data;break;case"end":D=this.listeners.end;break;case"error":D=this.listeners.error;break}if(D){const o=D.indexOf(I);o>=0&&D.splice(o,1)}}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const I=[...this.pendingWritePromises];this.pendingWritePromises.length=0,I.forEach(D=>D())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(v,m){const I=[];let D;for(;(D=v.read())!==null;)I.push(D);return m(I)}t.consumeReadable=h;function f(v,m,I){const D=[];let o;for(;(o=v.read())!==null&&D.length<I;)D.push(o);return o===null&&D.length>0?m(D):{read:()=>{if(D.length>0)return D.shift();if(typeof o!="undefined"){const i=o;return o=void 0,i}return v.read()}}}t.peekReadable=f;function O(v,m){return new Promise((I,D)=>{const o=[];d(v,{onData:i=>{m&&o.push(i)},onError:i=>{m?D(i):I(void 0)},onEnd:()=>{I(m?m(o):void 0)}})})}t.consumeStream=O;function d(v,m){v.on("error",I=>m.onError(I)),v.on("end",()=>m.onEnd()),v.on("data",I=>m.onData(I))}t.listenStream=d;function E(v,m){return new Promise((I,D)=>{const o=new C.DisposableStore,i=[],e=a=>{if(i.push(a),i.length>m)return o.dispose(),v.pause(),I({stream:v,buffer:i,ended:!1})},n=a=>D(a),s=()=>I({stream:v,buffer:i,ended:!0});o.add((0,C.toDisposable)(()=>v.removeListener("error",n))),v.on("error",n),o.add((0,C.toDisposable)(()=>v.removeListener("end",s))),v.on("end",s),o.add((0,C.toDisposable)(()=>v.removeListener("data",e))),v.on("data",e)})}t.peekStream=E;function y(v,m){const I=T(m);return I.end(v),I}t.toStream=y;function u(v){let m=!1;return{read:()=>m?null:(m=!0,v)}}t.toReadable=u;function w(v,m,I){const D=T(I);return d(v,{onData:o=>D.write(m.data(o)),onError:o=>D.error(m.error?m.error(o):o),onEnd:()=>D.end()}),D}t.transform=w}),define(Q[16],Z([0,1,20,32]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const L=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",T=typeof TextDecoder!="undefined";let R,h;class f{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new f(Buffer.allocUnsafe(r)):new f(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new f(r)}static fromString(r,g){return!((g==null?void 0:g.dontUseNodeBuffer)||!1)&&L?new f(Buffer.from(r)):b?(R||(R=new TextEncoder),new f(R.encode(r))):new f(p.encodeUTF8(r))}static concat(r,g){if(typeof g=="undefined"){g=0;for(let N=0,F=r.length;N<F;N++)g+=r[N].byteLength}const k=f.alloc(g);let z=0;for(let N=0,F=r.length;N<F;N++){const j=r[N];k.set(j,z),z+=j.byteLength}return k}toString(){return L?this.buffer.toString():T?(h||(h=new TextDecoder),h.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(r,g){return new f(this.buffer.subarray(r,g))}set(r,g){r instanceof f?this.buffer.set(r.buffer,g):this.buffer.set(r,g)}readUInt32BE(r){return E(this.buffer,r)}writeUInt32BE(r,g){y(this.buffer,r,g)}readUInt32LE(r){return u(this.buffer,r)}writeUInt32LE(r,g){w(this.buffer,r,g)}readUInt8(r){return v(this.buffer,r)}writeUInt8(r,g){m(this.buffer,r,g)}}t.VSBuffer=f;function O(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0}t.readUInt16LE=O;function d(a,r,g){a[g+0]=r&255,r=r>>>8,a[g+1]=r&255}t.writeUInt16LE=d;function E(a,r){return a[r]*2**24+a[r+1]*2**16+a[r+2]*2**8+a[r+3]}t.readUInt32BE=E;function y(a,r,g){a[g+3]=r,r=r>>>8,a[g+2]=r,r=r>>>8,a[g+1]=r,r=r>>>8,a[g]=r}t.writeUInt32BE=y;function u(a,r){return a[r+0]<<0>>>0|a[r+1]<<8>>>0|a[r+2]<<16>>>0|a[r+3]<<24>>>0}t.readUInt32LE=u;function w(a,r,g){a[g+0]=r&255,r=r>>>8,a[g+1]=r&255,r=r>>>8,a[g+2]=r&255,r=r>>>8,a[g+3]=r&255}t.writeUInt32LE=w;function v(a,r){return a[r]}t.readUInt8=v;function m(a,r,g){a[g]=r}t.writeUInt8=m;function I(a){return C.consumeReadable(a,r=>f.concat(r))}t.readableToBuffer=I;function D(a){return C.toReadable(a)}t.bufferToReadable=D;function o(a){return C.consumeStream(a,r=>f.concat(r))}t.streamToBuffer=o;async function i(a){return a.ended?f.concat(a.buffer):f.concat([...a.buffer,await o(a.stream)])}t.bufferedStreamToBuffer=i;function e(a){return C.toStream(a,r=>f.concat(r))}t.bufferToStream=e;function n(a){return C.transform(a,{data:r=>typeof r=="string"?f.fromString(r):f.wrap(r)},r=>f.concat(r))}t.streamToBufferReadableStream=n;function s(a){return C.newWriteableStream(r=>f.concat(r),a)}t.newWriteableBufferStream=s}),define(Q[21],Z([0,1,8]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function C(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const w=Array.isArray(u)?[]:{};return Object.keys(u).forEach(v=>{u[v]&&typeof u[v]=="object"?w[v]=C(u[v]):w[v]=u[v]}),w}t.deepClone=C;function L(u){if(!u||typeof u!="object")return u;const w=[u];for(;w.length>0;){const v=w.shift();Object.freeze(v);for(const m in v)if(b.call(v,m)){const I=v[m];typeof I=="object"&&!Object.isFrozen(I)&&w.push(I)}}return u}t.deepFreeze=L;const b=Object.prototype.hasOwnProperty;function T(u,w){return R(u,w,new Set)}t.cloneAndChange=T;function R(u,w,v){if((0,p.isUndefinedOrNull)(u))return u;const m=w(u);if(typeof m!="undefined")return m;if((0,p.isArray)(u)){const I=[];for(const D of u)I.push(R(D,w,v));return I}if((0,p.isObject)(u)){if(v.has(u))throw new Error("Cannot clone recursive data-structure");v.add(u);const I={};for(let D in u)b.call(u,D)&&(I[D]=R(u[D],w,v));return v.delete(u),I}return u}function h(u,w,v=!0){return(0,p.isObject)(u)?((0,p.isObject)(w)&&Object.keys(w).forEach(m=>{m in u?v&&((0,p.isObject)(u[m])&&(0,p.isObject)(w[m])?h(u[m],w[m],v):u[m]=w[m]):u[m]=w[m]}),u):w}t.mixin=h;function f(u,w){if(u===w)return!0;if(u==null||w===null||w===void 0||typeof u!=typeof w||typeof u!="object"||Array.isArray(u)!==Array.isArray(w))return!1;let v,m;if(Array.isArray(u)){if(u.length!==w.length)return!1;for(v=0;v<u.length;v++)if(!f(u[v],w[v]))return!1}else{const I=[];for(m in u)I.push(m);I.sort();const D=[];for(m in w)D.push(m);if(D.sort(),!f(I,D))return!1;for(v=0;v<I.length;v++)if(!f(u[I[v]],w[I[v]]))return!1}return!0}t.equals=f;function O(u){const w=new Set;return JSON.stringify(u,(v,m)=>{if((0,p.isObject)(m)||Array.isArray(m)){if(w.has(m))return"[Circular]";w.add(m)}return m})}t.safeStringify=O;function d(u,w,v){const m=w(u);return typeof m=="undefined"?v:m}t.getOrDefault=d;function E(u,w){const v=Object.create(null);return!u||!w||Object.keys(w).forEach(I=>{const D=u[I],o=w[I];f(D,o)||(v[I]=o)}),v}t.distinct=E;function y(u,w){const v=w.toLowerCase(),m=Object.keys(u).find(I=>I.toLowerCase()===v);return m?u[m]:u[w]}t.getCaseInsensitive=y}),define(Q[58],Z([0,1,9]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function C(f){const O=f;return O&&typeof O.type=="string"&&typeof O.severity=="string"}t.isRemoteConsoleLog=C;function L(f){const O=[];let d;try{const E=JSON.parse(f.arguments),y=E[E.length-1];y&&y.__$stack&&(E.pop(),d=y.__$stack),O.push(...E)}catch(E){O.push("Unable to log remote console arguments",f.arguments)}return{args:O,stack:d}}t.parse=L;function b(f){if(typeof f!="string")return b(L(f).stack);const O=f;if(O){const d=T(O),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(E&&E.length===4)return{uri:p.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}t.getFirstFrame=b;function T(f){if(!f)return f;const O=f.indexOf(`
`);return O===-1?f:f.substring(0,O)}function R(f,O){const{args:d,stack:E}=L(f),y=typeof d[0]=="string"&&d.length===1;let u=T(E);u&&(u=`(${u.trim()})`);let w=[];if(typeof d[0]=="string"?u&&y?w=[`%c[${O}] %c${d[0]} %c${u}`,h("blue"),h(""),h("grey")]:w=[`%c[${O}] %c${d[0]}`,h("blue"),h(""),...d.slice(1)]:w=[`%c[${O}]%`,h("blue"),...d],u&&!y&&w.push(u),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,w)}t.log=R;function h(f){return`color: ${f}`}}),define(Q[59],Z([0,1,16,20,9]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function b(f){return JSON.stringify(f,R)}t.stringify=b;function T(f){let O=JSON.parse(f);return O=h(O),O}t.parse=T;function R(f,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,C.regExpFlags)(O)}:O}function h(f,O=0){if(!f||O>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return L.URI.revive(f);case 2:return new RegExp(f.source,f.flags)}if(f instanceof p.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let d=0;d<f.length;++d)f[d]=h(f[d],O+1);else for(const d in f)Object.hasOwnProperty.call(f,d)&&(f[d]=h(f[d],O+1))}return f}t.revive=h}),define(Q[60],Z([0,1,20,33,3,43,4]),function(q,t,p,C,L,b,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function R(){return Object.create(null)}t.getEmptyExpression=R;const h="**",f="/",O="[/\\\\]",d="[^/\\\\]",E=/\//g;function y(c){switch(c){case 0:return"";case 1:return`${d}*?`;default:return`(?:${O}|${d}+${O}|${O}${d}+)*?`}}function u(c,S){if(!c)return[];const P=[];let A=!1,M=!1,U="";for(const W of c){switch(W){case S:if(!A&&!M){P.push(U),U="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":M=!0;break;case"]":M=!1;break}U+=W}return U&&P.push(U),P}t.splitGlobAware=u;function w(c){if(!c)return"";let S="";const P=u(c,f);if(P.every(A=>A===h))S=".*";else{let A=!1;P.forEach((M,U)=>{if(M===h){A||(S+=y(2),A=!0);return}let W=!1,x="",J=!1,Y="";for(const ie of M){if(ie!=="}"&&W){x+=ie;continue}if(J&&(ie!=="]"||!Y)){let re;ie==="-"?re=ie:(ie==="^"||ie==="!")&&!Y?re="^":ie===f?re="":re=p.escapeRegExpCharacters(ie),Y+=re;continue}switch(ie){case"{":W=!0;continue;case"[":J=!0;continue;case"}":S+=`(?:${u(x,",").map(ge=>w(ge)).join("|")})`,W=!1,x="";break;case"]":S+="["+Y+"]",J=!1,Y="";break;case"?":S+=d;continue;case"*":S+=y(1);continue;default:S+=p.escapeRegExpCharacters(ie)}}U<P.length-1&&(P[U+1]!==h||U+2<P.length)&&(S+=O),A=!1})}return S}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,D=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new b.LRUCache(1e4),n=function(){return!1},s=function(){return null};function a(c,S){if(!c)return s;let P;typeof c!="string"?P=c.pattern:P=c,P=P.trim();const A=`${P}_${!!S.trimForExclusions}`;let M=e.get(A);if(M)return r(M,c);let U;if(v.test(P)){const W=P.substr(4);M=function(x,J){return typeof x=="string"&&x.endsWith(W)?P:null}}else(U=m.exec(g(P,S)))?M=k(U[1],P):(S.trimForExclusions?D:I).test(P)?M=z(P,S):(U=o.exec(g(P,S)))?M=N(U[1].substr(1),P,!0):(U=i.exec(g(P,S)))?M=N(U[1],P,!1):M=F(P);return e.set(A,M),r(M,c)}function r(c,S){return typeof S=="string"?c:function(P,A){return C.isEqualOrParent(P,S.base)?c(L.relative(S.base,P),A):null}}function g(c,S){return S.trimForExclusions&&c.endsWith("/**")?c.substr(0,c.length-2):c}function k(c,S){const P=`/${c}`,A=`\\${c}`,M=function(W,x){return typeof W!="string"?null:x?x===c?S:null:W===c||W.endsWith(P)||W.endsWith(A)?S:null},U=[c];return M.basenames=U,M.patterns=[S],M.allBasenames=U,M}function z(c,S){const P=l(c.slice(1,-1).split(",").map(x=>a(x,S)).filter(x=>x!==s),c),A=P.length;if(!A)return s;if(A===1)return P[0];const M=function(x,J){for(let Y=0,ie=P.length;Y<ie;Y++)if(P[Y](x,J))return c;return null},U=P.find(x=>!!x.allBasenames);U&&(M.allBasenames=U.allBasenames);const W=P.reduce((x,J)=>J.allPaths?x.concat(J.allPaths):x,[]);return W.length&&(M.allPaths=W),M}function N(c,S,P){const A=L.sep===L.posix.sep,M=A?c:c.replace(E,L.sep),U=L.sep+M,W=L.posix.sep+c,x=P?function(J,Y){return typeof J=="string"&&(J===M||J.endsWith(U)||!A&&(J===c||J.endsWith(W)))?S:null}:function(J,Y){return typeof J=="string"&&(J===M||!A&&J===c)?S:null};return x.allPaths=[(P?"*/":"./")+c],x}function F(c){try{const S=new RegExp(`^${w(c)}$`);return function(P){return S.lastIndex=0,typeof P=="string"&&S.test(P)?c:null}}catch(S){return s}}function j(c,S,P){return!c||typeof S!="string"?!1:$(c)(S,void 0,P)}t.match=j;function $(c,S={}){if(!c)return n;if(typeof c=="string"||te(c)){const P=a(c,S);if(P===s)return n;const A=function(M,U){return!!P(M,U)};return P.allBasenames&&(A.allBasenames=P.allBasenames),P.allPaths&&(A.allPaths=P.allPaths),A}return G(c,S)}t.parse=$;function X(c){if(!!c){let S;return P=>(S||(S=(c()||Promise.resolve([])).then(A=>A?ee(A):{})),S.then(A=>!!A[P]))}}t.hasSiblingPromiseFn=X;function ne(c){if(!!c){let S;return P=>{if(!S){const A=c();S=A?ee(A):{}}return!!S[P]}}}t.hasSiblingFn=ne;function ee(c){const S={};for(const P of c)S[P]=!0;return S}function te(c){const S=c;return S&&typeof S.base=="string"&&typeof S.pattern=="string"}t.isRelativePattern=te;function ae(c){return c.allBasenames||[]}t.getBasenameTerms=ae;function _(c){return c.allPaths||[]}t.getPathTerms=_;function G(c,S){const P=l(Object.getOwnPropertyNames(c).map(x=>B(x,c[x],S)).filter(x=>x!==s)),A=P.length;if(!A)return s;if(!P.some(x=>!!x.requiresSiblings)){if(A===1)return P[0];const x=function(ie,re){for(let he=0,ge=P.length;he<ge;he++){const Pe=P[he](ie,re);if(Pe)return Pe}return null},J=P.find(ie=>!!ie.allBasenames);J&&(x.allBasenames=J.allBasenames);const Y=P.reduce((ie,re)=>re.allPaths?ie.concat(re.allPaths):ie,[]);return Y.length&&(x.allPaths=Y),x}const M=function(x,J,Y){let ie;for(let re=0,he=P.length;re<he;re++){const ge=P[re];ge.requiresSiblings&&Y&&(J||(J=L.basename(x)),ie||(ie=J.substr(0,J.length-L.extname(x).length)));const Pe=ge(x,J,ie,Y);if(Pe)return Pe}return null},U=P.find(x=>!!x.allBasenames);U&&(M.allBasenames=U.allBasenames);const W=P.reduce((x,J)=>J.allPaths?x.concat(J.allPaths):x,[]);return W.length&&(M.allPaths=W),M}function B(c,S,P){if(S===!1)return s;const A=a(c,P);if(A===s)return s;if(typeof S=="boolean")return A;if(S){const M=S.when;if(typeof M=="string"){const U=(W,x,J,Y)=>{if(!Y||!A(W,x))return null;const ie=M.replace("$(basename)",J),re=Y(ie);return(0,T.isThenable)(re)?re.then(he=>he?c:null):re?c:null};return U.requiresSiblings=!0,U}}return A}function l(c,S){const P=c.filter(x=>!!x.basenames);if(P.length<2)return c;const A=P.reduce((x,J)=>{const Y=J.basenames;return Y?x.concat(Y):x},[]);let M;if(S){M=[];for(let x=0,J=A.length;x<J;x++)M.push(S)}else M=P.reduce((x,J)=>{const Y=J.patterns;return Y?x.concat(Y):x},[]);const U=function(x,J){if(typeof x!="string")return null;if(!J){let ie;for(ie=x.length;ie>0;ie--){const re=x.charCodeAt(ie-1);if(re===47||re===92)break}J=x.substr(ie)}const Y=A.indexOf(J);return Y!==-1?M[Y]:null};U.basenames=A,U.patterns=M,U.allBasenames=A;const W=c.filter(x=>!x.basenames);return W.push(U),W}}),define(Q[61],Z([0,1,9,3,20,10,17,18,33]),function(q,t,p,C,L,b,T,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function f(a,r,g){if(typeof a=="string"&&(a=p.URI.file(a)),g){const z=g.getWorkspaceFolder(a);if(z){const N=g.getWorkspace().folders.length>1;let F;if((0,R.isEqual)(z.uri,a)?F="":F=(0,R.relativePath)(z.uri,a),N){const j=z.name?z.name:(0,R.basename)(z.uri);F=F?j+" \u2022 "+F:j}return F}}if(a.scheme!==b.Schemas.file&&a.scheme!==b.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(a.fsPath))return(0,C.normalize)(d(a.fsPath));let k=(0,C.normalize)(a.fsPath);return!T.isWindows&&(r==null?void 0:r.userHome)&&(k=y(k,r.userHome.fsPath)),k}t.getPathLabel=f;function O(a){if(!!a){typeof a=="string"&&(a=p.URI.file(a));const r=(0,R.basename)(a)||(a.scheme===b.Schemas.file?a.fsPath:a.path);return T.isWindows&&(0,h.isRootOrDriveLetter)(r)?d(r):r}}t.getBaseLabel=O;function d(a){return(0,h.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}t.normalizeDriveLetter=d;let E=Object.create(null);function y(a,r){if(T.isWindows||!a||!r)return a;let g=E.original===r?E.normalized:void 0;return g||(g=`${(0,L.rtrim)(r,C.posix.sep)}${C.posix.sep}`,E={original:r,normalized:g}),(T.isLinux?a.startsWith(g):(0,L.startsWithIgnoreCase)(a,g))&&(a=`~/${a.substr(g.length)}`),a}t.tildify=y;function u(a,r){return a.replace(/^~($|\/|\\)/,`${r}$1`)}t.untildify=u;const w="\u2026",v="\\\\",m="~";function I(a,r=C.sep){const g=new Array(a.length);let k=!1;for(let z=0;z<a.length;z++){let N=a[z];if(N===""){g[z]=`.${r}`;continue}if(!N){g[z]=N;continue}k=!0;let F="";N.indexOf(v)===0?(F=N.substr(0,N.indexOf(v)+v.length),N=N.substr(N.indexOf(v)+v.length)):N.indexOf(r)===0?(F=N.substr(0,N.indexOf(r)+r.length),N=N.substr(N.indexOf(r)+r.length)):N.indexOf(m)===0&&(F=N.substr(0,N.indexOf(m)+m.length),N=N.substr(N.indexOf(m)+m.length));const j=N.split(r);for(let $=1;k&&$<=j.length;$++)for(let X=j.length-$;k&&X>=0;X--){k=!1;let ne=j.slice(X,X+$).join(r);for(let ee=0;!k&&ee<a.length;ee++)if(ee!==z&&a[ee]&&a[ee].indexOf(ne)>-1){const te=X+$===j.length,ae=X>0&&a[ee].indexOf(r)>-1?r+ne:ne,_=a[ee].endsWith(ae);k=!te||_}if(!k){let ee="";(j[0].endsWith(":")||F!=="")&&(X===1&&(X=0,$++,ne=j[0]+r+ne),X>0&&(ee=j[0]+r),ee=F+ee),X>0&&(ee=ee+w+r),ee=ee+ne,X+$<j.length&&(ee=ee+r+w),g[z]=ee}}k&&(g[z]=N)}return g}t.shorten=I;var D;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(D||(D={}));function o(a,r=Object.create(null)){const g=[];let k=!1,z="";for(const N of a)if(N==="$"||k&&N==="{")z&&g.push({value:z,type:D.TEXT}),z="",k=!0;else if(N==="}"&&k){const F=r[z];if(typeof F=="string")F.length&&g.push({value:F,type:D.VARIABLE});else if(F){const j=g[g.length-1];(!j||j.type!==D.SEPARATOR)&&g.push({value:F.label,type:D.SEPARATOR})}z="",k=!1}else z+=N;return z&&!k&&g.push({value:z,type:D.TEXT}),g.filter((N,F)=>{if(N.type===D.SEPARATOR){const j=g[F-1],$=g[F+1];return[j,$].every(X=>X&&(X.type===D.VARIABLE||X.type===D.TEXT)&&X.value.length>0)}return!0}).map(N=>N.value).join("")}t.template=o;function i(a,r){return T.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):a.replace(/&&|&/g,g=>g==="&"?"&&":"&")}t.mnemonicMenuLabel=i;function e(a,r){return T.isMacintosh||r?a.replace(/\(&&\w\)|&&/g,""):T.isWindows?a.replace(/&&|&/g,g=>g==="&"?"&&":"&"):a.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function n(a){return a.replace(/&/g,"&&")}t.unmnemonicLabel=n;function s(a){const r=a.indexOf("/")!==-1?C.posix:C.win32,g=r.basename(a),k=r.dirname(a);return g.length?{name:g,parentPath:k}:{name:k,parentPath:""}}t.splitName=s}),define(Q[44],Z([0,1,123]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class C{constructor(b="utf8"){this.stringDecoder=new p.StringDecoder(b),this.remaining=null}write(b){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(R.length<1)return T;let h=0,f,O=h;for(;O<R.length;)if(f=R.charCodeAt(O),f===13||f===10){if(T.push(R.substring(h,O)),O++,O<R.length){const d=f;f=R.charCodeAt(O),(d===13&&f===10||d===10&&f===13)&&O++}h=O}else O++;return this.remaining=h<R.length?R.substr(h):null,T}end(){return this.remaining}}t.LineDecoder=C}),define(Q[62],Z([0,1,15,63,20,3,13]),function(q,t,p,C,L,b,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(d){const E=(0,b.dirname)(d);if(d===E)return d;const y=((0,b.basename)(d)||d).toLowerCase();try{const w=(0,T.readdirSync)(E).filter(v=>v.toLowerCase()===y);if(w.length===1){const v=R(E);if(v)return(0,b.join)(v,w[0])}else if(w.length>1){const v=w.indexOf(y);if(v>=0){const m=R(E);if(m)return(0,b.join)(m,w[v])}}}catch(u){}return null}t.realcaseSync=R;async function h(d){try{return await(0,C.promisify)(p.realpath)(d)}catch(E){const y=O(d);return await p.promises.access(y,p.constants.R_OK),y}}t.realpath=h;function f(d){try{return p.realpathSync(d)}catch(E){const y=O(d);return p.accessSync(y,p.constants.R_OK),y}}t.realpathSync=f;function O(d){return(0,L.rtrim)((0,b.normalize)(d),b.sep)}}),define(Q[64],Z([0,1,3,15,17,124,2,13]),function(q,t,p,C,L,b,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function h(d,E,y){return O({path:d,isDirectory:!1},E,y)}t.watchFile=h;function f(d,E,y){return O({path:d,isDirectory:!0},E,y)}t.watchFolder=f,t.CHANGE_BUFFER_DELAY=100;function O(d,E,y){const u=(0,p.basename)(d.path),w=new Map;let v=!1,m=[(0,T.toDisposable)(()=>{w.forEach(I=>(0,T.dispose)(I)),w.clear()})];try{const I=(0,C.watch)(d.path);m.push((0,T.toDisposable)(()=>{I.removeAllListeners(),I.close()}));const D=new Set;d.isDirectory&&(0,R.readdir)(d.path).then(o=>o.forEach(i=>D.add(i))),I.on("error",(o,i)=>{v||y(`Failed to watch ${d.path} for changes using fs.watch() (${o}, ${i})`)}),I.on("change",(o,i)=>{if(!v){let e="";if(i&&(e=i.toString(),L.isMacintosh&&(e=(0,b.normalizeNFC)(e))),!(!e||o!=="change"&&o!=="rename")){const n=d.isDirectory?(0,p.join)(d.path,e):d.path;if(d.isDirectory)if(o==="rename"){const s=w.get(n);s&&(0,T.dispose)(s);const a=setTimeout(async()=>{w.delete(n);const r=await(0,R.exists)(n);if(!v){let g;r?D.has(e)?g="changed":(g="added",D.add(e)):(D.delete(e),g="deleted"),E(g,n)}},t.CHANGE_BUFFER_DELAY);w.set(n,(0,T.toDisposable)(()=>clearTimeout(a)))}else{let s;D.has(e)?s="changed":(s="added",D.add(e)),E(s,n)}else if(o==="rename"||e!==u){const s=setTimeout(async()=>{const a=await(0,R.exists)(n);v||(a?(E("changed",n),m=[O(d,E,y)]):E("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,T.dispose)(m),m=[(0,T.toDisposable)(()=>clearTimeout(s))]}else E("changed",n)}}})}catch(I){(0,R.exists)(d.path).then(D=>{D&&!v&&y(`Failed to watch ${d.path} for changes using fs.watch() (${I.toString()})`)})}return(0,T.toDisposable)(()=>{v=!0,m=(0,T.dispose)(m)})}}),define(Q[34],Z([0,1,11,2,4,28,14,16,23,8,59,20]),function(q,t,p,C,L,b,T,R,h,f,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var E;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(E=t.RequestType||(t.RequestType={}));function y(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(u=t.ResponseType||(t.ResponseType={}));function w(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(v||(v={}));class m{constructor(l){this.buffer=l,this.pos=0}read(l){const c=this.buffer.slice(this.pos,this.pos+l);return this.pos+=c.byteLength,c}}class I{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(l){this.buffers.push(l)}}var D;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object"})(D||(D={}));function o(B){const l=R.VSBuffer.alloc(4);return l.writeUInt32BE(B,0),l}function i(B){return B.read(4).readUInt32BE(0)}function e(B){const l=R.VSBuffer.alloc(1);return l.writeUInt8(B,0),l}const n={Undefined:e(D.Undefined),String:e(D.String),Buffer:e(D.Buffer),VSBuffer:e(D.VSBuffer),Array:e(D.Array),Object:e(D.Object)},s=typeof Buffer!="undefined";function a(B,l){if(typeof l=="undefined")B.write(n.Undefined);else if(typeof l=="string"){const c=R.VSBuffer.fromString(l);B.write(n.String),B.write(o(c.byteLength)),B.write(c)}else if(s&&Buffer.isBuffer(l)){const c=R.VSBuffer.wrap(l);B.write(n.Buffer),B.write(o(c.byteLength)),B.write(c)}else if(l instanceof R.VSBuffer)B.write(n.VSBuffer),B.write(o(l.byteLength)),B.write(l);else if(Array.isArray(l)){B.write(n.Array),B.write(o(l.length));for(const c of l)a(B,c)}else{const c=R.VSBuffer.fromString(JSON.stringify(l));B.write(n.Object),B.write(o(c.byteLength)),B.write(c)}}function r(B){switch(B.read(1).readUInt8(0)){case D.Undefined:return;case D.String:return B.read(i(B)).toString();case D.Buffer:return B.read(i(B)).buffer;case D.VSBuffer:return B.read(i(B));case D.Array:{const c=i(B),S=[];for(let P=0;P<c;P++)S.push(r(B));return S}case D.Object:return JSON.parse(B.read(i(B)).toString())}}class g{constructor(l,c,S=null,P=1e3){this.protocol=l,this.ctx=c,this.logger=S,this.timeoutDelay=P,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(l,c){this.channels.set(l,c),setTimeout(()=>this.flushPendingRequests(l),0)}sendResponse(l){switch(l.type){case 200:{const c=this.send([l.type]);this.logger&&this.logger.logOutgoing(c,0,1,w(l.type));return}case 201:case 202:case 204:case 203:{const c=this.send([l.type,l.id],l.data);this.logger&&this.logger.logOutgoing(c,l.id,1,w(l.type),l.data);return}}}send(l,c=void 0){const S=new I;return a(S,l),a(S,c),this.sendBuffer(S.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(c){return 0}}onRawMessage(l){const c=new m(l),S=r(c),P=r(c),A=S[0];switch(A){case 100:return this.logger&&this.logger.logIncoming(l.byteLength,S[1],1,`${y(A)}: ${S[2]}.${S[3]}`,P),this.onPromise({type:A,id:S[1],channelName:S[2],name:S[3],arg:P});case 102:return this.logger&&this.logger.logIncoming(l.byteLength,S[1],1,`${y(A)}: ${S[2]}.${S[3]}`,P),this.onEventListen({type:A,id:S[1],channelName:S[2],name:S[3],arg:P});case 101:return this.logger&&this.logger.logIncoming(l.byteLength,S[1],1,`${y(A)}`),this.disposeActiveRequest({type:A,id:S[1]});case 103:return this.logger&&this.logger.logIncoming(l.byteLength,S[1],1,`${y(A)}`),this.disposeActiveRequest({type:A,id:S[1]})}}onPromise(l){const c=this.channels.get(l.channelName);if(!c){this.collectPendingRequest(l);return}const S=new b.CancellationTokenSource;let P;try{P=c.call(this.ctx,l.name,l.arg,S.token)}catch(U){P=Promise.reject(U)}const A=l.id;P.then(U=>{this.sendResponse({id:A,data:U,type:201}),this.activeRequests.delete(l.id)},U=>{U instanceof Error?this.sendResponse({id:A,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:A,data:U,type:203}),this.activeRequests.delete(l.id)});const M=(0,C.toDisposable)(()=>S.cancel());this.activeRequests.set(l.id,M)}onEventListen(l){const c=this.channels.get(l.channelName);if(!c){this.collectPendingRequest(l);return}const S=l.id,A=c.listen(this.ctx,l.name,l.arg)(M=>this.sendResponse({id:S,data:M,type:204}));this.activeRequests.set(l.id,A)}disposeActiveRequest(l){const c=this.activeRequests.get(l.id);c&&(c.dispose(),this.activeRequests.delete(l.id))}collectPendingRequest(l){let c=this.pendingRequests.get(l.channelName);c||(c=[],this.pendingRequests.set(l.channelName,c));const S=setTimeout(()=>{console.error(`Unknown channel: ${l.channelName}`),l.type===100&&this.sendResponse({id:l.id,data:{name:"Unknown channel",message:`Channel name '${l.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);c.push({request:l,timeoutTimer:S})}flushPendingRequests(l){const c=this.pendingRequests.get(l);if(c){for(const S of c)switch(clearTimeout(S.timeoutTimer),S.request.type){case 100:this.onPromise(S.request);break;case 102:this.onEventListen(S.request);break}this.pendingRequests.delete(l)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}t.ChannelServer=g;var k;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(k=t.RequestInitiator||(t.RequestInitiator={}));class z{constructor(l,c=null){this.protocol=l,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(S=>this.onBuffer(S)),this.logger=c}getChannel(l){const c=this;return{call(S,P,A){return c.isDisposed?Promise.reject(T.canceled()):c.requestPromise(l,S,P,A)},listen(S,P){return c.isDisposed?Promise.reject(T.canceled()):c.requestEvent(l,S,P)}}}requestPromise(l,c,S,P=b.CancellationToken.None){const A=this.lastRequestId++,U={id:A,type:100,channelName:l,name:c,arg:S};if(P.isCancellationRequested)return Promise.reject(T.canceled());let W;return new Promise((J,Y)=>{if(P.isCancellationRequested)return Y(T.canceled());const ie=()=>{const Pe=Le=>{switch(Le.type){case 201:this.handlers.delete(A),J(Le.data);break;case 202:this.handlers.delete(A);const Te=new Error(Le.data.message);Te.stack=Le.data.stack,Te.name=Le.data.name,Y(Te);break;case 203:this.handlers.delete(A),Y(Le.data);break}};this.handlers.set(A,Pe),this.sendRequest(U)};let re=null;this.state===v.Idle?ie():(re=(0,L.createCancelablePromise)(Pe=>this.whenInitialized()),re.then(()=>{re=null,ie()}));const he=()=>{re?(re.cancel(),re=null):this.sendRequest({id:A,type:101}),Y(T.canceled())},ge=P.onCancellationRequested(he);W=(0,C.combinedDisposable)((0,C.toDisposable)(he),ge),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent(l,c,S){const P=this.lastRequestId++,M={id:P,type:102,channelName:l,name:c,arg:S};let U=null;const W=new p.Emitter({onFirstListenerAdd:()=>{U=(0,L.createCancelablePromise)(J=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(W),this.sendRequest(M)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(W),this.sendRequest({id:P,type:103}))}}),x=J=>W.fire(J.data);return this.handlers.set(P,x),W.event}sendRequest(l){switch(l.type){case 100:case 102:{const c=this.send([l.type,l.id,l.channelName,l.name],l.arg);this.logger&&this.logger.logOutgoing(c,l.id,0,`${y(l.type)}: ${l.channelName}.${l.name}`,l.arg);return}case 101:case 103:{const c=this.send([l.type,l.id]);this.logger&&this.logger.logOutgoing(c,l.id,0,y(l.type));return}}}send(l,c=void 0){const S=new I;return a(S,l),a(S,c),this.sendBuffer(S.buffer)}sendBuffer(l){try{return this.protocol.send(l),l.byteLength}catch(c){return 0}}onBuffer(l){const c=new m(l),S=r(c),P=r(c),A=S[0];switch(A){case 200:return this.logger&&this.logger.logIncoming(l.byteLength,0,0,w(A)),this.onResponse({type:S[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(l.byteLength,S[1],0,w(A),P),this.onResponse({type:S[0],id:S[1],data:P})}}onResponse(l){if(l.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const c=this.handlers.get(l.id);c&&c(l)}whenInitialized(){return this.state===v.Idle?Promise.resolve():p.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(l=>l.dispose()),this.activeRequests.clear()}}t.ChannelClient=z;class N{constructor(l){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,l(({protocol:c,onDidClientDisconnect:S})=>{p.Event.once(c.onMessage)(A=>{const M=new m(A),U=r(M),W=new g(c,U),x=new z(c);this.channels.forEach((Y,ie)=>W.registerChannel(ie,Y));const J={channelServer:W,channelClient:x,ctx:U};this._connections.add(J),this._onDidAddConnection.fire(J),S(()=>{W.dispose(),x.dispose(),this._connections.delete(J),this._onDidRemoveConnection.fire(J)})})})}get connections(){const l=[];return this._connections.forEach(c=>l.push(c)),l}getChannel(l,c){const S=this;return{call(P,A,M){let U;if((0,f.isFunction)(c)){let x=(0,h.getRandomElement)(S.connections.filter(c));U=x?Promise.resolve(x):p.Event.toPromise(p.Event.filter(S.onDidAddConnection,c))}else U=c.routeCall(S,P,A);const W=U.then(x=>x.channelClient.getChannel(l));return j(W).call(P,A,M)},listen(P,A){if((0,f.isFunction)(c))return S.getMulticastEvent(l,c,P,A);const M=c.routeEvent(S,P,A).then(U=>U.channelClient.getChannel(l));return j(M).listen(P,A)}}}getMulticastEvent(l,c,S,P){const A=this;let M=new C.DisposableStore;const U=new p.Emitter({onFirstListenerAdd:()=>{M=new C.DisposableStore;const W=new p.EventMultiplexer,x=new Map,J=ie=>{const he=ie.channelClient.getChannel(l).listen(S,P),ge=W.add(he);x.set(ie,ge)},Y=ie=>{const re=x.get(ie);!re||(re.dispose(),x.delete(ie))};A.connections.filter(c).forEach(J),p.Event.filter(A.onDidAddConnection,c)(J,void 0,M),A.onDidRemoveConnection(Y,void 0,M),W.event(U.fire,U,M),M.add(W)},onLastListenerRemove:()=>{M.dispose()}});return U.event}registerChannel(l,c){this.channels.set(l,c),this._connections.forEach(S=>{S.channelServer.registerChannel(l,c)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=N;class F{constructor(l,c,S=null){const P=new I;a(P,c),l.send(P.buffer),this.channelClient=new z(l,S),this.channelServer=new g(l,c,S)}getChannel(l){return this.channelClient.getChannel(l)}registerChannel(l,c){this.channelServer.registerChannel(l,c)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=F;function j(B){return{call(l,c,S){return B.then(P=>P.call(l,c,S))},listen(l,c){const S=new p.Relay;return B.then(P=>S.input=P.listen(l,c)),S.event}}}t.getDelayedChannel=j;function $(B){let l=!1;return{call(c,S,P){return l?B.call(c,S,P):(0,L.timeout)(0).then(()=>l=!0).then(()=>B.call(c,S,P))},listen(c,S){if(l)return B.listen(c,S);const P=new p.Relay;return(0,L.timeout)(0).then(()=>l=!0).then(()=>P.input=B.listen(c,S)),P.event}}}t.getNextTickChannel=$;class X{constructor(l){this.fn=l}routeCall(l){return this.route(l)}routeEvent(l){return this.route(l)}async route(l){for(const c of l.connections)if(await Promise.resolve(this.fn(c.ctx)))return Promise.resolve(c);return await p.Event.toPromise(l.onDidAddConnection),await this.route(l)}}t.StaticRouter=X;var ne;(function(B){function l(P,A){const M=P,U=A&&A.disableMarshalling,W=new Map;for(const x in M)S(x)&&W.set(x,p.Event.buffer(M[x],!0));return new class{listen(x,J){const Y=W.get(J);if(Y)return Y;throw new Error(`Event not found: ${J}`)}call(x,J,Y){const ie=M[J];if(typeof ie=="function"){if(!U&&Array.isArray(Y))for(let re=0;re<Y.length;re++)Y[re]=(0,O.revive)(Y[re]);return ie.apply(M,Y)}throw new Error(`Method not found: ${J}`)}}}B.fromService=l;function c(P,A){const M=A&&A.disableMarshalling;return new Proxy({},{get(U,W){var x;if(typeof W=="string")return((x=A==null?void 0:A.properties)===null||x===void 0?void 0:x.has(W))?A.properties.get(W):S(W)?P.listen(W):async function(...J){let Y;A&&!(0,f.isUndefinedOrNull)(A.context)?Y=[A.context,...J]:Y=J;const ie=await P.call(W,Y);return M?ie:(0,O.revive)(ie)};throw new Error(`Property not found: ${String(W)}`)}})}B.toService=c;function S(P){return P[0]==="o"&&P[1]==="n"&&d.isUpperAsciiLetter(P.charCodeAt(2))}})(ne=t.ProxyChannel||(t.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){let l=B.toString();if(l!=="[object Object]")return l}return B}function ae(B){return Array.isArray(B)?B.map(te):te(B)}function _(B,l,c,S,P,A,M){M=ae(M);const U=ee[P],W=U[S%U.length];let x=[`%c[${B}]%c[${String(l).padStart(7," ")}]%c[len: ${String(c).padStart(5," ")}]%c${String(S).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test(A)?(x=x.concat(M),x.push(")")):x.push(M),console.log.apply(console,x)}t.logWithColors=_;class G{constructor(l,c){this._outgoingPrefix=l,this._incomingPrefix=c,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(l,c,S,P,A){this._totalOutgoing+=l,_(this._outgoingPrefix,this._totalOutgoing,l,c,S,P,A)}logIncoming(l,c,S,P,A){this._totalIncoming+=l,_(this._incomingPrefix,this._totalIncoming,l,c,S,P,A)}}t.IPCLogger=G}),define(Q[65],Z([0,1,2,11,4,8]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var T;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));var R;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(R||(R={}));class h extends p.Disposable{constructor(d,E=Object.create(null)){super();this.database=d,this.options=E,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=R.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(h.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){var E,y;(E=d.changed)===null||E===void 0||E.forEach((u,w)=>this.accept(w,u)),(y=d.deleted)===null||y===void 0||y.forEach(u=>this.accept(u,void 0))}accept(d,E){if(this.state!==R.Closed){let y=!1;(0,b.isUndefinedOrNull)(E)?y=this.cache.delete(d):this.cache.get(d)!==E&&(this.cache.set(d,E),y=!0),y&&this._onDidChangeStorage.fire(d)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===R.None&&(this.state=R.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,E){const y=this.cache.get(d);return(0,b.isUndefinedOrNull)(y)?E:y}getBoolean(d,E){const y=this.get(d);return(0,b.isUndefinedOrNull)(y)?E:y==="true"}getNumber(d,E){const y=this.get(d);return(0,b.isUndefinedOrNull)(y)?E:parseInt(y,10)}async set(d,E){if(this.state!==R.Closed){if((0,b.isUndefinedOrNull)(E))return this.delete(d);const y=String(E);if(this.cache.get(d)!==y)return this.cache.set(d,y),this.pendingInserts.set(d,y),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(d){if(this.state!==R.Closed&&!!this.cache.delete(d))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=R.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=h,h.DEFAULT_FLUSH_DELAY=100;class f{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((E,y)=>this.items.set(y,E)),d.delete&&d.delete.forEach(E=>this.items.delete(E))}async close(){}}t.InMemoryStorageDatabase=f}),define(Q[66],Z([5,6]),function(q,t){return q.create("vs/base/common/date",t)}),define(Q[67],Z([0,1,66]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const C=60,L=C*60,b=L*24,T=b*7,R=b*30,h=b*365;function f(d,E){typeof d!="number"&&(d=d.getTime());const y=Math.round((new Date().getTime()-d)/1e3);if(y<-30)return(0,p.localize)(0,null,f(new Date().getTime()+y*1e3,!1));if(y<30)return(0,p.localize)(1,null);let u;return y<C?(u=y,E?u===1?(0,p.localize)(2,null,u):(0,p.localize)(3,null,u):u===1?(0,p.localize)(4,null,u):(0,p.localize)(5,null,u)):y<L?(u=Math.floor(y/C),E?u===1?(0,p.localize)(6,null,u):(0,p.localize)(7,null,u):u===1?(0,p.localize)(8,null,u):(0,p.localize)(9,null,u)):y<b?(u=Math.floor(y/L),E?u===1?(0,p.localize)(10,null,u):(0,p.localize)(11,null,u):u===1?(0,p.localize)(12,null,u):(0,p.localize)(13,null,u)):y<T?(u=Math.floor(y/b),E?u===1?(0,p.localize)(14,null,u):(0,p.localize)(15,null,u):u===1?(0,p.localize)(16,null,u):(0,p.localize)(17,null,u)):y<R?(u=Math.floor(y/T),E?u===1?(0,p.localize)(18,null,u):(0,p.localize)(19,null,u):u===1?(0,p.localize)(20,null,u):(0,p.localize)(21,null,u)):y<h?(u=Math.floor(y/R),E?u===1?(0,p.localize)(22,null,u):(0,p.localize)(23,null,u):u===1?(0,p.localize)(24,null,u):(0,p.localize)(25,null,u)):(u=Math.floor(y/h),E?u===1?(0,p.localize)(26,null,u):(0,p.localize)(27,null,u):u===1?(0,p.localize)(28,null,u):(0,p.localize)(29,null,u))}t.fromNow=f;function O(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=O}),define(Q[68],Z([5,6]),function(q,t){return q.create("vs/base/common/errorMessage",t)}),define(Q[30],Z([0,1,68,8,23]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function b(f,O){return O&&(f.stack||f.stacktrace)?p.localize(0,null,R(f),T(f.stack)||T(f.stacktrace)):R(f)}function T(f){return Array.isArray(f)?f.join(`
`):f}function R(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?p.localize(1,null,f.message):f.message||p.localize(2,null)}function h(f=null,O=!1){if(!f)return p.localize(3,null);if(Array.isArray(f)){const d=L.coalesce(f),E=h(d[0],O);return d.length>1?p.localize(4,null,E,d.length):E}if(C.isString(f))return f;if(f.detail){const d=f.detail;if(d.error)return b(d.error,O);if(d.exception)return b(d.exception,O)}return f.stack?b(f,O):f.message?f.message:p.localize(5,null)}t.toErrorMessage=h}),define(Q[69],Z([5,6]),function(q,t){return q.create("vs/base/node/processes",t)}),define(Q[70],Z([0,1,3,15,13,35,69,36,8,21,33,17,44,10]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function u(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(i,e){if(d.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};e&&(n.cwd=e);const s=b.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],n);return new Promise(a=>{s.once("error",r=>{a({success:!1,error:r})}),s.once("exit",(r,g)=>{a(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?u(n.status):1})}else if(d.isLinux||d.isMacintosh)try{const n=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(s=>{b.execFile(n,[i.pid.toString()],{encoding:"utf8",shell:!0},(a,r,g)=>{s(a?{success:!1,error:a}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function v(i=R.env){return i.comspec||"cmd.exe"}t.getWindowsShell=v;class m{constructor(e,n,s,a){if(n!==void 0&&s!==void 0&&a!==void 0)this.cmd=e,this.args=n,this.shell=s,this.options=a;else{const r=e;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(R.env).forEach(g=>{r[g]=R.env[g]}),Object.keys(this.options.env).forEach(g=>{r[g]=this.options.env[g]}),this.options.env=r}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const n=e.lastIndexOf(p.sep);return n!==-1&&(e=e.substring(n+1)),m.WellKnowCommands[e]?e:"other"}start(e){return d.isWindows&&(this.options&&this.options.cwd&&O.isUNC(this.options.cwd)||!this.options&&O.isUNC(R.cwd()))?Promise.reject(new Error(T.localize(0,null))):this.useExec().then(n=>{let s,a;const r=new Promise((g,k)=>{s=g,a=k});if(n){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=b.exec(g,this.options,(k,z,N)=>{this.childProcess=null;const F=k;F&&F.killed?a({killed:this.terminateRequested,stdout:z.toString(),stderr:N.toString()}):this.handleExec(s,e,k,z,N)})}else{let g=null;const k=z=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(z,s,e,a);const N={terminated:this.terminateRequested};h.isNumber(z)&&(N.cmdCode=z),s(N)};if(this.shell&&d.isWindows){const z=f.deepClone(this.options);z.windowsVerbatimArguments=!0,z.detached=!1;let N=!1,F=!1;const j=[];let $=this.ensureQuotes(this.cmd);j.push($.value),N=$.quoted,this.args&&this.args.forEach(ne=>{$=this.ensureQuotes(ne),j.push($.value),F=F&&$.quoted});const X=["/s","/c"];N?F?X.push('"'+j.join(" ")+'"'):j.length>1?X.push('"'+j[0]+'" '+j.slice(1).join(" ")):X.push('"'+j[0]+'"'):X.push(j.join(" ")),g=b.spawn(v(),X,z)}else this.cmd&&(g=b.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(h.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",z=>{this.childProcess=null,a({terminated:this.terminateRequested,error:z})}),g.pid&&(this.childProcess.on("close",k),this.handleSpawn(g,s,e,a,!0)))}return r})}handleClose(e,n,s,a){}ensureQuotes(e){return m.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,w(e,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!d.isWindows)return e(!1);const n=b.spawn(v(),["/s","/c"]);n.on("error",s=>e(!0)),n.on("exit",s=>e(!1))})}}t.AbstractProcess=m,m.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},m.regexp=/^[^"].* .*[^"]/;class I extends m{constructor(e,n,s,a){super(e,n,s,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,n,s,a,r){[a,r].forEach((g,k)=>{const z=new E.LineDecoder;z.write(g).forEach(j=>{n({line:j,source:k===0?0:1})});const F=z.end();F&&n({line:F,source:k===0?0:1})}),e({terminated:this.terminateRequested,error:s})}handleSpawn(e,n,s,a,r){const g=new E.LineDecoder,k=new E.LineDecoder;e.stdout.on("data",z=>{g.write(z).forEach(F=>s({line:F,source:0}))}),e.stderr.on("data",z=>{k.write(z).forEach(F=>s({line:F,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=k}handleClose(e,n,s,a){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&s({line:r,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&s({line:g,source:1})}}t.LineProcess=I;function D(i){let e=[],n=!1;const s=function(a){if(n){e.push(a);return}(!i.send(a,g=>{if(g&&console.error(g),n=!1,e.length>0){const k=e.slice(0);e=[],k.forEach(z=>s(z))}})||d.isWindows)&&(n=!0)};return{send:s}}t.createQueuedSender=D;var o;(function(i){async function e(n,s,a){if(p.isAbsolute(n))return n;if(s===void 0&&(s=R.cwd()),p.dirname(n)!=="."||(a===void 0&&h.isString(R.env.PATH)&&(a=R.env.PATH.split(p.delimiter)),a===void 0||a.length===0))return p.join(s,n);async function g(k){return await L.exists(k)?!(await C.promises.stat(k)).isDirectory():!1}for(let k of a){let z;if(p.isAbsolute(k)?z=p.join(k,n):z=p.join(s,k,n),await g(z))return z;let N=z+".com";if(await g(N)||(N=z+".exe",await g(N)))return N}return p.join(s,n)}i.findExecutable=e})(o=t.win32||(t.win32={}))}),define(Q[45],Z([0,1,35,2,4,21,11,70,34,58,28,14,16,17]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends h.ChannelServer{constructor(m){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(D){}},onMessage:T.Event.fromNodeEventEmitter(process,"message",I=>E.VSBuffer.wrap(Buffer.from(I,"base64")))},m);process.once("disconnect",()=>this.dispose())}}t.Server=u;class w{constructor(m,I){this.modulePath=m,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new T.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const D=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new L.Delayer(D),this.child=null,this._client=null}getChannel(m){const I=this;return{call(D,o,i){return I.requestPromise(m,D,o,i)},listen(D,o){return I.requestEvent(m,D,o)}}}requestPromise(m,I,D,o=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(d.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(m),e=(0,L.createCancelablePromise)(a=>i.call(I,D,a)),n=o.onCancellationRequested(()=>e.cancel()),s=(0,C.toDisposable)(()=>e.cancel());return this.activeRequests.add(s),e.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(m,I,D){if(!this.disposeDelayer)return T.Event.None;this.disposeDelayer.cancel();let o;const i=new T.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(m).listen(I,D)(i.fire,i),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env=Object.assign(Object.assign({},(0,b.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(I.env=Object.assign(Object.assign({},I.env),this.options.env)),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),y.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,m,I);const D=new T.Emitter;T.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,f.isRemoteConsoleLog)(r)){(0,f.log)(r,`IPC Library: ${this.options.serverName}`);return}D.fire(E.VSBuffer.wrap(Buffer.from(r,"base64")))});const i=this.options.useQueue?(0,R.createQueuedSender)(this.child):this.child,e=r=>this.child&&this.child.connected&&i.send(r.buffer.toString("base64")),n=D.event,s={send:e,onMessage:n};this._client=new h.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,g)=>{process.removeListener("exit",a),this.activeRequests.forEach(k=>(0,C.dispose)(k)),this.activeRequests.clear(),r!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:g})})}return this._client}getCachedChannel(m){let I=this.channels.get(m);return I||(I=this.client.getChannel(m),this.channels.set(m,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=w}),define(Q[71],Z([5,6]),function(q,t){return q.create("vs/base/node/zip",t)}),define(Q[72],Z([5,6]),function(q,t){return q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[73],Z([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[74],Z([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[75],Z([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[76],Z([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[77],Z([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[78],Z([5,6]),function(q,t){return q.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[79],Z([5,6]),function(q,t){return q.create("vs/platform/files/common/fileService",t)}),define(Q[80],Z([5,6]),function(q,t){return q.create("vs/platform/files/common/io",t)}),define(Q[81],Z([5,6]),function(q,t){return q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[82],Z([5,6]),function(q,t){return q.create("vs/platform/request/common/request",t)}),define(Q[83],Z([5,6]),function(q,t){return q.create("vs/platform/telemetry/common/telemetryService",t)});var ce=this&&this.__decorate||function(q,t,p,C){var L=arguments.length,b=L<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,p):C,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(q,t,p,C);else for(var R=q.length-1;R>=0;R--)(T=q[R])&&(b=(L<3?T(b):L>3?T(t,p,b):T(t,p))||b);return L>3&&b&&Object.defineProperty(t,p,b),b};define(Q[84],Z([0,1,3,18,56,67,10,9,36]),function(q,t,p,C,L,b,T,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class f{constructor(u,w,v){this._args=u,this.paths=w,this.productService=v}get appRoot(){return(0,p.dirname)(T.FileAccess.asFileUri("",q).fsPath)}get userHome(){return R.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return R.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return R.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return R.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(R.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return R.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return R.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=h.env.VSCODE_PORTABLE;return u?R.URI.file((0,p.join)(u,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return R.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,p.resolve)(u):(0,p.normalize)((0,p.join)(T.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,p.resolve)(u):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,p.resolve)(u);const w=h.env.VSCODE_EXTENSIONS;if(w)return w;const v=h.env.VSCODE_PORTABLE;return v?(0,p.join)(v,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(w=>/^[^:/?#]+?:\/\//.test(w)?R.URI.parse(w):R.URI.file((0,p.normalize)(w)))}get extensionDevelopmentKind(){var u;return(u=this.args.extensionDevelopmentKind)===null||u===void 0?void 0:u.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?R.URI.parse(u):R.URI.file((0,p.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return O(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!h.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(R.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return R.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([L.memoize],f.prototype,"appRoot",null),ce([L.memoize],f.prototype,"userHome",null),ce([L.memoize],f.prototype,"userDataPath",null),ce([L.memoize],f.prototype,"appSettingsHome",null),ce([L.memoize],f.prototype,"tmpDir",null),ce([L.memoize],f.prototype,"userRoamingDataHome",null),ce([L.memoize],f.prototype,"settingsResource",null),ce([L.memoize],f.prototype,"userDataSyncHome",null),ce([L.memoize],f.prototype,"userDataSyncLogResource",null),ce([L.memoize],f.prototype,"sync",null),ce([L.memoize],f.prototype,"machineSettingsResource",null),ce([L.memoize],f.prototype,"globalStorageHome",null),ce([L.memoize],f.prototype,"workspaceStorageHome",null),ce([L.memoize],f.prototype,"keybindingsResource",null),ce([L.memoize],f.prototype,"keyboardLayoutResource",null),ce([L.memoize],f.prototype,"argvResource",null),ce([L.memoize],f.prototype,"snippetsHome",null),ce([L.memoize],f.prototype,"isExtensionDevelopment",null),ce([L.memoize],f.prototype,"untitledWorkspacesHome",null),ce([L.memoize],f.prototype,"installSourcePath",null),ce([L.memoize],f.prototype,"builtinExtensionsPath",null),ce([L.memoize],f.prototype,"extensionsPath",null),ce([L.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ce([L.memoize],f.prototype,"extensionDevelopmentKind",null),ce([L.memoize],f.prototype,"extensionTestsLocationURI",null),ce([L.memoize],f.prototype,"debugExtensionHost",null),ce([L.memoize],f.prototype,"serviceMachineIdResource",null),ce([L.memoize],f.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=f;function O(y,u){return E(y["inspect-extensions"],y["inspect-brk-extensions"],5870,u,y.debugId)}t.parseExtensionHostPort=O;function d(y,u){return E(y["inspect-search"],y["inspect-brk-search"],5876,u)}t.parseSearchPort=d;function E(y,u,w,v,m){const D=Number(u||y)||(v?null:w),o=D?Boolean(!!u):!1;return{port:D,break:o,debugId:m}}}),function(){"use strict";function q(t,p,C){function L(T){return t.resolve(b(T))}function b(T){const R=process.env.VSCODE_PORTABLE;if(R)return t.join(R,"user-data");const h=T["user-data-dir"];if(h)return h;let f=process.env.VSCODE_APPDATA;if(!f)switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=t.join(O,"AppData","Roaming")}break;case"darwin":f=t.join(p.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||t.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(f,C)}return{getUserDataPath:L}}if(typeof define=="function")define(Q[85],Z([0,125,46,10,18]),function(t,p,C,L,b){const T=b.dirname(L.FileAccess.asFileUri("",t)),R=t.__$__nodeRequire(b.joinPath(T,"package.json").fsPath);return q(p,C,R.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),p=require("path"),C=require("os");module.exports=q(p,C,t.name)}else throw new Error("Unknown context")}(),define(Q[86],Z([0,1,46,85,84]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class b extends L.AbstractNativeEnvironmentService{constructor(R,h){super(R,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,C.getUserDataPath)(R)},h)}}t.NativeEnvironmentService=b}),define(Q[87],Z([0,1,21]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const C=/^%([\w\d.-]+)%$/i;function L(b,T){const R=h=>{if(typeof h=="string"){const f=C.exec(h);if(!!f)return T[f[1]]||h}};return(0,p.cloneAndChange)(b,R)}t.localizeManifest=L}),define(Q[47],Z([0,1,78]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function L(d){return d=d.trim(),d==="*"||C.test(d)}t.isValidVersionStr=L;function b(d){if(!L(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=d.match(C);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}t.parseVersion=b;function T(d){if(!d)return null;let E=d.majorBase,y=d.majorMustEqual,u=d.minorBase,w=d.minorMustEqual,v=d.patchBase,m=d.patchMustEqual;return d.hasCaret&&(E===0||(w=!1),m=!1),{majorBase:E,majorMustEqual:y,minorBase:u,minorMustEqual:w,patchBase:v,patchMustEqual:m,isMinimum:d.hasGreaterEquals}}t.normalizeVersion=T;function R(d,E){let y;typeof d=="string"?y=T(b(d)):y=d;let u;if(typeof E=="string"?u=T(b(E)):u=E,!y||!u)return!1;let w=y.majorBase,v=y.minorBase,m=y.patchBase,I=u.majorBase,D=u.minorBase,o=u.patchBase,i=u.majorMustEqual,e=u.minorMustEqual,n=u.patchMustEqual;return u.isMinimum?w>I?!0:w<I?!1:v>D?!0:v<D?!1:m>=o:(w===1&&I===0&&(!i||!e||!n)&&(I=1,D=0,o=0,i=!0,e=!1,n=!1),w<I?!1:w>I?!i:v<D?!1:v>D?!e:m<o?!1:m>o?!n:!0)}t.isValidVersion=R;function h(d,E,y){return E.isBuiltin||typeof E.main=="undefined"?!0:O(d,E.engines.vscode,y)}t.isValidExtensionVersion=h;function f(d,E){return d==="*"||O(E,d)}t.isEngineValid=f;function O(d,E,y=[]){let u=T(b(E));if(!u)return y.push(p.localize(0,null,E)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return y.push(p.localize(1,null,E)),!1}else if(!u.majorMustEqual)return y.push(p.localize(2,null,E)),!1;return R(d,u)?!0:(y.push(p.localize(3,null,d,E)),!1)}t.isVersionValid=O}),define(Q[88],Z([0,1,34,45,2,10]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends L.Disposable{constructor(h,f,O,d){super();this.folders=h,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new C.Client(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.setFolders(this.folders)}setVerboseLogging(h){this.verboseLogging=h,!this.isDisposed&&this.service&&this.service.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[89],Z([0,1,34,45,2,10]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends L.Disposable{constructor(h,f,O,d,E={}){super();this.folders=h,this.onDidFilesChange=f,this.onLogMessage=O,this.verboseLogging=d,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const h=this._register(new C.Client(b.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(h.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=T.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(h.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f))),this.service.setRoots(this.folders)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${h}`})}setVerboseLogging(h){this.verboseLogging=h,this.service&&this.service.setVerboseLogging(h)}setFolders(h){this.folders=h,this.service&&this.service.setRoots(h)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T,T.MAX_RESTARTS=5}),define(Q[90],Z([0,1,35,44,60,10]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class T{constructor(h,f,O,d,E){this.watchedFolder=h,this.eventCallback=O,this.logCallback=d,this.verboseLogging=E,this.restartCounter=0,Array.isArray(f)?this.ignored=f.map(y=>L.parse(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${h}`),this.startWatcher()}startWatcher(){const h=[this.watchedFolder];this.verboseLogging&&h.push("-verbose"),this.handle=p.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,h);const f=new C.LineDecoder;this.handle.stdout.on("data",O=>{const d=[];f.write(O).forEach(E=>{const y=E.split("|");if(y.length===2){const u=Number(y[0]),w=y[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(v=>v(w))){this.verboseLogging&&this.log(w);return}d.push({type:T.changeTypeMap[u],path:w})}else this.log(y[1])}}),d.length>0&&this.eventCallback(d)}),this.handle.on("error",O=>this.onError(O)),this.handle.stderr.on("data",O=>this.onError(O)),this.handle.on("exit",(O,d)=>this.onExit(O,d))}onError(h){this.error("process error: "+h.toString())}onExit(h,f){this.handle&&(this.error(`terminated unexpectedly (code: ${h}, signal: ${f})`),this.restartCounter<=T.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(h){this.logCallback({type:"error",message:`[File Watcher (C#)] ${h}`})}log(h){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${h}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=T,T.MAX_RESTARTS=5,T.changeTypeMap=[0,1,2]}),define(Q[91],Z([0,1,90,3,20]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class b{constructor(R,h,f,O){this.onDidFilesChange=h,this.onLogMessage=f,this.verboseLogging=O,this.service=void 0,this.folder=R[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(C.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,C.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,R=>this.onFileEvents(R),R=>this.onLogMessage(R),this.verboseLogging)}setVerboseLogging(R){this.verboseLogging=R,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(R){this.isDisposed||R.length>0&&this.onDidFilesChange(R)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=b}),define(Q[48],Z([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class p{constructor(b,T=[],R=!1){this.ctor=b,this.staticArguments=T,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=p;const C=(L,...b)=>new p(L,b);t.createSyncDescriptor=C}),define(Q[92],Z([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class p{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}t.Node=p;class C{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let T of this._nodes.values())T.outgoing.size===0&&b.push(T);return b}insertEdge(b,T){const R=this.lookupOrInsertNode(b),h=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),h),h.incoming.set(this._hashFn(b),R)}removeNode(b){const T=this._hashFn(b);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(b){const T=this._hashFn(b);let R=this._nodes.get(T);return R||(R=new p(b),this._nodes.set(T,R)),R}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[T,R]of this._nodes)b.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return b.join(`
`)}}t.Graph=C}),define(Q[93],Z([0,1,7]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Q[22],Z([0,1,7]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,p.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,p.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,73,7,10]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function b(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=b;var T;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=5]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(T=t.SortBy||(t.SortBy={}));var R;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(R=t.SortOrder||(t.SortOrder={}));var h;(function(d){d.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var f;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class O extends Error{constructor(E,y){super(E);this.code=y}}t.ExtensionManagementError=O,t.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),t.ExtensionsLabel=(0,p.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,p.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Q[37],Z([0,1,20,7]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(b=t.ExtensionType||(t.ExtensionType={}));class T{constructor(O){this.value=O,this._lower=O.toLowerCase()}static equals(O,d){if(typeof O=="undefined"||O===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof O=="string"||typeof d=="string"){let E=typeof O=="string"?O:O.value,y=typeof d=="string"?d:d.value;return p.equalsIgnoreCase(E,y)}return O._lower===d._lower}static toKey(O){return typeof O=="string"?O.toLowerCase():O._lower}}t.ExtensionIdentifier=T;function R(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=R;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,20,37]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function L(y,u){return y.uuid&&u.uuid?y.uuid===u.uuid:y.id===u.id?!0:(0,p.compareIgnoreCase)(y.id,u.id)===0}t.areSameExtensions=L;class b{constructor(u,w){this.version=w,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof b?L(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=b;function T(y,u){return`${y}.${u}`}t.getExtensionId=T;function R(y){return y.toLocaleLowerCase()}t.adoptToGalleryExtensionId=R;function h(y,u){return R(T(y,u))}t.getGalleryExtensionId=h;function f(y,u){const w=[],v=m=>{for(const I of w)if(I.some(D=>L(u(D),u(m))))return I;return null};for(const m of y){const I=v(m);I?I.push(m):w.push([m])}return w}t.groupByExtension=f;function O(y){return{id:y.identifier.id,name:y.manifest.name,galleryId:null,publisherId:y.publisherId,publisherName:y.manifest.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:y.manifest.extensionDependencies&&y.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=O;function d(y){return Object.assign({id:y.identifier.id,name:y.name,galleryId:y.identifier.uuid,publisherId:y.publisherId,publisherName:y.publisher,publisherDisplayName:y.publisherDisplayName,dependencies:!!(y.properties.dependencies&&y.properties.dependencies.length>0)},y.telemetryData)}t.getGalleryExtensionTelemetryData=d,t.BetterMergeId=new C.ExtensionIdentifier("pprice.better-merge");function E(y){const u=new Set;for(const w of y)w.malicious&&u.add(w.id.id);return u}t.getMaliciousExtensionsSet=E}),define(Q[94],Z([0,1,2,3,37,13]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends p.Disposable{constructor(h,f){super();this.environmentService=h,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtension(O=>this.onDidInstallExtension(O))),this._register(f.onDidUninstallExtension(O=>this.onDidUnInstallExtension(O)))}onDidInstallExtension(h){h.error||this.invalidate()}onDidUnInstallExtension(h){h.error||this.invalidate()}invalidate(){b.rimraf(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Q[49],Z([0,1,80,16,19,14]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(O,d,E,y,u,w){let v;try{await R(O,d,E,y,u,w)}catch(m){v=m}finally{v&&u.errorTransformer&&(v=u.errorTransformer(v)),typeof v!="undefined"&&E.error(v),E.end()}}t.readFileIntoStream=T;async function R(O,d,E,y,u,w){h(w);const v=await O.open(d,{create:!1});try{h(w);let m=0,I=0,D=u&&typeof u.length=="number"?u.length:void 0,o=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof D=="number"?D:u.bufferSize)),i=u&&typeof u.position=="number"?u.position:0,e=0;do I=await O.read(v,i,o.buffer,e,o.byteLength-e),i+=I,e+=I,m+=I,typeof D=="number"&&(D-=I),e===o.byteLength&&(await E.write(y(o)),o=C.VSBuffer.alloc(Math.min(u.bufferSize,typeof D=="number"?D:u.bufferSize)),e=0);while(I>0&&(typeof D!="number"||D>0)&&h(w)&&f(m,u));if(e>0){let n=e;typeof D=="number"&&(n=Math.min(e,D)),E.write(y(o.slice(0,n)))}}catch(m){throw(0,L.ensureFileSystemProviderError)(m)}finally{await O.close(v)}}function h(O){if(O.isCancellationRequested)throw(0,b.canceled)();return!0}function f(O,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&O>d.limits.memory)throw(0,L.createFileSystemProviderError)((0,p.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&O>d.limits.size)throw(0,L.createFileSystemProviderError)((0,p.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[50],Z([0,1,9,19,17]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function b(h){return h.map(f=>({type:f.type,resource:p.URI.file(f.path)}))}t.toFileChanges=b;function T(h){const f=new R;for(const O of h)f.processEvent(O);return f.normalize()}t.normalizeFileChanges=T;class R{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(f){const O=this.mapPathToChange.get(f.path);if(O){const d=O.type,E=f.type;d===1&&E===2?(this.mapPathToChange.delete(f.path),this.normalized.splice(this.normalized.indexOf(O),1)):d===2&&E===1?O.type=0:d===1&&E===0||(O.type=E)}else this.normalized.push(f),this.mapPathToChange.set(f.path,f)}normalize(){const f=[],O=[];return this.normalized.filter(d=>d.type!==2?(f.push(d),!1):!0).sort((d,E)=>d.path.length-E.path.length).filter(d=>O.some(E=>(0,C.isParent)(d.path,E,!L.isLinux))?!1:(O.push(d.path),!0)).concat(f)}}}),define(Q[95],Z([0,1,50,2,13,62,64,4,3]),function(q,t,p,C,L,b,T,R,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class f extends C.Disposable{constructor(d,E,y,u){super();this.path=d,this.onDidFilesChange=E,this.onLogMessage=y,this.verboseLogging=u,this.fileChangesDelayer=this._register(new R.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(d){this.verboseLogging=d}async startWatching(){try{const{stat:d,symbolicLink:E}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(E)try{y=await(0,b.realpath)(y)}catch(u){if(this.onError(u),E.dangling)return}d.isDirectory()?this._register((0,T.watchFolder)(y,(u,w)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,h.join)(this.path,(0,h.basename)(w))})},u=>this.onError(u))):this._register((0,T.watchFile)(y,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(d){d.code!=="ENOENT"&&this.onError(d)}}onFileChange(d){this.fileChangesBuffer.push(d),this.verboseLogging&&this.onVerbose(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,p.normalizeFileChanges)(E);this.verboseLogging&&y.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),y.length>0&&this.onDidFilesChange(y)})}onError(d){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${d}`})}onVerbose(d){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=f}),define(Q[51],Z([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class p{constructor(...L){this._entries=new Map;for(let[b,T]of L)this.set(b,T)}set(L,b){const T=this._entries.get(L);return this._entries.set(L,b),T}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}t.ServiceCollection=p}),define(Q[96],Z([0,1,14,92,48,7,51,4]),function(q,t,p,C,L,b,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const h=!1;class f extends Error{constructor(u){super("cyclic dependency between services");this.message=u.toString()}}class O{constructor(u=new T.ServiceCollection,w=!1,v){this._activeInstantiations=new Set,this._services=u,this._strict=w,this._parent=v,this._services.set(b.IInstantiationService,this)}createChild(u){return new O(u,this._strict,this)}invokeFunction(u,...w){let v=E.traceInvocation(u),m=!1;try{return u({get:(D,o)=>{if(m)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const i=this._getOrCreateServiceInstance(D,v);if(!i&&o!==b.optional)throw new Error(`[invokeFunction] unknown service '${D}'`);return i}},...w)}finally{m=!0,v.stop()}}createInstance(u,...w){let v,m;return u instanceof L.SyncDescriptor?(v=E.traceCreation(u.ctor),m=this._createInstance(u.ctor,u.staticArguments.concat(w),v)):(v=E.traceCreation(u),m=this._createInstance(u,w,v)),v.stop(),m}_createInstance(u,w=[],v){let m=b._util.getServiceDependencies(u).sort((o,i)=>o.index-i.index),I=[];for(const o of m){let i=this._getOrCreateServiceInstance(o.id,v);if(!i&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);I.push(i)}let D=m.length>0?m[0].index:w.length;if(w.length!==D){console.warn(`[createInstance] First service dependency of ${u.name} at position ${D+1} conflicts with ${w.length} static arguments`);let o=D-w.length;o>0?w=w.concat(new Array(o)):w=w.slice(0,D)}return new u(...[...w,...I])}_setServiceInstance(u,w){if(this._services.get(u)instanceof L.SyncDescriptor)this._services.set(u,w);else if(this._parent)this._parent._setServiceInstance(u,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let w=this._services.get(u);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):w}_getOrCreateServiceInstance(u,w){let v=this._getServiceInstanceOrDescriptor(u);return v instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,w.branch(u,!0)):(w.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,w,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,w,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,w,v){const m=new C.Graph(o=>o.id.toString());let I=0;const D=[{id:u,desc:w,_trace:v}];for(;D.length;){const o=D.pop();if(m.lookupOrInsertNode(o),I++>1e3)throw new f(m);for(let i of b._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(i.id);if(!e&&!i.optional&&console.warn(`[createInstance] ${u} depends on ${i.id} which is NOT registered.`),e instanceof L.SyncDescriptor){const n={id:i.id,desc:e,_trace:o._trace.branch(i.id,!0)};m.insertEdge(o,n),D.push(n)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new f(m);break}for(const{data:i}of o){if(this._getServiceInstanceOrDescriptor(i.id)instanceof L.SyncDescriptor){const n=this._createServiceInstanceWithOwner(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this._setServiceInstance(i.id,n)}m.removeNode(i)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,w,v=[],m,I){if(this._services.get(u)instanceof L.SyncDescriptor)return this._createServiceInstance(w,v,m,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,w,v,m,I);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(u,w=[],v,m){if(v){const I=new R.IdleValue(()=>this._createInstance(u,w,m));return new Proxy(Object.create(null),{get(D,o){if(o in D)return D[o];let i=I.value,e=i[o];return typeof e!="function"||(e=e.bind(i),D[o]=e),e},set(D,o,i){return I.value[o]=i,!0}})}else return this._createInstance(u,w,m)}}t.InstantiationService=O;var d;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(d||(d={}));class E{constructor(u,w){this.type=u,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return h?new E(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(u){return h?new E(0,u.name):E._None}branch(u,w){let v=new E(2,u.toString());return this._dep.push([u,w,v]),v}stop(){let u=Date.now()-this._start;E._totals+=u;let w=!1;function v(I,D){let o=[],i=new Array(I+1).join("	");for(const[e,n,s]of D._dep)if(n&&s){w=!0,o.push(`${i}CREATES -> ${e}`);let a=v(I+1,s);a&&o.push(a)}else o.push(`${i}uses -> ${e}`);return o.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(u>2||w)&&console.log(m.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Q[38],Z([0,1,7]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,p.createDecorator)("localizationsService");function C(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const b of L.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}t.isValidLocalization=C});var ue=this&&this.__param||function(q,t){return function(p,C){t(p,C,q)}};define(Q[97],Z([0,1,74,14,9,39,24,25,37,61,28,10,38]),function(q,t,p,C,L,b,T,R,h,f,O,d,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const y=D=>(0,p.localize)(0,null,D),u=(0,p.localize)(1,null,"ms-dotnettools.csharp");function w(D,o){return o?`${D.publisher}.${D.name}@${D.version}`:`${D.publisher}.${D.name}`}const v=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function m(D){const o=v.exec(D);return o&&o[1]?[(0,R.adoptToGalleryExtensionId)(o[1]),o[2]]:[(0,R.adoptToGalleryExtensionId)(D),void 0]}t.getIdAndVersion=m;let I=class{constructor(o,i,e){this.extensionManagementService=o,this.extensionGalleryService=i,this.localizationsService=e}get location(){}async listExtensions(o,i,e=console){let n=await this.extensionManagementService.getInstalled(1);const s=h.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(i&&i!==""){if(s.indexOf(i.toLowerCase())<0){e.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(r=>r.manifest.categories?r.manifest.categories.map(k=>k.toLowerCase()).indexOf(i.toLowerCase())>-1:!1)}else if(i===""){e.log("Possible Categories: "),s.forEach(r=>{e.log(r)});return}this.location&&e.log((0,p.localize)(2,null,this.location)),n=n.sort((r,g)=>r.identifier.id.localeCompare(g.identifier.id));let a;for(let r of n)a!==r.identifier.id&&(a=r.identifier.id,e.log(w(r.manifest,o)))}async installExtensions(o,i,e,n,s=console){const a=[],r=[];o.length&&s.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const g=await this.extensionManagementService.getInstalled(1),k=(F,j)=>{const $=g.find(X=>(0,R.areSameExtensions)(X.identifier,{id:F}));if($){if(!j&&!n)return s.log((0,p.localize)(5,null,F,$.manifest.version,F)),!1;if(j&&$.manifest.version===j)return s.log((0,p.localize)(6,null,`${F}@${j}`)),!1}return!0},z=[],N=[];for(const F of o)if(F instanceof L.URI)z.push(F);else{const[j,$]=m(F);k(j,$)&&N.push({id:j,version:$,installOptions:{isBuiltin:!1,isMachineScoped:e}})}for(const F of i){const[j,$]=m(F);k(j,$)&&N.push({id:j,version:$,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(z.length&&await Promise.all(z.map(async F=>{try{const j=await this.installVSIX(F,n,s);j&&r.push(j)}catch(j){s.error(j.message||j.stack||j),a.push(F.toString())}})),N.length){const F=await this.getGalleryExtensions(N);await Promise.all(N.map(async j=>{const $=F.get(j.id.toLowerCase());if($)try{const X=await this.installFromGallery(j,$,g,n,s);X&&r.push(X)}catch(X){s.error(X.message||X.stack||X),a.push(j.id)}else s.error(`${y(j.version?`${j.id}@${j.version}`:j.id)}
${u}`),a.push(j.id)}))}if(r.some(F=>(0,h.isLanguagePackExtension)(F))&&await this.updateLocalizationsCache(),a.length)throw new Error((0,p.localize)(7,null,a.join(", ")))}async installVSIX(o,i,e){const n=await this.extensionManagementService.getManifest(o);if(!n)throw new Error("Invalid vsix");if(await this.validateVSIX(n,i,e))try{return await this.extensionManagementService.install(o),e.log((0,p.localize)(8,null,(0,f.getBaseLabel)(o))),n}catch(a){if((0,C.isPromiseCanceledError)(a))return e.log((0,p.localize)(9,null,(0,f.getBaseLabel)(o))),null;throw a}return null}async getGalleryExtensions(o){const i=o.filter(({version:s})=>s===void 0).map(({id:s})=>s),e=o.filter(({version:s})=>s!==void 0),n=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(i,O.CancellationToken.None)).forEach(a=>n.set(a.identifier.id.toLowerCase(),a))})(),Promise.all(e.map(async({id:s,version:a})=>{const r=await this.extensionGalleryService.getCompatibleExtension({id:s},a);r&&n.set(r.identifier.id.toLowerCase(),r)}))]),n}async installFromGallery({id:o,version:i,installOptions:e},n,s,a,r){const g=await this.extensionGalleryService.getManifest(n,O.CancellationToken.None);if(g&&!this.validateExtensionKind(g,r))return null;const k=s.find(z=>(0,R.areSameExtensions)(z.identifier,n.identifier));if(k){if(n.version===k.manifest.version)return r.log((0,p.localize)(10,null,i?`${o}@${i}`:o)),null;r.log((0,p.localize)(11,null,o,n.version))}try{return e.isBuiltin?r.log((0,p.localize)(12,null,o,n.version)):r.log((0,p.localize)(13,null,o,n.version)),await this.extensionManagementService.installFromGallery(n,e),r.log((0,p.localize)(14,null,o,n.version)),g}catch(z){if((0,C.isPromiseCanceledError)(z))return r.log((0,p.localize)(15,null,o)),null;throw z}}validateExtensionKind(o,i){return!0}async validateVSIX(o,i,e){const n={id:(0,R.getGalleryExtensionId)(o.publisher,o.name)},a=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,R.areSameExtensions)(n,r.identifier)&&(0,b.gt)(r.manifest.version,o.version));return a&&!i?(e.log((0,p.localize)(16,null,a.identifier.id,a.manifest.version,o.version)),!1):this.validateExtensionKind(o,e)}async uninstallExtensions(o,i,e=console){const n=async a=>{if(a instanceof L.URI){const r=await this.extensionManagementService.getManifest(a);return w(r)}return a},s=[];for(const a of o){const r=await n(a),k=(await this.extensionManagementService.getInstalled()).filter(z=>(0,R.areSameExtensions)(z.identifier,{id:r}));if(!k.length)throw new Error(`${this.notInstalled(r)}
${u}`);if(k.some(z=>z.type===0)){e.log((0,p.localize)(17,null,r));return}if(!i&&k.some(z=>z.isBuiltin)){e.log((0,p.localize)(18,null,r));return}e.log((0,p.localize)(19,null,r));for(const z of k)await this.extensionManagementService.uninstall(z),s.push(z);this.location?e.log((0,p.localize)(20,null,r,this.location)):e.log((0,p.localize)(21,null,r))}s.some(a=>(0,h.isLanguagePackExtension)(a.manifest))&&await this.updateLocalizationsCache()}async locateExtension(o,i=console){const e=await this.extensionManagementService.getInstalled();o.forEach(n=>{e.forEach(s=>{if(s.identifier.id===n&&s.location.scheme===d.Schemas.file){i.log(s.location.fsPath);return}})})}updateLocalizationsCache(){return this.localizationsService.update()}notInstalled(o){return this.location?(0,p.localize)(22,null,o,this.location):(0,p.localize)(23,null,o)}};I=ce([ue(0,T.IExtensionManagementService),ue(1,T.IExtensionGalleryService),ue(2,E.ILocalizationsService)],I),t.ExtensionManagementCLIService=I}),define(Q[12],Z([0,1,7,2,17,11,30]),function(q,t,p,C,L,b,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,p.createDecorator)("logService"),t.ILoggerService=(0,p.createDecorator)("loggerService");function R(){return new Date().toISOString()}var h;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(h=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=h.Info;class f extends C.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=f;class O extends f{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...e){this.checkLogLevel(h.Trace)&&this.log(h.Trace,this.format([i,...e]))}debug(i,...e){this.checkLogLevel(h.Debug)&&this.log(h.Debug,this.format([i,...e]))}info(i,...e){this.checkLogLevel(h.Info)&&this.log(h.Info,this.format([i,...e]))}warn(i,...e){this.checkLogLevel(h.Warning)&&this.log(h.Warning,this.format([i,...e]))}error(i,...e){if(this.checkLogLevel(h.Error))if(i instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=i.stack,this.log(h.Error,this.format(n))}else this.log(h.Error,this.format([i,...e]))}critical(i,...e){this.checkLogLevel(h.Critical)&&this.log(h.Critical,this.format([i,...e]))}flush(){}format(i){let e="";for(let n=0;n<i.length;n++){let s=i[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(a){}e+=(n>0?" ":"")+s}return e}}t.AbstractMessageLogger=O;class d extends f{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!L.isWindows}trace(i,...e){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}debug(i,...e){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}info(i,...e){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...e):console.log(`[main ${R()}]`,i,...e))}warn(i,...e){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...e):console.warn(`[main ${R()}]`,i,...e))}error(i,...e){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...e):console.error(`[main ${R()}]`,i,...e))}critical(i,...e){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...e):console.error(`[main ${R()}]`,i,...e))}dispose(){}flush(){}}t.ConsoleMainLogger=d;class E extends f{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...e){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",i,...e)}debug(i,...e){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...e)}info(i,...e){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",i,...e)}warn(i,...e){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",i,...e)}error(i,...e){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",i,...e)}critical(i,...e){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...e)}dispose(){}flush(){}}t.ConsoleLogger=E;class y extends f{constructor(i,e=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(e)}trace(i,...e){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(i),...e])}debug(i,...e){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(i),...e])}info(i,...e){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(i),...e])}warn(i,...e){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(i),...e])}error(i,...e){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(i),...e])}critical(i,...e){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(i),...e])}extractMessage(i){return typeof i=="string"?i:(0,T.toErrorMessage)(i,this.getLevel()<=h.Trace)}dispose(){}flush(){}}t.AdapterLogger=y;class u extends f{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const e of this.logServices)e.setLevel(i);super.setLevel(i)}trace(i,...e){for(const n of this.logServices)n.trace(i,...e)}debug(i,...e){for(const n of this.logServices)n.debug(i,...e)}info(i,...e){for(const n of this.logServices)n.info(i,...e)}warn(i,...e){for(const n of this.logServices)n.warn(i,...e)}error(i,...e){for(const n of this.logServices)n.error(i,...e)}critical(i,...e){for(const n of this.logServices)n.critical(i,...e)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=u;class w extends C.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...e){this.logger.trace(i,...e)}debug(i,...e){this.logger.debug(i,...e)}info(i,...e){this.logger.info(i,...e)}warn(i,...e){this.logger.warn(i,...e)}error(i,...e){this.logger.error(i,...e)}critical(i,...e){this.logger.critical(i,...e)}flush(){this.logger.flush()}}t.LogService=w;class v{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(i){}getLevel(){return h.Info}trace(i,...e){}debug(i,...e){}info(i,...e){}warn(i,...e){}error(i,...e){}critical(i,...e){}dispose(){}flush(){}}t.NullLogService=v;function m(o){if(o.verbose)return h.Trace;if(typeof o.logLevel=="string"){const i=I(o.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function I(o){switch(o){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}t.parseLogLevel=I;function D(o){switch(o){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}t.LogLevelToString=D}),define(Q[98],Z([0,1,15,2,19,24,22,9,18,25,12,31,39,17,4]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends C.Disposable{constructor(I,D,o,i){super();this.fileService=D,this.extensionGalleryService=o,this.logService=i,this.extensionsDownloadDir=R.URI.file(I.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(I,D){await this.cleanUpPromise;const o=this.getName(I),i=(0,h.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(i)){const e=(0,h.joinPath)(this.extensionsDownloadDir,`.${o}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(I,e,D),await this.rename(e,i,Date.now()+2*60*1e3)}return i}async delete(I){}async rename(I,D,o){try{await p.promises.rename(I.fsPath,D.fsPath)}catch(i){if(y.isWindows&&i&&i.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${I} to ${D} with 'EPERM' error. Trying again...`),this.rename(I,D,o);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const I=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(I.children){const D=[],o=[];for(const n of I.children){const s=this.parse(n.name);s&&o.push([s,n])}const i=(0,f.groupByExtension)(o,([n])=>n),e=[];for(const n of i)n.sort((s,a)=>E.rcompare(s[0].version,a[0].version)),D.push(...n.slice(1).map(s=>s[1].resource)),e.push(n[0][1]);e.sort((n,s)=>n.mtime-s.mtime),D.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await u.Promises.settled(D.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(I){this.logService.error(I)}}getName(I){return this.cache?new f.ExtensionIdentifierWithVersion(I.identifier,I.version).key().toLowerCase():(0,d.generateUuid)()}parse(I){const D=w.exec(I);return D&&D[1]&&D[2]?new f.ExtensionIdentifierWithVersion({id:D[1]},D[2]):null}};v=ce([ue(0,T.INativeEnvironmentService),ue(1,L.IFileService),ue(2,b.IExtensionGalleryService),ue(3,O.ILogService)],v),t.ExtensionsDownloader=v}),define(Q[99],Z([0,1,2,12,35,30,3,4,11,10,13,22]),function(q,t,p,C,L,b,T,R,h,f,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let E=class extends p.Disposable{constructor(u,w){super();this.environmentService=u,this.logService=w,this.processesLimiter=new R.Limiter(5)}async postUninstall(u){const w=this.parseScript(u,"uninstall");return w&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${v}`)))),(0,O.rimraf)(this.getExtensionStoragePath(u)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(u,w){const v=`vscode:${w}`;if(u.location.scheme===f.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[v]=="string"){const m=u.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${v} should be a node script`),null):{script:(0,T.join)(u.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(u,w,v,m,I){return new Promise((D,o)=>{const i=this.start(u,w,v,I);let e;const n=s=>{e&&(clearTimeout(e),e=null),s?o(s):D(void 0)};i.on("error",s=>{n((0,b.toErrorMessage)(s)||"Unknown")}),i.on("exit",(s,a)=>{n(s?`post-${w} process exited with code ${s}`:void 0)}),m&&(e=setTimeout(()=>{e=null,i.kill(),o("timed out")},5e3))})}start(u,w,v,m){const I={silent:!0,execArgv:void 0},D=(0,L.fork)(u,[`--type=extension-post-${w}`,...v],I);D.stdout.setEncoding("utf8"),D.stderr.setEncoding("utf8");const o=h.Event.fromNodeEventEmitter(D.stdout,"data"),i=h.Event.fromNodeEventEmitter(D.stderr,"data");o(s=>this.logService.info(m.identifier.id,m.manifest.version,`post-${w}`,s)),i(s=>this.logService.error(m.identifier.id,m.manifest.version,`post-${w}`,s));const e=h.Event.any(h.Event.map(o,s=>({data:`%c${s}`,format:[""]})),h.Event.map(i,s=>({data:`%c${s}`,format:["color: red"]})));return h.Event.debounce(e,(s,a)=>s?{data:s.data+a.data,format:[...s.format,...a.format]}:{data:a.data,format:a.format},100)(s=>{console.group(m.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),D}getExtensionStoragePath(u){return(0,T.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};E=ce([ue(0,d.IEnvironmentService),ue(1,C.ILogService)],E),t.ExtensionsLifecycle=E}),define(Q[100],Z([0,1,2,22,11,19,9,25,18,12]),function(q,t,p,C,L,b,T,R,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let O=class extends p.Disposable{constructor(E,y,u,w){super();this.extensionsManagementService=E,this.logService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(D=>D.identifier),this.startTimestamp=Date.now()}),this._register(E.onInstallExtension(I=>this.onInstallExtension(I))),this._register(E.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(E.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const v=T.URI.file(u.extensionsPath),m=new h.ExtUri(I=>!y.hasCapability(I,1024));this._register(y.watch(v)),this._register(L.Event.filter(y.onDidFilesChange,I=>I.changes.some(D=>this.doesChangeAffects(D,v,m)))(()=>this.onDidChange()))}doesChangeAffects(E,y,u){return u.isEqual(u.dirname(E.resource),y)?u.isEqual(E.resource,u.joinPath(y,".obsolete"))?!0:!(E.type!==1&&E.type!==2||u.basename(E.resource).startsWith(".")):!1}onInstallExtension(E){this.addInstallingExtension(E.identifier)}onDidInstallExtension(E){this.removeInstallingExtension(E.identifier),E.error||this.addInstalledExtension(E.identifier)}onDidUninstallExtension(E){E.error||this.removeInstalledExtension(E.identifier)}addInstallingExtension(E){this.removeInstallingExtension(E),this.installingExtensions.push(E)}removeInstallingExtension(E){this.installingExtensions=this.installingExtensions.filter(y=>!(0,R.areSameExtensions)(y,E))}addInstalledExtension(E){this.installedExtensions&&(this.removeInstalledExtension(E),this.installedExtensions.push(E))}removeInstalledExtension(E){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,R.areSameExtensions)(y,E)))}async onDidChange(){if(this.installedExtensions){const E=await this.extensionsManagementService.getInstalled(1),y=E.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,R.areSameExtensions)(v,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),u=this.installedExtensions.filter(w=>E.every(v=>!(0,R.areSameExtensions)(v.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=E.map(w=>w.identifier),(y.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:u})}}};O=ce([ue(1,b.IFileService),ue(2,C.INativeEnvironmentService),ue(3,f.ILogService)],O),t.ExtensionsWatcher=O}),define(Q[101],Z([0,1,79,126,2,19,11,18,43,23,12,16,32,4,28,10,49,127]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u,w,v,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let I=class extends L.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new y.ResourceQueue)}registerProvider(o,i){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:i});const e=new L.DisposableStore;return e.add(i.onDidChangeFile(n=>this._onDidFilesChange.fire(new b.FileChangesEvent(n,!this.isPathCaseSensitive(i))))),e.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:o}))),typeof i.onDidErrorOccur=="function"&&e.add(i.onDidErrorOccur(n=>this._onError.fire(new Error(n)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:i}),this.provider.delete(o),(0,L.dispose)(e)})}async activateProvider(o){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){i.push(e)}}),!this.provider.has(o)&&await y.Promises.settled(i)}canHandleResource(o){return this.provider.has(o.scheme)}hasCapability(o,i){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&i)}listCapabilities(){return m.Iterable.map(this.provider,([o,i])=>({scheme:o,capabilities:i.capabilities}))}async withProvider(o){if(!(0,R.isAbsolutePath)(o))throw new b.FileOperationError((0,p.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const i=this.provider.get(o.scheme);if(!i){const e=new Error;throw e.name="ENOPRO",e.message=(0,p.localize)(1,null,o.toString()),e}return i}async withReadProvider(o){const i=await this.withProvider(o);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)||(0,b.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const i=await this.withProvider(o);if((0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,i){try{return await this.doResolveFile(o,i)}catch(e){throw(0,b.toFileSystemProviderErrorCode)(e)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,p.localize)(2,null,this.resourceForError(o)),1):(0,b.ensureFileSystemProviderError)(e)}}async doResolveFile(o,i){const e=await this.withProvider(o),n=this.isPathCaseSensitive(e),s=i==null?void 0:i.resolveTo,a=i==null?void 0:i.resolveSingleChildDescendants,r=i==null?void 0:i.resolveMetadata,g=await e.stat(o);let k;return this.toFileStat(e,o,g,void 0,!!r,(z,N)=>(k||(k=h.TernarySearchTree.forUris(()=>!n),k.set(o,!0),(0,f.isNonEmptyArray)(s)&&s.forEach(F=>k.set(F,!0))),Boolean(k.findSuperstr(z.resource)||k.get(z.resource))?!0:z.isDirectory&&a?N===1:!1))}async toFileStat(o,i,e,n,s,a){const{providerExtUri:r}=this.getExtUri(o),g={resource:i,name:r.basename(i),isFile:(e.type&b.FileType.File)!=0,isDirectory:(e.type&b.FileType.Directory)!=0,isSymbolicLink:(e.type&b.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,b.etag)({mtime:e.mtime,size:e.size})};if(g.isDirectory&&a(g,n)){try{const k=await o.readdir(i),z=await y.Promises.settled(k.map(async([N,F])=>{try{const j=r.joinPath(i,N),$=s?await o.stat(j):{type:F};return await this.toFileStat(o,j,$,k.length,s,a)}catch(j){return this.logService.trace(j),null}}));g.children=(0,f.coalesce)(z)}catch(k){this.logService.trace(k),g.children=[]}return g}return g}async resolveAll(o){return y.Promises.settled(o.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const i=await this.withProvider(o);try{return!!await i.stat(o)}catch(e){return!1}}async canCreateFile(o,i){try{await this.doValidateCreateFile(o,i)}catch(e){return e}return!0}async doValidateCreateFile(o,i){if(!(i==null?void 0:i.overwrite)&&await this.exists(o))throw new b.FileOperationError((0,p.localize)(3,null,this.resourceForError(o)),3,i)}async createFile(o,i=d.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const n=await this.writeFile(o,i);return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,n)),n}async writeFile(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(n);try{await this.validateWriteFile(n,o,e)||await this.mkdirp(n,s.dirname(o));let r;if((0,b.hasReadWriteCapability)(n)&&!(i instanceof d.VSBuffer))if((0,E.isReadableStream)(i)){const g=await(0,E.peekStream)(i,3);g.ended?r=d.VSBuffer.concat(g.buffer):r=g}else r=(0,E.peekReadable)(i,g=>d.VSBuffer.concat(g),3);else r=i;!(0,b.hasOpenReadWriteCloseCapability)(n)||(0,b.hasReadWriteCapability)(n)&&r instanceof d.VSBuffer?await this.doWriteUnbuffered(n,o,e,r):await this.doWriteBuffered(n,o,e,r instanceof d.VSBuffer?(0,d.bufferToReadable)(r):r)}catch(a){throw new b.FileOperationError((0,p.localize)(4,null,this.resourceForError(o),(0,b.ensureFileSystemProviderError)(a).toString()),(0,b.toFileOperationResult)(a),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,i,e){if(!!(e==null?void 0:e.unlock)&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(i)));let s;try{s=await o.stat(i)}catch(a){return}if((s.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,p.localize)(6,null,this.resourceForError(i)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==b.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&e.mtime<s.mtime&&e.etag!==(0,b.etag)({mtime:e.mtime,size:s.size}))throw new b.FileOperationError((0,p.localize)(7,null),3,e);return s}async readFile(o,i){const e=await this.withReadProvider(o);return(i==null?void 0:i.atomic)?this.doReadFileAtomic(e,o,i):this.doReadFile(e,o,i)}async doReadFileAtomic(o,i,e){return new Promise((n,s)=>{this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,i,e);n(a)}catch(a){s(a)}})})}async doReadFile(o,i,e){const n=await this.doReadFileStream(o,i,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},n),{value:await(0,d.streamToBuffer)(n.value)})}async readFileStream(o,i){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,i)}async doReadFileStream(o,i,e){const n=new u.CancellationTokenSource,s=this.validateReadFile(i,e).then(r=>r,r=>{throw n.cancel(),r});let a;try{e&&typeof e.etag=="string"&&e.etag!==b.ETAG_DISABLED&&await s,!((0,b.hasOpenReadWriteCloseCapability)(o)||(0,b.hasFileReadStreamCapability)(o))||(0,b.hasReadWriteCapability)(o)&&(e==null?void 0:e.preferUnbuffered)?a=this.readFileUnbuffered(o,i,e):(0,b.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,i,n.token,e):a=this.readFileBuffered(o,i,n.token,e);const r=await s;return Object.assign(Object.assign({},r),{value:a})}catch(r){throw a&&await(0,E.consumeStream)(a),new b.FileOperationError((0,p.localize)(8,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(r).toString()),(0,b.toFileOperationResult)(r),e)}}readFileStreamed(o,i,e,n=Object.create(null)){const s=o.readFileStream(i,n,e);return(0,E.transform)(s,{data:a=>a instanceof d.VSBuffer?a:d.VSBuffer.wrap(a),error:a=>new b.FileOperationError((0,p.localize)(9,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(a).toString()),(0,b.toFileOperationResult)(a),n)},a=>d.VSBuffer.concat(a))}readFileBuffered(o,i,e,n=Object.create(null)){const s=(0,d.newWriteableBufferStream)();return(0,v.readFileIntoStream)(o,i,s,a=>a,Object.assign(Object.assign({},n),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new b.FileOperationError((0,p.localize)(10,null,this.resourceForError(i),(0,b.ensureFileSystemProviderError)(a).toString()),(0,b.toFileOperationResult)(a),n)}),e),s}readFileUnbuffered(o,i,e){const n=(0,E.newWriteableStream)(s=>d.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(i);e&&typeof e.position=="number"&&(s=s.slice(e.position)),e&&typeof e.length=="number"&&(s=s.slice(0,e.length)),this.validateReadFileLimits(i,s.byteLength,e),n.end(d.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async validateReadFile(o,i){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new b.FileOperationError((0,p.localize)(11,null,this.resourceForError(o)),0,i);if(i&&typeof i.etag=="string"&&i.etag!==b.ETAG_DISABLED&&i.etag===e.etag)throw new b.FileOperationError((0,p.localize)(12,null),2,i);return this.validateReadFileLimits(o,e.size,i),e}validateReadFileLimits(o,i,e){if(e==null?void 0:e.limits){let n;if(typeof e.limits.memory=="number"&&i>e.limits.memory&&(n=9),typeof e.limits.size=="number"&&i>e.limits.size&&(n=7),typeof n=="number")throw new b.FileOperationError((0,p.localize)(13,null,this.resourceForError(o)),n)}}async canMove(o,i,e){return this.doCanMoveCopy(o,i,"move",e)}async canCopy(o,i,e){return this.doCanMoveCopy(o,i,"copy",e)}async doCanMoveCopy(o,i,e,n){if(o.toString()!==i.toString())try{const s=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(s,o,a,i,e,n)}catch(s){return s}return!0}async move(o,i,e){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,s,i,"move",!!e),r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,a==="move"?2:3,r)),r}async copy(o,i,e){const n=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),a=await this.doMoveCopy(n,o,s,i,"copy",!!e),r=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,a==="copy"?3:2,r)),r}async doMoveCopy(o,i,e,n,s,a){if(i.toString()===n.toString())return s;const{exists:r,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(o,i,e,n,s,a);if(r&&!g&&a&&await this.del(n,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(n)),s==="copy"){if(o===e&&(0,b.hasFileFolderCopyCapability)(o))await o.copy(i,n,{overwrite:a});else{const k=await this.resolve(i);k.isDirectory?await this.doCopyFolder(o,k,e,n):await this.doCopyFile(o,i,e,n)}return s}else return o===e?(await o.rename(i,n,{overwrite:a}),s):(await this.doMoveCopy(o,i,e,n,"copy",a),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(o,i,e,n){if((0,b.hasOpenReadWriteCloseCapability)(o)&&(0,b.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,i,e,n);if((0,b.hasOpenReadWriteCloseCapability)(o)&&(0,b.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,i,e,n);if((0,b.hasReadWriteCapability)(o)&&(0,b.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,i,e,n);if((0,b.hasReadWriteCapability)(o)&&(0,b.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,i,e,n)}async doCopyFolder(o,i,e,n){await e.mkdir(n),Array.isArray(i.children)&&await y.Promises.settled(i.children.map(async s=>{const a=this.getExtUri(e).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),e,a):this.doCopyFile(o,s.resource,e,a)}))}async doValidateMoveCopy(o,i,e,n,s,a){let r=!1;if(o===e){const{providerExtUri:k,isPathCaseSensitive:z}=this.getExtUri(o);if(z||(r=k.isEqual(i,n)),r&&s==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(i),this.resourceForError(n)));if(!r&&k.isEqualOrParent(n,i))throw new Error((0,p.localize)(15,null,this.resourceForError(i),this.resourceForError(n)))}const g=await this.exists(n);if(g&&!r){if(!a)throw new b.FileOperationError((0,p.localize)(16,null,this.resourceForError(i),this.resourceForError(n)),4);if(o===e){const{providerExtUri:k}=this.getExtUri(o);if(k.isEqualOrParent(i,n))throw new Error((0,p.localize)(17,null,this.resourceForError(i),this.resourceForError(n)))}}return{exists:g,isSameResourceWithDifferentPathCase:r}}getExtUri(o){const i=this.isPathCaseSensitive(o);return{providerExtUri:i?R.extUri:R.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(i,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(o,0,e)),e}async mkdirp(o,i){const e=[],{providerExtUri:n}=this.getExtUri(o);for(;!n.isEqual(i,n.dirname(i));)try{if(((await o.stat(i)).type&b.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(i)));break}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileNotFound)throw s;e.push(n.basename(i)),i=n.dirname(i)}for(let s=e.length-1;s>=0;s--){i=n.joinPath(i,e[s]);try{await o.mkdir(i)}catch(a){if((0,b.toFileSystemProviderErrorCode)(a)!==b.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,i){try{await this.doValidateDelete(o,i)}catch(e){return e}return!0}async doValidateDelete(o,i){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!(i==null?void 0:i.useTrash)&&!(e.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(o)));const s=await this.exists(o);if(!s)throw new b.FileOperationError((0,p.localize)(20,null,this.resourceForError(o)),1);if(!!!(i==null?void 0:i.recursive)&&s){const r=await this.resolve(o);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(o)))}return e}async del(o,i){const e=await this.doValidateDelete(o,i),n=!!(i==null?void 0:i.useTrash),s=!!(i==null?void 0:i.recursive);await e.delete(o,{recursive:s,useTrash:n}),this._onDidRunOperation.fire(new b.FileOperationEvent(o,1))}watch(o,i={recursive:!1,excludes:[]}){let e=!1,n=()=>{e=!0};return this.doWatch(o,i).then(s=>{e?(0,L.dispose)(s):n=()=>(0,L.dispose)(s)},s=>this.logService.error(s)),(0,L.toDisposable)(()=>n())}async doWatch(o,i){const e=await this.withProvider(o),n=this.toWatchKey(e,o,i),s=this.activeWatchers.get(n)||{count:0,disposable:e.watch(o,i)};return this.activeWatchers.has(n)||this.activeWatchers.set(n,s),s.count+=1,(0,L.toDisposable)(()=>{s.count--,s.count===0&&((0,L.dispose)(s.disposable),this.activeWatchers.delete(n))})}toWatchKey(o,i,e){const{providerExtUri:n}=this.getExtUri(o);return[n.getComparisonKey(i),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(o=>(0,L.dispose)(o.disposable)),this.activeWatchers.clear()}async doWriteBuffered(o,i,e,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(async()=>{var s;const a=await o.open(i,{create:!0,unlock:(s=e==null?void 0:e.unlock)!==null&&s!==void 0?s:!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(o,a,n):await this.doWriteReadableBufferedQueued(o,a,n)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await o.close(a)}})}async doWriteStreamBufferedQueued(o,i,e){let n=0,s;if((0,E.isReadableBufferedStream)(e)){if(e.buffer.length>0){const a=d.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,i,a,a.byteLength,n,0),n+=a.byteLength}if(e.ended)return;s=e.stream}else s=e;return new Promise(async(a,r)=>{(0,E.listenStream)(s,{onData:async g=>{s.pause();try{await this.doWriteBuffer(o,i,g,g.byteLength,n,0)}catch(k){return r(k)}n+=g.byteLength,setTimeout(()=>s.resume())},onError:g=>r(g),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(o,i,e){let n=0,s;for(;(s=e.read())!==null;)await this.doWriteBuffer(o,i,s,s.byteLength,n,0),n+=s.byteLength}async doWriteBuffer(o,i,e,n,s,a){let r=0;for(;r<n;)r+=await o.write(i,s+r,e.buffer,a+r,n-r)}async doWriteUnbuffered(o,i,e,n){return this.writeQueue.queueFor(i,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,i,e,n))}async doWriteUnbufferedQueued(o,i,e,n){var s;let a;n instanceof d.VSBuffer?a=n:(0,E.isReadableStream)(n)?a=await(0,d.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?a=await(0,d.bufferedStreamToBuffer)(n):a=(0,d.readableToBuffer)(n),await o.writeFile(i,a.buffer,{create:!0,overwrite:!0,unlock:(s=e==null?void 0:e.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,i,e,n))}async doPipeBufferedQueued(o,i,e,n){let s,a;try{s=await o.open(i,{create:!1}),a=await e.open(n,{create:!0,unlock:!1});const r=d.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,k=0,z=0;do z=await o.read(s,g,r.buffer,k,r.byteLength-k),await this.doWriteBuffer(e,a,r,z,g,k),g+=z,k+=z,k===r.byteLength&&(k=0);while(z>0)}catch(r){throw(0,b.ensureFileSystemProviderError)(r)}finally{await y.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof a=="number"?e.close(a):Promise.resolve()])}}async doPipeUnbuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,i,e,n))}async doPipeUnbufferedQueued(o,i,e,n){return e.writeFile(n,await o.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,i,e,n){return this.writeQueue.queueFor(n,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,i,e,n))}async doPipeUnbufferedToBufferedQueued(o,i,e,n){const s=await e.open(n,{create:!0,unlock:!1});try{const a=await o.readFile(i);await this.doWriteBuffer(e,s,d.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,b.ensureFileSystemProviderError)(a)}finally{await e.close(s)}}async doPipeBufferedToUnbuffered(o,i,e,n){const s=await(0,d.streamToBuffer)(this.readFileBuffered(o,i,u.CancellationToken.None));await this.doWriteUnbuffered(e,n,void 0,s)}throwIfFileSystemIsReadonly(o,i){if(o.capabilities&2048)throw new b.FileOperationError((0,p.localize)(22,null,this.resourceForError(i)),6);return o}resourceForError(o){return o.scheme===w.Schemas.file?o.fsPath:o.toString(!0)}};I=ce([ue(0,O.ILogService)],I),t.FileService=I}),define(Q[102],Z([0,1,15,63,2,19,11,17,13,3,18,33,4,12,81,50,89,91,88,95,32,49,23,16]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u,w,v,m,I,D,o,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class s extends L.Disposable{constructor(r,g){var k;super();this.logService=r,this.options=g,this.BUFFER_SIZE=((k=this.options)===null||k===void 0?void 0:k.bufferSize)||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,R.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:g,symbolicLink:k}=await h.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(g,k),ctime:g.birthtime.getTime(),mtime:g.mtime.getTime(),size:g.size}}catch(g){throw this.toFileSystemProviderError(g)}}async readdir(r){try{const g=await(0,h.readdir)(this.toFilePath(r),{withFileTypes:!0}),k=[];return await Promise.all(g.map(async z=>{try{let N;z.isSymbolicLink()?N=(await this.stat((0,O.joinPath)(r,z.name))).type:N=this.toType(z),k.push([z.name,N])}catch(N){this.logService.trace(N)}})),k}catch(g){throw this.toFileSystemProviderError(g)}}toType(r,g){let k;return(g==null?void 0:g.dangling)?k=b.FileType.Unknown:r.isFile()?k=b.FileType.File:r.isDirectory()?k=b.FileType.Directory:k=b.FileType.Unknown,g&&(k|=b.FileType.SymbolicLink),k}async readFile(r){try{const g=this.toFilePath(r);return await p.promises.readFile(g)}catch(g){throw this.toFileSystemProviderError(g)}}readFileStream(r,g,k){const z=(0,o.newWriteableStream)(N=>n.VSBuffer.concat(N.map(F=>n.VSBuffer.wrap(F))).buffer);return(0,i.readFileIntoStream)(this,r,z,N=>N.buffer,Object.assign(Object.assign({},g),{bufferSize:this.BUFFER_SIZE}),k),z}async writeFile(r,g,k){let z;try{const N=this.toFilePath(r);if(!k.create||!k.overwrite){if(await(0,h.exists)(N)){if(!k.overwrite)throw(0,b.createFileSystemProviderError)((0,u.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!k.create)throw(0,b.createFileSystemProviderError)((0,u.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}z=await this.open(r,{create:!0,unlock:k.unlock}),await this.write(z,0,g,0,g.byteLength)}catch(N){throw await this.toFileSystemProviderWriteError(r,N)}finally{typeof z=="number"&&await this.close(z)}}async open(r,g){try{const k=this.toFilePath(r);if((0,b.isFileOpenForWriteOptions)(g)&&g.unlock)try{const{stat:F}=await h.SymlinkSupport.stat(k);F.mode&128||await p.promises.chmod(k,F.mode|128)}catch(F){this.logService.trace(F)}let z;if((0,b.isFileOpenForWriteOptions)(g)){if(R.isWindows)try{await p.promises.truncate(k,0),z="r+"}catch(F){F.code!=="ENOENT"&&this.logService.trace(F)}z||(z="w")}else z="r";const N=await(0,C.promisify)(p.open)(k,z);return this.mapHandleToPos.set(N,0),(0,b.isFileOpenForWriteOptions)(g)&&this.writeHandles.set(N,r),N}catch(k){throw(0,b.isFileOpenForWriteOptions)(g)?await this.toFileSystemProviderWriteError(r,k):this.toFileSystemProviderError(k)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await(0,C.promisify)(p.fdatasync)(r)}catch(g){this.canFlush=!1,this.logService.error(g)}return await(0,C.promisify)(p.close)(r)}catch(g){throw this.toFileSystemProviderError(g)}}async read(r,g,k,z,N){const F=this.normalizePos(r,g);let j=null;try{const $=await(0,C.promisify)(p.read)(r,k,z,N,F);return typeof $=="number"?j=$:j=$.bytesRead,j}catch($){throw this.toFileSystemProviderError($)}finally{this.updatePos(r,F,j)}}normalizePos(r,g){return g===this.mapHandleToPos.get(r)?null:g}updatePos(r,g,k){const z=this.mapHandleToPos.get(r);typeof z=="number"&&(typeof g=="number"||(typeof k=="number"?this.mapHandleToPos.set(r,z+k):this.mapHandleToPos.delete(r)))}async write(r,g,k,z,N){return(0,E.retry)(()=>this.doWrite(r,g,k,z,N),100,3)}async doWrite(r,g,k,z,N){const F=this.normalizePos(r,g);let j=null;try{const $=await(0,C.promisify)(p.write)(r,k,z,N,F);return typeof $=="number"?j=$:j=$.bytesWritten,j}catch($){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),$)}finally{this.updatePos(r,F,j)}}async mkdir(r){try{await p.promises.mkdir(this.toFilePath(r))}catch(g){throw this.toFileSystemProviderError(g)}}async delete(r,g){try{const k=this.toFilePath(r);await this.doDelete(k,g)}catch(k){throw this.toFileSystemProviderError(k)}}async doDelete(r,g){g.recursive?await(0,h.rimraf)(r,h.RimRafMode.MOVE):await p.promises.unlink(r)}async rename(r,g,k){const z=this.toFilePath(r),N=this.toFilePath(g);if(z!==N)try{await this.validateTargetDeleted(r,g,"move",k.overwrite),await(0,h.move)(z,N)}catch(F){throw(F.code==="EINVAL"||F.code==="EBUSY"||F.code==="ENAMETOOLONG")&&(F=new Error((0,u.localize)(2,null,(0,f.basename)(z),(0,f.basename)((0,f.dirname)(N)),F.toString()))),this.toFileSystemProviderError(F)}}async copy(r,g,k){const z=this.toFilePath(r),N=this.toFilePath(g);if(z!==N)try{await this.validateTargetDeleted(r,g,"copy",k.overwrite),await(0,h.copy)(z,N,{preserveSymlinks:!0})}catch(F){throw(F.code==="EINVAL"||F.code==="EBUSY"||F.code==="ENAMETOOLONG")&&(F=new Error((0,u.localize)(3,null,(0,f.basename)(z),(0,f.basename)((0,f.dirname)(N)),F.toString()))),this.toFileSystemProviderError(F)}}async validateTargetDeleted(r,g,k,z){const N=this.toFilePath(r),F=this.toFilePath(g);let j=!1;if(!!(this.capabilities&1024)||(j=(0,d.isEqual)(N,F,!0)),j&&k==="copy")throw(0,b.createFileSystemProviderError)((0,u.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!j&&await(0,h.exists)(F)){if(!z)throw(0,b.createFileSystemProviderError)((0,u.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(g,{recursive:!0,useTrash:!1})}}watch(r,g){return g.recursive?this.watchRecursive(r,g.excludes):this.watchNonRecursive(r)}watchRecursive(r,g){const k={path:this.toFilePath(r),excludes:g},z=(0,e.insert)(this.recursiveFoldersToWatch,k);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{z(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var r,g,k;if(this.recursiveWatcher instanceof I.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let z,N;((g=(r=this.options)===null||r===void 0?void 0:r.watcher)===null||g===void 0?void 0:g.usePolling)?(z=v.FileWatcher,N=(k=this.options)===null||k===void 0?void 0:k.watcher):this.recursiveFoldersToWatch.length===1?R.isWindows?z=m.FileWatcher:z=v.FileWatcher:z=I.FileWatcher,this.recursiveWatcher=new z(this.recursiveFoldersToWatch,F=>this._onDidChangeFile.fire((0,w.toFileChanges)(F)),F=>{F.type==="error"&&this._onDidWatchErrorOccur.fire(F.message),this.logService[F.type](F.message)},this.logService.getLevel()===y.LogLevel.Trace,N),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)}))}}watchNonRecursive(r){const g=new D.FileWatcher(this.toFilePath(r),z=>this._onDidChangeFile.fire((0,w.toFileChanges)(z)),z=>{z.type==="error"&&this._onDidWatchErrorOccur.fire(z.message),this.logService[z.type](z.message)},this.logService.getLevel()===y.LogLevel.Trace),k=this.logService.onDidChangeLogLevel(()=>{g.setVerboseLogging(this.logService.getLevel()===y.LogLevel.Trace)});return(0,L.combinedDisposable)(g,k)}toFilePath(r){return(0,f.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof b.FileSystemProviderError)return r;let g;switch(r.code){case"ENOENT":g=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":g=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":g=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":g=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":g=b.FileSystemProviderErrorCode.NoPermissions;break;default:g=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(r,g)}async toFileSystemProviderWriteError(r,g){let k=this.toFileSystemProviderError(g);if(r&&k.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:z}=await h.SymlinkSupport.stat(this.toFilePath(r));z.mode&128||(k=(0,b.createFileSystemProviderError)(g,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(z){this.logService.trace(z)}return k}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=s}),define(Q[103],Z([0,1,13,15,128,24,2,22,4,25,12,38,23,11,10,3]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let v=class extends T.Disposable{constructor(D,o,i){super();this.extensionManagementService=D,this.logService=i,this._onDidLanguagesChange=this._register(new y.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new m(o,i)),this._register(D.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(D.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(D=>{const o=["en",...Object.keys(D)];return(0,E.distinct)(o)})}onDidInstallExtension(D){D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",D.identifier.id),this.update().then(o=>{o&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(D){this.cache.getLanguagePacks().then(o=>{Object.keys(o).some(i=>o[i]&&o[i].extensions.some(e=>(0,f.areSameExtensions)(e.extensionIdentifier,D)))&&(this.logService.debug("Removing language packs from the extension",D.id),this.update().then(i=>{i&&this._onDidLanguagesChange.fire()}))})}async update(){const[D,o]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),i=await this.cache.update(o);return!(0,E.equals)(Object.keys(D),Object.keys(i))}};v=ce([ue(0,b.IExtensionManagementService),ue(1,R.INativeEnvironmentService),ue(2,O.ILogService)],v),t.LocalizationsService=v;let m=class extends T.Disposable{constructor(D,o){super();this.logService=o,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(D.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new h.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(D){return this.withLanguagePacks(o=>{Object.keys(o).forEach(i=>delete o[i]),this.createLanguagePacksFromExtensions(o,...D)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(D,...o){for(const i of o)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(D,i);Object.keys(D).forEach(i=>this.updateHash(D[i]))}createLanguagePacksFromExtension(D,o){const i=o.identifier,e=o.manifest.contributes&&o.manifest.contributes.localizations?o.manifest.contributes.localizations:[];for(const n of e)if(o.location.scheme===u.Schemas.file&&(0,d.isValidLocalization)(n)){let s=D[n.languageId];s||(s={hash:"",extensions:[],translations:{}},D[n.languageId]=s);let a=s.extensions.filter(r=>(0,f.areSameExtensions)(r.extensionIdentifier,i))[0];a?a.version=o.manifest.version:s.extensions.push({extensionIdentifier:i,version:o.manifest.version});for(const r of n.translations)s.translations[r.id]=(0,w.join)(o.location.fsPath,r.path)}}updateHash(D){if(D){const o=(0,L.createHash)("md5");for(const i of D.extensions)o.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);D.hash=o.digest("hex")}}withLanguagePacks(D=()=>null){return this.languagePacksFileLimiter.queue(()=>{let o=null;return C.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch(e){return{}}}).then(i=>(o=D(i),i)).then(i=>{for(const n of Object.keys(i))i[n]||delete i[n];this.languagePacks=i,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,p.writeFile)(this.languagePacksFilePath,e)}).then(()=>o,i=>this.logService.error(i))})}};m=ce([ue(0,R.INativeEnvironmentService),ue(1,O.ILogService)],m)}),define(Q[104],Z([0,1,12,19]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function L(h,f,O,d){try{const E=await new Promise((y,u)=>{q(["spdlog"],y,u)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(h,f,O,d)}catch(E){console.error(E)}return null}function b(h,f,O,d){return q.__$__nodeRequire("spdlog").createRotatingLogger(h,f,O,d)}t.createRotatingLogger=b;function T(h,f,O){switch(f){case p.LogLevel.Trace:h.trace(O);break;case p.LogLevel.Debug:h.debug(O);break;case p.LogLevel.Info:h.info(O);break;case p.LogLevel.Warning:h.warn(O);break;case p.LogLevel.Error:h.error(O);break;case p.LogLevel.Critical:h.critical(O);break;default:throw new Error("Invalid log level")}}class R extends p.AbstractMessageLogger{constructor(f,O,d,E){super();this.name=f,this.filepath=O,this.rotating=d,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const f=this.rotating?6:1,O=30/f*C.ByteSize.MB;return L(this.name,this.filepath,O,f).then(d=>{if(d){this._logger=d,this._logger.setLevel(this.getLevel());for(const{level:E,message:y}of this.buffer)T(this._logger,E,y);this.buffer=[]}})}log(f,O){this._logger?T(this._logger,f,O):this.getLevel()<=f&&this.buffer.push({level:f,message:O})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=R}),define(Q[40],Z([0,1,7]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,p.createDecorator)("productService")}),define(Q[26],Z([0,1,8,55]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class L{constructor(){this.data=new Map}add(T,R){C.ok(p.isString(T)),C.ok(p.isObject(R)),C.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new L}),define(Q[105],Z([0,1,26,11]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class b{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,f){this.schemasById[L(h)]=f,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new b;p.Registry.add(t.Extensions.JSONContribution,T)}),define(Q[29],Z([0,1,72,11,26,8,105]),function(q,t,p,C,L,b,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=L.Registry.as(T.Extensions.JSONContribution);class f{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,I=!0){this.registerConfigurations([m],I)}registerConfigurations(m,I=!0){const D=[];m.forEach(o=>{D.push(...this.validateAndRegisterProperties(o,I)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterConfigurations(m){const I=[],D=o=>{if(o.properties)for(const i in o.properties)I.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,o.properties[i]);o.allOf&&o.allOf.forEach(i=>D(i))};for(const o of m){D(o);const i=this.configurationContributors.indexOf(o);i!==-1&&this.configurationContributors.splice(i,1)}h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(m){const I=[],D=[];for(const o of m)for(const i in o)if(I.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]=Object.assign(Object.assign({},this.defaultValues[i]||{}),o[i]);const e={type:"object",default:this.defaultValues[i],description:p.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};D.push(d(i)),this.configurationProperties[i]=e,this.defaultLanguageConfigurationOverridesNode.properties[i]=e}else{this.defaultValues[i]=o[i];const e=this.configurationProperties[i];e&&(this.updatePropertyDefaultValue(i,e),this.updateSchema(i,e))}this.registerOverrideIdentifiers(D),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(m){const I=[];for(const D of m)for(const o in D)if(I.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const i=this.configurationProperties[o];i&&(this.updatePropertyDefaultValue(o,i),this.updateSchema(o,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const I of m)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,I=!0,D=3){D=b.isUndefinedOrNull(m.scope)?D:m.scope;let o=[],i=m.properties;if(i)for(let n in i){if(I&&u(n)){delete i[n];continue}const s=i[n];if(this.updatePropertyDefaultValue(n,s),t.OVERRIDE_PROPERTY_PATTERN.test(n)?s.scope=void 0:s.scope=b.isUndefinedOrNull(s.scope)?D:s.scope,i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),o.push(n)}let e=m.allOf;if(e)for(let n of e)o.push(...this.validateAndRegisterProperties(n,I,D));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const I=D=>{let o=D.properties;if(o)for(const e in o)this.updateSchema(e,o[e]);let i=D.allOf;i&&i.forEach(I)};I(m)}updateSchema(m,I){switch(t.allSettings.properties[m]=I,I.scope){case 1:t.applicationSettings.properties[m]=I;break;case 2:t.machineSettings.properties[m]=I;break;case 6:t.machineOverridableSettings.properties[m]=I;break;case 3:t.windowSettings.properties[m]=I;break;case 4:t.resourceSettings.properties[m]=I;break;case 5:t.resourceSettings.properties[m]=I,this.resourceLanguageSettingsSchema.properties[m]=I;break}}removeFromSchema(m,I){switch(delete t.allSettings.properties[m],I.scope){case 1:delete t.applicationSettings.properties[m];break;case 2:delete t.machineSettings.properties[m];break;case 6:delete t.machineOverridableSettings.properties[m];break;case 3:delete t.windowSettings.properties[m];break;case 4:case 5:delete t.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const I=`[${m}]`,D={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,D),t.allSettings.properties[I]=D,t.applicationSettings.properties[I]=D,t.machineSettings.properties[I]=D,t.machineOverridableSettings.properties[I]=D,t.windowSettings.properties[I]=D,t.resourceSettings.properties[I]=D}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,I){let D=this.defaultValues[m];b.isUndefined(D)&&(D=I.default),b.isUndefined(D)&&(D=E(I.type)),I.default=D}}const O="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(O);function d(v){return v.substring(1,v.length-1)}t.overrideIdentifierFromKey=d;function E(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=E;const y=new f;L.Registry.add(t.Extensions.Configuration,y);function u(v){return v.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(v)?p.localize(5,null,v):y.getConfigurationProperties()[v]!==void 0?p.localize(6,null,v):null:p.localize(4,null)}t.validateProperty=u;function w(){const v=[],m=y.getConfigurationProperties();for(const I of Object.keys(m))v.push([I,m[I].scope]);return v.push(["launch",4]),v.push(["task",4]),v}t.getScopes=w}),define(Q[27],Z([0,1,21,8,9,26,7,29]),function(q,t,p,C,L,b,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function h(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof L.URI)}t.isConfigurationOverrides=h;var f;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(f=t.ConfigurationTarget||(t.ConfigurationTarget={}));function O(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=O;function d(n,s){const a=s?n?s.keys.filter(j=>n.keys.indexOf(j)===-1):[...s.keys]:[],r=n?s?n.keys.filter(j=>s.keys.indexOf(j)===-1):[...n.keys]:[],g=[];if(s&&n){for(const j of n.keys)if(s.keys.indexOf(j)!==-1){const $=m(n.contents,j),X=m(s.contents,j);p.equals($,X)||g.push(j)}}const k=[],z=j=>{const $={};for(const X of j)for(const ne of X.identifiers)$[i(ne)]=X;return $},N=s?z(s.overrides):{},F=n?z(n.overrides):{};if(Object.keys(N).length)for(const j of a){const $=N[j];$&&k.push([(0,R.overrideIdentifierFromKey)(j),$.keys])}if(Object.keys(F).length)for(const j of r){const $=F[j];$&&k.push([(0,R.overrideIdentifierFromKey)(j),$.keys])}if(Object.keys(N).length&&Object.keys(F).length)for(const j of g){const $=F[j],X=N[j];if($&&X){const ne=d({contents:$.contents,keys:$.keys,overrides:[]},{contents:X.contents,keys:X.keys,overrides:[]});k.push([(0,R.overrideIdentifierFromKey)(j),[...ne.added,...ne.removed,...ne.updated]])}}return{added:a,removed:r,updated:g,overrides:k}}t.compare=d;function E(n,s){const a=[];for(const r of Object.keys(n))if(R.OVERRIDE_PROPERTY_PATTERN.test(r)){const g={};for(const k in n[r])g[k]=n[r][k];a.push({identifiers:[(0,R.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(g),contents:y(g,s)})}return a}t.toOverrides=E;function y(n,s){const a=Object.create(null);for(let r in n)u(a,r,n[r],s);return a}t.toValuesTree=y;function u(n,s,a,r){const g=s.split("."),k=g.pop();let z=n;for(let N=0;N<g.length;N++){let F=g[N],j=z[F];switch(typeof j){case"undefined":j=z[F]=Object.create(null);break;case"object":break;default:r(`Ignoring ${s} as ${g.slice(0,N+1).join(".")} is ${JSON.stringify(j)}`);return}z=j}if(typeof z=="object"&&z!==null)try{z[k]=a}catch(N){r(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(z)}`)}else r(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(z)}`)}t.addToValueTree=u;function w(n,s){const a=s.split(".");v(n,a)}t.removeFromValueTree=w;function v(n,s){const a=s.shift();if(s.length===0){delete n[a];return}if(Object.keys(n).indexOf(a)!==-1){const r=n[a];typeof r=="object"&&!Array.isArray(r)&&(v(r,s),Object.keys(r).length===0&&delete n[a])}}function m(n,s,a){function r(z,N){let F=z;for(const j of N){if(typeof F!="object"||F===null)return;F=F[j]}return F}const g=s.split("."),k=r(n,g);return typeof k=="undefined"?a:k}t.getConfigurationValue=m;function I(n,s,a){Object.keys(s).forEach(r=>{r!=="__proto__"&&(r in n?C.isObject(n[r])&&C.isObject(s[r])?I(n[r],s[r],a):a&&(n[r]=s[r]):n[r]=s[r])})}t.merge=I;function D(){const n=b.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}t.getConfigurationKeys=D;function o(){const n=Object.create(null),s=b.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let a in s){let r=s[a].default;u(n,a,r,g=>console.error(`Conflict in default settings: ${g}`))}return n}t.getDefaultValues=o;function i(n){return`[${n}]`}t.keyFromOverrideIdentifier=i;function e(n,s,a){const r=n.inspect(s),g=n.inspect(a);return typeof r.userValue!="undefined"||typeof r.workspaceValue!="undefined"||typeof r.workspaceFolderValue!="undefined"?r.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:r.defaultValue}t.getMigratedSettingValue=e}),define(Q[106],Z([0,1,57,43,23,8,21,9,29,27,26,2,11]),function(q,t,p,C,L,b,T,R,h,f,O,d,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class y{constructor(e={},n=[],s=[]){this._contents=e,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,f.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const s=this.getContentsForOverrideIdentifer(n);return s?e?(0,f.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.keys;return[]}override(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(n)])){let r=this.contents[a],g=n[a];g&&(typeof r=="object"&&typeof g=="object"?(r=T.deepClone(r),this.mergeContents(r,g)):r=g),s[a]=r}return new y(s,this.keys,this.overrides)}merge(...e){const n=T.deepClone(this.contents),s=T.deepClone(this.overrides),a=[...this.keys];for(const r of e){this.mergeContents(n,r.contents);for(const g of r.overrides){const[k]=s.filter(z=>L.equals(z.identifiers,g.identifiers));k?this.mergeContents(k.contents,g.contents):s.push(T.deepClone(g))}for(const g of r.keys)a.indexOf(g)===-1&&a.push(g)}return new y(n,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(e,n){for(const s of Object.keys(n)){if(s in e&&b.isObject(e[s])&&b.isObject(n[s])){this.mergeContents(e[s],n[s]);continue}e[s]=T.deepClone(n[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const n of this.overrides)if(n.identifiers.indexOf(e)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,f.addToValueTree)(this.contents,e,n,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,f.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let s=0;s<n;s++)e.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=y;class u extends y{constructor(){const e=(0,f.getDefaultValues)(),n=(0,f.getConfigurationKeys)(),s=[];for(const a of Object.keys(e))h.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[(0,h.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(e[a]),contents:(0,f.toValuesTree)(e[a],r=>console.error(`Conflict in default settings file: ${r}`))});super(e,n,s)}}t.DefaultConfigurationModel=u;class w{constructor(e,n){this._name=e,this._scopes=n,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get errors(){return this._parseErrors}parseContent(e){if(!b.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n)}}parseRaw(e){this._raw=e;const n=this.doParseRaw(e);this._configurationModel=new y(n.contents,n.keys,n.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let n={},s=null,a=[],r=[],g=[];function k(N){Array.isArray(a)?a.push(N):s&&(a[s]=N)}let z={onObjectBegin:()=>{let N={};k(N),r.push(a),a=N,s=null},onObjectProperty:N=>{s=N},onObjectEnd:()=>{a=r.pop()},onArrayBegin:()=>{let N=[];k(N),r.push(a),a=N,s=null},onArrayEnd:()=>{a=r.pop()},onLiteralValue:k,onError:(N,F,j)=>{g.push({error:N,offset:F,length:j})}};if(e)try{p.visit(e,z),n=a[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e){if(this._scopes){const r=O.Registry.as(h.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,r,!0,this._scopes)}const n=(0,f.toValuesTree)(e,r=>console.error(`Conflict in settings file ${this._name}: ${r}`)),s=Object.keys(e),a=(0,f.toOverrides)(e,r=>console.error(`Conflict in settings file ${this._name}: ${r}`));return{contents:n,keys:s,overrides:a}}filterByScope(e,n,s,a){const r={};for(let g in e)if(h.OVERRIDE_PROPERTY_PATTERN.test(g)&&s)r[g]=this.filterByScope(e[g],n,!1,a);else{const k=this.getScope(g,n);(k===void 0||a.indexOf(k)!==-1)&&(r[g]=e[g])}return r}getScope(e,n){const s=n[e];return s?typeof s.scope!="undefined"?s.scope:3:void 0}}t.ConfigurationModelParser=w;class v extends d.Disposable{constructor(e,n,s,a){super();this.userSettingsResource=e,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(E.Event.filter(this.fileService.onDidFilesChange,r=>r.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new y}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=v;class m{constructor(e,n,s=new y,a=new y,r=new C.ResourceMap,g=new y,k=new C.ResourceMap,z=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=r,this._memoryConfiguration=g,this._memoryConfigurationByResource=k,this._freeze=z,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(e,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(e)}updateValue(e,n,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new y,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(e):a.setValue(e,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,s){const a=this.getConsolidateConfigurationModel(n,s),r=this.getFolderConfigurationModelForResource(n.resource,s),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,k=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),z=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),F=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),j=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,$=r?n.overrideIdentifier?r.freeze().override(n.overrideIdentifier).getValue(e):r.freeze().getValue(e):void 0,X=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(e):g.getValue(e),ne=a.getValue(e),ee=L.distinct(L.flatten(a.overrides.map(te=>te.identifiers))).filter(te=>a.getOverrideValue(e,te)!==void 0);return{defaultValue:k,userValue:z,userLocalValue:N,userRemoteValue:F,workspaceValue:j,workspaceFolderValue:$,memoryValue:X,value:ne,default:k!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:z!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:j!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:r==null?void 0:r.freeze().getValue(e),override:n.overrideIdentifier?r==null?void 0:r.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:g.getValue(e),override:n.overrideIdentifier?g.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const s=n.filter(a=>h.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const r=(0,h.overrideIdentifierFromKey)(a),g=this._defaultConfiguration.getKeysForOverrideIdentifier(r),k=e.getKeysForOverrideIdentifier(r),z=[...k.filter(N=>g.indexOf(N)===-1),...g.filter(N=>k.indexOf(N)===-1),...g.filter(N=>!T.equals(this._defaultConfiguration.override(r).getValue(N),e.override(r).getValue(N)))];return[r,z]});return this.updateDefaultConfiguration(e),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,f.compare)(this.localUserConfiguration,e),g=[...n,...s,...a];return g.length&&this.updateLocalUserConfiguration(e),{keys:g,overrides:r}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,f.compare)(this.remoteUserConfiguration,e);let g=[...n,...s,...a];return g.length&&this.updateRemoteUserConfiguration(e),{keys:g,overrides:r}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:s,removed:a,overrides:r}=(0,f.compare)(this.workspaceConfiguration,e);let g=[...n,...s,...a];return g.length&&this.updateWorkspaceConfiguration(e),{keys:g,overrides:r}}compareAndUpdateFolderConfiguration(e,n){const s=this.folderConfigurations.get(e),{added:a,updated:r,removed:g,overrides:k}=(0,f.compare)(s,n);let z=[...a,...r,...g];return(z.length||!s)&&this.updateFolderConfiguration(e,n),{keys:z,overrides:k}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:a,removed:r,overrides:g}=(0,f.compare)(n,void 0);return{keys:[...s,...a,...r],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let s=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const a=n.getFolder(e);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const r=this._memoryConfigurationByResource.get(e);r&&(s=s.merge(r))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(e);a?(n=s.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=s}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const s=n.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:s,overrides:a,keys:r}=this._folderConfigurations.get(n);return e.push([n,{contents:s,overrides:a,keys:r}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(a=>n.add(a))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),a=this.parseConfigurationModel(e.workspace),r=e.folders.reduce((g,k)=>(g.set(R.URI.revive(k[0]),this.parseConfigurationModel(k[1])),g),new C.ResourceMap);return new m(n,s,new y,a,r,new y,new C.ResourceMap,!1)}static parseConfigurationModel(e){return new y(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=m;function I(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const e=new Set,n=new Map;for(const a of i)a.keys.forEach(r=>e.add(r)),a.overrides.forEach(([r,g])=>{const k=(0,C.getOrSet)(n,r,new Set);g.forEach(z=>k.add(z))});const s=[];return n.forEach((a,r)=>s.push([r,[...a.values()]])),{keys:[...e.values()],overrides:s}}t.mergeChanges=I;class D{constructor(e,n,s,a){this.change=e,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const r=new Set;e.keys.forEach(k=>r.add(k)),e.overrides.forEach(([,k])=>k.forEach(z=>r.add(z))),this.affectedKeys=[...r.values()];const g=new y;this.affectedKeys.forEach(k=>g.setValue(k,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(e,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!T.equals(a,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let s=(0,f.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(e=e[a],!e)return!1;s=s[a]}return!0}}t.ConfigurationChangeEvent=D;class o extends D{constructor(e,n,s,a){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=s,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=o}),define(Q[107],Z([0,1,26,29,2,27,106,11,4,18]),function(q,t,p,C,L,b,T,R,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class O extends L.Disposable{constructor(E,y){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,f.extUriBiasedIgnorePathCase,y)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new h.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,y){const u=typeof E=="string"?E:void 0,w=(0,b.isConfigurationOverrides)(E)?E:(0,b.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(u,w,void 0)}updateValue(E,y,u,w){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const y=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(u,y,1)}onDidDefaultConfigurationChange(E){const y=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,E);this.trigger(u,y,6)}trigger(E,y,u){const w=new T.ConfigurationChangeEvent(E,{data:y},this.configuration);w.source=u,w.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=O}),define(Q[52],Z([0,1,82,7,29,26,16]),function(q,t,p,C,L,b,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,C.createDecorator)("requestService");function R(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}t.isSuccess=R;function h(d){return d.res.statusCode===204}async function f(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);return h(d)?null:(await(0,T.streamToBuffer)(d.stream)).toString()}t.asText=f;async function O(d){if(!R(d))throw new Error("Server returned "+d.res.statusCode);if(h(d))return null;const y=(await(0,T.streamToBuffer)(d.stream)).toString();try{return JSON.parse(y)}catch(u){throw u.message+=`:
`+y,u}}t.asJson=O,b.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,p.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null)],default:"override",description:(0,p.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(8,null)}}})}),define(Q[108],Z([0,1,109,8]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function L(T){return T.protocol==="http:"?process.env.HTTP_PROXY||process.env.http_proxy||null:T.protocol==="https:"&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}async function b(T,R={}){const h=(0,p.parse)(T),f=R.proxyUrl||L(h);if(!f)return null;const O=(0,p.parse)(f);if(!/^https?:$/.test(O.protocol||""))return null;const d={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,C.isBoolean)(R.strictSSL)?R.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((E,y)=>{q(["http-proxy-agent"],E,y)}))(d):new(await new Promise((E,y)=>{q(["https-proxy-agent"],E,y)}))(d)}t.getProxyAgent=b}),define(Q[110],Z([0,1,31,16]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function L(b,T,R){let h=R&&R.get("storage.serviceMachineId",0)||null;if(h)return h;try{const O=(await T.readFile(b.serviceMachineIdResource)).value.toString();h=(0,p.isUUID)(O)?O:null}catch(f){h=null}if(!h){h=(0,p.generateUuid)();try{await T.writeFile(b.serviceMachineIdResource,C.VSBuffer.fromString(h))}catch(f){}}return R&&R.store("storage.serviceMachineId",h,0,1),h}t.getServiceMachineId=L}),define(Q[111],Z([0,1,7]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,p.createDecorator)("stateService")}),define(Q[112],Z([0,1,3,15,22,13,8,12]),function(q,t,p,C,L,b,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class h{constructor(d,E){this.dbPath=d,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const d=await this.loadAsync();this._database||(this._database=d)}}loadSync(){try{return this.lastFlushedSerializedDatabase=C.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await C.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(d){return d.code!=="ENOENT"&&this.onError(d),{}}}getItem(d,E){const y=this.database[d];return(0,T.isUndefinedOrNull)(y)?E:y}setItem(d,E){if((0,T.isUndefinedOrNull)(E))return this.removeItem(d);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[d]===E||(this.database[d]=E,this.saveSync())}removeItem(d){(0,T.isUndefined)(this.database[d])||(this.database[d]=void 0,this.saveSync())}saveSync(){const d=JSON.stringify(this.database,null,4);if(d!==this.lastFlushedSerializedDatabase)try{(0,b.writeFileSync)(this.dbPath,d),this.lastFlushedSerializedDatabase=d}catch(E){this.onError(E)}}}t.FileStorage=h;let f=class Ve{constructor(d,E){this.fileStorage=new h(p.join(d.userDataPath,Ve.STATE_FILE),y=>E.error(y))}init(){return this.fileStorage.init()}getItem(d,E){return this.fileStorage.getItem(d,E)}setItem(d,E){this.fileStorage.setItem(d,E)}removeItem(d){this.fileStorage.removeItem(d)}};f.STATE_FILE="storage.json",f=ce([ue(0,L.INativeEnvironmentService),ue(1,R.ILogService)],f),t.StateService=f}),define(Q[113],Z([0,1,7,11,2,8,65,4]),function(q,t,p,C,L,b,T,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const h="__$__targetStorageMarker";t.IStorageService=(0,p.createDecorator)("storageService");var f;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(f=t.WillSaveStateReason||(t.WillSaveStateReason={}));var O;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(O=t.StorageScope||(t.StorageScope={}));var d;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(d=t.StorageTarget||(t.StorageTarget={}));class E extends L.Disposable{constructor(v={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,m){m===h?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:m,target:this.getKeyTargets(v)[m]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,m,I){var D;return(D=this.getStorage(m))===null||D===void 0?void 0:D.get(v,I)}getBoolean(v,m,I){var D;return(D=this.getStorage(m))===null||D===void 0?void 0:D.getBoolean(v,I)}getNumber(v,m,I){var D;return(D=this.getStorage(m))===null||D===void 0?void 0:D.getNumber(v,I)}store(v,m,I,D){if((0,b.isUndefinedOrNull)(m)){this.remove(v,I);return}this.withPausedEmitters(()=>{var o;this.updateKeyTarget(v,I,D),(o=this.getStorage(I))===null||o===void 0||o.set(v,m)})}remove(v,m){this.withPausedEmitters(()=>{var I;this.updateKeyTarget(v,m,void 0),(I=this.getStorage(m))===null||I===void 0||I.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,m){const I=[],D=this.getKeyTargets(v);for(const o of Object.keys(D))D[o]===m&&I.push(o);return I}updateKeyTarget(v,m,I){var D,o;const i=this.getKeyTargets(m);typeof I=="number"?i[v]!==I&&(i[v]=I,(D=this.getStorage(m))===null||D===void 0||D.set(h,JSON.stringify(i))):typeof i[v]=="number"&&(delete i[v],(o=this.getStorage(m))===null||o===void 0||o.set(h,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const m=this.get(h,v);if(m)try{return JSON.parse(m)}catch(I){}return Object.create(null)}isNew(v){return this.getBoolean(t.IS_NEW_KEY,v)===!0}async flush(){var v,m,I,D;this._onWillSaveState.fire({reason:f.NONE}),await R.Promises.settled([(m=(v=this.getStorage(0))===null||v===void 0?void 0:v.whenFlushed())!==null&&m!==void 0?m:Promise.resolve(),(D=(I=this.getStorage(1))===null||I===void 0?void 0:I.whenFlushed())!==null&&D!==void 0?D:Promise.resolve()])}async logStorage(){var v,m,I,D,o,i;const e=(m=(v=this.getStorage(0))===null||v===void 0?void 0:v.items)!==null&&m!==void 0?m:new Map,n=(D=(I=this.getStorage(1))===null||I===void 0?void 0:I.items)!==null&&D!==void 0?D:new Map;return u(e,n,(o=this.getLogDetails(0))!==null&&o!==void 0?o:"",(i=this.getLogDetails(1))!==null&&i!==void 0?i:"")}}t.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends E{constructor(){super();this.globalStorage=new T.Storage(new T.InMemoryStorageDatabase),this.workspaceStorage=new T.Storage(new T.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}t.InMemoryStorageService=y;async function u(w,v,m,I){const D=r=>{try{return JSON.parse(r)}catch(g){return r}},o=new Map,i=new Map;w.forEach((r,g)=>{o.set(g,r),i.set(g,D(r))});const e=new Map,n=new Map;v.forEach((r,g)=>{e.set(g,r),n.set(g,D(r))}),console.group(`Storage: Global (path: ${m})`);let s=[];o.forEach((r,g)=>{s.push({key:g,value:r})}),console.table(s),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${I})`);let a=[];e.forEach((r,g)=>{a.push({key:g,value:r})}),console.table(a),console.groupEnd(),console.log(n)}t.logStorage=u}),define(Q[114],Z([0,1,17,36,31,9]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;async function T(h,f,O,d,E,y,u,w,v){const m=Object.create(null);m["common.machineId"]=y,m.sessionID=(0,L.generateUuid)()+Date.now(),m.commitHash=d,m.version=E,m["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,p.PlatformToString)(p.platform),m["common.nodePlatform"]=C.platform,m["common.nodeArch"]=O,m["common.product"]=v||"desktop";const I=R(u||[]);I&&(m["common.msftInternal"]=I);let D=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),p.isLinuxSnap&&(m["common.snap"]="true");try{const i=await h.readFile(b.URI.file(w));m["common.source"]=i.value.toString().slice(0,30)}catch(i){}return m}t.resolveCommonProperties=T;function R(h){const f=C.env.USERDNSDOMAIN;if(!f)return!1;const O=f.toLowerCase();return h.some(d=>O===d)}}),define(Q[41],Z([0,1,7]),function(q,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,p.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[115],Z([0,1,14,24,25,21,41,52,47,22,28,12,19,9,40,113,110,7,18]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u,w,v,m,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var D;(function(l){l[l.None=0]="None",l[l.IncludeVersions=1]="IncludeVersions",l[l.IncludeFiles=2]="IncludeFiles",l[l.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",l[l.IncludeSharedAccounts=8]="IncludeSharedAccounts",l[l.IncludeVersionProperties=16]="IncludeVersionProperties",l[l.ExcludeNonValidated=32]="ExcludeNonValidated",l[l.IncludeInstallationTargets=64]="IncludeInstallationTargets",l[l.IncludeAssetUri=128]="IncludeAssetUri",l[l.IncludeStatistics=256]="IncludeStatistics",l[l.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",l[l.Unpublished=4096]="Unpublished"})(D||(D={}));function o(...l){return String(l.reduce((c,S)=>c|S,0))}var i;(function(l){l[l.Tag=1]="Tag",l[l.ExtensionId=4]="ExtensionId",l[l.Category=5]="Category",l[l.ExtensionName=7]="ExtensionName",l[l.Target=8]="Target",l[l.Featured=9]="Featured",l[l.SearchText=10]="SearchText",l[l.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},n={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:D.None,criteria:[],assetTypes:[]};class r{constructor(c=a){this.state=c}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(c,S=this.state.pageSize){return new r(Object.assign(Object.assign({},this.state),{pageNumber:c,pageSize:S}))}withFilter(c,...S){const P=[...this.state.criteria,...S.length?S.map(A=>({filterType:c,value:A})):[{filterType:c}]];return new r(Object.assign(Object.assign({},this.state),{criteria:P}))}withSortBy(c){return new r(Object.assign(Object.assign({},this.state),{sortBy:c}))}withSortOrder(c){return new r(Object.assign(Object.assign({},this.state),{sortOrder:c}))}withFlags(...c){return new r(Object.assign(Object.assign({},this.state),{flags:c.reduce((S,P)=>S|P,0)}))}withAssetTypes(...c){return new r(Object.assign(Object.assign({},this.state),{assetTypes:c}))}get raw(){const{criteria:c,pageNumber:S,pageSize:P,sortBy:A,sortOrder:M,flags:U,assetTypes:W}=this.state;return{filters:[{criteria:c,pageNumber:S,pageSize:P,sortBy:A,sortOrder:M}],assetTypes:W,flags:U}}get searchText(){const c=this.state.criteria.filter(S=>S.filterType===i.SearchText)[0];return c&&c.value?c.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(c=>String(c.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(l,c){const S=(l||[]).filter(P=>P.statisticName===c)[0];return S?S.value:0}function k(l){const c="Microsoft.VisualStudio.Code.Translation.";return l.files.filter(P=>P.assetType.indexOf(c)===0).reduce((P,A)=>{const M=j(l,A.assetType);return M&&P.push([A.assetType.substring(c.length),M]),P},[])}function z(l){if(l.properties){const c=l.properties.filter(A=>A.key===e.Repository),S=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),P=c.filter(A=>S.test(A.value))[0];return P?{uri:P.value,fallbackUri:P.value}:null}return j(l,e.Repository)}function N(l){return{uri:`${l.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${l.fallbackAssetUri}/${e.VSIX}`}}function F(l){const c=j(l,e.Icon);if(c)return c;const S=C.DefaultIconPath;return{uri:S,fallbackUri:S}}function j(l,c){return l.files.filter(P=>P.assetType===c)[0]?{uri:`${l.assetUri}/${c}`,fallbackUri:`${l.fallbackAssetUri}/${c}`}:null}function $(l,c){const S=l.properties?l.properties.filter(A=>A.key===c):[],P=S.length>0&&S[0].value;return P?P.split(",").map(A=>(0,L.adoptToGalleryExtensionId)(A)):[]}function X(l){const c=l.properties?l.properties.filter(S=>S.key===n.Engine):[];return c.length>0&&c[0].value||""}function ne(l){const c=l.properties?l.properties.filter(P=>P.key===n.LocalizedLanguages):[],S=c.length>0&&c[0].value||"";return S?S.split(","):[]}function ee(l){return l.indexOf("preview")!==-1}function te(l){const c=l.properties?l.properties.find(S=>S.key===n.WebExtension):void 0;return!!c&&c.value==="true"}function ae(l){return l.files.some(c=>c.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,I.joinPath)(y.URI.parse(l.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function _(l,c,S,P,A){const M={manifest:j(c,e.Manifest),readme:j(c,e.Details),changelog:j(c,e.Changelog),license:j(c,e.License),repository:z(c),download:N(c),icon:F(c),coreTranslations:k(c)};return{identifier:{id:(0,L.getGalleryExtensionId)(l.publisher.publisherName,l.extensionName),uuid:l.extensionId},name:l.extensionName,version:c.version,date:c.lastUpdated,displayName:l.displayName,publisherId:l.publisher.publisherId,publisher:l.publisher.publisherName,publisherDisplayName:l.publisher.displayName,description:l.shortDescription||"",installCount:g(l.statistics,"install"),rating:g(l.statistics,"averagerating"),ratingCount:g(l.statistics,"ratingcount"),assetUri:y.URI.parse(c.assetUri),webResource:ae(c),assetTypes:c.files.map(({assetType:U})=>U),assets:M,properties:{dependencies:$(c,n.Dependency),extensionPack:$(c,n.ExtensionPack),engine:X(c),localizedLanguages:ne(c),webExtension:te(c)},telemetryData:{index:(P.pageNumber-1)*P.pageSize+S,searchText:P.searchText,querySource:A},preview:ee(l.flags)}}let G=class{constructor(c,S,P,A,M,U,W){this.requestService=c,this.logService=S,this.environmentService=P,this.telemetryService=A,this.fileService=M,this.productService=U;const x=U.extensionsGallery;this.extensionsGalleryUrl=x&&x.serviceUrl,this.extensionsControlUrl=x&&x.controlUrl,this.commonHeadersPromise=B(U.version,this.environmentService,this.fileService,W)}api(c=""){return`${this.extensionsGalleryUrl}${c}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(c,S){const P=[];let{total:A,firstPage:M,getPage:U}=await this.query({names:c,pageSize:c.length},S);P.push(...M);for(let W=1;P.length<A&&(M=await U(W,S),M.length);W++)P.push(...M);return P}async getCompatibleExtension(c,S){const P=await this.getCompatibleExtensionByEngine(c,S);return(P==null?void 0:P.properties.webExtension)?P.webResource?P:null:P}async getCompatibleExtensionByEngine(c,S){const P=(0,C.isIExtensionIdentifier)(c)?null:c;if(P&&P.properties.engine&&(0,h.isEngineValid)(P.properties.engine,this.productService.version))return P;const{id:A,uuid:M}=P?P.identifier:c;let U=new r().withFlags(D.IncludeAssetUri,D.IncludeStatistics,D.IncludeFiles,D.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");M?U=U.withFilter(i.ExtensionId,M):U=U.withFilter(i.ExtensionName,A);const{galleryExtensions:W}=await this.queryGallery(U,O.CancellationToken.None),[x]=W;if(!x||!x.versions.length)return null;if(S){const Y=x.versions.filter(ie=>ie.version===S)[0];if(Y){const ie=_(x,Y,0,U);if(ie.properties.engine&&(0,h.isEngineValid)(ie.properties.engine,this.productService.version))return ie}return null}const J=await this.getLastValidExtensionVersion(x,x.versions);return J?_(x,J,0,U):null}async query(c,S){const P=O.CancellationToken.isCancellationToken(c)?{}:c,A=O.CancellationToken.isCancellationToken(c)?c:S;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=P.text||"";const U=(0,b.getOrDefault)(P,re=>re.pageSize,50);let W=new r().withFlags(D.IncludeLatestVersionOnly,D.IncludeAssetUri,D.IncludeStatistics,D.IncludeFiles,D.IncludeVersionProperties).withPage(1,U).withFilter(i.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(W=W.withFilter(i.Category,ge||he),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,he,ge)=>(W=W.withFilter(i.Tag,ge||he),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(i.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),W=W.withFilter(i.SearchText,M)),W=W.withSortBy(0)):P.ids?W=W.withFilter(i.ExtensionId,...P.ids):P.names?W=W.withFilter(i.ExtensionName,...P.names):W=W.withSortBy(4),typeof P.sortBy=="number"&&(W=W.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(W=W.withSortOrder(P.sortOrder));const{galleryExtensions:x,total:J}=await this.queryGallery(W,A),Y=x.map((re,he)=>_(re,re.versions[0],he,W,P.source)),ie=async(re,he)=>{if(he.isCancellationRequested)throw(0,p.canceled)();const ge=W.withPage(re+1),{galleryExtensions:Pe}=await this.queryGallery(ge,he);return Pe.map((Le,Te)=>_(Le,Le.versions[0],Te,ge,P.source))};return{firstPage:Y,total:J,pageSize:W.pageSize,getPage:ie}}async queryGallery(c,S){if(!this.isEnabled())throw new Error("No extension gallery service configured.");c=c.withFlags(c.flags,D.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,o(D.Unpublished));const P=await this.commonHeadersPromise,A=JSON.stringify(c.raw),M=Object.assign(Object.assign({},P),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(A.length)}),U=new Date().getTime();let W,x,J=0;try{if(W=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:A,headers:M},S),W.res.statusCode&&W.res.statusCode>=400&&W.res.statusCode<500)return{galleryExtensions:[],total:J};const Y=await(0,R.asJson)(W);if(Y){const ie=Y.results[0],re=ie.extensions,he=ie.resultMetadata&&ie.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return J=he&&he.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:J}}return{galleryExtensions:[],total:J}}catch(Y){throw x=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},c.telemetryData),{requestBodySize:String(A.length),duration:new Date().getTime()-U,success:!!W&&(0,R.isSuccess)(W),responseBodySize:W==null?void 0:W.res.headers["Content-Length"],statusCode:W?String(W.res.statusCode):void 0,errorCode:x?(0,p.isPromiseCanceledError)(x)?"canceled":(0,p.getErrorMessage)(x).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(J)}))}}async reportStatistic(c,S,P,A){if(!!this.isEnabled()){const M=await this.commonHeadersPromise,U=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${c}/extensions/${S}/${P}/stats?statType=${A}`),headers:U},O.CancellationToken.None)}catch(W){}}}async download(c,S,P){this.logService.trace("ExtensionGalleryService#download",c.identifier.id);const A=(0,L.getGalleryExtensionTelemetryData)(c),M=new Date().getTime(),U=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},A),{duration:Y})),W=P===1?"install":P===2?"update":"",x=W?{uri:`${c.assets.download.uri}&${W}=true`,fallbackUri:`${c.assets.download.fallbackUri}?${W}=true`}:c.assets.download,J=await this.getAsset(x);await this.fileService.writeFile(S,J.stream),U(new Date().getTime()-M)}async getReadme(c,S){if(c.assets.readme){const P=await this.getAsset(c.assets.readme,{},S);return await(0,R.asText)(P)||""}return""}async getManifest(c,S){if(c.assets.manifest){const P=await this.getAsset(c.assets.manifest,{},S),A=await(0,R.asText)(P);return A?JSON.parse(A):null}return null}async getCoreTranslation(c,S){const P=c.assets.coreTranslations.filter(A=>A[0]===S.toUpperCase())[0];if(P){const A=await this.getAsset(P[1]),M=await(0,R.asText)(A);return M?JSON.parse(M):null}return null}async getChangelog(c,S){if(c.assets.changelog){const P=await this.getAsset(c.assets.changelog,{},S);return await(0,R.asText)(P)||""}return""}async getAllVersions(c,S){let P=new r().withFlags(D.IncludeVersions,D.IncludeFiles,D.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");c.identifier.uuid?P=P.withFilter(i.ExtensionId,c.identifier.uuid):P=P.withFilter(i.ExtensionName,c.identifier.id);const A=[],{galleryExtensions:M}=await this.queryGallery(P,O.CancellationToken.None);return M.length&&(S?await Promise.all(M[0].versions.map(async U=>{let W;try{W=await this.getEngine(U)}catch(x){}W&&(0,h.isEngineValid)(W,this.productService.version)&&A.push({version:U.version,date:U.lastUpdated})})):A.push(...M[0].versions.map(U=>({version:U.version,date:U.lastUpdated})))),A}async getAsset(c,S={},P=O.CancellationToken.None){const A=await this.commonHeadersPromise,M={type:"GET"},U=Object.assign(Object.assign({},A),S.headers||{});S=Object.assign(Object.assign(Object.assign({},S),M),{headers:U});const W=c.uri,x=c.fallbackUri,J=Object.assign(Object.assign({},S),{url:W});try{const Y=await this.requestService.request(J,P);if(Y.res.statusCode===200)return Y;const ie=await(0,R.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${ie}`)}catch(Y){if((0,p.isPromiseCanceledError)(Y))throw Y;const ie=(0,p.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:W,message:ie});const re=Object.assign(Object.assign({},S),{url:x});return this.requestService.request(re,P)}}async getLastValidExtensionVersion(c,S){const P=this.getLastValidExtensionVersionFromProperties(c,S);return P||this.getLastValidExtensionVersionRecursively(c,S)}getLastValidExtensionVersionFromProperties(c,S){for(const P of S){const A=X(P);if(!A)return null;if((0,h.isEngineValid)(A,this.productService.version))return P}return null}async getEngine(c){const S=X(c);if(S)return S;const P=j(c,e.Manifest);if(!P)throw new Error("Manifest was not found");const A={"Accept-Encoding":"gzip"},M=await this.getAsset(P,{headers:A}),U=await(0,R.asJson)(M);if(U)return U.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(c,S){if(!S.length)return null;const P=S[0],A=await this.getEngine(P);return(0,h.isEngineValid)(A,this.productService.version)?(P.properties=P.properties||[],P.properties.push({key:n.Engine,value:A}),P):this.getLastValidExtensionVersionRecursively(c,S.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const c=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(c.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,R.asJson)(c),P=new Map;if(S)for(const A of S.malicious){const M=P.get(A)||{id:{id:A},malicious:!0,slow:!1};M.malicious=!0,P.set(A,M)}return[...P.values()]}};G=ce([ue(0,R.IRequestService),ue(1,d.ILogService),ue(2,f.IEnvironmentService),ue(3,T.ITelemetryService),ue(4,E.IFileService),ue(5,u.IProductService),ue(6,(0,m.optional)(w.IStorageService))],G),t.ExtensionGalleryService=G;async function B(l,c,S,P){const A={"X-Market-Client-Id":`VSCode ${l}`,"User-Agent":`VSCode ${l}`},M=await(0,v.getServiceMachineId)(c,S,P);return A["X-Market-User-Id"]=M,A}t.resolveMarketplaceHeaders=B}),define(Q[116],Z([0,1,53,83,20,7,27,29,2,21,26]),function(q,t,p,C,L,b,T,R,h,f,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let d=class{constructor(u,w){this._configurationService=w,this._experimentProperties={},this._disposables=new h.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(v),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(v=>{const m=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!m})}))}setExperimentProperty(u,w){this._experimentProperties[u]=w}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const w=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(E);this._userOptIn=w?w.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let w=u.sessionID,v=u["common.instanceId"],m=u["common.machineId"],I=u["common.firstSessionDate"],D=u["common.msftInternal"];return{sessionId:w,instanceId:v,machineId:m,firstSessionDate:I,msftInternal:D}}dispose(){this._disposables.dispose()}publicLog(u,w,v){return this.isOptedIn?this._commonProperties.then(m=>{w=(0,f.mixin)(w,m),w=(0,f.mixin)(w,this._experimentProperties),w=(0,f.cloneAndChange)(w,I=>{if(typeof I=="string")return this._cleanupInfo(I,v)}),this._appender.log(u,w)},m=>{console.error(m)}):Promise.resolve(void 0)}publicLog2(u,w,v){return this.publicLog(u,w,v)}publicLogError(u,w){return this.sendErrorTelemetry?this.publicLog(u,w,!0):Promise.resolve(void 0)}publicLogError2(u,w){return this.publicLogError(u,w)}_cleanupInfo(u,w){let v=u;if(w){const m=[];for(let i of this._cleanupPatterns)for(;;){const e=i.exec(u);if(!e)break;m.push([e.index,i.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(v="";;){const i=D.exec(u);if(!i)break;!I.test(i[0])&&m.every(([e,n])=>i.index<e||i.index>=n)&&(v+=u.substring(o,i.index)+"<REDACTED: user-file-path>",o=D.lastIndex)}o<u.length&&(v+=u.substr(o))}for(let m of this._cleanupPatterns)v=v.replace(m,"");return v}};d.IDLE_START_EVENT_NAME="UserIdleStart",d.IDLE_STOP_EVENT_NAME="UserIdleStop",d=ce([ue(1,(0,b.optional)(T.IConfigurationService))],d),t.TelemetryService=d;const E="telemetry";O.Registry.as(R.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,C.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,C.localize)(2,null,p.default.privacyStatementUrl):(0,C.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(Q[54],Z([0,1,27,21,8,4]),function(q,t,p,C,L,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,w){return Promise.resolve(void 0)}publicLog2(u,w){return this.publicLog(u,w)}publicLogError(u,w){return Promise.resolve(void 0)}publicLogError2(u,w){return this.publicLogError(u,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class T{async publicLog(w,v,m){}async publicLogError(w,v,m){}}t.NullEndpointTelemetryService=T;function R(...u){return{log:(w,v)=>u.forEach(m=>m.log(w,v)),flush:()=>b.Promises.settled(u.map(w=>w.flush()))}}t.combinedAppender=R,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(u,w){return w.onDidChangeConfiguration(v=>{v.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(v.source),configurationKeys:E(v.sourceConfig)})})}t.configurationTelemetry=h;function f(u){const w=Object.create(null),v=Object.create(null),m=Object.create(null);d(u,m);for(let I in m){I=I.length>150?I.substr(I.length-149):I;const D=m[I];typeof D=="number"?v[I]=D:typeof D=="boolean"?v[I]=D?1:0:typeof D=="string"?w[I]=D.substring(0,1023):typeof D!="undefined"&&D!==null&&(w[I]=D)}return{properties:w,measurements:v}}t.validateTelemetryData=f;function O(u){if(!u)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(m=>{u.indexOf(`${m}+`)===0&&(w=m)}),w}t.cleanRemoteAuthority=O;function d(u,w,v=0,m){if(!!u)for(let I of Object.getOwnPropertyNames(u)){const D=u[I],o=m?m+I:I;Array.isArray(D)?w[o]=(0,C.safeStringify)(D):D instanceof Date?w[o]=D.toISOString():(0,L.isObject)(D)?v<2?d(D,w,v+1,o+"."):w[o]=(0,C.safeStringify)(D):w[o]=D}}function E(u){if(!u)return[];const w=[];return y(w,"",u),w}function y(u,w,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(m=>y(u,w?`${w}.${m}`:m,v[m])):u.push(w)}}),define(Q[117],Z([0,1,14,21,54]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function b(R){const h=await new Promise((O,d)=>{q(["applicationinsights"],O,d)});let f;return h.defaultClient?(f=new h.TelemetryClient(R),f.channel.setUseDiskRetryCaching(!0)):(h.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),f=h.defaultClient),R.indexOf("AIF-")===0&&(f.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),f}class T{constructor(h,f,O){this._eventPrefix=h,this._defaultData=f,this._defaultData||(this._defaultData=Object.create(null)),typeof O=="function"?this._aiClient=O():this._aiClient=O,this._asyncAIClient=null}_withAIClient(h){if(!!this._aiClient){if(typeof this._aiClient!="string"){h(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=b(this._aiClient)),this._asyncAIClient.then(f=>{h(f)},f=>{(0,p.onUnexpectedError)(f),console.error(f)})}}log(h,f){!this._aiClient||(f=(0,C.mixin)(f,this._defaultData),f=(0,L.validateTelemetryData)(f),this._withAIClient(O=>O.trackEvent({name:this._eventPrefix+"/"+h,properties:f.properties,measurements:f.measurements})))}flush(){return this._aiClient?new Promise(h=>{this._withAIClient(f=>{f.flush({callback:()=>{this._aiClient=void 0,h(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Q[118],Z([0,1,13,15,3]),function(q,t,p,C,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function b(T,R){const h=Object.create(null),f=(d,E)=>{const y=JSON.parse(d);h[E]=y};if(R){const d=(0,p.readdirSync)(R).filter(y=>{try{return(0,C.statSync)((0,L.join)(R,y)).isDirectory()}catch(u){return!1}}),E=[];d.forEach(y=>{(0,p.readdirSync)((0,L.join)(R,y)).filter(w=>w==="telemetry.json").length===1&&E.push(y)}),E.forEach(y=>{const u=(0,C.readFileSync)((0,L.join)(R,y,"telemetry.json")).toString();f(u,y)})}let O=(0,C.readFileSync)((0,L.join)(T,"telemetry-core.json")).toString();return f(O,"vscode-core"),O=(0,C.readFileSync)((0,L.join)(T,"telemetry-extensions.json")).toString(),f(O,"vscode-extensions"),JSON.stringify(h,null,4)}t.buildTelemetryMessage=b}),define(Q[42],Z([0,1,71,3,15,4,13,129,130,8]),function(q,t,p,C,L,b,T,R,h,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class O extends Error{constructor(e,n){let s=n.message;switch(e){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s);this.type=e,this.cause=n}}t.ExtractError=O;function d(i){const e=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,s)=>n+s,e&61440)}function E(i){if(i instanceof O)return i;let e;return/end of central directory record signature not found/.test(i.message)&&(e="CorruptZip"),new O(e,i)}function y(i,e,n,s,a,r){const g=C.dirname(e),k=C.join(s,g);if(!k.startsWith(s))return Promise.reject(new Error(p.localize(0,null,e)));const z=C.join(s,e);let N;return r.onCancellationRequested(()=>{N&&N.destroy()}),Promise.resolve(L.promises.mkdir(k,{recursive:!0})).then(()=>new Promise((F,j)=>{if(!r.isCancellationRequested)try{N=(0,L.createWriteStream)(z,{mode:n}),N.once("close",()=>F()),N.once("error",j),i.once("error",j),i.pipe(N)}catch($){j($)}}))}function u(i,e,n,s){let a=(0,b.createCancelablePromise)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{a.cancel(),i.close()}),new Promise((g,k)=>{const z=new b.Sequencer,N=F=>{F.isCancellationRequested||(r++,i.readEntry())};i.once("error",k),i.once("close",()=>a.then(()=>{s.isCancellationRequested||i.entryCount===r?g():k(new O("Incomplete",new Error(p.localize(1,null,r,i.entryCount))))},k)),i.readEntry(),i.on("entry",F=>{if(!s.isCancellationRequested){if(!n.sourcePathRegex.test(F.fileName)){N(s);return}const j=F.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(j)){const ne=C.join(e,j);a=(0,b.createCancelablePromise)(ee=>L.promises.mkdir(ne,{recursive:!0}).then(()=>N(ee)).then(void 0,k));return}const $=v(i,F),X=d(F);a=(0,b.createCancelablePromise)(ne=>z.queue(()=>$.then(ee=>y(ee,j,X,e,n,ne).then(()=>N(ne)))).then(null,k))}})})}function w(i,e=!1){return new Promise((n,s)=>{(0,R.open)(i,e?{lazyEntries:!0}:void 0,(a,r)=>{a?s(E(a)):n((0,f.assertIsDefined)(r))})})}function v(i,e){return new Promise((n,s)=>{i.openReadStream(e,(a,r)=>{a?s(E(a)):n((0,f.assertIsDefined)(r))})})}function m(i,e){return new Promise((n,s)=>{const a=new h.ZipFile;e.forEach(g=>{g.contents?a.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&a.addFile(g.localPath,g.path)}),a.end();const r=(0,L.createWriteStream)(i);a.outputStream.pipe(r),a.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(i))})}t.zip=m;function I(i,e,n={},s){const a=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=w(i,!0);return n.overwrite&&(r=r.then(g=>(0,T.rimraf)(e).then(()=>g))),r.then(g=>u(g,e,{sourcePathRegex:a},s))}t.extract=I;function D(i,e){return w(i).then(n=>new Promise((s,a)=>{n.on("entry",r=>{r.fileName===e&&v(n,r).then(g=>s(g),g=>a(g))}),n.once("close",()=>a(new Error(p.localize(2,null,e))))}))}function o(i,e){return D(i,e).then(n=>new Promise((s,a)=>{const r=[];n.once("error",a),n.on("data",g=>r.push(g)),n.on("end",()=>s(Buffer.concat(r)))}))}t.buffer=o}),define(Q[119],Z([0,1,42,76]),function(q,t,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function L(b){return(0,p.buffer)(b,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(R){throw new Error((0,C.localize)(0,null))}})}t.getManifest=L}),define(Q[120],Z([0,1,15,39,2,13,3,12,24,25,4,9,22,87,77,40,42,17,23,10,19,18,31,14]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u,w,v,m,I,D,o,i,e,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const s="scanningSystem",a="scanningUser",r="extracting",g="deleting",k="renaming";let z=class extends L.Disposable{constructor(F,j,$,X,ne){super();this.beforeRemovingExtension=F,this.fileService=j,this.logService=$,this.environmentService=X,this.productService=ne,this._devSystemExtensionsPath=null,this.systemExtensionsPath=X.builtinExtensionsPath,this.extensionsPath=X.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new O.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(F){const j=[];(F===null||F===0)&&j.push(this.scanSystemExtensions().then(null,$=>Promise.reject(new h.ExtensionManagementError(this.joinErrors($).message,s)))),(F===null||F===1)&&j.push(this.scanUserExtensions(!0).then(null,$=>Promise.reject(new h.ExtensionManagementError(this.joinErrors($).message,a))));try{const $=await Promise.all(j);return(0,I.flatten)($)}catch($){throw this.joinErrors($)}}async scanUserExtensions(F){this.logService.trace("Started scanning user extensions");let[j,$]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return $=$.filter(X=>!j[new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).key()]),F&&($=(0,f.groupByExtension)($,ne=>ne.identifier).map(ne=>ne.sort((ee,te)=>C.rcompare(ee.manifest.version,te.manifest.version))[0])),this.logService.trace("Scanned user extensions:",$.length),$}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(F,j,$){const X=F.key(),ne=T.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=T.join(this.extensionsPath,X);try{await b.rimraf(ee)}catch(ae){try{await b.rimraf(ee)}catch(_){}throw new h.ExtensionManagementError((0,u.localize)(0,null,ee,F.id),g)}await this.extractAtLocation(F,j,ne,$);let te=await this.scanExtension(d.URI.file(ne),1);if(!te)throw new Error((0,u.localize)(1,null,ne));await this.storeMetadata(te,{installedTimestamp:Date.now()});try{await this.rename(F,ne,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(ae){try{await b.rimraf(ne)}catch(_){}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(ae)}. Deleted from extracted location`,ne),ae}try{te=await this.scanExtension(d.URI.file(ee),1)}catch(ae){}if(te)return te;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(F,j){return this.setMetadata(F,j),await this.storeMetadata(F,Object.assign(Object.assign({},j),{installedTimestamp:F.installedTimestamp})),F}async storeMetadata(F,j){j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0;const $=T.join(F.location.fsPath,"package.json"),X=await p.promises.readFile($,"utf8"),{manifest:ne}=await this.parseManifest(X);return ne.__metadata=j,await b.writeFile($,JSON.stringify(ne,null,"	")),F}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...F){const j=F.map($=>new f.ExtensionIdentifierWithVersion($.identifier,$.manifest.version));await this.withUninstalledExtensions($=>{j.forEach(X=>$[X.key()]=!0)})}async setInstalled(F){await this.withUninstalledExtensions(X=>delete X[F.key()]);const $=(await this.scanExtensions(1)).find(X=>new f.ExtensionIdentifierWithVersion(X.identifier,X.manifest.version).equals(F))||null;return $?(await this.storeMetadata($,{installedTimestamp:Date.now()}),this.scanExtension($.location,1)):null}async withUninstalledExtensions(F){return this.uninstalledFileLimiter.queue(async()=>{let j;try{j=await p.promises.readFile(this.uninstalledPath,"utf8")}catch(X){if(X.code!=="ENOENT")throw X}let $={};if(j)try{$=JSON.parse(j)}catch(X){}return F&&(F($),Object.keys($).length?await b.writeFile(this.uninstalledPath,JSON.stringify($)):await b.rimraf(this.uninstalledPath)),$})}async removeExtension(F,j){this.logService.trace(`Deleting ${j} extension from disk`,F.identifier.id,F.location.fsPath),await b.rimraf(F.location.fsPath),this.logService.info("Deleted from disk",F.identifier.id,F.location.fsPath)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.withUninstalledExtensions(j=>delete j[new f.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()])}async extractAtLocation(F,j,$,X){this.logService.trace(`Started extracting the extension from ${j} to ${$}`);try{await b.rimraf($)}catch(ne){throw new h.ExtensionManagementError(this.joinErrors(ne).message,g)}try{await(0,v.extract)(j,$,{sourcePath:"extension",overwrite:!0},X),this.logService.info(`Extracted extension to ${$}:`,F.id)}catch(ne){try{await b.rimraf($)}catch(ee){}throw new h.ExtensionManagementError(ne.message,ne instanceof v.ExtractError&&ne.type?ne.type:r)}}async rename(F,j,$,X){try{await p.promises.rename(j,$)}catch(ne){if(m.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<X)return this.logService.info(`Failed renaming ${j} to ${$} with 'EPERM' error. Trying again...`,F.id),this.rename(F,j,$,X);throw new h.ExtensionManagementError(ne.message||(0,u.localize)(3,null,j,$),ne.code||k)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const F=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return F;const j=this.scanDevSystemExtensions(),[$,X]=await Promise.all([F,j]);return[...$,...X]}async scanExtensionsInDir(F,j){const $=new O.Limiter(10),X=await this.fileService.resolve(d.URI.file(F));return X.children?(await Promise.all(X.children.filter(ee=>ee.isDirectory).map(ee=>$.queue(async()=>j===1&&(0,i.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,j))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(F,j){var $,X;try{const ne=await this.fileService.resolve(F);if(ne.children){const{manifest:ee,metadata:te}=await this.readManifest(F.fsPath),ae=($=ne.children.find(({name:l})=>/^readme(\.txt|\.md|)$/i.test(l)))===null||$===void 0?void 0:$.resource,_=(X=ne.children.find(({name:l})=>/^changelog(\.txt|\.md|)$/i.test(l)))===null||X===void 0?void 0:X.resource,G={id:(0,f.getGalleryExtensionId)(ee.publisher,ee.name)},B={type:j,identifier:G,manifest:ee,location:F,readmeUrl:ae,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:j===0};return te&&(this.setMetadata(B,te),B.installedTimestamp=te.installedTimestamp),B}}catch(ne){j!==0&&this.logService.trace(ne)}return null}async scanDefaultSystemExtensions(){const F=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",F.length),F}async scanDevSystemExtensions(){const F=this.getDevSystemExtensionsList();if(F.length){const j=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",j.length),j.filter($=>F.some(X=>(0,f.areSameExtensions)($.identifier,{id:X})))}else return[]}setMetadata(F,j){F.publisherDisplayName=j.publisherDisplayName||null,F.publisherId=j.publisherId||null,F.identifier.uuid=j.id,F.isMachineScoped=!!j.isMachineScoped,F.isBuiltin=F.type===0||!!j.isBuiltin}async removeUninstalledExtensions(){const F=await this.getUninstalledExtensions(),j=await this.scanAllUserExtensions(),$=new Set;for(const ee of j)F[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||$.add(ee.identifier.id.toLowerCase());const X=(0,f.groupByExtension)(j,ee=>ee.identifier);await O.Promises.settled(X.map(async ee=>{const te=ee.sort((ae,_)=>C.rcompare(ae.manifest.version,_.manifest.version))[0];$.has(te.identifier.id.toLowerCase())||await this.beforeRemovingExtension(te)}));const ne=j.filter(ee=>F[new f.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await O.Promises.settled(ne.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const F=await this.scanAllUserExtensions(),j=[],$=(0,f.groupByExtension)(F,X=>X.identifier);j.push(...(0,I.flatten)($.map(X=>X.sort((ne,ee)=>C.rcompare(ne.manifest.version,ee.manifest.version)).slice(1)))),await O.Promises.settled(j.map(X=>this.removeExtension(X,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(F=>F.name)}joinErrors(F){const j=Array.isArray(F)?F:[F];return j.length===1?j[0]instanceof Error?j[0]:new Error(j[0]):j.reduce(($,X)=>new Error(`${$.message}${$.message?",":""}${X instanceof Error?X.message:X}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(D.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(F){const j=[p.promises.readFile(T.join(F,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),p.promises.readFile(T.join(F,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:$,metadata:X},ne]=await Promise.all(j);return{manifest:(0,y.localizeManifest)($,ne),metadata:X}}parseManifest(F){return new Promise((j,$)=>{try{const X=JSON.parse(F),ne=X.__metadata||null;j({manifest:X,metadata:ne})}catch(X){$(new Error((0,u.localize)(4,null)))}})}};z=ce([ue(1,o.IFileService),ue(2,R.ILogService),ue(3,E.INativeEnvironmentService),ue(4,w.IProductService)],z),t.ExtensionsScanner=z}),define(Q[121],Z([0,1,15,75,3,13,2,23,42,24,25,22,4,11,39,9,53,17,12,94,30,41,47,18,31,93,7,10,28,119,98,120,99,100,19]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u,w,v,m,I,D,o,i,e,n,s,a,r,g,k,z,N,F,j,$,X){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",ee="downloading",te="validating",ae="local",_="unknown";let G=class extends T.Disposable{constructor(l,c,S,P,A,M,U){super();this.environmentService=l,this.galleryService=c,this.logService=S,this.downloadService=P,this.telemetryService=A,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new y.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new y.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new y.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new y.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const W=this._register(M.createInstance(j.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(F.ExtensionsScanner,J=>W.postUninstall(J))),this.manifestCache=this._register(new D.ExtensionsManifestCache(l,this)),this.extensionsDownloader=this._register(M.createInstance(N.ExtensionsDownloader));const x=this._register(new $.ExtensionsWatcher(this,U,l,S));this._register(x.onDidChangeExtensionsByAnotherSource(({added:J,removed:Y})=>{J.forEach(ie=>this._onDidInstallExtension.fire({identifier:ie.identifier,operation:0,local:ie})),Y.forEach(ie=>this._onDidUninstallExtension.fire({identifier:ie}))})),this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(J=>J.cancel()),this.uninstallingExtensions.forEach(J=>J.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(l){this.logService.trace("ExtensionManagementService#zip",l.identifier.id);const c=await this.collectFiles(l),S=await(0,h.zip)((0,n.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)()).fsPath,c);return w.URI.file(S)}async unzip(l){return this.logService.trace("ExtensionManagementService#unzip",l.toString()),(await this.install(l)).identifier}async getManifest(l){const c=await this.downloadVsix(l),S=L.resolve(c.fsPath);return(0,z.getManifest)(S)}async collectFiles(l){const c=async P=>{let A=await b.readdir(P);A=A.map(W=>L.join(P,W));const M=await Promise.all(A.map(W=>p.promises.stat(W)));let U=Promise.resolve([]);return M.forEach((W,x)=>{const J=A[x];W.isFile()&&(U=U.then(Y=>[...Y,J])),W.isDirectory()&&(U=U.then(Y=>c(J).then(ie=>[...Y,...ie])))}),U};return(await c(l.location.fsPath)).map(P=>({path:`extension/${L.relative(l.location.fsPath,P)}`,localPath:P}))}async install(l,c={}){return this.logService.trace("ExtensionManagementService#install",l.toString()),(0,E.createCancelablePromise)(async S=>{const P=await this.downloadVsix(l),A=L.resolve(P.fsPath),M=await(0,z.getManifest)(A),U={id:(0,O.getGalleryExtensionId)(M.publisher,M.name)};let W=1;if(M.engines&&M.engines.vscode&&!(0,e.isEngineValid)(M.engines.vscode,v.default.version))throw new Error(C.localize(0,null,U.id,v.default.version));const x=new O.ExtensionIdentifierWithVersion(U,M.version),Y=(await this.getInstalled(1)).find(re=>(0,O.areSameExtensions)(U,re.identifier));if(Y)if(c.isMachineScoped=c.isMachineScoped||Y.isMachineScoped,c.isBuiltin=c.isBuiltin||Y.isBuiltin,W=2,x.equals(new O.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(C.localize(1,null,M.displayName||M.name))}else u.gt(Y.manifest.version,M.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal(x);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(he){throw new Error(C.localize(2,null,M.displayName||M.name))}}this.logService.info("Installing the extension:",U.id),this._onInstallExtension.fire({identifier:U,zipPath:A});let ie;try{ie=await this.getGalleryMetadata((0,O.getGalleryExtensionId)(M.publisher,M.name))}catch(re){}try{const re=await this.installFromZipPath(x,A,Object.assign(Object.assign({},ie||{}),c),c,W,S);return this.logService.info("Successfully installed the extension:",U.id),re}catch(re){throw this.logService.error("Failed to install the extension:",U.id,re.message),re}})}async downloadVsix(l){if(l.scheme===g.Schemas.file)return l;if(!this.downloadService)throw new Error("Download service is not available");const c=(0,n.joinPath)(this.environmentService.tmpDir,(0,s.generateUuid)());return await this.downloadService.download(l,c),c}async installFromZipPath(l,c,S,P,A,M){try{const U=await this.installExtension({zipPath:c,identifierWithVersion:l,metadata:S},M);try{await this.installDependenciesAndPackExtensions(U,void 0,P)}catch(W){(0,R.isNonEmptyArray)(U.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",U.identifier.id,W.message),(0,R.isNonEmptyArray)(U.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",U.identifier.id,W.message)}return this._onDidInstallExtension.fire({identifier:l,zipPath:c,local:U,operation:A}),U}catch(U){throw this._onDidInstallExtension.fire({identifier:l,zipPath:c,operation:A,error:U}),U}}async canInstall(l){return!0}async installFromGallery(l,c={}){if(!this.galleryService.isEnabled())throw new Error(C.localize(3,null));try{l=await this.checkAndGetCompatibleVersion(l)}catch(A){const M=A&&A.code?A.code:_;throw this.logService.error("Failed to install extension:",l.identifier.id,A?A.message:M),this.reportTelemetry(this.getTelemetryEvent(1),(0,O.getGalleryExtensionTelemetryData)(l),void 0,A),A instanceof Error&&(A.name=M),A}const S=new O.ExtensionIdentifierWithVersion(l.identifier,l.version).key();let P=this.installingExtensions.get(S);return P||(P=(0,E.createCancelablePromise)(A=>this.doInstallFromGallery(l,c,A)),this.installingExtensions.set(S,P),P.finally(()=>this.installingExtensions.delete(S))),P}async doInstallFromGallery(l,c,S){const P=new Date().getTime();let A=1;this.logService.info("Installing extension:",l.identifier.id),this._onInstallExtension.fire({identifier:l.identifier,gallery:l});try{const U=(await this.getInstalled(1)).find(J=>(0,O.areSameExtensions)(J.identifier,l.identifier));U&&(A=2);const W=await this.downloadInstallableExtension(l,A);W.metadata.isMachineScoped=c.isMachineScoped||(U==null?void 0:U.isMachineScoped),W.metadata.isBuiltin=c.isBuiltin||(U==null?void 0:U.isBuiltin);const x=await this.installExtension(W,S);try{await this.extensionsDownloader.delete(w.URI.file(W.zipPath))}catch(J){}if(!c.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(x,U,c)}catch(J){try{await this.uninstall(x)}catch(Y){}throw J}return U&&u.neq(U.manifest.version,l.version)&&await this.extensionsScanner.setUninstalled(U),this.logService.info("Extensions installed successfully:",l.identifier.id),this._onDidInstallExtension.fire({identifier:l.identifier,gallery:l,local:x,operation:A}),this.reportTelemetry(this.getTelemetryEvent(A),(0,O.getGalleryExtensionTelemetryData)(l),new Date().getTime()-P,void 0),x}catch(M){const U=M&&M.code?M.code:_;throw this.logService.error("Failed to install extension:",l.identifier.id,M?M.message:U),this._onDidInstallExtension.fire({identifier:l.identifier,gallery:l,operation:A,error:U}),this.reportTelemetry(this.getTelemetryEvent(A),(0,O.getGalleryExtensionTelemetryData)(l),new Date().getTime()-P,M),M instanceof Error&&(M.name=U),M}}async checkAndGetCompatibleVersion(l){if(await this.isMalicious(l))throw new f.ExtensionManagementError(C.localize(4,null),f.INSTALL_ERROR_MALICIOUS);const c=await this.galleryService.getCompatibleExtension(l);if(!c)throw new f.ExtensionManagementError(C.localize(5,null,l.identifier.id,v.default.version),f.INSTALL_ERROR_INCOMPATIBLE);return c}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(6,null));const c=await this.findGalleryExtension(l);if(!c)throw new Error(C.localize(7,null));await this.extensionsScanner.setUninstalled(l);try{await this.extensionsScanner.removeUninstalledExtension(l)}catch(S){throw new Error(C.localize(8,null,(0,o.toErrorMessage)(S)))}await this.installFromGallery(c)}getTelemetryEvent(l){return l===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(l){const c=await this.getExtensionsReport();return(0,O.getMaliciousExtensionsSet)(c).has(l.identifier.id)}async downloadInstallableExtension(l,c){const S={id:l.identifier.uuid,publisherId:l.publisherId,publisherDisplayName:l.publisherDisplayName};let P;try{this.logService.trace("Started downloading extension:",l.identifier.id);const A=await this.extensionsDownloader.downloadExtension(l,c);this.logService.info("Downloaded extension:",l.identifier.id,P),P=A.fsPath}catch(A){throw new f.ExtensionManagementError(this.joinErrors(A).message,ee)}try{const A=await(0,z.getManifest)(P);return{zipPath:P,identifierWithVersion:new O.ExtensionIdentifierWithVersion(l.identifier,A.version),metadata:S}}catch(A){throw new f.ExtensionManagementError(this.joinErrors(A).message,te)}}async installExtension(l,c){try{const S=await this.unsetUninstalledAndGetLocal(l.identifierWithVersion);if(S)return l.metadata?this.extensionsScanner.saveMetadataForLocalExtension(S,l.metadata):S}catch(S){throw m.isMacintosh?new f.ExtensionManagementError(C.localize(9,null),ne):new f.ExtensionManagementError(C.localize(10,null),ne)}return this.extractAndInstall(l,c)}async unsetUninstalledAndGetLocal(l){if(!await this.isUninstalled(l))return null;this.logService.trace("Removing the extension from uninstalled list:",l.id);const S=await this.extensionsScanner.setInstalled(l);return this.logService.info("Removed the extension from uninstalled list:",l.id),S}async extractAndInstall({zipPath:l,identifierWithVersion:c,metadata:S},P){let A=await this.extensionsScanner.extractUserExtension(c,l,P);return this.logService.info("Installation completed.",c.id),S&&(A=await this.extensionsScanner.saveMetadataForLocalExtension(A,S)),A}async installDependenciesAndPackExtensions(l,c,S){if(!!this.galleryService.isEnabled()){const P=l.manifest.extensionDependencies||[];if(l.manifest.extensionPack)for(const A of l.manifest.extensionPack)c&&c.manifest.extensionPack&&c.manifest.extensionPack.some(M=>(0,O.areSameExtensions)({id:M},{id:A}))||P.every(M=>!(0,O.areSameExtensions)({id:M},{id:A}))&&P.push(A);if(P.length){const A=await this.getInstalled(),M=P.filter(U=>A.every(({identifier:W})=>!(0,O.areSameExtensions)(W,{id:U})));if(M.length){const W=(await this.galleryService.query({names:M,pageSize:P.length},k.CancellationToken.None)).firstPage;try{await E.Promises.settled(W.map(x=>this.installFromGallery(x,S)))}catch(x){try{await this.rollback(W)}catch(J){}throw x}}}}}async rollback(l){const S=(await this.getInstalled(1)).filter(P=>l.some(A=>new O.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).equals(new O.ExtensionIdentifierWithVersion(A.identifier,A.version))));await E.Promises.settled(S.map(P=>this.uninstall(P)))}async uninstall(l,c={}){this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id);const S=await this.getInstalled(1),P=S.find(A=>(0,O.areSameExtensions)(A.identifier,l.identifier));if(!P)throw new Error(C.localize(11,null,l.manifest.displayName||l.manifest.name));try{await this.checkForDependenciesAndUninstall(P,S,c)}catch(A){throw this.joinErrors(A)}}async updateMetadata(l,c){return this.logService.trace("ExtensionManagementService#updateMetadata",l.identifier.id),l=await this.extensionsScanner.saveMetadataForLocalExtension(l,Object.assign(Object.assign({},l.manifest.__metadata||{}),c)),this.manifestCache.invalidate(),l}async updateExtensionScope(l,c){return this.logService.trace("ExtensionManagementService#updateExtensionScope",l.identifier.id),l=await this.extensionsScanner.saveMetadataForLocalExtension(l,Object.assign(Object.assign({},l.manifest.__metadata||{}),{isMachineScoped:c})),this.manifestCache.invalidate(),l}async getGalleryMetadata(l){const c=await this.findGalleryExtensionByName(l);return c?{id:c.identifier.uuid,publisherDisplayName:c.publisherDisplayName,publisherId:c.publisherId}:void 0}async findGalleryExtension(l){if(l.identifier.uuid){const c=await this.findGalleryExtensionById(l.identifier.uuid);return c||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},k.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},k.CancellationToken.None)).firstPage[0]}joinErrors(l){const c=Array.isArray(l)?l:[l];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((S,P)=>new Error(`${S.message}${S.message?",":""}${P instanceof Error?P.message:P}`),new Error(""))}async checkForDependenciesAndUninstall(l,c,S){try{await this.preUninstallExtension(l);const P=S.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(l,c);await this.uninstallExtensions(l,P,c,S)}catch(P){throw await this.postUninstallExtension(l,new f.ExtensionManagementError(P instanceof Error?P.message:P,ae)),P}await this.postUninstallExtension(l)}async uninstallExtensions(l,c,S,P){const A=[l,...c];if(!P.donotCheckDependents)for(const M of A)this.checkForDependents(M,A,S,l);await E.Promises.settled([this.uninstallExtension(l),...c.map(M=>this.doUninstall(M))])}checkForDependents(l,c,S,P){const A=this.getDependents(l,S);if(A.length){const M=A.filter(U=>c.indexOf(U)===-1);if(M.length)throw new Error(this.getDependentsErrorMessage(l,M,P))}}getDependentsErrorMessage(l,c,S){return S===l?c.length===1?C.localize(12,null,S.manifest.displayName||S.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?C.localize(13,null,S.manifest.displayName||S.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):C.localize(14,null,S.manifest.displayName||S.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):c.length===1?C.localize(15,null,S.manifest.displayName||S.manifest.name,l.manifest.displayName||l.manifest.name,c[0].manifest.displayName||c[0].manifest.name):c.length===2?C.localize(16,null,S.manifest.displayName||S.manifest.name,l.manifest.displayName||l.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name):C.localize(17,null,S.manifest.displayName||S.manifest.name,l.manifest.displayName||l.manifest.name,c[0].manifest.displayName||c[0].manifest.name,c[1].manifest.displayName||c[1].manifest.name)}getAllPackExtensionsToUninstall(l,c,S=[]){if(S.indexOf(l)!==-1)return[];S.push(l);const P=l.manifest.extensionPack?l.manifest.extensionPack:[];if(P.length){const A=c.filter(U=>!U.isBuiltin&&P.some(W=>(0,O.areSameExtensions)({id:W},U.identifier))),M=[];for(const U of A)M.push(...this.getAllPackExtensionsToUninstall(U,c,S));return[...A,...M]}return[]}getDependents(l,c){return c.filter(S=>S.manifest.extensionDependencies&&S.manifest.extensionDependencies.some(P=>(0,O.areSameExtensions)({id:P},l.identifier)))}async doUninstall(l){try{await this.preUninstallExtension(l),await this.uninstallExtension(l)}catch(c){throw await this.postUninstallExtension(l,new f.ExtensionManagementError(c instanceof Error?c.message:c,ae)),c}await this.postUninstallExtension(l)}async preUninstallExtension(l){if(!await b.exists(l.location.fsPath))throw new Error(C.localize(18,null));this.logService.info("Uninstalling extension:",l.identifier.id),this._onUninstallExtension.fire(l.identifier)}async uninstallExtension(l){let c=this.uninstallingExtensions.get(l.identifier.id);return c||(c=(0,E.createCancelablePromise)(async()=>{const S=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...S.filter(P=>(0,O.areSameExtensions)(P.identifier,l.identifier)))}),this.uninstallingExtensions.set(l.identifier.id,c),c.finally(()=>this.uninstallingExtensions.delete(l.identifier.id))),c}async postUninstallExtension(l,c){if(c)this.logService.error("Failed to uninstall extension:",l.identifier.id,c.message);else if(this.logService.info("Successfully uninstalled extension:",l.identifier.id),l.identifier.uuid)try{await this.galleryService.reportStatistic(l.manifest.publisher,l.manifest.name,l.manifest.version,"uninstall")}catch(P){}this.reportTelemetry("extensionGallery:uninstall",(0,O.getLocalExtensionTelemetryData)(l),void 0,c);const S=c?c instanceof f.ExtensionManagementError?c.code:_:void 0;this._onDidUninstallExtension.fire({identifier:l.identifier,error:S})}getInstalled(l=null){return this.extensionsScanner.scanExtensions(l)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(l){return(await this.filterUninstalled(l)).length===1}async filterUninstalled(...l){const c=[],S=await this.extensionsScanner.getUninstalledExtensions();for(const P of l)S[P.key()]&&c.push(P.key());return c}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(l,c,S,P){const A=P?P instanceof f.ExtensionManagementError?P.code:_:void 0;this.telemetryService.publicLogError(l,Object.assign(Object.assign({},c),{success:!P,duration:S,errorcode:A}))}};G=ce([ue(0,d.INativeEnvironmentService),ue(1,f.IExtensionGalleryService),ue(2,I.ILogService),ue(3,(0,r.optional)(a.IDownloadService)),ue(4,i.ITelemetryService),ue(5,r.IInstantiationService),ue(6,X.IFileService)],G),t.ExtensionManagementService=G}),define(Q[122],Z([0,1,131,109,2,8,14,108,27,12,16]),function(q,t,p,C,L,b,T,R,h,f,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let d=class extends L.Disposable{constructor(y,u){super();this.logService=u,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,u){this.logService.trace("RequestService#request",y.url);const{proxyUrl:w,strictSSL:v}=this,m=y.agent?y.agent:await(0,R.getProxyAgent)(y.url||"",{proxyUrl:w,strictSSL:v});return y.agent=m,y.strictSSL=v,this.authorization&&(y.headers=Object.assign(Object.assign({},y.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(y,u)}async getNodeRequest(y){return((0,C.parse)(y.url).protocol==="https:"?await new Promise((v,m)=>{q(["https"],v,m)}):await new Promise((v,m)=>{q(["http"],v,m)})).request}_request(y,u){return new Promise(async(w,v)=>{let m;const I=(0,C.parse)(y.url),D=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),o={hostname:I.hostname,port:I.port?parseInt(I.port):I.protocol==="https:"?443:80,protocol:I.protocol,path:I.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,b.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(o.auth=y.user+":"+y.password),m=D(o,i=>{const e=(0,b.isNumber)(y.followRedirects)?y.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&e>0&&i.headers.location)this._request(Object.assign(Object.assign({},y),{url:i.headers.location,followRedirects:e-1}),u).then(w,v);else{let n=i;i.headers["content-encoding"]==="gzip"&&(n=i.pipe((0,p.createGunzip)())),w({res:i,stream:(0,O.streamToBufferReadableStream)(n)})}}),m.on("error",v),y.timeout&&m.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&m.write(y.data),m.end(),u.onCancellationRequested(()=>{m.abort(),v((0,T.canceled)())})})}async resolveProxy(y){}};d=ce([ue(0,h.IConfigurationService),ue(1,f.ILogService)],d),t.RequestService=d}),define(Q[132],Z([0,1,46,15,133,3,4,53,51,48,96,22,86,24,121,115,41,54,116,114,52,122,27,107,117,111,112,12,10,104,118,101,19,102,2,40,97,9,103,38,14,30,16,36]),function(q,t,p,C,L,b,T,R,h,f,O,d,E,y,u,w,v,m,I,D,o,i,e,n,s,a,r,g,k,z,N,F,j,$,X,ne,ee,te,ae,_,G,B,l,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class S extends X.Disposable{constructor(M){super();this.argv=M,(0,L.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[M,U]=await this.initServices();return M.invokeFunction(async W=>{const x=W.get(g.ILogService),J=W.get(j.IFileService),Y=W.get(d.INativeEnvironmentService),ie=W.get(y.IExtensionManagementCLIService);return x.info("CLI main",this.argv),this.registerErrorHandler(x),await this.doRun(Y,ie,J),(0,T.raceTimeout)((0,m.combinedAppender)(...U).flush(),1e3)})}async initServices(){const M=new h.ServiceCollection,U=Object.assign({_serviceBrand:void 0},R.default);M.set(ne.IProductService,U);const W=new E.NativeEnvironmentService(this.argv,U);M.set(d.INativeEnvironmentService,W),await Promise.all([W.appSettingsHome.fsPath,W.extensionsPath].map(we=>we?C.promises.mkdir(we,{recursive:!0}):void 0));const x=(0,g.getLogLevel)(W),J=[];J.push(new z.SpdLogLogger("cli",(0,b.join)(W.logsPath,"cli.log"),!0,x)),x===g.LogLevel.Trace&&J.push(new g.ConsoleLogger(x));const Y=this._register(new g.MultiplexLogService(J));M.set(g.ILogService,Y);const ie=this._register(new F.FileService(Y));M.set(j.IFileService,ie);const re=this._register(new $.DiskFileSystemProvider(Y));ie.registerProvider(k.Schemas.file,re);const he=this._register(new n.ConfigurationService(W.settingsResource,ie));M.set(e.IConfigurationService,he),await he.initialize();const ge=new r.StateService(W,Y);M.set(a.IStateService,ge);const{appRoot:Pe,extensionsPath:Le,extensionDevelopmentLocationURI:Te,isBuilt:Oe,installSourcePath:ke}=W;M.set(o.IRequestService,new f.SyncDescriptor(i.RequestService)),M.set(y.IExtensionManagementService,new f.SyncDescriptor(u.ExtensionManagementService)),M.set(y.IExtensionGalleryService,new f.SyncDescriptor(w.ExtensionGalleryService)),M.set(y.IExtensionManagementCLIService,new f.SyncDescriptor(ee.ExtensionManagementCLIService)),M.set(_.ILocalizationsService,new f.SyncDescriptor(ae.LocalizationsService));const ve=[];if(Oe&&!Te&&!W.disableTelemetry&&U.enableTelemetry){U.aiConfig&&U.aiConfig.asimovKey&&ve.push(new s.AppInsightsAppender("monacoworkbench",null,U.aiConfig.asimovKey));const we={appender:(0,m.combinedAppender)(...ve),sendErrorTelemetry:!1,commonProperties:(0,D.resolveCommonProperties)(ie,(0,p.release)(),process.arch,U.commit,U.version,ge.getItem("telemetry.machineId"),U.msftInternalDomains,ke),piiPaths:[Pe,Le]};M.set(v.ITelemetryService,new f.SyncDescriptor(I.TelemetryService,[we]))}else M.set(v.ITelemetryService,m.NullTelemetryService);return[new O.InstantiationService(M),ve]}registerErrorHandler(M){(0,G.setUnexpectedErrorHandler)(U=>{const W=(0,B.toErrorMessage)(U,!0);!W||M.error(`[uncaught exception in CLI]: ${W}`)})}async doRun(M,U,W){if(this.argv["install-source"])return this.setInstallSource(M,W,this.argv["install-source"]);if(this.argv["list-extensions"])return U.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return U.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return U.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return U.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,N.buildTelemetryMessage)(M.appRoot,M.extensionsPath))}asExtensionIdOrVSIX(M){return M.map(U=>/\.vsix$/i.test(U)?te.URI.file((0,b.isAbsolute)(U)?U:(0,b.join)((0,c.cwd)(),U)):U)}async setInstallSource(M,U,W){await U.writeFile(te.URI.file(M.installSourcePath),l.VSBuffer.fromString(W.slice(0,30)))}}async function P(A){const M=new S(A);try{await M.run()}finally{M.dispose()}}t.main=P})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/469e4f6e2755b220dae3eccb04d1ddc587b84a5a/core/vs/code/node/cliProcessMain.js.map
