/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/process","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(oe){for(var e=[],w=0,D=oe.length;w<D;w++)e[w]=we[oe[w]];return e};define(we[43],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(D,T){if(!D)throw new Error(T?`Assertion failed (${T})`:"Assertion Failed")}e.ok=w}),define(we[51],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function D(A){const k=[];for(let _ in A)w.call(A,_)&&k.push(A[_]);return k}e.values=D;function T(A,k){for(let _ in A)if(w.call(A,_)&&k({key:_,value:A[_]},function(){delete A[_]})===!1)return}e.forEach=T;function P(A,k){const _=Object.create(null);for(const f of A){const r=k(f);let h=_[r];h||(h=_[r]=[]),h.push(f)}return _}e.groupBy=P;function S(A){const k=Object.create(null);return A&&A.forEach((_,f)=>{k[f]=_}),k}e.fromMap=S;function I(A,k){const _=[],f=[];for(let r of A)k.has(r)||_.push(r);for(let r of k)A.has(r)||f.push(r);return{removed:_,added:f}}e.diffSets=I;function y(A,k){const _=[],f=[];for(let[r,h]of A)k.has(r)||_.push(h);for(let[r,h]of k)A.has(r)||f.push(h);return{removed:_,added:f}}e.diffMaps=y;class n{constructor(){this.map=new Map}add(k,_){let f=this.map.get(k);f||(f=new Set,this.map.set(k,f)),f.add(_)}delete(k,_){const f=this.map.get(k);!f||(f.delete(_),f.size===0&&this.map.delete(k))}forEach(k,_){const f=this.map.get(k);!f||f.forEach(_)}}e.SetMap=n}),define(we[44],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(y){return(n,A,k)=>{let _=null,f=null;if(typeof k.value=="function"?(_="value",f=k.value):typeof k.get=="function"&&(_="get",f=k.get),!f)throw new Error("not supported");k[_]=y(f,A)}}e.createDecorator=w;let D=0;function T(){const y=`$memoize${D++}`;let n;const A=function(_,f,r){let h=null,p=null;if(typeof r.value=="function"?(h="value",p=r.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(h="get",p=r.get),!p)throw new Error("not supported");const m=`${y}:${f}`;r[h]=function(...v){return n=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:p.apply(this,v)}),this[m]}};return A.clear=()=>{typeof n!="undefined"&&Object.getOwnPropertyNames(n).forEach(k=>{k.indexOf(y)===0&&delete n[k]})},A}e.createMemoizer=T;function P(y,n,A){return T()(y,n,A)}e.memoize=P;function S(y,n,A){return w((k,_)=>{const f=`$debounce$${_}`,r=`$debounce$result$${_}`;return function(...h){this[r]||(this[r]=A?A():void 0),clearTimeout(this[f]),n&&(this[r]=n(this[r],...h),h=[this[r]]),this[f]=setTimeout(()=>{k.apply(this,h),this[r]=A?A():void 0},y)}})}e.debounce=S;function I(y,n,A){return w((k,_)=>{const f=`$throttle$timer$${_}`,r=`$throttle$result$${_}`,h=`$throttle$lastRun$${_}`,p=`$throttle$pending$${_}`;return function(...m){if(this[r]||(this[r]=A?A():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),n&&(this[r]=n(this[r],...m)),!this[p]){const v=this[h]+y;v<=Date.now()?(this[h]=Date.now(),k.apply(this,[this[r]]),this[r]=A?A():void 0):(this[p]=!0,this[f]=setTimeout(()=>{this[p]=!1,this[h]=Date.now(),k.apply(this,[this[r]]),this[r]=A?A():void 0},v-Date.now()))}}})}e.throttle=I}),define(we[10],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function D(o){e.errorHandler.setUnexpectedErrorHandler(o)}e.setUnexpectedErrorHandler=D;function T(o){y(o)||e.errorHandler.onUnexpectedError(o)}e.onUnexpectedError=T;function P(o){y(o)||e.errorHandler.onUnexpectedExternalError(o)}e.onUnexpectedExternalError=P;function S(o){if(o instanceof Error){let{name:t,message:i}=o;const u=o.stacktrace||o.stack;return{$isError:!0,name:t,message:i,stack:u}}return o}e.transformErrorForSerialization=S;const I="Canceled";function y(o){return o instanceof Error&&o.name===I&&o.message===I}e.isPromiseCanceledError=y;class n extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=n;function A(){const o=new Error(I);return o.name=o.message,o}e.canceled=A;function k(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}e.illegalArgument=k;function _(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}e.illegalState=_;function f(o){return o?new Error(`readonly property '${o} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function r(o){const t=new Error(`${o} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function h(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}e.getErrorMessage=h;class p extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=p;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function d(o){const t=o;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function c(o,t=Object.create(null)){const i=new Error(o);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=c}),define(we[15],Ee([0,1,10]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(L,$=0){return L[L.length-(1+$)]}e.tail=D;function T(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.tail2=T;function P(L,$,U=(Q,N)=>Q===N){if(L===$)return!0;if(!L||!$||L.length!==$.length)return!1;for(let Q=0,N=L.length;Q<N;Q++)if(!U(L[Q],$[Q]))return!1;return!0}e.equals=P;function S(L,$,U){let Q=0,N=L.length-1;for(;Q<=N;){const Z=(Q+N)/2|0,ne=U(L[Z],$);if(ne<0)Q=Z+1;else if(ne>0)N=Z-1;else return Z}return-(Q+1)}e.binarySearch=S;function I(L,$){let U=0,Q=L.length;if(Q===0)return 0;for(;U<Q;){const N=Math.floor((U+Q)/2);$(L[N])?Q=N:U=N+1}return U}e.findFirstInSorted=I;function y(L,$,U){if(L=L|0,L>=$.length)throw new TypeError("invalid index");let Q=$[Math.floor($.length*Math.random())],N=[],Z=[],ne=[];for(let re of $){const ye=U(re,Q);ye<0?N.push(re):ye>0?Z.push(re):ne.push(re)}return L<N.length?y(L,N,U):L<N.length+ne.length?ne[0]:y(L-(N.length+ne.length),Z,U)}e.quickSelect=y;function n(L,$){const U=[];let Q;for(const N of L.slice(0).sort($))!Q||$(Q[0],N)!==0?(Q=[N],U.push(Q)):Q.push(N);return U}e.groupBy=n;function A(L,$,U){const Q=[];function N(re,ye,Ae){if(!(ye===0&&Ae.length===0)){const Be=Q[Q.length-1];Be&&Be.start+Be.deleteCount===re?(Be.deleteCount+=ye,Be.toInsert.push(...Ae)):Q.push({start:re,deleteCount:ye,toInsert:Ae})}}let Z=0,ne=0;for(;;){if(Z===L.length){N(Z,0,$.slice(ne));break}if(ne===$.length){N(Z,L.length-Z,[]);break}const re=L[Z],ye=$[ne],Ae=U(re,ye);Ae===0?(Z+=1,ne+=1):Ae<0?(N(Z,1,[]),Z+=1):Ae>0&&(N(Z,0,[ye]),ne+=1)}return Q}e.sortedDiff=A;function k(L,$,U){const Q=A(L,$,U),N=[],Z=[];for(const ne of Q)N.push(...L.slice(ne.start,ne.start+ne.deleteCount)),Z.push(...ne.toInsert);return{removed:N,added:Z}}e.delta=k;function _(L,$,U){if(U===0)return[];const Q=L.slice(0,U).sort($);return r(L,$,Q,U,L.length),Q}e.top=_;function f(L,$,U,Q,N){return U===0?Promise.resolve([]):new Promise((Z,ne)=>{(async()=>{const re=L.length,ye=L.slice(0,U).sort($);for(let Ae=U,Be=Math.min(U+Q,re);Ae<re;Ae=Be,Be=Math.min(Be+Q,re)){if(Ae>U&&await new Promise(Re=>setTimeout(Re)),N&&N.isCancellationRequested)throw(0,w.canceled)();r(L,$,ye,Ae,Be)}return ye})().then(Z,ne)})}e.topAsync=f;function r(L,$,U,Q,N){for(const Z=U.length;Q<N;Q++){const ne=L[Q];if($(ne,U[Z-1])<0){U.pop();const re=I(U,ye=>$(ne,ye)<0);U.splice(re,0,ne)}}}function h(L){return L.filter($=>!!$)}e.coalesce=h;function p(L){let $=0;for(let U=0;U<L.length;U++)L[U]&&(L[$]=L[U],$+=1);L.length=$}e.coalesceInPlace=p;function m(L,$,U){L.splice(U,0,L.splice($,1)[0])}e.move=m;function v(L){return!Array.isArray(L)||L.length===0}e.isFalsyOrEmpty=v;function d(L){return Array.isArray(L)&&L.length>0}e.isNonEmptyArray=d;function c(L,$){if(!$)return L.filter((Q,N)=>L.indexOf(Q)===N);const U=Object.create(null);return L.filter(Q=>{const N=$(Q);return U[N]?!1:(U[N]=!0,!0)})}e.distinct=c;function o(L){const $=new Set;return L.filter(U=>$.has(U)?!1:($.add(U),!0))}e.distinctES6=o;function t(L){const $=Object.create(null);return U=>{const Q=L(U);return $[Q]?!1:($[Q]=!0,!0)}}e.uniqueFilter=t;function i(L,$){for(let U=L.length-1;U>=0;U--){const Q=L[U];if($(Q))return U}return-1}e.lastIndex=i;function u(L,$){return L.length>0?L[0]:$}e.firstOrDefault=u;function l(L,$,U=(Q,N)=>Q===N){let Q=0;for(let N=0,Z=Math.min(L.length,$.length);N<Z&&U(L[N],$[N]);N++)Q++;return Q}e.commonPrefixLength=l;function s(L){return[].concat(...L)}e.flatten=s;function a(L,$){let U=typeof $=="number"?L:0;typeof $=="number"?U=L:(U=0,$=L);const Q=[];if(U<=$)for(let N=U;N<$;N++)Q.push(N);else for(let N=U;N>$;N--)Q.push(N);return Q}e.range=a;function E(L,$,U){return L.reduce((Q,N)=>(Q[$(N)]=U?U(N):N,Q),Object.create(null))}e.index=E;function R(L,$){return L.push($),()=>g(L,$)}e.insert=R;function g(L,$){const U=L.indexOf($);if(U>-1)return L.splice(U,1),$}e.remove=g;function b(L,$,U){const Q=L.slice(0,$),N=L.slice($);return Q.concat(U,N)}e.arrayInsert=b;function C(L,$){let U;if(typeof $=="number"){let Q=$;U=()=>{const N=Math.sin(Q++)*179426549;return N-Math.floor(N)}}else U=Math.random;for(let Q=L.length-1;Q>0;Q-=1){const N=Math.floor(U()*(Q+1)),Z=L[Q];L[Q]=L[N],L[N]=Z}}e.shuffle=C;function F(L,$){const U=L.indexOf($);U>-1&&(L.splice(U,1),L.unshift($))}e.pushToStart=F;function x(L,$){const U=L.indexOf($);U>-1&&(L.splice(U,1),L.push($))}e.pushToEnd=x;function le(L,$){return Array.isArray(L)?L.map($):$(L)}e.mapArrayOrNot=le;function B(L){return Array.isArray(L)?L:[L]}e.asArray=B;function H(L){return L[Math.floor(Math.random()*L.length)]}e.getRandomElement=H;function G(L,$){for(const U of L){const Q=$(U);if(Q!==void 0)return Q}}e.mapFind=G}),define(we[52],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(D){const T=this;let P=!1,S;return function(){return P||(P=!0,S=D.apply(T,arguments)),S}}e.once=w}),define(we[53],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(T){this._prefix=T,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(we[54],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(D){function T(o){return o&&typeof o=="object"&&typeof o[Symbol.iterator]=="function"}D.is=T;const P=Object.freeze([]);function S(){return P}D.empty=S;function*I(o){yield o}D.single=I;function y(o){return o||P}D.from=y;function n(o){return!o||o[Symbol.iterator]().next().done===!0}D.isEmpty=n;function A(o){return o[Symbol.iterator]().next().value}D.first=A;function k(o,t){for(const i of o)if(t(i))return!0;return!1}D.some=k;function _(o,t){for(const i of o)if(t(i))return i}D.find=_;function*f(o,t){for(const i of o)t(i)&&(yield i)}D.filter=f;function*r(o,t){for(const i of o)yield t(i)}D.map=r;function*h(...o){for(const t of o)for(const i of t)yield i}D.concat=h;function*p(o){for(const t of o)for(const i of t)yield i}D.concatNested=p;function m(o,t,i){let u=i;for(const l of o)u=t(u,l);return u}D.reduce=m;function*v(o,t,i=o.length){for(t<0&&(t+=o.length),i<0?i+=o.length:i>o.length&&(i=o.length);t<i;t++)yield o[t]}D.slice=v;function d(o,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,o];const u=o[Symbol.iterator]();for(let l=0;l<t;l++){const s=u.next();if(s.done)return[i,D.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return u}}]}D.consume=d;function c(o,t,i=(u,l)=>u===l){const u=o[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const s=u.next(),a=l.next();if(s.done!==a.done)return!1;if(s.done)return!0;if(!i(s.value,a.value))return!1}}D.equals=c})(w=e.Iterable||(e.Iterable={}))}),define(we[45],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var D;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P=e.ParseOptions||(e.ParseOptions={}));function S(t,i=!1){let u=0,l=t.length,s="",a=0,E=16,R=0;function g(H){let G=0,L=0;for(;G<H;){const $=t.charCodeAt(u);if($>=48&&$<=57)L=L*16+$-48;else if($>=65&&$<=70)L=L*16+$-65+10;else if($>=97&&$<=102)L=L*16+$-97+10;else break;u++,G++}return G<H&&(L=-1),L}function b(H){u=H,s="",a=0,E=16,R=0}function C(){const H=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&n(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&n(t.charCodeAt(u)))for(u++;u<t.length&&n(t.charCodeAt(u));)u++;else return R=3,t.substring(H,u);let G=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&n(t.charCodeAt(u))){for(u++;u<t.length&&n(t.charCodeAt(u));)u++;G=u}else R=3;return t.substring(H,G)}function F(){let H="",G=u;for(;;){if(u>=l){H+=t.substring(G,u),R=2;break}const L=t.charCodeAt(u);if(L===34){H+=t.substring(G,u),u++;break}if(L===92){if(H+=t.substring(G,u),u++,u>=l){R=2;break}switch(t.charCodeAt(u++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const U=g(4);U>=0?H+=String.fromCharCode(U):R=4;break;default:R=5}G=u;continue}if(L>=0&&L<=31)if(y(L)){H+=t.substring(G,u),R=2;break}else R=6;u++}return H}function x(){if(s="",R=0,a=u,u>=l)return a=l,E=17;let H=t.charCodeAt(u);if(I(H)){do u++,s+=String.fromCharCode(H),H=t.charCodeAt(u);while(I(H));return E=15}if(y(H))return u++,s+=String.fromCharCode(H),H===13&&t.charCodeAt(u)===10&&(u++,s+=`
`),E=14;switch(H){case 123:return u++,E=1;case 125:return u++,E=2;case 91:return u++,E=3;case 93:return u++,E=4;case 58:return u++,E=6;case 44:return u++,E=5;case 34:return u++,s=F(),E=10;case 47:const G=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<l&&!y(t.charCodeAt(u));)u++;return s=t.substring(G,u),E=12}if(t.charCodeAt(u+1)===42){u+=2;const L=l-1;let $=!1;for(;u<L;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,$=!0;break}u++}return $||(u++,R=1),s=t.substring(G,u),E=13}return s+=String.fromCharCode(H),u++,E=16;case 45:if(s+=String.fromCharCode(H),u++,u===l||!n(t.charCodeAt(u)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=C(),E=11;default:for(;u<l&&le(H);)u++,H=t.charCodeAt(u);if(a!==u){switch(s=t.substring(a,u),s){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return s+=String.fromCharCode(H),u++,E=16}}function le(H){if(I(H)||y(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let H;do H=x();while(H>=12&&H<=15);return H}return{setPosition:b,getPosition:()=>u,scan:i?B:x,getToken:()=>E,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>u-a,getTokenError:()=>R}}e.createScanner=S;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function n(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function k(t,i){const u=[],l=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function R(g,b,C,F){a.value=g,a.offset=b,a.length=C,a.type=F,a.colonOffset=void 0,s=a}try{d(t,{onObjectBegin:(g,b)=>{if(i<=g)throw l;s=void 0,E=i>g,u.push("")},onObjectProperty:(g,b,C)=>{if(i<b||(R(g,b,C,"property"),u[u.length-1]=g,i<=b+C))throw l},onObjectEnd:(g,b)=>{if(i<=g)throw l;s=void 0,u.pop()},onArrayBegin:(g,b)=>{if(i<=g)throw l;s=void 0,u.push(0)},onArrayEnd:(g,b)=>{if(i<=g)throw l;s=void 0,u.pop()},onLiteralValue:(g,b,C)=>{if(i<b||(R(g,b,C,o(g)),i<=b+C))throw l},onSeparator:(g,b,C)=>{if(i<=b)throw l;if(g===":"&&s&&s.type==="property")s.colonOffset=b,E=!1,s=void 0;else if(g===","){const F=u[u.length-1];typeof F=="number"?u[u.length-1]=F+1:(E=!0,u[u.length-1]=""),s=void 0}}})}catch(g){if(g!==l)throw g}return{path:u,previousNode:s,isAtPropertyKey:E,matches:g=>{let b=0;for(let C=0;b<g.length&&C<u.length;C++)if(g[b]===u[C]||g[b]==="*")b++;else if(g[b]!=="**")return!1;return b===g.length}}}e.getLocation=k;function _(t,i=[],u=P.DEFAULT){let l=null,s=[];const a=[];function E(g){Array.isArray(s)?s.push(g):l!==null&&(s[l]=g)}return d(t,{onObjectBegin:()=>{const g={};E(g),a.push(s),s=g,l=null},onObjectProperty:g=>{l=g},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const g=[];E(g),a.push(s),s=g,l=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:E,onError:(g,b,C)=>{i.push({error:g,offset:b,length:C})}},u),s[0]}e.parse=_;function f(t,i=[],u=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(g){l.type==="property"&&(l.length=g-l.offset,l=l.parent)}function a(g){return l.children.push(g),g}d(t,{onObjectBegin:g=>{l=a({type:"object",offset:g,length:-1,parent:l,children:[]})},onObjectProperty:(g,b,C)=>{l=a({type:"property",offset:b,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:g,offset:b,length:C,parent:l})},onObjectEnd:(g,b)=>{l.length=g+b-l.offset,l=l.parent,s(g+b)},onArrayBegin:(g,b)=>{l=a({type:"array",offset:g,length:-1,parent:l,children:[]})},onArrayEnd:(g,b)=>{l.length=g+b-l.offset,l=l.parent,s(g+b)},onLiteralValue:(g,b,C)=>{a({type:o(g),offset:b,length:C,parent:l,value:g}),s(b+C)},onSeparator:(g,b,C)=>{l.type==="property"&&(g===":"?l.colonOffset=b:g===","&&s(b))},onError:(g,b,C)=>{i.push({error:g,offset:b,length:C})}},u);const R=l.children[0];return R&&delete R.parent,R}e.parseTree=f;function r(t,i){if(!!t){let u=t;for(let l of i)if(typeof l=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let s=!1;for(const a of u.children)if(Array.isArray(a.children)&&a.children[0].value===l){u=a.children[1],s=!0;break}if(!s)return}else{const s=l;if(u.type!=="array"||s<0||!Array.isArray(u.children)||s>=u.children.length)return;u=u.children[s]}return u}}e.findNodeAtLocation=r;function h(t){if(!t.parent||!t.parent.children)return[];const i=h(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;i.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&i.push(u)}return i}e.getNodePath=h;function p(t){switch(t.type){case"array":return t.children.map(p);case"object":const i=Object.create(null);for(let u of t.children){const l=u.children[1];l&&(i[u.children[0].value]=p(l))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=p;function m(t,i,u=!1){return i>=t.offset&&i<t.offset+t.length||u&&i===t.offset+t.length}e.contains=m;function v(t,i,u=!1){if(m(t,i,u)){const l=t.children;if(Array.isArray(l))for(let s=0;s<l.length&&l[s].offset<=i;s++){const a=v(l[s],i,u);if(a)return a}return t}}e.findNodeAtOffset=v;function d(t,i,u=P.DEFAULT){const l=S(t,!1);function s(ye){return ye?()=>ye(l.getTokenOffset(),l.getTokenLength()):()=>!0}function a(ye){return ye?Ae=>ye(Ae,l.getTokenOffset(),l.getTokenLength()):()=>!0}const E=s(i.onObjectBegin),R=a(i.onObjectProperty),g=s(i.onObjectEnd),b=s(i.onArrayBegin),C=s(i.onArrayEnd),F=a(i.onLiteralValue),x=a(i.onSeparator),le=s(i.onComment),B=a(i.onError),H=u&&u.disallowComments,G=u&&u.allowTrailingComma;function L(){for(;;){const ye=l.scan();switch(l.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:H||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(ye){case 12:case 13:H?$(10):le();break;case 16:$(1);break;case 15:case 14:break;default:return ye}}}function $(ye,Ae=[],Be=[]){if(B(ye),Ae.length+Be.length>0){let Re=l.getToken();for(;Re!==17;){if(Ae.indexOf(Re)!==-1){L();break}else if(Be.indexOf(Re)!==-1)break;Re=L()}}}function U(ye){const Ae=l.getTokenValue();return ye?F(Ae):R(Ae),L(),!0}function Q(){switch(l.getToken()){case 11:let ye=0;try{ye=JSON.parse(l.getTokenValue()),typeof ye!="number"&&($(2),ye=0)}catch(Ae){$(2)}F(ye);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return L(),!0}function N(){return l.getToken()!==10?($(3,[],[2,5]),!1):(U(!1),l.getToken()===6?(x(":"),L(),re()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function Z(){E(),L();let ye=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(ye||$(4,[],[]),x(","),L(),l.getToken()===2&&G)break}else ye&&$(6,[],[]);N()||$(4,[],[2,5]),ye=!0}return g(),l.getToken()!==2?$(7,[2],[]):L(),!0}function ne(){b(),L();let ye=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(ye||$(4,[],[]),x(","),L(),l.getToken()===4&&G)break}else ye&&$(6,[],[]);re()||$(4,[],[4,5]),ye=!0}return C(),l.getToken()!==4?$(8,[4],[]):L(),!0}function re(){switch(l.getToken()){case 3:return ne();case 1:return Z();case 10:return U(!0);default:return Q()}}return L(),l.getToken()===17?u.allowEmptyContent?!0:($(4,[],[]),!1):re()?(l.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=d;function c(t,i){let u=S(t),l=[],s,a=0,E;do switch(E=u.getPosition(),s=u.scan(),s){case 12:case 13:case 17:a!==E&&l.push(t.substring(a,E)),i!==void 0&&l.push(u.getTokenValue().replace(/[^\r\n]/g,i)),a=u.getPosition();break}while(s!==17);return l.join("")}e.stripComments=c;function o(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=o}),define(we[103],Ee([0,1,45]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(y,n,A){let k,_,f,r,h;if(n){for(r=n.offset,h=r+n.length,f=r;f>0&&!I(y,f-1);)f--;let a=h;for(;a<y.length&&!I(y,a);)a++;_=y.substring(f,a),k=P(_,A)}else _=y,k=0,f=0,r=0,h=y.length;const p=S(A,y);let m=!1,v=0,d;A.insertSpaces?d=T(" ",A.tabSize||4):d="	";const c=(0,w.createScanner)(_,!1);let o=!1;function t(){return p+T(d,k+v)}function i(){let a=c.scan();for(m=!1;a===15||a===14;)m=m||a===14,a=c.scan();return o=a===16||c.getTokenError()!==0,a}const u=[];function l(a,E,R){!o&&E<h&&R>r&&y.substring(E,R)!==a&&u.push({offset:E,length:R-E,content:a})}let s=i();if(s!==17){const a=c.getTokenOffset()+f,E=T(d,k);l(E,f,a)}for(;s!==17;){let a=c.getTokenOffset()+c.getTokenLength()+f,E=i(),R="";for(;!m&&(E===12||E===13);){const b=c.getTokenOffset()+f;l(" ",a,b),a=c.getTokenOffset()+c.getTokenLength()+f,R=E===12?t():"",E=i()}if(E===2)s!==1&&(v--,R=t());else if(E===4)s!==3&&(v--,R=t());else{switch(s){case 3:case 1:v++,R=t();break;case 5:case 12:R=t();break;case 13:m?R=t():R=" ";break;case 6:R=" ";break;case 10:if(E===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?R=" ":E!==5&&E!==17&&(o=!0);break;case 16:o=!0;break}m&&(E===12||E===13)&&(R=t())}const g=c.getTokenOffset()+f;l(R,a,g),s=E}return u}e.format=D;function T(y,n){let A="";for(let k=0;k<n;k++)A+=y;return A}function P(y,n){let A=0,k=0;const _=n.tabSize||4;for(;A<y.length;){const f=y.charAt(A);if(f===" ")k++;else if(f==="	")k+=_;else break;A++}return Math.floor(k/_)}function S(y,n){for(let A=0;A<n.length;A++){const k=n.charAt(A);if(k==="\r")return A+1<n.length&&n.charAt(A+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=S;function I(y,n){return`\r
`.indexOf(y.charAt(n))!==-1}e.isEOL=I}),define(we[104],Ee([0,1,45,103]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function T(n,A,k){return P(n,A,void 0,k)}e.removeProperty=T;function P(n,A,k,_,f){const r=A.slice(),h=[],p=(0,w.parseTree)(n,h);let m,v;for(;r.length>0&&(v=r.pop(),m=(0,w.findNodeAtLocation)(p,r),m===void 0&&k!==void 0);)typeof v=="string"?k={[v]:k}:k=[k];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const d=(0,w.findNodeAtLocation)(m,[v]);if(d!==void 0)if(k===void 0){if(!d.parent)throw new Error("Malformed AST");const c=m.children.indexOf(d.parent);let o,t=d.parent.offset+d.parent.length;if(c>0){const i=m.children[c-1];o=i.offset+i.length}else o=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return S(n,{offset:o,length:t-o,content:""},_)}else return S(n,{offset:d.offset,length:d.length,content:JSON.stringify(k)},_);else{if(k===void 0)return[];const c=`${JSON.stringify(v)}: ${JSON.stringify(k)}`,o=f?f(m.children.map(i=>i.children[0].value)):m.children.length;let t;if(o>0){const i=m.children[o-1];t={offset:i.offset+i.length,length:0,content:","+c}}else m.children.length===0?t={offset:m.offset+1,length:0,content:c}:t={offset:m.offset+1,length:0,content:c+","};return S(n,t,_)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(k!==void 0){const d=`${JSON.stringify(k)}`;let c;if(m.children.length===0||v===0)c={offset:m.offset+1,length:0,content:m.children.length===0?d:d+","};else{const o=v===-1||v>m.children.length?m.children.length:v,t=m.children[o-1];c={offset:t.offset+t.length,length:0,content:","+d}}return S(n,c,_)}else{const d=v,c=m.children[d];let o;if(m.children.length===1)o={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===d){const t=m.children[d-1],i=t.offset+t.length,u=m.offset+m.length;o={offset:i,length:u-2-i,content:""}}else o={offset:c.offset,length:m.children[d+1].offset-c.offset,content:""};return S(n,o,_)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return S(n,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(k)},_)}}e.setProperty=P;function S(n,A,k){let _=I(n,A),f=A.offset,r=A.offset+A.content.length;if(A.length===0||A.content.length===0){for(;f>0&&!(0,D.isEOL)(_,f-1);)f--;for(;r<_.length&&!(0,D.isEOL)(_,r);)r++}const h=(0,D.format)(_,{offset:f,length:r-f},k);for(let m=h.length-1;m>=0;m--){const v=h[m];_=I(_,v),f=Math.min(f,v.offset),r=Math.max(r,v.offset+v.length),r+=v.content.length-v.length}const p=n.length-(_.length-r)-f;return[{offset:f,length:p,content:_.substring(f,r)}]}e.withFormatting=S;function I(n,A){return n.substring(0,A.offset)+A.content+n.substring(A.offset+A.length)}e.applyEdit=I;function y(n,A){let k=A.slice(0).sort((f,r)=>{const h=f.offset-r.offset;return h===0?f.length-r.length:h}),_=n.length;for(let f=k.length-1;f>=0;f--){let r=k[f];if(r.offset+r.length<=_)n=I(n,r);else throw new Error("Overlapping edit");_=r.offset}return n}e.applyEdits=y}),define(we[105],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(T){this.executor=T,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(T){this._error=T}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(T){return new w(()=>T(this.getValue()))}}e.Lazy=w}),define(we[6],Ee([0,1,52,54]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const T=!1;let P=null;function S(d){P=d}if(e.setDisposableTracker=S,T){const d="__is_disposable_tracked__";P=new class{trackDisposable(c){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[d]||console.log(o)},3e3)}markTracked(c){if(c&&c!==h.None)try{c[d]=!0}catch(o){}}}}function I(d){!P||P.markTracked(d)}function y(d){return P&&P.trackDisposable(d),d}e.trackDisposable=y;class n extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=n;function A(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=A;function k(d){if(D.Iterable.is(d)){let c=[];for(const o of d)if(o){I(o);try{o.dispose()}catch(t){c.push(t)}}if(c.length===1)throw c[0];if(c.length>1)throw new n(c);return Array.isArray(d)?[]:d}else if(d)return I(d),d.dispose(),d}e.dispose=k;function _(...d){return d.forEach(I),f(()=>k(d))}e.combinedDisposable=_;function f(d){const c=y({dispose:()=>{I(c),d()}});return c}e.toDisposable=f;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(I(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return I(c),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new r,y(this)}dispose(){I(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class p{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){var o;this._isDisposed||c===this._value||((o=this._value)===null||o===void 0||o.dispose(),c&&I(c),this._value=c)}clear(){this.value=void 0}dispose(){var c;this._isDisposed=!0,I(this),(c=this._value)===null||c===void 0||c.dispose(),this._value=void 0}}e.MutableDisposable=p;class m{constructor(){this.references=new Map}acquire(c,...o){let t=this.references.get(c);t||(t={counter:0,object:this.createReferencedObject(c,...o)},this.references.set(c,t));const{object:i}=t,u=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(c,t.object),this.references.delete(c))});return t.counter++,{object:i,dispose:u}}}e.ReferenceCollection=m;class v{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=v}),define(we[46],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(P){this.element=P,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class D{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(P){return this._insert(P,!1)}push(P){return this._insert(P,!0)}_insert(P,S){const I=new w(P);if(this._first===w.Undefined)this._first=I,this._last=I;else if(S){const n=this._last;this._last=I,I.prev=n,n.next=I}else{const n=this._first;this._first=I,I.next=n,n.prev=I}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(I))}}shift(){if(this._first!==w.Undefined){const P=this._first.element;return this._remove(this._first),P}}pop(){if(this._last!==w.Undefined){const P=this._last.element;return this._remove(this._last),P}}_remove(P){if(P.prev!==w.Undefined&&P.next!==w.Undefined){const S=P.prev;S.next=P.next,P.next.prev=S}else P.prev===w.Undefined&&P.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):P.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):P.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let P=this._first;for(;P!==w.Undefined;)yield P.element,P=P.next}}e.LinkedList=D}),function(oe,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(oe=typeof globalThis!="undefined"?globalThis:oe||self,oe.marked=e())}(this,function(){"use strict";function oe(z,ie){for(var ce=0;ce<ie.length;ce++){var j=ie[ce];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(z,j.key,j)}}function e(z,ie,ce){return ie&&oe(z.prototype,ie),ce&&oe(z,ce),z}function w(z,ie){if(!!z){if(typeof z=="string")return D(z,ie);var ce=Object.prototype.toString.call(z).slice(8,-1);if(ce==="Object"&&z.constructor&&(ce=z.constructor.name),ce==="Map"||ce==="Set")return Array.from(z);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return D(z,ie)}}function D(z,ie){(ie==null||ie>z.length)&&(ie=z.length);for(var ce=0,j=new Array(ie);ce<ie;ce++)j[ce]=z[ce];return j}function T(z,ie){var ce;if(typeof Symbol=="undefined"||z[Symbol.iterator]==null){if(Array.isArray(z)||(ce=w(z))||ie&&z&&typeof z.length=="number"){ce&&(z=ce);var j=0;return function(){return j>=z.length?{done:!0}:{done:!1,value:z[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=z[Symbol.iterator](),ce.next.bind(ce)}function P(z){var ie={exports:{}};return z(ie,ie.exports),ie.exports}var S=P(function(z){function ie(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(j){z.exports.defaults=j}z.exports={defaults:ie(),getDefaults:ie,changeDefaults:ce}}),I=/[&<>"']/,y=/[&<>"']/g,n=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(ie){return k[ie]};function f(z,ie){if(ie){if(I.test(z))return z.replace(y,_)}else if(n.test(z))return z.replace(A,_);return z}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(z){return z.replace(r,function(ie,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var p=/(^|[^\[])\^/g;function m(z,ie){z=z.source||z,ie=ie||"";var ce={replace:function(Y,se){return se=se.source||se,se=se.replace(p,"$1"),z=z.replace(Y,se),ce},getRegex:function(){return new RegExp(z,ie)}};return ce}var v=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(z,ie,ce){if(z){var j;try{j=decodeURIComponent(h(ce)).replace(v,"").toLowerCase()}catch(Y){return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}ie&&!d.test(ce)&&(ce=l(ie,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(Y){return null}return ce}var o={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(z,ie){o[" "+z]||(t.test(z)?o[" "+z]=z+"/":o[" "+z]=R(z,"/",!0)),z=o[" "+z];var ce=z.indexOf(":")===-1;return ie.substring(0,2)==="//"?ce?ie:z.replace(i,"$1")+ie:ie.charAt(0)==="/"?ce?ie:z.replace(u,"$1")+ie:z+ie}var s={exec:function(){}};function a(z){for(var ie=1,ce,j;ie<arguments.length;ie++){ce=arguments[ie];for(j in ce)Object.prototype.hasOwnProperty.call(ce,j)&&(z[j]=ce[j])}return z}function E(z,ie){var ce=z.replace(/\|/g,function(se,fe,ve){for(var $e=!1,Ne=fe;--Ne>=0&&ve[Ne]==="\\";)$e=!$e;return $e?"|":" |"}),j=ce.split(/ \|/),Y=0;if(j.length>ie)j.splice(ie);else for(;j.length<ie;)j.push("");for(;Y<j.length;Y++)j[Y]=j[Y].trim().replace(/\\\|/g,"|");return j}function R(z,ie,ce){var j=z.length;if(j===0)return"";for(var Y=0;Y<j;){var se=z.charAt(j-Y-1);if(se===ie&&!ce)Y++;else if(se!==ie&&ce)Y++;else break}return z.substr(0,j-Y)}function g(z,ie){if(z.indexOf(ie[1])===-1)return-1;for(var ce=z.length,j=0,Y=0;Y<ce;Y++)if(z[Y]==="\\")Y++;else if(z[Y]===ie[0])j++;else if(z[Y]===ie[1]&&(j--,j<0))return Y;return-1}function b(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(z,ie){if(ie<1)return"";for(var ce="";ie>1;)ie&1&&(ce+=z),ie>>=1,z+=z;return ce+z}var F={escape:f,unescape:h,edit:m,cleanUrl:c,resolveUrl:l,noopTest:s,merge:a,splitCells:E,rtrim:R,findClosingBracket:g,checkSanitizeDeprecation:b,repeatString:C},x=S.defaults,le=F.rtrim,B=F.splitCells,H=F.escape,G=F.findClosingBracket;function L(z,ie,ce){var j=ie.href,Y=ie.title?H(ie.title):null,se=z[1].replace(/\\([\[\]])/g,"$1");return z[0].charAt(0)!=="!"?{type:"link",raw:ce,href:j,title:Y,text:se}:{type:"image",raw:ce,href:j,title:Y,text:H(se)}}function $(z,ie){var ce=z.match(/^(\s+)(?:```)/);if(ce===null)return ie;var j=ce[1];return ie.split(`
`).map(function(Y){var se=Y.match(/^\s+/);if(se===null)return Y;var fe=se[0];return fe.length>=j.length?Y.slice(j.length):Y}).join(`
`)}var U=function(){function z(ce){this.options=ce||x}var ie=z.prototype;return ie.space=function(j){var Y=this.rules.block.newline.exec(j);if(Y)return Y[0].length>1?{type:"space",raw:Y[0]}:{raw:`
`}},ie.code=function(j){var Y=this.rules.block.code.exec(j);if(Y){var se=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?se:le(se,`
`)}}},ie.fences=function(j){var Y=this.rules.block.fences.exec(j);if(Y){var se=Y[0],fe=$(se,Y[3]||"");return{type:"code",raw:se,lang:Y[2]?Y[2].trim():Y[2],text:fe}}},ie.heading=function(j){var Y=this.rules.block.heading.exec(j);if(Y){var se=Y[2].trim();if(/#$/.test(se)){var fe=le(se,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(se=fe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:se}}},ie.nptable=function(j){var Y=this.rules.block.nptable.exec(j);if(Y){var se={type:"table",header:B(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[],raw:Y[0]};if(se.header.length===se.align.length){var fe=se.align.length,ve;for(ve=0;ve<fe;ve++)/^ *-+: *$/.test(se.align[ve])?se.align[ve]="right":/^ *:-+: *$/.test(se.align[ve])?se.align[ve]="center":/^ *:-+ *$/.test(se.align[ve])?se.align[ve]="left":se.align[ve]=null;for(fe=se.cells.length,ve=0;ve<fe;ve++)se.cells[ve]=B(se.cells[ve],se.header.length);return se}}},ie.hr=function(j){var Y=this.rules.block.hr.exec(j);if(Y)return{type:"hr",raw:Y[0]}},ie.blockquote=function(j){var Y=this.rules.block.blockquote.exec(j);if(Y){var se=Y[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Y[0],text:se}}},ie.list=function(j){var Y=this.rules.block.list.exec(j);if(Y){var se=Y[0],fe=Y[2],ve=fe.length>1,$e={type:"list",raw:se,ordered:ve,start:ve?+fe.slice(0,-1):"",loose:!1,items:[]},Ne=Y[0].match(this.rules.block.item),Ve=!1,Qe,Ze,ct,st,me,he,ue,q,Ie=Ne.length;ct=this.rules.block.listItemStart.exec(Ne[0]);for(var Pe=0;Pe<Ie;Pe++){if(Qe=Ne[Pe],se=Qe,Pe!==Ie-1){if(st=this.rules.block.listItemStart.exec(Ne[Pe+1]),this.options.pedantic?st[1].length>ct[1].length:st[1].length>ct[0].length||st[1].length>3){Ne.splice(Pe,2,Ne[Pe]+`
`+Ne[Pe+1]),Pe--,Ie--;continue}else(!this.options.pedantic||this.options.smartLists?st[2][st[2].length-1]!==fe[fe.length-1]:ve===(st[2].length===1))&&(me=Ne.slice(Pe+1).join(`
`),$e.raw=$e.raw.substring(0,$e.raw.length-me.length),Pe=Ie-1);ct=st}Ze=Qe.length,Qe=Qe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Qe.indexOf(`
 `)&&(Ze-=Qe.length,Qe=this.options.pedantic?Qe.replace(/^ {1,4}/gm,""):Qe.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),he=Ve||/\n\n(?!\s*$)/.test(Qe),Pe!==Ie-1&&(Ve=Qe.charAt(Qe.length-1)===`
`,he||(he=Ve)),he&&($e.loose=!0),this.options.gfm&&(ue=/^\[[ xX]\] /.test(Qe),q=void 0,ue&&(q=Qe[1]!==" ",Qe=Qe.replace(/^\[[ xX]\] +/,""))),$e.items.push({type:"list_item",raw:se,task:ue,checked:q,loose:he,text:Qe})}return $e}},ie.html=function(j){var Y=this.rules.block.html.exec(j);if(Y)return{type:this.options.sanitize?"paragraph":"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):H(Y[0]):Y[0]}},ie.def=function(j){var Y=this.rules.block.def.exec(j);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var se=Y[1].toLowerCase().replace(/\s+/g," ");return{tag:se,raw:Y[0],href:Y[2],title:Y[3]}}},ie.table=function(j){var Y=this.rules.block.table.exec(j);if(Y){var se={type:"table",header:B(Y[1].replace(/^ *| *\| *$/g,"")),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Y[3]?Y[3].replace(/\n$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=Y[0];var fe=se.align.length,ve;for(ve=0;ve<fe;ve++)/^ *-+: *$/.test(se.align[ve])?se.align[ve]="right":/^ *:-+: *$/.test(se.align[ve])?se.align[ve]="center":/^ *:-+ *$/.test(se.align[ve])?se.align[ve]="left":se.align[ve]=null;for(fe=se.cells.length,ve=0;ve<fe;ve++)se.cells[ve]=B(se.cells[ve].replace(/^ *\| *| *\| *$/g,""),se.header.length);return se}}},ie.lheading=function(j){var Y=this.rules.block.lheading.exec(j);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1]}},ie.paragraph=function(j){var Y=this.rules.block.paragraph.exec(j);if(Y)return{type:"paragraph",raw:Y[0],text:Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1]}},ie.text=function(j){var Y=this.rules.block.text.exec(j);if(Y)return{type:"text",raw:Y[0],text:Y[0]}},ie.escape=function(j){var Y=this.rules.inline.escape.exec(j);if(Y)return{type:"escape",raw:Y[0],text:H(Y[1])}},ie.tag=function(j,Y,se){var fe=this.rules.inline.tag.exec(j);if(fe)return!Y&&/^<a /i.test(fe[0])?Y=!0:Y&&/^<\/a>/i.test(fe[0])&&(Y=!1),!se&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?se=!0:se&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(se=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:Y,inRawBlock:se,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):H(fe[0]):fe[0]}},ie.link=function(j){var Y=this.rules.inline.link.exec(j);if(Y){var se=Y[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var fe=le(se.slice(0,-1),"\\");if((se.length-fe.length)%2==0)return}else{var ve=G(Y[2],"()");if(ve>-1){var $e=Y[0].indexOf("!")===0?5:4,Ne=$e+Y[1].length+ve;Y[2]=Y[2].substring(0,ve),Y[0]=Y[0].substring(0,Ne).trim(),Y[3]=""}}var Ve=Y[2],Qe="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);Ze&&(Ve=Ze[1],Qe=Ze[3])}else Qe=Y[3]?Y[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(se)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),L(Y,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:Qe&&Qe.replace(this.rules.inline._escapes,"$1")},Y[0])}},ie.reflink=function(j,Y){var se;if((se=this.rules.inline.reflink.exec(j))||(se=this.rules.inline.nolink.exec(j))){var fe=(se[2]||se[1]).replace(/\s+/g," ");if(fe=Y[fe.toLowerCase()],!fe||!fe.href){var ve=se[0].charAt(0);return{type:"text",raw:ve,text:ve}}return L(se,fe,se[0])}},ie.emStrong=function(j,Y,se){se===void 0&&(se="");var fe=this.rules.inline.emStrong.lDelim.exec(j);if(!!fe&&!(fe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ve=fe[1]||fe[2]||"";if(!ve||ve&&(se===""||this.rules.inline.punctuation.exec(se))){var $e=fe[0].length-1,Ne,Ve,Qe=$e,Ze=0,ct=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ct.lastIndex=0,Y=Y.slice(-1*j.length+$e);(fe=ct.exec(Y))!=null;)if(Ne=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ne){if(Ve=Ne.length,fe[3]||fe[4]){Qe+=Ve;continue}else if((fe[5]||fe[6])&&$e%3&&!(($e+Ve)%3)){Ze+=Ve;continue}if(Qe-=Ve,!(Qe>0)){if(Qe+Ze-Ve<=0&&!Y.slice(ct.lastIndex).match(ct)&&(Ve=Math.min(Ve,Ve+Qe+Ze)),Math.min($e,Ve)%2)return{type:"em",raw:j.slice(0,$e+fe.index+Ve+1),text:j.slice(1,$e+fe.index+Ve)};if(Math.min($e,Ve)%2==0)return{type:"strong",raw:j.slice(0,$e+fe.index+Ve+1),text:j.slice(2,$e+fe.index+Ve-1)}}}}}},ie.codespan=function(j){var Y=this.rules.inline.code.exec(j);if(Y){var se=Y[2].replace(/\n/g," "),fe=/[^ ]/.test(se),ve=/^ /.test(se)&&/ $/.test(se);return fe&&ve&&(se=se.substring(1,se.length-1)),se=H(se,!0),{type:"codespan",raw:Y[0],text:se}}},ie.br=function(j){var Y=this.rules.inline.br.exec(j);if(Y)return{type:"br",raw:Y[0]}},ie.del=function(j){var Y=this.rules.inline.del.exec(j);if(Y)return{type:"del",raw:Y[0],text:Y[2]}},ie.autolink=function(j,Y){var se=this.rules.inline.autolink.exec(j);if(se){var fe,ve;return se[2]==="@"?(fe=H(this.options.mangle?Y(se[1]):se[1]),ve="mailto:"+fe):(fe=H(se[1]),ve=fe),{type:"link",raw:se[0],text:fe,href:ve,tokens:[{type:"text",raw:fe,text:fe}]}}},ie.url=function(j,Y){var se;if(se=this.rules.inline.url.exec(j)){var fe,ve;if(se[2]==="@")fe=H(this.options.mangle?Y(se[0]):se[0]),ve="mailto:"+fe;else{var $e;do $e=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while($e!==se[0]);fe=H(se[0]),se[1]==="www."?ve="http://"+fe:ve=fe}return{type:"link",raw:se[0],text:fe,href:ve,tokens:[{type:"text",raw:fe,text:fe}]}}},ie.inlineText=function(j,Y,se){var fe=this.rules.inline.text.exec(j);if(fe){var ve;return Y?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):H(fe[0]):fe[0]:ve=H(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ve}}},z}(),Q=F.noopTest,N=F.edit,Z=F.merge,ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:Q,table:Q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=N(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,ne.item=N(ne.item,"gm").replace(/bull/g,ne.bullet).getRegex(),ne.listItemStart=N(/^( *)(bull)/).replace("bull",ne.bullet).getRegex(),ne.list=N(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=N(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=N(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=N(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=Z({},ne),ne.gfm=Z({},ne.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.nptable=N(ne.gfm.nptable).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.table=N(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=Z({},ne.normal,{html:N(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:Q,paragraph:N(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:Q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:Q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=N(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=N(ne._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=N(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=N(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=N(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=N(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=N(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=N(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=N(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=N(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=Z({},re),re.pedantic=Z({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:N(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:N(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=Z({},re.normal,{escape:N(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),re.gfm.url=N(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=Z({},re.gfm,{br:N(re.br).replace("{2,}","*").getRegex(),text:N(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ye={block:ne,inline:re},Ae=S.defaults,Be=ye.block,Re=ye.inline,xe=F.repeatString;function W(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(z){var ie="",ce,j,Y=z.length;for(ce=0;ce<Y;ce++)j=z.charCodeAt(ce),Math.random()>.5&&(j="x"+j.toString(16)),ie+="&#"+j+";";return ie}var J=function(){function z(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Ae,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var j={block:Be.normal,inline:Re.normal};this.options.pedantic?(j.block=Be.pedantic,j.inline=Re.pedantic):this.options.gfm&&(j.block=Be.gfm,this.options.breaks?j.inline=Re.breaks:j.inline=Re.gfm),this.tokenizer.rules=j}z.lex=function(j,Y){var se=new z(Y);return se.lex(j)},z.lexInline=function(j,Y){var se=new z(Y);return se.inlineTokens(j)};var ie=z.prototype;return ie.lex=function(j){return j=j.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(j,this.tokens,!0),this.inline(this.tokens),this.tokens},ie.blockTokens=function(j,Y,se){Y===void 0&&(Y=[]),se===void 0&&(se=!0),this.options.pedantic&&(j=j.replace(/^ +$/gm,""));for(var fe,ve,$e,Ne;j;){if(fe=this.tokenizer.space(j)){j=j.substring(fe.raw.length),fe.type&&Y.push(fe);continue}if(fe=this.tokenizer.code(j)){j=j.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="paragraph"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):Y.push(fe);continue}if(fe=this.tokenizer.fences(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.heading(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.nptable(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.hr(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.blockquote(j)){j=j.substring(fe.raw.length),fe.tokens=this.blockTokens(fe.text,[],se),Y.push(fe);continue}if(fe=this.tokenizer.list(j)){for(j=j.substring(fe.raw.length),$e=fe.items.length,ve=0;ve<$e;ve++)fe.items[ve].tokens=this.blockTokens(fe.items[ve].text,[],!1);Y.push(fe);continue}if(fe=this.tokenizer.html(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(se&&(fe=this.tokenizer.def(j))){j=j.substring(fe.raw.length),this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.lheading(j)){j=j.substring(fe.raw.length),Y.push(fe);continue}if(se&&(fe=this.tokenizer.paragraph(j))){j=j.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.text(j)){j=j.substring(fe.raw.length),Ne=Y[Y.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+fe.raw,Ne.text+=`
`+fe.text):Y.push(fe);continue}if(j){var Ve="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return Y},ie.inline=function(j){var Y,se,fe,ve,$e,Ne,Ve=j.length;for(Y=0;Y<Ve;Y++)switch(Ne=j[Y],Ne.type){case"paragraph":case"text":case"heading":{Ne.tokens=[],this.inlineTokens(Ne.text,Ne.tokens);break}case"table":{for(Ne.tokens={header:[],cells:[]},ve=Ne.header.length,se=0;se<ve;se++)Ne.tokens.header[se]=[],this.inlineTokens(Ne.header[se],Ne.tokens.header[se]);for(ve=Ne.cells.length,se=0;se<ve;se++)for($e=Ne.cells[se],Ne.tokens.cells[se]=[],fe=0;fe<$e.length;fe++)Ne.tokens.cells[se][fe]=[],this.inlineTokens($e[fe],Ne.tokens.cells[se][fe]);break}case"blockquote":{this.inline(Ne.tokens);break}case"list":{for(ve=Ne.items.length,se=0;se<ve;se++)this.inline(Ne.items[se].tokens);break}}return j},ie.inlineTokens=function(j,Y,se,fe){Y===void 0&&(Y=[]),se===void 0&&(se=!1),fe===void 0&&(fe=!1);var ve,$e,Ne=j,Ve,Qe,Ze;if(this.tokens.links){var ct=Object.keys(this.tokens.links);if(ct.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Ne))!=null;)ct.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Ne=Ne.slice(0,Ve.index)+"["+xe("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"["+xe("a",Ve[0].length-2)+"]"+Ne.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Ne))!=null;)Ne=Ne.slice(0,Ve.index)+"++"+Ne.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;){if(Qe||(Ze=""),Qe=!1,ve=this.tokenizer.escape(j)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.tag(j,se,fe)){j=j.substring(ve.raw.length),se=ve.inLink,fe=ve.inRawBlock;var st=Y[Y.length-1];st&&ve.type==="text"&&st.type==="text"?(st.raw+=ve.raw,st.text+=ve.text):Y.push(ve);continue}if(ve=this.tokenizer.link(j)){j=j.substring(ve.raw.length),ve.type==="link"&&(ve.tokens=this.inlineTokens(ve.text,[],!0,fe)),Y.push(ve);continue}if(ve=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(ve.raw.length);var me=Y[Y.length-1];ve.type==="link"?(ve.tokens=this.inlineTokens(ve.text,[],!0,fe),Y.push(ve)):me&&ve.type==="text"&&me.type==="text"?(me.raw+=ve.raw,me.text+=ve.text):Y.push(ve);continue}if(ve=this.tokenizer.emStrong(j,Ne,Ze)){j=j.substring(ve.raw.length),ve.tokens=this.inlineTokens(ve.text,[],se,fe),Y.push(ve);continue}if(ve=this.tokenizer.codespan(j)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.br(j)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.del(j)){j=j.substring(ve.raw.length),ve.tokens=this.inlineTokens(ve.text,[],se,fe),Y.push(ve);continue}if(ve=this.tokenizer.autolink(j,K)){j=j.substring(ve.raw.length),Y.push(ve);continue}if(!se&&(ve=this.tokenizer.url(j,K))){j=j.substring(ve.raw.length),Y.push(ve);continue}if(ve=this.tokenizer.inlineText(j,fe,W)){j=j.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(Ze=ve.raw.slice(-1)),Qe=!0,$e=Y[Y.length-1],$e&&$e.type==="text"?($e.raw+=ve.raw,$e.text+=ve.text):Y.push(ve);continue}if(j){var he="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return Y},e(z,null,[{key:"rules",get:function(){return{block:Be,inline:Re}}}]),z}(),ae=S.defaults,ge=F.cleanUrl,De=F.escape,Le=function(){function z(ce){this.options=ce||ae}var ie=z.prototype;return ie.code=function(j,Y,se){var fe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var ve=this.options.highlight(j,fe);ve!=null&&ve!==j&&(se=!0,j=ve)}return j=j.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+De(fe,!0)+'">'+(se?j:De(j,!0))+`</code></pre>
`:"<pre><code>"+(se?j:De(j,!0))+`</code></pre>
`},ie.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},ie.html=function(j){return j},ie.heading=function(j,Y,se,fe){return this.options.headerIds?"<h"+Y+' id="'+this.options.headerPrefix+fe.slug(se)+'">'+j+"</h"+Y+`>
`:"<h"+Y+">"+j+"</h"+Y+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(j,Y,se){var fe=Y?"ol":"ul",ve=Y&&se!==1?' start="'+se+'"':"";return"<"+fe+ve+`>
`+j+"</"+fe+`>
`},ie.listitem=function(j){return"<li>"+j+`</li>
`},ie.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(j){return"<p>"+j+`</p>
`},ie.table=function(j,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+Y+`</table>
`},ie.tablerow=function(j){return`<tr>
`+j+`</tr>
`},ie.tablecell=function(j,Y){var se=Y.header?"th":"td",fe=Y.align?"<"+se+' align="'+Y.align+'">':"<"+se+">";return fe+j+"</"+se+`>
`},ie.strong=function(j){return"<strong>"+j+"</strong>"},ie.em=function(j){return"<em>"+j+"</em>"},ie.codespan=function(j){return"<code>"+j+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(j){return"<del>"+j+"</del>"},ie.link=function(j,Y,se){if(j=ge(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var fe='<a href="'+De(j)+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=">"+se+"</a>",fe},ie.image=function(j,Y,se){if(j=ge(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var fe='<img src="'+j+'" alt="'+se+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=this.options.xhtml?"/>":">",fe},ie.text=function(j){return j},z}(),pe=function(){function z(){}var ie=z.prototype;return ie.strong=function(j){return j},ie.em=function(j){return j},ie.codespan=function(j){return j},ie.del=function(j){return j},ie.html=function(j){return j},ie.text=function(j){return j},ie.link=function(j,Y,se){return""+se},ie.image=function(j,Y,se){return""+se},ie.br=function(){return""},z}(),Ce=function(){function z(){this.seen={}}var ie=z.prototype;return ie.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(j,Y){var se=j,fe=0;if(this.seen.hasOwnProperty(se)){fe=this.seen[j];do fe++,se=j+"-"+fe;while(this.seen.hasOwnProperty(se))}return Y||(this.seen[j]=fe,this.seen[se]=0),se},ie.slug=function(j,Y){Y===void 0&&(Y={});var se=this.serialize(j);return this.getNextSafeSlug(se,Y.dryrun)},z}(),Te=S.defaults,Ue=F.unescape,be=function(){function z(ce){this.options=ce||Te,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}z.parse=function(j,Y){var se=new z(Y);return se.parse(j)},z.parseInline=function(j,Y){var se=new z(Y);return se.parseInline(j)};var ie=z.prototype;return ie.parse=function(j,Y){Y===void 0&&(Y=!0);var se="",fe,ve,$e,Ne,Ve,Qe,Ze,ct,st,me,he,ue,q,Ie,Pe,et,Ge,rt,lt=j.length;for(fe=0;fe<lt;fe++)switch(me=j[fe],me.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(me.tokens),me.depth,Ue(this.parseInline(me.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(me.text,me.lang,me.escaped);continue}case"table":{for(ct="",Ze="",Ne=me.header.length,ve=0;ve<Ne;ve++)Ze+=this.renderer.tablecell(this.parseInline(me.tokens.header[ve]),{header:!0,align:me.align[ve]});for(ct+=this.renderer.tablerow(Ze),st="",Ne=me.cells.length,ve=0;ve<Ne;ve++){for(Qe=me.tokens.cells[ve],Ze="",Ve=Qe.length,$e=0;$e<Ve;$e++)Ze+=this.renderer.tablecell(this.parseInline(Qe[$e]),{header:!1,align:me.align[$e]});st+=this.renderer.tablerow(Ze)}se+=this.renderer.table(ct,st);continue}case"blockquote":{st=this.parse(me.tokens),se+=this.renderer.blockquote(st);continue}case"list":{for(he=me.ordered,ue=me.start,q=me.loose,Ne=me.items.length,st="",ve=0;ve<Ne;ve++)Pe=me.items[ve],et=Pe.checked,Ge=Pe.task,Ie="",Pe.task&&(rt=this.renderer.checkbox(et),q?Pe.tokens.length>0&&Pe.tokens[0].type==="text"?(Pe.tokens[0].text=rt+" "+Pe.tokens[0].text,Pe.tokens[0].tokens&&Pe.tokens[0].tokens.length>0&&Pe.tokens[0].tokens[0].type==="text"&&(Pe.tokens[0].tokens[0].text=rt+" "+Pe.tokens[0].tokens[0].text)):Pe.tokens.unshift({type:"text",text:rt}):Ie+=rt),Ie+=this.parse(Pe.tokens,q),st+=this.renderer.listitem(Ie,Ge,et);se+=this.renderer.list(st,he,ue);continue}case"html":{se+=this.renderer.html(me.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(me.tokens));continue}case"text":{for(st=me.tokens?this.parseInline(me.tokens):me.text;fe+1<lt&&j[fe+1].type==="text";)me=j[++fe],st+=`
`+(me.tokens?this.parseInline(me.tokens):me.text);se+=Y?this.renderer.paragraph(st):st;continue}default:{var Je='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}return se},ie.parseInline=function(j,Y){Y=Y||this.renderer;var se="",fe,ve,$e=j.length;for(fe=0;fe<$e;fe++)switch(ve=j[fe],ve.type){case"escape":{se+=Y.text(ve.text);break}case"html":{se+=Y.html(ve.text);break}case"link":{se+=Y.link(ve.href,ve.title,this.parseInline(ve.tokens,Y));break}case"image":{se+=Y.image(ve.href,ve.title,ve.text);break}case"strong":{se+=Y.strong(this.parseInline(ve.tokens,Y));break}case"em":{se+=Y.em(this.parseInline(ve.tokens,Y));break}case"codespan":{se+=Y.codespan(ve.text);break}case"br":{se+=Y.br();break}case"del":{se+=Y.del(this.parseInline(ve.tokens,Y));break}case"text":{se+=Y.text(ve.text);break}default:{var Ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}return se},z}(),Ke=F.merge,V=F.checkSanitizeDeprecation,X=F.escape,_e=S.getDefaults,Me=S.changeDefaults,He=S.defaults;function Oe(z,ie,ce){if(typeof z=="undefined"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof ie=="function"&&(ce=ie,ie=null),ie=Ke({},Oe.defaults,ie||{}),V(ie),ce){var j=ie.highlight,Y;try{Y=J.lex(z,ie)}catch($e){return ce($e)}var se=function(Ne){var Ve;if(!Ne)try{Ve=be.parse(Y,ie)}catch(Qe){Ne=Qe}return ie.highlight=j,Ne?ce(Ne):ce(null,Ve)};if(!j||j.length<3||(delete ie.highlight,!Y.length))return se();var fe=0;Oe.walkTokens(Y,function($e){$e.type==="code"&&(fe++,setTimeout(function(){j($e.text,$e.lang,function(Ne,Ve){if(Ne)return se(Ne);Ve!=null&&Ve!==$e.text&&($e.text=Ve,$e.escaped=!0),fe--,fe===0&&se()})},0))}),fe===0&&se();return}try{var ve=J.lex(z,ie);return ie.walkTokens&&Oe.walkTokens(ve,ie.walkTokens),be.parse(ve,ie)}catch($e){if($e.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+X($e.message+"",!0)+"</pre>";throw $e}}Oe.options=Oe.setOptions=function(z){return Ke(Oe.defaults,z),Me(Oe.defaults),Oe},Oe.getDefaults=_e,Oe.defaults=He,Oe.use=function(z){var ie=Ke({},z);if(z.renderer&&function(){var j=Oe.defaults.renderer||new Le,Y=function(ve){var $e=j[ve];j[ve]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Qe=0;Qe<Ne;Qe++)Ve[Qe]=arguments[Qe];var Ze=z.renderer[ve].apply(j,Ve);return Ze===!1&&(Ze=$e.apply(j,Ve)),Ze}};for(var se in z.renderer)Y(se);ie.renderer=j}(),z.tokenizer&&function(){var j=Oe.defaults.tokenizer||new U,Y=function(ve){var $e=j[ve];j[ve]=function(){for(var Ne=arguments.length,Ve=new Array(Ne),Qe=0;Qe<Ne;Qe++)Ve[Qe]=arguments[Qe];var Ze=z.tokenizer[ve].apply(j,Ve);return Ze===!1&&(Ze=$e.apply(j,Ve)),Ze}};for(var se in z.tokenizer)Y(se);ie.tokenizer=j}(),z.walkTokens){var ce=Oe.defaults.walkTokens;ie.walkTokens=function(j){z.walkTokens(j),ce&&ce(j)}}Oe.setOptions(ie)},Oe.walkTokens=function(z,ie){for(var ce=T(z),j;!(j=ce()).done;){var Y=j.value;switch(ie(Y),Y.type){case"table":{for(var se=T(Y.tokens.header),fe;!(fe=se()).done;){var ve=fe.value;Oe.walkTokens(ve,ie)}for(var $e=T(Y.tokens.cells),Ne;!(Ne=$e()).done;)for(var Ve=Ne.value,Qe=T(Ve),Ze;!(Ze=Qe()).done;){var ct=Ze.value;Oe.walkTokens(ct,ie)}break}case"list":{Oe.walkTokens(Y.items,ie);break}default:Y.tokens&&Oe.walkTokens(Y.tokens,ie)}}},Oe.parseInline=function(z,ie){if(typeof z=="undefined"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");ie=Ke({},Oe.defaults,ie||{}),V(ie);try{var ce=J.lexInline(z,ie);return ie.walkTokens&&Oe.walkTokens(ce,ie.walkTokens),be.parseInline(ce,ie)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+X(j.message+"",!0)+"</pre>";throw j}},Oe.Parser=be,Oe.parser=be.parse,Oe.Renderer=Le,Oe.TextRenderer=pe,Oe.Lexer=J,Oe.lexer=J.lex,Oe.Tokenizer=U,Oe.Slugger=Ce,Oe.parse=Oe;var Xe=Oe;return Xe}),define(we[78],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(S,I,y){return Math.min(Math.max(S,I),y)}e.clamp=w;function D(S,I){return(I+S%I)%I}e.rot=D;class T{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=T;class P{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=P});"use strict";(function(){function oe(T){const P=[];typeof T=="number"&&P.push("code/timeOrigin",T);function S(y){P.push(y,Date.now())}function I(){const y=[];for(let n=0;n<P.length;n+=2)y.push({name:P[n],startTime:P[n+1]});return y}return{mark:S,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const S of performance.getEntriesByType("mark"))P.push({name:S.name,startTime:Math.round(T+S.startTime)});return P}};if(typeof process=="object"){const T=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=w(D))})(),define(we[21],Ee([0,1]),function(oe,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const D="en";let T=!1,P=!1,S=!1,I=!1,y=!1,n=!1,A=!1,k,_=D,f,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof process!="undefined"?h=process:typeof e.globals.vscode!="undefined"&&(h=e.globals.vscode.process);const p=typeof((w=h==null?void 0:h.versions)===null||w===void 0?void 0:w.electron)=="string"&&h.type==="renderer";if(e.isElectronSandboxed=p&&(h==null?void 0:h.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const l=h==null?void 0:h.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof l=="string")return l==="none"||l==="code"||l==="bypassHeatCheck"||l==="bypassHeatCheckAndEagerCompile"?l:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!p)r=navigator.userAgent,T=r.indexOf("Windows")>=0,P=r.indexOf("Macintosh")>=0,A=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=r.indexOf("Linux")>=0,n=!0,k=navigator.language,_=k;else if(typeof h=="object"){T=h.platform==="win32",P=h.platform==="darwin",S=h.platform==="linux",I=S&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,k=D,_=D;const l=h.env.VSCODE_NLS_CONFIG;if(l)try{const s=JSON.parse(l),a=s.availableLanguages["*"];k=s.locale,_=a||D,f=s._translationsConfigFile}catch(s){}y=!0}else console.error("Unable to resolve platform.");var m;(function(l){l[l.Web=0]="Web",l[l.Mac=1]="Mac",l[l.Linux=2]="Linux",l[l.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function v(l){switch(l){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let d=0;P?d=1:T?d=3:S&&(d=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=S,e.isLinuxSnap=I,e.isNative=y,e.isWeb=n,e.isIOS=A,e.platform=d,e.userAgent=r,e.language=_;var c;(function(l){function s(){return e.language}l.value=s;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}l.isDefaultVariant=a;function E(){return e.language==="en"}l.isDefault=E})(c=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeSetImmediateId)for(let g=0,b=a.length;g<b;g++){const C=a[g];if(C.id===R.data.vscodeSetImmediateId){a.splice(g,1),C.callback();return}}});let E=0;return R=>{const g=++E;a.push({id:g,callback:R}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof(h==null?void 0:h.nextTick)=="function")return h.nextTick.bind(h);const s=Promise.resolve();return a=>s.then(a)}();var o;(function(l){l[l.Windows=1]="Windows",l[l.Macintosh=2]="Macintosh",l[l.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||A?2:T?1:3;let t=!0,i=!1;function u(){if(!i){i=!0;const l=new Uint8Array(2);l[0]=1,l[1]=2,t=new Uint16Array(l.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=u}),define(we[32],Ee([0,1,21]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let D;if(typeof process!="undefined")D={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(T){return process.nextTick(T)}};else if(typeof w.globals.vscode!="undefined"){const T=w.globals.vscode.process;D={get platform(){return T.platform},get env(){return T.env},cwd(){return T.cwd()},nextTick(P){return(0,w.setImmediate)(P)}}}else D={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(T){return(0,w.setImmediate)(T)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick}),define(we[11],Ee([0,1,32]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,T=97,P=90,S=122,I=46,y=47,n=92,A=58,k=63;class _ extends Error{constructor(c,o,t){let i;typeof o=="string"&&o.indexOf("not ")===0?(i="must not be",o=o.replace(/^not /,"")):i="must be";const u=c.indexOf(".")!==-1?"property":"argument";let l=`The "${c}" ${u} ${i} of type ${o}`;l+=`. Received type ${typeof t}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function f(d,c){if(typeof d!="string")throw new _(c,"string",d)}function r(d){return d===y||d===n}function h(d){return d===y}function p(d){return d>=D&&d<=P||d>=T&&d<=S}function m(d,c,o,t){let i="",u=0,l=-1,s=0,a=0;for(let E=0;E<=d.length;++E){if(E<d.length)a=d.charCodeAt(E);else{if(t(a))break;a=y}if(t(a)){if(!(l===E-1||s===1))if(s===2){if(i.length<2||u!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const R=i.lastIndexOf(o);R===-1?(i="",u=0):(i=i.slice(0,R),u=i.length-1-i.lastIndexOf(o)),l=E,s=0;continue}else if(i.length!==0){i="",u=0,l=E,s=0;continue}}c&&(i+=i.length>0?`${o}..`:"..",u=2)}else i.length>0?i+=`${o}${d.slice(l+1,E)}`:i=d.slice(l+1,E),u=E-l-1;l=E,s=0}else a===I&&s!==-1?++s:s=-1}return i}function v(d,c){if(c===null||typeof c!="object")throw new _("pathObject","Object",c);const o=c.dir||c.root,t=c.base||`${c.name||""}${c.ext||""}`;return o?o===c.root?`${o}${t}`:`${o}${d}${t}`:t}e.win32={resolve(...d){let c="",o="",t=!1;for(let i=d.length-1;i>=-1;i--){let u;if(i>=0){if(u=d[i],f(u,"path"),u.length===0)continue}else c.length===0?u=w.cwd():(u=w.env[`=${c}`]||w.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==c.toLowerCase()&&u.charCodeAt(2)===n)&&(u=`${c}\\`));const l=u.length;let s=0,a="",E=!1;const R=u.charCodeAt(0);if(l===1)r(R)&&(s=1,E=!0);else if(r(R))if(E=!0,r(u.charCodeAt(1))){let g=2,b=g;for(;g<l&&!r(u.charCodeAt(g));)g++;if(g<l&&g!==b){const C=u.slice(b,g);for(b=g;g<l&&r(u.charCodeAt(g));)g++;if(g<l&&g!==b){for(b=g;g<l&&!r(u.charCodeAt(g));)g++;(g===l||g!==b)&&(a=`\\\\${C}\\${u.slice(b,g)}`,s=g)}}}else s=1;else p(R)&&u.charCodeAt(1)===A&&(a=u.slice(0,2),s=2,l>2&&r(u.charCodeAt(2))&&(E=!0,s=3));if(a.length>0)if(c.length>0){if(a.toLowerCase()!==c.toLowerCase())continue}else c=a;if(t){if(c.length>0)break}else if(o=`${u.slice(s)}\\${o}`,t=E,E&&c.length>0)break}return o=m(o,!t,"\\",r),t?`${c}\\${o}`:`${c}${o}`||"."},normalize(d){f(d,"path");const c=d.length;if(c===0)return".";let o=0,t,i=!1;const u=d.charCodeAt(0);if(c===1)return h(u)?"\\":d;if(r(u))if(i=!0,r(d.charCodeAt(1))){let s=2,a=s;for(;s<c&&!r(d.charCodeAt(s));)s++;if(s<c&&s!==a){const E=d.slice(a,s);for(a=s;s<c&&r(d.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&!r(d.charCodeAt(s));)s++;if(s===c)return`\\\\${E}\\${d.slice(a)}\\`;s!==a&&(t=`\\\\${E}\\${d.slice(a,s)}`,o=s)}}}else o=1;else p(u)&&d.charCodeAt(1)===A&&(t=d.slice(0,2),o=2,c>2&&r(d.charCodeAt(2))&&(i=!0,o=3));let l=o<c?m(d.slice(o),!i,"\\",r):"";return l.length===0&&!i&&(l="."),l.length>0&&r(d.charCodeAt(c-1))&&(l+="\\"),t===void 0?i?`\\${l}`:l:i?`${t}\\${l}`:`${t}${l}`},isAbsolute(d){f(d,"path");const c=d.length;if(c===0)return!1;const o=d.charCodeAt(0);return r(o)||c>2&&p(o)&&d.charCodeAt(1)===A&&r(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let c,o;for(let u=0;u<d.length;++u){const l=d[u];f(l,"path"),l.length>0&&(c===void 0?c=o=l:c+=`\\${l}`)}if(c===void 0)return".";let t=!0,i=0;if(typeof o=="string"&&r(o.charCodeAt(0))){++i;const u=o.length;u>1&&r(o.charCodeAt(1))&&(++i,u>2&&(r(o.charCodeAt(2))?++i:t=!1))}if(t){for(;i<c.length&&r(c.charCodeAt(i));)i++;i>=2&&(c=`\\${c.slice(i)}`)}return e.win32.normalize(c)},relative(d,c){if(f(d,"from"),f(c,"to"),d===c)return"";const o=e.win32.resolve(d),t=e.win32.resolve(c);if(o===t||(d=o.toLowerCase(),c=t.toLowerCase(),d===c))return"";let i=0;for(;i<d.length&&d.charCodeAt(i)===n;)i++;let u=d.length;for(;u-1>i&&d.charCodeAt(u-1)===n;)u--;const l=u-i;let s=0;for(;s<c.length&&c.charCodeAt(s)===n;)s++;let a=c.length;for(;a-1>s&&c.charCodeAt(a-1)===n;)a--;const E=a-s,R=l<E?l:E;let g=-1,b=0;for(;b<R;b++){const F=d.charCodeAt(i+b);if(F!==c.charCodeAt(s+b))break;F===n&&(g=b)}if(b!==R){if(g===-1)return t}else{if(E>R){if(c.charCodeAt(s+b)===n)return t.slice(s+b+1);if(b===2)return t.slice(s+b)}l>R&&(d.charCodeAt(i+b)===n?g=b:b===2&&(g=3)),g===-1&&(g=0)}let C="";for(b=i+g+1;b<=u;++b)(b===u||d.charCodeAt(b)===n)&&(C+=C.length===0?"..":"\\..");return s+=g,C.length>0?`${C}${t.slice(s,a)}`:(t.charCodeAt(s)===n&&++s,t.slice(s,a))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const c=e.win32.resolve(d);if(c.length<=2)return d;if(c.charCodeAt(0)===n){if(c.charCodeAt(1)===n){const o=c.charCodeAt(2);if(o!==k&&o!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===A&&c.charCodeAt(2)===n)return`\\\\?\\${c}`;return d},dirname(d){f(d,"path");const c=d.length;if(c===0)return".";let o=-1,t=0;const i=d.charCodeAt(0);if(c===1)return r(i)?d:".";if(r(i)){if(o=t=1,r(d.charCodeAt(1))){let s=2,a=s;for(;s<c&&!r(d.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&r(d.charCodeAt(s));)s++;if(s<c&&s!==a){for(a=s;s<c&&!r(d.charCodeAt(s));)s++;if(s===c)return d;s!==a&&(o=t=s+1)}}}}else p(i)&&d.charCodeAt(1)===A&&(o=c>2&&r(d.charCodeAt(2))?3:2,t=o);let u=-1,l=!0;for(let s=c-1;s>=t;--s)if(r(d.charCodeAt(s))){if(!l){u=s;break}}else l=!1;if(u===-1){if(o===-1)return".";u=o}return d.slice(0,u)},basename(d,c){c!==void 0&&f(c,"ext"),f(d,"path");let o=0,t=-1,i=!0,u;if(d.length>=2&&p(d.charCodeAt(0))&&d.charCodeAt(1)===A&&(o=2),c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let l=c.length-1,s=-1;for(u=d.length-1;u>=o;--u){const a=d.charCodeAt(u);if(r(a)){if(!i){o=u+1;break}}else s===-1&&(i=!1,s=u+1),l>=0&&(a===c.charCodeAt(l)?--l==-1&&(t=u):(l=-1,t=s))}return o===t?t=s:t===-1&&(t=d.length),d.slice(o,t)}for(u=d.length-1;u>=o;--u)if(r(d.charCodeAt(u))){if(!i){o=u+1;break}}else t===-1&&(i=!1,t=u+1);return t===-1?"":d.slice(o,t)},extname(d){f(d,"path");let c=0,o=-1,t=0,i=-1,u=!0,l=0;d.length>=2&&d.charCodeAt(1)===A&&p(d.charCodeAt(0))&&(c=t=2);for(let s=d.length-1;s>=c;--s){const a=d.charCodeAt(s);if(r(a)){if(!u){t=s+1;break}continue}i===-1&&(u=!1,i=s+1),a===I?o===-1?o=s:l!==1&&(l=1):o!==-1&&(l=-1)}return o===-1||i===-1||l===0||l===1&&o===i-1&&o===t+1?"":d.slice(o,i)},format:v.bind(null,"\\"),parse(d){f(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const o=d.length;let t=0,i=d.charCodeAt(0);if(o===1)return r(i)?(c.root=c.dir=d,c):(c.base=c.name=d,c);if(r(i)){if(t=1,r(d.charCodeAt(1))){let g=2,b=g;for(;g<o&&!r(d.charCodeAt(g));)g++;if(g<o&&g!==b){for(b=g;g<o&&r(d.charCodeAt(g));)g++;if(g<o&&g!==b){for(b=g;g<o&&!r(d.charCodeAt(g));)g++;g===o?t=g:g!==b&&(t=g+1)}}}}else if(p(i)&&d.charCodeAt(1)===A){if(o<=2)return c.root=c.dir=d,c;if(t=2,r(d.charCodeAt(2))){if(o===3)return c.root=c.dir=d,c;t=3}}t>0&&(c.root=d.slice(0,t));let u=-1,l=t,s=-1,a=!0,E=d.length-1,R=0;for(;E>=t;--E){if(i=d.charCodeAt(E),r(i)){if(!a){l=E+1;break}continue}s===-1&&(a=!1,s=E+1),i===I?u===-1?u=E:R!==1&&(R=1):u!==-1&&(R=-1)}return s!==-1&&(u===-1||R===0||R===1&&u===s-1&&u===l+1?c.base=c.name=d.slice(l,s):(c.name=d.slice(l,u),c.base=d.slice(l,s),c.ext=d.slice(u,s))),l>0&&l!==t?c.dir=d.slice(0,l-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let c="",o=!1;for(let t=d.length-1;t>=-1&&!o;t--){const i=t>=0?d[t]:w.cwd();f(i,"path"),i.length!==0&&(c=`${i}/${c}`,o=i.charCodeAt(0)===y)}return c=m(c,!o,"/",h),o?`/${c}`:c.length>0?c:"."},normalize(d){if(f(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===y,o=d.charCodeAt(d.length-1)===y;return d=m(d,!c,"/",h),d.length===0?c?"/":o?"./":".":(o&&(d+="/"),c?`/${d}`:d)},isAbsolute(d){return f(d,"path"),d.length>0&&d.charCodeAt(0)===y},join(...d){if(d.length===0)return".";let c;for(let o=0;o<d.length;++o){const t=d[o];f(t,"path"),t.length>0&&(c===void 0?c=t:c+=`/${t}`)}return c===void 0?".":e.posix.normalize(c)},relative(d,c){if(f(d,"from"),f(c,"to"),d===c||(d=e.posix.resolve(d),c=e.posix.resolve(c),d===c))return"";const o=1,t=d.length,i=t-o,u=1,l=c.length-u,s=i<l?i:l;let a=-1,E=0;for(;E<s;E++){const g=d.charCodeAt(o+E);if(g!==c.charCodeAt(u+E))break;g===y&&(a=E)}if(E===s)if(l>s){if(c.charCodeAt(u+E)===y)return c.slice(u+E+1);if(E===0)return c.slice(u+E)}else i>s&&(d.charCodeAt(o+E)===y?a=E:E===0&&(a=0));let R="";for(E=o+a+1;E<=t;++E)(E===t||d.charCodeAt(E)===y)&&(R+=R.length===0?"..":"/..");return`${R}${c.slice(u+a)}`},toNamespacedPath(d){return d},dirname(d){if(f(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===y;let o=-1,t=!0;for(let i=d.length-1;i>=1;--i)if(d.charCodeAt(i)===y){if(!t){o=i;break}}else t=!1;return o===-1?c?"/":".":c&&o===1?"//":d.slice(0,o)},basename(d,c){c!==void 0&&f(c,"ext"),f(d,"path");let o=0,t=-1,i=!0,u;if(c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let l=c.length-1,s=-1;for(u=d.length-1;u>=0;--u){const a=d.charCodeAt(u);if(a===y){if(!i){o=u+1;break}}else s===-1&&(i=!1,s=u+1),l>=0&&(a===c.charCodeAt(l)?--l==-1&&(t=u):(l=-1,t=s))}return o===t?t=s:t===-1&&(t=d.length),d.slice(o,t)}for(u=d.length-1;u>=0;--u)if(d.charCodeAt(u)===y){if(!i){o=u+1;break}}else t===-1&&(i=!1,t=u+1);return t===-1?"":d.slice(o,t)},extname(d){f(d,"path");let c=-1,o=0,t=-1,i=!0,u=0;for(let l=d.length-1;l>=0;--l){const s=d.charCodeAt(l);if(s===y){if(!i){o=l+1;break}continue}t===-1&&(i=!1,t=l+1),s===I?c===-1?c=l:u!==1&&(u=1):c!==-1&&(u=-1)}return c===-1||t===-1||u===0||u===1&&c===t-1&&c===o+1?"":d.slice(c,t)},format:v.bind(null,"/"),parse(d){f(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const o=d.charCodeAt(0)===y;let t;o?(c.root="/",t=1):t=0;let i=-1,u=0,l=-1,s=!0,a=d.length-1,E=0;for(;a>=t;--a){const R=d.charCodeAt(a);if(R===y){if(!s){u=a+1;break}continue}l===-1&&(s=!1,l=a+1),R===I?i===-1?i=a:E!==1&&(E=1):i!==-1&&(E=-1)}if(l!==-1){const R=u===0&&o?1:u;i===-1||E===0||E===1&&i===l-1&&i===u+1?c.base=c.name=d.slice(R,l):(c.name=d.slice(R,i),c.base=d.slice(R,l),c.ext=d.slice(i,l))}return u>0?c.dir=d.slice(0,u-1):o&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[55],Ee([0,1,21]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=w.globals.performance&&typeof w.globals.performance.now=="function";class T{constructor(S){this._highResolution=D&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new T(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=T}),define(we[3],Ee([0,1,10,52,6,46,55]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(m){m.None=()=>T.Disposable.None;function v(B){return(H,G=null,L)=>{let $=!1,U;return U=B(Q=>{if(!$)return U?U.dispose():$=!0,H.call(G,Q)},null,L),$&&U.dispose(),U}}m.once=v;function d(B,H){return l((G,L=null,$)=>B(U=>G.call(L,H(U)),null,$))}m.map=d;function c(B,H){return l((G,L=null,$)=>B(U=>{H(U),G.call(L,U)},null,$))}m.forEach=c;function o(B,H){return l((G,L=null,$)=>B(U=>H(U)&&G.call(L,U),null,$))}m.filter=o;function t(B){return B}m.signal=t;function i(...B){return(H,G=null,L)=>(0,T.combinedDisposable)(...B.map($=>$(U=>H.call(G,U),null,L)))}m.any=i;function u(B,H,G){let L=G;return d(B,$=>(L=H(L,$),L))}m.reduce=u;function l(B){let H;const G=new _({onFirstListenerAdd(){H=B(G.fire,G)},onLastListenerRemove(){H.dispose()}});return G.event}m.snapshot=l;function s(B,H,G=100,L=!1,$){let U,Q,N,Z=0;const ne=new _({leakWarningThreshold:$,onFirstListenerAdd(){U=B(re=>{Z++,Q=H(Q,re),L&&!N&&(ne.fire(Q),Q=void 0),clearTimeout(N),N=setTimeout(()=>{const ye=Q;Q=void 0,N=void 0,(!L||Z>1)&&ne.fire(ye),Z=0},G)})},onLastListenerRemove(){U.dispose()}});return ne.event}m.debounce=s;function a(B){const H=new Date().getTime();return d(v(B),G=>new Date().getTime()-H)}m.stopwatch=a;function E(B){let H=!0,G;return o(B,L=>{const $=H||L!==G;return H=!1,G=L,$})}m.latch=E;function R(B,H=!1,G=[]){let L=G.slice(),$=B(N=>{L?L.push(N):Q.fire(N)});const U=()=>{L&&L.forEach(N=>Q.fire(N)),L=null},Q=new _({onFirstListenerAdd(){$||($=B(N=>Q.fire(N)))},onFirstListenerDidAdd(){L&&(H?setTimeout(U):U())},onLastListenerRemove(){$&&$.dispose(),$=null}});return Q.event}m.buffer=R;class g{constructor(H){this.event=H}map(H){return new g(d(this.event,H))}forEach(H){return new g(c(this.event,H))}filter(H){return new g(o(this.event,H))}reduce(H,G){return new g(u(this.event,H,G))}latch(){return new g(E(this.event))}debounce(H,G=100,L=!1,$){return new g(s(this.event,H,G,L,$))}on(H,G,L){return this.event(H,G,L)}once(H,G,L){return v(this.event)(H,G,L)}}function b(B){return new g(B)}m.chain=b;function C(B,H,G=L=>L){const L=(...N)=>Q.fire(G(...N)),$=()=>B.on(H,L),U=()=>B.removeListener(H,L),Q=new _({onFirstListenerAdd:$,onLastListenerRemove:U});return Q.event}m.fromNodeEventEmitter=C;function F(B,H,G=L=>L){const L=(...N)=>Q.fire(G(...N)),$=()=>B.addEventListener(H,L),U=()=>B.removeEventListener(H,L),Q=new _({onFirstListenerAdd:$,onLastListenerRemove:U});return Q.event}m.fromDOMEventEmitter=F;function x(B){const H=new _;let G=!1;return B.then(void 0,()=>null).then(()=>{G?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),G=!0,H.event}m.fromPromise=x;function le(B){return new Promise(H=>v(B)(H))}m.toPromise=le})(I=e.Event||(e.Event={}));class y{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${y._idPool++}`}start(v){this._stopWatch=new S.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let n=-1;function A(m){const v=n;return n=m,{dispose(){n=v}}}e.setGlobalLeakWarningThreshold=A;class k{constructor(v,d=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let d=n;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||v<d)){this._stacks||(this._stacks=new Map);const c=new Error().stack.split(`
`).slice(3).join(`
`),o=this._stacks.get(c)||0;if(this._stacks.set(c,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,i=0;for(const[u,l]of this._stacks)(!t||i<l)&&(t=u,i=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(c)||0;this._stacks.set(c,t-1)}}}}class _{constructor(v){var d;this._disposed=!1,this._options=v,this._leakageMon=n>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(v,d,c)=>{var o;this._listeners||(this._listeners=new P.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(d?[v,d]:v);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,d);const u=(o=this._leakageMon)===null||o===void 0?void 0:o.check(this._listeners.size);let l;return l={dispose:()=>{u&&u(),l.dispose=_._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},c instanceof T.DisposableStore?c.add(l):Array.isArray(c)&&c.push(l),l}),this._event}fire(v){var d,c;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new P.LinkedList);for(let o of this._listeners)this._deliveryQueue.push([o,v]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[o,t]=this._deliveryQueue.shift();try{typeof o=="function"?o.call(void 0,t):o[0].call(o[1],t)}catch(i){(0,w.onUnexpectedError)(i)}}(c=this._perfMon)===null||c===void 0||c.stop()}}dispose(){var v,d,c;(v=this._listeners)===null||v===void 0||v.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(c=this._leakageMon)===null||c===void 0||c.dispose(),this._disposed=!0}}e.Emitter=_,_._noop=function(){};class f extends _{constructor(v){super(v);this._isPaused=0,this._eventQueue=new P.LinkedList,this._mergeFn=v==null?void 0:v.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=f;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new _({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const d={event:v,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const c=()=>{this.hasListeners&&this.unhook(d);const o=this.events.indexOf(d);this.events.splice(o,1)};return(0,T.toDisposable)((0,D.once)(c))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(d=>this.emitter.fire(d))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class h{constructor(){this.buffers=[]}wrapEvent(v){return(d,c,o)=>v(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>d.call(c,t)):d.call(c,t)},void 0,o)}bufferEvents(v){const d=[];this.buffers.push(d);const c=v();return this.buffers.pop(),d.forEach(o=>o()),c}}e.EventBufferer=h;class p{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=T.Disposable.None,this.emitter=new _({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=p}),define(we[20],Ee([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(I,y){const n=setTimeout(I.bind(y),0);return{dispose(){clearTimeout(n)}}});var T;(function(I){function y(n){return n===I.None||n===I.Cancelled||n instanceof P?!0:!n||typeof n!="object"?!1:typeof n.isCancellationRequested=="boolean"&&typeof n.onCancellationRequested=="function"}I.isCancellationToken=y,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(T=e.CancellationToken||(e.CancellationToken={}));class P{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new P),this._token}cancel(){this._token?this._token instanceof P&&this._token.cancel():this._token=T.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof P&&this._token.dispose():this._token=T.None}}e.CancellationTokenSource=S}),define(we[37],Ee([0,1,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(A){const k=this._icons.get(A.id);k?A.description?k.description=A.description:console.error(`Duplicate registration of codicon ${A.id}`):(this._icons.set(A.id,A),this._onDidRegister.fire(A))}get(A){return this._icons.get(A)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const T=new D;e.iconRegistry=T;function P(n,A){return new S(n,A)}e.registerCodicon=P;class S{constructor(A,k,_){this.id=A,this.definition=k,this.description=_,T.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function I(n,A){const k=["codicon","codicon-"+n];return A&&k.push("codicon-modifier-"+A),k}e.getClassNamesArray=I;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const A=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function k(r){if(r instanceof S)return["codicon","codicon-"+r.id];const h=A.exec(r.id);if(!h)return k(S.error);let[,p,m]=h;const v=["codicon","codicon-"+p];return m&&v.push("codicon-modifier-"+m.substr(1)),v}n.asClassNameArray=k;function _(r){return k(r).join(" ")}n.asClassName=_;function f(r){return"."+k(r).join(".")}n.asCSSSelector=f})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personAdd=new n("person-add",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnknown=new n("workspace-unknown",{fontCharacter:"\\ebc3"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(we[106],Ee([0,1,10,6]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function T(p){const m=p;return m&&[m.on,m.pause,m.resume,m.destroy].every(v=>typeof v=="function")}e.isReadableStream=T;function P(p){const m=p;return m&&T(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean"}e.isReadableBufferedStream=P;function S(p,m){return new I(p,m)}e.newWriteableStream=S;class I{constructor(m,v){this.reducer=m,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var v;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((v=this.options)===null||v===void 0?void 0:v.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(d=>this.pendingWritePromises.push(d))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(v=>v(m))}emitError(m){this.listeners.error.length===0?(0,w.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(v=>v(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,v){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(m,v){if(!this.state.destroyed){let d;switch(m){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const c=d.indexOf(v);c>=0&&d.splice(c,1)}}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(p,m){const v=[];let d;for(;(d=p.read())!==null;)v.push(d);return m(v)}e.consumeReadable=y;function n(p,m,v){const d=[];let c;for(;(c=p.read())!==null&&d.length<v;)d.push(c);return c===null&&d.length>0?m(d):{read:()=>{if(d.length>0)return d.shift();if(typeof c!="undefined"){const o=c;return c=void 0,o}return p.read()}}}e.peekReadable=n;function A(p,m){return new Promise((v,d)=>{const c=[];k(p,{onData:o=>{m&&c.push(o)},onError:o=>{m?d(o):v(void 0)},onEnd:()=>{v(m?m(c):void 0)}})})}e.consumeStream=A;function k(p,m){p.on("error",v=>m.onError(v)),p.on("end",()=>m.onEnd()),p.on("data",v=>m.onData(v))}e.listenStream=k;function _(p,m){return new Promise((v,d)=>{const c=new D.DisposableStore,o=[],t=l=>{if(o.push(l),o.length>m)return c.dispose(),p.pause(),v({stream:p,buffer:o,ended:!1})},i=l=>d(l),u=()=>v({stream:p,buffer:o,ended:!0});c.add((0,D.toDisposable)(()=>p.removeListener("error",i))),p.on("error",i),c.add((0,D.toDisposable)(()=>p.removeListener("end",u))),p.on("end",u),c.add((0,D.toDisposable)(()=>p.removeListener("data",t))),p.on("data",t)})}e.peekStream=_;function f(p,m){const v=S(m);return v.end(p),v}e.toStream=f;function r(p){let m=!1;return{read:()=>m?null:(m=!0,p)}}e.toReadable=r;function h(p,m,v){const d=S(v);return k(p,{onData:c=>d.write(m.data(c)),onError:c=>d.error(m.error?m.error(c):c),onEnd:()=>d.end()}),d}e.transform=h}),define(we[8],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=w;const D=/{(\d+)}/g;function T(z,...ie){return ie.length===0?z:z.replace(D,function(ce,j){const Y=parseInt(j,10);return isNaN(Y)||Y<0||Y>=ie.length?ce:ie[Y]})}e.format=T;function P(z){return z.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=P;function S(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function I(z,ie){let ce=0;const j=ie.charCodeAt(0);for(let Y=z.length-1;Y>=0;Y--)z.charCodeAt(Y)===j&&ce++;return ce}e.count=I;function y(z,ie,ce="\u2026"){return z.length<=ie?z:`${z.substr(0,ie)}${ce}`}e.truncate=y;function n(z,ie=" "){const ce=A(z,ie);return k(ce,ie)}e.trim=n;function A(z,ie){if(!z||!ie)return z;const ce=ie.length;if(ce===0||z.length===0)return z;let j=0;for(;z.indexOf(ie,j)===j;)j=j+ce;return z.substring(j)}e.ltrim=A;function k(z,ie){if(!z||!ie)return z;const ce=ie.length,j=z.length;if(ce===0||j===0)return z;let Y=j,se=-1;for(;se=z.lastIndexOf(ie,Y-1),!(se===-1||se+ce!==Y);){if(se===0)return"";Y=se}return z.substring(0,Y)}e.rtrim=k;function _(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=_;function f(z){return z.replace(/\*/g,"")}e.stripWildcards=f;function r(z,ie,ce={}){if(!z)throw new Error("Cannot create regex from empty string");ie||(z=S(z)),ce.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let j="";return ce.global&&(j+="g"),ce.matchCase||(j+="i"),ce.multiline&&(j+="m"),ce.unicode&&(j+="u"),new RegExp(z,j)}e.createRegExp=r;function h(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function p(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function m(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=m;function v(z){return z.split(/\r\n|\r|\n/)}e.splitLines=v;function d(z){for(let ie=0,ce=z.length;ie<ce;ie++){const j=z.charCodeAt(ie);if(j!==32&&j!==9)return ie}return-1}e.firstNonWhitespaceIndex=d;function c(z,ie=0,ce=z.length){for(let j=ie;j<ce;j++){const Y=z.charCodeAt(j);if(Y!==32&&Y!==9)return z.substring(ie,j)}return z.substring(ie,ce)}e.getLeadingWhitespace=c;function o(z,ie=z.length-1){for(let ce=ie;ce>=0;ce--){const j=z.charCodeAt(ce);if(j!==32&&j!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function t(z,ie){return z<ie?-1:z>ie?1:0}e.compare=t;function i(z,ie,ce=0,j=z.length,Y=0,se=ie.length){for(;ce<j&&Y<se;ce++,Y++){let $e=z.charCodeAt(ce),Ne=ie.charCodeAt(Y);if($e<Ne)return-1;if($e>Ne)return 1}const fe=j-ce,ve=se-Y;return fe<ve?-1:fe>ve?1:0}e.compareSubstring=i;function u(z,ie){return l(z,ie,0,z.length,0,ie.length)}e.compareIgnoreCase=u;function l(z,ie,ce=0,j=z.length,Y=0,se=ie.length){for(;ce<j&&Y<se;ce++,Y++){let $e=z.charCodeAt(ce),Ne=ie.charCodeAt(Y);if($e!==Ne){const Ve=$e-Ne;if(!(Ve===32&&a(Ne))&&!(Ve===-32&&a($e)))return s($e)&&s(Ne)?Ve:i(z.toLowerCase(),ie.toLowerCase(),ce,j,Y,se)}}const fe=j-ce,ve=se-Y;return fe<ve?-1:fe>ve?1:0}e.compareSubstringIgnoreCase=l;function s(z){return z>=97&&z<=122}e.isLowerAsciiLetter=s;function a(z){return z>=65&&z<=90}e.isUpperAsciiLetter=a;function E(z){return s(z)||a(z)}function R(z,ie){return z.length===ie.length&&g(z,ie)}e.equalsIgnoreCase=R;function g(z,ie,ce=z.length){for(let j=0;j<ce;j++){const Y=z.charCodeAt(j),se=ie.charCodeAt(j);if(Y!==se){if(E(Y)&&E(se)){const fe=Math.abs(Y-se);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(Y).toLowerCase()!==String.fromCharCode(se).toLowerCase())return!1}}return!0}function b(z,ie){const ce=ie.length;return ie.length>z.length?!1:g(z,ie,ce)}e.startsWithIgnoreCase=b;function C(z,ie){let ce,j=Math.min(z.length,ie.length);for(ce=0;ce<j;ce++)if(z.charCodeAt(ce)!==ie.charCodeAt(ce))return ce;return j}e.commonPrefixLength=C;function F(z,ie){let ce,j=Math.min(z.length,ie.length);const Y=z.length-1,se=ie.length-1;for(ce=0;ce<j;ce++)if(z.charCodeAt(Y-ce)!==ie.charCodeAt(se-ce))return ce;return j}e.commonSuffixLength=F;function x(z){return 55296<=z&&z<=56319}e.isHighSurrogate=x;function le(z){return 56320<=z&&z<=57343}e.isLowSurrogate=le;function B(z,ie){return(z-55296<<10)+(ie-56320)+65536}e.computeCodePoint=B;function H(z,ie,ce){const j=z.charCodeAt(ce);if(x(j)&&ce+1<ie){const Y=z.charCodeAt(ce+1);if(le(Y))return B(j,Y)}return j}e.getNextCodePoint=H;function G(z,ie){const ce=z.charCodeAt(ie-1);if(le(ce)&&ie>1){const j=z.charCodeAt(ie-2);if(x(j))return B(j,ce)}return ce}function L(z,ie){const ce=Oe.getInstance(),j=ie,Y=z.length,se=H(z,Y,ie);ie+=se>=65536?2:1;let fe=ce.getGraphemeBreakType(se);for(;ie<Y;){const ve=H(z,Y,ie),$e=ce.getGraphemeBreakType(ve);if(Me(fe,$e))break;ie+=ve>=65536?2:1,fe=$e}return ie-j}e.nextCharLength=L;function $(z,ie){const ce=Oe.getInstance(),j=ie,Y=G(z,ie);ie-=Y>=65536?2:1;let se=ce.getGraphemeBreakType(Y);for(;ie>0;){const fe=G(z,ie),ve=ce.getGraphemeBreakType(fe);if(Me(ve,se))break;ie-=fe>=65536?2:1,se=ve}return j-ie}e.prevCharLength=$;function U(z,ie){const ce=Oe.getInstance(),j=z.length,Y=ie,se=H(z,j,ie),fe=ce.getGraphemeBreakType(se);ie+=se>=65536?2:1;let ve=fe;for(;ie<j;){const Ne=H(z,j,ie),Ve=ce.getGraphemeBreakType(Ne);if(Me(ve,Ve))break;ie+=Ne>=65536?2:1,ve=Ve}const $e=ie;for(ie=Y,ve=fe;ie>0;){const Ne=G(z,ie),Ve=ce.getGraphemeBreakType(Ne);if(Me(Ve,ve))break;ie-=Ne>=65536?2:1,ve=Ve}return[ie,$e]}function Q(z,ie){return ie>0&&le(z.charCodeAt(ie))?U(z,ie-1):U(z,ie)}e.getCharContainingOffset=Q;function N(z){const ie=z.length;let ce=0,j=0;for(;j<ie;){const fe=H(z,ie,j);j+=fe>=65536?2:1,fe<128?ce+=1:fe<2048?ce+=2:fe<65536?ce+=3:ce+=4}const Y=new Uint8Array(ce);j=0;let se=0;for(;j<ie;){const fe=H(z,ie,j);j+=fe>=65536?2:1,fe<128?Y[se++]=fe:fe<2048?(Y[se++]=192|(fe&1984)>>>6,Y[se++]=128|(fe&63)>>>0):fe<65536?(Y[se++]=224|(fe&61440)>>>12,Y[se++]=128|(fe&4032)>>>6,Y[se++]=128|(fe&63)>>>0):(Y[se++]=240|(fe&1835008)>>>18,Y[se++]=128|(fe&258048)>>>12,Y[se++]=128|(fe&4032)>>>6,Y[se++]=128|(fe&63)>>>0)}return Y}e.encodeUTF8=N;function Z(z){const ie=z.byteLength,ce=[];let j=0;for(;j<ie;){const Y=z[j];let se;if(Y>=240&&j+3<ie?se=(z[j++]&7)<<18>>>0|(z[j++]&63)<<12>>>0|(z[j++]&63)<<6>>>0|(z[j++]&63)<<0>>>0:Y>=224&&j+2<ie?se=(z[j++]&15)<<12>>>0|(z[j++]&63)<<6>>>0|(z[j++]&63)<<0>>>0:Y>=192&&j+1<ie?se=(z[j++]&31)<<6>>>0|(z[j++]&63)<<0>>>0:se=z[j++],se>=0&&se<=55295||se>=57344&&se<=65535)ce.push(String.fromCharCode(se));else if(se>=65536&&se<=1114111){const fe=se-65536,ve=55296+((fe&1047552)>>>10),$e=56320+((fe&1023)>>>0);ce.push(String.fromCharCode(ve)),ce.push(String.fromCharCode($e))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=Z;const ne=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function re(z){return ne.test(z)}e.containsRTL=re;const ye=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Ae(z){return ye.test(z)}e.containsEmoji=Ae;const Be=/^[\t\n\r\x20-\x7E]*$/;function Re(z){return Be.test(z)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function xe(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=xe;function W(z){for(let ie=0,ce=z.length;ie<ce;ie++)if(K(z.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=W;function K(z){return z=+z,z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=K;function J(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129003||z>=129280&&z<=129535||z>=129648&&z<=129750}e.isEmojiImprecise=J;function ae(z,ie){if(z.length<ie)return z;const ce=/\b/g;let j=0;for(;ce.test(z)&&!(z.length-ce.lastIndex<ie);)j=ce.lastIndex,ce.lastIndex+=1;return z.substring(j).replace(/^\s/,"")}e.lcut=ae;const ge=/\x1B\x5B[12]?K/g,De=/\x1b\[\d+m/g,Le=/\x1b\[0?m/g;function pe(z){return z&&(z=z.replace(ge,""),z=z.replace(De,""),z=z.replace(Le,"")),z}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Te(z){return Ce(z)?z.substr(1):z}e.stripUTF8BOM=Te;function Ue(z,ie){if(!z||!ie||z.length<ie.length)return!1;const ce=ie.length,j=z.toLowerCase();let Y=0,se=-1;for(;Y<ce;){const fe=j.indexOf(ie[Y],se+1);if(fe<0)return!1;se=fe,Y++}return!0}e.fuzzyContains=Ue;function be(z,ie=!1){return z?(ie&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=be;function Ke(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ke;function V(z,ie=1){if(ie===0)return"";let ce=-1;do ce=z.indexOf(`
`,ce+1),ie--;while(ie>0&&ce>=0);return ce===-1?z:(z[ce-1]==="\r"&&ce--,z.substr(0,ce))}e.getNLines=V;function X(z){const ie=90-65+1;return z=z%(2*ie),z<ie?String.fromCharCode(97+z):String.fromCharCode(65+z-ie)}e.singleLetterHash=X;function _e(z){return Oe.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=_e;function Me(z,ie){return z===0?ie!==5&&ie!==7:z===2&&ie===3?!1:z===4||z===2||z===3||ie===4||ie===2||ie===3?!0:!(z===8&&(ie===8||ie===9||ie===11||ie===12)||(z===11||z===9)&&(ie===9||ie===10)||(z===12||z===10)&&ie===10||ie===5||ie===13||ie===7||z===1||z===13&&ie===14||z===6&&ie===6)}e.breakBetweenGraphemeBreakType=Me;var He;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Xe()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ce=this._data,j=ce.length/3;let Y=1;for(;Y<=j;)if(ie<ce[3*Y])Y=2*Y;else if(ie>ce[3*Y+1])Y=2*Y+1;else return ce[3*Y+2];return 0}}Oe._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(we[26],Ee([0,1,8,106]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined",P=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let I,y;class n{constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}static alloc(s){return T?new n(Buffer.allocUnsafe(s)):new n(new Uint8Array(s))}static wrap(s){return T&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new n(s)}static fromString(s,a){return!((a==null?void 0:a.dontUseNodeBuffer)||!1)&&T?new n(Buffer.from(s)):P?(I||(I=new TextEncoder),new n(I.encode(s))):new n(w.encodeUTF8(s))}static concat(s,a){if(typeof a=="undefined"){a=0;for(let g=0,b=s.length;g<b;g++)a+=s[g].byteLength}const E=n.alloc(a);let R=0;for(let g=0,b=s.length;g<b;g++){const C=s[g];E.set(C,R),R+=C.byteLength}return E}toString(){return T?this.buffer.toString():S?(y||(y=new TextDecoder),y.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(s,a){return new n(this.buffer.subarray(s,a))}set(s,a){s instanceof n?this.buffer.set(s.buffer,a):this.buffer.set(s,a)}readUInt32BE(s){return _(this.buffer,s)}writeUInt32BE(s,a){f(this.buffer,s,a)}readUInt32LE(s){return r(this.buffer,s)}writeUInt32LE(s,a){h(this.buffer,s,a)}readUInt8(s){return p(this.buffer,s)}writeUInt8(s,a){m(this.buffer,s,a)}}e.VSBuffer=n;function A(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0}e.readUInt16LE=A;function k(l,s,a){l[a+0]=s&255,s=s>>>8,l[a+1]=s&255}e.writeUInt16LE=k;function _(l,s){return l[s]*2**24+l[s+1]*2**16+l[s+2]*2**8+l[s+3]}e.readUInt32BE=_;function f(l,s,a){l[a+3]=s,s=s>>>8,l[a+2]=s,s=s>>>8,l[a+1]=s,s=s>>>8,l[a]=s}e.writeUInt32BE=f;function r(l,s){return l[s+0]<<0>>>0|l[s+1]<<8>>>0|l[s+2]<<16>>>0|l[s+3]<<24>>>0}e.readUInt32LE=r;function h(l,s,a){l[a+0]=s&255,s=s>>>8,l[a+1]=s&255,s=s>>>8,l[a+2]=s&255,s=s>>>8,l[a+3]=s&255}e.writeUInt32LE=h;function p(l,s){return l[s]}e.readUInt8=p;function m(l,s,a){l[a]=s}e.writeUInt8=m;function v(l){return D.consumeReadable(l,s=>n.concat(s))}e.readableToBuffer=v;function d(l){return D.toReadable(l)}e.bufferToReadable=d;function c(l){return D.consumeStream(l,s=>n.concat(s))}e.streamToBuffer=c;async function o(l){return l.ended?n.concat(l.buffer):n.concat([...l.buffer,await c(l.stream)])}e.bufferedStreamToBuffer=o;function t(l){return D.toStream(l,s=>n.concat(s))}e.bufferToStream=t;function i(l){return D.transform(l,{data:s=>typeof s=="string"?n.fromString(s):n.wrap(s)},s=>n.concat(s))}e.streamToBufferReadableStream=i;function u(l){return D.newWriteableStream(s=>n.concat(s),l)}e.newWriteableBufferStream=u}),define(we[56],Ee([0,1,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function D(m){return T(m,0)}e.hash=D;function T(m,v){switch(typeof m){case"object":return m===null?P(349,v):Array.isArray(m)?y(m,v):n(m,v);case"string":return I(m,v);case"boolean":return S(m,v);case"number":return P(m,v);case"undefined":return P(937,v);default:return P(617,v)}}e.doHash=T;function P(m,v){return(v<<5)-v+m|0}function S(m,v){return P(m?433:863,v)}function I(m,v){v=P(149417,v);for(let d=0,c=m.length;d<c;d++)v=P(m.charCodeAt(d),v);return v}e.stringHash=I;function y(m,v){return v=P(104579,v),m.reduce((d,c)=>T(c,d),v)}function n(m,v){return v=P(181387,v),Object.keys(m).sort().reduce((d,c)=>(d=I(c,d),T(m[c],d)),v)}class A{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=T(v,this._value),this._value}}e.Hasher=A;var k;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function _(m,v,d=32){const c=d-v,o=~((1<<c)-1);return(m<<v|(o&m)>>>c)>>>0}function f(m,v=0,d=m.byteLength,c=0){for(let o=0;o<d;o++)m[v+o]=c}function r(m,v,d="0"){for(;m.length<v;)m=d+m;return m}function h(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),v/4)}e.toHexString=h;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d!==0){const c=this._buff;let o=this._buffLen,t=this._leftoverHighSurrogate,i,u;for(t!==0?(i=t,u=-1,t=0):(i=v.charCodeAt(0),u=0);;){let l=i;if(w.isHighSurrogate(i))if(u+1<d){const s=v.charCodeAt(u+1);w.isLowSurrogate(s)?(u++,l=w.computeCodePoint(i,s)):l=65533}else{t=i;break}else w.isLowSurrogate(i)&&(l=65533);if(o=this._push(c,o,l),u++,u<d)i=v.charCodeAt(u);else break}this._buffLen=o,this._leftoverHighSurrogate=t}}_push(v,d,c){return c<128?v[d++]=c:c<2048?(v[d++]=192|(c&1984)>>>6,v[d++]=128|(c&63)>>>0):c<65536?(v[d++]=224|(c&61440)>>>12,v[d++]=128|(c&4032)>>>6,v[d++]=128|(c&63)>>>0):(v[d++]=240|(c&1835008)>>>18,v[d++]=128|(c&258048)>>>12,v[d++]=128|(c&4032)>>>6,v[d++]=128|(c&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=p._bigBlock32,d=this._buffDV;for(let E=0;E<64;E+=4)v.setUint32(E,d.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)v.setUint32(E,_(v.getUint32(E-12,!1)^v.getUint32(E-32,!1)^v.getUint32(E-56,!1)^v.getUint32(E-64,!1),1),!1);let c=this._h0,o=this._h1,t=this._h2,i=this._h3,u=this._h4,l,s,a;for(let E=0;E<80;E++)E<20?(l=o&t|~o&i,s=1518500249):E<40?(l=o^t^i,s=1859775393):E<60?(l=o&t|o&i|t&i,s=2400959708):(l=o^t^i,s=3395469782),a=_(c,5)+l+u+s+v.getUint32(E*4,!1)&4294967295,u=i,i=t,t=_(o,30),o=c,c=a;this._h0=this._h0+c&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+u&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[47],Ee([0,1,8]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(D||(D={})),function(T){const P="error",S="warning",I="warn",y="info";function n(A){return A?w.equalsIgnoreCase(P,A)?T.Error:w.equalsIgnoreCase(S,A)||w.equalsIgnoreCase(I,A)?T.Warning:w.equalsIgnoreCase(y,A)?T.Info:T.Ignore:T.Ignore}T.fromValue=n}(D||(D={})),e.default=D}),define(we[12],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(s){return Array.isArray(s)}e.isArray=w;function D(s){return typeof s=="string"}e.isString=D;function T(s){return Array.isArray(s)&&s.every(a=>D(a))}e.isStringArray=T;function P(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=P;function S(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=S;function I(s){return s===!0||s===!1}e.isBoolean=I;function y(s){return typeof s=="undefined"}e.isUndefined=y;function n(s){return!A(s)}e.isDefined=n;function A(s){return y(s)||s===null}e.isUndefinedOrNull=A;function k(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=k;function _(s){if(A(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=_;function f(...s){const a=[];for(let E=0;E<s.length;E++){const R=s[E];if(A(R))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);a.push(R)}return a}e.assertAllDefined=f;const r=Object.prototype.hasOwnProperty;function h(s){if(!P(s))return!1;for(let a in s)if(r.call(s,a))return!1;return!0}e.isEmptyObject=h;function p(s){return typeof s=="function"}e.isFunction=p;function m(...s){return s.length>0&&s.every(p)}e.areFunctions=m;function v(s,a){const E=Math.min(s.length,a.length);for(let R=0;R<E;R++)d(s[R],a[R])}e.validateConstraints=v;function d(s,a){if(D(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(p(a)){try{if(s instanceof a)return}catch(E){}if(!A(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function c(s){let a=[],E=Object.getPrototypeOf(s);for(;Object.prototype!==E;)a=a.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return a}e.getAllPropertyNames=c;function o(s){const a=[];for(const E of c(s))typeof s[E]=="function"&&a.push(E);return a}e.getAllMethodNames=o;function t(s,a){const E=g=>function(){const b=Array.prototype.slice.call(arguments,0);return a(g,b)};let R={};for(const g of s)R[g]=E(g);return R}e.createProxyObject=t;function i(s){return s===null?void 0:s}e.withNullAsUndefined=i;function u(s){return typeof s=="undefined"?null:s}e.withUndefinedAsNull=u;function l(s){return class{constructor(){return new Proxy({},{get(a,E){if(a[E])return a[E];throw new Error(`Not Implemented: ${s}->${String(E)}`)}})}}}e.NotImplementedProxy=l}),define(we[38],Ee([0,1,21,8,11,12]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function I(i){return i.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=I;function y(i,u=T.posix.sep){if(!i)return"";const l=i.length,s=i.charCodeAt(0);if(S(s)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let E=3;const R=E;for(;E<l&&!S(i.charCodeAt(E));E++);if(R!==E&&!S(i.charCodeAt(E+1))){for(E+=1;E<l;E++)if(S(i.charCodeAt(E)))return i.slice(0,E+1).replace(/[\\/]/g,u)}}return u}else if(p(s)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+u:i.slice(0,2);let a=i.indexOf("://");if(a!==-1){for(a+=3;a<l;a++)if(S(i.charCodeAt(a)))return i.slice(0,a+1)}return""}e.getRoot=y;function n(i){if(!w.isWindows||!i||i.length<5)return!1;let u=i.charCodeAt(0);if(u!==92||(u=i.charCodeAt(1),u!==92))return!1;let l=2;const s=l;for(;l<i.length&&(u=i.charCodeAt(l),u!==92);l++);return!(s===l||(u=i.charCodeAt(l+1),isNaN(u)||u===92))}e.isUNC=n;const A=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(i,u=w.isWindows){const l=u?A:k;return!(!i||i.length===0||/^\s+$/.test(i)||(l.lastIndex=0,l.test(i))||u&&_.test(i)||i==="."||i===".."||u&&i[i.length-1]==="."||u&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=f;function r(i,u,l){const s=i===u;return!l||s?s:!i||!u?!1:(0,D.equalsIgnoreCase)(i,u)}e.isEqual=r;function h(i,u,l,s=T.sep){if(i===u)return!0;if(!i||!u||u.length>i.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(i,u))return!1;if(u.length===i.length)return!0;let E=u.length;return u.charAt(u.length-1)===s&&E--,i.charAt(E)===s}return u.charAt(u.length-1)!==s&&(u+=s),i.indexOf(u)===0}e.isEqualOrParent=h;function p(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=p;function m(i,u){return w.isWindows&&i.endsWith(":")&&(i+=T.sep),(0,T.isAbsolute)(i)||(i=(0,T.join)(u,i)),i=(0,T.normalize)(i),w.isWindows?(i=(0,D.rtrim)(i,T.sep),i.endsWith(":")&&(i+=T.sep)):(i=(0,D.rtrim)(i,T.sep),i||(i=T.sep)),i}e.sanitizeFilePath=m;function v(i){const u=(0,T.normalize)(i);return w.isWindows?i.length>3?!1:d(u)&&(i.length===2||u.charCodeAt(2)===92):u===T.posix.sep}e.isRootOrDriveLetter=v;function d(i){return w.isWindows?p(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function c(i){return d(i)?i[0]:void 0}e.getDriveLetter=c;function o(i,u,l){return u.length>i.length?-1:i===u?0:(l&&(i=i.toLowerCase(),u=u.toLowerCase()),i.indexOf(u))}e.indexOfPath=o;function t(i){const u=i.split(":");let l,s,a;if(u.forEach(E=>{const R=Number(E);(0,P.isNumber)(R)?s===void 0?s=R:a===void 0&&(a=R):l=l?[l,E].join(":"):E}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:s!==void 0?s:void 0,column:a!==void 0?a:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(we[23],Ee([0,1,12]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const h=Array.isArray(r)?[]:{};return Object.keys(r).forEach(p=>{r[p]&&typeof r[p]=="object"?h[p]=D(r[p]):h[p]=r[p]}),h}e.deepClone=D;function T(r){if(!r||typeof r!="object")return r;const h=[r];for(;h.length>0;){const p=h.shift();Object.freeze(p);for(const m in p)if(P.call(p,m)){const v=p[m];typeof v=="object"&&!Object.isFrozen(v)&&h.push(v)}}return r}e.deepFreeze=T;const P=Object.prototype.hasOwnProperty;function S(r,h){return I(r,h,new Set)}e.cloneAndChange=S;function I(r,h,p){if((0,w.isUndefinedOrNull)(r))return r;const m=h(r);if(typeof m!="undefined")return m;if((0,w.isArray)(r)){const v=[];for(const d of r)v.push(I(d,h,p));return v}if((0,w.isObject)(r)){if(p.has(r))throw new Error("Cannot clone recursive data-structure");p.add(r);const v={};for(let d in r)P.call(r,d)&&(v[d]=I(r[d],h,p));return p.delete(r),v}return r}function y(r,h,p=!0){return(0,w.isObject)(r)?((0,w.isObject)(h)&&Object.keys(h).forEach(m=>{m in r?p&&((0,w.isObject)(r[m])&&(0,w.isObject)(h[m])?y(r[m],h[m],p):r[m]=h[m]):r[m]=h[m]}),r):h}e.mixin=y;function n(r,h){if(r===h)return!0;if(r==null||h===null||h===void 0||typeof r!=typeof h||typeof r!="object"||Array.isArray(r)!==Array.isArray(h))return!1;let p,m;if(Array.isArray(r)){if(r.length!==h.length)return!1;for(p=0;p<r.length;p++)if(!n(r[p],h[p]))return!1}else{const v=[];for(m in r)v.push(m);v.sort();const d=[];for(m in h)d.push(m);if(d.sort(),!n(v,d))return!1;for(p=0;p<v.length;p++)if(!n(r[v[p]],h[v[p]]))return!1}return!0}e.equals=n;function A(r){const h=new Set;return JSON.stringify(r,(p,m)=>{if((0,w.isObject)(m)||Array.isArray(m)){if(h.has(m))return"[Circular]";h.add(m)}return m})}e.safeStringify=A;function k(r,h,p){const m=h(r);return typeof m=="undefined"?p:m}e.getOrDefault=k;function _(r,h){const p=Object.create(null);return!r||!h||Object.keys(h).forEach(v=>{const d=r[v],c=h[v];n(d,c)||(p[v]=c)}),p}e.distinct=_;function f(r,h){const p=h.toLowerCase(),m=Object.keys(r).find(v=>v.toLowerCase()===p);return m?r[m]:r[h]}e.getCaseInsensitive=f}),define(we[79],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function D(P){return P<0?0:P>255?255:P|0}e.toUint8=D;function T(P){return P<0?0:P>4294967295?4294967295:P|0}e.toUint32=T}),define(we[2],Ee([0,1,21,11]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,P=/^\//,S=/^\/\//;function I(u,l){if(!u.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!T.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!P.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(u,l){return!u&&!l?"file":u}function n(u,l){switch(u){case"https":case"http":case"file":l?l[0]!==k&&(l=k+l):l=k;break}return l}const A="",k="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(l,s,a,E,R,g=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=y(l,g),this.authority=s||A,this.path=n(this.scheme,a||A),this.query=E||A,this.fragment=R||A,I(this,g))}static isUri(l){return l instanceof f?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}get fsPath(){return d(this,!1)}with(l){if(!l)return this;let{scheme:s,authority:a,path:E,query:R,fragment:g}=l;return s===void 0?s=this.scheme:s===null&&(s=A),a===void 0?a=this.authority:a===null&&(a=A),E===void 0?E=this.path:E===null&&(E=A),R===void 0?R=this.query:R===null&&(R=A),g===void 0?g=this.fragment:g===null&&(g=A),s===this.scheme&&a===this.authority&&E===this.path&&R===this.query&&g===this.fragment?this:new h(s,a,E,R,g)}static parse(l,s=!1){const a=_.exec(l);return a?new h(a[2]||A,i(a[4]||A),i(a[5]||A),i(a[7]||A),i(a[9]||A),s):new h(A,A,A,A,A)}static file(l){let s=A;if(w.isWindows&&(l=l.replace(/\\/g,k)),l[0]===k&&l[1]===k){const a=l.indexOf(k,2);a===-1?(s=l.substring(2),l=k):(s=l.substring(2,a),l=l.substring(a)||k)}return new h("file",s,l,A,A)}static from(l){return new h(l.scheme,l.authority,l.path,l.query,l.fragment)}static joinPath(l,...s){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return w.isWindows&&l.scheme==="file"?a=f.file(D.win32.join(d(l,!0),...s)).path:a=D.posix.join(l.path,...s),l.with({path:a})}toString(l=!1){return c(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof f)return l;{const s=new h(l);return s._formatted=l.external,s._fsPath=l._sep===r?l.fsPath:null,s}}else return l}}e.URI=f;const r=w.isWindows?1:void 0;class h extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(l=!1){return l?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=r),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(u,l){let s,a=-1;for(let E=0;E<u.length;E++){const R=u.charCodeAt(E);if(R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57||R===45||R===46||R===95||R===126||l&&R===47)a!==-1&&(s+=encodeURIComponent(u.substring(a,E)),a=-1),s!==void 0&&(s+=u.charAt(E));else{s===void 0&&(s=u.substr(0,E));const g=p[R];g!==void 0?(a!==-1&&(s+=encodeURIComponent(u.substring(a,E)),a=-1),s+=g):a===-1&&(a=E)}}return a!==-1&&(s+=encodeURIComponent(u.substring(a))),s!==void 0?s:u}function v(u){let l;for(let s=0;s<u.length;s++){const a=u.charCodeAt(s);a===35||a===63?(l===void 0&&(l=u.substr(0,s)),l+=p[a]):l!==void 0&&(l+=u[s])}return l!==void 0?l:u}function d(u,l){let s;return u.authority&&u.path.length>1&&u.scheme==="file"?s=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?l?s=u.path.substr(1):s=u.path[1].toLowerCase()+u.path.substr(2):s=u.path,w.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function c(u,l){const s=l?v:m;let a="",{scheme:E,authority:R,path:g,query:b,fragment:C}=u;if(E&&(a+=E,a+=":"),(R||E==="file")&&(a+=k,a+=k),R){let F=R.indexOf("@");if(F!==-1){const x=R.substr(0,F);R=R.substr(F+1),F=x.indexOf(":"),F===-1?a+=s(x,!1):(a+=s(x.substr(0,F),!1),a+=":",a+=s(x.substr(F+1),!1)),a+="@"}R=R.toLowerCase(),F=R.indexOf(":"),F===-1?a+=s(R,!1):(a+=s(R.substr(0,F),!1),a+=R.substr(F))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const F=g.charCodeAt(1);F>=65&&F<=90&&(g=`/${String.fromCharCode(F+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const F=g.charCodeAt(0);F>=65&&F<=90&&(g=`${String.fromCharCode(F+32)}:${g.substr(2)}`)}a+=s(g,!0)}return b&&(a+="?",a+=s(b,!1)),C&&(a+="#",a+=l?C:m(C,!1)),a}function o(u){try{return decodeURIComponent(u)}catch(l){return u.length>3?u.substr(0,3)+o(u.substr(3)):u}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(u){return u.match(t)?u.replace(t,l=>o(l)):u}}),define(we[22],Ee([0,1,2,8]),function(oe,e,w,D){"use strict";var T,P;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(c,o,t){let i=c.get(o);return i===void 0&&(i=t,c.set(o,i)),i}e.getOrSet=S;function I(c){const o=[];return c.forEach((t,i)=>{o.push(`${i} => ${t}`)}),`Map(${c.size}) {${o.join(", ")}}`}e.mapToString=I;function y(c){const o=[];return c.forEach(t=>{o.push(t)}),`Set(${c.size}) {${o.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const t=o.charCodeAt(0),i=this._value.charCodeAt(this._pos);return t-i}value(){return this._value[this._pos]}}e.StringIterator=n;class A{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,D.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class k{constructor(o=!0,t=!0){this._splitOnBackslash=o,this._caseSensitive=t}reset(o){return this._value=o.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,D.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var _;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(_||(_={}));class f{constructor(o){this._ignorePathCasing=o,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,D.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class r{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class h{constructor(o){this._iter=o}static forUris(o=()=>!1){return new h(new f(o))}static forPaths(){return new h(new k)}static forStrings(){return new h(new n)}static forConfigKeys(){return new h(new A)}clear(){this._root=void 0}set(o,t){const i=this._iter.reset(o);let u;for(this._root||(this._root=new r,this._root.segment=i.value()),u=this._root;;){const s=i.cmp(u.segment);if(s>0)u.left||(u.left=new r,u.left.segment=i.value()),u=u.left;else if(s<0)u.right||(u.right=new r,u.right.segment=i.value()),u=u.right;else if(i.hasNext())i.next(),u.mid||(u.mid=new r,u.mid.segment=i.value()),u=u.mid;else break}const l=u.value;return u.value=t,u.key=o,l}get(o){var t;return(t=this._getNode(o))===null||t===void 0?void 0:t.value}_getNode(o){const t=this._iter.reset(o);let i=this._root;for(;i;){const u=t.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else break}return i}has(o){const t=this._getNode(o);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,t){const i=this._iter.reset(o),u=[];let l=this._root;for(;l;){const s=i.cmp(l.segment);if(s>0)u.push([1,l]),l=l.left;else if(s<0)u.push([-1,l]),l=l.right;else if(i.hasNext())i.next(),u.push([0,l]),l=l.mid;else{for(t?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;u.length>0&&l.isEmpty();){let[a,E]=u.pop();switch(a){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}l=E}break}}}findSubstr(o){const t=this._iter.reset(o);let i=this._root,u;for(;i;){const l=t.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(t.hasNext())t.next(),u=i.value||u,i=i.mid;else break}return i&&i.value||u}findSuperstr(o){const t=this._iter.reset(o);let i=this._root;for(;i;){const u=t.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(t.hasNext())t.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(o){for(const[t,i]of this)o(i,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(o){o&&(yield*this._entries(o.left),o.value&&(yield[o.key,o.value]),yield*this._entries(o.mid),yield*this._entries(o.right))}}e.TernarySearchTree=h;class p{constructor(o,t){this[T]="ResourceMap",o instanceof p?(this.map=new Map(o.map),this.toKey=t!=null?t:p.defaultToKey):(this.map=new Map,this.toKey=o!=null?o:p.defaultToKey)}set(o,t){return this.map.set(this.toKey(o),t),this}get(o){return this.map.get(this.toKey(o))}has(o){return this.map.has(this.toKey(o))}get size(){return this.map.size}clear(){this.map.clear()}delete(o){return this.map.delete(this.toKey(o))}forEach(o,t){typeof t!="undefined"&&(o=o.bind(t));for(let[i,u]of this.map)o(u,w.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let o of this.map.keys())yield w.URI.parse(o)}*entries(){for(let o of this.map.entries())yield[w.URI.parse(o[0]),o[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let o of this.map)yield[w.URI.parse(o[0]),o[1]]}}e.ResourceMap=p,p.defaultToKey=c=>c.toString();var m;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(m=e.Touch||(e.Touch={}));class v{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var o;return(o=this._head)===null||o===void 0?void 0:o.value}get last(){var o;return(o=this._tail)===null||o===void 0?void 0:o.value}has(o){return this._map.has(o)}get(o,t=0){const i=this._map.get(o);if(!!i)return t!==0&&this.touch(i,t),i.value}set(o,t,i=0){let u=this._map.get(o);if(u)u.value=t,i!==0&&this.touch(u,i);else{switch(u={key:o,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(o,u),this._size++}return this}delete(o){return!!this.remove(o)}remove(o){const t=this._map.get(o);if(!!t)return this._map.delete(o),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const o=this._head;return this._map.delete(o.key),this.removeItem(o),this._size--,o.value}}forEach(o,t){const i=this._state;let u=this._head;for(;u;){if(t?o.bind(t)(u.value,u.key,this):o(u.value,u.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const o=this,t=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const l={value:i.key,done:!1};return i=i.next,l}else return{value:void 0,done:!0}}};return u}values(){const o=this,t=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const l={value:i.value,done:!1};return i=i.next,l}else return{value:void 0,done:!0}}};return u}entries(){const o=this,t=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(o._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const l={value:[i.key,i.value],done:!1};return i=i.next,l}else return{value:void 0,done:!0}}};return u}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(o){if(!(o>=this.size)){if(o===0){this.clear();return}let t=this._head,i=this.size;for(;t&&i>o;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}}addItemFirst(o){if(!this._head&&!this._tail)this._tail=o;else if(this._head)o.next=this._head,this._head.previous=o;else throw new Error("Invalid list");this._head=o,this._state++}addItemLast(o){if(!this._head&&!this._tail)this._head=o;else if(this._tail)o.previous=this._tail,this._tail.next=o;else throw new Error("Invalid list");this._tail=o,this._state++}removeItem(o){if(o===this._head&&o===this._tail)this._head=void 0,this._tail=void 0;else if(o===this._head){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this._head=o.next}else if(o===this._tail){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this._tail=o.previous}else{const t=o.next,i=o.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}o.next=void 0,o.previous=void 0,this._state++}touch(o,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(o===this._head)return;const i=o.next,u=o.previous;o===this._tail?(u.next=void 0,this._tail=u):(i.previous=u,u.next=i),o.previous=void 0,o.next=this._head,this._head.previous=o,this._head=o,this._state++}else if(t===2){if(o===this._tail)return;const i=o.next,u=o.previous;o===this._head?(i.previous=void 0,this._head=i):(i.previous=u,u.next=i),o.next=void 0,o.previous=this._tail,this._tail.next=o,this._tail=o,this._state++}}}toJSON(){const o=[];return this.forEach((t,i)=>{o.push([i,t])}),o}fromJSON(o){this.clear();for(const[t,i]of o)this.set(t,i)}}e.LinkedMap=v;class d extends v{constructor(o,t=1){super();this._limit=o,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(o){this._limit=o,this.checkTrim()}get ratio(){return this._ratio}set ratio(o){this._ratio=Math.min(Math.max(0,o),1),this.checkTrim()}get(o,t=2){return super.get(o,t)}peek(o){return super.get(o,0)}set(o,t){return super.set(o,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(we[107],Ee([0,1,22,8]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...pe){return function(Ce,Te){for(let Ue=0,be=pe.length;Ue<be;Ue++){const Ke=pe[Ue](Ce,Te);if(Ke)return Ke}return null}}e.or=T,e.matchesStrictPrefix=P.bind(void 0,!1),e.matchesPrefix=P.bind(void 0,!0);function P(pe,Ce,Te){if(!Te||Te.length<Ce.length)return null;let Ue;return pe?Ue=D.startsWithIgnoreCase(Te,Ce):Ue=Te.indexOf(Ce)===0,Ue?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(pe,Ce){const Te=Ce.toLowerCase().indexOf(pe.toLowerCase());return Te===-1?null:[{start:Te,end:Te+pe.length}]}e.matchesContiguousSubString=S;function I(pe,Ce){return y(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=I;function y(pe,Ce,Te,Ue){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(pe[Te]===Ce[Ue]){let be=null;return(be=y(pe,Ce,Te+1,Ue+1))?m({start:Ue,end:Ue+1},be):null}return y(pe,Ce,Te,Ue+1)}function n(pe){return 97<=pe&&pe<=122}function A(pe){return 65<=pe&&pe<=90}e.isUpper=A;function k(pe){return 48<=pe&&pe<=57}function _(pe){return pe===32||pe===9||pe===10||pe===13}const f=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>f.add(pe.charCodeAt(0)));function r(pe){return _(pe)||f.has(pe)}function h(pe,Ce){return pe===Ce||r(pe)&&r(Ce)}function p(pe){return n(pe)||A(pe)||k(pe)}function m(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function v(pe,Ce){for(let Te=Ce;Te<pe.length;Te++){const Ue=pe.charCodeAt(Te);if(A(Ue)||k(Ue)||Te>0&&!p(pe.charCodeAt(Te-1)))return Te}return pe.length}function d(pe,Ce,Te,Ue){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(pe[Te]!==Ce[Ue].toLowerCase())return null;{let be=null,Ke=Ue+1;for(be=d(pe,Ce,Te+1,Ue+1);!be&&(Ke=v(Ce,Ke))<Ce.length;)be=d(pe,Ce,Te+1,Ke),Ke++;return be===null?null:m({start:Ue,end:Ue+1},be)}}function c(pe){let Ce=0,Te=0,Ue=0,be=0,Ke=0;for(let He=0;He<pe.length;He++)Ke=pe.charCodeAt(He),A(Ke)&&Ce++,n(Ke)&&Te++,p(Ke)&&Ue++,k(Ke)&&be++;const V=Ce/pe.length,X=Te/pe.length,_e=Ue/pe.length,Me=be/pe.length;return{upperPercent:V,lowerPercent:X,alphaPercent:_e,numericPercent:Me}}function o(pe){const{upperPercent:Ce,lowerPercent:Te}=pe;return Te===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Te,alphaPercent:Ue,numericPercent:be}=pe;return Te>.2&&Ce<.8&&Ue>.6&&be<.2}function i(pe){let Ce=0,Te=0,Ue=0,be=0;for(let Ke=0;Ke<pe.length;Ke++)Ue=pe.charCodeAt(Ke),A(Ue)&&Ce++,n(Ue)&&Te++,_(Ue)&&be++;return(Ce===0||Te===0)&&be===0?pe.length<=30:Ce<=5}function u(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!i(pe)||Ce.length>60)return null;const Te=c(Ce);if(!t(Te)){if(!o(Te))return null;Ce=Ce.toLowerCase()}let Ue=null,be=0;for(pe=pe.toLowerCase();be<Ce.length&&(Ue=d(pe,Ce,0,be))===null;)be=v(Ce,be+1);return Ue}e.matchesCamelCase=u;function l(pe,Ce,Te=!1){if(!Ce||Ce.length===0)return null;let Ue=null,be=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();be<Ce.length&&(Ue=s(pe,Ce,0,be,Te))===null;)be=a(Ce,be+1);return Ue}e.matchesWords=l;function s(pe,Ce,Te,Ue,be){if(Te===pe.length)return[];if(Ue===Ce.length)return null;if(h(pe.charCodeAt(Te),Ce.charCodeAt(Ue))){let Ke=null,V=Ue+1;if(Ke=s(pe,Ce,Te+1,Ue+1,be),!be)for(;!Ke&&(V=a(Ce,V))<Ce.length;)Ke=s(pe,Ce,Te+1,V,be),V++;return Ke===null?null:m({start:Ue,end:Ue+1},Ke)}else return null}function a(pe,Ce){for(let Te=Ce;Te<pe.length;Te++)if(r(pe.charCodeAt(Te))||Te>0&&r(pe.charCodeAt(Te-1)))return Te;return pe.length}const E=T(e.matchesPrefix,u,S),R=T(e.matchesPrefix,u,I),g=new w.LRUCache(1e4);function b(pe,Ce,Te=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let Ue=g.get(pe);Ue||(Ue=new RegExp(D.convertSimple2RegExpPattern(pe),"i"),g.set(pe,Ue));const be=Ue.exec(Ce);return be?[{start:be.index,end:be.index+be[0].length}]:Te?R(pe,Ce):E(pe,Ce)}e.matchesFuzzy=b;function C(pe,Ce){const Te=W(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Te?x(Te):null}e.matchesFuzzy2=C;function F(pe,Ce,Te,Ue,be,Ke){const V=Math.min(13,pe.length);for(;Te<V;Te++){const X=W(pe,Ce,Te,Ue,be,Ke,!1);if(X)return X}return[0,Ke]}e.anyScore=F;function x(pe){if(typeof pe=="undefined")return[];const Ce=[],Te=pe[1];for(let Ue=pe.length-1;Ue>1;Ue--){const be=pe[Ue]+Te,Ke=Ce[Ce.length-1];Ke&&Ke.end===be?Ke.end=be+1:Ce.push({start:be,end:be+1})}return Ce}e.createMatches=x;const le=128;function B(){const pe=[],Ce=[];for(let Te=0;Te<=le;Te++)Ce[Te]=0;for(let Te=0;Te<=le;Te++)pe.push(Ce.slice(0));return pe}function H(pe){const Ce=[];for(let Te=0;Te<=pe;Te++)Ce[Te]=0;return Ce}const G=H(2*le),L=H(2*le),$=B(),U=B(),Q=B(),N=!1;function Z(pe,Ce,Te,Ue,be){function Ke(X,_e,Me=" "){for(;X.length<_e;)X=Me+X;return X}let V=` |   |${Ue.split("").map(X=>Ke(X,3)).join("|")}
`;for(let X=0;X<=Te;X++)X===0?V+=" |":V+=`${Ce[X-1]}|`,V+=pe[X].slice(0,be+1).map(_e=>Ke(_e.toString(),3)).join("|")+`
`;return V}function ne(pe,Ce,Te,Ue){pe=pe.substr(Ce),Te=Te.substr(Ue),console.log(Z(U,pe,pe.length,Te,Te.length)),console.log(Z(Q,pe,pe.length,Te,Te.length)),console.log(Z($,pe,pe.length,Te,Te.length))}function re(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Te=pe.codePointAt(Ce);switch(Te){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!D.isEmojiImprecise(Te)}}function ye(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Ae(pe,Ce,Te){return Ce[pe]!==Te[pe]}function Be(pe,Ce,Te,Ue,be,Ke,V=!1){for(;Ce<Te&&be<Ke;)pe[Ce]===Ue[be]&&(V&&(G[Ce]=be),Ce+=1),be+=1;return Ce===Te}e.isPatternInWord=Be;var Re;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var xe;(function(pe){pe.Default=[-100,0];function Ce(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}pe.isDefault=Ce})(xe=e.FuzzyScore||(e.FuzzyScore={}));function W(pe,Ce,Te,Ue,be,Ke,V){const X=pe.length>le?le:pe.length,_e=Ue.length>le?le:Ue.length;if(!(Te>=X||Ke>=_e||X-Te>_e-Ke)&&!!Be(Ce,Te,X,be,Ke,_e,!0)){K(X,_e,Te,Ke,Ce,be);let Me=1,He=1,Oe=Te,Xe=Ke;const z=[!1];for(Me=1,Oe=Te;Oe<X;Me++,Oe++){const se=G[Oe],fe=L[Oe],ve=Oe+1<X?L[Oe+1]:_e;for(He=se-Ke+1,Xe=se;Xe<ve;He++,Xe++){let $e=Number.MIN_SAFE_INTEGER,Ne=!1;Xe<=fe&&($e=J(pe,Ce,Oe,Te,Ue,be,Xe,_e,Ke,$[Me-1][He-1]===0,z));let Ve=0;$e!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Ve=$e+U[Me-1][He-1]);const Qe=Xe>se,Ze=Qe?U[Me][He-1]+($[Me][He-1]>0?-5:0):0,ct=Xe>se+1&&$[Me][He-1]>0,st=ct?U[Me][He-2]+($[Me][He-2]>0?-5:0):0;if(ct&&(!Qe||st>=Ze)&&(!Ne||st>=Ve))U[Me][He]=st,Q[Me][He]=3,$[Me][He]=0;else if(Qe&&(!Ne||Ze>=Ve))U[Me][He]=Ze,Q[Me][He]=2,$[Me][He]=0;else if(Ne)U[Me][He]=Ve,Q[Me][He]=1,$[Me][He]=$[Me-1][He-1]+1;else throw new Error("not possible")}}if(N&&ne(pe,Te,Ue,Ke),!(!z[0]&&!V)){Me--,He--;const ie=[U[Me][He],Ke];let ce=0,j=0;for(;Me>=1;){let se=He;do{const fe=Q[Me][se];if(fe===3)se=se-2;else if(fe===2)se=se-1;else break}while(se>=1);ce>1&&Ce[Te+Me-1]===be[Ke+He-1]&&!Ae(se+Ke-1,Ue,be)&&ce+1>$[Me][se]&&(se=He),se===He?ce++:ce=1,j||(j=se),Me--,He=se-1,ie.push(He)}_e===X&&(ie[0]+=2);const Y=j-X;return ie[0]-=Y,ie}}}e.fuzzyScore=W;function K(pe,Ce,Te,Ue,be,Ke){let V=pe-1,X=Ce-1;for(;V>=Te&&X>=Ue;)be[V]===Ke[X]&&(L[V]=X,V--),X--}function J(pe,Ce,Te,Ue,be,Ke,V,X,_e,Me,He){if(Ce[Te]!==Ke[V])return Number.MIN_SAFE_INTEGER;let Oe=1,Xe=!1;return V===Te-Ue?Oe=pe[Te]===be[V]?7:5:Ae(V,be,Ke)&&(V===0||!Ae(V-1,be,Ke))?(Oe=pe[Te]===be[V]?7:5,Xe=!0):re(Ke,V)&&(V===0||!re(Ke,V-1))?Oe=5:(re(Ke,V-1)||ye(Ke,V-1))&&(Oe=5,Xe=!0),Oe>1&&Te===Ue&&(He[0]=!0),Xe||(Xe=Ae(V,be,Ke)||re(Ke,V-1)||ye(Ke,V-1)),Te===Ue?V>_e&&(Oe-=Xe?3:5):Me?Oe+=Xe?2:0:Oe+=Xe?0:1,V+1===X&&(Oe-=Xe?3:5),Oe}function ae(pe,Ce,Te,Ue,be,Ke,V){return De(pe,Ce,Te,Ue,be,Ke,!0,V)}e.fuzzyScoreGracefulAggressive=ae;function ge(pe,Ce,Te,Ue,be,Ke,V){return De(pe,Ce,Te,Ue,be,Ke,!1,V)}e.fuzzyScoreGraceful=ge;function De(pe,Ce,Te,Ue,be,Ke,V,X){let _e=W(pe,Ce,Te,Ue,be,Ke,X);if(_e&&!V)return _e;if(pe.length>=3){const Me=Math.min(7,pe.length-1);for(let He=Te+1;He<Me;He++){const Oe=Le(pe,He);if(Oe){const Xe=W(Oe,Oe.toLowerCase(),Te,Ue,be,Ke,X);Xe&&(Xe[0]-=3,(!_e||Xe[0]>_e[0])&&(_e=Xe))}}}return _e}function Le(pe,Ce){if(!(Ce+1>=pe.length)){const Te=pe[Ce],Ue=pe[Ce+1];if(Te!==Ue)return pe.slice(0,Ce)+Ue+Te+pe.slice(Ce+2)}}}),define(we[108],Ee([0,1,37,107,8]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const P=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${P.source}`,"g");function I(h){return h.replace(S,(p,m)=>m?p:`\\${p}`)}e.escapeIcons=I;const y=new RegExp(`\\\\${P.source}`,"g");function n(h){return h.replace(y,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=n;const A=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function k(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(A,(p,m,v,d)=>v?p:m||d||"")}e.stripIcons=k;function _(h){const p=h.indexOf(e.iconStartMarker);return p===-1?{text:h}:f(h,p)}e.parseLabelWithIcons=_;function f(h,p){const m=[];let v="";function d(a){if(a){v+=a;for(const E of a)m.push(t)}}let c=-1,o="",t=0,i,u,l=p;const s=h.length;for(d(h.substr(0,p));l<s;)i=h[l],u=h[l+1],i===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(c=l,d(o),o=e.iconStartMarker,l++):i===")"&&c!==-1?(t+=l-c+1,c=-1,o=""):c!==-1?/^[a-z0-9\-]$/i.test(i)?o+=i:(d(o),c=-1,o=""):d(i),l++;return d(o),{text:v,iconOffsets:m}}function r(h,p,m=!1){const{text:v,iconOffsets:d}=p;if(!d||d.length===0)return(0,D.matchesFuzzy)(h,v,m);const c=(0,T.ltrim)(v," "),o=v.length-c.length,t=(0,D.matchesFuzzy)(h,c,m);if(t)for(const i of t){const u=d[i.start+o]+o;i.start+=u,i.end+=u}return t}e.matchesFuzzyIconAware=r}),define(we[80],Ee([0,1,15,108,10]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",p=!1){var m,v;if(this.value=h,typeof this.value!="string")throw(0,T.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1):(this.isTrusted=(m=p.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(v=p.supportThemeIcons)!==null&&v!==void 0?v:!1)}appendText(h,p=0){return this.value+=k(this.supportThemeIcons?(0,D.escapeIcons)(h):h).replace(/([ \t]+)/g,(m,v)=>"&nbsp;".repeat(v.length)).replace(/^>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,p){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}}e.MarkdownString=S;function I(r){return y(r)?!r.value:Array.isArray(r)?r.every(I):!0}e.isEmptyMarkdownString=I;function y(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=y;function n(r,h){return!r&&!h?!0:!r||!h?!1:Array.isArray(r)&&Array.isArray(h)?(0,w.equals)(r,h,A):y(r)&&y(h)?A(r,h):!1}e.markedStringsEquals=n;function A(r,h){return r===h?!0:!r||!h?!1:r.value===h.value&&r.isTrusted===h.isTrusted&&r.supportThemeIcons===h.supportThemeIcons}function k(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function _(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=_;function f(r){const h=[],p=r.split("|").map(v=>v.trim());r=p[0];const m=p[1];if(m){const v=/height=(\d+)/.exec(m),d=/width=(\d+)/.exec(m),c=v?v[1]:"",o=d?d[1]:"",t=isFinite(parseInt(o)),i=isFinite(parseInt(c));t&&h.push(`width="${o}"`),i&&h.push(`height="${c}"`)}return{href:r,dimensions:h}}e.parseHrefAndDimensions=f}),define(we[57],Ee([0,1,26,8,2]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function P(n){return JSON.stringify(n,I)}e.stringify=P;function S(n){let A=JSON.parse(n);return A=y(A),A}e.parse=S;function I(n,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,D.regExpFlags)(A)}:A}function y(n,A=0){if(!n||A>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return T.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof w.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let k=0;k<n.length;++k)n[k]=y(n[k],A+1);else for(const k in n)Object.hasOwnProperty.call(n,k)&&(n[k]=y(n[k],A+1))}return n}e.revive=y}),define(we[16],Ee([0,1,2,21]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var T;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.vscodeWebviewResource="vscode-webview-resource",I.extension="extension",I.vscodeFileResource="vscode-file"})(T=e.Schemas||(e.Schemas={}));class P{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,n,A){this._hosts[y]=n,this._ports[y]=A}setConnectionToken(y,n){this._connectionTokens[y]=n}rewrite(y){if(this._delegate)return this._delegate(y);const n=y.authority;let A=this._hosts[n];A&&A.indexOf(":")!==-1&&(A=`[${A}]`);const k=this._ports[n],_=this._connectionTokens[n];let f=`path=${encodeURIComponent(y.path)}`;return typeof _=="string"&&(f+=`&tkn=${encodeURIComponent(_)}`),w.URI.from({scheme:D.isWeb?this._preferredWebSchema:T.vscodeRemoteResource,authority:`${A}:${k}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new P;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,n,A){const k=this.toUri(y,n);return k.scheme===T.vscodeRemote?e.RemoteAuthorities.rewrite(k):D.isNative&&(A||D.isPreferringBrowserCodeLoad)&&k.scheme===T.file?k.with({scheme:T.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(y,n){const A=this.toUri(y,n);return A.scheme===T.vscodeFileResource?A.with({scheme:T.file,authority:A.authority!==this.FALLBACK_AUTHORITY?A.authority:null,query:null,fragment:null}):A}toUri(y,n){return w.URI.isUri(y)?y:w.URI.parse(n.toUrl(y))}}e.FileAccess=new S}),define(we[24],Ee([0,1,38,11,2,8,16,21]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(f){return(0,T.uriToFsPath)(f,!0)}e.originalFSPath=y;class n{constructor(r){this._ignorePathCasing=r}compare(r,h,p=!1){return r===h?0:(0,P.compare)(this.getComparisonKey(r,p),this.getComparisonKey(h,p))}isEqual(r,h,p=!1){return r===h?!0:!r||!h?!1:this.getComparisonKey(r,p)===this.getComparisonKey(h,p)}getComparisonKey(r,h=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,h,p=!1){if(r.scheme===h.scheme){if(r.scheme===S.Schemas.file)return w.isEqualOrParent(y(r),y(h),this._ignorePathCasing(r))&&r.query===h.query&&(p||r.fragment===h.fragment);if((0,e.isEqualAuthority)(r.authority,h.authority))return w.isEqualOrParent(r.path,h.path,this._ignorePathCasing(r),"/")&&r.query===h.query&&(p||r.fragment===h.fragment)}return!1}joinPath(r,...h){return T.URI.joinPath(r,...h)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return D.posix.basename(r.path)}extname(r){return D.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let h;return r.scheme===S.Schemas.file?h=T.URI.file(D.dirname(y(r))).path:(h=D.posix.dirname(r.path),r.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),h="/")),r.with({path:h})}normalizePath(r){if(!r.path.length)return r;let h;return r.scheme===S.Schemas.file?h=T.URI.file(D.normalize(y(r))).path:h=D.posix.normalize(r.path),r.with({path:h})}relativePath(r,h){if(!(r.scheme!==h.scheme||!(0,e.isEqualAuthority)(r.authority,h.authority))){if(r.scheme===S.Schemas.file){const v=D.relative(y(r),y(h));return I.isWindows?w.toSlashes(v):v}let p=r.path||"/",m=h.path||"/";if(this._ignorePathCasing(r)){let v=0;for(const d=Math.min(p.length,m.length);v<d&&!(p.charCodeAt(v)!==m.charCodeAt(v)&&p.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);p=m.substr(0,v)+p.substr(v)}return D.posix.relative(p,m)}}resolvePath(r,h){if(r.scheme===S.Schemas.file){const p=T.URI.file(D.resolve(y(r),h));return r.with({authority:p.authority,path:p.path})}return h.indexOf("/")===-1&&(h=w.toSlashes(h),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h)),r.with({path:D.posix.resolve(r.path,h)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,h){return r===h||(0,P.equalsIgnoreCase)(r,h)}hasTrailingPathSeparator(r,h=D.sep){if(r.scheme===S.Schemas.file){const p=y(r);return p.length>w.getRoot(p).length&&p[p.length-1]===h}else{const p=r.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,h=D.sep){return(0,e.hasTrailingPathSeparator)(r,h)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,h=D.sep){let p=!1;if(r.scheme===S.Schemas.file){const m=y(r);p=m!==void 0&&m.length===w.getRoot(m).length&&m[m.length-1]===h}else{h="/";const m=r.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(r,h)?r.with({path:r.path+"/"}):r}}e.ExtUri=n,e.extUri=new n(()=>!1),e.extUriBiasedIgnorePathCase=new n(f=>f.scheme===S.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new n(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function A(f,r){const h=[];for(let p=0;p<f.length;p++){const m=r(f[p]);f.some((v,d)=>d===p?!1:(0,e.isEqualOrParent)(m,r(v)))||h.push(f[p])}return h}e.distinctParents=A;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function r(h){const p=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,o]=d.split(":");c&&o&&p.set(c,o)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&p.set(f.META_DATA_MIME,v),p}f.parseMetaData=r})(k=e.DataUri||(e.DataUri={}));function _(f,r,h){if(r){let p=f.path;return p&&p[0]!==D.posix.sep&&(p=D.posix.sep+p),f.with({scheme:h,authority:r,path:p})}return f.with({scheme:h})}e.toLocalResource=_}),define(we[13],Ee([0,1,20,10,3,6,46,24]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(U){return!!U&&typeof U.then=="function"}e.isThenable=y;function n(U){const Q=new w.CancellationTokenSource,N=U(Q.token),Z=new Promise((ne,re)=>{Q.token.onCancellationRequested(()=>{re((0,D.canceled)())}),Promise.resolve(N).then(ye=>{Q.dispose(),ne(ye)},ye=>{Q.dispose(),re(ye)})});return new class{cancel(){Q.cancel()}then(ne,re){return Z.then(ne,re)}catch(ne){return this.then(void 0,ne)}finally(ne){return Z.finally(ne)}}}e.createCancelablePromise=n;function A(U,Q,N){return Promise.race([U,new Promise(Z=>Q.onCancellationRequested(()=>Z(N)))])}e.raceCancellation=A;async function k(U){let Q=-1;const N=U.map((ne,re)=>ne.then(ye=>(Q=re,ye))),Z=await Promise.race(N);return U.forEach((ne,re)=>{re!==Q&&ne.cancel()}),Z}e.raceCancellablePromises=k;function _(U,Q,N){let Z;const ne=setTimeout(()=>{Z==null||Z(void 0),N==null||N()},Q);return Promise.race([U.finally(()=>clearTimeout(ne)),new Promise(re=>Z=re)])}e.raceTimeout=_;function f(U){return new Promise((Q,N)=>{const Z=U();y(Z)?Z.then(Q,N):Q(Z)})}e.asPromise=f;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(N,N).then(Z)})}return new Promise((N,Z)=>{this.queuedPromise.then(N,Z)})}return this.activePromise=Q(),new Promise((N,Z)=>{this.activePromise.then(ne=>{this.activePromise=null,N(ne)},ne=>{this.activePromise=null,Z(ne)})})}}e.Throttler=r;class h{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=h;class p{constructor(){this.promiseMap=new Map}queue(Q,N){var Z;const re=((Z=this.promiseMap.get(Q))!==null&&Z!==void 0?Z:Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(Q)===re&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,re),re}}e.SequencerByKey=p;class m{constructor(Q){this.defaultDelay=Q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,N=this.defaultDelay){return this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Z,ne)=>{this.doResolve=Z,this.doReject=ne}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Z=this.task;return this.task=null,Z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class v{constructor(Q){this.delayer=new m(Q),this.throttler=new r}trigger(Q,N){return this.delayer.trigger(()=>this.throttler.queue(Q),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class d{constructor(){this._isOpen=!1,this._promise=new Promise((Q,N)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class c extends d{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function o(U,Q){return Q?new Promise((N,Z)=>{const ne=setTimeout(N,U);Q.onCancellationRequested(()=>{clearTimeout(ne),Z((0,D.canceled)())})}):n(N=>o(U,N))}e.timeout=o;function t(U,Q=0){const N=setTimeout(U,Q);return(0,P.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=t;function i(U){return U.then(void 0,Q=>{})}e.ignoreErrors=i;function u(U){const Q=[];let N=0;const Z=U.length;function ne(){return N<Z?U[N++]():null}function re(ye){ye!=null&&Q.push(ye);const Ae=ne();return Ae?Ae.then(re):Promise.resolve(Q)}return Promise.resolve(null).then(re)}e.sequence=u;function l(U,Q=Z=>!!Z,N=null){let Z=0;const ne=U.length,re=()=>{if(Z>=ne)return Promise.resolve(N);const ye=U[Z++];return Promise.resolve(ye()).then(Be=>Q(Be)?Promise.resolve(Be):re())};return re()}e.first=l;function s(U,Q=Z=>!!Z,N=null){if(U.length===0)return Promise.resolve(N);let Z=U.length;const ne=()=>{var re,ye;Z=-1;for(const Ae of U)(ye=(re=Ae).cancel)===null||ye===void 0||ye.call(re)};return new Promise((re,ye)=>{for(const Ae of U)Ae.then(Be=>{--Z>=0&&Q(Be)?(ne(),re(Be)):Z===0&&re(N)}).catch(Be=>{--Z>=0&&(ne(),ye(Be))})})}e.firstParallel=s;class a{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new T.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((N,Z)=>{this.outstandingPromises.push({factory:Q,c:N,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const N=Q.factory();N.then(Q.c,Q.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=a;class E extends a{constructor(){super(1)}}e.Queue=E;class R{constructor(){this.queues=new Map}queueFor(Q,N=I.extUri){const Z=N.getComparisonKey(Q);let ne=this.queues.get(Z);return ne||(ne=new E,T.Event.once(ne.onFinished)(()=>{ne==null||ne.dispose(),this.queues.delete(Z)}),this.queues.set(Z,ne)),ne}dispose(){this.queues.forEach(Q=>Q.dispose()),this.queues.clear()}}e.ResourceQueue=R;class g{constructor(Q,N){this._token=-1,typeof Q=="function"&&typeof N=="number"&&this.setIfNotSet(Q,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},N)}setIfNotSet(Q,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},N))}}e.TimeoutTimer=g;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,N){this.cancel(),this._token=setInterval(()=>{Q()},N)}}e.IntervalTimer=b;class C{constructor(Q,N){this.timeoutToken=-1,this.runner=Q,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=C;class F extends C{constructor(Q,N){super(Q,N);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=Q=>{const N=setTimeout(()=>Q(U));let Z=!1;return{dispose(){Z||(Z=!0,clearTimeout(N))}}}}else e.runWhenIdle=(U,Q)=>{const N=requestIdleCallback(U,typeof Q=="number"?{timeout:Q}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(N))}}}}();class x{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=x;async function le(U,Q,N){let Z;for(let ne=0;ne<N;ne++)try{return await U()}catch(re){Z=re,await o(Q)}throw Z}e.retry=le;class B{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var Q;(Q=this._pending)===null||Q===void 0||Q.cancel()}setPending(Q,N,Z){return this._pending={taskId:Q,cancel:()=>Z==null?void 0:Z(),promise:N},N.then(()=>this.donePending(Q),()=>this.donePending(Q)),N}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let N,Z;const ne=new Promise((re,ye)=>{N=re,Z=ye});this._next={run:Q,promise:ne,promiseResolve:N,promiseReject:Z}}return this._next.promise}}e.TaskSequentializer=B;class H{constructor(Q){this.interval=Q,this.lastIncrementTime=0,this.value=0}increment(){const Q=Date.now();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class G{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,N)=>{this.completeCallback=Q,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(N=>{this.completeCallback(Q),this.resolved=!0,N()})}error(Q){return new Promise(N=>{this.errorCallback(Q),this.rejected=!0,N()})}cancel(){new Promise(Q=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,Q()})}}e.DeferredPromise=G;class L extends T.Emitter{async fireAsync(Q,N,Z){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const ne of this._listeners)this._asyncDeliveryQueue.push([ne,Q]);for(;this._asyncDeliveryQueue.size>0&&!N.isCancellationRequested;){const[ne,re]=this._asyncDeliveryQueue.shift(),ye=[],Ae=Object.assign(Object.assign({},re),{waitUntil:Be=>{if(Object.isFrozen(ye))throw new Error("waitUntil can NOT be called asynchronous");Z&&(Be=Z(Be,typeof ne=="function"?ne:ne[0])),ye.push(Be)}});try{typeof ne=="function"?ne.call(void 0,Ae):ne[0].call(ne[1],Ae)}catch(Be){(0,D.onUnexpectedError)(Be);continue}Object.freeze(ye),await $.settled(ye).catch(Be=>(0,D.onUnexpectedError)(Be))}}}}e.AsyncEmitter=L;var $;(function(U){async function Q(re){return typeof Promise.allSettled=="function"?N(re):Z(re)}U.allSettled=Q;async function N(re){return Promise.allSettled(re)}async function Z(re){return Promise.all(re.map(ye=>ye.then(Ae=>({status:"fulfilled",value:Ae}),Ae=>({status:"rejected",reason:Ae}))))}async function ne(re){let ye;const Ae=await Promise.all(re.map(Be=>Be.then(Re=>Re,Re=>{ye||(ye=Re)})));if(typeof ye!="undefined")throw ye;return Ae}U.settled=ne})($=e.Promises||(e.Promises={}))}),define(we[109],Ee([0,1,11,13]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new D.IdleValue(()=>{const c=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:c,collatorIsNumeric:c.resolvedOptions().numeric}}),P=new D.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new D.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(c,o,t=!1){const i=c||"",u=o||"",l=T.value.collator.compare(i,u);return T.value.collatorIsNumeric&&l===0&&i!==u?i<u?-1:1:l}e.compareFileNames=I;function y(c,o){const t=P.value.collator;return c=c||"",o=o||"",h(t,c,o)}e.compareFileNamesDefault=y;function n(c,o,t=!1){t||(c=c&&c.toLowerCase(),o=o&&o.toLowerCase());const[i,u]=f(c),[l,s]=f(o);return i!==l?i<l?-1:1:u===s?0:u<s?-1:1}e.noIntlCompareFileNames=n;function A(c,o){const[t,i]=f(c),[u,l]=f(o);let s=T.value.collator.compare(i,l);if(s===0){if(T.value.collatorIsNumeric&&i!==l)return i<l?-1:1;if(s=T.value.collator.compare(t,u),T.value.collatorIsNumeric&&s===0&&t!==u)return t<u?-1:1}return s}e.compareFileExtensions=A;function k(c,o){c=c||"",o=o||"";const t=r(c),i=r(o),u=P.value.collator,l=S.value.collator;let s;return s=h(l,t,i),s!==0?s:h(u,c,o)}e.compareFileExtensionsDefault=k;const _=/^(.*?)(\.([^.]*))?$/;function f(c,o=!1){const t=c?_.exec(c):[];let i=[t&&t[1]||"",t&&t[3]||""];return o&&(!i[0]&&i[1]||i[0]&&i[0].charAt(0)===".")&&(i=[i[0]+"."+i[1],""]),i}function r(c){const o=c?_.exec(c):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function h(c,o,t){let i=c.compare(o,t);return i!==0?i:o.length!==t.length?o.length<t.length?-1:1:0}function p(c,o,t=!1){return t||(c=c&&c.toLowerCase(),o=o&&o.toLowerCase()),c===o?0:c<o?-1:1}function m(c,o,t=!1){const i=c.split(w.sep),u=o.split(w.sep),l=i.length-1,s=u.length-1;let a,E;for(let R=0;;R++){if(a=l===R,E=s===R,a&&E)return I(i[R],u[R],t);if(a)return-1;if(E)return 1;const g=p(i[R],u[R],t);if(g!==0)return g}}e.comparePaths=m;function v(c,o,t){const i=c.toLowerCase(),u=o.toLowerCase(),l=d(c,o,t);if(l)return l;const s=i.endsWith(t),a=u.endsWith(t);if(s!==a)return s?-1:1;const E=I(i,u);return E!==0?E:i.localeCompare(u)}e.compareAnything=v;function d(c,o,t){const i=c.toLowerCase(),u=o.toLowerCase(),l=i.startsWith(t),s=u.startsWith(t);if(l!==s)return l?-1:1;if(l&&s){if(i.length<u.length)return-1;if(i.length>u.length)return 1}return 0}e.compareByPrefix=d}),define(we[28],Ee([0,1,8,38,11,22,13]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const y="**",n="/",A="[/\\\\]",k="[^/\\\\]",_=/\//g;function f(N){switch(N){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}|${A}${k}+)*?`}}function r(N,Z){if(!N)return[];const ne=[];let re=!1,ye=!1,Ae="";for(const Be of N){switch(Be){case Z:if(!re&&!ye){ne.push(Ae),Ae="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ye=!0;break;case"]":ye=!1;break}Ae+=Be}return Ae&&ne.push(Ae),ne}e.splitGlobAware=r;function h(N){if(!N)return"";let Z="";const ne=r(N,n);if(ne.every(re=>re===y))Z=".*";else{let re=!1;ne.forEach((ye,Ae)=>{if(ye===y){re||(Z+=f(2),re=!0);return}let Be=!1,Re="",xe=!1,W="";for(const K of ye){if(K!=="}"&&Be){Re+=K;continue}if(xe&&(K!=="]"||!W)){let J;K==="-"?J=K:(K==="^"||K==="!")&&!W?J="^":K===n?J="":J=w.escapeRegExpCharacters(K),W+=J;continue}switch(K){case"{":Be=!0;continue;case"[":xe=!0;continue;case"}":Z+=`(?:${r(Re,",").map(ge=>h(ge)).join("|")})`,Be=!1,Re="";break;case"]":Z+="["+W+"]",xe=!1,W="";break;case"?":Z+=k;continue;case"*":Z+=f(1);continue;default:Z+=w.escapeRegExpCharacters(K)}}Ae<ne.length-1&&(ne[Ae+1]!==y||Ae+2<ne.length)&&(Z+=A),re=!1})}return Z}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.LRUCache(1e4),i=function(){return!1},u=function(){return null};function l(N,Z){if(!N)return u;let ne;typeof N!="string"?ne=N.pattern:ne=N,ne=ne.trim();const re=`${ne}_${!!Z.trimForExclusions}`;let ye=t.get(re);if(ye)return s(ye,N);let Ae;if(p.test(ne)){const Be=ne.substr(4);ye=function(Re,xe){return typeof Re=="string"&&Re.endsWith(Be)?ne:null}}else(Ae=m.exec(a(ne,Z)))?ye=E(Ae[1],ne):(Z.trimForExclusions?d:v).test(ne)?ye=R(ne,Z):(Ae=c.exec(a(ne,Z)))?ye=g(Ae[1].substr(1),ne,!0):(Ae=o.exec(a(ne,Z)))?ye=g(Ae[1],ne,!1):ye=b(ne);return t.set(re,ye),s(ye,N)}function s(N,Z){return typeof Z=="string"?N:function(ne,re){return D.isEqualOrParent(ne,Z.base)?N(T.relative(Z.base,ne),re):null}}function a(N,Z){return Z.trimForExclusions&&N.endsWith("/**")?N.substr(0,N.length-2):N}function E(N,Z){const ne=`/${N}`,re=`\\${N}`,ye=function(Be,Re){return typeof Be!="string"?null:Re?Re===N?Z:null:Be===N||Be.endsWith(ne)||Be.endsWith(re)?Z:null},Ae=[N];return ye.basenames=Ae,ye.patterns=[Z],ye.allBasenames=Ae,ye}function R(N,Z){const ne=Q(N.slice(1,-1).split(",").map(Re=>l(Re,Z)).filter(Re=>Re!==u),N),re=ne.length;if(!re)return u;if(re===1)return ne[0];const ye=function(Re,xe){for(let W=0,K=ne.length;W<K;W++)if(ne[W](Re,xe))return N;return null},Ae=ne.find(Re=>!!Re.allBasenames);Ae&&(ye.allBasenames=Ae.allBasenames);const Be=ne.reduce((Re,xe)=>xe.allPaths?Re.concat(xe.allPaths):Re,[]);return Be.length&&(ye.allPaths=Be),ye}function g(N,Z,ne){const re=T.sep===T.posix.sep,ye=re?N:N.replace(_,T.sep),Ae=T.sep+ye,Be=T.posix.sep+N,Re=ne?function(xe,W){return typeof xe=="string"&&(xe===ye||xe.endsWith(Ae)||!re&&(xe===N||xe.endsWith(Be)))?Z:null}:function(xe,W){return typeof xe=="string"&&(xe===ye||!re&&xe===N)?Z:null};return Re.allPaths=[(ne?"*/":"./")+N],Re}function b(N){try{const Z=new RegExp(`^${h(N)}$`);return function(ne){return Z.lastIndex=0,typeof ne=="string"&&Z.test(ne)?N:null}}catch(Z){return u}}function C(N,Z,ne){return!N||typeof Z!="string"?!1:F(N)(Z,void 0,ne)}e.match=C;function F(N,Z={}){if(!N)return i;if(typeof N=="string"||H(N)){const ne=l(N,Z);if(ne===u)return i;const re=function(ye,Ae){return!!ne(ye,Ae)};return ne.allBasenames&&(re.allBasenames=ne.allBasenames),ne.allPaths&&(re.allPaths=ne.allPaths),re}return $(N,Z)}e.parse=F;function x(N){if(!!N){let Z;return ne=>(Z||(Z=(N()||Promise.resolve([])).then(re=>re?B(re):{})),Z.then(re=>!!re[ne]))}}e.hasSiblingPromiseFn=x;function le(N){if(!!N){let Z;return ne=>{if(!Z){const re=N();Z=re?B(re):{}}return!!Z[ne]}}}e.hasSiblingFn=le;function B(N){const Z={};for(const ne of N)Z[ne]=!0;return Z}function H(N){const Z=N;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=H;function G(N){return N.allBasenames||[]}e.getBasenameTerms=G;function L(N){return N.allPaths||[]}e.getPathTerms=L;function $(N,Z){const ne=Q(Object.getOwnPropertyNames(N).map(Re=>U(Re,N[Re],Z)).filter(Re=>Re!==u)),re=ne.length;if(!re)return u;if(!ne.some(Re=>!!Re.requiresSiblings)){if(re===1)return ne[0];const Re=function(K,J){for(let ae=0,ge=ne.length;ae<ge;ae++){const De=ne[ae](K,J);if(De)return De}return null},xe=ne.find(K=>!!K.allBasenames);xe&&(Re.allBasenames=xe.allBasenames);const W=ne.reduce((K,J)=>J.allPaths?K.concat(J.allPaths):K,[]);return W.length&&(Re.allPaths=W),Re}const ye=function(Re,xe,W){let K;for(let J=0,ae=ne.length;J<ae;J++){const ge=ne[J];ge.requiresSiblings&&W&&(xe||(xe=T.basename(Re)),K||(K=xe.substr(0,xe.length-T.extname(Re).length)));const De=ge(Re,xe,K,W);if(De)return De}return null},Ae=ne.find(Re=>!!Re.allBasenames);Ae&&(ye.allBasenames=Ae.allBasenames);const Be=ne.reduce((Re,xe)=>xe.allPaths?Re.concat(xe.allPaths):Re,[]);return Be.length&&(ye.allPaths=Be),ye}function U(N,Z,ne){if(Z===!1)return u;const re=l(N,ne);if(re===u)return u;if(typeof Z=="boolean")return re;if(Z){const ye=Z.when;if(typeof ye=="string"){const Ae=(Be,Re,xe,W)=>{if(!W||!re(Be,Re))return null;const K=ye.replace("$(basename)",xe),J=W(K);return(0,S.isThenable)(J)?J.then(ae=>ae?N:null):J?N:null};return Ae.requiresSiblings=!0,Ae}}return re}function Q(N,Z){const ne=N.filter(Re=>!!Re.basenames);if(ne.length<2)return N;const re=ne.reduce((Re,xe)=>{const W=xe.basenames;return W?Re.concat(W):Re},[]);let ye;if(Z){ye=[];for(let Re=0,xe=re.length;Re<xe;Re++)ye.push(Z)}else ye=ne.reduce((Re,xe)=>{const W=xe.patterns;return W?Re.concat(W):Re},[]);const Ae=function(Re,xe){if(typeof Re!="string")return null;if(!xe){let K;for(K=Re.length;K>0;K--){const J=Re.charCodeAt(K-1);if(J===47||J===92)break}xe=Re.substr(K)}const W=re.indexOf(xe);return W!==-1?ye[W]:null};Ae.basenames=re,Ae.patterns=ye,Ae.allBasenames=re;const Be=N.filter(Re=>!Re.basenames);return Be.push(Ae),Be}}),define(we[58],Ee([0,1,2,11,8,16,21,24,38]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function n(l,s,a){if(typeof l=="string"&&(l=w.URI.file(l)),a){const R=a.getWorkspaceFolder(l);if(R){const g=a.getWorkspace().folders.length>1;let b;if((0,I.isEqual)(R.uri,l)?b="":b=(0,I.relativePath)(R.uri,l),g){const C=R.name?R.name:(0,I.basename)(R.uri);b=b?C+" \u2022 "+b:C}return b}}if(l.scheme!==P.Schemas.file&&l.scheme!==P.Schemas.untitled)return l.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(l.fsPath))return(0,D.normalize)(k(l.fsPath));let E=(0,D.normalize)(l.fsPath);return!S.isWindows&&(s==null?void 0:s.userHome)&&(E=f(E,s.userHome.fsPath)),E}e.getPathLabel=n;function A(l){if(!!l){typeof l=="string"&&(l=w.URI.file(l));const s=(0,I.basename)(l)||(l.scheme===P.Schemas.file?l.fsPath:l.path);return S.isWindows&&(0,y.isRootOrDriveLetter)(s)?k(s):s}}e.getBaseLabel=A;function k(l){return(0,y.hasDriveLetter)(l)?l.charAt(0).toUpperCase()+l.slice(1):l}e.normalizeDriveLetter=k;let _=Object.create(null);function f(l,s){if(S.isWindows||!l||!s)return l;let a=_.original===s?_.normalized:void 0;return a||(a=`${(0,T.rtrim)(s,D.posix.sep)}${D.posix.sep}`,_={original:s,normalized:a}),(S.isLinux?l.startsWith(a):(0,T.startsWithIgnoreCase)(l,a))&&(l=`~/${l.substr(a.length)}`),l}e.tildify=f;function r(l,s){return l.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=r;const h="\u2026",p="\\\\",m="~";function v(l,s=D.sep){const a=new Array(l.length);let E=!1;for(let R=0;R<l.length;R++){let g=l[R];if(g===""){a[R]=`.${s}`;continue}if(!g){a[R]=g;continue}E=!0;let b="";g.indexOf(p)===0?(b=g.substr(0,g.indexOf(p)+p.length),g=g.substr(g.indexOf(p)+p.length)):g.indexOf(s)===0?(b=g.substr(0,g.indexOf(s)+s.length),g=g.substr(g.indexOf(s)+s.length)):g.indexOf(m)===0&&(b=g.substr(0,g.indexOf(m)+m.length),g=g.substr(g.indexOf(m)+m.length));const C=g.split(s);for(let F=1;E&&F<=C.length;F++)for(let x=C.length-F;E&&x>=0;x--){E=!1;let le=C.slice(x,x+F).join(s);for(let B=0;!E&&B<l.length;B++)if(B!==R&&l[B]&&l[B].indexOf(le)>-1){const H=x+F===C.length,G=x>0&&l[B].indexOf(s)>-1?s+le:le,L=l[B].endsWith(G);E=!H||L}if(!E){let B="";(C[0].endsWith(":")||b!=="")&&(x===1&&(x=0,F++,le=C[0]+s+le),x>0&&(B=C[0]+s),B=b+B),x>0&&(B=B+h+s),B=B+le,x+F<C.length&&(B=B+s+h),a[R]=B}}E&&(a[R]=g)}return a}e.shorten=v;var d;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function c(l,s=Object.create(null)){const a=[];let E=!1,R="";for(const g of l)if(g==="$"||E&&g==="{")R&&a.push({value:R,type:d.TEXT}),R="",E=!0;else if(g==="}"&&E){const b=s[R];if(typeof b=="string")b.length&&a.push({value:b,type:d.VARIABLE});else if(b){const C=a[a.length-1];(!C||C.type!==d.SEPARATOR)&&a.push({value:b.label,type:d.SEPARATOR})}R="",E=!1}else R+=g;return R&&!E&&a.push({value:R,type:d.TEXT}),a.filter((g,b)=>{if(g.type===d.SEPARATOR){const C=a[b-1],F=a[b+1];return[C,F].every(x=>x&&(x.type===d.VARIABLE||x.type===d.TEXT)&&x.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=c;function o(l,s){return S.isMacintosh||s?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):l.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=o;function t(l,s){return S.isMacintosh||s?l.replace(/\(&&\w\)|&&/g,""):S.isWindows?l.replace(/&&|&/g,a=>a==="&"?"&&":"&"):l.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(l){return l.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(l){const s=l.indexOf("/")!==-1?D.posix:D.win32,a=s.basename(l),E=s.dirname(l);return a.length?{name:a,parentPath:E}:{name:E,parentPath:""}}e.splitName=u}),define(we[110],Ee([0,1,2]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(A){return A.toJSON()}class T{constructor(k){this._uriTransformer=k}transformIncoming(k){const _=this._uriTransformer.transformIncoming(k);return _===k?k:D(w.URI.from(_))}transformOutgoing(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:D(w.URI.from(_))}transformOutgoingURI(k){const _=this._uriTransformer.transformOutgoing(k);return _===k?k:w.URI.from(_)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(A){return A}transformOutgoing(A){return A}transformOutgoingURI(A){return A}transformOutgoingScheme(A){return A}};function P(A,k,_){if(!A||_>200)return null;if(typeof A=="object"){if(A instanceof w.URI)return k.transformOutgoing(A);for(let f in A)if(Object.hasOwnProperty.call(A,f)){const r=P(A[f],k,_+1);r!==null&&(A[f]=r)}}return null}function S(A,k){const _=P(A,k,0);return _===null?A:_}e.transformOutgoingURIs=S;function I(A,k,_,f){if(!A||f>200)return null;if(typeof A=="object"){if(A.$mid===1)return _?w.URI.revive(k.transformIncoming(A)):k.transformIncoming(A);for(let r in A)if(Object.hasOwnProperty.call(A,r)){const h=I(A[r],k,_,f+1);h!==null&&(A[r]=h)}}return null}function y(A,k){const _=I(A,k,!1,0);return _===null?A:_}e.transformIncomingURIs=y;function n(A,k){const _=I(A,k,!0,0);return _===null?A:_}e.transformAndReviveIncomingURIs=n}),define(we[29],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(y){return w.test(y)}e.isUUID=D;const T=new Uint8Array(16),P=[];for(let y=0;y<256;y++)P.push(y.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(y){for(let n=0;n<y.length;n++)y[n]=Math.floor(Math.random()*256);return y};function I(){S(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let y=0,n="";return n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+="-",n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n+=P[T[y++]],n}e.generateUuid=I}),define(we[81],Ee([0,1,79]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class D{constructor(I){let y=(0,w.toUint8)(I);this._defaultValue=y,this._asciiMap=D._createAsciiMap(y),this._map=new Map}static _createAsciiMap(I){let y=new Uint8Array(256);for(let n=0;n<256;n++)y[n]=I;return y}set(I,y){let n=(0,w.toUint8)(y);I>=0&&I<256?this._asciiMap[I]=n:this._map.set(I,n)}get(I){return I>=0&&I<256?this._asciiMap[I]:this._map.get(I)||this._defaultValue}}e.CharacterClassifier=D;var T;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(T||(T={}));class P{constructor(){this._actual=new D(0)}add(I){this._actual.set(I,1)}has(I){return this._actual.get(I)===1}}e.CharacterSet=P}),define(we[111],Ee([0,1,81]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var D;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(D=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends w.CharacterClassifier{constructor(I){super(0);for(let y=0,n=I.length;y<n;y++)this.set(I.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function P(S){let I={};return y=>(I.hasOwnProperty(y)||(I[y]=S(y)),I[y])}e.getMapForWordSeparators=P(S=>new T(S))}),define(we[39],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(T,P){this.lineNumber=T,this.column=P}with(T=this.lineNumber,P=this.column){return T===this.lineNumber&&P===this.column?this:new w(T,P)}delta(T=0,P=0){return this.with(this.lineNumber+T,this.column+P)}equals(T){return w.equals(this,T)}static equals(T,P){return!T&&!P?!0:!!T&&!!P&&T.lineNumber===P.lineNumber&&T.column===P.column}isBefore(T){return w.isBefore(this,T)}static isBefore(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<P.column}isBeforeOrEqual(T){return w.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,P){return T.lineNumber<P.lineNumber?!0:P.lineNumber<T.lineNumber?!1:T.column<=P.column}static compare(T,P){let S=T.lineNumber|0,I=P.lineNumber|0;if(S===I){let y=T.column|0,n=P.column|0;return y-n}return S-I}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new w(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=w}),define(we[33],Ee([0,1,39]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class D{constructor(P,S,I,y){P>I||P===I&&S>y?(this.startLineNumber=I,this.startColumn=y,this.endLineNumber=P,this.endColumn=S):(this.startLineNumber=P,this.startColumn=S,this.endLineNumber=I,this.endColumn=y)}isEmpty(){return D.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return D.containsPosition(this,P)}static containsPosition(P,S){return!(S.lineNumber<P.startLineNumber||S.lineNumber>P.endLineNumber||S.lineNumber===P.startLineNumber&&S.column<P.startColumn||S.lineNumber===P.endLineNumber&&S.column>P.endColumn)}containsRange(P){return D.containsRange(this,P)}static containsRange(P,S){return!(S.startLineNumber<P.startLineNumber||S.endLineNumber<P.startLineNumber||S.startLineNumber>P.endLineNumber||S.endLineNumber>P.endLineNumber||S.startLineNumber===P.startLineNumber&&S.startColumn<P.startColumn||S.endLineNumber===P.endLineNumber&&S.endColumn>P.endColumn)}strictContainsRange(P){return D.strictContainsRange(this,P)}static strictContainsRange(P,S){return!(S.startLineNumber<P.startLineNumber||S.endLineNumber<P.startLineNumber||S.startLineNumber>P.endLineNumber||S.endLineNumber>P.endLineNumber||S.startLineNumber===P.startLineNumber&&S.startColumn<=P.startColumn||S.endLineNumber===P.endLineNumber&&S.endColumn>=P.endColumn)}plusRange(P){return D.plusRange(this,P)}static plusRange(P,S){let I,y,n,A;return S.startLineNumber<P.startLineNumber?(I=S.startLineNumber,y=S.startColumn):S.startLineNumber===P.startLineNumber?(I=S.startLineNumber,y=Math.min(S.startColumn,P.startColumn)):(I=P.startLineNumber,y=P.startColumn),S.endLineNumber>P.endLineNumber?(n=S.endLineNumber,A=S.endColumn):S.endLineNumber===P.endLineNumber?(n=S.endLineNumber,A=Math.max(S.endColumn,P.endColumn)):(n=P.endLineNumber,A=P.endColumn),new D(I,y,n,A)}intersectRanges(P){return D.intersectRanges(this,P)}static intersectRanges(P,S){let I=P.startLineNumber,y=P.startColumn,n=P.endLineNumber,A=P.endColumn,k=S.startLineNumber,_=S.startColumn,f=S.endLineNumber,r=S.endColumn;return I<k?(I=k,y=_):I===k&&(y=Math.max(y,_)),n>f?(n=f,A=r):n===f&&(A=Math.min(A,r)),I>n||I===n&&y>A?null:new D(I,y,n,A)}equalsRange(P){return D.equalsRange(this,P)}static equalsRange(P,S){return!!P&&!!S&&P.startLineNumber===S.startLineNumber&&P.startColumn===S.startColumn&&P.endLineNumber===S.endLineNumber&&P.endColumn===S.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(P){return new w.Position(P.endLineNumber,P.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(P){return new w.Position(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,S){return new D(this.startLineNumber,this.startColumn,P,S)}setStartPosition(P,S){return new D(P,S,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(P){return new D(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}static fromPositions(P,S=P){return new D(P.lineNumber,P.column,S.lineNumber,S.column)}static lift(P){return P?new D(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,S){return!(P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<S.startColumn||S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<P.startColumn)}static areIntersecting(P,S){return!(P.endLineNumber<S.startLineNumber||P.endLineNumber===S.startLineNumber&&P.endColumn<=S.startColumn||S.endLineNumber<P.startLineNumber||S.endLineNumber===P.startLineNumber&&S.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,S){if(P&&S){const n=P.startLineNumber|0,A=S.startLineNumber|0;if(n===A){const k=P.startColumn|0,_=S.startColumn|0;if(k===_){const f=P.endLineNumber|0,r=S.endLineNumber|0;if(f===r){const h=P.endColumn|0,p=S.endColumn|0;return h-p}return f-r}return k-_}return n-A}return(P?1:0)-(S?1:0)}static compareRangesUsingEnds(P,S){return P.endLineNumber===S.endLineNumber?P.endColumn===S.endColumn?P.startLineNumber===S.startLineNumber?P.startColumn-S.startColumn:P.startLineNumber-S.startLineNumber:P.endColumn-S.endColumn:P.endLineNumber-S.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}}e.Range=D}),define(we[112],Ee([0,1,39,33]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class P extends D.Range{constructor(I,y,n,A){super(I,y,n,A);this.selectionStartLineNumber=I,this.selectionStartColumn=y,this.positionLineNumber=n,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(I){return P.selectionsEqual(this,I)}static selectionsEqual(I,y){return I.selectionStartLineNumber===y.selectionStartLineNumber&&I.selectionStartColumn===y.selectionStartColumn&&I.positionLineNumber===y.positionLineNumber&&I.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(I,y){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,I,y):new P(I,y,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(I,y){return this.getDirection()===0?new P(I,y,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,I,y)}static fromPositions(I,y=I){return new P(I.lineNumber,I.column,y.lineNumber,y.column)}static liftSelection(I){return new P(I.selectionStartLineNumber,I.selectionStartColumn,I.positionLineNumber,I.positionColumn)}static selectionsArrEqual(I,y){if(I&&!y||!I&&y)return!1;if(!I&&!y)return!0;if(I.length!==y.length)return!1;for(let n=0,A=I.length;n<A;n++)if(!this.selectionsEqual(I[n],y[n]))return!1;return!0}static isISelection(I){return I&&typeof I.selectionStartLineNumber=="number"&&typeof I.selectionStartColumn=="number"&&typeof I.positionLineNumber=="number"&&typeof I.positionColumn=="number"}static createWithDirection(I,y,n,A,k){return k===0?new P(I,y,n,A):new P(n,A,I,y)}}e.Selection=P}),define(we[82],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class y{constructor(r,h){this.range=r,this.matches=h}}e.FindMatch=y;var n;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(n=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(A=e.ModelConstants||(e.ModelConstants={}));class k{constructor(r,h,p,m,v,d){this.identifier=r,this.range=h,this.text=p,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=v,this._isTracked=d}}e.ValidAnnotatedEditOperation=k;class _{constructor(r,h,p){this.reverseEdits=r,this.changes=h,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=_}),define(we[113],Ee([0,1,8,111,39,33,82]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class y{constructor(d,c,o,t){this.searchString=d,this.isRegex=c,this.matchCase=o,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=n(this.searchString):d=this.searchString.indexOf(`
`)>=0;let c=null;try{c=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!c)return null;let o=!this.isRegex&&!d;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new A(c,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators):null,o?this.searchString:null)}}e.SearchParams=y;function n(v){if(!v||v.length===0)return!1;for(let d=0,c=v.length;d<c;d++)if(v.charCodeAt(d)===92){if(d++,d>=c)break;const t=v.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=n;class A{constructor(d,c,o){this.regex=d,this.wordSeparators=c,this.simpleSearch=o}}e.SearchData=A;function k(v,d,c){if(!c)return new S.FindMatch(v,null);let o=[];for(let t=0,i=d.length;t<i;t++)o[t]=d[t];return new S.FindMatch(v,o)}e.createFindMatch=k;class _{constructor(d){let c=[],o=0;for(let t=0,i=d.length;t<i;t++)d.charCodeAt(t)===10&&(c[o++]=t);this._lineFeedsOffsets=c}findLineFeedCountBeforeOffset(d){const c=this._lineFeedsOffsets;let o=0,t=c.length-1;if(t===-1||d<=c[0])return 0;for(;o<t;){const i=o+((t-o)/2>>0);c[i]>=d?t=i-1:c[i+1]>=d?(o=i,t=i):o=i+1}return o+1}}class f{static findMatches(d,c,o,t,i){const u=c.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(d,o,new m(u.wordSeparators,u.regex),t,i):this._doFindMatchesLineByLine(d,o,u,t,i):[]}static _getMultilineMatchRange(d,c,o,t,i,u){let l,s=0;t?(s=t.findLineFeedCountBeforeOffset(i),l=c+i+s):l=c+i;let a;if(t){let b=t.findLineFeedCountBeforeOffset(i+u.length)-s;a=l+u.length+b}else a=l+u.length;const E=d.getPositionAt(l),R=d.getPositionAt(a);return new P.Range(E.lineNumber,E.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(d,c,o,t,i){const u=d.getOffsetAt(c.getStartPosition()),l=d.getValueInRange(c,1),s=d.getEOL()===`\r
`?new _(l):null,a=[];let E=0,R;for(o.reset(0);R=o.next(l);)if(a[E++]=k(this._getMultilineMatchRange(d,u,l,s,R.index,R[0]),R,t),E>=i)return a;return a}static _doFindMatchesLineByLine(d,c,o,t,i){const u=[];let l=0;if(c.startLineNumber===c.endLineNumber){const a=d.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return l=this._findMatchesInLine(o,a,c.startLineNumber,c.startColumn-1,l,u,t,i),u}const s=d.getLineContent(c.startLineNumber).substring(c.startColumn-1);l=this._findMatchesInLine(o,s,c.startLineNumber,c.startColumn-1,l,u,t,i);for(let a=c.startLineNumber+1;a<c.endLineNumber&&l<i;a++)l=this._findMatchesInLine(o,d.getLineContent(a),a,0,l,u,t,i);if(l<i){const a=d.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);l=this._findMatchesInLine(o,a,c.endLineNumber,0,l,u,t,i)}return u}static _findMatchesInLine(d,c,o,t,i,u,l,s){const a=d.wordSeparators;if(!l&&d.simpleSearch){const g=d.simpleSearch,b=g.length,C=c.length;let F=-b;for(;(F=c.indexOf(g,F+b))!==-1;)if((!a||p(a,c,C,F,b))&&(u[i++]=new S.FindMatch(new P.Range(o,F+1+t,o,F+1+b+t),null),i>=s))return i;return i}const E=new m(d.wordSeparators,d.regex);let R;E.reset(0);do if(R=E.next(c),R&&(u[i++]=k(new P.Range(o,R.index+1+t,o,R.index+1+R[0].length+t),R,l),i>=s))return i;while(R);return i}static findNextMatch(d,c,o,t){const i=c.parseSearchRequest();if(!i)return null;const u=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(d,o,u,t):this._doFindNextMatchLineByLine(d,o,u,t)}static _doFindNextMatchMultiline(d,c,o,t){const i=new T.Position(c.lineNumber,1),u=d.getOffsetAt(i),l=d.getLineCount(),s=d.getValueInRange(new P.Range(i.lineNumber,i.column,l,d.getLineMaxColumn(l)),1),a=d.getEOL()===`\r
`?new _(s):null;o.reset(c.column-1);let E=o.next(s);return E?k(this._getMultilineMatchRange(d,u,s,a,E.index,E[0]),E,t):c.lineNumber!==1||c.column!==1?this._doFindNextMatchMultiline(d,new T.Position(1,1),o,t):null}static _doFindNextMatchLineByLine(d,c,o,t){const i=d.getLineCount(),u=c.lineNumber,l=d.getLineContent(u),s=this._findFirstMatchInLine(o,l,u,c.column,t);if(s)return s;for(let a=1;a<=i;a++){const E=(u+a-1)%i,R=d.getLineContent(E+1),g=this._findFirstMatchInLine(o,R,E+1,1,t);if(g)return g}return null}static _findFirstMatchInLine(d,c,o,t,i){d.reset(t-1);const u=d.next(c);return u?k(new P.Range(o,u.index+1,o,u.index+1+u[0].length),u,i):null}static findPreviousMatch(d,c,o,t){const i=c.parseSearchRequest();if(!i)return null;const u=new m(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(d,o,u,t):this._doFindPreviousMatchLineByLine(d,o,u,t)}static _doFindPreviousMatchMultiline(d,c,o,t){const i=this._doFindMatchesMultiline(d,new P.Range(1,1,c.lineNumber,c.column),o,t,10*I);if(i.length>0)return i[i.length-1];const u=d.getLineCount();return c.lineNumber!==u||c.column!==d.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(d,new T.Position(u,d.getLineMaxColumn(u)),o,t):null}static _doFindPreviousMatchLineByLine(d,c,o,t){const i=d.getLineCount(),u=c.lineNumber,l=d.getLineContent(u).substring(0,c.column-1),s=this._findLastMatchInLine(o,l,u,t);if(s)return s;for(let a=1;a<=i;a++){const E=(i+u-a-1)%i,R=d.getLineContent(E+1),g=this._findLastMatchInLine(o,R,E+1,t);if(g)return g}return null}static _findLastMatchInLine(d,c,o,t){let i=null,u;for(d.reset(0);u=d.next(c);)i=k(new P.Range(o,u.index+1,o,u.index+1+u[0].length),u,t);return i}}e.TextModelSearch=f;function r(v,d,c,o,t){if(o===0)return!0;const i=d.charCodeAt(o-1);if(v.get(i)!==0||i===13||i===10)return!0;if(t>0){const u=d.charCodeAt(o);if(v.get(u)!==0)return!0}return!1}function h(v,d,c,o,t){if(o+t===c)return!0;const i=d.charCodeAt(o+t);if(v.get(i)!==0||i===13||i===10)return!0;if(t>0){const u=d.charCodeAt(o+t-1);if(v.get(u)!==0)return!0}return!1}function p(v,d,c,o,t){return r(v,d,c,o,t)&&h(v,d,c,o,t)}e.isValidMatch=p;class m{constructor(d,c){this._wordSeparators=d,this._searchRegex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const c=d.length;let o;do{if(this._prevMatchStartIndex+this._prevMatchLength===c||(o=this._searchRegex.exec(d),!o))return null;const t=o.index,i=o[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){w.getNextCodePoint(d,c,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||p(this._wordSeparators,d,c,t,i))return o}while(o);return null}}e.Searcher=m}),define(we[83],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(I=""){let y="(-?\\d*\\.\\d\\w*)|([^";for(const n of e.USUAL_WORD_SEPARATORS)I.indexOf(n)>=0||(y+="\\"+n);return y+="\\s]+)",new RegExp(y,"g")}e.DEFAULT_WORD_REGEXP=w();function D(I){let y=e.DEFAULT_WORD_REGEXP;if(I&&I instanceof RegExp)if(I.global)y=I;else{let n="g";I.ignoreCase&&(n+="i"),I.multiline&&(n+="m"),I.unicode&&(n+="u"),y=new RegExp(I.source,n)}return y.lastIndex=0,y}e.ensureValidWordDefinition=D;const T={maxLen:1e3,windowSize:15,timeBudget:150};function P(I,y,n,A,k=T){if(n.length>k.maxLen){let p=I-k.maxLen/2;return p<0?p=0:A+=p,n=n.substring(p,I+k.maxLen/2),P(I,y,n,A,k)}const _=Date.now(),f=I-1-A;let r=-1,h=null;for(let p=1;!(Date.now()-_>=k.timeBudget);p++){const m=f-k.windowSize*p;y.lastIndex=Math.max(0,m);const v=S(y,n,f,r);if(!v&&h||(h=v,m<=0))break;r=m}if(h){let p={word:h[0],startColumn:A+1+h.index,endColumn:A+1+h.index+h[0].length};return y.lastIndex=0,p}return null}e.getWordAtText=P;function S(I,y,n,A){let k;for(;k=I.exec(y);){const _=k.index||0;if(_<=n&&I.lastIndex>=n)return k;if(A>0&&_>A)return null}return null}}),define(we[114],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class D{constructor(I){if(this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let y=0,n=I.notIn.length;y<n;y++)switch(I.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=D;class T{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of I)P(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),P(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),P(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),P(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&P(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function P(S,I,y){S.has(I)?S.get(I).push(y):S.set(I,[y])}}),define(we[59],Ee([0,1,28,11]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(P,S,I,y){if(Array.isArray(P)){let n=0;for(const A of P){const k=T(A,S,I,y);if(k===10)return k;k>n&&(n=k)}return n}else{if(typeof P=="string")return y?P==="*"?5:P===I?10:0:0;if(P){const{language:n,pattern:A,scheme:k,hasAccessToAllModels:_}=P;if(!y&&!_)return 0;let f=0;if(k)if(k===S.scheme)f=10;else if(k==="*")f=5;else return 0;if(n)if(n===I)f=10;else if(n==="*")f=Math.max(f,5);else return 0;if(A){let r;if(typeof A=="string"?r=A:r=Object.assign(Object.assign({},A),{base:(0,D.normalize)(A.base)}),r===S.fsPath||(0,w.match)(r,S.fsPath))f=10;else return 0}return f}else return 0}}e.score=T}),define(we[115],Ee([0,1,81]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var D;(function(f){f[f.Invalid=0]="Invalid",f[f.Start=1]="Start",f[f.H=2]="H",f[f.HT=3]="HT",f[f.HTT=4]="HTT",f[f.HTTP=5]="HTTP",f[f.F=6]="F",f[f.FI=7]="FI",f[f.FIL=8]="FIL",f[f.BeforeColon=9]="BeforeColon",f[f.AfterColon=10]="AfterColon",f[f.AlmostThere=11]="AlmostThere",f[f.End=12]="End",f[f.Accept=13]="Accept",f[f.LastKnownState=14]="LastKnownState"})(D=e.State||(e.State={}));class T{constructor(r,h,p){const m=new Uint8Array(r*h);for(let v=0,d=r*h;v<d;v++)m[v]=p;this._data=m,this.rows=r,this.cols=h}get(r,h){return this._data[r*this.cols+h]}set(r,h,p){this._data[r*this.cols+h]=p}}e.Uint8Matrix=T;class P{constructor(r){let h=0,p=0;for(let v=0,d=r.length;v<d;v++){let[c,o,t]=r[v];o>h&&(h=o),c>p&&(p=c),t>p&&(p=t)}h++,p++;let m=new T(p,h,0);for(let v=0,d=r.length;v<d;v++){let[c,o,t]=r[v];m.set(c,o,t)}this._states=m,this._maxCharCode=h}nextState(r,h){return h<0||h>=this._maxCharCode?0:this._states.get(r,h)}}e.StateMachine=P;let S=null;function I(){return S===null&&(S=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(f){f[f.None=0]="None",f[f.ForceTermination=1]="ForceTermination",f[f.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let n=null;function A(){if(n===null){n=new w.CharacterClassifier(0);const f=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let h=0;h<f.length;h++)n.set(f.charCodeAt(h),1);const r=".,;";for(let h=0;h<r.length;h++)n.set(r.charCodeAt(h),2)}return n}class k{static _createLink(r,h,p,m,v){let d=v-1;do{const c=h.charCodeAt(d);if(r.get(c)!==2)break;d--}while(d>m);if(m>0){const c=h.charCodeAt(m-1),o=h.charCodeAt(d);(c===40&&o===41||c===91&&o===93||c===123&&o===125)&&d--}return{range:{startLineNumber:p,startColumn:m+1,endLineNumber:p,endColumn:d+2},url:h.substring(m,d+1)}}static computeLinks(r,h=I()){const p=A();let m=[];for(let v=1,d=r.getLineCount();v<=d;v++){const c=r.getLineContent(v),o=c.length;let t=0,i=0,u=0,l=1,s=!1,a=!1,E=!1,R=!1;for(;t<o;){let g=!1;const b=c.charCodeAt(t);if(l===13){let C;switch(b){case 40:s=!0,C=0;break;case 41:C=s?0:1;break;case 91:E=!0,a=!0,C=0;break;case 93:E=!1,C=a?0:1;break;case 123:R=!0,C=0;break;case 125:C=R?0:1;break;case 39:C=u===34||u===96?0:1;break;case 34:C=u===39||u===96?0:1;break;case 96:C=u===39||u===34?0:1;break;case 42:C=u===42?1:0;break;case 124:C=u===124?1:0;break;case 32:C=E?0:1;break;default:C=p.get(b)}C===1&&(m.push(k._createLink(p,c,v,i,t)),g=!0)}else if(l===12){let C;b===91?(a=!0,C=0):C=p.get(b),C===1?g=!0:l=13}else l=h.nextState(l,b),l===0&&(g=!0);g&&(l=1,s=!1,a=!1,R=!1,i=t+1,u=b),t++}l===13&&m.push(k._createLink(p,c,v,i,o))}return m}}e.LinkComputer=k;function _(f){return!f||typeof f.getLineCount!="function"||typeof f.getLineContent!="function"?[]:k.computeLinks(f)}e.computeLinks=_}),define(we[116],Ee([0,1,3,6]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class T{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,I){return this._map.set(S,I),this.fire([S]),(0,D.toDisposable)(()=>{this._map.get(S)===I&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,I){let y=null,n=!1;return this._promises.set(S,I.then(A=>{this._promises.delete(S),!(n||!A)&&(y=this.register(S,A))})),(0,D.toDisposable)(()=>{n=!0,y&&y.dispose()})}getPromise(S){const I=this.get(S);if(I)return Promise.resolve(I);const y=this._promises.get(S);return y?y.then(n=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=T}),define(we[84],Ee([0,1,26,21]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(T||(T={}));function P(k){for(let _=0,f=k.length;_<f;_+=4){const r=k[_+0],h=k[_+1],p=k[_+2],m=k[_+3];k[_+0]=m,k[_+1]=p,k[_+2]=h,k[_+3]=r}}function S(k){const _=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return D.isLittleEndian()||P(_),w.VSBuffer.wrap(_)}function I(k){const _=k.buffer;if(D.isLittleEndian()||P(_),_.byteOffset%4==0)return new Uint32Array(_.buffer,_.byteOffset,_.length/4);{const f=new Uint8Array(_.byteLength);return f.set(_),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function y(k){const _=new Uint32Array(n(k));let f=0;if(_[f++]=k.id,k.type==="full")_[f++]=1,_[f++]=k.data.length,_.set(k.data,f),f+=k.data.length;else{_[f++]=2,_[f++]=k.deltas.length;for(const r of k.deltas)_[f++]=r.start,_[f++]=r.deleteCount,r.data?(_[f++]=r.data.length,_.set(r.data,f),f+=r.data.length):_[f++]=0}return S(_)}e.encodeSemanticTokensDto=y;function n(k){let _=0;if(_+=1+1,k.type==="full")_+=1+k.data.length;else{_+=1,_+=(1+1+1)*k.deltas.length;for(const f of k.deltas)f.data&&(_+=f.data.length)}return _}function A(k){const _=I(k);let f=0;const r=_[f++];if(_[f++]===1){const v=_[f++],d=_.subarray(f,f+v);return f+=v,{id:r,type:"full",data:d}}const p=_[f++];let m=[];for(let v=0;v<p;v++){const d=_[f++],c=_[f++],o=_[f++];let t;o>0&&(t=_.subarray(f,f+o),f+=o),m[v]={start:d,deleteCount:c,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=A}),define(we[85],Ee([0,1,79]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class D{constructor(S,I){this.index=S,this.remainder=I}}e.PrefixSumIndexOfResult=D;class T{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,I){S=(0,w.toUint32)(S);const y=this.values,n=this.prefixSum,A=I.length;return A===0?!1:(this.values=new Uint32Array(y.length+A),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S),S+A),this.values.set(I,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,I){return S=(0,w.toUint32)(S),I=(0,w.toUint32)(I),this.values[S]===I?!1:(this.values[S]=I,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,I){S=(0,w.toUint32)(S),I=(0,w.toUint32)(I);const y=this.values,n=this.prefixSum;if(S>=y.length)return!1;let A=y.length-S;return I>=A&&(I=A),I===0?!1:(this.values=new Uint32Array(y.length-I),this.values.set(y.subarray(0,S),0),this.values.set(y.subarray(S+I),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(n.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,w.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),S>=this.values.length&&(S=this.values.length-1);for(let y=I;y<=S;y++)this.prefixSum[y]=this.prefixSum[y-1]+this.values[y];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let I=0,y=this.values.length-1,n=0,A=0,k=0;for(;I<=y;)if(n=I+(y-I)/2|0,A=this.prefixSum[n],k=A-this.values[n],S<k)y=n-1;else if(S>=A)I=n+1;else break;return new D(n,S-k)}}e.PrefixSumComputer=T}),define(we[117],Ee([0,1,8,39,85]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class P{constructor(I,y,n,A){this._uri=I,this._lines=y,this._eol=n,this._versionId=A,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(I){I.eol&&I.eol!==this._eol&&(this._eol=I.eol,this._lineStarts=null);const y=I.changes;for(const n of y)this._acceptDeleteRange(n.range),this._acceptInsertText(new D.Position(n.range.startLineNumber,n.range.startColumn),n.text);this._versionId=I.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const I=this._eol.length,y=this._lines.length,n=new Uint32Array(y);for(let A=0;A<y;A++)n[A]=this._lines[A].length+I;this._lineStarts=new T.PrefixSumComputer(n)}}_setLineText(I,y){this._lines[I]=y,this._lineStarts&&this._lineStarts.changeValue(I,this._lines[I].length+this._eol.length)}_acceptDeleteRange(I){if(I.startLineNumber===I.endLineNumber){if(I.startColumn===I.endColumn)return;this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.startLineNumber-1].substring(I.endColumn-1));return}this._setLineText(I.startLineNumber-1,this._lines[I.startLineNumber-1].substring(0,I.startColumn-1)+this._lines[I.endLineNumber-1].substring(I.endColumn-1)),this._lines.splice(I.startLineNumber,I.endLineNumber-I.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(I.startLineNumber,I.endLineNumber-I.startLineNumber)}_acceptInsertText(I,y){if(y.length!==0){let n=(0,w.splitLines)(y);if(n.length===1){this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]+this._lines[I.lineNumber-1].substring(I.column-1));return}n[n.length-1]+=this._lines[I.lineNumber-1].substring(I.column-1),this._setLineText(I.lineNumber-1,this._lines[I.lineNumber-1].substring(0,I.column-1)+n[0]);let A=new Uint32Array(n.length-1);for(let k=1;k<n.length;k++)this._lines.splice(I.lineNumber+k-1,0,n[k]),A[k-1]=n[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(I.lineNumber,A)}}}e.MirrorTextModel=P}),define(we[118],Ee([17,18]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(we[60],Ee([0,1,118,12,15]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function P(n,A){return A&&(n.stack||n.stacktrace)?w.localize(0,null,I(n),S(n.stack)||S(n.stacktrace)):I(n)}function S(n){return Array.isArray(n)?n.join(`
`):n}function I(n){return typeof n.code=="string"&&typeof n.errno=="number"&&typeof n.syscall=="string"?w.localize(1,null,n.message):n.message||w.localize(2,null)}function y(n=null,A=!1){if(!n)return w.localize(3,null);if(Array.isArray(n)){const k=T.coalesce(n),_=y(k[0],A);return k.length>1?w.localize(4,null,_,k.length):_}if(D.isString(n))return n;if(n.detail){const k=n.detail;if(k.error)return P(k.error,A);if(k.exception)return P(k.exception,A)}return n.stack?P(n,A):n.message?n.message:w.localize(5,null)}e.toErrorMessage=y}),define(we[119],Ee([17,18]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(we[120],Ee([0,1,119,21,83]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=S;class I{constructor(){this._values=[]}_read(X){return this._values[X]}get(X){return this._values[X]}_write(X,_e){this._values[X]=_e}}e.ValidatedEditorOptions=I;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class n{constructor(X,_e,Me,He){this.id=X,this.name=_e,this.defaultValue=Me,this.schema=He}compute(X,_e,Me){return Me}}class A{constructor(X,_e=null){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(X){return this.defaultValue}}class k{constructor(X,_e,Me,He){this.id=X,this.name=_e,this.defaultValue=Me,this.schema=He}validate(X){return typeof X=="undefined"?this.defaultValue:X}compute(X,_e,Me){return Me}}function _(V,X){return typeof V=="undefined"?X:V==="false"?!1:Boolean(V)}e.boolean=_;class f extends k{constructor(X,_e,Me,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Me),super(X,_e,Me,He)}validate(X){return _(X,this.defaultValue)}}class r extends k{constructor(X,_e,Me,He,Oe,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Me,Xe.minimum=He,Xe.maximum=Oe),super(X,_e,Me,Xe),this.minimum=He,this.maximum=Oe}static clampedInt(X,_e,Me,He){if(typeof X=="undefined")return _e;let Oe=parseInt(X,10);return isNaN(Oe)?_e:(Oe=Math.max(Me,Oe),Oe=Math.min(He,Oe),Oe|0)}validate(X){return r.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class h extends k{constructor(X,_e,Me,He,Oe){typeof Oe!="undefined"&&(Oe.type="number",Oe.default=Me),super(X,_e,Me,Oe),this.validationFn=He}static clamp(X,_e,Me){return X<_e?_e:X>Me?Me:X}static float(X,_e){if(typeof X=="number")return X;if(typeof X=="undefined")return _e;const Me=parseFloat(X);return isNaN(Me)?_e:Me}validate(X){return this.validationFn(h.float(X,this.defaultValue))}}class p extends k{static string(X,_e){return typeof X!="string"?_e:X}constructor(X,_e,Me,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Me),super(X,_e,Me,He)}validate(X){return p.string(X,this.defaultValue)}}function m(V,X,_e){return typeof V!="string"||_e.indexOf(V)===-1?X:V}e.stringSet=m;class v extends k{constructor(X,_e,Me,He,Oe=void 0){typeof Oe!="undefined"&&(Oe.type="string",Oe.enum=He,Oe.default=Me),super(X,_e,Me,Oe),this._allowedValues=He}validate(X){return m(X,this.defaultValue,this._allowedValues)}}class d extends n{constructor(X,_e,Me,He,Oe,Xe,z=void 0){typeof z!="undefined"&&(z.type="string",z.enum=Oe,z.default=He),super(X,_e,Me,z),this._allowedValues=Oe,this._convert=Xe}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function c(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends n{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,_e,Me){return Me===0?X.accessibilitySupport:Me}}class t extends n{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(16,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:w.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{insertSpace:_(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:_(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(V){switch(V){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function a(V){switch(V){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class E extends A{constructor(){super(121,[60,29])}compute(X,_e,Me){const He=["monaco-editor"];return _e.get(29)&&He.push(_e.get(29)),X.extraEditorClassName&&He.push(X.extraEditorClassName),_e.get(60)==="default"?He.push("mouse-default"):_e.get(60)==="copy"&&He.push("mouse-copy"),_e.get(95)&&He.push("showUnused"),_e.get(119)&&He.push("showDeprecated"),He.join(" ")}}class R extends f{constructor(){super(28,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(X,_e,Me){return Me&&X.emptySelectionClipboard}}class g extends n{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(31,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:X.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:w.localize(13,null),included:D.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:w.localize(15,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{cursorMoveOnType:_(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:_(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":m(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:_(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:_(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:_(_e.loop,this.defaultValue.loop)}}}class b extends n{constructor(){super(39,"fontLigatures",b.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(X){return typeof X=="undefined"?this.defaultValue:typeof X=="string"?X==="false"?b.OFF:X==="true"?b.ON:X:Boolean(X)?b.ON:b.OFF}}e.EditorFontLigatures=b,b.OFF='"liga" off, "calt" off',b.ON='"liga" on, "calt" on';class C extends A{constructor(){super(38)}compute(X,_e,Me){return X.fontInfo}}class F extends k{constructor(){super(40,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(X){let _e=h.float(X,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(_e,6,100)}compute(X,_e,Me){return X.fontInfo.fontSize}}class x extends n{constructor(){super(41,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(X){return X==="normal"||X==="bold"?X:String(r.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class le extends n{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]};super(45,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},_e),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},_e),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},_e),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},_e),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},_e),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,description:w.localize(35,null)}})}validate(X){var _e,Me,He,Oe,Xe;if(!X||typeof X!="object")return this.defaultValue;const z=X;return{multiple:m(z.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(_e=z.multipleDefinitions)!==null&&_e!==void 0?_e:m(z.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=z.multipleTypeDefinitions)!==null&&Me!==void 0?Me:m(z.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=z.multipleDeclarations)!==null&&He!==void 0?He:m(z.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Oe=z.multipleImplementations)!==null&&Oe!==void 0?Oe:m(z.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=z.multipleReferences)!==null&&Xe!==void 0?Xe:m(z.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(z.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(z.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(z.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(z.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(z.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class B extends n{constructor(){const X={enabled:!0,delay:300,sticky:!0};super(48,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:X.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:w.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),delay:r.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:_(_e.sticky,this.defaultValue.sticky)}}}var H;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class G extends A{constructor(){super(124,[44,52,33,59,87,54,55,89,111,114,115,116,2])}compute(X,_e,Me){return G.computeLayout(_e,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const _e=X.height/X.lineHeight,Me=X.scrollBeyondLastLine?_e-1:0,He=(X.viewLineCount+Me)/(X.pixelRatio*X.height),Oe=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Me,desiredRatio:He,minimapLineCount:Oe}}static _computeMinimapLayout(X,_e){const Me=X.outerWidth,He=X.outerHeight,Oe=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Oe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=_e.stableMinimapLayoutInput,z=Xe&&X.outerHeight===Xe.outerHeight&&X.lineHeight===Xe.lineHeight&&X.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&X.pixelRatio===Xe.pixelRatio&&X.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&X.minimap.enabled===Xe.minimap.enabled&&X.minimap.side===Xe.minimap.side&&X.minimap.size===Xe.minimap.size&&X.minimap.showSlider===Xe.minimap.showSlider&&X.minimap.renderCharacters===Xe.minimap.renderCharacters&&X.minimap.maxColumn===Xe.minimap.maxColumn&&X.minimap.scale===Xe.minimap.scale&&X.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&X.isViewportWrapping===Xe.isViewportWrapping,ie=X.lineHeight,ce=X.typicalHalfwidthCharacterWidth,j=X.scrollBeyondLastLine,Y=X.minimap.renderCharacters;let se=Oe>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const fe=X.minimap.maxColumn,ve=X.minimap.size,$e=X.minimap.side,Ne=X.verticalScrollbarWidth,Ve=X.viewLineCount,Qe=X.remainingWidth,Ze=X.isViewportWrapping,ct=Y?2:3;let st=Math.floor(Oe*He);const me=st/Oe;let he=!1,ue=!1,q=ct*se,Ie=se/Oe,Pe=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:at,desiredRatio:Dt,minimapLineCount:gt}=G.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:j,height:He,lineHeight:ie,pixelRatio:Oe});if(Ve/gt>1)he=!0,ue=!0,se=1,q=1,Ie=se/Oe;else{let wt=!1,Et=se+1;if(ve==="fit"){const mt=Math.ceil((Ve+at)*q);Ze&&z&&Qe<=_e.stableFitRemainingWidth?(wt=!0,Et=_e.stableFitMaxMinimapScale):(wt=mt>st,Ze&&wt?(_e.stableMinimapLayoutInput=X,_e.stableFitRemainingWidth=Qe):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0))}if(ve==="fill"||wt){he=!0;const mt=se;q=Math.min(ie*Oe,Math.max(1,Math.floor(1/Dt))),se=Math.min(Et,Math.max(1,Math.floor(q/ct))),se>mt&&(Pe=Math.min(2,se/mt)),Ie=se/Oe/Pe,st=Math.ceil(Math.max(dt,Ve+at)*q),Ze&&wt&&(_e.stableFitMaxMinimapScale=se)}}}const et=Math.floor(fe*Ie),Ge=Math.min(et,Math.max(0,Math.floor((Qe-Ne-2)*Ie/(ce+Ie)))+e.MINIMAP_GUTTER_WIDTH);let rt=Math.floor(Oe*Ge);const lt=rt/Oe;rt=Math.floor(rt*Pe);const Je=Y?1:2,it=$e==="left"?0:Me-Ge-Ne;return{renderMinimap:Je,minimapLeft:it,minimapWidth:Ge,minimapHeightIsEditorHeight:he,minimapIsSampling:ue,minimapScale:se,minimapLineHeight:q,minimapCanvasInnerWidth:rt,minimapCanvasInnerHeight:st,minimapCanvasOuterWidth:lt,minimapCanvasOuterHeight:me}}static computeLayout(X,_e){const Me=_e.outerWidth|0,He=_e.outerHeight|0,Oe=_e.lineHeight|0,Xe=_e.lineNumbersDigitCount|0,z=_e.typicalHalfwidthCharacterWidth,ie=_e.maxDigitWidth,ce=_e.pixelRatio,j=_e.viewLineCount,Y=X.get(116),se=Y==="inherit"?X.get(115):Y,fe=se==="inherit"?X.get(111):se,ve=X.get(114),$e=X.get(2),Ne=_e.isDominatedByLongLines,Ve=X.get(44),Qe=X.get(54).renderType!==0,Ze=X.get(55),ct=X.get(89),st=X.get(59),me=X.get(87),he=me.verticalScrollbarSize,ue=me.verticalHasArrows,q=me.arrowSize,Ie=me.horizontalScrollbarSize,Pe=X.get(52),et=X.get(33);let Ge;if(typeof Pe=="string"&&/^\d+(\.\d+)?ch$/.test(Pe)){const ht=parseFloat(Pe.substr(0,Pe.length-2));Ge=r.clampedInt(ht*z,0,0,1e3)}else Ge=r.clampedInt(Pe,0,0,1e3);et&&(Ge+=16);let rt=0;if(Qe){const ht=Math.max(Xe,Ze);rt=Math.round(ht*ie)}let lt=0;Ve&&(lt=Oe);let Je=0,it=Je+lt,dt=it+rt,at=dt+Ge;const Dt=Me-lt-rt-Ge;let gt=!1,Ct=!1,wt=-1;$e!==2&&(se==="inherit"&&Ne?(gt=!0,Ct=!0):fe==="on"||fe==="bounded"?Ct=!0:fe==="wordWrapColumn"&&(wt=ve));const Et=G._computeMinimapLayout({outerWidth:Me,outerHeight:He,lineHeight:Oe,typicalHalfwidthCharacterWidth:z,pixelRatio:ce,scrollBeyondLastLine:ct,minimap:st,verticalScrollbarWidth:he,viewLineCount:j,remainingWidth:Dt,isViewportWrapping:Ct},_e.memory||new y);Et.renderMinimap!==0&&Et.minimapLeft===0&&(Je+=Et.minimapWidth,it+=Et.minimapWidth,dt+=Et.minimapWidth,at+=Et.minimapWidth);const mt=Dt-Et.minimapWidth,Rt=Math.max(1,Math.floor((mt-he-2)/z)),Ft=ue?q:0;return Ct&&(wt=Math.max(1,Rt),fe==="bounded"&&(wt=Math.min(wt,ve))),{width:Me,height:He,glyphMarginLeft:Je,glyphMarginWidth:lt,lineNumbersLeft:it,lineNumbersWidth:rt,decorationsLeft:dt,decorationsWidth:Ge,contentLeft:at,contentWidth:mt,minimap:Et,viewportColumn:Rt,isWordWrapMinified:gt,isViewportWrapping:Ct,wrappingColumn:wt,verticalScrollbarWidth:he,horizontalScrollbarHeight:Ie,overviewRuler:{top:Ft,width:he,height:He-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=G;class L extends n{constructor(){const X={enabled:!0};super(51,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:w.localize(39,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:_(X.enabled,this.defaultValue.enabled)}}}class $ extends n{constructor(){const X={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(120,"inlineHints",X,{"editor.inlineHints.enabled":{type:"boolean",default:X.enabled,description:w.localize(40,null)},"editor.inlineHints.fontSize":{type:"number",default:X.fontSize,description:w.localize(41,null)},"editor.inlineHints.fontFamily":{type:"string",default:X.fontFamily,description:w.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class U extends r{constructor(){super(53,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(X,_e,Me){return X.fontInfo.lineHeight}}class Q extends n{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(59,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:X.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:w.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),size:m(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(_e.side,this.defaultValue.side,["right","left"]),showSlider:m(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:_(_e.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(_e.scale,1,1,3),maxColumn:r.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function N(V){return V==="ctrlCmd"?D.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Z extends n{constructor(){super(69,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{top:r.clampedInt(_e.top,0,0,1e3),bottom:r.clampedInt(_e.bottom,0,0,1e3)}}}class ne extends n{constructor(){const X={enabled:!0,cycle:!1};super(70,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:w.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{enabled:_(_e.enabled,this.defaultValue.enabled),cycle:_(_e.cycle,this.defaultValue.cycle)}}}class re extends A{constructor(){super(122)}compute(X,_e,Me){return X.pixelRatio}}class ye extends n{constructor(){const X={other:!0,comments:!1,strings:!1};super(73,"quickSuggestions",X,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:X.strings,description:w.localize(58,null)},comments:{type:"boolean",default:X.comments,description:w.localize(59,null)},other:{type:"boolean",default:X.other,description:w.localize(60,null)}}}],default:X,description:w.localize(61,null)});this.defaultValue=X}validate(X){if(typeof X=="boolean")return X;if(X&&typeof X=="object"){const _e=X,Me={other:_(_e.other,this.defaultValue.other),comments:_(_e.comments,this.defaultValue.comments),strings:_(_e.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Ae;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ae=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Be extends n{constructor(){super(54,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(X){let _e=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X!="undefined"&&(typeof X=="function"?(_e=4,Me=X):X==="interval"?_e=3:X==="relative"?_e=2:X==="on"?_e=1:_e=0),{renderType:_e,renderFn:Me}}}function Re(V){const X=V.get(82);return X==="editable"?V.get(75):X!=="on"}e.filterValidationDecorations=Re;class xe extends n{constructor(){const X=[],_e={type:"number",description:w.localize(67,null)};super(86,"rulers",X,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:X,description:w.localize(69,null)})}validate(X){if(Array.isArray(X)){let _e=[];for(let Me of X)if(typeof Me=="number")_e.push({column:r.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const He=Me;_e.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return _e.sort((Me,He)=>Me.column-He.column),_e}return this.defaultValue}}function W(V,X){if(typeof V!="string")return X;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class K extends n{constructor(){super(87,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X,Me=r.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:W(_e.vertical,this.defaultValue.vertical),horizontal:W(_e.horizontal,this.defaultValue.horizontal),useShadows:_(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:_(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:_(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:_(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:_(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:r.clampedInt(_e.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(_e.verticalSliderSize,He,0,1e3),scrollByPage:_(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class J extends n{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(101,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:X.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:w.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:w.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const _e=X;return{insertMode:m(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:_(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:_(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:_(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:_(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:_(_e.showIcons,this.defaultValue.showIcons),showStatusBar:_(_e.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:_(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:_(_e.showMethods,this.defaultValue.showMethods),showFunctions:_(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:_(_e.showConstructors,this.defaultValue.showConstructors),showFields:_(_e.showFields,this.defaultValue.showFields),showVariables:_(_e.showVariables,this.defaultValue.showVariables),showClasses:_(_e.showClasses,this.defaultValue.showClasses),showStructs:_(_e.showStructs,this.defaultValue.showStructs),showInterfaces:_(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:_(_e.showModules,this.defaultValue.showModules),showProperties:_(_e.showProperties,this.defaultValue.showProperties),showEvents:_(_e.showEvents,this.defaultValue.showEvents),showOperators:_(_e.showOperators,this.defaultValue.showOperators),showUnits:_(_e.showUnits,this.defaultValue.showUnits),showValues:_(_e.showValues,this.defaultValue.showValues),showConstants:_(_e.showConstants,this.defaultValue.showConstants),showEnums:_(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:_(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:_(_e.showKeywords,this.defaultValue.showKeywords),showWords:_(_e.showWords,this.defaultValue.showWords),showColors:_(_e.showColors,this.defaultValue.showColors),showFiles:_(_e.showFiles,this.defaultValue.showFiles),showReferences:_(_e.showReferences,this.defaultValue.showReferences),showFolders:_(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:_(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:_(_e.showSnippets,this.defaultValue.showSnippets),showUsers:_(_e.showUsers,this.defaultValue.showUsers),showIssues:_(_e.showIssues,this.defaultValue.showIssues)}}}class ae extends n{constructor(){super(97,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(110,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:_(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ge extends A{constructor(){super(123,[75])}compute(X,_e,Me){return _e.get(75)?!0:X.tabFocusMode}}var De;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(De=e.WrappingIndent||(e.WrappingIndent={}));function Le(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends A{constructor(){super(125,[124])}compute(X,_e,Me){const He=_e.get(124);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",Ue="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:D.isMacintosh?Te:D.isLinux?Ue:Ce,fontWeight:"normal",fontSize:D.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(V){return e.editorOptionsRegistry[V.id]=V,V}var Ke;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingOvertype=6]="autoClosingOvertype",V[V.autoClosingQuotes=7]="autoClosingQuotes",V[V.autoIndent=8]="autoIndent",V[V.automaticLayout=9]="automaticLayout",V[V.autoSurround=10]="autoSurround",V[V.codeLens=11]="codeLens",V[V.codeLensFontFamily=12]="codeLensFontFamily",V[V.codeLensFontSize=13]="codeLensFontSize",V[V.colorDecorators=14]="colorDecorators",V[V.columnSelection=15]="columnSelection",V[V.comments=16]="comments",V[V.contextmenu=17]="contextmenu",V[V.copyWithSyntaxHighlighting=18]="copyWithSyntaxHighlighting",V[V.cursorBlinking=19]="cursorBlinking",V[V.cursorSmoothCaretAnimation=20]="cursorSmoothCaretAnimation",V[V.cursorStyle=21]="cursorStyle",V[V.cursorSurroundingLines=22]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=23]="cursorSurroundingLinesStyle",V[V.cursorWidth=24]="cursorWidth",V[V.disableLayerHinting=25]="disableLayerHinting",V[V.disableMonospaceOptimizations=26]="disableMonospaceOptimizations",V[V.dragAndDrop=27]="dragAndDrop",V[V.emptySelectionClipboard=28]="emptySelectionClipboard",V[V.extraEditorClassName=29]="extraEditorClassName",V[V.fastScrollSensitivity=30]="fastScrollSensitivity",V[V.find=31]="find",V[V.fixedOverflowWidgets=32]="fixedOverflowWidgets",V[V.folding=33]="folding",V[V.foldingStrategy=34]="foldingStrategy",V[V.foldingHighlight=35]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=36]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=37]="fontFamily",V[V.fontInfo=38]="fontInfo",V[V.fontLigatures=39]="fontLigatures",V[V.fontSize=40]="fontSize",V[V.fontWeight=41]="fontWeight",V[V.formatOnPaste=42]="formatOnPaste",V[V.formatOnType=43]="formatOnType",V[V.glyphMargin=44]="glyphMargin",V[V.gotoLocation=45]="gotoLocation",V[V.hideCursorInOverviewRuler=46]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=47]="highlightActiveIndentGuide",V[V.hover=48]="hover",V[V.inDiffEditor=49]="inDiffEditor",V[V.letterSpacing=50]="letterSpacing",V[V.lightbulb=51]="lightbulb",V[V.lineDecorationsWidth=52]="lineDecorationsWidth",V[V.lineHeight=53]="lineHeight",V[V.lineNumbers=54]="lineNumbers",V[V.lineNumbersMinChars=55]="lineNumbersMinChars",V[V.linkedEditing=56]="linkedEditing",V[V.links=57]="links",V[V.matchBrackets=58]="matchBrackets",V[V.minimap=59]="minimap",V[V.mouseStyle=60]="mouseStyle",V[V.mouseWheelScrollSensitivity=61]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=62]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=63]="multiCursorMergeOverlapping",V[V.multiCursorModifier=64]="multiCursorModifier",V[V.multiCursorPaste=65]="multiCursorPaste",V[V.occurrencesHighlight=66]="occurrencesHighlight",V[V.overviewRulerBorder=67]="overviewRulerBorder",V[V.overviewRulerLanes=68]="overviewRulerLanes",V[V.padding=69]="padding",V[V.parameterHints=70]="parameterHints",V[V.peekWidgetDefaultFocus=71]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=72]="definitionLinkOpensInPeek",V[V.quickSuggestions=73]="quickSuggestions",V[V.quickSuggestionsDelay=74]="quickSuggestionsDelay",V[V.readOnly=75]="readOnly",V[V.renameOnType=76]="renameOnType",V[V.renderControlCharacters=77]="renderControlCharacters",V[V.renderIndentGuides=78]="renderIndentGuides",V[V.renderFinalNewline=79]="renderFinalNewline",V[V.renderLineHighlight=80]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=81]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=82]="renderValidationDecorations",V[V.renderWhitespace=83]="renderWhitespace",V[V.revealHorizontalRightPadding=84]="revealHorizontalRightPadding",V[V.roundedSelection=85]="roundedSelection",V[V.rulers=86]="rulers",V[V.scrollbar=87]="scrollbar",V[V.scrollBeyondLastColumn=88]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=89]="scrollBeyondLastLine",V[V.scrollPredominantAxis=90]="scrollPredominantAxis",V[V.selectionClipboard=91]="selectionClipboard",V[V.selectionHighlight=92]="selectionHighlight",V[V.selectOnLineNumbers=93]="selectOnLineNumbers",V[V.showFoldingControls=94]="showFoldingControls",V[V.showUnused=95]="showUnused",V[V.snippetSuggestions=96]="snippetSuggestions",V[V.smartSelect=97]="smartSelect",V[V.smoothScrolling=98]="smoothScrolling",V[V.stickyTabStops=99]="stickyTabStops",V[V.stopRenderingLineAfter=100]="stopRenderingLineAfter",V[V.suggest=101]="suggest",V[V.suggestFontSize=102]="suggestFontSize",V[V.suggestLineHeight=103]="suggestLineHeight",V[V.suggestOnTriggerCharacters=104]="suggestOnTriggerCharacters",V[V.suggestSelection=105]="suggestSelection",V[V.tabCompletion=106]="tabCompletion",V[V.tabIndex=107]="tabIndex",V[V.unusualLineTerminators=108]="unusualLineTerminators",V[V.useTabStops=109]="useTabStops",V[V.wordSeparators=110]="wordSeparators",V[V.wordWrap=111]="wordWrap",V[V.wordWrapBreakAfterCharacters=112]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=113]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=114]="wordWrapColumn",V[V.wordWrapOverride1=115]="wordWrapOverride1",V[V.wordWrapOverride2=116]="wordWrapOverride2",V[V.wrappingIndent=117]="wrappingIndent",V[V.wrappingStrategy=118]="wrappingStrategy",V[V.showDeprecated=119]="showDeprecated",V[V.inlineHints=120]="inlineHints",V[V.editorClassName=121]="editorClassName",V[V.pixelRatio=122]="pixelRatio",V[V.tabFocusMode=123]="tabFocusMode",V[V.layoutInfo=124]="layoutInfo",V[V.wrappingInfo=125]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new f(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(111,null)})),acceptSuggestionOnEnter:be(new v(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(112,null),""],markdownDescription:w.localize(113,null)})),accessibilitySupport:be(new o),accessibilityPageSize:be(new r(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(114,null),deprecationMessage:w.localize(115,null)})),ariaLabel:be(new p(4,"ariaLabel",w.localize(116,null))),autoClosingBrackets:be(new v(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(117,null),w.localize(118,null),""],description:w.localize(119,null)})),autoClosingOvertype:be(new v(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(120,null),""],description:w.localize(121,null)})),autoClosingQuotes:be(new v(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(122,null),w.localize(123,null),""],description:w.localize(124,null)})),autoIndent:be(new d(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[w.localize(125,null),w.localize(126,null),w.localize(127,null),w.localize(128,null),w.localize(129,null)],description:w.localize(130,null)})),automaticLayout:be(new f(9,"automaticLayout",!1)),autoSurround:be(new v(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(131,null),w.localize(132,null),w.localize(133,null),""],description:w.localize(134,null)})),stickyTabStops:be(new f(99,"stickyTabStops",!1,{description:w.localize(135,null)})),codeLens:be(new f(11,"codeLens",!0,{description:w.localize(136,null)})),codeLensFontFamily:be(new p(12,"codeLensFontFamily","",{description:w.localize(137,null)})),codeLensFontSize:be(new r(13,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(138,null)})),colorDecorators:be(new f(14,"colorDecorators",!0,{description:w.localize(139,null)})),columnSelection:be(new f(15,"columnSelection",!1,{description:w.localize(140,null)})),comments:be(new t),contextmenu:be(new f(17,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new f(18,"copyWithSyntaxHighlighting",!0,{description:w.localize(141,null)})),cursorBlinking:be(new d(19,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:w.localize(142,null)})),cursorSmoothCaretAnimation:be(new f(20,"cursorSmoothCaretAnimation",!1,{description:w.localize(143,null)})),cursorStyle:be(new d(21,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],a,{description:w.localize(144,null)})),cursorSurroundingLines:be(new r(22,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(145,null)})),cursorSurroundingLinesStyle:be(new v(23,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(146,null),w.localize(147,null)],description:w.localize(148,null)})),cursorWidth:be(new r(24,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(149,null)})),disableLayerHinting:be(new f(25,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new f(26,"disableMonospaceOptimizations",!1)),dragAndDrop:be(new f(27,"dragAndDrop",!0,{description:w.localize(150,null)})),emptySelectionClipboard:be(new R),extraEditorClassName:be(new p(29,"extraEditorClassName","")),fastScrollSensitivity:be(new h(30,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:w.localize(151,null)})),find:be(new g),fixedOverflowWidgets:be(new f(32,"fixedOverflowWidgets",!1)),folding:be(new f(33,"folding",!0,{description:w.localize(152,null)})),foldingStrategy:be(new v(34,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(153,null),w.localize(154,null)],description:w.localize(155,null)})),foldingHighlight:be(new f(35,"foldingHighlight",!0,{description:w.localize(156,null)})),unfoldOnClickAfterEndOfLine:be(new f(36,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(157,null)})),fontFamily:be(new p(37,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(158,null)})),fontInfo:be(new C),fontLigatures2:be(new b),fontSize:be(new F),fontWeight:be(new x),formatOnPaste:be(new f(42,"formatOnPaste",!1,{description:w.localize(159,null)})),formatOnType:be(new f(43,"formatOnType",!1,{description:w.localize(160,null)})),glyphMargin:be(new f(44,"glyphMargin",!0,{description:w.localize(161,null)})),gotoLocation:be(new le),hideCursorInOverviewRuler:be(new f(46,"hideCursorInOverviewRuler",!1,{description:w.localize(162,null)})),highlightActiveIndentGuide:be(new f(47,"highlightActiveIndentGuide",!0,{description:w.localize(163,null)})),hover:be(new B),inDiffEditor:be(new f(49,"inDiffEditor",!1)),letterSpacing:be(new h(50,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>h.clamp(V,-5,20),{description:w.localize(164,null)})),lightbulb:be(new L),lineDecorationsWidth:be(new k(52,"lineDecorationsWidth",10)),lineHeight:be(new U),lineNumbers:be(new Be),lineNumbersMinChars:be(new r(55,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new f(56,"linkedEditing",!1,{description:w.localize(165,null)})),links:be(new f(57,"links",!0,{description:w.localize(166,null)})),matchBrackets:be(new v(58,"matchBrackets","always",["always","near","never"],{description:w.localize(167,null)})),minimap:be(new Q),mouseStyle:be(new v(60,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new h(61,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:w.localize(168,null)})),mouseWheelZoom:be(new f(62,"mouseWheelZoom",!1,{markdownDescription:w.localize(169,null)})),multiCursorMergeOverlapping:be(new f(63,"multiCursorMergeOverlapping",!0,{description:w.localize(170,null)})),multiCursorModifier:be(new d(64,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],N,{markdownEnumDescriptions:[w.localize(171,null),w.localize(172,null)],markdownDescription:w.localize(173,null)})),multiCursorPaste:be(new v(65,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(174,null),w.localize(175,null)],markdownDescription:w.localize(176,null)})),occurrencesHighlight:be(new f(66,"occurrencesHighlight",!0,{description:w.localize(177,null)})),overviewRulerBorder:be(new f(67,"overviewRulerBorder",!0,{description:w.localize(178,null)})),overviewRulerLanes:be(new r(68,"overviewRulerLanes",3,0,3)),padding:be(new Z),parameterHints:be(new ne),peekWidgetDefaultFocus:be(new v(71,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(179,null),w.localize(180,null)],description:w.localize(181,null)})),definitionLinkOpensInPeek:be(new f(72,"definitionLinkOpensInPeek",!1,{description:w.localize(182,null)})),quickSuggestions:be(new ye),quickSuggestionsDelay:be(new r(74,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(183,null)})),readOnly:be(new f(75,"readOnly",!1)),renameOnType:be(new f(76,"renameOnType",!1,{description:w.localize(184,null),markdownDeprecationMessage:w.localize(185,null)})),renderControlCharacters:be(new f(77,"renderControlCharacters",!1,{description:w.localize(186,null)})),renderIndentGuides:be(new f(78,"renderIndentGuides",!0,{description:w.localize(187,null)})),renderFinalNewline:be(new f(79,"renderFinalNewline",!0,{description:w.localize(188,null)})),renderLineHighlight:be(new v(80,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(189,null)],description:w.localize(190,null)})),renderLineHighlightOnlyWhenFocus:be(new f(81,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(191,null)})),renderValidationDecorations:be(new v(82,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new v(83,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(192,null),w.localize(193,null),w.localize(194,null),""],description:w.localize(195,null)})),revealHorizontalRightPadding:be(new r(84,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new f(85,"roundedSelection",!0,{description:w.localize(196,null)})),rulers:be(new xe),scrollbar:be(new K),scrollBeyondLastColumn:be(new r(88,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(197,null)})),scrollBeyondLastLine:be(new f(89,"scrollBeyondLastLine",!0,{description:w.localize(198,null)})),scrollPredominantAxis:be(new f(90,"scrollPredominantAxis",!0,{description:w.localize(199,null)})),selectionClipboard:be(new f(91,"selectionClipboard",!0,{description:w.localize(200,null),included:D.isLinux})),selectionHighlight:be(new f(92,"selectionHighlight",!0,{description:w.localize(201,null)})),selectOnLineNumbers:be(new f(93,"selectOnLineNumbers",!0)),showFoldingControls:be(new v(94,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(202,null),w.localize(203,null)],description:w.localize(204,null)})),showUnused:be(new f(95,"showUnused",!0,{description:w.localize(205,null)})),showDeprecated:be(new f(119,"showDeprecated",!0,{description:w.localize(206,null)})),inlineHints:be(new $),snippetSuggestions:be(new v(96,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(207,null),w.localize(208,null),w.localize(209,null),w.localize(210,null)],description:w.localize(211,null)})),smartSelect:be(new ae),smoothScrolling:be(new f(98,"smoothScrolling",!1,{description:w.localize(212,null)})),stopRenderingLineAfter:be(new r(100,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new J),suggestFontSize:be(new r(102,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(213,null)})),suggestLineHeight:be(new r(103,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(214,null)})),suggestOnTriggerCharacters:be(new f(104,"suggestOnTriggerCharacters",!0,{description:w.localize(215,null)})),suggestSelection:be(new v(105,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(216,null),w.localize(217,null),w.localize(218,null)],description:w.localize(219,null)})),tabCompletion:be(new v(106,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(220,null),w.localize(221,null),w.localize(222,null)],description:w.localize(223,null)})),tabIndex:be(new r(107,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new v(108,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(224,null),w.localize(225,null),w.localize(226,null)],description:w.localize(227,null)})),useTabStops:be(new f(109,"useTabStops",!0,{description:w.localize(228,null)})),wordSeparators:be(new p(110,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:w.localize(229,null)})),wordWrap:be(new v(111,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(230,null),w.localize(231,null),w.localize(232,null),w.localize(233,null)],description:w.localize(234,null)})),wordWrapBreakAfterCharacters:be(new p(112,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new p(113,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new r(114,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(235,null)})),wordWrapOverride1:be(new v(115,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new v(116,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new d(117,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Le,{enumDescriptions:[w.localize(236,null),w.localize(237,null),w.localize(238,null),w.localize(239,null)],description:w.localize(240,null)})),wrappingStrategy:be(new v(118,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(241,null),w.localize(242,null)],description:w.localize(243,null)})),editorClassName:be(new E),pixelRatio:be(new re),tabFocusMode:be(new ge),layoutInfo:be(new G),wrappingInfo:be(new pe)}}),define(we[121],Ee([17,18]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[122],Ee([17,18]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(we[123],Ee([17,18]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(we[124],Ee([17,18]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(we[125],Ee([17,18]),function(oe,e){return oe.create("vs/platform/workspaces/common/workspaces",e)}),define(we[126],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHost.api.impl",e)}),define(we[127],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[128],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionActivator",e)}),define(we[129],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[130],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostProgress",e)}),define(we[131],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[132],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[133],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[134],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[135],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(we[136],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[137],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[138],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[139],Ee([17,18]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[140],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var D;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(D=e.EditorOverride||(e.EditorOverride={}));var T;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(T=e.EditorOpenContext||(e.EditorOpenContext={}));var P;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(P=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[86],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(P,S=[],I=!1){this.ctor=P,this.staticArguments=S,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=w;const D=(T,...P)=>new w(T,P);e.createSyncDescriptor=D}),define(we[61],Ee([0,1,86]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const D=[];function T(S,I,y){I instanceof w.SyncDescriptor||(I=new w.SyncDescriptor(I,[],y)),D.push([S,I])}e.registerSingleton=T;function P(){return D}e.getSingletonServiceDescriptors=P}),define(we[141],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}e.Node=w;class D{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let S of this._nodes.values())S.outgoing.size===0&&P.push(S);return P}insertEdge(P,S){const I=this.lookupOrInsertNode(P),y=this.lookupOrInsertNode(S);I.outgoing.set(this._hashFn(S),y),y.incoming.set(this._hashFn(P),I)}removeNode(P){const S=this._hashFn(P);this._nodes.delete(S);for(let I of this._nodes.values())I.outgoing.delete(S),I.incoming.delete(S)}lookupOrInsertNode(P){const S=this._hashFn(P);let I=this._nodes.get(S);return I||(I=new w(P),this._nodes.set(S,I)),I}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[S,I]of this._nodes)P.push(`${S}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return P.join(`
`)}}e.Graph=D}),define(we[4],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function y(n){return n[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=y})(w=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function D(I,y,n,A){y[w.DI_TARGET]===y?y[w.DI_DEPENDENCIES].push({id:I,index:n,optional:A}):(y[w.DI_DEPENDENCIES]=[{id:I,index:n,optional:A}],y[w.DI_TARGET]=y)}function T(I){if(w.serviceIds.has(I))return w.serviceIds.get(I);const y=function(n,A,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(y,n,k,!1)};return y.toString=()=>I,w.serviceIds.set(I,y),y}e.createDecorator=T;function P(I){return I}e.refineServiceDecorator=P;function S(I){return function(y,n,A){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");D(I,y,A,!0)}}e.optional=S}),define(we[142],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function D(T){return!T.isTooLargeForSyncing()&&!T.isForSimpleWidget}e.shouldSynchronizeModel=D}),define(we[143],Ee([0,1,3,56,6,22,78,59,142]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function n(_){return typeof _=="string"?!1:Array.isArray(_)?_.every(n):!!_.exclusive}class A{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(f,r){let h={selector:f,provider:r,_score:-1,_time:this._clock++};return this._entries.push(h),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,T.toDisposable)(()=>{if(h){let p=this._entries.indexOf(h);p>=0&&(this._entries.splice(p,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),h=void 0)}})}has(f){return this.all(f).length>0}all(f){if(!f)return[];this._updateScores(f);const r=[];for(let h of this._entries)h._score>0&&r.push(h.provider);return r}ordered(f){const r=[];return this._orderedForEach(f,h=>r.push(h.provider)),r}orderedGroups(f){const r=[];let h,p;return this._orderedForEach(f,m=>{h&&p===m._score?h.push(m.provider):(p=m._score,h=[m.provider],r.push(h))}),r}_orderedForEach(f,r){if(!!f){this._updateScores(f);for(const h of this._entries)h._score>0&&r(h)}}_updateScores(f){let r={uri:f.uri.toString(),language:f.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let h of this._entries)if(h._score=(0,I.score)(h.selector,f.uri,f.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(f)),n(h.selector)&&h._score>0){for(let p of this._entries)p._score=0;h._score=1e3;break}this._entries.sort(A._compareByScoreAndTime)}}static _compareByScoreAndTime(f,r){return f._score<r._score?1:f._score>r._score?-1:f._time<r._time?1:f._time>r._time?-1:0}}e.LanguageFeatureRegistry=A;class k{constructor(f,r,h=Number.MAX_SAFE_INTEGER){this._registry=f,this.min=r,this.max=h,this._cache=new P.LRUCache(50,.7)}_key(f){return f.id+(0,D.hash)(this._registry.all(f))}_clamp(f){return f===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(f*1.3)))}get(f){const r=this._key(f),h=this._cache.get(r);return this._clamp(h==null?void 0:h.value)}update(f,r){const h=this._key(f);let p=this._cache.get(h);return p||(p=new S.MovingAverage,this._cache.set(h,p)),p.update(r),this.get(f)}}e.LanguageFeatureRequestDelays=k}),define(we[62],Ee([0,1,2,33,143,116,37]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlineHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlineHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(g){g[g.Null=0]="Null",g[g.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class y{constructor(b,C){this.language=b,this.id=C}}e.LanguageIdentifier=y;var n;(function(g){g[g.NotSet=-1]="NotSet",g[g.None=0]="None",g[g.Italic=1]="Italic",g[g.Bold=2]="Bold",g[g.Underline=4]="Underline"})(n=e.FontStyle||(e.FontStyle={}));var A;(function(g){g[g.None=0]="None",g[g.DefaultForeground=1]="DefaultForeground",g[g.DefaultBackground=2]="DefaultBackground"})(A=e.ColorId||(e.ColorId={}));var k;(function(g){g[g.Other=0]="Other",g[g.Comment=1]="Comment",g[g.String=2]="String",g[g.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(g){g[g.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",g[g.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",g[g.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",g[g.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",g[g.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",g[g.ITALIC_MASK=2048]="ITALIC_MASK",g[g.BOLD_MASK=4096]="BOLD_MASK",g[g.UNDERLINE_MASK=8192]="UNDERLINE_MASK",g[g.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",g[g.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",g[g.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",g[g.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",g[g.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",g[g.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",g[g.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",g[g.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",g[g.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",g[g.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class f{static getLanguageId(b){return(b&255)>>>0}static getTokenType(b){return(b&1792)>>>8}static getFontStyle(b){return(b&14336)>>>11}static getForeground(b){return(b&8372224)>>>14}static getBackground(b){return(b&4286578688)>>>23}static getClassNameFromMetadata(b){let C=this.getForeground(b),F="mtk"+C,x=this.getFontStyle(b);return x&1&&(F+=" mtki"),x&2&&(F+=" mtkb"),x&4&&(F+=" mtku"),F}static getInlineStyleFromMetadata(b,C){const F=this.getForeground(b),x=this.getFontStyle(b);let le=`color: ${C[F]};`;return x&1&&(le+="font-style: italic;"),x&2&&(le+="font-weight: bold;"),x&4&&(le+="text-decoration: underline;"),le}}e.TokenMetadata=f;var r;(function(g){g[g.Method=0]="Method",g[g.Function=1]="Function",g[g.Constructor=2]="Constructor",g[g.Field=3]="Field",g[g.Variable=4]="Variable",g[g.Class=5]="Class",g[g.Struct=6]="Struct",g[g.Interface=7]="Interface",g[g.Module=8]="Module",g[g.Property=9]="Property",g[g.Event=10]="Event",g[g.Operator=11]="Operator",g[g.Unit=12]="Unit",g[g.Value=13]="Value",g[g.Constant=14]="Constant",g[g.Enum=15]="Enum",g[g.EnumMember=16]="EnumMember",g[g.Keyword=17]="Keyword",g[g.Text=18]="Text",g[g.Color=19]="Color",g[g.File=20]="File",g[g.Reference=21]="Reference",g[g.Customcolor=22]="Customcolor",g[g.Folder=23]="Folder",g[g.TypeParameter=24]="TypeParameter",g[g.User=25]="User",g[g.Issue=26]="Issue",g[g.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let g=Object.create(null);return g[0]="symbol-method",g[1]="symbol-function",g[2]="symbol-constructor",g[3]="symbol-field",g[4]="symbol-variable",g[5]="symbol-class",g[6]="symbol-struct",g[7]="symbol-interface",g[8]="symbol-module",g[9]="symbol-property",g[10]="symbol-event",g[11]="symbol-operator",g[12]="symbol-unit",g[13]="symbol-value",g[14]="symbol-constant",g[15]="symbol-enum",g[16]="symbol-enum-member",g[17]="symbol-keyword",g[27]="symbol-snippet",g[18]="symbol-text",g[19]="symbol-color",g[20]="symbol-file",g[21]="symbol-reference",g[22]="symbol-customcolor",g[23]="symbol-folder",g[24]="symbol-type-parameter",g[25]="account",g[26]="issues",function(b){const C=g[b];let F=C&&S.iconRegistry.get(C);return F||(console.info("No codicon found for CompletionItemKind "+b),F=S.Codicon.symbolProperty),F.classNames}}(),e.completionKindFromString=function(){let g=Object.create(null);return g.method=0,g.function=1,g.constructor=2,g.field=3,g.variable=4,g.class=5,g.struct=6,g.interface=7,g.module=8,g.property=9,g.event=10,g.operator=11,g.unit=12,g.value=13,g.constant=14,g.enum=15,g["enum-member"]=16,g.enumMember=16,g.keyword=17,g.snippet=27,g.text=18,g.color=19,g.file=20,g.reference=21,g.customcolor=22,g.folder=23,g["type-parameter"]=24,g.typeParameter=24,g.account=25,g.issue=26,function(b,C){let F=g[b];return typeof F=="undefined"&&!C&&(F=9),F}}();var h;(function(g){g[g.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var p;(function(g){g[g.KeepWhitespace=1]="KeepWhitespace",g[g.InsertAsSnippet=4]="InsertAsSnippet"})(p=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(g){g[g.Invoke=0]="Invoke",g[g.TriggerCharacter=1]="TriggerCharacter",g[g.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var v;(function(g){g[g.Invoke=1]="Invoke",g[g.Auto=2]="Auto"})(v=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(g){g[g.Invoke=1]="Invoke",g[g.TriggerCharacter=2]="TriggerCharacter",g[g.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var c;(function(g){g[g.Text=0]="Text",g[g.Read=1]="Read",g[g.Write=2]="Write"})(c=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function o(g){return g&&w.URI.isUri(g.uri)&&D.Range.isIRange(g.range)&&(D.Range.isIRange(g.originSelectionRange)||D.Range.isIRange(g.targetSelectionRange))}e.isLocationLink=o;var t;(function(g){g[g.File=0]="File",g[g.Module=1]="Module",g[g.Namespace=2]="Namespace",g[g.Package=3]="Package",g[g.Class=4]="Class",g[g.Method=5]="Method",g[g.Property=6]="Property",g[g.Field=7]="Field",g[g.Constructor=8]="Constructor",g[g.Enum=9]="Enum",g[g.Interface=10]="Interface",g[g.Function=11]="Function",g[g.Variable=12]="Variable",g[g.Constant=13]="Constant",g[g.String=14]="String",g[g.Number=15]="Number",g[g.Boolean=16]="Boolean",g[g.Array=17]="Array",g[g.Object=18]="Object",g[g.Key=19]="Key",g[g.Null=20]="Null",g[g.EnumMember=21]="EnumMember",g[g.Struct=22]="Struct",g[g.Event=23]="Event",g[g.Operator=24]="Operator",g[g.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var i;(function(g){g[g.Deprecated=1]="Deprecated"})(i=e.SymbolTag||(e.SymbolTag={}));var u;(function(g){const b=new Map;b.set("file",0),b.set("module",1),b.set("namespace",2),b.set("package",3),b.set("class",4),b.set("method",5),b.set("property",6),b.set("field",7),b.set("constructor",8),b.set("enum",9),b.set("interface",10),b.set("function",11),b.set("variable",12),b.set("constant",13),b.set("string",14),b.set("number",15),b.set("boolean",16),b.set("array",17),b.set("object",18),b.set("key",19),b.set("null",20),b.set("enum-member",21),b.set("struct",22),b.set("event",23),b.set("operator",24),b.set("type-parameter",25);const C=new Map;C.set(0,"file"),C.set(1,"module"),C.set(2,"namespace"),C.set(3,"package"),C.set(4,"class"),C.set(5,"method"),C.set(6,"property"),C.set(7,"field"),C.set(8,"constructor"),C.set(9,"enum"),C.set(10,"interface"),C.set(11,"function"),C.set(12,"variable"),C.set(13,"constant"),C.set(14,"string"),C.set(15,"number"),C.set(16,"boolean"),C.set(17,"array"),C.set(18,"object"),C.set(19,"key"),C.set(20,"null"),C.set(21,"enum-member"),C.set(22,"struct"),C.set(23,"event"),C.set(24,"operator"),C.set(25,"type-parameter");function F(B){return b.get(B)}g.fromString=F;function x(B){return C.get(B)}g.toString=x;function le(B,H){const G=C.get(B);let L=G&&S.iconRegistry.get("symbol-"+G);return L||(console.info("No codicon found for SymbolKind "+B),L=S.Codicon.symbolProperty),`${H?"inline":"block"} ${L.classNames}`}g.toCssClassName=le})(u=e.SymbolKinds||(e.SymbolKinds={}));class l{constructor(b){this.value=b}}e.FoldingRangeKind=l,l.Comment=new l("comment"),l.Imports=new l("imports"),l.Region=new l("region");var s;(function(g){g[g.Collapsed=0]="Collapsed",g[g.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(g){g[g.Editing=0]="Editing",g[g.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var E;(function(g){g[g.Other=0]="Other",g[g.Type=1]="Type",g[g.Parameter=2]="Parameter"})(E=e.InlineHintKind||(e.InlineHintKind={})),e.ReferenceProviderRegistry=new T.LanguageFeatureRegistry,e.RenameProviderRegistry=new T.LanguageFeatureRegistry,e.CompletionProviderRegistry=new T.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new T.LanguageFeatureRegistry,e.HoverProviderRegistry=new T.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new T.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new T.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new T.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new T.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new T.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new T.LanguageFeatureRegistry,e.InlineHintsProviderRegistry=new T.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new T.LanguageFeatureRegistry,e.LinkProviderRegistry=new T.LanguageFeatureRegistry,e.ColorProviderRegistry=new T.LanguageFeatureRegistry,e.SelectionRangeRegistry=new T.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new T.LanguageFeatureRegistry,e.TokenizationRegistry=new P.TokenizationRegistryImpl;var R;(function(g){g[g.None=0]="None",g[g.Option=1]="Option",g[g.Default=2]="Default",g[g.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[144],Ee([0,1,6,12,4,3,46,54]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,T.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new P.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(y,n){if(!y)throw new Error("invalid command");if(typeof y=="string"){if(!n)throw new Error("invalid command");return this.registerCommand({id:y,handler:n})}if(y.description){const r=[];for(let p of y.description.args)r.push(p.constraint);const h=y.handler;y.handler=function(p,...m){return(0,D.validateConstraints)(m,r),h(p,...m)}}const{id:A}=y;let k=this._commands.get(A);k||(k=new S.LinkedList,this._commands.set(A,k));let _=k.unshift(y),f=(0,w.toDisposable)(()=>{_();const r=this._commands.get(A);(r==null?void 0:r.isEmpty())&&this._commands.delete(A)});return this._onDidRegisterCommand.fire(A),f}registerCommandAlias(y,n){return e.CommandsRegistry.registerCommand(y,(A,...k)=>A.get(e.ICommandService).executeCommand(n,...k))}getCommand(y){const n=this._commands.get(y);if(!(!n||n.isEmpty()))return I.Iterable.first(n)}getCommands(){const y=new Map;for(const n of this._commands.keys()){const A=this.getCommand(n);A&&y.set(n,A)}return y}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}}}),define(we[63],Ee([0,1,8,4,21]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let P=T.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",T.isMacintosh),S.set("isLinux",T.isLinux),S.set("isWindows",T.isWindows),S.set("isWeb",T.isWeb),S.set("isMacNative",T.isMacintosh&&!T.isWeb),S.set("isEdge",P.indexOf("Edg/")>=0),S.set("isFirefox",P.indexOf("Firefox")>=0),S.set("isChrome",P.indexOf("Chrome")>=0),S.set("isSafari",P.indexOf("Safari")>=0),S.set("isIPad",P.indexOf("iPad")>=0);const I=Object.prototype.hasOwnProperty;var y;(function(g){g[g.False=0]="False",g[g.True=1]="True",g[g.Defined=2]="Defined",g[g.Not=3]="Not",g[g.Equals=4]="Equals",g[g.NotEquals=5]="NotEquals",g[g.And=6]="And",g[g.Regex=7]="Regex",g[g.NotRegex=8]="NotRegex",g[g.Or=9]="Or",g[g.In=10]="In",g[g.NotIn=11]="NotIn",g[g.Greater=12]="Greater",g[g.GreaterEquals=13]="GreaterEquals",g[g.Smaller=14]="Smaller",g[g.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class n{static false(){return k.INSTANCE}static true(){return _.INSTANCE}static has(b){return f.create(b)}static equals(b,C){return r.create(b,C)}static notEquals(b,C){return m.create(b,C)}static regex(b,C){return i.create(b,C)}static in(b,C){return h.create(b,C)}static not(b){return v.create(b)}static and(...b){return l.create(b)}static or(...b){return s.create(b)}static greater(b,C){return d.create(b,C)}static less(b,C){return o.create(b,C)}static deserialize(b,C=!1){if(!!b)return this._deserializeOrExpression(b,C)}static _deserializeOrExpression(b,C){let F=b.split("||");return s.create(F.map(x=>this._deserializeAndExpression(x,C)))}static _deserializeAndExpression(b,C){let F=b.split("&&");return l.create(F.map(x=>this._deserializeOne(x,C)))}static _deserializeOne(b,C){if(b=b.trim(),b.indexOf("!=")>=0){let F=b.split("!=");return m.create(F[0].trim(),this._deserializeValue(F[1],C))}if(b.indexOf("==")>=0){let F=b.split("==");return r.create(F[0].trim(),this._deserializeValue(F[1],C))}if(b.indexOf("=~")>=0){let F=b.split("=~");return i.create(F[0].trim(),this._deserializeRegexValue(F[1],C))}if(b.indexOf(" in ")>=0){let F=b.split(" in ");return h.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(b)){const F=b.split(">=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(b)){const F=b.split(">");return d.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(b)){const F=b.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(b)){const F=b.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(b)?v.create(b.substr(1).trim()):f.create(b)}static _deserializeValue(b,C){if(b=b.trim(),b==="true")return!0;if(b==="false")return!1;let F=/^'([^']*)'$/.exec(b);return F?F[1].trim():b}static _deserializeRegexValue(b,C){if((0,w.isFalsyOrWhitespace)(b)){if(C)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=b.indexOf("/"),x=b.lastIndexOf("/");if(F===x||F<0){if(C)throw new Error(`bad regexp-value '${b}', missing /-enclosure`);return console.warn(`bad regexp-value '${b}', missing /-enclosure`),null}let le=b.slice(F+1,x),B=b[x+1]==="i"?"i":"";try{return new RegExp(le,B)}catch(H){if(C)throw new Error(`bad regexp-value '${b}', parse error: ${H}`);return console.warn(`bad regexp-value '${b}', parse error: ${H}`),null}}}e.ContextKeyExpr=n;function A(g,b){return g.cmp(b)}class k{constructor(){this.type=0}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return _.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class _{constructor(){this.type=1}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=_,_.INSTANCE=new _;class f{constructor(b){this.key=b,this.type=2}static create(b){const C=S.get(b);return typeof C=="boolean"?C?_.INSTANCE:k.INSTANCE:new f(b)}cmp(b){return b.type!==this.type?this.type-b.type:E(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return v.create(this.key)}}e.ContextKeyDefinedExpr=f;class r{constructor(b,C){this.key=b,this.value=C,this.type=4}static create(b,C){if(typeof C=="boolean")return C?f.create(b):v.create(b);const F=S.get(b);return typeof F=="boolean"?C===(F?"true":"false")?_.INSTANCE:k.INSTANCE:new r(b,C)}cmp(b){return b.type!==this.type?this.type-b.type:R(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(b){return b.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class h{constructor(b,C){this.key=b,this.valueKey=C,this.type=10}static create(b,C){return new h(b,C)}cmp(b){return b.type!==this.type?this.type-b.type:R(this.key,this.valueKey,b.key,b.valueKey)}equals(b){return b.type===this.type?this.key===b.key&&this.valueKey===b.valueKey:!1}evaluate(b){const C=b.getValue(this.valueKey),F=b.getValue(this.key);return Array.isArray(C)?C.indexOf(F)>=0:typeof F=="string"&&typeof C=="object"&&C!==null?I.call(C,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(b){return b.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}e.ContextKeyInExpr=h;class p{constructor(b){this._actual=b,this.type=11}static create(b){return new p(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new p(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotInExpr=p;class m{constructor(b,C){this.key=b,this.value=C,this.type=5}static create(b,C){if(typeof C=="boolean")return C?v.create(b):f.create(b);const F=S.get(b);return typeof F=="boolean"?C===(F?"true":"false")?k.INSTANCE:_.INSTANCE:new m(b,C)}cmp(b){return b.type!==this.type?this.type-b.type:R(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return b.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(b){return b.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class v{constructor(b){this.key=b,this.type=3}static create(b){const C=S.get(b);return typeof C=="boolean"?C?k.INSTANCE:_.INSTANCE:new v(b)}cmp(b){return b.type!==this.type?this.type-b.type:E(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}evaluate(b){return!b.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(b){return b.mapNot(this.key)}negate(){return f.create(this.key)}}e.ContextKeyNotExpr=v;class d{constructor(b,C){this.key=b,this.value=C,this.type=12}static create(b,C){return new d(b,C)}cmp(b){return b.type!==this.type?this.type-b.type:R(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class c{constructor(b,C){this.key=b,this.value=C,this.type=13}static create(b,C){return new c(b,C)}cmp(b){return b.type!==this.type?this.type-b.type:R(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(b){return b.mapGreaterEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=c;class o{constructor(b,C){this.key=b,this.value=C,this.type=14}static create(b,C){return new o(b,C)}cmp(b){return b.type!==this.type?this.type-b.type:R(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmaller(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerExpr=o;class t{constructor(b,C){this.key=b,this.value=C,this.type=15}static create(b,C){return new t(b,C)}cmp(b){return b.type!==this.type?this.type-b.type:R(this.key,this.value,b.key,b.value)}equals(b){return b.type===this.type?this.key===b.key&&this.value===b.value:!1}evaluate(b){return parseFloat(b.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(b){return b.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(b,C){this.key=b,this.regexp=C,this.type=7}static create(b,C){return new i(b,C)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.key<b.key)return-1;if(this.key>b.key)return 1;const C=this.regexp?this.regexp.source:"",F=b.regexp?b.regexp.source:"";return C<F?-1:C>F?1:0}equals(b){if(b.type===this.type){const C=this.regexp?this.regexp.source:"",F=b.regexp?b.regexp.source:"";return this.key===b.key&&C===F}return!1}evaluate(b){let C=b.getValue(this.key);return this.regexp?this.regexp.test(C):!1}serialize(){const b=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${b}`}keys(){return[this.key]}map(b){return b.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=i;class u{constructor(b){this._actual=b,this.type=8}static create(b){return new u(b)}cmp(b){return b.type!==this.type?this.type-b.type:this._actual.cmp(b._actual)}equals(b){return b.type===this.type?this._actual.equals(b._actual):!1}evaluate(b){return!this._actual.evaluate(b)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(b){return new u(this._actual.map(b))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class l{constructor(b){this.expr=b,this.type=6}static create(b){return l._normalizeArr(b)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let C=0,F=this.expr.length;C<F;C++){const x=A(this.expr[C],b.expr[C]);if(x!==0)return x}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let C=0,F=this.expr.length;C<F;C++)if(!this.expr[C].equals(b.expr[C]))return!1;return!0}return!1}evaluate(b){for(let C=0,F=this.expr.length;C<F;C++)if(!this.expr[C].evaluate(b))return!1;return!0}static _normalizeArr(b){const C=[];let F=!1;for(const x of b)if(!!x){if(x.type===1){F=!0;continue}if(x.type===0)return k.INSTANCE;if(x.type===6){C.push(...x.expr);continue}C.push(x)}if(C.length===0&&F)return _.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];for(C.sort(A);C.length>1;){const x=C[C.length-1];if(x.type!==9)break;C.pop();const le=C.pop(),B=s.create(x.expr.map(H=>l.create([H,le])));B&&(C.push(B),C.sort(A))}return C.length===1?C[0]:new l(C)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(let C of this.expr)b.push(...C.keys());return b}map(b){return new l(this.expr.map(C=>C.map(b)))}negate(){let b=[];for(let C of this.expr)b.push(C.negate());return s.create(b)}}e.ContextKeyAndExpr=l;class s{constructor(b){this.expr=b,this.type=9}static create(b){const C=s._normalizeArr(b);if(C.length!==0)return C.length===1?C[0]:new s(C)}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let C=0,F=this.expr.length;C<F;C++){const x=A(this.expr[C],b.expr[C]);if(x!==0)return x}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let C=0,F=this.expr.length;C<F;C++)if(!this.expr[C].equals(b.expr[C]))return!1;return!0}return!1}evaluate(b){for(let C=0,F=this.expr.length;C<F;C++)if(this.expr[C].evaluate(b))return!0;return!1}static _normalizeArr(b){let C=[],F=!1;if(b){for(let x=0,le=b.length;x<le;x++){const B=b[x];if(!!B){if(B.type===0){F=!0;continue}if(B.type===1)return[_.INSTANCE];if(B.type===9){C=C.concat(B.expr);continue}C.push(B)}}if(C.length===0&&F)return[k.INSTANCE];C.sort(A)}return C}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(let C of this.expr)b.push(...C.keys());return b}map(b){return new s(this.expr.map(C=>C.map(b)))}negate(){let b=[];for(let F of this.expr)b.push(F.negate());const C=F=>F.type===9?F.expr:[F];for(;b.length>1;){const F=b.shift(),x=b.shift(),le=[];for(const B of C(F))for(const H of C(x))le.push(n.and(B,H));b.unshift(n.or(...le))}return b[0]}}e.ContextKeyOrExpr=s;class a extends f{constructor(b,C,F){super(b);this.key=b,this._defaultValue=C,typeof F=="object"?a._info.push(Object.assign(Object.assign({},F),{key:b})):F!==!0&&a._info.push({key:b,description:F,type:C!=null?typeof C:void 0})}static all(){return a._info.values()}bindTo(b){return b.createKey(this.key,this._defaultValue)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return n.not(this.key)}isEqualTo(b){return n.equals(this.key,b)}notEqualsTo(b){return n.notEquals(this.key,b)}}e.RawContextKey=a,a._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(g,b){return g<b?-1:g>b?1:0}function R(g,b,C,F){return g<C?-1:g>C?1:b<F?-1:b>F?1:0}}),define(we[145],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(we[25],Ee([0,1,8,4]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function T(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class S{constructor(A){this.value=A,this._lower=A.toLowerCase()}static equals(A,k){if(typeof A=="undefined"||A===null)return typeof k=="undefined"||k===null;if(typeof k=="undefined"||k===null)return!1;if(typeof A=="string"||typeof k=="string"){let _=typeof A=="string"?A:A.value,f=typeof k=="string"?k:k.value;return w.equalsIgnoreCase(_,f)}return A._lower===k._lower}static toKey(A){return typeof A=="string"?A.toLowerCase():A._lower}}e.ExtensionIdentifier=S;function I(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function y(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[146],Ee([0,1,8,25]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function T(f,r){return f.uuid&&r.uuid?f.uuid===r.uuid:f.id===r.id?!0:(0,w.compareIgnoreCase)(f.id,r.id)===0}e.areSameExtensions=T;class P{constructor(r,h){this.version=h,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof P?T(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=P;function S(f,r){return`${f}.${r}`}e.getExtensionId=S;function I(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(f,r){return I(S(f,r))}e.getGalleryExtensionId=y;function n(f,r){const h=[],p=m=>{for(const v of h)if(v.some(d=>T(r(d),r(m))))return v;return null};for(const m of f){const v=p(m);v?v.push(m):h.push([m])}return h}e.groupByExtension=n;function A(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=A;function k(f){return Object.assign({id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0)},f.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function _(f){const r=new Set;for(const h of f)h.malicious&&r.add(h.id.id);return r}e.getMaliciousExtensionsSet=_}),define(we[64],Ee([0,1,122,11,2,4,8,12,22]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function n(B){return B.create===!0}e.isFileOpenForWriteOptions=n;var A;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(A=e.FileType||(e.FileType={}));var k;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock"})(k=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=_;function f(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=f;function r(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function h(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=h;var p;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(H,G){super(H);this.code=G}}e.FileSystemProviderError=m;function v(B,H){const G=new m(B.toString(),H);return c(G,H),G}e.createFileSystemProviderError=v;function d(B){return B||v((0,w.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=d;function c(B,H){return B.name=H?`${H} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=c;function o(B){if(!B)return p.Unknown;if(B instanceof m)return B.code;const H=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!H)return p.Unknown;switch(H[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=o;function t(B){if(B instanceof E)return B.fileOperationResult;switch(o(B)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class u{constructor(H,G,L){this.resource=H,this.operation=G,this.target=L}isOperation(H){return this.operation===H}}e.FileOperationEvent=u;var l;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class s{constructor(H,G){this.ignorePathCasing=G,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const L of H)switch(L.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(L.resource,L);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(L.resource,L);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(L.resource,L);break}}contains(H,...G){return this.doContains(H,{includeChildren:!1},...G)}affects(H,...G){return this.doContains(H,{includeChildren:!0},...G)}doContains(H,G,...L){var $,U,Q,N,Z,ne;if(!H)return!1;const re=L.length>0;return!!((!re||L.includes(1))&&((($=this.added)===null||$===void 0?void 0:$.get(H))||G.includeChildren&&((U=this.added)===null||U===void 0?void 0:U.findSuperstr(H)))||(!re||L.includes(0))&&(((Q=this.updated)===null||Q===void 0?void 0:Q.get(H))||G.includeChildren&&((N=this.updated)===null||N===void 0?void 0:N.findSuperstr(H)))||(!re||L.includes(2))&&(((Z=this.deleted)===null||Z===void 0?void 0:Z.findSubstr(H))||G.includeChildren&&((ne=this.deleted)===null||ne===void 0?void 0:ne.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const G=[],L=H===1?this.added:H===0?this.updated:this.deleted;if(L)for(const[,$]of L)G.push($);return G}filter(H){return new s(this.changes.filter(G=>H(G)),this.ignorePathCasing)}}e.FileChangesEvent=s;function a(B,H,G){return!B||!H||B===H||H.length>B.length?!1:(H.charAt(H.length-1)!==D.sep&&(H+=D.sep),G?(0,S.startsWithIgnoreCase)(B,H):B.indexOf(H)===0)}e.isParent=a;class E extends Error{constructor(H,G,L){super(H);this.fileOperationResult=G,this.options=L}static isFileOperationError(H){return H instanceof Error&&!(0,I.isUndefinedOrNull)(H.fileOperationResult)}}e.FileOperationError=E;var R;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var g;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(g=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function b(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=b;async function C(B,H){if(!H.canHandleResource(T.URI.from({scheme:B.scheme})))return new Promise(G=>{const L=H.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===B.scheme&&$.added&&(L.dispose(),G())})})}e.whenProviderRegistered=C,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(H){return(0,I.isNumber)(H)||(H=0),H<F.KB?(0,w.localize)(1,null,H.toFixed(0)):H<F.MB?(0,w.localize)(2,null,(H/F.KB).toFixed(2)):H<F.GB?(0,w.localize)(3,null,(H/F.MB).toFixed(2)):H<F.TB?(0,w.localize)(4,null,(H/F.GB).toFixed(2)):(0,w.localize)(5,null,(H/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;var x;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(x=e.Arch||(e.Arch={}));function le(B){return{maxFileSize:B===0?300*F.MB:16*F.GB,maxHeapSize:B===0?700*F.MB:2*700*F.MB}}e.getPlatformLimits=le}),define(we[65],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...T){this._entries=new Map;for(let[P,S]of T)this.set(P,S)}set(T,P){const S=this._entries.get(T);return this._entries.set(T,P),S}has(T){return this._entries.has(T)}get(T){return this._entries.get(T)}}e.ServiceCollection=w}),define(we[147],Ee([0,1,10,141,86,4,65,13]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class n extends Error{constructor(r){super("cyclic dependency between services");this.message=r.toString()}}class A{constructor(r=new S.ServiceCollection,h=!1,p){this._activeInstantiations=new Set,this._services=r,this._strict=h,this._parent=p,this._services.set(P.IInstantiationService,this)}createChild(r){return new A(r,this._strict,this)}invokeFunction(r,...h){let p=_.traceInvocation(r),m=!1;try{return r({get:(d,c)=>{if(m)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(d,p);if(!o&&c!==P.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return o}},...h)}finally{m=!0,p.stop()}}createInstance(r,...h){let p,m;return r instanceof T.SyncDescriptor?(p=_.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(h),p)):(p=_.traceCreation(r),m=this._createInstance(r,h,p)),p.stop(),m}_createInstance(r,h=[],p){let m=P._util.getServiceDependencies(r).sort((c,o)=>c.index-o.index),v=[];for(const c of m){let o=this._getOrCreateServiceInstance(c.id,p);if(!o&&this._strict&&!c.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${c.id}.`);v.push(o)}let d=m.length>0?m[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${r.name} at position ${d+1} conflicts with ${h.length} static arguments`);let c=d-h.length;c>0?h=h.concat(new Array(c)):h=h.slice(0,d)}return new r(...[...h,...v])}_setServiceInstance(r,h){if(this._services.get(r)instanceof T.SyncDescriptor)this._services.set(r,h);else if(this._parent)this._parent._setServiceInstance(r,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let h=this._services.get(r);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):h}_getOrCreateServiceInstance(r,h){let p=this._getServiceInstanceOrDescriptor(r);return p instanceof T.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,p,h.branch(r,!0)):(h.branch(r,!1),p)}_safeCreateAndCacheServiceInstance(r,h,p){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,h,p)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,h,p){const m=new D.Graph(c=>c.id.toString());let v=0;const d=[{id:r,desc:h,_trace:p}];for(;d.length;){const c=d.pop();if(m.lookupOrInsertNode(c),v++>1e3)throw new n(m);for(let o of P._util.getServiceDependencies(c.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(o.id);if(!t&&!o.optional&&console.warn(`[createInstance] ${r} depends on ${o.id} which is NOT registered.`),t instanceof T.SyncDescriptor){const i={id:o.id,desc:t,_trace:c._trace.branch(o.id,!0)};m.insertEdge(c,i),d.push(i)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new n(m);break}for(const{data:o}of c){if(this._getServiceInstanceOrDescriptor(o.id)instanceof T.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}m.removeNode(o)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,h,p=[],m,v){if(this._services.get(r)instanceof T.SyncDescriptor)return this._createServiceInstance(h,p,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,h,p,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(r,h=[],p,m){if(p){const v=new I.IdleValue(()=>this._createInstance(r,h,m));return new Proxy(Object.create(null),{get(d,c){if(c in d)return d[c];let o=v.value,t=o[c];return typeof t!="function"||(t=t.bind(o),d[c]=t),t},set(d,c,o){return v.value[c]=o,!0}})}else return this._createInstance(r,h,m)}}e.InstantiationService=A;var k;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(k||(k={}));class _{constructor(r,h){this.type=r,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return y?new _(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):_._None}static traceCreation(r){return y?new _(0,r.name):_._None}branch(r,h){let p=new _(2,r.toString());return this._dep.push([r,h,p]),p}stop(){let r=Date.now()-this._start;_._totals+=r;let h=!1;function p(v,d){let c=[],o=new Array(v+1).join("	");for(const[t,i,u]of d._dep)if(i&&u){h=!0,c.push(`${o}CREATES -> ${t}`);let l=p(v+1,u);l&&c.push(l)}else c.push(`${o}uses -> ${t}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${_._totals.toFixed(2)}ms)`];(r>2||h)&&console.log(m.join(`
`))}}_._None=new class extends _{constructor(){super(-1,null)}stop(){}branch(){return this}},_._totals=0}),define(we[19],Ee([0,1,4,6,21,3,60]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function I(){return new Date().toISOString()}var y;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class n extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=n;class A extends n{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([o,...t]))}debug(o,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([o,...t]))}info(o,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([o,...t]))}warn(o,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([o,...t]))}error(o,...t){if(this.checkLogLevel(y.Error))if(o instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=o.stack,this.log(y.Error,this.format(i))}else this.log(y.Error,this.format([o,...t]))}critical(o,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([o,...t]))}flush(){}format(o){let t="";for(let i=0;i<o.length;i++){let u=o[i];if(typeof u=="object")try{u=JSON.stringify(u)}catch(l){}t+=(i>0?" ":"")+u}return t}}e.AbstractMessageLogger=A;class k extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!T.isWindows}trace(o,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...t):console.log(`[main ${I()}]`,o,...t))}debug(o,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...t):console.log(`[main ${I()}]`,o,...t))}info(o,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,o,...t):console.log(`[main ${I()}]`,o,...t))}warn(o,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,o,...t):console.warn(`[main ${I()}]`,o,...t))}error(o,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,o,...t):console.error(`[main ${I()}]`,o,...t))}critical(o,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,o,...t):console.error(`[main ${I()}]`,o,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class _ extends n{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",o,...t)}debug(o,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...t)}info(o,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",o,...t)}warn(o,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",o,...t)}error(o,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",o,...t)}critical(o,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...t)}dispose(){}flush(){}}e.ConsoleLogger=_;class f extends n{constructor(o,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(t)}trace(o,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(o),...t])}debug(o,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(o),...t])}info(o,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(o),...t])}warn(o,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(o),...t])}error(o,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(o),...t])}critical(o,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(o),...t])}extractMessage(o){return typeof o=="string"?o:(0,S.toErrorMessage)(o,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=f;class r extends n{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const t of this.logServices)t.setLevel(o);super.setLevel(o)}trace(o,...t){for(const i of this.logServices)i.trace(o,...t)}debug(o,...t){for(const i of this.logServices)i.debug(o,...t)}info(o,...t){for(const i of this.logServices)i.info(o,...t)}warn(o,...t){for(const i of this.logServices)i.warn(o,...t)}error(o,...t){for(const i of this.logServices)i.error(o,...t)}critical(o,...t){for(const i of this.logServices)i.critical(o,...t)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=r;class h extends D.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...t){this.logger.trace(o,...t)}debug(o,...t){this.logger.debug(o,...t)}info(o,...t){this.logger.info(o,...t)}warn(o,...t){this.logger.warn(o,...t)}error(o,...t){this.logger.error(o,...t)}critical(o,...t){this.logger.critical(o,...t)}flush(){this.logger.flush()}}e.LogService=h;class p{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(o){}getLevel(){return y.Info}trace(o,...t){}debug(o,...t){}info(o,...t){}warn(o,...t){}error(o,...t){}critical(o,...t){}dispose(){}flush(){}}e.NullLogService=p;function m(c){if(c.verbose)return y.Trace;if(typeof c.logLevel=="string"){const o=v(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=m;function v(c){switch(c){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=v;function d(c){switch(c){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=d}),define(we[87],Ee([0,1,4,123,47]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(P=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function n(r,h){return h-r}y.compare=n;const A=Object.create(null);A[y.Error]=(0,D.localize)(0,null),A[y.Warning]=(0,D.localize)(1,null),A[y.Info]=(0,D.localize)(2,null);function k(r){return A[r]||""}y.toString=k;function _(r){switch(r){case T.default.Error:return y.Error;case T.default.Warning:return y.Warning;case T.default.Info:return y.Info;case T.default.Ignore:return y.Hint}}y.fromSeverity=_;function f(r){switch(r){case y.Error:return T.default.Error;case y.Warning:return T.default.Warning;case y.Info:return T.default.Info;case y.Hint:return T.default.Ignore}}y.toSeverity=f}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(y){const n="";function A(_){return k(_,!0)}y.makeKey=A;function k(_,f){let r=[n];return _.source?r.push(_.source.replace("\xA6","\\\xA6")):r.push(n),_.code?typeof _.code=="string"?r.push(_.code.replace("\xA6","\\\xA6")):r.push(_.code.value.replace("\xA6","\\\xA6")):r.push(n),_.severity!==void 0&&_.severity!==null?r.push(S.toString(_.severity)):r.push(n),_.message&&f?r.push(_.message.replace("\xA6","\\\xA6")):r.push(n),_.startLineNumber!==void 0&&_.startLineNumber!==null?r.push(_.startLineNumber.toString()):r.push(n),_.startColumn!==void 0&&_.startColumn!==null?r.push(_.startColumn.toString()):r.push(n),_.endLineNumber!==void 0&&_.endLineNumber!==null?r.push(_.endLineNumber.toString()):r.push(n),_.endColumn!==void 0&&_.endColumn!==null?r.push(_.endColumn.toString()):r.push(n),r.push(n),r.join("\xA6")}y.makeKeyOptionalMessage=k})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[148],Ee([0,1,47,4,3]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,D.createDecorator)("notificationService");var P;(function(n){n[n.WORKSPACE=0]="WORKSPACE",n[n.GLOBAL=1]="GLOBAL"})(P=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(n){n[n.OFF=0]="OFF",n[n.SILENT=1]="SILENT",n[n.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new y,this.onDidClose=T.Event.None,this.onDidChangeVisibility=T.Event.None}updateSeverity(A){}updateMessage(A){}updateActions(A){}close(){}}e.NoOpNotification=I;class y{infinite(){}done(){}total(A){}worked(A){}}e.NoOpProgress=y});var je=this&&this.__decorate||function(oe,e,w,D){var T=arguments.length,P=T<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,w):D,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(oe,e,w,D);else for(var I=oe.length-1;I>=0;I--)(S=oe[I])&&(P=(T<3?S(P):T>3?S(e,w,P):S(e,w))||P);return T>3&&P&&Object.defineProperty(e,w,P),P},qe=this&&this.__param||function(oe,e){return function(w,D){e(w,D,oe)}};define(we[149],Ee([0,1,4,20,6,13]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var S;(function(A){A[A.Explorer=1]="Explorer",A[A.Scm=3]="Scm",A[A.Extensions=5]="Extensions",A[A.Window=10]="Window",A[A.Notification=15]="Notification",A[A.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(k,_){super();this.deferred=new P.DeferredPromise,_.withProgress(k,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,T.toDisposable)(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};y=je([qe(1,e.IProgressService)],y),e.UnmanagedProgress=y;class n extends T.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new T.DisposableStore)}start(k){this.stop();const _=++this.currentOperationId,f=new D.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{_===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add((0,T.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,T.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,T.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:_,token:f.token,stop:()=>this.doStop(_),isCurrent:()=>this.currentOperationId===_}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=n,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(we[30],Ee([0,1,12,43]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.data=new Map}add(S,I){D.ok(w.isString(S)),D.ok(w.isObject(I)),D.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,I)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new T}),define(we[88],Ee([0,1,30,3]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,n){this.schemasById[T(y)]=n,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new P;w.Registry.add(e.Extensions.JSONContribution,S)}),define(we[66],Ee([0,1,121,3,30,12,88]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=T.Registry.as(S.Extensions.JSONContribution);class n{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,v=!0){this.registerConfigurations([m],v)}registerConfigurations(m,v=!0){const d=[];m.forEach(c=>{d.push(...this.validateAndRegisterProperties(c,v)),this.configurationContributors.push(c),this.registerJSONConfiguration(c)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(m){const v=[],d=c=>{if(c.properties)for(const o in c.properties)v.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,c.properties[o]);c.allOf&&c.allOf.forEach(o=>d(o))};for(const c of m){d(c);const o=this.configurationContributors.indexOf(c);o!==-1&&this.configurationContributors.splice(o,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}registerDefaultConfigurations(m){const v=[],d=[];for(const c of m)for(const o in c)if(v.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]=Object.assign(Object.assign({},this.defaultValues[o]||{}),c[o]);const t={type:"object",default:this.defaultValues[o],description:w.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};d.push(k(o)),this.configurationProperties[o]=t,this.defaultLanguageConfigurationOverridesNode.properties[o]=t}else{this.defaultValues[o]=c[o];const t=this.configurationProperties[o];t&&(this.updatePropertyDefaultValue(o,t),this.updateSchema(o,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterDefaultConfigurations(m){const v=[];for(const d of m)for(const c in d)if(v.push(c),delete this.defaultValues[c],e.OVERRIDE_PROPERTY_PATTERN.test(c))delete this.configurationProperties[c],delete this.defaultLanguageConfigurationOverridesNode.properties[c];else{const o=this.configurationProperties[c];o&&(this.updatePropertyDefaultValue(c,o),this.updateSchema(c,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const v of m)this.overrideIdentifiers.add(v);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,v=!0,d=3){d=P.isUndefinedOrNull(m.scope)?d:m.scope;let c=[],o=m.properties;if(o)for(let i in o){if(v&&r(i)){delete o[i];continue}const u=o[i];if(this.updatePropertyDefaultValue(i,u),e.OVERRIDE_PROPERTY_PATTERN.test(i)?u.scope=void 0:u.scope=P.isUndefinedOrNull(u.scope)?d:u.scope,o[i].hasOwnProperty("included")&&!o[i].included){this.excludedConfigurationProperties[i]=o[i],delete o[i];continue}else this.configurationProperties[i]=o[i];!o[i].deprecationMessage&&o[i].markdownDeprecationMessage&&(o[i].deprecationMessage=o[i].markdownDeprecationMessage),c.push(i)}let t=m.allOf;if(t)for(let i of t)c.push(...this.validateAndRegisterProperties(i,v,d));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const v=d=>{let c=d.properties;if(c)for(const t in c)this.updateSchema(t,c[t]);let o=d.allOf;o&&o.forEach(v)};v(m)}updateSchema(m,v){switch(e.allSettings.properties[m]=v,v.scope){case 1:e.applicationSettings.properties[m]=v;break;case 2:e.machineSettings.properties[m]=v;break;case 6:e.machineOverridableSettings.properties[m]=v;break;case 3:e.windowSettings.properties[m]=v;break;case 4:e.resourceSettings.properties[m]=v;break;case 5:e.resourceSettings.properties[m]=v,this.resourceLanguageSettingsSchema.properties[m]=v;break}}removeFromSchema(m,v){switch(delete e.allSettings.properties[m],v.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const v=`[${m}]`,d={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(v,d),e.allSettings.properties[v]=d,e.applicationSettings.properties[v]=d,e.machineSettings.properties[v]=d,e.machineOverridableSettings.properties[v]=d,e.windowSettings.properties[v]=d,e.resourceSettings.properties[v]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,v){let d=this.defaultValues[m];P.isUndefined(d)&&(d=v.default),P.isUndefined(d)&&(d=_(v.type)),v.default=d}}const A="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(A);function k(p){return p.substring(1,p.length-1)}e.overrideIdentifierFromKey=k;function _(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=_;const f=new n;T.Registry.add(e.Extensions.Configuration,f);function r(p){return p.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(p)?w.localize(5,null,p):f.getConfigurationProperties()[p]!==void 0?w.localize(6,null,p):null:w.localize(4,null)}e.validateProperty=r;function h(){const p=[],m=f.getConfigurationProperties();for(const v of Object.keys(m))p.push([v,m[v].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=h}),define(we[89],Ee([0,1,23,12,2,30,4,66]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function y(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.isConfigurationOverrides=y;var n;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(n=e.ConfigurationTarget||(e.ConfigurationTarget={}));function A(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=A;function k(i,u){const l=u?i?u.keys.filter(C=>i.keys.indexOf(C)===-1):[...u.keys]:[],s=i?u?i.keys.filter(C=>u.keys.indexOf(C)===-1):[...i.keys]:[],a=[];if(u&&i){for(const C of i.keys)if(u.keys.indexOf(C)!==-1){const F=m(i.contents,C),x=m(u.contents,C);w.equals(F,x)||a.push(C)}}const E=[],R=C=>{const F={};for(const x of C)for(const le of x.identifiers)F[o(le)]=x;return F},g=u?R(u.overrides):{},b=i?R(i.overrides):{};if(Object.keys(g).length)for(const C of l){const F=g[C];F&&E.push([(0,I.overrideIdentifierFromKey)(C),F.keys])}if(Object.keys(b).length)for(const C of s){const F=b[C];F&&E.push([(0,I.overrideIdentifierFromKey)(C),F.keys])}if(Object.keys(g).length&&Object.keys(b).length)for(const C of a){const F=b[C],x=g[C];if(F&&x){const le=k({contents:F.contents,keys:F.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});E.push([(0,I.overrideIdentifierFromKey)(C),[...le.added,...le.removed,...le.updated]])}}return{added:l,removed:s,updated:a,overrides:E}}e.compare=k;function _(i,u){const l=[];for(const s of Object.keys(i))if(I.OVERRIDE_PROPERTY_PATTERN.test(s)){const a={};for(const E in i[s])a[E]=i[s][E];l.push({identifiers:[(0,I.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(a),contents:f(a,u)})}return l}e.toOverrides=_;function f(i,u){const l=Object.create(null);for(let s in i)r(l,s,i[s],u);return l}e.toValuesTree=f;function r(i,u,l,s){const a=u.split("."),E=a.pop();let R=i;for(let g=0;g<a.length;g++){let b=a[g],C=R[b];switch(typeof C){case"undefined":C=R[b]=Object.create(null);break;case"object":break;default:s(`Ignoring ${u} as ${a.slice(0,g+1).join(".")} is ${JSON.stringify(C)}`);return}R=C}if(typeof R=="object"&&R!==null)try{R[E]=l}catch(g){s(`Ignoring ${u} as ${a.join(".")} is ${JSON.stringify(R)}`)}else s(`Ignoring ${u} as ${a.join(".")} is ${JSON.stringify(R)}`)}e.addToValueTree=r;function h(i,u){const l=u.split(".");p(i,l)}e.removeFromValueTree=h;function p(i,u){const l=u.shift();if(u.length===0){delete i[l];return}if(Object.keys(i).indexOf(l)!==-1){const s=i[l];typeof s=="object"&&!Array.isArray(s)&&(p(s,u),Object.keys(s).length===0&&delete i[l])}}function m(i,u,l){function s(R,g){let b=R;for(const C of g){if(typeof b!="object"||b===null)return;b=b[C]}return b}const a=u.split("."),E=s(i,a);return typeof E=="undefined"?l:E}e.getConfigurationValue=m;function v(i,u,l){Object.keys(u).forEach(s=>{s!=="__proto__"&&(s in i?D.isObject(i[s])&&D.isObject(u[s])?v(i[s],u[s],l):l&&(i[s]=u[s]):i[s]=u[s])})}e.merge=v;function d(){const i=P.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=d;function c(){const i=Object.create(null),u=P.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let l in u){let s=u[l].default;r(i,l,s,a=>console.error(`Conflict in default settings: ${a}`))}return i}e.getDefaultValues=c;function o(i){return`[${i}]`}e.keyFromOverrideIdentifier=o;function t(i,u,l){const s=i.inspect(u),a=i.inspect(l);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:s.defaultValue}e.getMigratedSettingValue=t}),define(we[150],Ee([0,1,45,22,15,12,23,2,66,89,30,6,3]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(t={},i=[],u=[]){this._contents=t,this._keys=i,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const u=this.getContentsForOverrideIdentifer(i);return u?t?(0,n.getConfigurationValue)(u,t):u:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let u={};for(const l of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[l],a=i[l];a&&(typeof s=="object"&&typeof a=="object"?(s=S.deepClone(s),this.mergeContents(s,a)):s=a),u[l]=s}return new f(u,this.keys,this.overrides)}merge(...t){const i=S.deepClone(this.contents),u=S.deepClone(this.overrides),l=[...this.keys];for(const s of t){this.mergeContents(i,s.contents);for(const a of s.overrides){const[E]=u.filter(R=>T.equals(R.identifiers,a.identifiers));E?this.mergeContents(E.contents,a.contents):u.push(S.deepClone(a))}for(const a of s.keys)l.indexOf(a)===-1&&l.push(a)}return new f(i,l,u)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const u of Object.keys(i)){if(u in t&&P.isObject(t[u])&&P.isObject(i[u])){this.mergeContents(t[u],i[u]);continue}t[u]=S.deepClone(i[u])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,n.addToValueTree)(this.contents,t,i,u=>{throw new Error(u)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let u=0;u<i;u++)t.indexOf(this.keys[u])===0&&(i=u);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class r extends f{constructor(){const t=(0,n.getDefaultValues)(),i=(0,n.getConfigurationKeys)(),u=[];for(const l of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(l)&&u.push({identifiers:[(0,y.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(t[l]),contents:(0,n.toValuesTree)(t[l],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,i,u)}}e.DefaultConfigurationModel=r;class h{constructor(t,i){this._name=t,this._scopes=i,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get errors(){return this._parseErrors}parseContent(t){if(!P.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i)}}parseRaw(t){this._raw=t;const i=this.doParseRaw(t);this._configurationModel=new f(i.contents,i.keys,i.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let i={},u=null,l=[],s=[],a=[];function E(g){Array.isArray(l)?l.push(g):u&&(l[u]=g)}let R={onObjectBegin:()=>{let g={};E(g),s.push(l),l=g,u=null},onObjectProperty:g=>{u=g},onObjectEnd:()=>{l=s.pop()},onArrayBegin:()=>{let g=[];E(g),s.push(l),l=g,u=null},onArrayEnd:()=>{l=s.pop()},onLiteralValue:E,onError:(g,b,C)=>{a.push({error:g,offset:b,length:C})}};if(t)try{w.visit(t,R),i=l[0]||{}}catch(g){console.error(`Error while parsing settings file ${this._name}: ${g}`),this._parseErrors=[g]}return i}doParseRaw(t){if(this._scopes){const s=A.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,s,!0,this._scopes)}const i=(0,n.toValuesTree)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`)),u=Object.keys(t),l=(0,n.toOverrides)(t,s=>console.error(`Conflict in settings file ${this._name}: ${s}`));return{contents:i,keys:u,overrides:l}}filterByScope(t,i,u,l){const s={};for(let a in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(a)&&u)s[a]=this.filterByScope(t[a],i,!1,l);else{const E=this.getScope(a,i);(E===void 0||l.indexOf(E)!==-1)&&(s[a]=t[a])}return s}getScope(t,i){const u=i[t];return u?typeof u.scope!="undefined"?u.scope:3:void 0}}e.ConfigurationModelParser=h;class p extends k.Disposable{constructor(t,i,u,l){super();this.userSettingsResource=t,this.scopes=i,this.fileService=l,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(_.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new f}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=p;class m{constructor(t,i,u=new f,l=new f,s=new D.ResourceMap,a=new f,E=new D.ResourceMap,R=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=u,this._workspaceConfiguration=l,this._folderConfigurations=s,this._memoryConfiguration=a,this._memoryConfigurationByResource=E,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(t,i,u){return this.getConsolidateConfigurationModel(i,u).getValue(t)}updateValue(t,i,u={}){let l;u.resource?(l=this._memoryConfigurationByResource.get(u.resource),l||(l=new f,this._memoryConfigurationByResource.set(u.resource,l))):l=this._memoryConfiguration,i===void 0?l.removeValue(t):l.setValue(t,i),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,u){const l=this.getConsolidateConfigurationModel(i,u),s=this.getFolderConfigurationModelForResource(i.resource,u),a=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),g=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),b=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),C=u?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,x=i.overrideIdentifier?a.override(i.overrideIdentifier).getValue(t):a.getValue(t),le=l.getValue(t),B=T.distinct(T.flatten(l.overrides.map(H=>H.identifiers))).filter(H=>l.getOverrideValue(t,H)!==void 0);return{defaultValue:E,userValue:R,userLocalValue:g,userRemoteValue:b,workspaceValue:C,workspaceFolderValue:F,memoryValue:x,value:le,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:g!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:b!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:C!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:i.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:a.getValue(t),override:i.overrideIdentifier?a.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const u=i.filter(l=>y.OVERRIDE_PROPERTY_PATTERN.test(l)).map(l=>{const s=(0,y.overrideIdentifierFromKey)(l),a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),E=t.getKeysForOverrideIdentifier(s),R=[...E.filter(g=>a.indexOf(g)===-1),...a.filter(g=>E.indexOf(g)===-1),...a.filter(g=>!S.equals(this._defaultConfiguration.override(s).getValue(g),t.override(s).getValue(g)))];return[s,R]});return this.updateDefaultConfiguration(t),{keys:i,overrides:u}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:u,removed:l,overrides:s}=(0,n.compare)(this.localUserConfiguration,t),a=[...i,...u,...l];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:u,removed:l,overrides:s}=(0,n.compare)(this.remoteUserConfiguration,t);let a=[...i,...u,...l];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:u,removed:l,overrides:s}=(0,n.compare)(this.workspaceConfiguration,t);let a=[...i,...u,...l];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(t,i){const u=this.folderConfigurations.get(t),{added:l,updated:s,removed:a,overrides:E}=(0,n.compare)(u,i);let R=[...l,...s,...a];return(R.length||!u)&&this.updateFolderConfiguration(t,i),{keys:R,overrides:E}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:u,updated:l,removed:s,overrides:a}=(0,n.compare)(i,void 0);return{keys:[...u,...l,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let u=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?u.override(t.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:t},i){let u=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const l=i.getFolder(t);l&&(u=this.getFolderConsolidatedConfiguration(l.uri)||u);const s=this._memoryConfigurationByResource.get(t);s&&(u=u.merge(s))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const u=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(t);l?(i=u.merge(l),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=u}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const u=i.getFolder(t);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:u,overrides:l,keys:s}=this._folderConfigurations.get(i);return t.push([i,{contents:u,overrides:l,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(u=>t.add(u))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>i.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>i.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(t).forEach(l=>i.add(l))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),u=this.parseConfigurationModel(t.user),l=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((a,E)=>(a.set(I.URI.revive(E[0]),this.parseConfigurationModel(E[1])),a),new D.ResourceMap);return new m(i,u,new f,l,s,new f,new D.ResourceMap,!1)}static parseConfigurationModel(t){return new f(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function v(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const l of o)l.keys.forEach(s=>t.add(s)),l.overrides.forEach(([s,a])=>{const E=(0,D.getOrSet)(i,s,new Set);a.forEach(R=>E.add(R))});const u=[];return i.forEach((l,s)=>u.push([s,[...l.values()]])),{keys:[...t.values()],overrides:u}}e.mergeChanges=v;class d{constructor(t,i,u,l){this.change=t,this.previous=i,this.currentConfiguraiton=u,this.currentWorkspace=l,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(E=>s.add(E)),t.overrides.forEach(([,E])=>E.forEach(R=>s.add(R))),this.affectedKeys=[...s.values()];const a=new f;this.affectedKeys.forEach(E=>a.setValue(E,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var u;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const l=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(u=this.previous)===null||u===void 0?void 0:u.workspace):void 0,s=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!S.equals(l,s)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let u=(0,n.toValuesTree)({[i]:!0},()=>{}),l;for(;typeof u=="object"&&(l=Object.keys(u)[0]);){if(t=t[l],!t)return!1;u=u[l]}return!0}}e.ConfigurationChangeEvent=d;class c extends d{constructor(t,i,u,l){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=u,this.sourceConfig=l}}e.AllKeysConfigurationChangeEvent=c}),define(we[90],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var D;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(S,I=D.Unknown,y){super(S);this._message=S,this._code=I,this._detail=y,this.isHandled=I===D.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(S){return S instanceof T&&S._code===D.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof T&&S._code===D.NoResolverFound}static isHandled(S){return S instanceof T&&S.isHandled}}e.RemoteAuthorityResolverError=T}),define(we[91],Ee([0,1,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function D(P){return P.scheme===w.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=D;function T(P){if(!!P){const S=P.indexOf("+");return S<0?P:P.substr(0,S)}}e.getRemoteName=T}),define(we[151],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(T){this._callback=T,this._terminalBufferMap=new Map}dispose(){for(const T of this._terminalBufferMap.values())T.dispose()}startBuffering(T,P,S=5){let I;return I=P(y=>{const n=typeof y=="string"?y:y.data;let A=this._terminalBufferMap.get(T);if(A){A.data.push(n);return}const k=setTimeout(()=>this._flushBuffer(T),S);A={data:[n],timeoutId:k,dispose:()=>{clearTimeout(k),this._flushBuffer(T),I.dispose()}},this._terminalBufferMap.set(T,A)}),I}stopBuffering(T){const P=this._terminalBufferMap.get(T);P&&P.dispose()}_flushBuffer(T){const P=this._terminalBufferMap.get(T);P&&(this._terminalBufferMap.delete(T),this._callback(T,P.data.join("")))}}e.TerminalDataBufferer=w}),define(we[152],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(we[153],Ee([0,1,4,6,30,3,152,37]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var y;(function(p){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}p.isThemeColor=m})(y=e.ThemeColor||(e.ThemeColor={}));function n(p){return{id:p}}e.themeColorFromId=n;var A;(function(p){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}p.isThemeIcon=m;const v=new RegExp(`^\\$\\((${I.CSSIcon.iconNameExpression}(?:${I.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const i=v.exec(t);if(!!i){let[,u]=i;return{id:u}}}p.fromString=d;function c(t,i){let u=t.id;const l=u.lastIndexOf("~");return l!==-1&&(u=u.substring(0,l)),i&&(u=`${u}~${i}`),{id:u}}p.modify=c;function o(t,i){var u,l;return t.id===i.id&&((u=t.color)===null||u===void 0?void 0:u.id)===((l=i.color)===null||l===void 0?void 0:l.id)}p.isEqual=o,p.asClassNameArray=I.CSSIcon.asClassNameArray,p.asClassName=I.CSSIcon.asClassName,p.asCSSSelector=I.CSSIcon.asCSSSelector})(A=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=I.Codicon.file,e.FolderThemeIcon=I.Codicon.folder;function k(p){switch(p){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class _{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new P.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new _;T.Registry.add(e.Extensions.ThemingContribution,f);function r(p){return f.onColorThemeChange(p)}e.registerThemingParticipant=r;class h extends D.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let d=this.theme.getColor(m);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=h}),define(we[154],Ee([0,1,30,153,3,124,88,13,37]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class n{constructor(){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,P.localize)(0,null)},fontCharacter:{type:"string",description:(0,P.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${y.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,v,d,c){const o=this.iconsById[m];if(o){if(d&&!o.description){o.description=d,this.iconSchema.properties[m].markdownDescription=`${d} $(${m})`;const u=this.iconReferenceSchema.enum.indexOf(m);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=d),this._onDidChange.fire()}return o}let t={id:m,description:d,defaults:v,deprecationMessage:c};this.iconsById[m]=t;let i={$ref:"#/definitions/icons"};return c&&(i.deprecationMessage=c),d&&(i.markdownDescription=`${d}: $(${m})`),this.iconSchema.properties[m]=i,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const v=this.iconReferenceSchema.enum.indexOf(m);v!==-1&&(this.iconReferenceSchema.enum.splice(v,1),this.iconReferenceSchema.enumDescriptions.splice(v,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,v){const d=this.iconFontsById[m];if(d)return d;let c={id:m,definition:v};return this.iconFontsById[m]=c,this._onDidChange.fire(),c}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(o,t)=>o.id.localeCompare(t.id),v=o=>{for(;D.ThemeIcon.isThemeIcon(o.defaults);)o=this.iconsById[o.defaults.id];return`codicon codicon-${o?o.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.iconsById).map(o=>this.iconsById[o]);for(const o of c.filter(t=>!!t.description).sort(m))d.push(`|<i class="${v(o)}"></i>|${o.id}|${D.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const o of c.filter(t=>!D.ThemeIcon.isThemeIcon(t.defaults)).sort(m))d.push(`|<i class="${v(o)}"></i>|${o.id}|`);return d.join(`
`)}}const A=new n;w.Registry.add(e.Extensions.IconContribution,A);function k(p,m,v,d){return A.registerIcon(p,m,v,d)}e.registerIcon=k;function _(){return A}e.getIconRegistry=_;function f(){for(const p of y.iconRegistry.all)A.registerIcon(p.id,p.definition,p.description);y.iconRegistry.onDidRegister(p=>A.registerIcon(p.id,p.definition,p.description))}f(),e.iconsSchemaId="vscode://schemas/icons";let r=w.Registry.as(S.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,A.getIconSchema());const h=new I.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);A.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=k("widget-close",y.Codicon.close,(0,P.localize)(2,null)),e.gotoPreviousLocation=k("goto-previous-location",y.Codicon.arrowUp,(0,P.localize)(3,null)),e.gotoNextLocation=k("goto-next-location",y.Codicon.arrowDown,(0,P.localize)(4,null)),e.syncing=D.ThemeIcon.modify(y.Codicon.sync,"spin")}),define(we[48],Ee([0,1,2,24,4,22]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var S;(function(_){_[_.EMPTY=1]="EMPTY",_[_.FOLDER=2]="FOLDER",_[_.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function I(_){const f=_;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=I;function y(_){const f=_;return!!(f&&typeof f=="object"&&w.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=y;class n{constructor(f,r,h,p){this._id=f,this._configuration=h,this._ignorePathCasing=p,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(f){this._id=f.id,this._configuration=f.configuration,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=n;class A{constructor(f,r){this.raw=r,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,D.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function k(_){return new A({uri:_,index:0,name:(0,D.basenameOrAuthority)(_)},{uri:_.toString()})}e.toWorkspaceFolder=k}),define(we[155],Ee([0,1,4,125,48,2,21,11,24,104,45,16,58,38,91]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(G){return(typeof G=="string"?(0,I.extname)(G):(0,y.extname)(G))===h}e.hasWorkspaceFileExtension=p,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function m(G){return G.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function v(G){return G.hasOwnProperty("folderUri")}e.isRecentFolder=v;function d(G){return G.hasOwnProperty("fileUri")}e.isRecentFile=d;function c(G){const L=G;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.uri)}e.isSingleFolderWorkspaceIdentifier=c;function o(G){if(G.configuration)return{id:G.id,configPath:G.configuration};if(G.folders.length===1)return{id:G.id,uri:G.folders[0].uri}}e.toWorkspaceIdentifier=o;function t(G){const L=G;return typeof(L==null?void 0:L.id)=="string"&&P.URI.isUri(L.configPath)}e.isWorkspaceIdentifier=t;function i(G){const L=G;if(L==null?void 0:L.uri)return{id:L.id,uri:P.URI.revive(L.uri)};const $=G;if($==null?void 0:$.configPath)return{id:$.id,configPath:P.URI.revive($.configPath)};if(G==null?void 0:G.id)return{id:G.id}}e.reviveIdentifier=i;function u(G,L){return y.extUriBiasedIgnorePathCase.isEqualOrParent(G,L.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function l(G){return s(G)||a(G)}e.isStoredWorkspaceFolder=l;function s(G){const L=G;return typeof(L==null?void 0:L.path)=="string"&&(!L.name||typeof L.name=="string")}e.isRawFileWorkspaceFolder=s;function a(G){const L=G;return typeof(L==null?void 0:L.uri)=="string"&&(!L.name||typeof L.name=="string")}e.isRawUriWorkspaceFolder=a;function E(G,L,$,U,Q=!S.isWindows,N){if(G.scheme!==U.scheme)return{name:$,uri:G.toString(!0)};let Z=L?void 0:N.relativePath(U,G);if(Z!==void 0)Z.length===0?Z=".":S.isWindows&&G.scheme===k.Schemas.file&&!Q&&(Z=Z.replace(/\//g,"\\"));else if(G.scheme===k.Schemas.file)Z=G.fsPath,S.isWindows&&(Z=(0,_.normalizeDriveLetter)(Z),Q&&(Z=(0,f.toSlashes)(Z)));else{if(!N.isEqualAuthority(G.authority,U.authority))return{name:$,uri:G.toString(!0)};Z=G.path}return{name:$,path:Z}}e.getStoredWorkspaceFolder=E;function R(G,L,$){let U=[],Q=new Set;const N=$.dirname(L);for(let Z of G){let ne=null;if(s(Z))Z.path&&(ne=$.resolvePath(N,Z.path));else if(a(Z))try{ne=P.URI.parse(Z.uri),ne.path[0]!=="/"&&(ne=ne.with({path:"/"+ne.path}))}catch(re){console.warn(re)}if(ne){let re=$.getComparisonKey(ne);if(!Q.has(re)){Q.add(re);const ye=Z.name||$.basenameOrAuthority(ne);U.push(new T.WorkspaceFolder({uri:ne,name:ye,index:U.length},Z))}}}return U}e.toWorkspaceFolders=R;function g(G,L,$,U,Q){let N=b(L,G);const Z=Q.dirname(L),ne=Q.dirname(U),re=[],ye=C(N.folders);for(const xe of N.folders){const W=s(xe)?Q.resolvePath(Z,xe.path):P.URI.parse(xe.uri);let K;$?K=!1:K=!s(xe)||(0,I.isAbsolute)(xe.path),re.push(E(W,K,xe.name,ne,ye,Q))}const Ae={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},Be=n.setProperty(G,["folders"],re,Ae);let Re=n.applyEdits(G,Be);return N.remoteAuthority===(0,r.getRemoteAuthority)(U)&&(Re=n.applyEdits(Re,n.removeProperty(Re,["remoteAuthority"],Ae))),Re}e.rewriteWorkspaceFileForNewLocation=g;function b(G,L){let $=A.parse(L);if($&&Array.isArray($.folders))$.folders=$.folders.filter(U=>l(U));else throw new Error(`${G} looks like an invalid workspace file.`);return $}function C(G){return S.isWindows?G.some(L=>s(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=C;function F(G){return G.workspace&&typeof G.workspace=="object"&&typeof G.workspace.id=="string"&&typeof G.workspace.configPath=="string"}function x(G){return typeof G.folderUri=="string"}function le(G){return typeof G.fileUri=="string"}function B(G,L){const $={workspaces:[],files:[]};if(G){const U=function(N,Z){for(let ne=0;ne<N.length;ne++)try{Z(N[ne],ne)}catch(re){L.warn(`Error restoring recent entry ${JSON.stringify(N[ne])}: ${re.toString()}. Skip entry.`)}},Q=G;if(Array.isArray(Q.entries))U(Q.entries,N=>{const Z=N.label,ne=N.remoteAuthority;F(N)?$.workspaces.push({label:Z,remoteAuthority:ne,workspace:{id:N.workspace.id,configPath:P.URI.parse(N.workspace.configPath)}}):x(N)?$.workspaces.push({label:Z,remoteAuthority:ne,folderUri:P.URI.parse(N.folderUri)}):le(N)&&$.files.push({label:Z,remoteAuthority:ne,fileUri:P.URI.parse(N.fileUri)})});else{const N=G;Array.isArray(N.workspaces3)&&U(N.workspaces3,(Z,ne)=>{const re=Array.isArray(N.workspaceLabels)&&N.workspaceLabels[ne]||void 0;typeof Z=="object"&&typeof Z.id=="string"&&typeof Z.configURIPath=="string"?$.workspaces.push({label:re,workspace:{id:Z.id,configPath:P.URI.parse(Z.configURIPath)}}):typeof Z=="string"&&$.workspaces.push({label:re,folderUri:P.URI.parse(Z)})}),Array.isArray(N.files2)&&U(N.files2,(Z,ne)=>{const re=Array.isArray(N.fileLabels)&&N.fileLabels[ne]||void 0;typeof Z=="string"&&$.files.push({label:re,fileUri:P.URI.parse(Z)})})}}return $}e.restoreRecentlyOpened=B;function H(G){const L={entries:[]};for(const $ of G.workspaces)v($)?L.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):L.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of G.files)L.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return L}e.toStoreData=H}),define(we[92],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(T){this.id=T,this._data=new Map,this._idPool=1}add(T){const P=this._idPool++;return this._data.set(P,T),this.logDebugInfo(),P}get(T,P){return this._data.has(T)?this._data.get(T)[P]:void 0}delete(T){this._data.delete(T),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(we[156],Ee([0,1,2,3]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class T{constructor(){this._onDidChangeTabs=new D.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(I=>({name:I.name,group:I.group,resource:w.URI.revive(I.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(we[49],Ee([0,1,16,4]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,I){I===null?this._providerInfo.delete(S):this._providerInfo.set(S,I)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(we[157],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class w{constructor(P,S,I){this._id=P,this._shared=S,this._storage=I,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(y=>(this._value=y,this)),this._storageListener=this._storage.onDidChangeStorage(y=>{y.shared===this._shared&&y.key===this._id&&(this._value=y.value)})}get whenReady(){return this._init}get(P,S){let I=this._value[P];return typeof I=="undefined"&&(I=S),I}update(P,S){return this._value[P]=S,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=w;class D extends w{constructor(P,S){super(P.identifier.value,!0,S);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=D}),define(we[14],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class D{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.ExtHostRpcService=D});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[158],Ee([0,1,25,3]),function(oe,e,w,D){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class P{constructor(I,y){T.set(this,void 0),this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(I.identifier),tt(this,T,y),We(this,T).onDidChangePassword(n=>{n.extensionId===this._id&&this._onDidChange.fire({key:n.key})})}get(I){return We(this,T).get(this._id,I)}store(I,y){return We(this,T).store(this._id,I,y)}delete(I){return We(this,T).delete(this._id,I)}}e.ExtensionSecrets=P,T=new WeakMap}),define(we[93],Ee([0,1,4,3]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class T{constructor(){this._onDidChangeTelemetryEnabled=new D.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=T,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(we[67],Ee([0,1,4,3,14]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(I){function y(A){return{remoteAddress:A.remoteAddress,localAddress:A.localAddress,public:!!A.public}}I.fromApiTunnel=y;function n(A){return{remoteAddress:{host:A.tunnelRemoteHost,port:A.tunnelRemotePort},localAddress:A.localAddress,public:A.public}}I.fromServiceTunnel=n})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let S=class{constructor(y){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,n){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,n){return{dispose:()=>{}}}async $providePortAttributes(y,n,A,k,_){return[]}async $forwardPort(y,n){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=je([qe(0,T.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[7],Ee([0,1,15,10,80,22,12,2,29,64,90]),function(oe,e,w,D,T,P,S,I,y,n,A){"use strict";var k,_,f,r,h,p,m,v,d,c,o,t,i,u,l,s;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestState=e.TestItem=e.TestMessageSeverity=e.TestResult=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookRunState=e.NotebookCellRunState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlineHint=e.InlineHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(O){function M(){return Reflect.construct(O,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(O,"name")),Object.setPrototypeOf(M,O),Object.setPrototypeOf(M.prototype,O.prototype),M}let E=f=class{constructor(M){k.set(this,void 0),tt(this,k,M)}static from(...M){let te=M;return new f(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}dispose(){typeof We(this,k)=="function"&&(We(this,k).call(this),tt(this,k,void 0))}};k=new WeakMap,E=f=je([a],E),e.Disposable=E;let R=r=class{constructor(M,te){if(M<0)throw(0,D.illegalArgument)("line must be non-negative");if(te<0)throw(0,D.illegalArgument)("character must be non-negative");this._line=M,this._character=te}static Min(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Se=1;Se<M.length;Se++){const ze=M[Se];ze.isBefore(te)&&(te=ze)}return te}static Max(...M){if(M.length===0)throw new TypeError;let te=M[0];for(let Se=1;Se<M.length;Se++){const ze=M[Se];ze.isAfter(te)&&(te=ze)}return te}static isPosition(M){if(!M)return!1;if(M instanceof r)return!0;let{line:te,character:Se}=M;return typeof te=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,te=0){if(M===null||te===null)throw(0,D.illegalArgument)();let Se;return typeof M=="undefined"?Se=0:typeof M=="number"?Se=M:(Se=typeof M.lineDelta=="number"?M.lineDelta:0,te=typeof M.characterDelta=="number"?M.characterDelta:0),Se===0&&te===0?this:new r(this.line+Se,this.character+te)}with(M,te=this.character){if(M===null||te===null)throw(0,D.illegalArgument)();let Se;return typeof M=="undefined"?Se=this.line:typeof M=="number"?Se=M:(Se=typeof M.line=="number"?M.line:this.line,te=typeof M.character=="number"?M.character:this.character),Se===this.line&&te===this.character?this:new r(Se,te)}toJSON(){return{line:this.line,character:this.character}}};R=r=je([a],R),e.Position=R;let g=h=class{constructor(M,te,Se,ze){let Ye,nt;if(typeof M=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ye=new R(M,te),nt=new R(Se,ze)):M instanceof R&&te instanceof R&&(Ye=M,nt=te),!Ye||!nt)throw new Error("Invalid arguments");Ye.isBefore(nt)?(this._start=Ye,this._end=nt):(this._start=nt,this._end=Ye)}static isRange(M){return M instanceof h?!0:M?R.isPosition(M.start)&&R.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof h?this.contains(M._start)&&this.contains(M._end):M instanceof R?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const te=R.Max(M.start,this._start),Se=R.Min(M.end,this._end);if(!te.isAfter(Se))return new h(te,Se)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const te=R.Min(M.start,this._start),Se=R.Max(M.end,this.end);return new h(te,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,te=this.end){if(M===null||te===null)throw(0,D.illegalArgument)();let Se;return M?R.isPosition(M)?Se=M:(Se=M.start||this.start,te=M.end||this.end):Se=this.start,Se.isEqual(this._start)&&te.isEqual(this.end)?this:new h(Se,te)}toJSON(){return[this.start,this.end]}};g=h=je([a],g),e.Range=g;let b=p=class extends g{constructor(M,te,Se,ze){let Ye,nt;if(typeof M=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"?(Ye=new R(M,te),nt=new R(Se,ze)):M instanceof R&&te instanceof R&&(Ye=M,nt=te),!Ye||!nt)throw new Error("Invalid arguments");super(Ye,nt);this._anchor=Ye,this._active=nt}static isSelection(M){return M instanceof p?!0:M?g.isRange(M)&&R.isPosition(M.anchor)&&R.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};b=p=je([a],b),e.Selection=b;class C{constructor(M,te,Se){if(typeof M!="string"||M.length===0)throw(0,D.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,D.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,D.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(te),this.connectionToken=Se}}e.ResolvedAuthority=C;class F extends Error{constructor(M,te=A.RemoteAuthorityResolverErrorCode.Unknown,Se){super(M);this._message=M,this._code=te,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,F.prototype)}static NotAvailable(M,te){return new F(M,A.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(M){return new F(M,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=F;var x;(function(O){O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var le;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(le=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=m=class{constructor(M,te){this._range=M,this._newText=te}static isTextEdit(M){return M instanceof m?!0:M?g.isRange(M)&&typeof M.newText=="string":!1}static replace(M,te){return new m(M,te)}static insert(M,te){return m.replace(new g(M,M),te)}static delete(M){return m.replace(M,"")}static setEndOfLine(M){const te=new m(new g(new R(0,0),new R(0,0)),"");return te.newEol=M,te}get range(){return this._range}set range(M){if(M&&!g.isRange(M))throw(0,D.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,D.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,D.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};B=m=je([a],B),e.TextEdit=B;var H;(function(O){O[O.File=1]="File",O[O.Text=2]="Text",O[O.Cell=3]="Cell",O[O.CellOutput=4]="CellOutput",O[O.CellReplace=5]="CellReplace",O[O.CellOutputItem=6]="CellOutputItem"})(H=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,te,Se,ze){this._edits.push({_type:1,from:M,to:te,options:Se,metadata:ze})}createFile(M,te,Se){this._edits.push({_type:1,from:void 0,to:M,options:te,metadata:Se})}deleteFile(M,te,Se){this._edits.push({_type:1,from:M,to:void 0,options:te,metadata:Se})}replaceNotebookMetadata(M,te,Se){this._edits.push({_type:3,metadata:Se,uri:M,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(M,te,Se,ze,Ye){(te!==Se||ze.length>0)&&this._edits.push({_type:5,uri:M,index:te,count:Se-te,cells:ze,metadata:Ye})}replaceNotebookCellOutput(M,te,Se,ze){this._editNotebookCellOutput(M,te,!1,Se,ze)}appendNotebookCellOutput(M,te,Se,ze){this._editNotebookCellOutput(M,te,!0,Se,ze)}replaceNotebookCellOutputItems(M,te,Se,ze,Ye){this._editNotebookCellOutputItems(M,te,Se,!1,ze,Ye)}appendNotebookCellOutputItems(M,te,Se,ze,Ye){this._editNotebookCellOutputItems(M,te,Se,!0,ze,Ye)}_editNotebookCellOutputItems(M,te,Se,ze,Ye,nt){this._edits.push({_type:6,metadata:nt,uri:M,index:te,outputId:Se,append:ze,newOutputItems:Ye})}_editNotebookCellOutput(M,te,Se,ze,Ye){this._edits.push({_type:4,metadata:Ye,uri:M,index:te,append:Se,newOutputs:ze,newMetadata:void 0})}replaceNotebookCellMetadata(M,te,Se,ze){this._edits.push({_type:3,metadata:ze,uri:M,edit:{editType:3,index:te,metadata:Se}})}replace(M,te,Se,ze){this._edits.push({_type:2,uri:M,edit:new B(te,Se),metadata:ze})}insert(M,te,Se,ze){this.replace(M,new g(te,te),Se,ze)}delete(M,te,Se){this.replace(M,te,"",Se)}has(M){return this._edits.some(te=>te._type===2&&te.uri.toString()===M.toString())}set(M,te){if(te)for(const Se of te)Se&&this._edits.push({_type:2,uri:M,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const ze=this._edits[Se];ze._type===2&&ze.uri.toString()===M.toString()&&(this._edits[Se]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(M){const te=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===M.toString()&&te.push(Se.edit);return te}entries(){const M=new P.ResourceMap;for(let te of this._edits)if(te._type===2){let Se=M.get(te.uri);Se||(Se=[te.uri,[]],M.set(te.uri,Se)),Se[1].push(te.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=je([a],G),e.WorkspaceEdit=G;let L=v=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof v?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=v._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,te=this._tabstop++){if(typeof M=="function"){const Se=new v;Se._tabstop=this._tabstop,M(Se),this._tabstop=Se._tabstop,M=Se.value}else M=v._escape(M);return this.value+="${",this.value+=te,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,te=this._tabstop++){const Se=M.map(ze=>ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(M,te){if(typeof te=="function"){const Se=new v;Se._tabstop=this._tabstop,te(Se),this._tabstop=Se._tabstop,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,te&&(this.value+=":",this.value+=te),this.value+="}",this}};L=v=je([a],L),e.SnippetString=L;var $;(function(O){O[O.Unnecessary=1]="Unnecessary",O[O.Deprecated=2]="Deprecated"})($=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(O){O[O.Hint=3]="Hint",O[O.Information=2]="Information",O[O.Warning=1]="Warning",O[O.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=d=class{constructor(M,te){if(this.uri=M,te)if(te instanceof g)this.range=te;else if(te instanceof R)this.range=new g(te,te);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof d?!0:M?g.isRange(M.range)&&I.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Q=d=je([a],Q),e.Location=Q;let N=class{constructor(M,te){this.location=M,this.message=te}static is(M){return M?typeof M.message=="string"&&M.location&&g.isRange(M.location.range)&&I.URI.isUri(M.location.uri):!1}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.location.range.isEqual(te.location.range)&&M.location.uri.toString()===te.location.uri.toString()}};N=je([a],N),e.DiagnosticRelatedInformation=N;let Z=class{constructor(M,te,Se=U.Error){if(!g.isRange(M))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=M,this.message=te,this.severity=Se}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,te){return M===te?!0:!M||!te?!1:M.message===te.message&&M.severity===te.severity&&M.code===te.code&&M.severity===te.severity&&M.source===te.source&&M.range.isEqual(te.range)&&(0,w.equals)(M.tags,te.tags)&&(0,w.equals)(M.relatedInformation,te.relatedInformation,N.isEqual)}};Z=je([a],Z),e.Diagnostic=Z;let ne=class{constructor(M,te){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:(0,T.isMarkdownString)(M)?this.contents=[M]:this.contents=[M],this.range=te}};ne=je([a],ne),e.Hover=ne;var re;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ye=class{constructor(M,te=re.Text){this.range=M,this.kind=te}toJSON(){return{range:this.range,kind:re[this.kind]}}};ye=je([a],ye),e.DocumentHighlight=ye;var Ae;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(Ae=e.SymbolKind||(e.SymbolKind={}));var Be;(function(O){O[O.Deprecated=1]="Deprecated"})(Be=e.SymbolTag||(e.SymbolTag={}));let Re=c=class{constructor(M,te,Se,ze,Ye){this.name=M,this.kind=te,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),ze instanceof Q?this.location=ze:Se instanceof g&&(this.location=new Q(ze,Se)),c.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};Re=c=je([a],Re),e.SymbolInformation=Re;let xe=o=class{constructor(M,te,Se,ze,Ye){this.name=M,this.detail=te,this.kind=Se,this.range=ze,this.selectionRange=Ye,this.children=[],o.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(o.validate)}};xe=o=je([a],xe),e.DocumentSymbol=xe;var W;(function(O){O[O.Invoke=1]="Invoke",O[O.Automatic=2]="Automatic"})(W=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let K=class{constructor(M,te){this.title=M,this.kind=te}};K=je([a],K),e.CodeAction=K;let J=t=class{constructor(M){this.value=M}append(M){return new t(this.value?this.value+t.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+t.sep)}};J.sep=".",J=t=je([a],J),e.CodeActionKind=J,J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll");let ae=class{constructor(M,te){if(this.range=M,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ae=je([a],ae),e.SelectionRange=ae;class ge{constructor(M,te,Se,ze,Ye,nt){this.kind=M,this.name=te,this.detail=Se,this.uri=ze,this.range=Ye,this.selectionRange=nt}}e.CallHierarchyItem=ge;class De{constructor(M,te){this.fromRanges=te,this.from=M}}e.CallHierarchyIncomingCall=De;class Le{constructor(M,te){this.fromRanges=te,this.to=M}}e.CallHierarchyOutgoingCall=Le;let pe=class{constructor(M,te){this.range=M,this.command=te}get isResolved(){return!!this.command}};pe=je([a],pe),e.CodeLens=pe;let Ce=i=class{constructor(M,te=!1){_.set(this,void 0),tt(this,_,new T.MarkdownString(M,{supportThemeIcons:te}))}static isMarkdownString(M){return M instanceof i?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return We(this,_).value}set value(M){We(this,_).value=M}get isTrusted(){return We(this,_).isTrusted}set isTrusted(M){We(this,_).isTrusted=M}get supportThemeIcons(){return We(this,_).supportThemeIcons}appendText(M){return We(this,_).appendText(M),this}appendMarkdown(M){return We(this,_).appendMarkdown(M),this}appendCodeblock(M,te){return We(this,_).appendCodeblock(te!=null?te:"",M),this}};_=new WeakMap,Ce=i=je([a],Ce),e.MarkdownString=Ce;let Te=class{constructor(M,te){this.label=M,this.documentation=te}};Te=je([a],Te),e.ParameterInformation=Te;let Ue=class{constructor(M,te){this.label=M,this.documentation=te,this.parameters=[]}};Ue=je([a],Ue),e.SignatureInformation=Ue;let be=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};be=je([a],be),e.SignatureHelp=be;var Ke;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(Ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var V;(function(O){O[O.Other=0]="Other",O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(V=e.InlineHintKind||(e.InlineHintKind={}));let X=class{constructor(M,te,Se){this.text=M,this.range=te,this.kind=Se}};X=je([a],X),e.InlineHint=X;var _e;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_e=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Me;(function(O){O[O.Text=0]="Text",O[O.Method=1]="Method",O[O.Function=2]="Function",O[O.Constructor=3]="Constructor",O[O.Field=4]="Field",O[O.Variable=5]="Variable",O[O.Class=6]="Class",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Unit=10]="Unit",O[O.Value=11]="Value",O[O.Enum=12]="Enum",O[O.Keyword=13]="Keyword",O[O.Snippet=14]="Snippet",O[O.Color=15]="Color",O[O.File=16]="File",O[O.Reference=17]="Reference",O[O.Folder=18]="Folder",O[O.EnumMember=19]="EnumMember",O[O.Constant=20]="Constant",O[O.Struct=21]="Struct",O[O.Event=22]="Event",O[O.Operator=23]="Operator",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue"})(Me=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function(O){O[O.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(M,te){this.label=M,this.kind=te}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Me[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=je([a],Oe),e.CompletionItem=Oe;let Xe=class{constructor(M=[],te=!1){this.items=M,this.isIncomplete=te}};Xe=je([a],Xe),e.CompletionList=Xe;var z;(function(O){O[O.Active=-1]="Active",O[O.Beside=-2]="Beside",O[O.One=1]="One",O[O.Two=2]="Two",O[O.Three=3]="Three",O[O.Four=4]="Four",O[O.Five=5]="Five",O[O.Six=6]="Six",O[O.Seven=7]="Seven",O[O.Eight=8]="Eight",O[O.Nine=9]="Nine"})(z=e.ViewColumn||(e.ViewColumn={}));var ie;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(ie=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ce;(function(O){O[O.Off=0]="Off",O[O.On=1]="On",O[O.Relative=2]="Relative"})(ce=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var j;(function(O){O[O.Manual=1]="Manual",O[O.AfterDelay=2]="AfterDelay",O[O.FocusOut=3]="FocusOut"})(j=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Y;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(Y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(O){O[O.Keyboard=1]="Keyboard",O[O.Mouse=2]="Mouse",O[O.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var fe;(function(O){O[O.OpenOpen=0]="OpenOpen",O[O.ClosedClosed=1]="ClosedClosed",O[O.OpenClosed=2]="OpenClosed",O[O.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(O){function M(te){switch(te){case"keyboard":return O.Keyboard;case"mouse":return O.Mouse;case"api":return O.Command}}O.fromValue=M}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(M,te){if(te&&!I.URI.isUri(te))throw(0,D.illegalArgument)("target");if(!g.isRange(M)||M.isEmpty)throw(0,D.illegalArgument)("range");this.range=M,this.target=te}};ve=je([a],ve),e.DocumentLink=ve;let $e=class{constructor(M,te,Se,ze){this.red=M,this.green=te,this.blue=Se,this.alpha=ze}};$e=je([a],$e),e.Color=$e;let Ne=class{constructor(M,te){if(te&&!(te instanceof $e))throw(0,D.illegalArgument)("color");if(!g.isRange(M)||M.isEmpty)throw(0,D.illegalArgument)("range");this.range=M,this.color=te}};Ne=je([a],Ne),e.ColorInformation=Ne;let Ve=class{constructor(M){if(!M||typeof M!="string")throw(0,D.illegalArgument)("label");this.label=M}};Ve=je([a],Ve),e.ColorPresentation=Ve;var Qe;(function(O){O[O.RGB=0]="RGB",O[O.HEX=1]="HEX",O[O.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var Ze;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information"})(Ze=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ct;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(ct=e.TaskRevealKind||(e.TaskRevealKind={}));var st;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(st=e.TaskPanelKind||(e.TaskPanelKind={}));let me=u=class{constructor(M,te){if(typeof M!="string"||typeof te!="string")throw(0,D.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};me.Clean=new u("clean","Clean"),me.Build=new u("build","Build"),me.Rebuild=new u("rebuild","Rebuild"),me.Test=new u("test","Test"),me=u=je([a],me),e.TaskGroup=me;function he(O){let M="";for(let te=0;te<O.length;te++)M+=O[te].replace(/,/g,",,")+",";return M}let ue=class{constructor(M,te,Se){if(typeof M!="string")throw(0,D.illegalArgument)("process");this._args=[],this._process=M,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Se):this._options=te)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,D.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let te of this._args)M.push(te);return he(M)}};ue=je([a],ue),e.ProcessExecution=ue;let q=class{constructor(M,te,Se){if(this._args=[],Array.isArray(te)){if(!M)throw(0,D.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,D.illegalArgument)("command");this._command=M,this._args=te,this._options=Se}else{if(typeof M!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=M,this._options=te}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,D.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,D.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)M.push(typeof te=="string"?te:te.value);return he(M)}};q=je([a],q),e.ShellExecution=q;var Ie;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(Ie=e.ShellQuoting||(e.ShellQuoting={}));var Pe;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace"})(Pe=e.TaskScope||(e.TaskScope={}));class et{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,y.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=et;let Ge=l=class{constructor(M,te,Se,ze,Ye,nt){this.__deprecated=!1,this._definition=this.definition=M;let ot;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Se,this.execution=ze,ot=Ye,this.__deprecated=!0):te===Pe.Global||te===Pe.Workspace?(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ye,ot=nt):(this.target=te,this._name=this.name=Se,this._source=this.source=ze,this.execution=Ye,ot=nt),typeof ot=="string"?(this._problemMatchers=[ot],this._hasDefinedMatchers=!0):Array.isArray(ot)?(this._problemMatchers=ot,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ue?this._definition={type:l.ProcessType,id:this._execution.computeId()}:this._execution instanceof q?this._definition={type:l.ShellType,id:this._execution.computeId()}:this._execution instanceof et?this._definition={type:l.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:l.EmptyType,id:(0,y.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,D.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,D.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const te=this._definition.type;(l.EmptyType===te||l.ProcessType===te||l.ShellType===te||l.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,D.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};Ge.ExtensionCallbackType="customExecution",Ge.ProcessType="process",Ge.ShellType="shell",Ge.EmptyType="$empty",Ge=l=je([a],Ge),e.Task=Ge;var rt;(function(O){O[O.SourceControl=1]="SourceControl",O[O.Window=10]="Window",O[O.Notification=15]="Notification"})(rt=e.ProgressLocation||(e.ProgressLocation={}));let lt=class{constructor(M,te=Je.None){this.collapsibleState=te,I.URI.isUri(M)?this.resourceUri=M:this.label=M}};lt=je([a],lt),e.TreeItem=lt;var Je;(function(O){O[O.None=0]="None",O[O.Collapsed=1]="Collapsed",O[O.Expanded=2]="Expanded"})(Je=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let it=class{constructor(M,te){this.id=M,this.color=te}};it=je([a],it),e.ThemeIcon=it,it.File=new it("file"),it.Folder=new it("folder");let dt=class{constructor(M){this.id=M}};dt=je([a],dt),e.ThemeColor=dt;var at;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.WorkspaceFolder=3]="WorkspaceFolder"})(at=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Dt=class{constructor(M,te){if(typeof M!="string"&&(!M||!I.URI.isUri(M)&&!I.URI.isUri(M.uri)))throw(0,D.illegalArgument)("base");if(typeof te!="string")throw(0,D.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=I.URI.file(M),this.base=M):I.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=te}};Dt=je([a],Dt),e.RelativePattern=Dt;let gt=class{constructor(M,te,Se,ze){this.enabled=typeof M=="boolean"?M:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof ze=="string"&&(this.logMessage=ze)}get id(){return this._id||(this._id=(0,y.generateUuid)()),this._id}};gt=je([a],gt),e.Breakpoint=gt;let Ct=class extends gt{constructor(M,te,Se,ze,Ye){super(te,Se,ze,Ye);if(M===null)throw(0,D.illegalArgument)("location");this.location=M}};Ct=je([a],Ct),e.SourceBreakpoint=Ct;let wt=class extends gt{constructor(M,te,Se,ze,Ye){super(te,Se,ze,Ye);this.functionName=M}};wt=je([a],wt),e.FunctionBreakpoint=wt;let Et=class extends gt{constructor(M,te,Se,ze,Ye,nt,ot){super(ze,Ye,nt,ot);if(!te)throw(0,D.illegalArgument)("dataId");this.label=M,this.dataId=te,this.canPersist=Se}};Et=je([a],Et),e.DataBreakpoint=Et;let mt=class{constructor(M,te,Se){this.command=M,this.args=te||[],this.options=Se}};mt=je([a],mt),e.DebugAdapterExecutable=mt;let Rt=class{constructor(M,te){this.port=M,this.host=te}};Rt=je([a],Rt),e.DebugAdapterServer=Rt;let Ft=class{constructor(M){this.path=M}};Ft=je([a],Ft),e.DebugAdapterNamedPipeServer=Ft;let ht=class{constructor(M){this.implementation=M}};ht=je([a],ht),e.DebugAdapterInlineImplementation=ht;let yt=class{constructor(M,te){this.range=M,this.expression=te}};yt=je([a],yt),e.EvaluatableExpression=yt;let Ut=class{constructor(M,te){this.range=M,this.text=te}};Ut=je([a],Ut),e.InlineValueText=Ut;let $t=class{constructor(M,te,Se=!0){this.range=M,this.variableName=te,this.caseSensitiveLookup=Se}};$t=je([a],$t),e.InlineValueVariableLookup=$t;let Lt=class{constructor(M,te){this.range=M,this.expression=te}};Lt=je([a],Lt),e.InlineValueEvaluatableExpression=Lt;let ut=class{constructor(M,te){this.frameId=M,this.stoppedLocation=te}};ut=je([a],ut),e.InlineValueContext=ut;var ln;(function(O){O[O.Changed=1]="Changed",O[O.Created=2]="Created",O[O.Deleted=3]="Deleted"})(ln=e.FileChangeType||(e.FileChangeType={}));let It=s=class extends Error{constructor(M,te=n.FileSystemProviderErrorCode.Unknown,Se){var ze;super(I.URI.isUri(M)?M.toString(!0):M);this.code=(ze=Se==null?void 0:Se.name)!==null&&ze!==void 0?ze:"Unknown",(0,n.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,s.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(M){return new s(M,n.FileSystemProviderErrorCode.FileExists,s.FileExists)}static FileNotFound(M){return new s(M,n.FileSystemProviderErrorCode.FileNotFound,s.FileNotFound)}static FileNotADirectory(M){return new s(M,n.FileSystemProviderErrorCode.FileNotADirectory,s.FileNotADirectory)}static FileIsADirectory(M){return new s(M,n.FileSystemProviderErrorCode.FileIsADirectory,s.FileIsADirectory)}static NoPermissions(M){return new s(M,n.FileSystemProviderErrorCode.NoPermissions,s.NoPermissions)}static Unavailable(M){return new s(M,n.FileSystemProviderErrorCode.Unavailable,s.Unavailable)}};It=s=je([a],It),e.FileSystemError=It;let At=class{constructor(M,te,Se){this.start=M,this.end=te,this.kind=Se}};At=je([a],At),e.FoldingRange=At;var Yt;(function(O){O[O.Comment=1]="Comment",O[O.Imports=2]="Imports",O[O.Region=3]="Region"})(Yt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var un;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(un=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Xt;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(Xt=e.CommentMode||(e.CommentMode={}));class cn{constructor(M,te=[]){this.tokenTypes=M,this.tokenModifiers=te}}e.SemanticTokensLegend=cn;function Zt(O){return typeof O=="undefined"||(0,S.isStringArray)(O)}class Pt{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let te=0,Se=M.tokenTypes.length;te<Se;te++)this._tokenTypeStrToInt.set(M.tokenTypes[te],te);for(let te=0,Se=M.tokenModifiers.length;te<Se;te++)this._tokenModifierStrToInt.set(M.tokenModifiers[te],te)}}push(M,te,Se,ze,Ye){if(typeof M=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof ze=="number"&&(typeof Ye=="number"||typeof Ye=="undefined"))return typeof Ye=="undefined"&&(Ye=0),this._pushEncoded(M,te,Se,ze,Ye);if(g.isRange(M)&&typeof te=="string"&&Zt(Se))return this._push(M,te,Se);throw(0,D.illegalArgument)()}_push(M,te,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const ze=M.start.line,Ye=M.start.character,nt=M.end.character-M.start.character,ot=this._tokenTypeStrToInt.get(te);let pt=0;if(Se)for(const vt of Se){if(!this._tokenModifierStrToInt.has(vt))throw new Error("`tokenModifier` is not in the provided legend");const _t=this._tokenModifierStrToInt.get(vt);pt|=1<<_t>>>0}this._pushEncoded(ze,Ye,nt,ot,pt)}_pushEncoded(M,te,Se,ze,Ye){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const pt=this._data.length/5|0;let vt=0,_t=0;for(let bt=0;bt<pt;bt++){let St=this._data[5*bt],Qt=this._data[5*bt+1];St===0?(St=vt,Qt+=_t):St+=vt,this._data[5*bt]=St,this._data[5*bt+1]=Qt,vt=St,_t=Qt}}let nt=M,ot=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(ot-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=ot,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=ze,this._data[this._dataLen++]=Ye,this._prevLine=M,this._prevChar=te}static _sortAndDeltaEncode(M){let te=[];const Se=M.length/5|0;for(let ot=0;ot<Se;ot++)te[ot]=ot;te.sort((ot,pt)=>{const vt=M[5*ot],_t=M[5*pt];if(vt===_t){const bt=M[5*ot+1],St=M[5*pt+1];return bt-St}return vt-_t});const ze=new Uint32Array(M.length);let Ye=0,nt=0;for(let ot=0;ot<Se;ot++){const pt=5*te[ot],vt=M[pt+0],_t=M[pt+1],bt=M[pt+2],St=M[pt+3],Qt=M[pt+4],Sn=vt-Ye,In=Sn===0?_t-nt:_t,Jt=5*ot;ze[Jt+0]=Sn,ze[Jt+1]=In,ze[Jt+2]=bt,ze[Jt+3]=St,ze[Jt+4]=Qt,Ye=vt,nt=_t}return ze}build(M){return this._dataIsSortedAndDeltaEncoded?new Bt(new Uint32Array(this._data),M):new Bt(Pt._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=Pt;class Bt{constructor(M,te){this.resultId=te,this.data=M}}e.SemanticTokens=Bt;class xt{constructor(M,te,Se){this.start=M,this.deleteCount=te,this.data=Se}}e.SemanticTokensEdit=xt;class Ht{constructor(M,te){this.resultId=te,this.edits=M}}e.SemanticTokensEdits=Ht;var dn;(function(O){O[O.Separate=0]="Separate",O[O.MergeWithParent=1]="MergeWithParent"})(dn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var hn;(function(O){O[O.Initial=1]="Initial",O[O.Dynamic=2]="Dynamic"})(hn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let kt=class{constructor(){}};kt.Back={iconPath:new it("arrow-left")},kt=je([a],kt),e.QuickInputButtons=kt;var fn;(function(O){O[O.UI=1]="UI",O[O.Workspace=2]="Workspace"})(fn=e.ExtensionKind||(e.ExtensionKind={}));class mn{constructor(M,te,Se){this.badge=M,this.tooltip=te,this.color=Se}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=mn;let zt=class{constructor(M){this.kind=M}};zt=je([a],zt),e.ColorTheme=zt;var gn;(function(O){O[O.Light=1]="Light",O[O.Dark=2]="Dark",O[O.HighContrast=3]="HighContrast"})(gn=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(M,te){if(M<0)throw(0,D.illegalArgument)("start must be positive");if(te<M)throw(0,D.illegalArgument)("end cannot be smaller than start");this._start=M,this._end=te}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}}e.NotebookCellRange=Vt;class Wt{constructor(M,te,Se,ze,Ye,nt,ot,pt,vt,_t,bt){this.editable=M,this.breakpointMargin=te,this.hasExecutionOrder=Se,this.executionOrder=ze,this.runState=Ye,this.runStartTime=nt,this.statusMessage=ot,this.lastRunDuration=pt,this.inputCollapsed=vt,this.outputCollapsed=_t,this.custom=bt}with(M){let{editable:te,breakpointMargin:Se,hasExecutionOrder:ze,executionOrder:Ye,runState:nt,runStartTime:ot,statusMessage:pt,lastRunDuration:vt,inputCollapsed:_t,outputCollapsed:bt,custom:St}=M;return te===void 0?te=this.editable:te===null&&(te=void 0),Se===void 0?Se=this.breakpointMargin:Se===null&&(Se=void 0),ze===void 0?ze=this.hasExecutionOrder:ze===null&&(ze=void 0),Ye===void 0?Ye=this.executionOrder:Ye===null&&(Ye=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.runStartTime:ot===null&&(ot=void 0),pt===void 0?pt=this.statusMessage:pt===null&&(pt=void 0),vt===void 0?vt=this.lastRunDuration:vt===null&&(vt=void 0),_t===void 0?_t=this.inputCollapsed:_t===null&&(_t=void 0),bt===void 0?bt=this.outputCollapsed:bt===null&&(bt=void 0),St===void 0?St=this.custom:St===null&&(St=void 0),te===this.editable&&Se===this.breakpointMargin&&ze===this.hasExecutionOrder&&Ye===this.executionOrder&&nt===this.runState&&ot===this.runStartTime&&pt===this.statusMessage&&vt===this.lastRunDuration&&_t===this.inputCollapsed&&bt===this.outputCollapsed&&St===this.custom?this:new Wt(te,Se,ze,Ye,nt,ot,pt,vt,_t,bt,St)}}e.NotebookCellMetadata=Wt;class Mt{constructor(M=!0,te=!0,Se=!0,ze={},Ye=en.Idle,nt=!0){this.editable=M,this.cellEditable=te,this.cellHasExecutionOrder=Se,this.custom=ze,this.runState=Ye,this.trusted=nt}with(M){let{editable:te,cellEditable:Se,cellHasExecutionOrder:ze,custom:Ye,runState:nt,trusted:ot}=M;return te===void 0?te=this.editable:te===null&&(te=void 0),Se===void 0?Se=this.cellEditable:Se===null&&(Se=void 0),ze===void 0?ze=this.cellHasExecutionOrder:ze===null&&(ze=void 0),Ye===void 0?Ye=this.custom:Ye===null&&(Ye=void 0),nt===void 0?nt=this.runState:nt===null&&(nt=void 0),ot===void 0?ot=this.trusted:ot===null&&(ot=void 0),te===this.editable&&Se===this.cellEditable&&ze===this.cellHasExecutionOrder&&Ye===this.custom&&nt===this.runState&&ot===this.trusted?this:new Mt(te,Se,ze,Ye,nt,ot)}}e.NotebookDocumentMetadata=Mt;class jt{constructor(M,te,Se,ze,Ye){this.kind=M,this.source=te,this.language=Se,this.outputs=ze!=null?ze:[],this.metadata=Ye}}e.NotebookCellData=jt;class Fe{constructor(M,te){this.cells=M,this.metadata=te!=null?te:new Mt}}e.NotebookData=Fe;class Ot{constructor(M,te,Se){this.mime=M,this.value=te,this.metadata=Se}static isNotebookCellOutputItem(M){return M instanceof Ot}}e.NotebookCellOutputItem=Ot;class qt{constructor(M,te,Se){this.outputs=M,typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,y.generateUuid)(),this.metadata=te!=null?te:Se)}}e.NotebookCellOutput=qt;var ft;(function(O){O[O.Markdown=1]="Markdown",O[O.Code=2]="Code"})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var pn;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle",O[O.Success=3]="Success",O[O.Error=4]="Error"})(pn=e.NotebookCellRunState||(e.NotebookCellRunState={}));var en;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(en=e.NotebookRunState||(e.NotebookRunState={}));var tn;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(tn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var nn;(function(O){O[O.Default=0]="Default",O[O.InCenter=1]="InCenter",O[O.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",O[O.AtTop=3]="AtTop"})(nn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));let Kt=class{constructor(M,te){this.label=M,this.timestamp=te}};Kt=je([a],Kt),e.TimelineItem=Kt;var vn;(function(O){O[O.Production=1]="Production",O[O.Development=2]="Development",O[O.Test=3]="Test"})(vn=e.ExtensionMode||(e.ExtensionMode={}));var _n;(function(O){O[O.Node=1]="Node",O[O.Webworker=2]="Webworker"})(_n=e.ExtensionRuntime||(e.ExtensionRuntime={}));var bn;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=4]="RegEx"})(bn=e.StandardTokenType||(e.StandardTokenType={}));class rn{constructor(M,te){this.ranges=M,this.wordPattern=te}}e.LinkedEditingRanges=rn;var wn;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(wn=e.TestResult||(e.TestResult={}));var sn;(function(O){O[O.Error=0]="Error",O[O.Warning=1]="Warning",O[O.Information=2]="Information",O[O.Hint=3]="Hint"})(sn=e.TestMessageSeverity||(e.TestMessageSeverity={}));class En{constructor(M,te){this.label=te,this.runnable=!0,this.debuggable=!1,this.children=[],Object.defineProperty(this,"id",{value:M,enumerable:!0,writable:!1})}}e.TestItem=En;class yn{constructor(M){this.state=M,this.messages=[]}}e.TestState=yn;class Gt{constructor(M){this.message=M,this.severity=sn.Error}static diff(M,te,Se){const ze=new Gt(M);return ze.expectedOutput=te,ze.actualOutput=Se,ze}}e.TestMessage=Gt;var ee;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(ee=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var de;(function(O){O[O.Untrusted=0]="Untrusted",O[O.Trusted=1]="Trusted",O[O.Unknown=2]="Unknown"})(de=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ke;(function(O){O[O.Notify=1]="Notify",O[O.OpenBrowser=2]="OpenBrowser",O[O.OpenPreview=3]="OpenPreview",O[O.Silent=4]="Silent",O[O.Ignore=5]="Ignore"})(ke=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[94],Ee([0,1,43,16,8,117,83,7,15]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const n=new Map;function A(r,h){h?n.set(r,h):n.delete(r)}e.setWordDefinitionFor=A;function k(r){return n.get(r)}e.getWordDefinitionFor=k;class _ extends P.MirrorTextModel{constructor(h,p,m,v,d,c,o,t){super(p,m,v,d);this._proxy=h,this._languageId=c,this._isDirty=o,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,y.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===D.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(p){return p?h._getTextInRange(p):h.getText()},get eol(){return h._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(p){return h._lineAt(p)},offsetAt(p){return h._offsetAt(p)},positionAt(p){return h._positionAt(p)},validateRange(p){return h._validateRange(p)},validatePosition(p){return h._validatePosition(p)},getWordRangeAtPosition(p,m){return h._getWordRangeAtPosition(p,m)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,w.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,w.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const p=this._validateRange(h);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const m=this._eol,v=p.start.line,d=p.end.line,c=[];c.push(this._lines[v].substring(p.start.character));for(let o=v+1;o<d;o++)c.push(this._lines[o]);return c.push(this._lines[d].substring(0,p.end.character)),c.join(m)}_lineAt(h){let p;if(h instanceof I.Position?p=h.line:typeof h=="number"&&(p=h),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new f(p,this._lines[p],p===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(h),m=this._lines[p.index].length;return new I.Position(p.index,Math.min(p.remainder,m))}_validateRange(h){if(!(h instanceof I.Range))throw new Error("Invalid argument");const p=this._validatePosition(h.start),m=this._validatePosition(h.end);return p===h.start&&m===h.end?h:new I.Range(p.line,p.character,m.line,m.character)}_validatePosition(h){if(!(h instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:p,character:m}=h,v=!1;if(p<0)p=0,m=0,v=!0;else if(p>=this._lines.length)p=this._lines.length-1,m=this._lines[p].length,v=!0;else{const d=this._lines[p].length;m<0?(m=0,v=!0):m>d&&(m=d,v=!0)}return v?new I.Position(p,m):h}_getWordRangeAtPosition(h,p){const m=this._validatePosition(h);if(!p)p=k(this._languageId);else if((0,T.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const v=(0,S.getWordAtText)(m.character+1,(0,S.ensureValidWordDefinition)(p),this._lines[m.line],0);if(v)return new I.Range(m.line,v.startColumn-1,m.line,v.endColumn-1)}}e.ExtHostDocumentData=_;class f{constructor(h,p,m){this._line=h,this._text=p,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(we[159],Ee([0,1,7,3,85,6,59,22,2,29]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class A{constructor(_,f,r,h){this._notebook=r,this._selector=h,this._disposables=new P.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,n.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(m=>{const v=this._cellUris.get(m.document.uri);v!==void 0&&(this._cellLengths.changeValue(v,this._cells[v].document.getText().length+1),this._cellLines.changeValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(_.onDidChangeNotebookCells(m=>p(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const _=[],f=[];for(const r of this._notebook.cells)r.kind===w.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),_.push(r.document.getText().length+1),f.push(r.document.lineCount));this._cellLengths=new T.PrefixSumComputer(new Uint32Array(_)),this._cellLines=new T.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(_){var f,r;if(!_){let d="";for(const c of this._cells)d+=c.document.getText()+`
`;return d=d.slice(0,-1),d}if(_.isEmpty)return"";const h=this.locationAt(_.start),p=this.locationAt(_.end),m=this._cells[(f=this._cellUris.get(h.uri))!==null&&f!==void 0?f:-1],v=this._cells[(r=this._cellUris.get(p.uri))!==null&&r!==void 0?r:-1];if(!m||!v)return"";if(m===v)return m.document.getText(new w.Range(h.range.start,p.range.end));{const d=m.document.getText(new w.Range(h.range.start,new w.Position(m.document.lineCount,0))),c=v.document.getText(new w.Range(new w.Position(0,0),p.range.end));return d+`
`+c}}offsetAt(_){const f=this._cellLines.getIndexOf(_.line),r=this._cellLengths.getAccumulatedValue(f.index-1),h=this._cells[f.index].document.offsetAt(_.with(f.remainder));return r+h}positionAt(_){if(typeof _=="number"){const r=this._cellLengths.getIndexOf(_),h=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(h)}const f=this._cellUris.get(_.uri);if(f!==void 0){const r=this._cellLines.getAccumulatedValue(f-1);return new w.Position(r+_.range.start.line,_.range.start.character)}return new w.Position(0,0)}locationAt(_){w.Range.isRange(_)||(_=new w.Range(_,_));const f=this._cellLines.getIndexOf(_.start.line);let r=f;_.isEmpty||(r=this._cellLines.getIndexOf(_.end.line));const h=new w.Position(f.remainder,_.start.character),p=new w.Position(r.remainder,_.end.character),m=new w.Range(h,p),v=this._cells[f.index];return new w.Location(v.document.uri,v.document.validateRange(m))}contains(_){return this._cellUris.has(_)}validateRange(_){const f=this.validatePosition(_.start),r=this.validatePosition(_.end);return _.with(f,r)}validatePosition(_){const f=this._cellLines.getIndexOf(_.line),r=new w.Position(f.remainder,_.character),h=this._cells[f.index].document.validatePosition(r),p=this._cellLines.getAccumulatedValue(f.index-1);return new w.Position(p+h.line,h.character)}}e.ExtHostNotebookConcatDocument=A}),define(we[160],Ee([0,1,7,14,3]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let P=class{constructor(I){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new T.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let y=I==="light"?w.ColorThemeKind.Light:I==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};P=je([qe(0,D.IExtHostRpcService)],P),e.ExtHostTheming=P}),define(we[68],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class D{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=D}),define(we[69],Ee([0,1,2]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function D(P,S,I){const y=P.webviewResourceRoot.replace("{{resource}}",I.scheme+T(I)).replace("{{uuid}}",S);return w.URI.parse(y)}e.asWebviewUri=D;function T(P){return P.toString().replace(/^\S+?:/,"")}}),define(we[161],Ee([0,1,3,6,69,29]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(y,n,A){this._proxy=y,this._editors=n,this._initData=A,this._handlePool=0,this._disposables=new D.DisposableStore,this._insets=new Map,this._disposables.add(n.onDidChangeVisibleTextEditors(()=>{const k=n.getVisibleTextEditors();for(const _ of this._insets.values())k.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(y=>y.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(y,n,A,k,_){let f;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===y){f=c;break}if(!f)throw new Error("not a visible editor");const r=this,h=this._handlePool++,p=new w.Emitter,m=new w.Emitter,v=new class{constructor(){this._uuid=(0,P.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,T.asWebviewUri)(r._initData,this._uuid,c)}get cspSource(){return r._initData.webviewCspSource}set options(c){this._options=c,r._proxy.$setOptions(h,c)}get options(){return this._options}set html(c){this._html=c,r._proxy.$setHtml(h,c)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(c){return r._proxy.$postMessage(h,c)}},d=new class{constructor(){this.editor=y,this.line=n,this.height=A,this.webview=v,this.onDidDispose=m.event}dispose(){r._insets.has(h)&&(r._insets.delete(h),r._proxy.$disposeEditorInset(h),m.fire(),m.dispose(),p.dispose())}};return this._proxy.$createEditorInset(h,f.id,f.value.document.uri,n+1,A,k||{},_.identifier,_.extensionLocation),this._insets.set(h,{editor:y,inset:d,onDidReceiveMessage:p}),d}$onDidDispose(y){const n=this._insets.get(y);n&&n.inset.dispose()}$onDidReceiveMessage(y,n){const A=this._insets.get(y);A&&A.onDidReceiveMessage.fire(n)}}e.ExtHostEditorInsets=S}),define(we[162],Ee([0,1,3,63,135,4,6,22,30,15,51,23,37,154]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,f.registerIcon)("default-view-icon",_.Codicon.window,(0,T.localize)(0,null));var r;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var h;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={}));function p(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=p;function m(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=m;class v extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,n.flatten)([...this.viewContainers.values()])}registerViewContainer(a,E,R){var g;const b=this.get(a.id);if(b)return b;const C=a;return C.openCommandActionDescriptor=(R==null?void 0:R.donotRegisterOpenCommand)?void 0:(g=C.openCommandActionDescriptor)!==null&&g!==void 0?g:{id:C.id},(0,I.getOrSet)(this.viewContainers,E,[]).push(C),(R==null?void 0:R.isDefault)&&this.defaultViewContainers.push(C),this._onDidRegister.fire({viewContainer:C,viewContainerLocation:E}),C}deregisterViewContainer(a){for(const E of this.viewContainers.keys()){const R=this.viewContainers.get(E),g=R==null?void 0:R.indexOf(a);if(g!==-1){R==null||R.splice(g,1),R.length===0&&this.viewContainers.delete(E),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:E});return}}}get(a){return this.all.filter(E=>E.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(E=>this.getViewContainers(E).filter(R=>(R==null?void 0:R.id)===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(E=>this.getViewContainerLocation(E)===a)}}y.Registry.add(r.ViewContainersRegistry,new v);var d;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function c(s,a){var E,R,g,b;const C=(E=s.group)!==null&&E!==void 0?E:d.More,F=(R=a.group)!==null&&R!==void 0?R:d.More;return C!==F?C.localeCompare(F):((g=s.order)!==null&&g!==void 0?g:5)-((b=a.order)!==null&&b!==void 0?b:5)}class o extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new A.SetMap}registerViews(a,E){this.registerViews2([{views:a,viewContainer:E}])}registerViews2(a){a.forEach(({views:E,viewContainer:R})=>this.addViews(E,R)),this._onViewsRegistered.fire(a)}deregisterViews(a,E){const R=this.removeViews(a,E);R.length&&this._onViewsDeregistered.fire({views:R,viewContainer:E})}moveViews(a,E){for(const R of this._views.keys())if(R!==E){const g=this.removeViews(a,R);g.length&&(this.addViews(g,E),this._onDidChangeContainer.fire({views:g,from:R,to:E}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const E of this._viewContainers){const R=(this._views.get(E)||[]).filter(g=>g.id===a)[0];if(R)return R}return null}getViewContainer(a){for(const E of this._viewContainers)if((this._views.get(E)||[]).filter(g=>g.id===a)[0])return E;return null}registerViewWelcomeContent(a,E){return this._viewWelcomeContents.add(a,E),this._onDidChangeViewWelcomeContent.fire(a),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(a,E),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,E){const R=new Map;for(const[g,b]of E)this._viewWelcomeContents.add(a,b),R.set(g,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(a,b),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),R}getViewWelcomeContent(a){const E=[];return this._viewWelcomeContents.forEach(a,R=>E.push(R)),E.sort(c)}addViews(a,E){let R=this._views.get(E);R||(R=[],this._views.set(E,R),this._viewContainers.push(E));for(const g of a){if(this.getView(g.id)!==null)throw new Error((0,T.localize)(1,null,g.id));R.push(g)}}removeViews(a,E){const R=this._views.get(E);if(!R)return[];const g=[],b=[];for(const C of R)a.includes(C)?g.push(C):b.push(C);return g.length&&(b.length?this._views.set(E,b):(this._views.delete(E),this._viewContainers.splice(this._viewContainers.indexOf(E),1))),g}}y.Registry.add(r.ViewsRegistry,new o),e.IViewsService=(0,P.createDecorator)("viewsService"),e.FocusedViewContext=new D.RawContextKey("focusedView","",(0,T.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,P.createDecorator)("viewDescriptorService");var i;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(i=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class l{constructor(a,E){this.resolved=!1,this._hasResolve=!1,(0,k.mixin)(this,a),this._hasResolve=!!E,this.resolve=async R=>{var g,b;if(E&&!this.resolved){const C=await E(R);C&&(this.tooltip=(g=this.tooltip)!==null&&g!==void 0?g:C.tooltip,this.command=(b=this.command)!==null&&b!==void 0?b:C.command)}R.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=l}),define(we[163],Ee([0,1,2,144,155,19,145,162]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function y(h){return(p,...m)=>h(p.get(D.ICommandService),...m)}class n{static execute(p,m){const v={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return p.executeCommand("_files.newWindow",v)}}e.NewWindowAPICommand=n,n.ID="vscode.newWindow",D.CommandsRegistry.registerCommand({id:n.ID,handler:y(n.execute),description:{description:"Opens an new window",args:[]}}),D.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(h,p){return h.get(T.IWorkspacesService).removeRecentlyOpened([p])});class A{static execute(p,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?w.URI.parse(m):w.URI.file(m):m=w.URI.revive(m),p.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=A,A.ID="vscode.removeFromRecentlyOpened",D.CommandsRegistry.registerCommand(A.ID,y(A.execute));class k{static execute(p,m){const v=typeof m=="string"?{extensionId:m}:m;return p.executeCommand("workbench.action.openIssueReporter",v)}}e.OpenIssueReporter=k,k.ID="vscode.openIssueReporter",D.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(h,p){const m=h.get(T.IWorkspacesService);let v;const d=p.uri,c=p.label,o=p.remoteAuthority;return p.type==="workspace"?v={workspace:await m.getWorkspaceIdentifier(d),label:c,remoteAuthority:o}:p.type==="folder"?v={folderUri:d,label:c,remoteAuthority:o}:v={fileUri:d,label:c,remoteAuthority:o},m.addRecentlyOpened([v])}),D.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(h){return h.get(T.IWorkspacesService).getRecentlyOpened()}),D.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(h,p){const m=h.get(P.ILogService),v=h.get(S.IEnvironmentService);v.isExtensionDevelopment&&!!v.extensionTestsLocationURI&&m.setLevel(p)}),D.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(h){return h.get(P.ILogService).getLevel()}),D.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(h,p){const m=h.get(I.IViewDescriptorService),v=m.getViewContainerById(p.destinationId);if(!!v){for(const d of p.viewIds){const c=m.getViewDescriptorById(d);(c==null?void 0:c.canMoveView)&&m.moveViewsToContainer([c],v,I.ViewVisibilityState.Default)}await h.get(I.IViewsService).openViewContainer(v.id,!0)}});class _{static execute(p,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):p.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=_,_.ID="vscode.moveViews",D.CommandsRegistry.registerCommand({id:_.ID,handler:y(_.execute),description:{description:"Move Views",args:[]}});class f{static execute(p,m){return p.executeCommand("_workbench.open",m)}}f.ID="vscode.open",D.CommandsRegistry.registerCommand(f.ID,y(f.execute));class r{static execute(p,m,v,d,c){return p.executeCommand("_workbench.diff",[m,v,d])}}r.ID="vscode.diff",D.CommandsRegistry.registerCommand(r.ID,y(r.execute))}),define(we[164],Ee([0,1,3,13,136]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class P{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,y,n,A){const k={command:I};if(y&&Object.keys(y).length>0&&(k.arguments=y),this.internalSend("request",k),typeof A=="number"){const _=setTimeout(()=>{clearTimeout(_);const f=this.pendingRequests.get(k.seq);if(f){this.pendingRequests.delete(k.seq);const r={type:"response",seq:0,request_seq:k.seq,success:!1,command:I,message:(0,T.localize)(0,null,A,I)};f(r)}},A)}return n&&this.pendingRequests.set(k.seq,n),k.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,y){return I.type!=="event"||y.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,D.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const y=I,n=this.pendingRequests.get(y.request_seq);n&&(this.pendingRequests.delete(y.request_seq),n(y));break}}}internalSend(I,y){y.type=I,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((y,n)=>I.set(n,y)),await(0,D.timeout)(500),I.forEach((y,n)=>{y({type:"response",seq:0,request_seq:n,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(n)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=P}),define(we[165],Ee([0,1,8,2,11,23,16]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function y(i,u,l){return i.replace(I,function(s,a){return u&&a.length>0&&a[0]!=="_"?s:l&&l.hasOwnProperty(a)?l[a]:s})}e.formatPII=y;function n(i){const u={};for(const l of Object.keys(i))l.startsWith("!")||(u[l]=i[l]);return u}e.filterExceptionsFromTelemetry=n;function A(i){return i.configuration.request==="attach"&&!k(i)}e.isSessionAttach=A;function k(i){let u=i.configuration.type;if(!!u)return u==="vslsShare"&&(u=i.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(u,"extensionhost")||(0,w.equalsIgnoreCase)(u,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function _(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=_;function f(i,u,l){let s,a=0,E=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,R=null;for(;R=E.exec(i);){let g=R.index+1,b=g+R[0].length;if(g<=u&&b>=l){s=R[0],a=g;break}}if(s){let g=/\w+/g,b=null;for(;(b=g.exec(s))&&!(b.index+1+a+b[0].length>=l););b&&(s=s.substring(0,g.lastIndex))}return s?{start:a,end:a+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(i){return!!(i&&i.match(r))}e.isUri=h;function p(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(h(i.path))return D.URI.parse(i.path);if((0,T.isAbsolute)(i.path))return D.URI.file(i.path)}return i.path}function m(i){if(typeof i.path=="object"){const u=D.URI.revive(i.path);if(u)return u.scheme===S.Schemas.file?u.fsPath:u.toString()}return i.path}function v(i,u){const l=u?p:m,s=(0,P.deepClone)(i);return c(s,(a,E)=>{a&&E&&(E.path=l(E))}),s}e.convertToDAPaths=v;function d(i,u){const l=u?p:m,s=(0,P.deepClone)(i);return c(s,(a,E)=>{!a&&E&&(E.path=l(E))}),s}e.convertToVSCPaths=d;function c(i,u){switch(i.type){case"event":const l=i;switch(l.event){case"output":u(!1,l.body.source);break;case"loadedSource":u(!1,l.body.source);break;case"breakpoint":u(!1,l.body.breakpoint.source);break;default:break}break;case"request":const s=i;switch(s.command){case"setBreakpoints":u(!0,s.arguments.source);break;case"breakpointLocations":u(!0,s.arguments.source);break;case"source":u(!0,s.arguments.source);break;case"gotoTargets":u(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(E=>u(!1,E));break;default:break}break;case"response":const a=i;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(E=>u(!1,E.source));break;case"loadedSources":a.body.sources.forEach(E=>u(!1,E));break;case"scopes":a.body.scopes.forEach(E=>u(!1,E.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(E=>u(!1,E.source));break;case"setBreakpoints":a.body.breakpoints.forEach(E=>u(!1,E.source));break;default:break}break}}function o(i){return i.filter(u=>{var l;return!((l=u.presentation)===null||l===void 0?void 0:l.hidden)}).sort((u,l)=>u.presentation?l.presentation?u.presentation.group?l.presentation.group?u.presentation.group!==l.presentation.group?u.presentation.group.localeCompare(l.presentation.group):t(u.presentation.order,l.presentation.order):-1:l.presentation.group?1:t(u.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=o;function t(i,u){return typeof i!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:i-u}}),define(we[70],Ee([0,1,28,16,11,21,63]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cellRangeContains=e.reduceRanges=e.cellRangesToIndexes=e.cellIndexesToRanges=e.CellStatusbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookCellRunState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(C){C[C.Markdown=1]="Markdown",C[C.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={editable:!0,cellEditable:!0,cellHasExecutionOrder:!0,custom:{},runState:y.Idle,trusted:!0};var n;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle",C[C.Success=3]="Success",C[C.Error=4]="Error"})(n=e.NotebookCellRunState||(e.NotebookCellRunState={}));var A;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.CellClearOutput=3]="CellClearOutput",C[C.CellsClearOutput=4]="CellsClearOutput",C[C.ChangeLanguage=5]="ChangeLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.Unknown=12]="Unknown"})(A=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var k;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(k=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.OutputsSplice=6]="OutputsSplice",C[C.Move=7]="Move",C[C.Unknown=8]="Unknown",C[C.CellContent=9]="CellContent",C[C.OutputItems=10]="OutputItems"})(_=e.CellEditType||(e.CellEditType={}));function f(C){const F=r.parse(C);return F?F.notebook.toString():C.toString()}e.getCellUndoRedoComparisonKey=f;var r;(function(C){C.scheme=D.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function x(G,L){return G.with({scheme:C.scheme,fragment:`ch${L.toString().padStart(7,"0")}${G.scheme!==D.Schemas.file?G.scheme:""}`})}C.generate=x;function le(G){if(G.scheme===C.scheme){const L=F.exec(G.fragment);if(!!L)return{handle:Number(L[1]),notebook:G.with({scheme:G.fragment.substr(L[0].length)||D.Schemas.file,fragment:null})}}}C.parse=le;function B(G,L){return G.with({scheme:D.Schemas.vscodeNotebookCellMetadata,fragment:`ch${L.toString().padStart(7,"0")}${G.scheme!==D.Schemas.file?G.scheme:""}`})}C.generateCellMetadataUri=B;function H(G){if(G.scheme===D.Schemas.vscodeNotebookCellMetadata){const L=F.exec(G.fragment);if(!!L)return{handle:Number(L[1]),notebook:G.with({scheme:G.fragment.substr(L[0].length)||D.Schemas.file,fragment:null})}}}C.parseCellMetadataUri=H})(r=e.CellUri||(e.CellUri={}));const h=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function p(C){var F,x;return(x=(F=h.get(C))===null||F===void 0?void 0:F.alwaysSecure)!==null&&x!==void 0?x:!1}e.mimeTypeIsAlwaysSecure=p;function m(C){var F,x;return(x=(F=h.get(C))===null||F===void 0?void 0:F.supportedByCore)!==null&&x!==void 0?x:!1}e.mimeTypeSupportedByCore=m;function v(C){var F,x;return(x=(F=h.get(C))===null||F===void 0?void 0:F.mergeable)!==null&&x!==void 0?x:!1}e.mimeTypeIsMergeable=v;function d(C,F){return P.isWindows&&(C=C.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),w.match(C,F)}function c(C,F,x){let le=0;for(let B=0;B<F.length;B++){if(d(F[B],C))return le;le++}for(let B=0;B<x.length;B++){if(d(x[B],C))return le;le++}return le}function o(C,F,x){return C.sort((le,B)=>c(le,F,x)-c(B,F,x))}e.sortMimeTypes=o;function t(C,F,x,le=(B,H)=>B===H){const B=[];function H($,U,Q){if(!(U===0&&Q.length===0)){const N=B[B.length-1];N&&N.start+N.deleteCount===$?(N.deleteCount+=U,N.toInsert.push(...Q)):B.push({start:$,deleteCount:U,toInsert:Q})}}let G=0,L=0;for(;;){if(G===C.length){H(G,0,F.slice(L));break}if(L===F.length){H(G,C.length-G,[]);break}const $=C[G],U=F[L];if(le($,U)){G+=1,L+=1;continue}x(U)?(H(G,1,[]),G+=1):(H(G,0,[U]),L+=1)}return B}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none"),e.NOTEBOOK_EDITOR_CURSOR_BEGIN_END=new S.RawContextKey("notebookEditorCursorAtEditorBeginEnd",!1);var i;(function(C){C.default="default",C.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(C){const F=C;return!!((typeof F.include=="string"||w.isRelativePattern(F.include))&&(typeof F.exclude=="string"||w.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=u;function l(C,F,x){if(Array.isArray(C.viewType)&&C.viewType.indexOf(F)>=0||C.viewType===F)return!0;if(C.filenamePattern){let le=u(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,B=u(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(w.match(le,(0,T.basename)(x.fsPath).toLowerCase()))return!(B&&w.match(B,(0,T.basename)(x.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=l;class s{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let x=0;x<this.textModel.cells.length;x++)F[x]=this.textModel.cells[x].getHashValue();return F}}e.CellSequence=s,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview";var a;(function(C){C[C.LEFT=0]="LEFT",C[C.RIGHT=1]="RIGHT"})(a=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));function E(C){C.sort((x,le)=>x-le);const F=C.shift();return F===void 0?[]:C.reduce(function(x,le){return le<=x[0][1]?x[0][1]=le+1:x.unshift([le,le+1]),x},[[F,F+1]]).reverse().map(x=>({start:x[0],end:x[1]}))}e.cellIndexesToRanges=E;function R(C){return C.reduce((x,le)=>{for(let B=le.start;B<le.end;B++)x.push(B);return x},[])}e.cellRangesToIndexes=R;function g(C){const F=C.sort((le,B)=>le.start-B.start),x=F[0];return x?F.reduce((le,B)=>{const H=le[le.length-1];return H.end>=B.start?H.end=Math.max(H.end,B.end):le.push(B),le},[x]):[]}e.reduceRanges=g;function b(C,F){return F.start>=C.start&&F.end<=C.end}e.cellRangeContains=b}),define(we[166],Ee([0,1,138,4,63]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new T.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new T.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new T.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,D.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[167],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(T){return[...T.entries()]}e.serializeEnvironmentVariableCollection=w;function D(T){return new Map(T)}e.deserializeEnvironmentVariableCollection=D}),define(we[168],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=void 0;var w;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.DeltaDiscoverComplete=3]="DeltaDiscoverComplete",S[S.DeltaRootsComplete=4]="DeltaRootsComplete"})(w=e.TestDiffOpType||(e.TestDiffOpType={}));const D=(S,I)=>`${S}:${I.toString()}`;e.getTestSubscriptionKey=D;class T{add(I){}update(I){}remove(I,y){}complete(){}}e.IncrementalChangeCollector=T;class P{constructor(){this.items=new Map,this.roots=new Set}apply(I){const y=this.createChangeCollector();for(const n of I)switch(n[0]){case 0:{const A=n[1];if(A.parent){if(this.items.has(A.parent)){const k=this.items.get(A.parent);k.children.add(A.item.extId);const _=this.createItem(A,k);this.items.set(A.item.extId,_),y.add(_)}}else{this.roots.add(A.item.extId);const k=this.createItem(A);this.items.set(A.item.extId,k),y.add(k)}break}case 1:{const A=n[1],k=this.items.get(A.item.extId);k&&(Object.assign(k.item,A.item),y.update(k));break}case 2:{const A=this.items.get(n[1]);if(!A)break;A.parent?this.items.get(A.parent).children.delete(A.item.extId):this.roots.delete(A.item.extId);const k=[[n[1]]];for(;k.length;)for(const _ of k.pop()){const f=this.items.get(_);f&&(k.push(f.children),this.items.delete(_),y.remove(f,f!==A))}break}case 3:this.updateBusyProviders(n[1]);break;case 4:this.updatePendingRoots(n[1]);break}y.complete()}updateBusyProviders(I){}updatePendingRoots(I){}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=P}),define(we[169],Ee([0,1,11,32,12,23,21,58,139]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class n{constructor(k,_,f){if(this._contributedVariables=new Map,this._context=k,this._labelService=_,f)if(S.isWindows){const r=Object.create(null);this._envVariables=r,Object.keys(f).forEach(h=>{r[h.toLowerCase()]=f[h]})}else this._envVariables=f}resolve(k,_){return this.recursiveResolve(k?k.uri:void 0,_)}resolveAnyBase(k,_,f,r){const h=P.deepClone(_);return S.isWindows&&h.windows?Object.keys(h.windows).forEach(p=>h[p]=h.windows[p]):S.isMacintosh&&h.osx?Object.keys(h.osx).forEach(p=>h[p]=h.osx[p]):S.isLinux&&h.linux&&Object.keys(h.linux).forEach(p=>h[p]=h.linux[p]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(k?k.uri:void 0,h,f,r)}resolveAny(k,_,f){return this.resolveAnyBase(k,_,f)}resolveAnyMap(k,_,f){const r=new Map;return{newConfig:this.resolveAnyBase(k,_,f,r),resolvedVariables:r}}resolveWithInteractionReplace(k,_,f,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,_,f,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,_){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,_)}recursiveResolve(k,_,f,r){if(T.isString(_))return this.resolveString(k,_,f,r);if(T.isArray(_))return _.map(h=>this.recursiveResolve(k,h,f,r));if(T.isObject(_)){let h=Object.create(null);return Object.keys(_).forEach(p=>{const m=this.resolveString(k,p,f,r);h[m]=this.recursiveResolve(k,_[p],f,r)}),h}return _}resolveString(k,_,f,r){return _.replace(n.VARIABLE_REGEXP,(p,m)=>{if(m.includes(n.VARIABLE_LHS))return p;let v=this.evaluateSingleVariable(p,m,k,f);return r&&r.set(m,v),v})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,_,f,r){let h;const p=_.split(":");p.length>1&&(_=p[0],h=p[1]);const m=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,y.localize)(0,null,k))},v=()=>{const c=m();if(this._context.getWorkspaceFolderPathForFile){const o=this._context.getWorkspaceFolderPathForFile();if(o)return o}throw new Error((0,y.localize)(1,null,k,w.basename(c)))},d=()=>{if(h){const c=this._context.getFolderUri(h);if(c)return c;throw new Error((0,y.localize)(2,null,k,h))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,k)):new Error((0,y.localize)(4,null,k))};switch(_){case"env":if(h){if(this._envVariables){const c=this._envVariables[S.isWindows?h.toLowerCase():h];if(T.isString(c))return c}return""}throw new Error((0,y.localize)(5,null,k));case"config":if(h){const c=this._context.getConfigurationValue(f,h);if(T.isUndefinedOrNull(c))throw new Error((0,y.localize)(6,null,k,h));if(T.isObject(c))throw new Error((0,y.localize)(7,null,k,h));return c}throw new Error((0,y.localize)(8,null,k));case"command":return this.resolveFromMap(k,h,r,"command");case"input":return this.resolveFromMap(k,h,r,"input");default:switch(_){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return f||h?(0,I.normalizeDriveLetter)(this.fsPath(d())):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(d()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,y.localize)(9,null,k));case"selectedText":const o=this._context.getSelectedText();if(o)return o;throw new Error((0,y.localize)(10,null,k));case"file":return m();case"fileWorkspaceFolder":return v();case"relativeFile":return f||h?w.relative(this.fsPath(d()),m()):m();case"relativeFileDirname":const t=w.dirname(m());if(f||h){const s=w.relative(this.fsPath(d()),t);return s.length===0?".":s}return t;case"fileDirname":return w.dirname(m());case"fileExtname":return w.extname(m());case"fileBasename":return w.basename(m());case"fileBasenameNoExtension":const i=w.basename(m());return i.slice(0,i.length-w.extname(i).length);case"fileDirnameBasename":return w.basename(w.dirname(m()));case"execPath":const u=this._context.getExecPath();return u||k;case"execInstallFolder":const l=this._context.getAppRoot();return l||k;case"pathSeparator":return w.sep;default:try{const s=h?`${_}:${h}`:_;return this.resolveFromMap(k,s,r,void 0)}catch(s){return k}}}}resolveFromMap(k,_,f,r){if(_&&f){const h=r===void 0?f[_]:f[r+":"+_];if(typeof h=="string")return h;throw new Error((0,y.localize)(11,null,k))}return k}}e.AbstractVariableResolverService=n,n.VARIABLE_LHS="${",n.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[170],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var D;(function(_){_[_.UP=0]="UP",_[_.DOWN=1]="DOWN",_[_.LEFT=2]="LEFT",_[_.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var T;(function(_){_[_.HORIZONTAL=0]="HORIZONTAL",_[_.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(_){_[_.FIRST=0]="FIRST",_[_.LAST=1]="LAST",_[_.NEXT=2]="NEXT",_[_.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var S;(function(_){_[_.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",_[_.EVEN=1]="EVEN",_[_.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var I;(function(_){_[_.COPY_EDITORS=0]="COPY_EDITORS",_[_.MOVE_EDITORS=1]="MOVE_EDITORS"})(I=e.MergeGroupMode||(e.MergeGroupMode={}));var y;(function(_){_[_.CREATION_TIME=0]="CREATION_TIME",_[_.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",_[_.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y=e.GroupsOrder||(e.GroupsOrder={}));var n;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.EDITOR_OPEN=2]="EDITOR_OPEN",_[_.EDITOR_CLOSE=3]="EDITOR_CLOSE",_[_.EDITOR_MOVE=4]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=6]="EDITOR_LABEL",_[_.EDITOR_PIN=7]="EDITOR_PIN",_[_.EDITOR_STICKY=8]="EDITOR_STICKY",_[_.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(n=e.GroupChangeKind||(e.GroupChangeKind={}));var A;(function(_){_[_.NEW_EDITOR=1]="NEW_EDITOR",_[_.MOVE_EDITOR=2]="MOVE_EDITOR",_[_.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function k(_){return _.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(we[171],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],Ee([0,1,62,7,140,2,33,80,87,171,12,224,57,23,15,70]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.TestState=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookCellRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlineHintKind=e.InlineHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(me){function he(q){const{selectionStartLineNumber:Ie,selectionStartColumn:Pe,positionLineNumber:et,positionColumn:Ge}=q,rt=new D.Position(Ie-1,Pe-1),lt=new D.Position(et-1,Ge-1);return new D.Selection(rt,lt)}me.to=he;function ue(q){const{anchor:Ie,active:Pe}=q;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}me.from=ue})(p=e.Selection||(e.Selection={}));var m;(function(me){function he(q){if(!!q){const{start:Ie,end:Pe}=q;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}}me.from=he;function ue(q){if(!!q){const{startLineNumber:Ie,startColumn:Pe,endLineNumber:et,endColumn:Ge}=q;return new D.Range(Ie-1,Pe-1,et-1,Ge-1)}}me.to=ue})(m=e.Range||(e.Range={}));var v;(function(me){function he(ue){switch(ue){case 1:return D.StandardTokenType.Comment;case 0:return D.StandardTokenType.Other;case 4:return D.StandardTokenType.RegEx;case 2:return D.StandardTokenType.String}}me.to=he})(v=e.TokenType||(e.TokenType={}));var d;(function(me){function he(q){return new D.Position(q.lineNumber-1,q.column-1)}me.to=he;function ue(q){return{lineNumber:q.line+1,column:q.character+1}}me.from=ue})(d=e.Position||(e.Position={}));var c;(function(me){function he(q){switch(q){case D.DiagnosticTag.Unnecessary:return 1;case D.DiagnosticTag.Deprecated:return 2}}me.from=he;function ue(q){switch(q){case 1:return D.DiagnosticTag.Unnecessary;case 2:return D.DiagnosticTag.Deprecated;default:return}}me.to=ue})(c=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(me){function he(q){let Ie;return q.code&&((0,A.isString)(q.code)||(0,A.isNumber)(q.code)?Ie=String(q.code):Ie={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},m.from(q.range)),{message:q.message,source:q.source,code:Ie,severity:i.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,r.coalesce)(q.tags.map(c.from)):void 0})}me.from=he;function ue(q){var Ie;const Pe=new D.Diagnostic(m.to(q),q.message,i.to(q.severity));return Pe.source=q.source,Pe.code=(0,A.isString)(q.code)?q.code:(Ie=q.code)===null||Ie===void 0?void 0:Ie.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Pe.tags=q.tags&&(0,r.coalesce)(q.tags.map(c.to)),Pe}me.to=ue})(o=e.Diagnostic||(e.Diagnostic={}));var t;(function(me){function he(q){return Object.assign(Object.assign({},m.from(q.location.range)),{message:q.message,resource:q.location.uri})}me.from=he;function ue(q){return new D.DiagnosticRelatedInformation(new D.Location(q.resource,m.to(q)),q.message)}me.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(me){function he(q){switch(q){case D.DiagnosticSeverity.Error:return y.MarkerSeverity.Error;case D.DiagnosticSeverity.Warning:return y.MarkerSeverity.Warning;case D.DiagnosticSeverity.Information:return y.MarkerSeverity.Info;case D.DiagnosticSeverity.Hint:return y.MarkerSeverity.Hint}return y.MarkerSeverity.Error}me.from=he;function ue(q){switch(q){case y.MarkerSeverity.Info:return D.DiagnosticSeverity.Information;case y.MarkerSeverity.Warning:return D.DiagnosticSeverity.Warning;case y.MarkerSeverity.Error:return D.DiagnosticSeverity.Error;case y.MarkerSeverity.Hint:return D.DiagnosticSeverity.Hint;default:return D.DiagnosticSeverity.Error}}me.to=ue})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(me){function he(q){return typeof q=="number"&&q>=D.ViewColumn.One?q-1:q===D.ViewColumn.Beside?n.SIDE_GROUP:n.ACTIVE_GROUP}me.from=he;function ue(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=ue})(u=e.ViewColumn||(e.ViewColumn={}));function l(me){return typeof me.range!="undefined"}function s(me){return me.length===0?!0:!!l(me[0])}e.isDecorationOptionsArr=s;var a;(function(me){function he(Ge){return Ge.map(me.from)}me.fromMany=he;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function q(Ge){let rt;if(ue(Ge)){const{language:dt,value:at}=Ge;rt={value:"```"+dt+`
`+at+"\n```\n"}}else D.MarkdownString.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const lt=Object.create(null);rt.uris=lt;const Je=dt=>{try{let at=P.URI.parse(dt,!0);at=at.with({query:Ie(at.query,lt)}),lt[dt]=at}catch(at){}return""},it=new k.Renderer;return it.link=Je,it.image=dt=>Je(I.parseHrefAndDimensions(dt).href),k(rt.value,{renderer:it}),rt}me.from=q;function Ie(Ge,rt){if(!Ge)return Ge;let lt;try{lt=(0,_.parse)(Ge)}catch(it){}if(!lt)return Ge;let Je=!1;return lt=(0,f.cloneAndChange)(lt,it=>{if(P.URI.isUri(it)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=it,Je=!0,dt}else return}),Je?JSON.stringify(lt):Ge}function Pe(Ge){const rt=new D.MarkdownString(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt}me.to=Pe;function et(Ge){if(!!Ge)return typeof Ge=="string"?Ge:me.from(Ge)}me.fromStrict=et})(a=e.MarkdownString||(e.MarkdownString={}));function E(me){return s(me)?me.map(he=>({range:m.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?a.fromMany(he.hoverMessage):he.hoverMessage?a.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):me.map(he=>({range:m.from(he)}))}e.fromRangeOrRangeWithMessage=E;function R(me){return typeof me=="undefined"?me:typeof me=="string"?P.URI.file(me):me}e.pathOrURIToURI=R;var g;(function(me){function he(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?R(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}me.from=he})(g=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var b;(function(me){function he(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?R(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?g.from(ue.before):void 0,after:ue.after?g.from(ue.after):void 0}}me.from=he})(b=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var C;(function(me){function he(ue){if(typeof ue=="undefined")return ue;switch(ue){case D.DecorationRangeBehavior.OpenOpen:return 0;case D.DecorationRangeBehavior.ClosedClosed:return 1;case D.DecorationRangeBehavior.OpenClosed:return 2;case D.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=he})(C=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var F;(function(me){function he(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?C.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?b.from(ue.light):void 0,dark:ue.dark?b.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?R(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?g.from(ue.before):void 0,after:ue.after?g.from(ue.after):void 0}}me.from=he})(F=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var x;(function(me){function he(q){return{text:q.newText,eol:q.newEol&&X.from(q.newEol),range:m.from(q.range)}}me.from=he;function ue(q){const Ie=new D.TextEdit(m.to(q.range),q.text);return Ie.newEol=typeof q.eol=="undefined"?void 0:X.to(q.eol),Ie}me.to=ue})(x=e.TextEdit||(e.TextEdit={}));var le;(function(me){function he(q,Ie,Pe){var et,Ge,rt;const lt={edits:[]};if(q instanceof D.WorkspaceEdit)for(let Je of q._allEntries())if(Je._type===1)lt.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const it=Ie==null?void 0:Ie.getDocument(Je.uri);lt.edits.push({_type:2,resource:Je.uri,edit:x.from(Je.edit),modelVersionId:it==null?void 0:it.version,metadata:Je.metadata})}else Je._type===3?lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(et=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||et===void 0?void 0:et.notebookDocument.version}):Je._type===4?(Je.newOutputs&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(ve.from)}}),Je.newMetadata&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:3,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(Ge=Pe==null?void 0:Pe.lookupNotebookDocument(Je.uri))===null||Ge===void 0?void 0:Ge.notebookDocument.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(se.from)}}):Je._type===6&&lt.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:10,index:Je.index,outputId:Je.outputId,items:((rt=Je.newOutputItems)===null||rt===void 0?void 0:rt.map(fe.from))||[],append:Je.append}});return lt}me.from=he;function ue(q){const Ie=new D.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Ie.replace(P.URI.revive(Pe.resource),m.to(Pe.edit.range),Pe.edit.text):Ie.renameFile(P.URI.revive(Pe.oldUri),P.URI.revive(Pe.newUri),Pe.options);return Ie}me.to=ue})(le=e.WorkspaceEdit||(e.WorkspaceEdit={}));var B;(function(me){const he=Object.create(null);he[D.SymbolKind.File]=0,he[D.SymbolKind.Module]=1,he[D.SymbolKind.Namespace]=2,he[D.SymbolKind.Package]=3,he[D.SymbolKind.Class]=4,he[D.SymbolKind.Method]=5,he[D.SymbolKind.Property]=6,he[D.SymbolKind.Field]=7,he[D.SymbolKind.Constructor]=8,he[D.SymbolKind.Enum]=9,he[D.SymbolKind.Interface]=10,he[D.SymbolKind.Function]=11,he[D.SymbolKind.Variable]=12,he[D.SymbolKind.Constant]=13,he[D.SymbolKind.String]=14,he[D.SymbolKind.Number]=15,he[D.SymbolKind.Boolean]=16,he[D.SymbolKind.Array]=17,he[D.SymbolKind.Object]=18,he[D.SymbolKind.Key]=19,he[D.SymbolKind.Null]=20,he[D.SymbolKind.EnumMember]=21,he[D.SymbolKind.Struct]=22,he[D.SymbolKind.Event]=23,he[D.SymbolKind.Operator]=24,he[D.SymbolKind.TypeParameter]=25;function ue(Ie){return typeof he[Ie]=="number"?he[Ie]:6}me.from=ue;function q(Ie){for(const Pe in he)if(he[Pe]===Ie)return Number(Pe);return D.SymbolKind.Property}me.to=q})(B=e.SymbolKind||(e.SymbolKind={}));var H;(function(me){function he(q){switch(q){case D.SymbolTag.Deprecated:return 1}}me.from=he;function ue(q){switch(q){case 1:return D.SymbolTag.Deprecated}}me.to=ue})(H=e.SymbolTag||(e.SymbolTag={}));var G;(function(me){function he(q){return{name:q.name,kind:B.from(q.kind),tags:q.tags&&q.tags.map(H.from),containerName:q.containerName,location:N.from(q.location)}}me.from=he;function ue(q){const Ie=new D.SymbolInformation(q.name,B.to(q.kind),q.containerName,N.to(q.location));return Ie.tags=q.tags&&q.tags.map(H.to),Ie}me.to=ue})(G=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var L;(function(me){function he(q){var Ie,Pe;const et={name:q.name||"!!MISSING: name!!",detail:q.detail,range:m.from(q.range),selectionRange:m.from(q.selectionRange),kind:B.from(q.kind),tags:(Pe=(Ie=q.tags)===null||Ie===void 0?void 0:Ie.map(H.from))!==null&&Pe!==void 0?Pe:[]};return q.children&&(et.children=q.children.map(he)),et}me.from=he;function ue(q){const Ie=new D.DocumentSymbol(q.name,q.detail,B.to(q.kind),m.to(q.range),m.to(q.selectionRange));return(0,r.isNonEmptyArray)(q.tags)&&(Ie.tags=q.tags.map(H.to)),q.children&&(Ie.children=q.children.map(ue)),Ie}me.to=ue})(L=e.DocumentSymbol||(e.DocumentSymbol={}));var $;(function(me){function he(ue){const q=new D.CallHierarchyItem(B.to(ue.kind),ue.name,ue.detail||"",P.URI.revive(ue.uri),m.to(ue.range),m.to(ue.selectionRange));return q._sessionId=ue._sessionId,q._itemId=ue._itemId,q}me.to=he})($=e.CallHierarchyItem||(e.CallHierarchyItem={}));var U;(function(me){function he(ue){return new D.CallHierarchyIncomingCall($.to(ue.from),ue.fromRanges.map(q=>m.to(q)))}me.to=he})(U=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Q;(function(me){function he(ue){return new D.CallHierarchyOutgoingCall($.to(ue.to),ue.fromRanges.map(q=>m.to(q)))}me.to=he})(Q=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var N;(function(me){function he(q){return{range:q.range&&m.from(q.range),uri:q.uri}}me.from=he;function ue(q){return new D.Location(P.URI.revive(q.uri),m.to(q.range))}me.to=ue})(N=e.location||(e.location={}));var Z;(function(me){function he(q){const Ie=q,Pe=q;return{originSelectionRange:Ie.originSelectionRange?m.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Pe.uri,range:m.from(Ie.targetRange?Ie.targetRange:Pe.range),targetSelectionRange:Ie.targetSelectionRange?m.from(Ie.targetSelectionRange):void 0}}me.from=he;function ue(q){return{targetUri:P.URI.revive(q.uri),targetRange:m.to(q.range),targetSelectionRange:q.targetSelectionRange?m.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?m.to(q.originSelectionRange):void 0}}me.to=ue})(Z=e.DefinitionLink||(e.DefinitionLink={}));var ne;(function(me){function he(q){return{range:m.from(q.range),contents:a.fromMany(q.contents)}}me.from=he;function ue(q){return new D.Hover(q.contents.map(a.to),m.to(q.range))}me.to=ue})(ne=e.Hover||(e.Hover={}));var re;(function(me){function he(q){return{range:m.from(q.range),expression:q.expression}}me.from=he;function ue(q){return new D.EvaluatableExpression(m.to(q.range),q.expression)}me.to=ue})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ye;(function(me){function he(q){if(q instanceof D.InlineValueText)return{type:"text",range:m.from(q.range),text:q.text};if(q instanceof D.InlineValueVariableLookup)return{type:"variable",range:m.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof D.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}me.from=he;function ue(q){switch(q.type){case"text":return{range:m.to(q.range),text:q.text};case"variable":return{range:m.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:m.to(q.range),expression:q.expression}}}me.to=ue})(ye=e.InlineValue||(e.InlineValue={}));var Ae;(function(me){function he(q){return{frameId:q.frameId,stoppedLocation:m.from(q.stoppedLocation)}}me.from=he;function ue(q){return new D.InlineValueContext(q.frameId,m.to(q.stoppedLocation))}me.to=ue})(Ae=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(me){function he(q){return{range:m.from(q.range),kind:q.kind}}me.from=he;function ue(q){return new D.DocumentHighlight(m.to(q.range),q.kind)}me.to=ue})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var Re;(function(me){function he(ue){switch(ue){case 1:return D.CompletionTriggerKind.TriggerCharacter;case 2:return D.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return D.CompletionTriggerKind.Invoke}}me.to=he})(Re=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var xe;(function(me){function he(ue){return{triggerKind:Re.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}me.to=he})(xe=e.CompletionContext||(e.CompletionContext={}));var W;(function(me){function he(q){switch(q){case D.CompletionItemTag.Deprecated:return 1}}me.from=he;function ue(q){switch(q){case 1:return D.CompletionItemTag.Deprecated}}me.to=ue})(W=e.CompletionItemTag||(e.CompletionItemTag={}));var K;(function(me){const he=new Map([[D.CompletionItemKind.Method,0],[D.CompletionItemKind.Function,1],[D.CompletionItemKind.Constructor,2],[D.CompletionItemKind.Field,3],[D.CompletionItemKind.Variable,4],[D.CompletionItemKind.Class,5],[D.CompletionItemKind.Interface,7],[D.CompletionItemKind.Struct,6],[D.CompletionItemKind.Module,8],[D.CompletionItemKind.Property,9],[D.CompletionItemKind.Unit,12],[D.CompletionItemKind.Value,13],[D.CompletionItemKind.Constant,14],[D.CompletionItemKind.Enum,15],[D.CompletionItemKind.EnumMember,16],[D.CompletionItemKind.Keyword,17],[D.CompletionItemKind.Snippet,27],[D.CompletionItemKind.Text,18],[D.CompletionItemKind.Color,19],[D.CompletionItemKind.File,20],[D.CompletionItemKind.Reference,21],[D.CompletionItemKind.Folder,23],[D.CompletionItemKind.Event,10],[D.CompletionItemKind.Operator,11],[D.CompletionItemKind.TypeParameter,24],[D.CompletionItemKind.Issue,26],[D.CompletionItemKind.User,25]]);function ue(Pe){var et;return(et=he.get(Pe))!==null&&et!==void 0?et:9}me.from=ue;const q=new Map([[0,D.CompletionItemKind.Method],[1,D.CompletionItemKind.Function],[2,D.CompletionItemKind.Constructor],[3,D.CompletionItemKind.Field],[4,D.CompletionItemKind.Variable],[5,D.CompletionItemKind.Class],[7,D.CompletionItemKind.Interface],[6,D.CompletionItemKind.Struct],[8,D.CompletionItemKind.Module],[9,D.CompletionItemKind.Property],[12,D.CompletionItemKind.Unit],[13,D.CompletionItemKind.Value],[14,D.CompletionItemKind.Constant],[15,D.CompletionItemKind.Enum],[16,D.CompletionItemKind.EnumMember],[17,D.CompletionItemKind.Keyword],[27,D.CompletionItemKind.Snippet],[18,D.CompletionItemKind.Text],[19,D.CompletionItemKind.Color],[20,D.CompletionItemKind.File],[21,D.CompletionItemKind.Reference],[23,D.CompletionItemKind.Folder],[10,D.CompletionItemKind.Event],[11,D.CompletionItemKind.Operator],[24,D.CompletionItemKind.TypeParameter],[25,D.CompletionItemKind.User],[26,D.CompletionItemKind.Issue]]);function Ie(Pe){var et;return(et=q.get(Pe))!==null&&et!==void 0?et:D.CompletionItemKind.Property}me.to=Ie})(K=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(me){function he(ue,q){var Ie;const Pe=new D.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Pe.label2=ue.label),Pe.insertText=ue.insertText,Pe.kind=K.to(ue.kind),Pe.tags=(Ie=ue.tags)===null||Ie===void 0?void 0:Ie.map(W.to),Pe.detail=ue.detail,Pe.documentation=I.isMarkdownString(ue.documentation)?a.to(ue.documentation):ue.documentation,Pe.sortText=ue.sortText,Pe.filterText=ue.filterText,Pe.preselect=ue.preselect,Pe.commitCharacters=ue.commitCharacters,S.Range.isIRange(ue.range)?Pe.range=m.to(ue.range):typeof ue.range=="object"&&(Pe.range={inserting:m.to(ue.range.insert),replacing:m.to(ue.range.replace)}),Pe.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Pe.insertText=new D.SnippetString(ue.insertText):(Pe.insertText=ue.insertText,Pe.textEdit=Pe.range instanceof D.Range?new D.TextEdit(Pe.range,Pe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Pe.additionalTextEdits=ue.additionalTextEdits.map(et=>x.to(et))),Pe.command=q&&ue.command?q.fromInternal(ue.command):void 0,Pe}me.to=he})(J=e.CompletionItem||(e.CompletionItem={}));var ae;(function(me){function he(q){return{label:q.label,documentation:q.documentation?a.fromStrict(q.documentation):void 0}}me.from=he;function ue(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?a.to(q.documentation):q.documentation}}me.to=ue})(ae=e.ParameterInformation||(e.ParameterInformation={}));var ge;(function(me){function he(q){return{label:q.label,documentation:q.documentation?a.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.from):[],activeParameter:q.activeParameter}}me.from=he;function ue(q){return{label:q.label,documentation:I.isMarkdownString(q.documentation)?a.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(ae.to):[],activeParameter:q.activeParameter}}me.to=ue})(ge=e.SignatureInformation||(e.SignatureInformation={}));var De;(function(me){function he(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(ge.from):[]}}me.from=he;function ue(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(ge.to):[]}}me.to=ue})(De=e.SignatureHelp||(e.SignatureHelp={}));var Le;(function(me){function he(q){var Ie;return{text:q.text,range:m.from(q.range),kind:pe.from((Ie=q.kind)!==null&&Ie!==void 0?Ie:D.InlineHintKind.Other),description:q.description&&a.fromStrict(q.description),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}me.from=he;function ue(q){const Ie=new D.InlineHint(q.text,m.to(q.range),pe.to(q.kind));return Ie.whitespaceAfter=q.whitespaceAfter,Ie.whitespaceBefore=q.whitespaceBefore,Ie.description=I.isMarkdownString(q.description)?a.to(q.description):q.description,Ie}me.to=ue})(Le=e.InlineHint||(e.InlineHint={}));var pe;(function(me){function he(q){return q}me.from=he;function ue(q){return q}me.to=ue})(pe=e.InlineHintKind||(e.InlineHintKind={}));var Ce;(function(me){function he(q){return{range:m.from(q.range),url:q.target,tooltip:q.tooltip}}me.from=he;function ue(q){let Ie;if(q.url)try{Ie=typeof q.url=="string"?P.URI.parse(q.url,!0):P.URI.revive(q.url)}catch(Pe){}return new D.DocumentLink(m.to(q.range),Ie)}me.to=ue})(Ce=e.DocumentLink||(e.DocumentLink={}));var Te;(function(me){function he(q){const Ie=new D.ColorPresentation(q.label);return q.textEdit&&(Ie.textEdit=x.to(q.textEdit)),q.additionalTextEdits&&(Ie.additionalTextEdits=q.additionalTextEdits.map(Pe=>x.to(Pe))),Ie}me.to=he;function ue(q){return{label:q.label,textEdit:q.textEdit?x.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ie=>x.from(Ie)):void 0}}me.from=ue})(Te=e.ColorPresentation||(e.ColorPresentation={}));var Ue;(function(me){function he(q){return new D.Color(q[0],q[1],q[2],q[3])}me.to=he;function ue(q){return[q.red,q.green,q.blue,q.alpha]}me.from=ue})(Ue=e.Color||(e.Color={}));var be;(function(me){function he(q){return{range:m.from(q.range)}}me.from=he;function ue(q){return new D.SelectionRange(m.to(q.range))}me.to=ue})(be=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(me){function he(ue){switch(ue){case 2:return D.TextDocumentSaveReason.AfterDelay;case 1:return D.TextDocumentSaveReason.Manual;case 3:case 4:return D.TextDocumentSaveReason.FocusOut}}me.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(me){function he(q){switch(q){case D.TextEditorLineNumbersStyle.Off:return 0;case D.TextEditorLineNumbersStyle.Relative:return 2;case D.TextEditorLineNumbersStyle.On:default:return 1}}me.from=he;function ue(q){switch(q){case 0:return D.TextEditorLineNumbersStyle.Off;case 2:return D.TextEditorLineNumbersStyle.Relative;case 1:default:return D.TextEditorLineNumbersStyle.On}}me.to=ue})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var X;(function(me){function he(q){if(q===D.EndOfLine.CRLF)return 1;if(q===D.EndOfLine.LF)return 0}me.from=he;function ue(q){if(q===1)return D.EndOfLine.CRLF;if(q===0)return D.EndOfLine.LF}me.to=ue})(X=e.EndOfLine||(e.EndOfLine={}));var _e;(function(me){function he(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case D.ProgressLocation.SourceControl:return 3;case D.ProgressLocation.Window:return 10;case D.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=he})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(me){function he(ue){const q={start:ue.start+1,end:ue.end+1};return ue.kind&&(q.kind=He.from(ue.kind)),q}me.from=he})(Me=e.FoldingRange||(e.FoldingRange={}));var He;(function(me){function he(ue){if(ue)switch(ue){case D.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case D.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case D.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}me.from=he})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Oe;(function(me){function he(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?m.from(ue.selection):void 0,override:typeof ue.override=="boolean"?T.EditorOverride.DISABLED:void 0}}me.from=he})(Oe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(me){function he(q){return q instanceof D.RelativePattern||typeof q=="string"?q:ue(q)?new D.RelativePattern(q.base,q.pattern):q}me.from=he;function ue(q){const Ie=q;return Ie&&typeof Ie.base=="string"&&typeof Ie.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var z;(function(me){function he(ue){if(ue){if(Array.isArray(ue))return ue.map(he);if(typeof ue=="string")return ue;{const q=ue;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Xe.from(q.pattern),exclusive:q.exclusive}}}else return}me.from=he})(z=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(me){function he(q){return{start:q.start,end:q.end}}me.from=he;function ue(q){return new D.NotebookCellRange(q.start,q.end)}me.to=ue})(ie=e.NotebookCellRange||(e.NotebookCellRange={}));var ce;(function(me){function he(ue){return new D.NotebookCellMetadata(ue.editable,ue.breakpointMargin,ue.hasExecutionOrder,ue.executionOrder,ue.runState,ue.runStartTime,ue.statusMessage,ue.lastRunDuration,ue.inputCollapsed,ue.outputCollapsed,ue.custom)}me.to=he})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var j;(function(me){function he(q){return q}me.from=he;function ue(q){return new D.NotebookDocumentMetadata(q.editable,q.cellEditable,q.cellHasExecutionOrder,q.custom,q.runState,q.trusted)}me.to=ue})(j=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var Y;(function(me){function he(q){switch(q){case D.NotebookCellKind.Markdown:return h.CellKind.Markdown;case D.NotebookCellKind.Code:default:return h.CellKind.Code}}me.from=he;function ue(q){switch(q){case h.CellKind.Markdown:return D.NotebookCellKind.Markdown;case h.CellKind.Code:default:return D.NotebookCellKind.Code}}me.to=ue})(Y=e.NotebookCellKind||(e.NotebookCellKind={}));var se;(function(me){function he(q){return{cellKind:Y.from(q.kind),language:q.language,source:q.source,metadata:q.metadata,outputs:q.outputs?q.outputs.map(ve.from):[]}}me.from=he;function ue(q){return new D.NotebookCellData(Y.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(ve.to):void 0,q.metadata?ce.to(q.metadata):void 0)}me.to=ue})(se=e.NotebookCellData||(e.NotebookCellData={}));var fe;(function(me){function he(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}me.from=he;function ue(q){return new D.NotebookCellOutputItem(q.mime,q.value,q.metadata)}me.to=ue})(fe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ve;(function(me){function he(q){return{outputId:q.id,outputs:q.outputs.map(fe.from),metadata:q.metadata}}me.from=he;function ue(q){const Ie=q.outputs.map(fe.to);return new D.NotebookCellOutput(Ie,q.outputId,q.metadata)}me.to=ue})(ve=e.NotebookCellOutput||(e.NotebookCellOutput={}));var $e;(function(me){function he(Pe){if(Pe!=null){if(Pe instanceof D.RelativePattern||typeof Pe=="string")return Pe;if(Ie(Pe))return new D.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:Xe.from(Pe.include)||void 0,exclude:Xe.from(Pe.exclude)||void 0}}}me.from=he;function ue(Pe){return typeof Pe=="string"?Pe:Ie(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}me.to=ue;function q(Pe){const et=Pe,Ge=Xe.from(et.include);if(!(Ge&&Ge instanceof D.RelativePattern||typeof Ge=="string"))return!1;const rt=Xe.from(et.exclude);return!!(rt&&rt instanceof D.RelativePattern||typeof rt=="string")}function Ie(Pe){const et=Pe;return et&&typeof et.base=="string"&&typeof et.pattern=="string"}})($e=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ne;(function(me){function he(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?g.from(ue.top):void 0}}me.from=he})(Ne=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ve;(function(me){function he(q){return{state:q.state,duration:q.duration,messages:q.messages.map(Qe.from)}}me.from=he;function ue(q){const Ie=new D.TestState(q.state);return Ie.duration=q.duration,Ie.messages=q.messages.map(Qe.to),Ie}me.to=ue})(Ve=e.TestState||(e.TestState={}));var Qe;(function(me){function he(q){return{message:a.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?N.from(q.location):void 0}}me.from=he;function ue(q){const Ie=new D.TestMessage(typeof q.message=="string"?q.message:a.to(q.message));return Ie.severity=q.severity,Ie.actualOutput=q.actualOutput,Ie.expectedOutput=q.expectedOutput,Ie}me.to=ue})(Qe=e.TestMessage||(e.TestMessage={}));var Ze;(function(me){function he(Ie){var Pe,et;return{extId:Ie.id,label:Ie.label,location:Ie.location?N.from(Ie.location):void 0,debuggable:(Pe=Ie.debuggable)!==null&&Pe!==void 0?Pe:!1,description:Ie.description,runnable:(et=Ie.runnable)!==null&&et!==void 0?et:!0}}me.from=he;function ue(Ie){return{id:Ie.extId,label:Ie.label,location:Ie.location&&N.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)}),debuggable:Ie.debuggable,description:Ie.description,runnable:Ie.runnable}}me.toPlainShallow=ue;function q(Ie){const Pe=new D.TestItem(Ie.extId,Ie.label);return Ie.location&&(Pe.location=N.to({range:Ie.location.range,uri:P.URI.revive(Ie.location.uri)})),Pe.debuggable=Ie.debuggable,Pe.description=Ie.description,Pe.runnable=Ie.runnable,Pe}me.toShallow=q})(Ze=e.TestItem||(e.TestItem={}));var ct;(function(me){function he(Ie,Pe){var et,Ge,rt;const lt={completedAt:Pe.completedAt,id:Ie,items:[]},Je=[[null,Pe.results]];for(;Je.length;){const[it,dt]=Je.pop();for(const at of dt){const Dt={children:(Ge=(et=at.children)===null||et===void 0?void 0:et.map(gt=>gt.id))!==null&&Ge!==void 0?Ge:[],computedState:at.result.state,item:Ze.from(at),state:Ve.from(at.result),retired:void 0,parent:(rt=it==null?void 0:it.item.extId)!==null&&rt!==void 0?rt:null,providerId:"",direct:!it};lt.items.push(Dt),at.children&&Je.push([Dt,at.children])}}return lt}me.from=he;const ue=(Ie,Pe)=>Object.assign(Object.assign({},Ze.toPlainShallow(Ie.item)),{result:Ve.to(Ie.state),children:Ie.children.map(et=>Pe.get(et)).filter(A.isDefined).map(et=>ue(et,Pe))});function q(Ie){const Pe=[],et=new Map;for(const Ge of Ie.items)et.set(Ge.item.extId,Ge),Ge.direct&&Pe.push(Ge);return{completedAt:Ie.completedAt,results:Pe.map(Ge=>ue(Ge,et))}}me.to=q})(ct=e.TestResults||(e.TestResults={}));var st;(function(me){function he(ue){switch(ue){case 1:return D.CodeActionTriggerKind.Invoke;case 2:return D.CodeActionTriggerKind.Automatic}}me.to=he})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[172],Ee([0,1,2,10,7,9,46]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(n,A,k,_={timeout:1500,errors:3}){this._logService=n,this._documents=A,this._mainThreadBulkEdits=k,this._thresholds=_,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(n){return(A,k,_)=>{const r={dispose:this._callbacks.push([A,k,n])};return Array.isArray(_)&&_.push(r),r}}async $participateInSave(n,A){const k=w.URI.revive(n);let _=!1;const f=setTimeout(()=>_=!0,this._thresholds.timeout),r=[];try{for(let h of[...this._callbacks]){if(_)break;const p=this._documents.getDocument(k),m=await this._deliverEventAsyncAndBlameBadListeners(h,{document:p,reason:P.TextDocumentSaveReason.to(A)});r.push(m)}}finally{clearTimeout(f)}return r}_deliverEventAsyncAndBlameBadListeners([n,A,k],_){const f=this._badListeners.get(n);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,n,A,_).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const h=this._badListeners.get(n);this._badListeners.set(n,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(n,A,k,_){const f=[],r=Date.now(),{document:h,reason:p}=_,{version:m}=h,v=Object.freeze({document:h,reason:p,waitUntil(d){if(Object.isFrozen(f))throw(0,D.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(d))}});try{A.apply(k,[v])}catch(d){return Promise.reject(d)}return Object.freeze(f),new Promise((d,c)=>{const o=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${n.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(o),d(t)}).catch(t=>{clearTimeout(o),c(t)})}).then(d=>{const c={edits:[]};for(const o of d)if(Array.isArray(o)&&o.every(t=>t instanceof T.TextEdit))for(const{newText:t,newEol:i,range:u}of o)c.edits.push({_type:2,resource:h.uri,edit:{range:u&&P.Range.from(u),text:t,eol:i&&P.EndOfLine.from(i)}});if(c.edits.length!==0)return m===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(we[173],Ee([0,1,3,13,28,2,9,7]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{constructor(k,_,f,r,h){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,f&&(this._config+=1),r&&(this._config+=2),h&&(this._config+=4);const p=(0,T.parse)(_),m=k(v=>{if(!f)for(let d of v.created){const c=P.URI.revive(d);p(c.fsPath)&&this._onDidCreate.fire(c)}if(!r)for(let d of v.changed){const c=P.URI.revive(d);p(c.fsPath)&&this._onDidChange.fire(c)}if(!h)for(let d of v.deleted){const c=P.URI.revive(d);p(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=I.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class n{constructor(k,_,f){this._logService=_,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new D.AsyncEmitter,this._onWillCreateFile=new D.AsyncEmitter,this._onWillDeleteFile=new D.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,_,f,r){return new y(this._onFileSystemEvent.event,k,_,f,r)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,_){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(f=>P.URI.revive(f.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,_){return(f,r,h)=>{const p=function(v){f.call(r,v)};return p.extension=k,_.event(p,void 0,h)}}async $onWillRunFileOperation(k,_,f,r){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},f,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(h=>P.URI.revive(h.target))},f,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(h=>P.URI.revive(h.target))},f,r)}}async _fireWillEvent(k,_,f,r){const h=new Set,p=[];if(await k.fireAsync(_,r,async(v,d)=>{var c;const o=Date.now(),t=await Promise.resolve(v);t instanceof I.WorkspaceEdit&&(p.push(t),h.add((c=d.extension.displayName)!==null&&c!==void 0?c:d.extension.identifier.value)),Date.now()-o>f&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!r.isCancellationRequested&&p.length!==0){const m={edits:[]};for(let v of p){let{edits:d}=S.WorkspaceEdit.from(v,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(d)}return{edit:m,extensionNames:Array.from(h)}}}}e.ExtHostFileSystemEventService=n}),define(we[174],Ee([0,1,3,6,16,23,2,9,70]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class n{constructor(f,r,h,p){this.start=f,this.deletedCount=r,this.deletedItems=h,this.items=p}static asApiEvents(f){return f.map(r=>({start:r.start,deletedCount:r.deletedCount,deletedItems:r.deletedItems,items:r.items.map(h=>h.cell)}))}}class A{constructor(f,r,h){var p;this._notebook=f,this._extHostDocument=r,this._cellData=h,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this.handle=h.handle,this.uri=S.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(I.NotebookCellOutput.to),this._metadata=I.NotebookCellMetadata.to((p=h.metadata)!==null&&p!==void 0?p:{})}static asModelAddData(f,r){return{EOL:r.eol,lines:r.source,modeId:r.language,uri:r.uri,isDirty:!1,versionId:1,notebook:f}}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get cell(){if(!this._cell){const f=this,r=this._extHostDocument.getDocument(this.uri);if(!r)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return f._notebook.getCellIndex(f)},notebook:f._notebook.notebookDocument,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:r.document,get outputs(){return f._outputs.slice(0)},get metadata(){return f._metadata}})}return this._cell}setOutputs(f){this._outputs=f.map(I.NotebookCellOutput.to)}setOutputItems(f,r,h){const p=h.map(I.NotebookCellOutputItem.to),m=this._outputs.find(v=>v.id===f);m&&(r||(m.outputs.length=0),m.outputs.push(...p))}setMetadata(f){this._metadata=I.NotebookCellMetadata.to(f)}}e.ExtHostCell=A;class k extends D.Disposable{constructor(f,r,h,p,m,v,d){super();this._proxy=f,this._textDocumentsAndEditors=r,this._textDocuments=h,this._emitter=p,this._viewType=m,this._metadata=v,this.uri=d,this.handle=k._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0,super.dispose(),(0,D.dispose)(this._cellDisposableMapping.values())}get notebookDocument(){if(!this._notebook){const f=this;this._notebook=Object.freeze({get uri(){return f.uri},get version(){return f._versionId},get fileName(){return f.uri.fsPath},get viewType(){return f._viewType},get isDirty(){return f._isDirty},get isUntitled(){return f.uri.scheme===T.Schemas.untitled},get cells(){return f._cells.map(r=>r.cell)},get metadata(){return f._metadata},set metadata(r){throw new Error("Use WorkspaceEdit to update metadata.")},save(){return f._save()}})}return this._notebook}updateBackup(f){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=f}disposeBackup(){var f;(f=this._backup)===null||f===void 0||f.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(f){f.metadata&&(this._metadata=this._metadata.with(f.metadata))}acceptModelChanged(f,r){this._versionId=f.versionId,this._isDirty=r;for(const h of f.rawEvents)h.kind===y.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(h.changes,!0),h.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===y.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===y.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===y.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===y.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===y.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(h.index,h.metadata)}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(f,r){if(!this._disposed){const h=[],p=[],m=[];f.reverse().forEach(v=>{var d;const o=v[2].map(u=>{const l=new A(this,this._textDocumentsAndEditors,u);if(r||p.push(A.asModelAddData(this.notebookDocument,u)),!this._cellDisposableMapping.has(l.handle)){const s=new D.DisposableStore;s.add(l),this._cellDisposableMapping.set(l.handle,s)}return l});for(let u=v[0];u<v[0]+v[1];u++)(d=this._cellDisposableMapping.get(this._cells[u].handle))===null||d===void 0||d.dispose(),this._cellDisposableMapping.delete(this._cells[u].handle);const t=new n(v[0],v[1],[],o),i=this._cells.splice(v[0],v[1],...o);for(let u of i)m.push(u.uri),t.deletedItems.push(u.cell);h.push(t)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:m}),r||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(h)}))}}_moveCell(f,r){const h=this._cells.splice(f,1);this._cells.splice(r,0,...h);const p=[new n(f,1,h.map(m=>m.cell),[]),new n(r,0,[],h)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.notebookDocument,changes:n.asApiEvents(p)}))}_setCellOutputs(f,r){const h=this._cells[f];h.setOutputs(r),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[h.cell]}))}_setCellOutputItems(f,r,h,p){const m=this._cells[f];m.setOutputItems(r,h,p),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.notebookDocument,cells:[m.cell]}))}_changeCellLanguage(f,r){const h=this._cells[f];h.cell.document.languageId!==r&&this._textDocuments.$acceptModelModeChanged(h.uri,r)}_changeCellMetadata(f,r){const h=this._cells[f];h.setMetadata(r||{}),this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.notebookDocument,cell:h.cell}))}getCellFromIndex(f){return this._cells[f]}getCell(f){return this._cells.find(r=>r.handle===f)}getCellIndex(f){return this._cells.indexOf(f)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(we[175],Ee([0,1,3,7,9]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:y,metadata:n})}replaceCellOutput(y,n){this._throwIfFinalized(),this._collectedEdits.push({editType:2,index:y,outputs:n.map(A=>T.NotebookCellOutput.from(A))})}replaceCells(y,n,A){this._throwIfFinalized(),!(y===n&&A.length===0)&&this._collectedEdits.push({editType:1,index:y,count:n-y,cells:A.map(T.NotebookCellData.from)})}}class S{constructor(y,n,A,k,_,f,r){this.id=y,this._viewType=n,this._proxy=A,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._onDidDispose=new w.Emitter,this.onDidDispose=this._onDidDispose.event,this._selections=f,this._visibleRanges=_,this._viewColumn=r}dispose(){this._onDidDispose.fire(),this._onDidDispose.dispose()}get editor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.notebookDocument},get selection(){var n;const A=y._selections[0];return A&&((n=y.notebookData.getCellFromIndex(A.start))===null||n===void 0?void 0:n.cell)},get selections(){return y._selections},get visibleRanges(){return y._visibleRanges},revealRange(n,A){y._proxy.$tryRevealRange(y.id,T.NotebookCellRange.from(n),A!=null?A:D.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},get onDidDispose(){return y.onDidDispose},edit(n){const A=new P(this.document.version);return n(A),y._applyEdit(A.finalize())},get kernel(){return y._kernel},setDecorations(n,A){return y.setDecorations(n,A)}}}return this._editor}_acceptKernel(y){this._kernel=y}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const n=[];let A=-1;for(let k=0;k<y.cellEdits.length;k++){if(A<0){n.push(y.cellEdits[k]),A++;continue}const f=n[A];if(f.editType===1&&y.cellEdits[k].editType===1){const r=y.cellEdits[k];if(r.editType!==5&&f.index===r.index){f.cells.push(...y.cellEdits[k].cells),f.count+=y.cellEdits[k].count;continue}}n.push(y.cellEdits[k]),A++}return this._proxy.$tryApplyEdits(this._viewType,this.notebookData.uri,y.documentVersionId,n)}setDecorations(y,n){if(!(n.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return n.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,T.NotebookCellRange.from(n),y.key)}}e.ExtHostNotebookEditor=S}),define(we[176],Ee([0,1,9,149,130,20,44]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,_,f){const r=this._handles++,{title:h,location:p,cancellable:m}=_,v=(0,T.localize)(0,null,k.displayName||k.name);return this._proxy.$startProgress(r,{location:w.ProgressLocation.from(p),title:h,source:v,cancellable:m},k),this._withProgress(r,f,!!m)}_withProgress(k,_,f){let r;f&&(r=new P.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,r));const h=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let p;try{p=_(new n(this._proxy,k),f&&r?r.token:P.CancellationToken.None)}catch(m){throw h(k),m}return p.then(m=>h(k),m=>h(k)),p}$acceptProgressCanceled(k){const _=this._mapHandleToCancellationSource.get(k);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=I;function y(A,k){return A.message=k.message,typeof k.increment=="number"&&(typeof A.increment=="number"?A.increment+=k.increment:A.increment=k.increment),A}class n extends D.Progress{constructor(k,_){super(f=>this.throttledReport(f));this._proxy=k,this._handle=_}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}je([(0,S.throttle)(100,(A,k)=>y(A,k),()=>Object.create(null))],n.prototype,"throttledReport",null)}),define(we[95],Ee([0,1,43,10,53,9,7]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(_,f){const r=I._Keys.nextId();_.$registerTextEditorDecorationType(r,P.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:r,dispose(){_.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=I,I._Keys=new T.IdGenerator("TextEditorDecorationType");class y{constructor(_,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=_,this._documentVersionId=_.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(_,f){this._throwIfFinalized();let r=null;if(_ instanceof S.Position)r=new S.Range(_,_);else if(_ instanceof S.Range)r=_;else throw new Error("Unrecognized location");this._pushEdit(r,f,!1)}insert(_,f){this._throwIfFinalized(),this._pushEdit(new S.Range(_,_),f,!0)}delete(_){this._throwIfFinalized();let f=null;if(_ instanceof S.Range)f=_;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(_,f,r){const h=this._document.validateRange(_);this._collectedEdits.push({range:h,text:f,forceMoveMarkers:r})}setEndOfLine(_){if(this._throwIfFinalized(),_!==S.EndOfLine.LF&&_!==S.EndOfLine.CRLF)throw(0,D.illegalArgument)("endOfLine");this._setEndOfLine=_}}e.TextEditorEdit=y;class n{constructor(_,f,r,h){this._proxy=_,this._id=f,this._accept(r),this._logService=h;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(m){p._setTabSize(m)},get insertSpaces(){return p._insertSpaces},set insertSpaces(m){p._setInsertSpaces(m)},get cursorStyle(){return p._cursorStyle},set cursorStyle(m){p._setCursorStyle(m)},get lineNumbers(){return p._lineNumbers},set lineNumbers(m){p._setLineNumbers(m)}}}_accept(_){this._tabSize=_.tabSize,this._insertSpaces=_.insertSpaces,this._cursorStyle=_.cursorStyle,this._lineNumbers=P.TextEditorLineNumbersStyle.to(_.lineNumbers)}_validateTabSize(_){if(_==="auto")return"auto";if(typeof _=="number"){const f=Math.floor(_);return f>0?f:null}if(typeof _=="string"){const f=parseInt(_,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(_){const f=this._validateTabSize(_);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(_){return _==="auto"?"auto":_==="false"?!1:Boolean(_)}_setInsertSpaces(_){const f=this._validateInsertSpaces(_);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(_){this._cursorStyle!==_&&(this._cursorStyle=_,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:_})))}_setLineNumbers(_){this._lineNumbers!==_&&(this._lineNumbers=_,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:P.TextEditorLineNumbersStyle.from(_)})))}assign(_){const f={};let r=!1;if(typeof _.tabSize!="undefined"){const h=this._validateTabSize(_.tabSize);h==="auto"?(r=!0,f.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,r=!0,f.tabSize=h)}if(typeof _.insertSpaces!="undefined"){const h=this._validateInsertSpaces(_.insertSpaces);h==="auto"?(r=!0,f.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,r=!0,f.insertSpaces=h)}typeof _.cursorStyle!="undefined"&&this._cursorStyle!==_.cursorStyle&&(this._cursorStyle=_.cursorStyle,r=!0,f.cursorStyle=_.cursorStyle),typeof _.lineNumbers!="undefined"&&this._lineNumbers!==_.lineNumbers&&(this._lineNumbers=_.lineNumbers,r=!0,f.lineNumbers=P.TextEditorLineNumbersStyle.from(_.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,f))}_warnOnError(_){_.catch(f=>this._logService.warn(f))}}e.ExtHostTextEditorOptions=n;class A{constructor(_,f,r,h,p,m,v,d){this.id=_,this._proxy=f,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new n(this._proxy,this.id,m,r),this._visibleRanges=v,this._viewColumn=d;const c=this;this.value=Object.freeze({get document(){return h.getValue()},set document(o){throw(0,D.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(o){if(!(o instanceof S.Selection))throw(0,D.illegalArgument)("selection");c._selections=[o],c._trySetSelection()},get selections(){return c._selections},set selections(o){if(!Array.isArray(o)||o.some(t=>!(t instanceof S.Selection)))throw(0,D.illegalArgument)("selections");c._selections=o,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(o){throw(0,D.readonly)("visibleRanges")},get options(){return c._options.value},set options(o){c._disposed||c._options.assign(o)},get viewColumn(){return c._viewColumn},set viewColumn(o){throw(0,D.readonly)("viewColumn")},edit(o,t={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new y(h.getValue(),t);return o(i),c._applyEdit(i)},insertSnippet(o,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=c._selections.map(l=>P.Range.from(l));else if(t instanceof S.Position){const{lineNumber:l,column:s}=P.Position.from(t);u=[{startLineNumber:l,startColumn:s,endLineNumber:l,endColumn:s}]}else if(t instanceof S.Range)u=[P.Range.from(t)];else{u=[];for(const l of t)if(l instanceof S.Range)u.push(P.Range.from(l));else{const{lineNumber:s,column:a}=P.Position.from(l);u.push({startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a})}}return f.$tryInsertSnippet(_,o.value,u,i)},setDecorations(o,t){const i=t.length===0;i&&!c._hasDecorationsForKey.has(o.key)||(i?c._hasDecorationsForKey.delete(o.key):c._hasDecorationsForKey.add(o.key),c._runOnProxy(()=>{if(P.isDecorationOptionsArr(t))return f.$trySetDecorations(_,o.key,P.fromRangeOrRangeWithMessage(t));{const u=new Array(4*t.length);for(let l=0,s=t.length;l<s;l++){const a=t[l];u[4*l]=a.start.line+1,u[4*l+1]=a.start.character+1,u[4*l+2]=a.end.line+1,u[4*l+3]=a.end.character+1}return f.$trySetDecorationsFast(_,o.key,u)}}))},revealRange(o,t){c._runOnProxy(()=>f.$tryRevealRange(_,P.Range.from(o),t||S.TextEditorRevealType.Default))},show(o){f.$tryShowEditor(_,P.ViewColumn.from(o))},hide(){f.$tryHideEditor(_)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(_){(0,w.ok)(!this._disposed),this._options._accept(_)}_acceptVisibleRanges(_){(0,w.ok)(!this._disposed),this._visibleRanges=_}_acceptViewColumn(_){(0,w.ok)(!this._disposed),this._viewColumn=_}_acceptSelections(_){(0,w.ok)(!this._disposed),this._selections=_}async _trySetSelection(){const _=this._selections.map(P.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,_)),this.value}_applyEdit(_){const f=_.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const r=f.edits.map(p=>p.range);r.sort((p,m)=>p.end.line===m.end.line?p.end.character===m.end.character?p.start.line===m.start.line?p.start.character-m.start.character:p.start.line-m.start.line:p.end.character-m.end.character:p.end.line-m.end.line);for(let p=0,m=r.length-1;p<m;p++){const v=r[p].end;if(r[p+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=f.edits.map(p=>({range:P.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,h,{setEndOfLine:typeof f.setEndOfLine=="number"?P.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(_){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):_().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=A}),define(we[177],Ee([0,1,133,24,2,3,6,13,7,12,15,9,20]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function f(p,m){if((0,n.isString)(p))return{label:p};if(p&&typeof p=="object"&&typeof p.label=="string"){let v;return Array.isArray(p.highlights)&&(v=p.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),v=v.length?v:void 0),{label:p.label,highlights:v}}}class r{constructor(m,v,d){this._proxy=m,this.commands=v,this.logService=d,this.treeViews=new Map;function c(o){return o&&o.$treeViewId&&o.$treeItemHandle}v.registerArgumentProcessor({processArgument:o=>c(o)?this.convertArgument(o):Array.isArray(o)&&o.length>0?o.map(t=>c(t)?this.convertArgument(t):t):o})}registerTreeDataProvider(m,v,d){const c=this.createTreeView(m,{treeDataProvider:v},d);return{dispose:()=>c.dispose()}}createTreeView(m,v,d){if(!v||!v.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!v.showCollapseAll,canSelectMany:!!v.canSelectMany}),o=this.createExtHostTreeView(m,v,d);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(t){o.message=t},get title(){return o.title},set title(t){o.title=t},get description(){return o.description},set description(t){o.description=t},reveal:(t,i)=>o.reveal(t,i),dispose:async()=>{await c,this.treeViews.delete(m),o.dispose()}}}$getChildren(m,v){const d=this.treeViews.get(m);return d?d.getChildren(v):Promise.reject(new Error((0,w.localize)(0,null,m)))}async $hasResolve(m){const v=this.treeViews.get(m);if(!v)throw new Error((0,w.localize)(1,null,m));return v.hasResolve}$resolve(m,v,d){const c=this.treeViews.get(m);if(!c)throw new Error((0,w.localize)(2,null,m));return c.resolveTreeItem(v,d)}$setExpanded(m,v,d){const c=this.treeViews.get(m);if(!c)throw new Error((0,w.localize)(3,null,m));c.setExpanded(v,d)}$setSelection(m,v){const d=this.treeViews.get(m);if(!d)throw new Error((0,w.localize)(4,null,m));d.setSelection(v)}$setVisible(m,v){const d=this.treeViews.get(m);if(!d)throw new Error((0,w.localize)(5,null,m));d.setVisible(v)}createExtHostTreeView(m,v,d){const c=new h(m,v,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(m,c),c}convertArgument(m){const v=this.treeViews.get(m.$treeViewId);return v?v.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class h extends S.Disposable{constructor(m,v,d,c,o,t){super();if(this.viewId=m,this.proxy=d,this.commands=c,this.logService=o,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new P.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new P.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new P.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new P.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new P.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new _.CancellationTokenSource,t.contributes&&t.contributes.views)for(const l in t.contributes.views)for(const s of t.contributes.views[l])s.id===m&&(this._title=s.name);this.dataProvider=v.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(l=>this._onDidChangeData.fire({message:!1,element:l})));let i,u;this._register(P.Event.debounce(this._onDidChangeData.event,(l,s)=>(l||(l={message:!1,elements:[]}),s.element!==!1&&(i||(i=new Promise(a=>u=a),this.refreshPromise=this.refreshPromise.then(()=>i)),l.elements.push(s.element)),s.message&&(l.message=!0),l),200,!0)(({message:l,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const a=u;return i=null,this.refresh(s).then(()=>a())})),l&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,n.isUndefinedOrNull)(m))}getChildren(m){const v=m?this.getExtensionElement(m):void 0;if(m&&!v)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(m);return(d?Promise.resolve(d):this.fetchChildrenNodes(v)).then(c=>c.map(o=>o.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,v){v=v||{select:!0,focus:!1};const d=(0,n.isUndefinedOrNull)(v.select)?!0:v.select,c=(0,n.isUndefinedOrNull)(v.focus)?!1:v.focus,o=(0,n.isUndefinedOrNull)(v.expand)?!1:v.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(u=>u.item)},{select:d,focus:c,expand:o})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:c,expand:o})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,v){const d=this.getExtensionElement(m);d&&(v?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(m){(0,A.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,v){var d;if(!!this.dataProvider.resolveTreeItem){const c=this.elements.get(m);if(c){const o=this.nodes.get(c);if(o){const t=(d=await this.dataProvider.resolveTreeItem(o.extensionItem,c,v))!==null&&d!==void 0?d:o.extensionItem;return o.item.tooltip=this.getTooltip(t.tooltip),o.item.command=this.getCommand(o.disposableStore,t.command),o.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(v=>v?this.resolveUnknownParentChain(v).then(d=>this.resolveTreeNode(v,d[d.length-1]).then(c=>(d.push(c),d))):Promise.resolve([]))}resolveParent(m){const v=this.nodes.get(m);return v?Promise.resolve(v.parent?this.elements.get(v.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,v){const d=this.nodes.get(m);return d?Promise.resolve(d):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(c=>this.createHandle(m,c,v,!0)).then(c=>this.getChildren(v?v.item.handle:void 0).then(()=>{const o=this.getExtensionElement(c);if(o){const t=this.nodes.get(o);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(m){if(m){let v;if(typeof m=="string"){const d=this.getExtensionElement(m);v=d?this.nodes.get(d):void 0}else v=m;return v&&v.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const v=new _.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=m?this.nodes.get(m):void 0,c=await this.dataProvider.getChildren(m);if(v.token.isCancellationRequested)return[];const o=await Promise.all((0,A.coalesce)(c||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!v.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,d):null}));return v.token.isCancellationRequested?[]:(0,A.coalesce)(o)}finally{v.dispose()}}refresh(m){if(m.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new _.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(m);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const v=new Set;for(const c of m){const o=this.nodes.get(c);if(o&&!v.has(o.item.handle)){let t=o;for(;t&&t.parent&&!v.has(t.parent.item.handle);){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&v.add(o.item.handle)}}const d=[];return v.forEach(c=>{const o=this.elements.get(c);if(o){const t=this.nodes.get(o);t&&(!t.parent||!v.has(t.parent.item.handle))&&d.push(c)}}),d}refreshHandles(m){const v={};return Promise.all(m.map(d=>this.refreshNode(d).then(c=>{c&&(v[d]=c.item)}))).then(()=>Object.keys(v).length?this.proxy.$refresh(this.viewId,v):void 0)}refreshNode(m){const v=this.getExtensionElement(m);if(v){const d=this.nodes.get(v);if(d)return this.clearChildren(v),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(v)).then(c=>{if(c){const o=this.createTreeNode(v,c,d.parent);return this.updateNodeCache(v,o,d,d.parent),d.dispose(),o}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,v,d){const c=this.createTreeNode(m,v,d);if(v.id&&this.elements.has(c.item.handle))throw new Error((0,w.localize)(6,null,v.id));return this.addNodeToCache(m,c),this.addNodeToParentCache(c,d),c}getTooltip(m){return y.MarkdownString.isMarkdownString(m)?k.MarkdownString.from(m):m}getCommand(m,v){return v?this.commands.toInternal(v,m):void 0}createTreeNode(m,v,d){const c=new S.DisposableStore,o=this.createHandle(m,v,d),t=this.getLightIconPath(v);return{item:{handle:o,parentHandle:d?d.item.handle:void 0,label:f(v.label,this.extension),description:v.description,resourceUri:v.resourceUri,tooltip:this.getTooltip(v.tooltip),command:this.getCommand(c,v.command),contextValue:v.contextValue,icon:t,iconDark:this.getDarkIconPath(v)||t,themeIcon:this.getThemeIcon(v),collapsibleState:(0,n.isUndefinedOrNull)(v.collapsibleState)?y.TreeItemCollapsibleState.None:v.collapsibleState,accessibilityInformation:v.accessibilityInformation},extensionItem:v,parent:d,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(m){return m.iconPath instanceof y.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:v,label:d,resourceUri:c},o,t){if(v)return`${h.ID_HANDLE_PREFIX}/${v}`;const i=f(d,this.extension),u=o?o.item.handle:h.LABEL_HANDLE_PREFIX;let l=i?i.label:c?(0,D.basename)(c):"";l=l.indexOf("/")!==-1?l.replace("/","//"):l;const s=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,a=this.getChildrenNodes(o)||[];let E,R=0;do{if(E=`${u}/${R}:${l}`,t||!this.elements.has(E)||s===E)break;R++}while(R<=a.length);return E}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon))return typeof m.iconPath=="string"||T.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof y.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return T.URI.isUri(m)?m:T.URI.file(m)}addNodeToCache(m,v){this.elements.set(v.item.handle,m),this.nodes.set(m,v)}updateNodeCache(m,v,d,c){this.elements.delete(v.item.handle),this.nodes.delete(m),v.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(m,v);const o=this.getChildrenNodes(c)||[],t=o.filter(i=>i.item.handle===d.item.handle)[0];t&&o.splice(o.indexOf(t),1,v)}addNodeToParentCache(m,v){v?(v.children||(v.children=[]),v.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const v=this.nodes.get(m);if(v){if(v.children)for(const d of v.children){const c=this.elements.get(d.item.handle);c&&this.clear(c)}v.children=void 0}}else this.clearAll()}clear(m){const v=this.nodes.get(m);if(v){if(v.children)for(const d of v.children){const c=this.elements.get(d.item.handle);c&&this.clear(c)}this.nodes.delete(m),this.elements.delete(v.item.handle),v.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}h.LABEL_HANDLE_PREFIX="0",h.ID_HANDLE_PREFIX="1"}),define(we[178],Ee([0,1,15,13,44,9]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class S{constructor(){this.testIdsToInternal=new Set}getTestById(r){return(0,w.mapFind)(this.testIdsToInternal,h=>{const p=h.get(r);return p&&[h,p]})}createForHierarchy(r=()=>{}){return new n(this.createIdMap(),r)}createIdMap(){const r=new y;return this.testIdsToInternal.add(r),{object:r,dispose:()=>this.testIdsToInternal.delete(r)}}}e.OwnedTestCollection=S;var I;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));class y{constructor(){this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(r){if(this.map.has(r.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${r.item.extId}`);this.map.set(r.item.extId,r),r.parent||this._roots.add(r)}has(r){return this.map.has(r)}delete(r){const h=this.map.get(r);return h?(this.map.delete(r),this._roots.delete(h),!0):!1}get(r){return this.map.get(r)}comparePositions(r,h){const p=typeof r=="string"?this.map.get(r):r,m=typeof h=="string"?this.map.get(h):h;if(!p||!m)return 0;if(p===m)return 3;for(let v=this.map.get(m.parent);v;v=this.map.get(v.parent))if(v===p)return 1;for(let v=this.map.get(p.parent);v;v=this.map.get(v.parent))if(v===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=y;class n{constructor(r,h){this.testIdToInternal=r,this.publishDiff=h,this.testItemToInternal=new Map,this.diff=[],this.disposed=!1,this.debounceSendDiff=new D.RunOnceScheduler(()=>this.throttleSendDiff(),2)}addRoot(r,h){this.addItem(r,h,null),this.debounceSendDiff.schedule()}getTestByReference(r){return this.testItemToInternal.get(r)}onItemChange(r,h){const p=this.testItemToInternal.get(r);if(!p){this.disposed||console.warn("Received a TestProvider.onDidChangeTest for a test that wasn't seen before as a child.");return}this.addItem(r,h,p.parent),this.debounceSendDiff.schedule()}collectDiff(){const r=this.diff;return this.diff=[],r}pushDiff(r){this.diff.push(r),this.debounceSendDiff.schedule()}dispose(){this.testIdToInternal.dispose(),this.diff=[],this.disposed=!0}addItem(r,h,p){let m=this.testItemToInternal.get(r);if(m)m.previousEquals(r)||(m.item=P.TestItem.from(r),m.previousEquals=_(r),this.diff.push([1,{parent:p,providerId:h,item:m.item}]));else{if(this.testIdToInternal.object.has(r.id))throw new Error(`Attempted to insert a duplicate test item ID ${r.id}`);m={actual:r,parent:p,item:P.TestItem.from(r),providerId:h,previousChildren:new Set,previousEquals:_(r)},this.testIdToInternal.object.add(m),this.testItemToInternal.set(r,m),this.diff.push([0,{parent:p,providerId:h,item:m.item}])}if(r.children){const v=m.previousChildren,d=new Set;for(const c of r.children){const o=this.testIdToInternal.object.get(c.id);o&&o.actual!==c&&this.removeItembyId(c.id);const t=this.addItem(c,h,m.item.extId);v.delete(t.item.extId),d.add(t.item.extId)}for(const c of v)this.removeItembyId(c);m.previousChildren=d}return m}removeItembyId(r){this.diff.push([2,r]);const h=[this.testIdToInternal.object.get(r)];for(;h.length;){const p=h.pop();if(!!p){this.testIdToInternal.object.delete(p.item.extId),this.testItemToInternal.delete(p.actual);for(const m of p.previousChildren)h.push(this.testIdToInternal.object.get(m))}}}throttleSendDiff(){this.flushDiff()}flushDiff(){const r=this.collectDiff();r.length&&this.publishDiff(r)}}je([(0,T.throttle)(200)],n.prototype,"throttleSendDiff",null),e.SingleUseTestCollection=n;const k=Object.keys({id:null,label:null,location:null,debuggable:null,description:null,runnable:null}),_=f=>{const r=[];for(const h of k)r.push(f[h]);return h=>{for(let p=0;p<k.length;p++)if(r[p]!==h[k[p]])return!1;return!0}}}),define(we[179],Ee([0,1,25,3,11]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class P{constructor(A){this.removedDueToLooping=A}}e.DeltaExtensionsResult=P;class S{constructor(A){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=A,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const A of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(A.identifier))){console.error("Extension `"+A.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(A.identifier),A),this._extensionsArr.push(A),Array.isArray(A.activationEvents))for(let k of A.activationEvents)k==="onUri"&&(k=`onUri:${w.ExtensionIdentifier.toKey(A.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(A)}}keepOnly(A){const k=new Set;A.forEach(_=>k.add(w.ExtensionIdentifier.toKey(_))),this._extensionDescriptions=this._extensionDescriptions.filter(_=>k.has(w.ExtensionIdentifier.toKey(_.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(A,k){A.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(A));const _=S._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(_.map(f=>f.identifier)),k.length>0){const f=new Set;k.forEach(r=>f.add(w.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!f.has(w.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new P(_)}static _findLoopingExtensions(A){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,m){this.addNode(p),this.addNode(m),this._arcs.has(p)?this._arcs.get(p).push(m):this._arcs.set(p,[m])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,m){const v=k.getArcs(p);for(let d=0;d<v.length;d++)if(!m.has(v[d]))return!1;return!0}getNodes(){return this._nodesArr}};let _=new Map;for(let p of A){const m=w.ExtensionIdentifier.toKey(p.identifier);if(_.set(m,p),p.extensionDependencies)for(let v of p.extensionDependencies){const d=w.ExtensionIdentifier.toKey(v);k.addArc(m,d)}}let f=new Set;k.getNodes().filter(p=>k.getArcs(p).length===0).forEach(p=>f.add(p));let r=k.getNodes().filter(p=>!f.has(p)),h;do{h=!1;for(let p=0;p<r.length;p++){const m=r[p];k.hasOnlyGoodArcs(m,f)&&(r.splice(p,1),p--,f.add(m),h=!0)}}while(h);return r.map(p=>_.get(p))}containsActivationEvent(A){return this._activationMap.has(A)}containsExtension(A){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(A))}getExtensionDescriptionsForActivationEvent(A){const k=this._activationMap.get(A);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(A){const k=this._extensionsMap.get(w.ExtensionIdentifier.toKey(A));return k||void 0}}e.ExtensionDescriptionRegistry=S;var I;(function(n){n[n.Builtin=0]="Builtin",n[n.User=1]="User",n[n.Dev=2]="Dev"})(I||(I={}));function y(n,A){const k=n.isBuiltin?0:n.isUnderDevelopment?2:1,_=A.isBuiltin?0:A.isUnderDevelopment?2:1;if(k!==_)return k-_;const f=T.posix.basename(n.extensionLocation.path),r=T.posix.basename(A.extensionLocation.path);return f<r?-1:f>r?1:0}}),define(we[180],Ee([0,1,26]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var D;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function P(I){const y=w.VSBuffer.alloc(1);switch(I){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=P;function S(I,y){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=S}),define(we[34],Ee([0,1,3,2,4,25,146]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwRequiresWorkspaceTrustError=e.checkRequiresWorkspaceTrust=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingDependencyError=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new P.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class I{constructor(c){this.dependency=c}}e.MissingDependencyError=I;var y;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(y=e.ExtensionHostKind||(e.ExtensionHostKind={}));class n{constructor(c,o,t,i){this.codeLoadingTime=c,this.activateCallTime=o,this.activateResolvedTime=t,this.activationReason=i}}e.ActivationTimes=n;class A{constructor(c,o){this.description=c,this.value=o}}e.ExtensionPointContribution=A,e.ExtensionHostLogFileName="exthost";var k;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function _(d){d.enableProposedApi||f(d)}e.checkProposedApiEnabled=_;function f(d){throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.throwProposedApiError=f;function r(d){var c;((c=d.workspaceTrust)===null||c===void 0?void 0:c.required)||h(d)}e.checkRequiresWorkspaceTrust=r;function h(d){throw new Error(`[${d.identifier.value}]: This API is only available when the "workspaceTrust.require" is set to "onStart" or "onDemand" in the extension's package.json.`)}e.throwRequiresWorkspaceTrustError=h;function p(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=p;function m(d){return Object.assign(Object.assign({identifier:new P.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!1,extensionLocation:d.location},d.manifest),{uuid:d.identifier.uuid})}e.toExtensionDescription=m;class v{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(c){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c){return Promise.resolve(0)}restartExtensionHost(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(c,o){}_activateById(c,o){return Promise.resolve()}_onWillActivateExtension(c){}_onDidActivateExtension(c,o,t,i,u){}_onExtensionRuntimeError(c,o){}_onExtensionHostExit(c){}}e.NullExtensionService=v}),define(we[181],Ee([0,1,128,25,34,19]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class I{constructor(h,p,m,v){this.startup=h,this.codeLoadingTime=p,this.activateCallTime=m,this.activateResolvedTime=v}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class y{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,p){return h===-1||p===-1?-1:p-h}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class n{constructor(h,p,m,v,d,c){this.activationFailed=h,this.activationFailedError=p,this.activationTimes=m,this.module=v,this.exports=d,this.subscriptions=c}}e.ActivatedExtension=n;class A extends n{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=A;class k extends n{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=k;class _ extends n{constructor(h){super(!0,h,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let f=class{constructor(h,p,m,v,d){this._logService=d,this._registry=h,this._resolvedExtensionsSet=new Set,p.forEach(c=>this._resolvedExtensionsSet.add(D.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,m.forEach(c=>this._hostExtensionsMap.set(D.ExtensionIdentifier.toKey(c),c)),this._host=v,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const p=D.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(p)}getActivatedExtension(h){const p=D.ExtensionIdentifier.toKey(h),m=this._activatedExtensions.get(p);if(!m)throw new Error("Extension `"+h.value+"` is not known or not activated");return m}activateByEvent(h,p){if(this._alreadyActivatedEvents[h])return S;const m=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(m.map(v=>({id:v.identifier,reason:{startup:p,extensionId:v.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,p){const m=this._registry.getExtensionDescription(h);if(!m)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:m.identifier,reason:p}])}_handleActivateRequest(h,p,m){if(this._hostExtensionsMap.has(D.ExtensionIdentifier.toKey(h.id))){p[D.ExtensionIdentifier.toKey(h.id)]=h;return}const v=this._registry.getExtensionDescription(h.id);if(!v){this._host.onExtensionActivationError(h.id,new T.MissingDependencyError(h.id.value));const o=new Error(`Unknown dependency '${h.id.value}'`);this._activatedExtensions.set(D.ExtensionIdentifier.toKey(h.id),new _(o));return}const d=typeof v.extensionDependencies=="undefined"?[]:v.extensionDependencies;let c=!0;for(let o=0,t=d.length;o<t;o++){const i=d[o];if(!this._resolvedExtensionsSet.has(D.ExtensionIdentifier.toKey(i))){const u=this._activatedExtensions.get(D.ExtensionIdentifier.toKey(i));if(!(u&&!u.activationFailed)){if(u&&u.activationFailed){this._host.onExtensionActivationError(v.identifier,w.localize(0,null,v.displayName||v.identifier.value,i));const a=new Error(`Dependency ${i} failed to activate`);a.detail=u.activationFailedError,this._activatedExtensions.set(D.ExtensionIdentifier.toKey(v.identifier),new _(a));return}if(this._hostExtensionsMap.has(D.ExtensionIdentifier.toKey(i))){c=!1,p[D.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(D.ExtensionIdentifier.toKey(i)),reason:h.reason};continue}const l=this._registry.getExtensionDescription(i);if(l){c=!1,p[D.ExtensionIdentifier.toKey(i)]={id:l.identifier,reason:h.reason};continue}this._host.onExtensionActivationError(v.identifier,new T.MissingDependencyError(i));const s=new Error(`Unknown dependency '${i}'`);this._activatedExtensions.set(D.ExtensionIdentifier.toKey(v.identifier),new _(s));return}}}c?p[D.ExtensionIdentifier.toKey(v.identifier)]=h:m.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(d=>!this._activatedExtensions.has(D.ExtensionIdentifier.toKey(d.id))),h.length===0))return Promise.resolve(void 0);const p=Object.create(null),m=[];for(let d=0,c=h.length;d<c;d++)this._handleActivateRequest(h[d],p,m);for(let d=0,c=m.length;d<c;d++){const o=D.ExtensionIdentifier.toKey(m[d].id);p[o]&&delete p[o]}const v=Object.keys(p).map(d=>p[d]);return m.length===0?Promise.all(v.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(v).then(d=>this._activateExtensions(m))}_activateExtension(h,p){const m=D.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(m))return Promise.resolve(void 0);const v=this._activatingExtensions.get(m);if(v)return v;const d=this._host.actualActivateExtension(h,p).then(void 0,c=>(this._host.onExtensionActivationError(h,w.localize(1,null,h.value,c.message)),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(c),new _(c))).then(c=>{this._activatedExtensions.set(m,c),this._activatingExtensions.delete(m)});return this._activatingExtensions.set(m,d),d}};f=je([qe(4,P.ILogService)],f),e.ExtensionsActivator=f}),define(we[182],Ee([0,1,10]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class D{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((P,S)=>{this._actualOk=P,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(P){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=P,this._actual&&this._actualOk(P))}resolveErr(P){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=P,this._actual?this._actualErr(P):(0,w.onUnexpectedError)(P))}then(P,S){return this._ensureActual().then(P,S)}catch(P){return this._ensureActual().then(void 0,P)}finally(P){return this._ensureActual().finally(P)}}e.LazyPromise=D}),define(we[96],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(y,n){this.isMain=y,this.sid=n,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const D=[];function T(I){const y=new w(!0,I);return D[y.nid]=y,y}e.createMainContextProxyIdentifier=T;function P(I){const y=new w(!1,I);return D[y.nid]=y,y}e.createExtHostContextProxyIdentifier=P;function S(I){return D[I].sid}e.getStringIdentifierForProxy=S}),define(we[5],Ee([0,1,2,96,57]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var P;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(P=e.UIKind||(e.UIKind={}));var S;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(d){d[d.Editable=0]="Editable",d[d.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(d){d[d.Markdown=1]="Markdown",d[d.Code=2]="Code"})(y=e.CellKind||(e.CellKind={}));var n;(function(d){d[d.Text=1]="Text",d[d.Error=2]="Error",d[d.Rich=3]="Rich"})(n=e.CellOutputKind||(e.CellOutputKind={}));var A;(function(d){d[d.Default=0]="Default",d[d.InCenter=1]="InCenter",d[d.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",d[d.AtTop=3]="AtTop"})(A=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(d){d[d.None=0]="None",d[d.Process=1]="Process",d[d.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var _;(function(d){d.name="$ident";function c(t,i){return Object.defineProperty(t,d.name,{value:i,enumerable:!0}),t}d.mixin=c;function o(t){return t[d.name]}d.of=o})(_=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(c){return c._id=f._n++,c}}e.IdObject=f,f._n=0;var r;(function(d){d.label="a",d.kind="b",d.detail="c",d.documentation="d",d.sortText="e",d.filterText="f",d.preselect="g",d.insertText="h",d.insertTextRules="i",d.range="j",d.commitCharacters="k",d.additionalTextEdits="l",d.command="m",d.kindModifier="n",d.label2="o"})(r=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(d){d.defaultRanges="a",d.completions="b",d.isIncomplete="c",d.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(d){d[d.File=1]="File",d[d.Text=2]="Text",d[d.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(d){if(d&&d.edits)for(const c of d.edits)typeof c.resource=="object"?c.resource=w.URI.revive(c.resource):(c.newUri=w.URI.revive(c.newUri),c.oldUri=w.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,T.revive)(c.metadata));return d}e.reviveWorkspaceEditDto=m;var v;(function(d){d[d.Workspace=0]="Workspace",d[d.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[71],Ee([0,1,5,3,4]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class P{constructor(I){this._onDidChangePassword=new D.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,y){return this._proxy.$getPassword(I,y)}store(I,y,n){return this._proxy.$setPassword(I,y,n)}delete(I,y){return this._proxy.$deletePassword(I,y)}}e.ExtHostSecretState=P,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")}),define(we[72],Ee([0,1,4,19,5,14]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,n){this._extHostLogService=n,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,n,A){const k=this.getUsageKey(y,n);this._reportedUsages.has(k)||(this._reportedUsages.add(k),n.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${A}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:n.identifier.value,apiId:y}))}getUsageKey(y,n){return`${y}-${n.identifier.value}`}};S=je([qe(0,P.IExtHostRpcService),qe(1,D.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(I,y,n){}})}),define(we[183],Ee([0,1,3,5,7,25]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(D.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(y,n,A,k={}){const _=P.ExtensionIdentifier.toKey(y.identifier),f=this._inFlightRequests.get(_)||[],r=A.sort().join(" ");let h=f.find(p=>p.scopes===r);if(h)return h.result;{const p=this._getSession(y,_,n,A,k);h={scopes:r,result:p},f.push(h),this._inFlightRequests.set(_,f);try{await p}finally{const m=f.findIndex(v=>v.scopes===r);m>-1&&(f.splice(m),this._inFlightRequests.set(_,f))}return p}}async _getSession(y,n,A,k,_={}){await this._proxy.$ensureProvider(A);const f=y.displayName||y.name;return this._proxy.$getSession(A,k,n,f,_)}async removeSession(y,n){const A=this._authenticationProviders.get(y);return A?A.provider.removeSession(n):this._proxy.$removeSession(y,n)}registerAuthenticationProvider(y,n,A,k){var _;if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:n,provider:A,options:k!=null?k:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===y)||this._providers.push({id:y,label:n});const f=A.onDidChangeSessions(r=>{var h,p,m;this._proxy.$sendDidChangeSessions(y,{added:(h=r.added)!==null&&h!==void 0?h:[],changed:(p=r.changed)!==null&&p!==void 0?p:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(y,n,(_=k==null?void 0:k.supportsMultipleAccounts)!==null&&_!==void 0?_:!1),new T.Disposable(()=>{f.dispose(),this._authenticationProviders.delete(y);const r=this._providers.findIndex(h=>h.id===y);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,n){const A=this._authenticationProviders.get(y);if(A)return Promise.resolve(A.provider.createSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,n){const A=this._authenticationProviders.get(y);if(A)return Promise.resolve(A.provider.removeSession(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,n){const A=this._authenticationProviders.get(y);if(A)return Promise.resolve(A.provider.getSessions(n));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,n){return this._onDidChangeSessions.fire({provider:{id:y,label:n}}),Promise.resolve()}$onDidChangeAuthenticationProviders(y,n){return y.forEach(A=>{this._providers.some(k=>k.id===A.id)||this._providers.push(A)}),n.forEach(A=>{const k=this._providers.findIndex(_=>_.id===A.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:y,removed:n}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(we[184],Ee([0,1,5,14,9]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let P=class{constructor(I,y){this._extHostDocumentsAndEditors=y,this._proxy=I.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const y=T.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};P=je([qe(0,D.IExtHostRpcService)],P),e.ExtHostBulkEdits=P}),define(we[185],Ee([0,1,5]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class D{constructor(P){const S=P.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(I){return S.$writeText(I)}})}}e.ExtHostClipboard=D}),define(we[73],Ee([0,1,12,7,9,23,5,15,19,57,33,39,2,6,4,14]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let p=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=i,this.converter=new m(this,u=>{const l=this._apiCommands.get(u);return(l==null?void 0:l.result)===d.Void?l:void 0},i),this._argumentProcessors=[{processArgument(u){return(0,n.revive)(u)}},{processArgument(u){return(0,P.cloneAndChange)(u,function(l){if(A.Range.isIRange(l))return T.Range.to(l);if(k.Position.isIPosition(l))return T.Position.to(l);if(A.Range.isIRange(l.range)&&_.URI.isUri(l.uri))return T.location.to(l);if(!Array.isArray(l))return l})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...u)=>{const l=t.args.map((a,E)=>{if(!a.validate(u[E]))throw new Error(`Invalid argument '${a.name}' when running '${t.id}', received: ${u[E]}`);return a.convert(u[E])}),s=await this.executeCommand(t.internalId,...l);return t.result.convert(s,u,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new D.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,u,l,s){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:u,thisArg:l,description:s}),t&&this._proxy.$registerCommand(i),new D.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,u){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const l=(0,P.cloneAndChange)(i,function(s){if(s instanceof D.Position)return T.Position.from(s);if(s instanceof D.Range)return T.Range.from(s);if(s instanceof D.Location)return T.location.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,l,u);return(0,n.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw s}}}async _executeContributedCommand(t,i){const u=this._commands.get(t);if(!u)throw new Error("Unknown command");let{callback:l,thisArg:s,description:a}=u;if(a)for(let E=0;E<a.args.length;E++)try{(0,w.validateConstraint)(i[E],a.args[E].constraint)}catch(R){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${a.args[E].name}' - ${a.args[E].description}`)}try{return await l.apply(s,i)}catch(E){if(t===this.converter.delegatingCommandId){const R=this.converter.getActualCommand(...i);R&&(t=R.command)}throw this._logService.error(E,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(u=>this._argumentProcessors.reduce((l,s)=>s.processArgument(l),u)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(u=>u[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,u]of this._commands){let{description:l}=u;l&&(t[i]=l)}return Promise.resolve(t)}};p=je([qe(0,h.IExtHostRpcService),qe(1,y.ILogService)],p),e.ExtHostCommands=p,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,i,u){this._commands=t,this._lookupApiCommand=i,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!!t){const u={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return u;const l=this._lookupApiCommand(t.command);if(l)u.id=l.internalId,u.arguments=l.args.map((s,a)=>s.convert(t.arguments&&t.arguments[a]));else if((0,I.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),i.add((0,f.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),u.$ident=s,u.id=this.delegatingCommandId,u.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return u}}fromInternal(t){const i=S.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class v{constructor(t,i,u,l){this.name=t,this.description=i,this.validate=u,this.convert=l}optional(){return new v(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new v(t!=null?t:this.name,i!=null?i:this.description,this.validate,this.convert)}}e.ApiCommandArgument=v,v.Uri=new v("uri","Uri of a text document",o=>_.URI.isUri(o),o=>o),v.Position=new v("position","A position in a text document",o=>D.Position.isPosition(o),T.Position.from),v.Range=new v("range","A range in a text document",o=>D.Range.isRange(o),T.Range.from),v.Selection=new v("selection","A selection in a text document",o=>D.Selection.isSelection(o),T.Selection.from),v.Number=new v("number","",o=>typeof o=="number",o=>o),v.String=new v("string","",o=>typeof o=="string",o=>o),v.CallHierarchyItem=new v("item","A call hierarchy item",o=>o instanceof D.CallHierarchyItem,T.CallHierarchyItem.to);class d{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=d,d.Void=new d("no result",o=>o);class c{constructor(t,i,u,l,s){this.id=t,this.internalId=i,this.description=u,this.args=l,this.result=s}}e.ApiCommand=c}),define(we[186],Ee([0,1,6,9,7,62,73,163,15,84]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const A=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",_(D.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",(r,h)=>{if(!(0,y.isFalsyOrEmpty)(r)){class p extends T.SymbolInformation{static to(v){const d=new p(v.name,D.SymbolKind.to(v.kind),v.containerName||"",new T.Location(h[0],D.Range.to(v.range)));return d.detail=v.detail,d.range=d.location.range,d.selectionRange=D.Range.to(v.selectionRange),d.children=v.children?v.children.map(p.to):[],d}}return r.map(p.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(D.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(D.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(D.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(D.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(D.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(h=>T.Position.isPosition(h)),r=>r.map(D.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(h=>{let p;for(const m of h.reverse())p=new T.SelectionRange(D.Range.to(m),p);return p}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const h=[];if(Array.isArray(r))for(let p of r)h.push(...p[1].map(D.WorkspaceSymbol.to));return h})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(D.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(D.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(D.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return D.WorkspaceEdit.to(r)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(D.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new T.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const h=(0,n.decodeSemanticTokensDto)(r);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new T.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const h=(0,n.decodeSemanticTokensDto)(r);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,h,p)=>{if(!r)return new T.CompletionList([]);const m=r.suggestions.map(v=>D.CompletionItem.to(v,p));return new T.CompletionList(m,r.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return D.SignatureHelp.to(r)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,h,p)=>_(m=>new T.CodeLens(D.Range.to(m.range),m.command&&p.fromInternal(m.command)))(r))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>T.Range.isRange(r),r=>T.Selection.isSelection(r)?D.Selection.from(r):D.Range.from(r)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,h,p)=>_(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return p.fromInternal(m.command)}else{const v=new T.CodeAction(m.title,m.kind?new T.CodeActionKind(m.kind):void 0);return m.edit&&(v.edit=D.WorkspaceEdit.to(m.edit)),m.command&&(v.command=p.fromInternal(m.command)),v.isPreferred=m.isPreferred,v}})(r))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(h=>new T.ColorInformation(D.Range.to(h.range),D.Color.to(h.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",r=>r instanceof T.Color,D.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:D.Range.from(r.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(D.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlineHintProvider","_executeInlineHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineHint objects",r=>r.map(D.InlineHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientMetadata:r.options.transientMetadata},filenamePattern:r.filenamePattern.map(h=>D.NotebookExclusiveDocumentPattern.to(h))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(D.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[D.ViewColumn.from(r.viewColumn),D.TextEditorOpenOptions.from(r)]).optional()],S.ApiCommandResult.Void)];class k{constructor(h){this._disposables=new w.DisposableStore,this._commands=h}static register(h){return A.forEach(h.registerApiCommand,h),new k(h).registerCommands()}registerCommands(){const h=p=>(...m)=>p(this._commands,...m);this._register(I.RemoveFromRecentlyOpenedAPICommand.ID,h(I.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:p=>typeof p=="string"}]}),this._register(I.OpenIssueReporter.ID,h(I.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:p=>typeof p=="string"||typeof p=="object"&&typeof p.extensionId=="string"}]})}_register(h,p,m){const v=this._commands.registerCommand(!1,h,p,this,m);this._disposables.add(v)}}e.ExtHostApiCommands=k;function _(r){return h=>{if(Array.isArray(h))return h.map(r)}}function f(r){if(!!Array.isArray(r)){const h=[];for(const p of r)P.isLocationLink(p)?h.push(D.DefinitionLink.to(p)):h.push(D.location.to(p));return h}}}),define(we[187],Ee([0,1,13,44,3,6,2,62,25,9,7,5]),function(oe,e,w,D,T,P,S,I,y,n,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class _{constructor(c,o,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=c.getProxy(k.MainContext.MainThreadComments),o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const u=this._commentControllers.get(i.handle);return u||i}else if(i&&i.$mid===7){const u=this._commentControllers.get(i.commentControlHandle);if(!u)return i;const l=u.getCommentThread(i.commentThreadHandle);return l||i}else if(i&&i.$mid===8){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const l=u.getCommentThread(i.thread.commentThreadHandle);return l?{thread:l,text:i.text}:i}else if(i&&i.$mid===9){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const l=u.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let s=i.commentUniqueId,a=l.getCommentByUniqueId(s);return a||i}else if(i&&i.$mid===10){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const l=u.getCommentThread(i.thread.commentThreadHandle);if(!l)return i;let s=i.text,a=i.commentUniqueId,E=l.getCommentByUniqueId(a);return E?(E.body=s,E):i}return i}})}createCommentController(c,o,t){const i=_.handlePool++,u=new r(c,i,this._proxy,o,t);this._commentControllers.set(u.handle,u);const l=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return l.push(u),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(c.identifier),l),u}$createCommentThreadTemplate(c,o,t){const i=this._commentControllers.get(c);!i||i.$createCommentThreadTemplate(o,t)}async $updateCommentThreadTemplate(c,o,t){const i=this._commentControllers.get(c);!i||i.$updateCommentThreadTemplate(o,t)}$deleteCommentThread(c,o){const t=this._commentControllers.get(c);t&&t.$deleteCommentThread(o)}$provideCommentingRanges(c,o,t){const i=this._commentControllers.get(c);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const u=this._documents.getDocument(S.URI.revive(o));return(0,w.asPromise)(()=>i.commentingRangeProvider.provideCommentingRanges(u,t)).then(l=>l?l.map(s=>n.Range.from(s)):void 0)}$toggleReaction(c,o,t,i,u){const l=this._commentControllers.get(c);return!l||!l.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const s=l.getCommentThread(o);if(s){const a=s.getCommentByUniqueId(i.uniqueIdInThread);if(l!==void 0&&a&&l.reactionHandler)return l.reactionHandler(a,m(u))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=_,_.handlePool=0;class f{constructor(c,o,t,i,u,l,s){this._proxy=c,this._commentController=o,this._id=t,this._uri=i,this._range=u,this._comments=l,this.handle=f._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new T.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputDisposables.value=new P.DisposableStore,this._id===void 0&&(this._id=`${o.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,n.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=l}set threadId(c){this._id=c}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(c){c.isEqual(this._range)||(this._range=c,this.modifications.range=c,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(c){this._canReply!==c&&(this._canReply=c,this.modifications.canReply=c,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(c){this._label=c,this.modifications.label=c,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(c){this._contextValue=c,this.modifications.contextValue=c,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(c){this._comments=c,this.modifications.comments=c,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(c){this._collapseState=c,this.modifications.collapsibleState=c,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new P.DisposableStore);const c=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),o={};c("range")&&(o.range=n.Range.from(this._range)),c("label")&&(o.label=this.label),c("contextValue")&&(o.contextValue=this.contextValue),c("comments")&&(o.comments=this._comments.map(t=>h(this,this._commentController,t,this._commentsMap))),c("collapsibleState")&&(o.collapseState=v(this._collapseState)),c("canReply")&&(o.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,o)}}getCommentByUniqueId(c){for(let o of this._commentsMap){let t=o[0],i=o[1];if(c===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(c=>c.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}f._handlePool=0,je([(0,D.debounce)(100)],f.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=f;class r{constructor(c,o,t,i,u){this._extension=c,this._handle=o,this._proxy=t,this._id=i,this._label=u,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,u)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(c){this._reactionHandler=c,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this._options}set options(c){this._options=c,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(c,o,t,i){if(typeof c=="string"){const u=new f(this._proxy,this,c,o,t,i,this._extension.identifier);return this._threads.set(u.handle,u),u}else{const u=new f(this._proxy,this,void 0,c,o,t,this._extension.identifier);return this._threads.set(u.handle,u),u}}$createCommentThreadTemplate(c,o){const t=new f(this._proxy,this,void 0,S.URI.revive(c),n.Range.to(o),[],this._extension.identifier);return t.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(c,o){let t=this._threads.get(c);t&&(t.range=n.Range.to(o))}$deleteCommentThread(c){let o=this._threads.get(c);o&&o.dispose(),this._threads.delete(c)}getCommentThread(c){return this._threads.get(c)}dispose(){this._threads.forEach(c=>{c.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function h(d,c,o,t){let i=t.get(o);i||(i=++d.commentHandle,t.set(o,i));const u=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:i,body:n.MarkdownString.from(o.body),userName:o.author.name,userIconPath:u,label:o.label,commentReactions:o.reactions?o.reactions.map(l=>p(l)):void 0}}function p(d){return{label:d.label,iconPath:d.iconPath?n.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function m(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?S.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function v(d){if(d!==void 0)switch(d){case A.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}}),define(we[97],Ee([0,1,2,5,7,4,14,19,15,8,11]),function(oe,e,w,D,T,P,S,I,y,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class on{constructor(f,r){this._logService=r,this._provider=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,r){const h=on._handlePool++;this._provider.set(h,{provider:f,extensionId:r}),this._proxy.$registerDecorationProvider(h,r.value);const p=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(h,null);return}let v=(0,y.asArray)(m);if(v.length<=on._maxEventSize){this._proxy.$onDidChange(h,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,v.length);const d=v.map(t=>({uri:t,rank:(0,n.count)(t.path,"/")})),c=(0,y.groupBy)(d,(t,i)=>t.rank-i.rank||(0,n.compare)(t.uri.path,i.uri.path));let o=[];e:for(let t of c){let i;for(let u of t){let l=(0,A.dirname)(u.uri.path);if(i!==l&&(i=l,o.push(u.uri)>=on._maxEventSize))break e}}this._proxy.$onDidChange(h,o)});return new T.Disposable(()=>{p==null||p.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(f,r,h){if(!this._provider.has(f))return Object.create(null);const p=Object.create(null),{provider:m,extensionId:v}=this._provider.get(f);return await Promise.all(r.map(async d=>{try{const{uri:c,id:o}=d,t=await Promise.resolve(m.provideFileDecoration(w.URI.revive(c),h));if(!t)return;try{T.FileDecoration.validate(t),p[o]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${v.value}': ${i}`)}}catch(c){this._logService.error(c)}})),p}};k._handlePool=0,k._maxEventSize=250,k=je([qe(0,S.IExtHostRpcService),qe(1,I.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=(0,P.createDecorator)("IExtHostDecorations")}),define(we[188],Ee([0,1,127,87,2,5,7,9,3,19,22]),function(oe,e,w,D,T,P,S,I,y,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(r,h,p,m,v){this._name=r,this._owner=h,this._maxDiagnosticsPerFile=p,this._proxy=m,this._onDidChangeDiagnostics=v,this._isDisposed=!1,this._data=new A.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,h){if(!r){this.clear();return}this._checkDisposed();let p=[];if(T.URI.isUri(r)){if(!h){this.delete(r);return}this._data.set(r,h.slice()),p=[r]}else if(Array.isArray(r)){p=[];let v;r=[...r].sort(k._compareIndexedTuplesByUri);for(const d of r){const[c,o]=d;if((!v||c.toString()!==v.toString())&&(v&&this._data.get(v).length===0&&this._data.delete(v),v=c,p.push(c),this._data.set(c,[])),o){const t=this._data.get(c);t&&t.push(...o)}else{const t=this._data.get(c);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(p),!!this._proxy){const m=[];for(let v of p){let d=[];const c=this._data.get(v);if(c)if(c.length>this._maxDiagnosticsPerFile){d=[];const o=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of c)if(i.severity===o[t]&&d.push(I.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;d.push({severity:D.MarkerSeverity.Info,message:(0,w.localize)(0,null,c.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=c.map(o=>I.Diagnostic.from(o));m.push([v,d])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,h){this._checkDisposed();for(let p of this._data.keys())r.apply(h,[p,this.get(p),this])}get(r){this._checkDisposed();const h=this._data.get(r);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,h){return r[0].toString()<h[0].toString()?-1:r[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=k;let _=class Nt{constructor(r,h){this._logService=h,this._collections=new Map,this._onDidChangeDiagnostics=new y.Emitter,this.onDidChangeDiagnostics=y.Event.map(y.Event.debounce(this._onDidChangeDiagnostics.event,Nt._debouncer,50),Nt._mapper),this._proxy=r.getProxy(P.MainContext.MainThreadDiagnostics)}static _debouncer(r,h){return r?r.concat(h):h}static _mapper(r){const h=[],p=new Set;for(const m of r)typeof m=="string"?p.has(m)||(p.add(m),h.push(T.URI.parse(m))):p.has(m.toString())||(p.add(m.toString()),h.push(m));return Object.freeze(h),{uris:h}}createDiagnosticCollection(r,h){const{_collections:p,_proxy:m,_onDidChangeDiagnostics:v,_logService:d}=this,c=new class{$changeMany(i,u){m.$changeMany(i,u),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,i,u.length===0?"CLEARING":u)}$clear(i){m.$clear(i),d.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,i)}dispose(){m.dispose()}};let o;if(!h)h="_generated_diagnostic_collection_name_#"+Nt._idPool++,o=h;else if(!p.has(h))o=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do o=h+Nt._idPool++;while(p.has(o))}return new class extends k{constructor(){super(h,o,Nt._maxDiagnosticsPerFile,c,v);p.set(o,this)}dispose(){super.dispose(),p.delete(o)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const h=new Map,p=[];for(const m of this._collections.values())m.forEach((v,d)=>{let c=h.get(v.toString());typeof c=="undefined"&&(c=p.length,h.set(v.toString(),c),p.push([v,[]])),p[c][1]=p[c][1].concat(...d)});return p}}_getDiagnostics(r){let h=[];for(let p of this._collections.values())p.has(r)&&(h=h.concat(p.get(r)));return h}$acceptMarkersChange(r){if(!this._mirrorCollection){const h="_generated_mirror",p=new k(h,h,Nt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(h,p),this._mirrorCollection=p}for(const[h,p]of r)this._mirrorCollection.set(T.URI.revive(h),p.map(I.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=je([qe(1,n.ILogService)],_),e.ExtHostDiagnostics=_}),define(we[189],Ee([0,1,2,5]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(S){this._proxy=S.getProxy(D.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(I=>I?I.map(y=>w.URI.revive(y)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(I=>I?w.URI.revive(I):void 0)}}e.ExtHostDialogs=T}),define(we[190],Ee([0,1,10,2,7,5,16,20,8]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class n{constructor(k,_,f){this._documentsAndEditors=_,this._logService=f,this._documentContentProviders=new Map,this._proxy=k.getProxy(P.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,_){if(Object.keys(S.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const f=n._handlePool++;this._documentContentProviders.set(f,_),this._proxy.$registerTextContentProvider(f,k);let r;return typeof _.onDidChange=="function"&&(r=_.onDidChange(h=>{if(h.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(f,h).then(p=>{if(!(!p&&typeof p!="string")){const m=this._documentsAndEditors.getDocument(h);if(!!m){const v=(0,y.splitLines)(p);if(!m.equalLines(v))return this._proxy.$onVirtualDocumentChange(h,p)}}},w.onUnexpectedError)})),new T.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(k,_){const f=this._documentContentProviders.get(k);return f?Promise.resolve(f.provideTextDocumentContent(D.URI.revive(_),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${_.scheme}`))}}e.ExtHostDocumentContentProvider=n,n._handlePool=0}),define(we[191],Ee([0,1,3,6,2,5,94,9,12,23]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(_,f){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new D.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(P.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const h of r)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const h of r)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!!_){const f=this._documentsAndEditors.getDocument(_);if(f)return f}}getDocument(_){const f=this.getDocumentData(_);if(!(f==null?void 0:f.document))throw new Error(`Unable to retrieve document from URI '${_}'`);return f.document}ensureDocumentData(_){const f=this._documentsAndEditors.getDocument(_);if(f)return Promise.resolve(f);let r=this._documentLoader.get(_.toString());return r||(r=this._proxy.$tryOpenDocument(_).then(h=>{this._documentLoader.delete(_.toString());const p=T.URI.revive(h);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(p))},h=>(this._documentLoader.delete(_.toString()),Promise.reject(h))),this._documentLoader.set(_.toString(),r)),r}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(f=>T.URI.revive(f))}$acceptModelModeChanged(_,f){const r=T.URI.revive(_),h=this._documentsAndEditors.getDocument(r);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(_){const f=T.URI.revive(_),r=this._documentsAndEditors.getDocument(f);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(_,f){const r=T.URI.revive(_),h=this._documentsAndEditors.getDocument(r);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[]})}$acceptModelChanged(_,f,r){const h=T.URI.revive(_),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");p._acceptIsDirty(r),p.onEvents(f),this._onDidChangeDocument.fire((0,n.deepFreeze)({document:p.document,contentChanges:f.changes.map(m=>({range:I.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(_,f){(0,S.setWordDefinitionFor)(_,f)}}e.ExtHostDocuments=A}),define(we[40],Ee([0,1,43,3,6,2,4,5,94,14,95,9,19,22,16,54,105]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(c,o){this._extHostRpc=c,this._logService=o,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new D.Emitter,this._onDidRemoveDocuments=new D.Emitter,this._onDidChangeVisibleTextEditors=new D.Emitter,this._onDidChangeActiveTextEditor=new D.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const o=[],t=[],i=[];if(c.removedDocuments)for(const u of c.removedDocuments){const l=P.URI.revive(u),s=this._documents.get(l);(s==null?void 0:s.unref())&&(this._documents.delete(l),o.push(s.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const l=P.URI.revive(u.uri);let s=this._documents.get(l);if(s&&l.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${l} already exists!'`);s||(s=new m(new y.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),l,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(l,s),t.push(s.value)),s.ref()}if(c.removedEditors)for(const u of c.removedEditors){const l=this._editors.get(u);this._editors.delete(u),l&&i.push(l)}if(c.addedEditors)for(const u of c.addedEditors){const l=P.URI.revive(u.documentUri);w.ok(this._documents.has(l),`document '${l}' does not exist`),w.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const s=this._documents.get(l).value,a=new A.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>s.document),u.selections.map(k.Selection.to),u.options,u.visibleRanges.map(E=>k.Range.to(E)),typeof u.editorPosition=="number"?k.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,a)}c.newActiveEditor!==void 0&&(w.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,T.dispose)(o),(0,T.dispose)(i),c.removedDocuments&&this._onDidRemoveDocuments.fire(o),c.addedDocuments&&this._onDidAddDocuments.fire(t),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){var o;return(o=this._documents.get(c))===null||o===void 0?void 0:o.value}allDocuments(){return h.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!!this._activeEditorId){const o=this._editors.get(this._activeEditorId);return c?o:o==null?void 0:o.value}}allEditors(){return[...this._editors.values()]}};v=je([qe(0,n.IExtHostRpcService),qe(1,_.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[192],Ee([0,1,2,5,6,7,9,115,8,26]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class A{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const r=this._schemes.indexOf(f);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),r=[];let h,p,m=14,v=14;for(const d of f){let c=h?(0,y.commonPrefixLength)(h,d):0;for(c===0?p=1:p=v;c<d.length;c++)c+1===d.length?(m=v,v=9):v+=1,r.push([p,d.toUpperCase().charCodeAt(c),v]),r.push([p,d.toLowerCase().charCodeAt(c),v]),p=v;h=d,v=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new I.StateMachine(r)}}provideDocumentLinks(f){this._initStateMachine();const r=[],h=I.LinkComputer.computeLinks({getLineContent(p){return f.lineAt(p-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const p of h){const m=S.DocumentLink.to(p);m.target&&r.push(m)}return r}}class k{constructor(f,r){this._extHostLanguageFeatures=r,this._linkProvider=new A,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(D.MainContext.MainThreadFileSystem)}dispose(){var f;(f=this._linkProviderRegistration)===null||f===void 0||f.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(f,r,h,p={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(m,h);let v=2;p.isCaseSensitive&&(v+=1024),p.isReadonly&&(v+=2048),typeof h.copy=="function"&&(v+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&(v+=4),this._proxy.$registerFileSystemProvider(m,r,v).catch(c=>{console.error(`FAILED to register filesystem provider of ${f.value}-extension for the scheme ${r}`),console.error(c)});const d=h.onDidChangeFile(c=>{const o=[];for(const t of c){let{uri:i,type:u}=t;if(i.scheme===r){let l;switch(u){case P.FileChangeType.Changed:l=0;break;case P.FileChangeType.Created:l=1;break;case P.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}o.push({resource:i,type:l})}}this._proxy.$onFileSystemChange(m,o)});return(0,T.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(f){const{type:r,ctime:h,mtime:p,size:m}=f;return{type:r,ctime:h,mtime:p,size:m}}$stat(f,r){return Promise.resolve(this._getFsProvider(f).stat(w.URI.revive(r))).then(k._asIStat)}$readdir(f,r){return Promise.resolve(this._getFsProvider(f).readDirectory(w.URI.revive(r)))}$readFile(f,r){return Promise.resolve(this._getFsProvider(f).readFile(w.URI.revive(r))).then(h=>n.VSBuffer.wrap(h))}$writeFile(f,r,h,p){return Promise.resolve(this._getFsProvider(f).writeFile(w.URI.revive(r),h.buffer,p))}$delete(f,r,h){return Promise.resolve(this._getFsProvider(f).delete(w.URI.revive(r),h))}$rename(f,r,h,p){return Promise.resolve(this._getFsProvider(f).rename(w.URI.revive(r),w.URI.revive(h),p))}$copy(f,r,h,p){const m=this._getFsProvider(f);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(w.URI.revive(r),w.URI.revive(h),p))}$mkdir(f,r){return Promise.resolve(this._getFsProvider(f).createDirectory(w.URI.revive(r)))}$watch(f,r,h,p){const m=this._getFsProvider(f).watch(w.URI.revive(h),p);this._watches.set(r,m)}$unwatch(f,r){const h=this._watches.get(r);h&&(h.dispose(),this._watches.delete(r))}$open(f,r,h){const p=this._getFsProvider(f);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(w.URI.revive(r),h))}$close(f,r){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(r))}$read(f,r,h,p){const m=this._getFsProvider(f);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const v=n.VSBuffer.alloc(p);return Promise.resolve(m.read(r,h,v.buffer,0,p)).then(d=>v.slice(0,d))}$write(f,r,h,p){const m=this._getFsProvider(f);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,h,p.buffer,0,p.byteLength))}_getFsProvider(f){const r=this._fsProvider.get(f);if(!r){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return r}}e.ExtHostFileSystem=k}),define(we[74],Ee([0,1,5,64,7,26,4,14,49]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let n=class Tt{constructor(k,_){const f=k.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return f.$stat(r).catch(Tt._handleError)},readDirectory(r){return f.$readdir(r).catch(Tt._handleError)},createDirectory(r){return f.$mkdir(r).catch(Tt._handleError)},async readFile(r){return f.$readFile(r).then(h=>h.buffer).catch(Tt._handleError)},writeFile(r,h){return f.$writeFile(r,P.VSBuffer.wrap(h)).catch(Tt._handleError)},delete(r,h){return f.$delete(r,Object.assign({recursive:!1,useTrash:!1},h)).catch(Tt._handleError)},rename(r,h,p){return f.$rename(r,h,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},copy(r,h,p){return f.$copy(r,h,Object.assign({overwrite:!1},p)).catch(Tt._handleError)},isWritableFileSystem(r){const h=_.getCapabilities(r);if(typeof h=="number")return!(h&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new T.FileSystemError(String(k));if(k.name==="ENOPRO")throw T.FileSystemError.Unavailable(k.message);switch(k.name){case D.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(k.message);case D.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(k.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(k.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(k.message);case D.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(k.message);case D.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(k.message);default:throw new T.FileSystemError(k.message,k.name)}}};n=je([qe(0,I.IExtHostRpcService),qe(1,y.IExtHostFileSystemInfo)],n),e.ExtHostConsumerFileSystem=n,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(we[193],Ee([0,1,6,5]),function(oe,e,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(S){this._handlePool=0,this._proxy=S.getProxy(D.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,S),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=T}),define(we[194],Ee([0,1,2,23,9,7,13,5,8,33,15,12,112,6,84,53,92,55,10]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(W,K){this._documents=W,this._provider=K}provideDocumentSymbols(W,K){const J=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(J,K)).then(ae=>{if(!(0,A.isFalsyOrEmpty)(ae))return ae[0]instanceof P.DocumentSymbol?ae.map(T.DocumentSymbol.from):d._asDocumentSymbolTree(ae)})}static _asDocumentSymbolTree(W){var K;W=W.slice(0).sort((ge,De)=>{let Le=ge.location.range.start.compareTo(De.location.range.start);return Le===0&&(Le=De.location.range.end.compareTo(ge.location.range.end)),Le});const J=[],ae=[];for(const ge of W){const De={name:ge.name||"!!MISSING: name!!",kind:T.SymbolKind.from(ge.kind),tags:((K=ge.tags)===null||K===void 0?void 0:K.map(T.SymbolTag.from))||[],detail:"",containerName:ge.containerName,range:T.Range.from(ge.location.range),selectionRange:T.Range.from(ge.location.range),children:[]};for(;;){if(ae.length===0){ae.push(De),J.push(De);break}const Le=ae[ae.length-1];if(n.Range.containsRange(Le.range,De.range)&&!n.Range.equalsRange(Le.range,De.range)){Le.children&&Le.children.push(De),ae.push(De);break}ae.pop()}}return J}}class c{constructor(W,K,J){this._documents=W,this._commands=K,this._provider=J,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,K){const J=this._documents.getDocument(W),ae=await this._provider.provideCodeLenses(J,K);if(!(!ae||K.isCancellationRequested)){const ge=this._cache.add(ae),De=new f.DisposableStore;this._disposables.set(ge,De);const Le={cacheId:ge,lenses:[]};for(let pe=0;pe<ae.length;pe++)Le.lenses.push({cacheId:[ge,pe],range:T.Range.from(ae[pe].range),command:this._commands.toInternal(ae[pe].command,De)});return Le}}async resolveCodeLens(W,K){var J;const ae=W.cacheId&&this._cache.get(...W.cacheId);if(!!ae){let ge;if(typeof this._provider.resolveCodeLens!="function"||ae.isResolved?ge=ae:ge=await this._provider.resolveCodeLens(ae,K),ge||(ge=ae),!K.isCancellationRequested){const De=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!De)return W.command=this._commands.toInternal((J=ge.command)!==null&&J!==void 0?J:c._badCmd,De),W}}}releaseCodeLenses(W){var K;(K=this._disposables.get(W))===null||K===void 0||K.dispose(),this._disposables.delete(W),this._cache.delete(W)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function o(xe){return Array.isArray(xe)?xe.map(T.DefinitionLink.from):xe?[T.DefinitionLink.from(xe)]:[]}class t{constructor(W,K){this._documents=W,this._provider=K}provideDefinition(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDefinition(ae,ge,J)).then(o)}}class i{constructor(W,K){this._documents=W,this._provider=K}provideDeclaration(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDeclaration(ae,ge,J)).then(o)}}class u{constructor(W,K){this._documents=W,this._provider=K}provideImplementation(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideImplementation(ae,ge,J)).then(o)}}class l{constructor(W,K){this._documents=W,this._provider=K}provideTypeDefinition(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(ae,ge,J)).then(o)}}class s{constructor(W,K){this._documents=W,this._provider=K}provideHover(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideHover(ae,ge,J)).then(De=>{if(!(!De||(0,A.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=ae.getWordRangeAtPosition(ge)),De.range||(De.range=new P.Range(ge,ge)),T.Hover.from(De)})}}class a{constructor(W,K){this._documents=W,this._provider=K}provideEvaluatableExpression(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(ae,ge,J)).then(De=>{if(De)return T.EvaluatableExpression.from(De)})}}class E{constructor(W,K){this._documents=W,this._provider=K}provideInlineValues(W,K,J,ae){const ge=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideInlineValues(ge,T.Range.to(K),T.InlineValueContext.to(J),ae)).then(De=>{if(Array.isArray(De))return De.map(Le=>T.InlineValue.from(Le))})}}class R{constructor(W,K){this._documents=W,this._provider=K}provideDocumentHighlights(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(ae,ge,J)).then(De=>{if(Array.isArray(De))return De.map(T.DocumentHighlight.from)})}}class g{constructor(W,K){this._documents=W,this._provider=K}provideLinkedEditingRanges(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(ae,ge,J)).then(De=>{if(De&&Array.isArray(De.ranges))return{ranges:(0,A.coalesce)(De.ranges.map(T.Range.from)),wordPattern:De.wordPattern}})}}class b{constructor(W,K){this._documents=W,this._provider=K}provideReferences(W,K,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideReferences(ge,De,J,ae)).then(Le=>{if(Array.isArray(Le))return Le.map(T.location.from)})}}class C{constructor(W,K,J,ae,ge,De,Le){this._documents=W,this._commands=K,this._diagnostics=J,this._provider=ae,this._logService=ge,this._extension=De,this._apiDeprecation=Le,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(W,K,J,ae){const ge=this._documents.getDocument(W),De=_.Selection.isISelection(K)?T.Selection.to(K):T.Range.to(K),Le=[];for(const Ce of this._diagnostics.getDiagnostics(W))if(De.intersection(Ce.range)&&Le.push(Ce)>C._maxCodeActionsPerFile)break;const pe={diagnostics:Le,only:J.only?new P.CodeActionKind(J.only):void 0,triggerKind:T.CodeActionTriggerKind.to(J.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(ge,De,pe,ae)).then(Ce=>{var Te;if(!(!(0,A.isNonEmptyArray)(Ce)||ae.isCancellationRequested)){const Ue=this._cache.add(Ce),be=new f.DisposableStore;this._disposables.set(Ue,be);const Ke=[];for(let V=0;V<Ce.length;V++){const X=Ce[V];!X||(C._isCommand(X)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:X.title,command:this._commands.toInternal(X,be)})):(pe.only&&(X.kind?pe.only.contains(X.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${X.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[Ue,V],title:X.title,command:X.command&&this._commands.toInternal(X.command,be),diagnostics:X.diagnostics&&X.diagnostics.map(T.Diagnostic.from),edit:X.edit&&T.WorkspaceEdit.from(X.edit),kind:X.kind&&X.kind.value,isPreferred:X.isPreferred,disabled:(Te=X.disabled)===null||Te===void 0?void 0:Te.reason})))}return{cacheId:Ue,actions:Ke}}})}async resolveCodeAction(W,K){var J;const[ae,ge]=W,De=this._cache.get(ae,ge);if(!(!De||C._isCommand(De))&&!!this._provider.resolveCodeAction){const Le=(J=await this._provider.resolveCodeAction(De,K))!==null&&J!==void 0?J:De;return(Le==null?void 0:Le.edit)?T.WorkspaceEdit.from(Le.edit):void 0}}releaseCodeActions(W){var K;(K=this._disposables.get(W))===null||K===void 0||K.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}C._maxCodeActionsPerFile=1e3;class F{constructor(W,K){this._documents=W,this._provider=K}provideDocumentFormattingEdits(W,K,J){const ae=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(ae,K,J)).then(ge=>{if(Array.isArray(ge))return ge.map(T.TextEdit.from)})}}class x{constructor(W,K){this._documents=W,this._provider=K}provideDocumentRangeFormattingEdits(W,K,J,ae){const ge=this._documents.getDocument(W),De=T.Range.to(K);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(ge,De,J,ae)).then(Le=>{if(Array.isArray(Le))return Le.map(T.TextEdit.from)})}}class le{constructor(W,K){this._documents=W,this._provider=K,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(W,K,J,ae,ge){const De=this._documents.getDocument(W),Le=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(De,Le,J,ae,ge)).then(pe=>{if(Array.isArray(pe))return pe.map(T.TextEdit.from)})}}class B{constructor(W,K){this._provider=W,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(W,K){const J=I.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(W,K)).then(ae=>{if((0,A.isNonEmptyArray)(ae)){for(const ge of ae)if(!!ge){if(!ge.name){this._logService.warn("INVALID SymbolInformation, lacks name",ge);continue}const De=I.IdObject.mixin(T.WorkspaceSymbol.from(ge));this._symbolCache.set(De._id,ge),J.symbols.push(De)}}}).then(()=>(J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J))}async resolveWorkspaceSymbol(W,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const J=this._symbolCache.get(W._id);if(J){const ae=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(J,K));return ae&&(0,D.mixin)(W,T.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(W){const K=this._resultCache.get(W);if(K){for(let[J,ae]=K;J<=ae;J++)this._symbolCache.delete(J);this._resultCache.delete(W)}}}class H{constructor(W,K,J){this._documents=W,this._provider=K,this._logService=J}static supportsResolving(W){return typeof W.prepareRename=="function"}provideRenameEdits(W,K,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(ge,De,J,ae)).then(Le=>{if(!!Le)return T.WorkspaceEdit.from(Le)},Le=>{const pe=H._asMessage(Le);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Le)})}resolveRenameLocation(W,K,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument(W),ge=T.Position.to(K);return(0,S.asPromise)(()=>this._provider.prepareRename(ae,ge,J)).then(De=>{let Le,pe;if(P.Range.isRange(De)?(Le=De,pe=ae.getText(De)):(0,k.isObject)(De)&&(Le=De.range,pe=De.placeholder),!!Le){if(Le.start.line>ge.line||Le.end.line<ge.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Le),text:pe}}},De=>{const Le=H._asMessage(De);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(De)})}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class G{constructor(W,K){this.resultId=W,this.tokens=K}}class L{constructor(W,K){this._documents=W,this._provider=K,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(W,K,J){const ae=this._documents.getDocument(W),ge=K!==0?this._previousResults.get(K):null;return(0,S.asPromise)(()=>ge&&typeof ge.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(ae,ge.resultId,J):this._provider.provideDocumentSemanticTokens(ae,J)).then(De=>(ge&&this._previousResults.delete(K),De?(De=L._fixProvidedSemanticTokens(De),this._send(L._convertToEdits(ge,De),De)):null))}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return L._isSemanticTokens(W)?L._isCorrectSemanticTokens(W)?W:new P.SemanticTokens(new Uint32Array(W.data),W.resultId):L._isSemanticTokensEdits(W)?L._isCorrectSemanticTokensEdits(W)?W:new P.SemanticTokensEdits(W.edits.map(K=>new P.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const K of W.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,K){if(!L._isSemanticTokens(K)||!W||!W.tokens)return K;const J=W.tokens,ae=J.length,ge=K.data,De=ge.length;let Le=0;const pe=Math.min(ae,De);for(;Le<pe&&J[Le]===ge[Le];)Le++;if(Le===ae&&Le===De)return new P.SemanticTokensEdits([],K.resultId);let Ce=0;const Te=pe-Le;for(;Ce<Te&&J[ae-Ce-1]===ge[De-Ce-1];)Ce++;return new P.SemanticTokensEdits([{start:Le,deleteCount:ae-Le-Ce,data:ge.subarray(Le,De-Ce)}],K.resultId)}_send(W,K){if(L._isSemanticTokens(W)){const J=this._nextResultId++;return this._previousResults.set(J,new G(W.resultId,W.data)),(0,r.encodeSemanticTokensDto)({id:J,type:"full",data:W.data})}if(L._isSemanticTokensEdits(W)){const J=this._nextResultId++;return L._isSemanticTokens(K)?this._previousResults.set(J,new G(K.resultId,K.data)):this._previousResults.set(J,new G(W.resultId)),(0,r.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(W.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=L;class ${constructor(W,K){this._documents=W,this._provider=K}provideDocumentRangeSemanticTokens(W,K,J){const ae=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(ae,T.Range.to(K),J)).then(ge=>ge?this._send(ge):null)}_send(W){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=$;class U{constructor(W,K,J,ae,ge){this._documents=W,this._commands=K,this._provider=J,this._apiDeprecation=ae,this._extension=ge,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,K,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(K),Le=ge.getWordRangeAtPosition(De)||new P.Range(De,De),pe=Le.with({end:De}),Ce=new m.StopWatch(!0),Te=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(ge,De,ae,T.CompletionContext.to(J)));if(!!Te&&!ae.isCancellationRequested){const Ue=Array.isArray(Te)?new P.CompletionList(Te):Te,be=U.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),Ke=new f.DisposableStore;this._disposables.set(be,Ke);const V=[],X={x:be,b:V,a:{replace:T.Range.from(Le),insert:T.Range.from(pe)},c:Ue.isIncomplete||void 0,d:Ce.elapsed()};for(let _e=0;_e<Ue.items.length;_e++){const Me=Ue.items[_e],He=this._convertCompletionItem(Me,[be,_e],pe,Le);V.push(He)}return X}}async resolveCompletionItem(W,K){if(typeof this._provider.resolveCompletionItem=="function"){const J=this._cache.get(...W);if(!!J){const ae=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(J,K));if(!!ae)return this._convertCompletionItem(ae,W)}}}releaseCompletionItems(W){var K;(K=this._disposables.get(W))===null||K===void 0||K.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,K,J,ae){var ge;const De=this._disposables.get(K[0]);if(!De)throw Error("DisposableStore is missing...");const Le={x:K,a:(ge=W.label)!==null&&ge!==void 0?ge:"",o:W.label2,b:W.kind!==void 0?T.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(T.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:T.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(T.TextEdit.from),m:this._commands.toInternal(W.command,De)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=W.textEdit.newText):typeof W.insertText=="string"?Le.h=W.insertText:W.insertText instanceof P.SnippetString&&(Le.h=W.insertText.value,Le.i|=4);let pe;return W.textEdit?pe=W.textEdit.range:W.range&&(pe=W.range),P.Range.isRange(pe)?Le.j=T.Range.from(pe):pe&&(!(J==null?void 0:J.isEqual(pe.inserting))||!(ae==null?void 0:ae.isEqual(pe.replacing)))&&(Le.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Le}}class Q{constructor(W,K){this._documents=W,this._provider=K,this._cache=new p.Cache("SignatureHelp")}provideSignatureHelp(W,K,J,ae){const ge=this._documents.getDocument(W),De=T.Position.to(K),Le=this.reviveContext(J);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(ge,De,ae,Le)).then(pe=>{if(pe){const Ce=this._cache.add([pe]);return Object.assign(Object.assign({},T.SignatureHelp.from(pe)),{id:Ce})}})}reviveContext(W){let K;if(W.activeSignatureHelp){const J=T.SignatureHelp.to(W.activeSignatureHelp),ae=this._cache.get(W.activeSignatureHelp.id,0);ae?(K=ae,K.activeSignature=J.activeSignature,K.activeParameter=J.activeParameter):K=J}return Object.assign(Object.assign({},W),{activeSignatureHelp:K})}releaseSignatureHelp(W){this._cache.delete(W)}}class N{constructor(W,K){this._documents=W,this._provider=K}provideInlineHints(W,K,J){const ae=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideInlineHints(ae,T.Range.to(K),J)).then(ge=>ge?{hints:ge.map(T.InlineHint.from)}:void 0)}}class Z{constructor(W,K){this._documents=W,this._provider=K,this._cache=new p.Cache("DocumentLink")}provideLinks(W,K){const J=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(J,K)).then(ae=>{if(!(!Array.isArray(ae)||ae.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.map(T.DocumentLink.from)};{const ge=this._cache.add(ae),De={links:[],id:ge};for(let Le=0;Le<ae.length;Le++){const pe=T.DocumentLink.from(ae[Le]);pe.cacheId=[ge,Le],De.links.push(pe)}return De}}})}resolveLink(W,K){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const J=this._cache.get(...W);return J?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(J,K)).then(ae=>ae&&T.DocumentLink.from(ae)||void 0):Promise.resolve(void 0)}releaseLinks(W){this._cache.delete(W)}}class ne{constructor(W,K){this._documents=W,this._provider=K}provideColors(W,K){const J=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(J,K)).then(ae=>Array.isArray(ae)?ae.map(De=>({color:T.Color.from(De.color),range:T.Range.from(De.range)})):[])}provideColorPresentations(W,K,J){const ae=this._documents.getDocument(W),ge=T.Range.to(K.range),De=T.Color.to(K.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(De,{document:ae,range:ge},J)).then(Le=>{if(!!Array.isArray(Le))return Le.map(T.ColorPresentation.from)})}}class re{constructor(W,K){this._documents=W,this._provider=K}provideFoldingRanges(W,K,J){const ae=this._documents.getDocument(W);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(ae,K,J)).then(ge=>{if(!!Array.isArray(ge))return ge.map(T.FoldingRange.from)})}}class ye{constructor(W,K,J){this._documents=W,this._provider=K,this._logService=J}provideSelectionRanges(W,K,J){const ae=this._documents.getDocument(W),ge=K.map(T.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(ae,ge,J)).then(De=>{if(!(0,A.isNonEmptyArray)(De))return[];if(De.length!==ge.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let pe=0;pe<ge.length;pe++){const Ce=[];Le.push(Ce);let Te=ge[pe],Ue=De[pe];for(;;){if(!Ue.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(T.SelectionRange.from(Ue)),!Ue.parent)break;Te=Ue.range,Ue=Ue.parent}}return Le})}}class Ae{constructor(W,K){this._documents=W,this._provider=K,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(W,K,J){const ae=this._documents.getDocument(W),ge=T.Position.to(K),De=await this._provider.prepareCallHierarchy(ae,ge,J);if(!!De){const Le=this._idPool.nextId();return this._cache.set(Le,new Map),Array.isArray(De)?De.map(pe=>this._cacheAndConvertItem(Le,pe)):[this._cacheAndConvertItem(Le,De)]}}async provideCallsTo(W,K,J){const ae=this._itemFromCache(W,K);if(!ae)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyIncomingCalls(ae,J);if(!!ge)return ge.map(De=>({from:this._cacheAndConvertItem(W,De.from),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}async provideCallsFrom(W,K,J){const ae=this._itemFromCache(W,K);if(!ae)throw new Error("missing call hierarchy item");const ge=await this._provider.provideCallHierarchyOutgoingCalls(ae,J);if(!!ge)return ge.map(De=>({to:this._cacheAndConvertItem(W,De.to),fromRanges:De.fromRanges.map(Le=>T.Range.from(Le))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,K){var J;const ae=this._cache.get(W),ge={_sessionId:W,_itemId:ae.size.toString(36),name:K.name,detail:K.detail,kind:T.SymbolKind.from(K.kind),uri:K.uri,range:T.Range.from(K.range),selectionRange:T.Range.from(K.selectionRange),tags:(J=K.tags)===null||J===void 0?void 0:J.map(T.SymbolTag.from)};return ae.set(ge._itemId,K),ge}_itemFromCache(W,K){const J=this._cache.get(W);return J==null?void 0:J.get(K)}}class Be{constructor(W,K){this.adapter=W,this.extension=K}}class Re{constructor(W,K,J,ae,ge,De,Le){this._adapter=new Map,this._uriTransformer=K,this._proxy=W.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=ae,this._diagnostics=ge,this._logService=De,this._apiDeprecation=Le}_transformDocumentSelector(W){return(0,A.coalesce)((0,A.asArray)(W).map(K=>this._doTransformDocumentSelector(K)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:T.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new P.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Re._handlePool++}_withAdapter(W,K,J,ae,ge=!1){const De=this._adapter.get(W);if(!De)return Promise.resolve(ae);if(De.adapter instanceof K){let Le;De.extension&&(Le=Date.now(),this._logService.trace(`[${De.extension.identifier.value}] INVOKE provider '${K.name}'`));const pe=J(De.adapter,De.extension),Ce=De.extension;return Ce&&Promise.resolve(pe).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Le}ms`),Te=>{ge&&Te instanceof v.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Te))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,K){const J=this._nextHandle();return this._adapter.set(J,new Be(W,K)),J}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,K,J,ae){const ge=this._addNewAdapter(new d(this._documents,J),W),De=ae&&ae.label||Re._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(ge,this._transformDocumentSelector(K),De),this._createDisposable(ge)}$provideDocumentSymbols(W,K,J){return this._withAdapter(W,d,ae=>ae.provideDocumentSymbols(w.URI.revive(K),J),void 0)}registerCodeLensProvider(W,K,J){const ae=this._nextHandle(),ge=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Be(new c(this._documents,this._commands.converter,J),W)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(K),ge);let De=this._createDisposable(ae);if(ge!==void 0){const Le=J.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(ge));De=P.Disposable.from(De,Le)}return De}$provideCodeLenses(W,K,J){return this._withAdapter(W,c,ae=>ae.provideCodeLenses(w.URI.revive(K),J),void 0)}$resolveCodeLens(W,K,J){return this._withAdapter(W,c,ae=>ae.resolveCodeLens(K,J),void 0)}$releaseCodeLenses(W,K){this._withAdapter(W,c,J=>Promise.resolve(J.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(W,K,J){const ae=this._addNewAdapter(new t(this._documents,J),W);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDefinition(W,K,J,ae){return this._withAdapter(W,t,ge=>ge.provideDefinition(w.URI.revive(K),J,ae),[])}registerDeclarationProvider(W,K,J){const ae=this._addNewAdapter(new i(this._documents,J),W);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDeclaration(W,K,J,ae){return this._withAdapter(W,i,ge=>ge.provideDeclaration(w.URI.revive(K),J,ae),[])}registerImplementationProvider(W,K,J){const ae=this._addNewAdapter(new u(this._documents,J),W);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideImplementation(W,K,J,ae){return this._withAdapter(W,u,ge=>ge.provideImplementation(w.URI.revive(K),J,ae),[])}registerTypeDefinitionProvider(W,K,J){const ae=this._addNewAdapter(new l(this._documents,J),W);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideTypeDefinition(W,K,J,ae){return this._withAdapter(W,l,ge=>ge.provideTypeDefinition(w.URI.revive(K),J,ae),[])}registerHoverProvider(W,K,J,ae){const ge=this._addNewAdapter(new s(this._documents,J),W);return this._proxy.$registerHoverProvider(ge,this._transformDocumentSelector(K)),this._createDisposable(ge)}$provideHover(W,K,J,ae){return this._withAdapter(W,s,ge=>ge.provideHover(w.URI.revive(K),J,ae),void 0)}registerEvaluatableExpressionProvider(W,K,J,ae){const ge=this._addNewAdapter(new a(this._documents,J),W);return this._proxy.$registerEvaluatableExpressionProvider(ge,this._transformDocumentSelector(K)),this._createDisposable(ge)}$provideEvaluatableExpression(W,K,J,ae){return this._withAdapter(W,a,ge=>ge.provideEvaluatableExpression(w.URI.revive(K),J,ae),void 0)}registerInlineValuesProvider(W,K,J,ae){const ge=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,De=this._addNewAdapter(new E(this._documents,J),W);this._proxy.$registerInlineValuesProvider(De,this._transformDocumentSelector(K),ge);let Le=this._createDisposable(De);if(ge!==void 0){const pe=J.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(ge));Le=P.Disposable.from(Le,pe)}return Le}$provideInlineValues(W,K,J,ae,ge){return this._withAdapter(W,E,De=>De.provideInlineValues(w.URI.revive(K),J,ae,ge),void 0)}registerDocumentHighlightProvider(W,K,J){const ae=this._addNewAdapter(new R(this._documents,J),W);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentHighlights(W,K,J,ae){return this._withAdapter(W,R,ge=>ge.provideDocumentHighlights(w.URI.revive(K),J,ae),void 0)}registerLinkedEditingRangeProvider(W,K,J){const ae=this._addNewAdapter(new g(this._documents,J),W);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideLinkedEditingRanges(W,K,J,ae){return this._withAdapter(W,g,async ge=>{const De=await ge.provideLinkedEditingRanges(w.URI.revive(K),J,ae);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?Re._serializeRegExp(De.wordPattern):void 0}},void 0)}registerReferenceProvider(W,K,J){const ae=this._addNewAdapter(new b(this._documents,J),W);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideReferences(W,K,J,ae,ge){return this._withAdapter(W,b,De=>De.provideReferences(w.URI.revive(K),J,ae,ge),void 0)}registerCodeActionProvider(W,K,J,ae){var ge,De;const Le=new f.DisposableStore,pe=this._addNewAdapter(new C(this._documents,this._commands.converter,this._diagnostics,J,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(K),{providedKinds:(ge=ae==null?void 0:ae.providedCodeActionKinds)===null||ge===void 0?void 0:ge.map(Ce=>Ce.value),documentation:(De=ae==null?void 0:ae.documentation)===null||De===void 0?void 0:De.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Le)}))},Re._extLabel(W),Boolean(J.resolveCodeAction)),Le.add(this._createDisposable(pe)),Le}$provideCodeActions(W,K,J,ae,ge){return this._withAdapter(W,C,De=>De.provideCodeActions(w.URI.revive(K),J,ae,ge),void 0)}$resolveCodeAction(W,K,J){return this._withAdapter(W,C,ae=>ae.resolveCodeAction(K,J),void 0)}$releaseCodeActions(W,K){this._withAdapter(W,C,J=>Promise.resolve(J.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(W,K,J){const ae=this._addNewAdapter(new F(this._documents,J),W);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(K),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentFormattingEdits(W,K,J,ae){return this._withAdapter(W,F,ge=>ge.provideDocumentFormattingEdits(w.URI.revive(K),J,ae),void 0)}registerDocumentRangeFormattingEditProvider(W,K,J){const ae=this._addNewAdapter(new x(this._documents,J),W);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(K),W.identifier,W.displayName||W.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits(W,K,J,ae,ge){return this._withAdapter(W,x,De=>De.provideDocumentRangeFormattingEdits(w.URI.revive(K),J,ae,ge),void 0)}registerOnTypeFormattingEditProvider(W,K,J,ae){const ge=this._addNewAdapter(new le(this._documents,J),W);return this._proxy.$registerOnTypeFormattingSupport(ge,this._transformDocumentSelector(K),ae,W.identifier),this._createDisposable(ge)}$provideOnTypeFormattingEdits(W,K,J,ae,ge,De){return this._withAdapter(W,le,Le=>Le.provideOnTypeFormattingEdits(w.URI.revive(K),J,ae,ge,De),void 0)}registerWorkspaceSymbolProvider(W,K){const J=this._addNewAdapter(new B(K,this._logService),W);return this._proxy.$registerNavigateTypeSupport(J),this._createDisposable(J)}$provideWorkspaceSymbols(W,K,J){return this._withAdapter(W,B,ae=>ae.provideWorkspaceSymbols(K,J),{symbols:[]})}$resolveWorkspaceSymbol(W,K,J){return this._withAdapter(W,B,ae=>ae.resolveWorkspaceSymbol(K,J),void 0)}$releaseWorkspaceSymbols(W,K){this._withAdapter(W,B,J=>J.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(W,K,J){const ae=this._addNewAdapter(new H(this._documents,J,this._logService),W);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(K),H.supportsResolving(J)),this._createDisposable(ae)}$provideRenameEdits(W,K,J,ae,ge){return this._withAdapter(W,H,De=>De.provideRenameEdits(w.URI.revive(K),J,ae,ge),void 0)}$resolveRenameLocation(W,K,J,ae){return this._withAdapter(W,H,ge=>ge.resolveRenameLocation(w.URI.revive(K),J,ae),void 0)}registerDocumentSemanticTokensProvider(W,K,J,ae){const ge=this._nextHandle(),De=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(ge,new Be(new L(this._documents,J),W)),this._proxy.$registerDocumentSemanticTokensProvider(ge,this._transformDocumentSelector(K),ae,De);let Le=this._createDisposable(ge);if(De){const pe=J.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(De));Le=P.Disposable.from(Le,pe)}return Le}$provideDocumentSemanticTokens(W,K,J,ae){return this._withAdapter(W,L,ge=>ge.provideDocumentSemanticTokens(w.URI.revive(K),J,ae),null,!0)}$releaseDocumentSemanticTokens(W,K){this._withAdapter(W,L,J=>J.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(W,K,J,ae){const ge=this._addNewAdapter(new $(this._documents,J),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ge,this._transformDocumentSelector(K),ae),this._createDisposable(ge)}$provideDocumentRangeSemanticTokens(W,K,J,ae){return this._withAdapter(W,$,ge=>ge.provideDocumentRangeSemanticTokens(w.URI.revive(K),J,ae),null,!0)}registerCompletionItemProvider(W,K,J,ae){const ge=this._addNewAdapter(new U(this._documents,this._commands.converter,J,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(ge,this._transformDocumentSelector(K),ae,U.supportsResolving(J),`${W.identifier.value}(${ae.join("")})`),this._createDisposable(ge)}$provideCompletionItems(W,K,J,ae,ge){return this._withAdapter(W,U,De=>De.provideCompletionItems(w.URI.revive(K),J,ae,ge),void 0)}$resolveCompletionItem(W,K,J){return this._withAdapter(W,U,ae=>ae.resolveCompletionItem(K,J),void 0)}$releaseCompletionItems(W,K){this._withAdapter(W,U,J=>J.releaseCompletionItems(K),void 0)}registerSignatureHelpProvider(W,K,J,ae){const ge=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,De=this._addNewAdapter(new Q(this._documents,J),W);return this._proxy.$registerSignatureHelpProvider(De,this._transformDocumentSelector(K),ge),this._createDisposable(De)}$provideSignatureHelp(W,K,J,ae,ge){return this._withAdapter(W,Q,De=>De.provideSignatureHelp(w.URI.revive(K),J,ae,ge),void 0)}$releaseSignatureHelp(W,K){this._withAdapter(W,Q,J=>J.releaseSignatureHelp(K),void 0)}registerInlineHintsProvider(W,K,J){const ae=typeof J.onDidChangeInlineHints=="function"?this._nextHandle():void 0,ge=this._addNewAdapter(new N(this._documents,J),W);this._proxy.$registerInlineHintsProvider(ge,this._transformDocumentSelector(K),ae);let De=this._createDisposable(ge);if(ae!==void 0){const Le=J.onDidChangeInlineHints(pe=>this._proxy.$emitInlineHintsEvent(ae));De=P.Disposable.from(De,Le)}return De}$provideInlineHints(W,K,J,ae){return this._withAdapter(W,N,ge=>ge.provideInlineHints(w.URI.revive(K),J,ae),void 0)}registerDocumentLinkProvider(W,K,J){const ae=this._addNewAdapter(new Z(this._documents,J),W);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(K),typeof J.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks(W,K,J){return this._withAdapter(W,Z,ae=>ae.provideLinks(w.URI.revive(K),J),void 0)}$resolveDocumentLink(W,K,J){return this._withAdapter(W,Z,ae=>ae.resolveLink(K,J),void 0)}$releaseDocumentLinks(W,K){this._withAdapter(W,Z,J=>J.releaseLinks(K),void 0)}registerColorProvider(W,K,J){const ae=this._addNewAdapter(new ne(this._documents,J),W);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentColors(W,K,J){return this._withAdapter(W,ne,ae=>ae.provideColors(w.URI.revive(K),J),[])}$provideColorPresentations(W,K,J,ae){return this._withAdapter(W,ne,ge=>ge.provideColorPresentations(w.URI.revive(K),J,ae),void 0)}registerFoldingRangeProvider(W,K,J){const ae=this._nextHandle(),ge=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Be(new re(this._documents,J),W)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(K),ge);let De=this._createDisposable(ae);if(ge!==void 0){const Le=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ge));De=P.Disposable.from(De,Le)}return De}$provideFoldingRanges(W,K,J,ae){return this._withAdapter(W,re,ge=>ge.provideFoldingRanges(w.URI.revive(K),J,ae),void 0)}registerSelectionRangeProvider(W,K,J){const ae=this._addNewAdapter(new ye(this._documents,J,this._logService),W);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideSelectionRanges(W,K,J,ae){return this._withAdapter(W,ye,ge=>ge.provideSelectionRanges(w.URI.revive(K),J,ae),[])}registerCallHierarchyProvider(W,K,J){const ae=this._addNewAdapter(new Ae(this._documents,J),W);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareCallHierarchy(W,K,J,ae){return this._withAdapter(W,Ae,ge=>Promise.resolve(ge.prepareSession(w.URI.revive(K),J,ae)),void 0)}$provideCallHierarchyIncomingCalls(W,K,J,ae){return this._withAdapter(W,Ae,ge=>ge.provideCallsTo(K,J,ae),void 0)}$provideCallHierarchyOutgoingCalls(W,K,J,ae){return this._withAdapter(W,Ae,ge=>ge.provideCallsFrom(K,J,ae),void 0)}$releaseCallHierarchy(W,K){this._withAdapter(W,Ae,J=>Promise.resolve(J.releaseSession(K)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,y.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Re._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Re._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Re._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Re._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Re._serializeRegExp(W.beforeText),afterText:W.afterText?Re._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Re._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Re._serializeOnEnterRule)}setLanguageConfiguration(W,K,J){let{wordPattern:ae}=J;if(ae&&(0,y.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(K,ae):this._documents.setWordDefinitionFor(K,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const ge=this._nextHandle(),De={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Re._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Re._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Re._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ge,K,De),this._createDisposable(ge)}$setWordDefinitions(W){for(const K of W)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Re,Re._handlePool=0}),define(we[195],Ee([0,1,5,9,7]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class P{constructor(I,y){this._proxy=I.getProxy(w.MainContext.MainThreadLanguages),this._documents=y}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(I,y){await this._proxy.$changeLanguage(I,y);const n=this._documents.getDocumentData(I);if(!n)throw new Error(`document '${I.toString}' NOT found`);return n.document}async tokenAtPosition(I,y){var n;const A=I.version,k=D.Position.from(y),_=await this._proxy.$tokensAtPosition(I.uri,k),f={type:T.StandardTokenType.Other,range:(n=I.getWordRangeAtPosition(y))!==null&&n!==void 0?n:new T.Range(y.line,y.character,y.line,y.character)};if(!_)return f;const r={range:D.Range.to(_.range),type:D.TokenType.to(_.type)};return!r.range.contains(y)||A!==I.version?f:r}}e.ExtHostLanguages=P}),define(we[196],Ee([0,1,5,19,34]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function P(I){return I&&I.title}let S=class{constructor(y,n){this._logService=n,this._proxy=y.getProxy(w.MainContext.MainThreadMessageService)}showMessage(y,n,A,k,_){const f={extension:y};let r;typeof k=="string"||P(k)?r=[k,..._]:(f.modal=k&&k.modal,f.useCustom=k&&k.useCustom,r=_),f.useCustom&&(0,T.checkProposedApiEnabled)(y);const h=[];for(let p=0;p<r.length;p++){const m=r[p];if(typeof m=="string")h.push({title:m,handle:p,isCloseAffordance:!1});else if(typeof m=="object"){let{title:v,isCloseAffordance:d}=m;h.push({title:v,isCloseAffordance:!!d,handle:p})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(n,A,f,h).then(p=>{if(typeof p=="number")return r[p]})}};S=je([qe(1,D.ILogService)],S),e.ExtHostMessageService=S}),define(we[197],Ee([0,1,20,3,6,2,29,5,9,7,69,70,22,174,175,53,12,26,56]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookCellStatusBarItemInternal=e.ExtHostNotebookController=e.NotebookEditorDecorationType=e.ExtHostNotebookKernelProviderAdapter=void 0;class d extends T.Disposable{constructor(a,E,R,g,b){super();this._editorId=a,this.uri=E,this._proxy=R,this._webviewInitData=g,this.document=b,this._onDidReceiveDocumentMessage=new D.Emitter,this._rendererIdToEmitters=new Map,this.contentProviderComm={editorId:this._editorId,onDidReceiveMessage:this._onDidReceiveDocumentMessage.event,postMessage:C=>this._proxy.$postMessage(this._editorId,void 0,C),asWebviewUri:C=>this._asWebviewUri(C)}}onDidReceiveMessage(a,E){var R;this._onDidReceiveDocumentMessage.fire(E),a!==void 0&&((R=this._rendererIdToEmitters.get(a))===null||R===void 0||R.fire(E))}getRendererComm(a){const E=new D.Emitter;return this._rendererIdToEmitters.set(a,E),{editorId:this._editorId,onDidReceiveMessage:E.event,postMessage:R=>this._proxy.$postMessage(this._editorId,a,R),asWebviewUri:R=>this._asWebviewUri(R)}}_asWebviewUri(a){return(0,A.asWebviewUri)(this._webviewInitData,this._editorId,a)}}class c extends T.Disposable{constructor(a,E,R,g){super();this._proxy=a,this._handle=E,this._extension=R,this._provider=g,this._kernelToFriendlyId=new _.ResourceMap,this._friendlyIdToKernel=new _.ResourceMap,this._provider.onDidChangeKernels&&this._register(this._provider.onDidChangeKernels(b=>{const C=b==null?void 0:b.uri;this._proxy.$onNotebookKernelChange(this._handle,C)}))}async provideKernels(a,E){const R=await this._provider.provideKernels(a.notebookDocument,E)||[],g=new Map;let b=0;const C=new Set,F=this._kernelToFriendlyId.get(a.uri),x=R.map(B=>{let H=F==null?void 0:F.get(B);return H===void 0&&(B.id&&C.has(B.id)?H=`${this._extension.identifier.value}_${B.id}_${b++}`:H=`${this._extension.identifier.value}_${B.id||S.generateUuid()}`),g.set(B,H),{id:B.id,friendlyId:H,label:B.label,extension:this._extension.identifier,extensionLocation:this._extension.extensionLocation,providerHandle:this._handle,description:B.description,detail:B.detail,isPreferred:B.isPreferred,preloads:B.preloads,supportedLanguages:B.supportedLanguages}});this._kernelToFriendlyId.set(a.uri,g);const le=new Map;return g.forEach((B,H)=>{le.set(B,H)}),this._friendlyIdToKernel.set(a.uri,le),x}getKernelByFriendlyId(a,E){var R;return(R=this._friendlyIdToKernel.get(a))===null||R===void 0?void 0:R.get(E)}async resolveNotebook(a,E,R,g){var b;const C=(b=this._friendlyIdToKernel.get(E.uri))===null||b===void 0?void 0:b.get(a);if(C&&this._provider.resolveKernel)return this._provider.resolveKernel(C,E.notebookDocument,R,g)}async executeNotebook(a,E,R){var g;const b=(g=this._friendlyIdToKernel.get(E.uri))===null||g===void 0?void 0:g.get(a);if(!!b)return o(R?C=>b.executeCell(E.notebookDocument,R.cell,C):C=>b.executeAllCells(E.notebookDocument,C))}async cancelNotebook(a,E,R){var g;const b=(g=this._friendlyIdToKernel.get(E.uri))===null||g===void 0?void 0:g.get(a);if(!!b)return R?b.cancelCellExecution(E.notebookDocument,R.cell):b.cancelAllCellsExecution(E.notebookDocument)}}e.ExtHostNotebookKernelProviderAdapter=c;async function o(s){const a=new w.CancellationTokenSource;try{await s(a.token)}finally{a.dispose()}}class t{constructor(a,E){const R=t._Keys.nextId();a.$registerNotebookEditorDecorationType(R,y.NotebookDecorationRenderOptions.from(E)),this.value={key:R,dispose(){a.$removeNotebookEditorDecorationType(R)}}}}e.NotebookEditorDecorationType=t,t._Keys=new h.IdGenerator("NotebookEditorDecorationType");class i{constructor(a,E,R,g,b,C,F){this._textDocumentsAndEditors=R,this._textDocuments=g,this._webviewInitData=b,this.logService=C,this._extensionStoragePaths=F,this._notebookContentProviders=new Map,this._notebookKernelProviders=new Map,this._documents=new _.ResourceMap,this._editors=new Map,this._webviewComm=new Map,this._onDidChangeNotebookEditorSelection=new D.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new D.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new D.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new D.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new D.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new D.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new D.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new D.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new D.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new D.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeActiveNotebookKernel=new D.Emitter,this.onDidChangeActiveNotebookKernel=this._onDidChangeActiveNotebookKernel.event,this._onDidChangeVisibleNotebookEditors=new D.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._proxy=a.getProxy(I.MainContext.MainThreadNotebook),this._commandsConverter=E.converter,E.registerArgumentProcessor({processArgument:x=>{var le;if(x&&x.$mid===12){const B=(le=x.notebookEditor)===null||le===void 0?void 0:le.notebookUri,H=x.cell.handle,G=this._documents.get(B),L=G==null?void 0:G.getCell(H);if(L)return L.cell}return x}})}get activeNotebookEditor(){var a;return(a=this._activeNotebookEditor)===null||a===void 0?void 0:a.editor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.editor)}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(a){return this._documents.get(a)}_getNotebookDocument(a){const E=this._documents.get(a);if(!E)throw new Error(`NO notebook document for '${a}'`);return E}_getProviderData(a){const E=this._notebookContentProviders.get(a);if(!E)throw new Error(`NO provider for '${a}'`);return E}registerNotebookContentProvider(a,E,R,g){var b,C,F;if(this._notebookContentProviders.has(E))throw new Error(`Notebook provider for '${E}' already registered`);this._notebookContentProviders.set(E,{extension:a,provider:R});let x;R.onDidChangeNotebookContentOptions&&(x=R.onDidChangeNotebookContentOptions(()=>{this._proxy.$updateNotebookProviderOptions(E,R.options)}));const le=(b=g==null?void 0:g.viewOptions)===null||b===void 0?void 0:b.filenamePattern.map(B=>y.NotebookExclusiveDocumentPattern.from(B)).filter(B=>B!==void 0);return((C=g==null?void 0:g.viewOptions)===null||C===void 0?void 0:C.filenamePattern)&&!le&&console.warn(`Notebook content provider view options file name pattern is invalid ${(F=g==null?void 0:g.viewOptions)===null||F===void 0?void 0:F.filenamePattern}`),this._proxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation,description:a.description},E,{transientOutputs:(g==null?void 0:g.transientOutputs)||!1,transientMetadata:(g==null?void 0:g.transientMetadata)||{},viewOptions:(g==null?void 0:g.viewOptions)&&le?{displayName:g.viewOptions.displayName,filenamePattern:le,exclusive:g.viewOptions.exclusive||!1}:void 0}),new n.Disposable(()=>{x==null||x.dispose(),this._notebookContentProviders.delete(E),this._proxy.$unregisterNotebookProvider(E)})}registerNotebookKernelProvider(a,E,R){const g=i._notebookKernelProviderHandlePool++,b=new c(this._proxy,g,a,R);return this._notebookKernelProviders.set(g,b),this._proxy.$registerNotebookKernelProvider({id:a.identifier,location:a.extensionLocation,description:a.description},g,{viewType:E.viewType,filenamePattern:E.filenamePattern?y.NotebookExclusiveDocumentPattern.from(E.filenamePattern):void 0}),new n.Disposable(()=>{b.dispose(),this._notebookKernelProviders.delete(g),this._proxy.$unregisterNotebookKernelProvider(g)})}createNotebookEditorDecorationType(a){return new t(this._proxy,a).value}async openNotebookDocument(a){const E=this._documents.get(a);if(E)return E.notebookDocument;const R=await this._proxy.$tryOpenDocument(a),g=this._documents.get(P.URI.revive(R));return(0,p.assertIsDefined)(g==null?void 0:g.notebookDocument)}_withAdapter(a,E,R){const g=this._documents.get(P.URI.revive(E));if(!g)return[];const b=this._notebookKernelProviders.get(a);return b?R(b,g):[]}async showNotebookDocument(a,E){var R;P.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let g;typeof E=="object"?g={position:y.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:E.selection&&y.NotebookCellRange.from(E.selection),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:g={preserveFocus:!1};const b=await this._proxy.$tryShowNotebookDocument(a.uri,a.viewType,g),C=b&&((R=this._editors.get(b))===null||R===void 0?void 0:R.editor);if(C)return C.editor;throw b?new Error(`Could NOT open editor for "${a.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.toString()}".`)}async $provideNotebookKernels(a,E,R){return this._withAdapter(a,E,(g,b)=>g.provideKernels(b,R))}async $resolveNotebookKernel(a,E,R,g,b){await this._withAdapter(a,R,async(C,F)=>{const x=this._webviewComm.get(E);x&&await C.resolveNotebook(g,F,x.contentProviderComm,b)})}async $resolveNotebookEditor(a,E,R){const g=this._notebookContentProviders.get(a),b=P.URI.revive(E),C=this._documents.get(b);if(!(!C||!g)){let F=this._webviewComm.get(R);F||(F=new d(R,b,this._proxy,this._webviewInitData,C),this._webviewComm.set(R,F)),!!g.provider.resolveNotebook&&await g.provider.resolveNotebook(C.notebookDocument,F.contentProviderComm)}}async $executeNotebookKernelFromProvider(a,E,R,g){await this._withAdapter(a,E,async(b,C)=>{const F=g!==void 0?C.getCell(g):void 0;return b.executeNotebook(R,C,F)})}async $cancelNotebookKernelFromProvider(a,E,R,g){await this._withAdapter(a,E,async(b,C)=>{const F=g!==void 0?C.getCell(g):void 0;return b.cancelNotebook(R,C,F)})}registerNotebookSerializer(a,E,R,g){const b=this._handlePool++;return this._notebookSerializer.set(b,R),this._proxy.$registerNotebookSerializer(b,{id:a.identifier,location:a.extensionLocation,description:a.description},E,g!=null?g:{transientOutputs:!1,transientMetadata:{}}),(0,T.toDisposable)(()=>{this._proxy.$unregisterNotebookSerializer(b)})}async $dataToNotebook(a,E){const R=this._notebookSerializer.get(a);if(!R)throw new Error("NO serializer found");const g=await R.dataToNotebook(E.buffer);return{metadata:y.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(y.NotebookCellData.from)}}async $notebookToData(a,E){const R=this._notebookSerializer.get(a);if(!R)throw new Error("NO serializer found");const g=await R.notebookToData({metadata:y.NotebookDocumentMetadata.to(E.metadata),cells:E.cells.map(y.NotebookCellData.to)});return m.VSBuffer.wrap(g)}async $openNotebook(a,E,R,g,b){const{provider:C}=this._getProviderData(a),F=await C.openNotebook(P.URI.revive(E),{backupId:R,untitledDocumentData:g==null?void 0:g.buffer},b);return{metadata:y.NotebookDocumentMetadata.from(F.metadata),cells:F.cells.map(y.NotebookCellData.from)}}async $saveNotebook(a,E,R){const g=this._getNotebookDocument(P.URI.revive(E)),{provider:b}=this._getProviderData(a);return await b.saveNotebook(g.notebookDocument,R),!0}async $saveNotebookAs(a,E,R,g){const b=this._getNotebookDocument(P.URI.revive(E)),{provider:C}=this._getProviderData(a);return await C.saveNotebookAs(P.URI.revive(R),b.notebookDocument,g),!0}async $backupNotebook(a,E,R){var g;const b=this._getNotebookDocument(P.URI.revive(E)),C=this._getProviderData(a),F=(g=this._extensionStoragePaths.workspaceValue(C.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(C.extension),x=String((0,v.hash)([b.uri.toString(),this._backupIdPool++])),le=P.URI.joinPath(F,x),B=await C.provider.backupNotebook(b.notebookDocument,{destination:le},R);return b.updateBackup(B),B.id}$acceptNotebookActiveKernelChange(a){a.providerHandle!==void 0&&this._withAdapter(a.providerHandle,a.uri,async(E,R)=>{const g=a.kernelFriendlyId?E.getKernelByFriendlyId(P.URI.revive(a.uri),a.kernelFriendlyId):void 0;this._editors.forEach(b=>{b.editor.notebookData===R&&b.editor._acceptKernel(g)}),this._onDidChangeActiveNotebookKernel.fire({document:R.notebookDocument,kernel:g})})}$onDidReceiveMessage(a,E,R){var g;(g=this._webviewComm.get(a))===null||g===void 0||g.onDidReceiveMessage(E,R)}$acceptModelChanged(a,E,R){this._getNotebookDocument(P.URI.revive(a)).acceptModelChanged(E,R)}$acceptDirtyStateChanged(a,E){const R=this._getNotebookDocument(P.URI.revive(a));R.acceptModelChanged({rawEvents:[],versionId:R.notebookDocument.version},E)}$acceptModelSaved(a){const E=this._getNotebookDocument(P.URI.revive(a));this._onDidSaveNotebookDocument.fire(E.notebookDocument)}$acceptEditorPropertiesChanged(a,E){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",a,E);const R=this._editors.get(a);if(!R)throw new Error(`unknown text editor: ${a}`);E.visibleRanges&&R.editor._acceptVisibleRanges(E.visibleRanges.ranges.map(y.NotebookCellRange.to)),E.selections&&R.editor._acceptSelections(E.selections.selections.map(y.NotebookCellRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:R.editor.editor,visibleRanges:R.editor.editor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:R.editor.editor,selections:R.editor.editor.selections}))}$acceptDocumentPropertiesChanged(a,E){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",a.path,E);const R=this._getNotebookDocument(P.URI.revive(a));R.acceptDocumentPropertiesChanged(E),E.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.notebookDocument})}_createExtHostEditor(a,E,R){var g;const b=a.uri;let C=this._webviewComm.get(E);C||(C=new d(E,b,this._proxy,this._webviewInitData,a),this._webviewComm.set(E,C));const F=new r.ExtHostNotebookEditor(E,a.notebookDocument.viewType,this._proxy,a,R.visibleRanges.map(y.NotebookCellRange.to),R.selections.map(y.NotebookCellRange.to),typeof R.viewColumn=="number"?y.ViewColumn.to(R.viewColumn):void 0);(g=this._editors.get(E))===null||g===void 0||g.editor.dispose(),this._editors.set(E,{editor:F})}$acceptDocumentAndEditorsDelta(a){var E,R,g,b;let C=!1;if(a.removedDocuments)for(const x of a.removedDocuments){const le=P.URI.revive(x),B=this._documents.get(le);B&&(B.dispose(),this._documents.delete(le),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:B.notebookDocument.cells.map(H=>H.document.uri)}),this._onDidCloseNotebookDocument.fire(B.notebookDocument));for(const H of this._editors.values())H.editor.notebookData.uri.toString()===le.toString()&&(H.editor.dispose(),this._editors.delete(H.editor.id),C=!0)}if(a.addedDocuments){const x=[];for(const le of a.addedDocuments){const B=P.URI.revive(le.uri),H=le.viewType;if(this._documents.has(B))throw new Error(`adding EXISTING notebook ${B}`);const G=this,L=new f.ExtHostNotebookDocument(this._proxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange($){G._onDidChangeNotebookCells.fire($)},emitCellOutputsChange($){G._onDidChangeCellOutputs.fire($)},emitCellMetadataChange($){G._onDidChangeCellMetadata.fire($)}},H,le.metadata?y.NotebookDocumentMetadata.to(le.metadata):new n.NotebookDocumentMetadata,B);L.acceptModelChanged({versionId:le.versionId,rawEvents:[{kind:k.NotebookCellsChangeType.Initialize,changes:[[0,0,le.cells]]}]},!1),x.push(...le.cells.map($=>f.ExtHostCell.asModelAddData(L.notebookDocument,$))),(E=this._documents.get(B))===null||E===void 0||E.dispose(),this._documents.set(B,L),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:x}),this._onDidOpenNotebookDocument.fire(L.notebookDocument)}}if(a.addedEditors)for(const x of a.addedEditors){if(this._editors.has(x.id))return;const le=P.URI.revive(x.documentUri),B=this._documents.get(le);B&&(this._createExtHostEditor(B,x.id,x),C=!0)}const F=[];if(a.removedEditors)for(const x of a.removedEditors){const le=this._editors.get(x);le&&(C=!0,this._editors.delete(x),((R=this._activeNotebookEditor)===null||R===void 0?void 0:R.id)===le.editor.id&&(this._activeNotebookEditor=void 0),F.push(le))}if(C&&F.forEach(x=>{x.editor.dispose()}),a.visibleEditors){this._visibleNotebookEditors=a.visibleEditors.map(le=>this._editors.get(le).editor).filter(le=>!!le);const x=new Set;this._visibleNotebookEditors.forEach(le=>x.add(le.id));for(const le of this._editors.values()){const B=x.has(le.editor.id);le.editor._acceptVisibility(B)}this._visibleNotebookEditors=[...this._editors.values()].map(le=>le.editor).filter(le=>le.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.newActiveEditor===null?this._activeNotebookEditor=void 0:a.newActiveEditor&&(this._activeNotebookEditor=(g=this._editors.get(a.newActiveEditor))===null||g===void 0?void 0:g.editor),a.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((b=this._activeNotebookEditor)===null||b===void 0?void 0:b.editor)}createNotebookCellStatusBarItemInternal(a,E,R){const g=new u(this._proxy,this._commandsConverter,a,E,R),b=k.CellUri.parse(a.document.uri);if(b){const C=this._documents.get(b.notebook);if(C){const F=C.getCell(b.handle);F&&D.Event.once(F.onDidDispose)(()=>g.dispose())}}return g}}e.ExtHostNotebookController=i,i._notebookKernelProviderHandlePool=0;class u extends T.Disposable{constructor(a,E,R,g,b){super();this._proxy=a,this._commands=E,this._cell=R,this._priority=b,this._id=u.NEXT_ID++,this._isDisposed=!1,this._text="",this._visible=!1,this._internalCommandRegistration=this._register(new T.DisposableStore),this._alignment=g!=null?g:n.NotebookCellStatusBarAlignment.Left}get apiItem(){return this._apiItem||(this._apiItem=l(this)),this._apiItem}get cell(){return this._cell}get alignment(){return this._alignment}set alignment(a){this._alignment=a,this.update()}get priority(){return this._priority}set priority(a){this._priority=a,this.update()}get text(){return this._text}set text(a){this._text=a,this.update()}get tooltip(){return this._tooltip}set tooltip(a){this._tooltip=a,this.update()}get command(){var a;return(a=this._command)===null||a===void 0?void 0:a.fromApi}set command(a){var E;((E=this._command)===null||E===void 0?void 0:E.fromApi)!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:this._commands.toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:this._commands.toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}get accessibilityInformation(){return this._accessibilityInformation}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){this._visible=!1,this.update()}dispose(){this.hide(),this._isDisposed=!0,this._internalCommandRegistration.dispose()}update(){var a;if(!this._isDisposed){const E={alignment:this.alignment===n.NotebookCellStatusBarAlignment.Left?0:1,cellResource:this.cell.document.uri,command:(a=this._command)===null||a===void 0?void 0:a.internal,text:this.text,tooltip:this.tooltip,accessibilityInformation:this.accessibilityInformation,priority:this.priority,visible:this._visible};this._proxy.$setStatusBarEntry(this._id,E)}}}e.NotebookCellStatusBarItemInternal=u,u.NEXT_ID=0;function l(s){return Object.freeze({cell:s.cell,get alignment(){return s.alignment},set alignment(a){s.alignment=a},get priority(){return s.priority},set priority(a){s.priority=a},get text(){return s.text},set text(a){s.text=a},get tooltip(){return s.tooltip},set tooltip(a){s.tooltip=a},get command(){return s.command},set command(a){s.command=a},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(a){s.accessibilityInformation=a},show(){s.show()},hide(){s.hide()},dispose(){s.dispose()}})}}),define(we[98],Ee([0,1,5,3,6,26,4,14]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends T.Disposable{constructor(r,h,p,m){super();this._onDidAppend=this._register(new D.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,h,p),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?P.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(h=>this._proxy.$clear(h,r))}show(r,h){this.validate(),this._id.then(p=>this._proxy.$reveal(p,!!(typeof r=="boolean"?r:h)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class n extends y{constructor(r,h){super(r,!1,void 0,h)}append(r){super.append(r),this._id.then(h=>this._proxy.$append(h,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=n;class A extends y{constructor(r,h,p){super(r,!0,h,p)}append(r){throw new Error("Not supported")}}class k{constructor(r,h){this.name=r,this._channel=h}append(r){this._channel.then(h=>h.append(r))}appendLine(r){this._channel.then(h=>h.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,h){this._channel.then(p=>p.show(r,h))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=k;let _=class{constructor(r){this._proxy=r.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new n(r,this._proxy)}createOutputChannelFromLogFile(r,h){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!h)throw new Error("illegal argument `file`. must not be falsy");return new A(r,h,this._proxy)}};_=je([qe(0,I.IExtHostRpcService)],_),e.ExtHostOutputService=_,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(we[198],Ee([0,1,13,20,3,6,5,2,7,10,15,47]),function(oe,e,w,D,T,P,S,I,y,n,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(f,r,h){const p=f.getProxy(S.MainContext.MainThreadQuickOpen);class m{constructor(l,s){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=s}showQuickPick(l,s,a,E=D.CancellationToken.None){this._onDidSelectItem=void 0;const R=Promise.resolve(l),g=++this._instances,b=p.$show(g,{title:a==null?void 0:a.title,placeHolder:a==null?void 0:a.placeHolder,matchOnDescription:a==null?void 0:a.matchOnDescription,matchOnDetail:a==null?void 0:a.matchOnDetail,ignoreFocusLost:a==null?void 0:a.ignoreFocusOut,canPickMany:a==null?void 0:a.canPickMany},E),C={},F=b.then(()=>C);return Promise.race([F,R]).then(x=>{if(x!==C)return R.then(le=>{const B=[];for(let H=0;H<le.length;H++){const G=le[H];let L,$,U,Q,N;typeof G=="string"?L=G:(L=G.label,$=G.description,U=G.detail,Q=G.picked,N=G.alwaysShow),B.push({label:L,description:$,handle:H,detail:U,picked:Q,alwaysShow:N})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{a.onDidSelectItem(le[H])}),p.$setItems(g,B),b.then(H=>{if(typeof H=="number")return le[H];if(Array.isArray(H))return H.map(G=>le[G])})})}).then(void 0,x=>{if(!(0,n.isPromiseCanceledError)(x))return p.$setError(g,x),Promise.reject(x)})}$onItemSelected(l){this._onDidSelectItem&&this._onDidSelectItem(l)}showInput(l,s=D.CancellationToken.None){return this._validateInput=l?l.validateInput:void 0,p.$input(l,typeof this._validateInput=="function",s).then(void 0,a=>{if(!(0,n.isPromiseCanceledError)(a))return Promise.reject(a)})}$validateInput(l){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(l)):Promise.resolve(void 0)}async showWorkspaceFolderPick(l,s=D.CancellationToken.None){const a=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!!a){const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(R=>R.uri.toString()===a.uri.toString())}}createQuickPick(l,s){const a=new t(l,s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(l){const s=new i(l,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(l,s){const a=this._sessions.get(l);a&&a._fireDidChangeValue(s)}$onDidAccept(l){const s=this._sessions.get(l);s&&s._fireDidAccept()}$onDidChangeActive(l,s){const a=this._sessions.get(l);a instanceof t&&a._fireDidChangeActive(s)}$onDidChangeSelection(l,s){const a=this._sessions.get(l);a instanceof t&&a._fireDidChangeSelection(s)}$onDidTriggerButton(l,s){const a=this._sessions.get(l);a&&a._fireDidTriggerButton(s)}$onDidHide(l){const s=this._sessions.get(l);s&&s._fireDidHide()}}class v{constructor(l,s){this._extensionId=l,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new T.Emitter,this._onDidChangeValueEmitter=new T.Emitter,this._onDidTriggerButtonEmitter=new T.Emitter,this._onDidHideEmitter=new T.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((s,a)=>{const E=s===y.QuickInputButtons.Back?-1:a;this._handlesToButtons.set(E,s)}),this.update({buttons:l.map((s,a)=>({iconPath:d(s.iconPath),tooltip:s.tooltip,handle:s===y.QuickInputButtons.Back?-1:a}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const s=this._handlesToButtons.get(l);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,P.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),p.$dispose(this._id))}update(l){if(!this._disposed){for(const s of Object.keys(l)){const a=l[s];this._pendingUpdate[s]=a===void 0?null:a}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){p.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function d(u){if(u instanceof y.ThemeIcon)return{id:u.id};const l=o(u),s=c(u);return{dark:typeof l=="string"?I.URI.file(l):l,light:typeof s=="string"?I.URI.file(s):s}}function c(u){return typeof u=="object"&&"light"in u?u.light:u}function o(u){return typeof u=="object"&&"dark"in u?u.dark:u}class t extends v{constructor(l,s,a){super(l,a);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new T.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new T.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((s,a)=>{this._handlesToItems.set(a,s),this._itemsToHandles.set(s,a)}),this.update({items:l.map((s,a)=>({label:s.label,description:s.description,handle:a,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(l){const s=(0,A.coalesce)(l.map(a=>this._handlesToItems.get(a)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(l){const s=(0,A.coalesce)(l.map(a=>this._handlesToItems.get(a)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class i extends v{constructor(l,s){super(l,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,this.update({validationMessage:l,severity:l?k.default.Error:k.default.Ignore})}}return new m(r,h)}e.createExtHostQuickOpen=_}),define(we[199],Ee([0,1,2,3,44,6,13,5,15,109,19,25,34]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?w.URI.file(l.iconPath):l.iconPath}function r(l,s){if(!l.iconPath&&!s.iconPath)return 0;if(l.iconPath){if(!s.iconPath)return 1}else return-1;const a=typeof l.iconPath=="string"?l.iconPath:l.iconPath.fsPath,E=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,n.comparePaths)(a,E)}function h(l,s){let a=0;if(l.strikeThrough!==s.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==s.faded)return l.faded?1:-1;if(l.tooltip!==s.tooltip)return(l.tooltip||"").localeCompare(s.tooltip||"");if(a=r(l,s),a!==0)return a;if(l.light&&s.light)a=r(l.light,s.light);else{if(l.light)return 1;if(s.light)return-1}if(a!==0)return a;if(l.dark&&s.dark)a=r(l.dark,s.dark);else{if(l.dark)return 1;if(s.dark)return-1}return a}function p(l,s){if(l.command!==s.command)return l.command<s.command?-1:1;if(l.title!==s.title)return l.title<s.title?-1:1;if(l.tooltip!==s.tooltip){if(l.tooltip!==void 0&&s.tooltip!==void 0)return l.tooltip<s.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(l.arguments===s.arguments)return 0;if(l.arguments)if(s.arguments){if(l.arguments.length!==s.arguments.length)return l.arguments.length-s.arguments.length}else return 1;else return-1;for(let a=0;a<l.arguments.length;a++){const E=l.arguments[a],R=s.arguments[a];if(E!==R)return E<R?-1:1}return 0}function m(l,s){let a=(0,n.comparePaths)(l.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(a!==0)return a;if(l.command&&s.command)a=p(l.command,s.command);else{if(l.command)return 1;if(s.command)return-1}if(a!==0)return a;if(l.decorations&&s.decorations)a=h(l.decorations,s.decorations);else{if(l.decorations)return 1;if(s.decorations)return-1}return a}function v(l,s){for(let a=0;a<l.length;a++)if(l[a]!==s[a])return!1;return!0}function d(l,s){return l.command===s.command&&l.title===s.title&&l.tooltip===s.tooltip&&(l.arguments&&s.arguments?v(l.arguments,s.arguments):l.arguments===s.arguments)}function c(l,s){return(0,y.equals)(l,s,d)}class o{constructor(s,a,E){this._extension=s,this._proxy=a,this._sourceControlHandle=E,this._value="",this._onDidChange=new D.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,_.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=o;class t{constructor(s,a,E,R,g){this._proxy=s,this._commands=a,this._sourceControlHandle=E,this._id=R,this._label=g,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new D.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,a){const E=this._resourceStatesCommandsMap.get(s);return E?(0,S.asPromise)(()=>this._commands.executeCommand(E.command,...E.arguments||[],a)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const a=[...this._resourceStates].sort(m),R=(0,y.sortedDiff)(this._resourceSnapshot,a,m).map(C=>{const F=C.toInsert.map(x=>{const le=this._resourceHandlePool++;this._resourceStatesMap.set(le,x);const B=x.resourceUri,H=f(x.decorations),G=x.decorations&&f(x.decorations.light)||H,L=x.decorations&&f(x.decorations.dark)||H,$=[];let U;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const ye=new P.DisposableStore;U=this._commands.converter.toInternal(x.command,ye),this._resourceStatesDisposablesMap.set(le,ye)}else this._resourceStatesCommandsMap.set(le,x.command);G&&$.push(G),L&&L.toString()!==(G==null?void 0:G.toString())&&$.push(L);const Q=x.decorations&&x.decorations.tooltip||"",N=x.decorations&&!!x.decorations.strikeThrough,Z=x.decorations&&!!x.decorations.faded,ne=x.contextValue||"";return{rawResource:[le,B,$,Q,N,Z,ne,U],handle:le}});return{start:C.start,deleteCount:C.deleteCount,toInsert:F}}),g=R.map(({start:C,deleteCount:F,toInsert:x})=>[C,F,x.map(le=>le.rawResource)]),b=R.reverse();for(const{start:C,deleteCount:F,toInsert:x}of b){const le=x.map(H=>H.handle),B=this._handlesSnapshot.splice(C,F,...le);for(const H of B)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),(s=this._resourceStatesDisposablesMap.get(H))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=a,g}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(s,a,E,R,g,b){this._proxy=a,this._commands=E,this._id=R,this._label=g,this._rootUri=b,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new P.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new P.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new D.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new o(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,R,g,b)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new P.DisposableStore,this._acceptInputCommand=s;const a=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:a})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&c(this._statusBarCommands,s))){this._statusBarDisposables.value=new P.DisposableStore,this._statusBarCommands=s;const a=(s||[]).map(E=>this._commands.converter.toInternal(E,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:a})}}get selected(){return this._selected}createResourceGroup(s,a){const E=new t(this._proxy,this._commands,this.handle,s,a),R=D.Event.once(E.onDidDispose)(()=>this.createdResourceGroups.delete(E));return this.createdResourceGroups.set(E,R),this.eventuallyAddResourceGroups(),E}eventuallyAddResourceGroups(){const s=[],a=[];for(const[E,R]of this.createdResourceGroups){R.dispose();const g=E.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(E),this.eventuallyUpdateResourceStates()});D.Event.once(E.onDidDispose)(()=>{this.updatedResourceGroups.delete(E),g.dispose(),this._groups.delete(E.handle),this._proxy.$unregisterGroup(this.handle,E.handle)}),s.push([E.handle,E.id,E.label,E.features]);const b=E._takeResourceStateSnapshot();b.length>0&&a.push([E.handle,b]),this._groups.set(E.handle,E)}this._proxy.$registerGroups(this.handle,s,a),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(a=>{const E=a._takeResourceStateSnapshot();E.length!==0&&s.push([a.handle,E])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,je([(0,T.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),je([(0,T.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let u=class Dn{constructor(s,a,E){this._commands=a,this.logService=E,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new D.Emitter,this._proxy=s.getProxy(I.MainContext.MainThreadSCM),this._telemetry=s.getProxy(I.MainContext.MainThreadTelemetry),a.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const g=this._sourceControls.get(R.sourceControlHandle);if(!g)return R;const b=g.getResourceGroup(R.groupHandle);return b?b.getResourceState(R.handle):R}else if(R&&R.$mid===4){const g=this._sourceControls.get(R.sourceControlHandle);return g?g.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const g=this._sourceControls.get(R.handle);return g||R}return R}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,a,E,R){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,a,E,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const g=Dn._handlePool++,b=new i(s,this._proxy,this._commands,a,E,R);this._sourceControls.set(g,b);const C=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(s.identifier))||[];return C.push(b),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(s.identifier),C),b}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const a=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(s.identifier)),E=a&&a[a.length-1];return E&&E.inputBox}$provideOriginalResource(s,a,E){const R=w.URI.revive(a);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,R.toString());const g=this._sourceControls.get(s);return!g||!g.quickDiffProvider||!g.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>g.quickDiffProvider.provideOriginalResource(R,E)).then(b=>b||null)}$onInputBoxValueChange(s,a){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const E=this._sourceControls.get(s);return E&&E.inputBox.$onInputBoxValueChange(a),Promise.resolve(void 0)}$executeResourceCommand(s,a,E,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,a,E);const g=this._sourceControls.get(s);if(!g)return Promise.resolve(void 0);const b=g.getResourceGroup(a);return b?b.$executeResourceCommand(E,R):Promise.resolve(void 0)}$validateInput(s,a,E){this.logService.trace("ExtHostSCM#$validateInput",s);const R=this._sourceControls.get(s);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>R.inputBox.validateInput(a,E)).then(g=>g?Promise.resolve([g.message,g.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var a,E;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((a=this._sourceControls.get(s))===null||a===void 0||a.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((E=this._sourceControls.get(this._selectedSourceControlHandle))===null||E===void 0||E.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};u._handlePool=0,u=je([qe(2,A.ILogService)],u),e.ExtHostSCM=u});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[200],Ee([0,1,7,5,131,6]),function(oe,e,w,D,T,P){"use strict";var S,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class y{constructor(_,f,r,h,p=w.StatusBarAlignment.Left,m,v){S.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new P.DisposableStore,tt(this,S,_),tt(this,I,f),this._id=y.ID_GEN++,this._statusId=r,this._statusName=h,this._alignment=p,this._priority=m,this._accessibilityInformation=v}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var _;return(_=this._command)===null||_===void 0?void 0:_.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(_){this._text=_,this.update()}set tooltip(_){this._tooltip=_,this.update()}set color(_){this._color=_,this.update()}set backgroundColor(_){_&&!y.ALLOWED_BACKGROUND_COLORS.has(_.id)&&(_=void 0),this._backgroundColor=_,this.update()}set command(_){var f;((f=this._command)===null||f===void 0?void 0:f.fromApi)!==_&&(this._internalCommandRegistration.clear(),typeof _=="string"?this._command={fromApi:_,internal:We(this,I).toInternal({title:"",command:_},this._internalCommandRegistration)}:_?this._command={fromApi:_,internal:We(this,I).toInternal(_,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(_){this._accessibilityInformation=_,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,We(this,S).$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var _;this._timeoutHandle=void 0;let f=this._color;this._backgroundColor&&(f=y.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),We(this,S).$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(_=this._command)===null||_===void 0?void 0:_.internal,f,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=y,S=new WeakMap,I=new WeakMap,y.ID_GEN=0,y.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(_){this._messages=[],this._item=_.createStatusBarEntry("status.extensionMessage",(0,T.localize)(0,null),w.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(_){const f={message:_};return this._messages.unshift(f),this._update(),new w.Disposable(()=>{const r=this._messages.indexOf(f);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class A{constructor(_,f){this._proxy=_.getProxy(D.MainContext.MainThreadStatusBar),this._commands=f,this._statusMessage=new n(this)}createStatusBarEntry(_,f,r,h,p){return new y(this._proxy,this._commands,_,f,r,h,p)}setStatusBarMessage(_,f){const r=this._statusMessage.setMessage(_);let h;return typeof f=="number"?h=setTimeout(()=>r.dispose(),f):typeof f!="undefined"&&f.then(()=>r.dispose(),()=>r.dispose()),new w.Disposable(()=>{r.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=A}),define(we[75],Ee([0,1,5,3,4]),function(oe,e,w,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class P{constructor(I){this._onDidChangeStorage=new D.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,y){this._proxy.$registerExtensionStorageKeysToSync(I,y)}getValue(I,y,n){return this._proxy.$getValue(I,y).then(A=>A||n)}setValue(I,y,n){return this._proxy.$setValue(I,y,n)}$acceptValue(I,y,n){this._onDidChangeStorage.fire({shared:I,key:y,value:n})}}e.ExtHostStorage=P,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(we[76],Ee([0,1,4,27,19,74,2]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let I=class{constructor(n,A,k){var _;this._logService=A,this._extHostFileSystem=k,this._workspace=(_=n.workspace)!==null&&_!==void 0?_:void 0,this._environment=n.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(f=>this._value=f)}async _getOrCreateWorkspaceStoragePath(){var n;if(!this._workspace)return Promise.resolve(void 0);const A=this._workspace.id,k=S.URI.joinPath(this._environment.workspaceStorageHome,A);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(_){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(n=S.URI.revive(this._workspace.configuration))===null||n===void 0?void 0:n.toString(),name:this._workspace.name},void 0,2))),k}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(n){if(this._value)return S.URI.joinPath(this._value,n.identifier.value)}globalValue(n){return S.URI.joinPath(this._environment.globalStorageHome,n.identifier.value.toLowerCase())}};I=je([qe(0,D.IExtHostInitDataService),qe(1,T.ILogService),qe(2,P.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(we[41],Ee([0,1,3,5,4,2,14,6,7,132,10,167,20,29,151]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class h{constructor(t,i,u,l){this._proxy=t,this._id=i,this._creationOptions=u,this._name=l,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(a=>this._pidPromiseComplete=a);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(a,E=!0){s._checkDisposed(),s._proxy.$sendText(s._id,a,E)},show(a){s._checkDisposed(),s._proxy.$show(s._id,a)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,i,u,l,s,a,E,R,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:i,cwd:u,env:l,waitOnExit:s,strictEnv:a,hideFromUser:E,isFeatureTerminal:R,isExtensionOwnedTerminal:g})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,i){return t===this._cols&&i===this._rows||t===0||i===0?!1:(this._cols=t,this._rows=i,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=h;class p{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,i){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:i})}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=p;let m=1,v=class extends I.Disposable{constructor(t,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=i.getProxy(D.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[u,l]of this._terminalProcesses)l.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const i=new h(this._proxy,(0,f.generateUuid)(),t,t.name),u=new p(t.pty);return i.createExtensionTerminal().then(l=>{const s=this._setupExtHostProcessListeners(l,u);this._terminalProcessDisposables[l]=s}),this._terminals.push(i),i.value}attachPtyToTerminal(t,i){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const l=new p(i),s=this._setupExtHostProcessListeners(t,l);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const i=this._activeTerminal;if(t===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(t);u&&(this._activeTerminal=u,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,i){const u=this._getTerminalById(t);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:i})}async $acceptTerminalDimensions(t,i,u){const l=this._getTerminalById(t);l&&l.setDimensions(i,u)&&this._onDidChangeTerminalDimensions.fire({terminal:l.value,dimensions:l.value.dimensions})}async $acceptTerminalMaximumDimensions(t,i,u){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(i,u)}async $acceptTerminalTitleChange(t,i){const u=this._getTerminalById(t);u&&(u.name=i)}async $acceptTerminalClosed(t,i){const u=this._getTerminalObjectIndexById(this._terminals,t);if(u!==null){const l=this._terminals.splice(u,1)[0];l.setExitCode(i),this._onDidCloseTerminal.fire(l.value)}}$acceptTerminalOpened(t,i,u,l){if(i){const E=this._getTerminalObjectIndexById(this._terminals,i);if(E!==null){this._terminals[E]._id=t,this._onDidOpenTerminal.fire(this.terminals[E]),this._terminals[E].isOpen=!0;return}}const s={name:l.name,shellPath:l.executable,shellArgs:l.args,cwd:typeof l.cwd=="string"?l.cwd:P.URI.revive(l.cwd),env:l.env,hideFromUser:l.hideFromUser},a=new h(this._proxy,t,s,u);this._terminals.push(a),this._onDidOpenTerminal.fire(a.value),a.isOpen=!0}async $acceptTerminalProcessId(t,i){const u=this._getTerminalById(t);u&&u._setProcessId(i)}async $startExtensionTerminal(t,i){const u=this._getTerminalById(t);if(!u)return{message:(0,n.localize)(0,null,t)};u.isOpen||await new Promise(s=>{const a=this.onDidOpenTerminal(async E=>{E===u.value&&(a.dispose(),s())})});const l=this._terminalProcesses.get(t);l?l.startSendingEvents(i):this._extensionTerminalAwaitingStart[t]={initialDimensions:i}}_setupExtHostProcessListeners(t,i){const u=new I.DisposableStore;u.add(i.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),u.add(i.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,i.onProcessData),u.add(i.onProcessExit(s=>this._onProcessExit(t,s))),i.onProcessOverrideDimensions&&u.add(i.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,i);const l=this._extensionTerminalAwaitingStart[t];return l&&i instanceof p&&(i.startSendingEvents(l.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),u}$acceptProcessAckDataEvent(t,i){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.acknowledgeDataEvent(i)}$acceptProcessInput(t,i){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.input(i)}$acceptProcessResize(t,i,u){var l;try{(l=this._terminalProcesses.get(t))===null||l===void 0||l.resize(i,u)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,i){var u;(u=this._terminalProcesses.get(t))===null||u===void 0||u.shutdown(i)}$acceptProcessRequestInitialCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(t,u))}$acceptProcessRequestCwd(t){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.getCwd().then(u=>this._proxy.$sendProcessCwd(t,u))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,i){const u=this._getTerminalById(t);if(!u)return[];this._terminalLinkCache.delete(t);const l=this._terminalLinkCancellationSource.get(t);l&&l.dispose(!0);const s=new _.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const a=[],E={terminal:u.value,line:i},R=[];for(const C of this._linkProviders)R.push(new Promise(async F=>{s.token.onCancellationRequested(()=>F({provider:C,links:[]}));const x=await C.provideTerminalLinks(E,s.token)||[];s.token.isCancellationRequested||F({provider:C,links:x})}));const g=await Promise.all(R);if(s.token.isCancellationRequested)return[];const b=new Map;for(const C of g)C&&C.links.length>0&&a.push(...C.links.map(F=>{const x={id:m++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return b.set(x.id,{provider:C.provider,link:F}),x}));return this._terminalLinkCache.set(t,b),a}$activateLink(t,i){var u;const l=(u=this._terminalLinkCache.get(t))===null||u===void 0?void 0:u.get(i);!l||l.provider.handleTerminalLink(l.link)}_onProcessExit(t,i){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const u=this._terminalProcessDisposables[t];u&&(u.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,i)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,i){const u=this._getTerminalObjectIndexById(t,i);return u!==null?t[u]:null}_getTerminalObjectIndexById(t,i){let u=null;return t.some((l,s)=>l._id===i?(u=s,!0):!1),u}getEnvironmentVariableCollection(t){let i=this._environmentVariableCollections.get(t.identifier.value);return i||(i=new d,this._setEnvironmentVariableCollection(t.identifier.value,i)),i}_syncEnvironmentVariableCollection(t,i){const u=(0,k.serializeEnvironmentVariableCollection)(i.map);this._proxy.$setEnvironmentVariableCollection(t,i.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(t){t.forEach(i=>{const u=i[0],l=new d(i[1]);this._setEnvironmentVariableCollection(u,l)})}_setEnvironmentVariableCollection(t,i){this._environmentVariableCollections.set(t,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,i)})}};v=je([qe(1,S.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Replace})}append(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Append})}prepend(t,i){this._setIfDiffers(t,{value:i,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,i){const u=this.map.get(t);(!u||u.value!==i.value||u.type!==i.type)&&(this.map.set(t,i),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,i){this.map.forEach((u,l)=>t.call(i,l,u,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let c=class extends v{constructor(t){super(!1,t)}createTerminal(t,i,u){throw new A.NotSupportedError}createTerminalFromOptions(t){throw new A.NotSupportedError}getDefaultShell(t,i){return""}getDefaultShellArgs(t,i){throw new A.NotSupportedError}$getAvailableProfiles(t){throw new A.NotSupportedError}async $getDefaultShellAndArgs(t){throw new A.NotSupportedError}$acceptWorkspacePermissionsChanged(t){}};c=je([qe(0,S.IExtHostRpcService)],c),e.WorkerExtHostTerminalService=c}),define(we[201],Ee([0,1,3,15,5,95,9,7]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(A,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=A.getProxy(T.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(_=>this._onDidChangeVisibleTextEditors.fire(_)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(_=>this._onDidChangeActiveTextEditor.fire(_))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(A){const k=this._extHostDocumentsAndEditors.allEditors();return A?k:k.map(_=>_.value)}async showTextDocument(A,k,_){let f;typeof k=="number"?f={position:S.ViewColumn.from(k),preserveFocus:_}:typeof k=="object"?f={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?S.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:f={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(A.uri,f),h=r&&this._extHostDocumentsAndEditors.getEditor(r);if(h)return h.value;throw r?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A){return new P.TextEditorDecorationType(this._proxy,A).value}$acceptEditorPropertiesChanged(A,k){const _=this._extHostDocumentsAndEditors.getEditor(A);if(!_)throw new Error("unknown text editor");if(k.options&&_._acceptOptions(k.options),k.selections){const f=k.selections.selections.map(S.Selection.to);_._acceptSelections(f)}if(k.visibleRanges){const f=D.coalesce(k.visibleRanges.map(S.Range.to));_._acceptVisibleRanges(f)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:_.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const f=I.TextEditorSelectionChangeKind.fromValue(k.selections.source),r=k.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:_.value,selections:r,kind:f})}if(k.visibleRanges){const f=D.coalesce(k.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:_.value,visibleRanges:f})}}$acceptEditorPositionData(A){for(const k in A){const _=this._extHostDocumentsAndEditors.getEditor(k);if(!_)throw new Error("Unknown text editor");const f=S.ViewColumn.to(A[k]);_.value.viewColumn!==f&&(_._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:_.value,viewColumn:f}))}}getDiffInformation(A){return Promise.resolve(this._proxy.$getDiffInformation(A))}}e.ExtHostEditors=y});var an=this&&this.__rest||function(oe,e){var w={};for(var D in oe)Object.prototype.hasOwnProperty.call(oe,D)&&e.indexOf(D)<0&&(w[D]=oe[D]);if(oe!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,D=Object.getOwnPropertySymbols(oe);T<D.length;T++)e.indexOf(D[T])<0&&Object.prototype.propertyIsEnumerable.call(oe,D[T])&&(w[D[T]]=oe[D[T]]);return w};define(we[202],Ee([0,1,2,4,5,6,7]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,D.createDecorator)("IExtHostTimeline");class I{constructor(A,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=A.getProxy(T.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:_=>{var f,r;if(_&&_.$mid===11){const h=_.uri===void 0?void 0:w.URI.revive(_.uri);return(r=(f=this._itemsBySourceAndUriMap.get(_.source))===null||f===void 0?void 0:f.get(y(h)))===null||r===void 0?void 0:r.get(_.handle)}return _}})}async $getTimeline(A,k,_,f,r){const h=this._providers.get(A);return h==null?void 0:h.provideTimeline(w.URI.revive(k),_,f,r)}registerTimelineProvider(A,k,_,f){const r=new P.DisposableStore,h=this.convertTimelineItem(k.id,f,r).bind(this);let p;k.onDidChange&&(p=k.onDidChange(v=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},v),{id:k.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:A,onDidChange:void 0,async provideTimeline(v,d,c,o){var t;(o==null?void 0:o.resetCache)&&(r.clear(),(t=m.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(v,d,c);if(i!=null){const u=h(v,o);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(u)})}},dispose(){var v;for(const d of m.values())(v=d.get(k.id))===null||v===void 0||v.clear();p==null||p.dispose(),r.dispose()}}))}convertTimelineItem(A,k,_){return(f,r)=>{let h;if(r==null?void 0:r.cacheResults){let p=this._itemsBySourceAndUriMap.get(A);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(A,p));const m=y(f);h=p.get(m),h===void 0&&(h=new Map,p.set(m,h))}return p=>{var m,v;const{iconPath:d}=p,c=an(p,["iconPath"]),o=`${A}|${(m=p.id)!==null&&m!==void 0?m:p.timestamp}`;h==null||h.set(o,p);let t,i,u;return p.iconPath&&(d instanceof S.ThemeIcon?u={id:d.id}:w.URI.isUri(d)?(t=d,i=d):{light:t,dark:i}=d),Object.assign(Object.assign({},c),{id:(v=c.id)!==null&&v!==void 0?v:void 0,handle:o,source:A,command:p.command?k.toInternal(p.command,_):void 0,icon:t,iconDark:i,themeIcon:u,accessibilityInformation:p.accessibilityInformation})}}}registerTimelineProviderCore(A){if(this._providers.get(A.id))throw new Error(`Timeline Provider ${A.id} already exists.`);return this._proxy.$registerTimelineProvider({id:A.id,label:A.label,scheme:A.scheme}),this._providers.set(A.id,A),(0,P.toDisposable)(()=>{var _;for(const f of this._itemsBySourceAndUriMap.values())(_=f.get(A.id))===null||_===void 0||_.clear();this._providers.delete(A.id),this._proxy.$unregisterTimelineProvider(A.id),A.dispose()})}}e.ExtHostTimeline=I;function y(n){return n==null?void 0:n.toString()}}),define(we[203],Ee([0,1,6,16,2,5]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this._openers=new Map,this._proxy=y.getProxy(P.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,n,A,k){if(this._openers.has(n))throw new Error(`Opener with id '${n}' already registered`);const _=k.schemes.find(f=>!S.supportedSchemes.has(f));if(_)throw new Error(`Scheme '${_}' is not supported. Only http and https are currently supported.`);return this._openers.set(n,A),this._proxy.$registerUriOpener(n,k.schemes,y,k.label),(0,w.toDisposable)(()=>{this._openers.delete(n),this._proxy.$unregisterUriOpener(n)})}async $canOpenUri(y,n,A){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener with id: ${y}`);const _=T.URI.revive(n);return k.canOpenExternalUri(_,A)}async $openUri(y,n,A){const k=this._openers.get(y);if(!k)throw new Error(`Unknown opener id: '${y}'`);return k.openExternalUri(T.URI.revive(n.resolvedUri),{sourceUri:T.URI.revive(n.sourceUri)},A)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([D.Schemas.http,D.Schemas.https])}),define(we[204],Ee([0,1,5,2,6,10,25]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(n){this.handles=new Set,this.handlers=new Map,this._proxy=n.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(n,A){if(this.handles.has(S.ExtensionIdentifier.toKey(n)))throw new Error(`Protocol handler already registered for extension ${n}`);const k=I.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(n)),this.handlers.set(k,A),this._proxy.$registerUriHandler(k,n),(0,T.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(n)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(n,A){const k=this.handlers.get(n);if(!k)return Promise.resolve(void 0);try{k.handleUri(D.URI.revive(A))}catch(_){(0,P.onUnexpectedError)(_)}return Promise.resolve(void 0)}async createAppUri(n){return D.URI.revive(await this._proxy.$createAppUri(n))}}e.ExtHostUrls=I,I.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[50],Ee([0,1,3,2,69,5]),function(oe,e,w,D,T,P){"use strict";var S,I,y,n,A,k,_,f,r,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.ExtHostWebview=void 0;class m{constructor(u,l,s,a,E,R,g){S.set(this,void 0),I.set(this,void 0),y.set(this,void 0),n.set(this,void 0),A.set(this,void 0),k.set(this,void 0),_.set(this,""),f.set(this,void 0),r.set(this,!1),h.set(this,!1),this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new w.Emitter),this._onDidDispose=We(this,p).event,tt(this,S,u),tt(this,I,l),tt(this,f,s),tt(this,n,a),tt(this,A,E),tt(this,k,R),tt(this,y,g)}dispose(){tt(this,r,!0),We(this,p).fire(),We(this,p).dispose(),this._onMessageEmitter.dispose()}asWebviewUri(u){return tt(this,h,!0),(0,T.asWebviewUri)(We(this,n),We(this,S),u)}get cspSource(){return We(this,n).webviewCspSource.replace("{{uuid}}",We(this,S))}get html(){return this.assertNotDisposed(),We(this,_)}set html(u){this.assertNotDisposed(),We(this,_)!==u&&(tt(this,_,u),!We(this,h)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(u)&&(tt(this,h,!0),We(this,y).report("Webview vscode-resource: uris",We(this,k),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,I).$setHtml(We(this,S),u))}get options(){return this.assertNotDisposed(),We(this,f)}set options(u){this.assertNotDisposed(),We(this,I).$setOptions(We(this,S),c(We(this,k),We(this,A),u)),tt(this,f,u)}async postMessage(u){return We(this,r)?!1:We(this,I).$postMessage(We(this,S),u)}assertNotDisposed(){if(We(this,r))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,S=new WeakMap,I=new WeakMap,y=new WeakMap,n=new WeakMap,A=new WeakMap,k=new WeakMap,_=new WeakMap,f=new WeakMap,r=new WeakMap,h=new WeakMap,p=new WeakMap;class v{constructor(u,l,s,a,E){this.initData=l,this.workspace=s,this._logService=a,this._deprecationService=E,this._webviews=new Map,this._webviewProxy=u.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(u,l){const s=this.getWebview(u);s&&s._onMessageEmitter.fire(l)}$onMissingCsp(u,l){this._logService.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(u,l,s){const a=new m(u,this._webviewProxy,o(l),this.initData,this.workspace,s,this._deprecationService);return this._webviews.set(u,a),a._onDidDispose(()=>{this._webviews.delete(u)}),a}deleteWebview(u){this._webviews.delete(u)}getWebview(u){return this._webviews.get(u)}}e.ExtHostWebviews=v;function d(i){return{id:i.identifier,location:i.extensionLocation}}e.toExtensionData=d;function c(i,u,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||t(i,u)}}e.serializeWebviewOptions=c;function o(i){var u;return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,portMapping:i.portMapping,localResourceRoots:(u=i.localResourceRoots)===null||u===void 0?void 0:u.map(l=>D.URI.from(l))}}e.reviveOptions=o;function t(i,u){return[...((u==null?void 0:u.getWorkspaceFolders())||[]).map(l=>l.uri),i.extensionLocation]}}),define(we[205],Ee([0,1,20,56,6,16,24,2,9,50,92,5,7]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new A.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=c(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class r{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,u){const l=this.key(t,i.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const s=new f(i,u);return this._documents.set(l,s),s}delete(t,i){const u=this.key(t,i.uri);this._documents.delete(u)}key(t,i){return`${t}@@@${i}`}}var h;(function(o){o[o.Text=0]="Text",o[o.Custom=1]="Custom"})(h||(h={}));class p{constructor(){this._providers=new Map}addTextProvider(t,i,u){return this.add(0,t,i,u)}addCustomProvider(t,i,u){return this.add(1,t,i,u)}get(t){return this._providers.get(t)}add(t,i,u,l){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:u,provider:l}),new _.Disposable(()=>this._providers.delete(i))}}class m{constructor(t,i,u,l,s){this._extHostDocuments=i,this._extensionStoragePaths=u,this._extHostWebview=l,this._extHostWebviewPanels=s,this._editorProviders=new p,this._documents=new r,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,u,l){const s=new T.DisposableStore;return v(u)?(s.add(this._editorProviders.addTextProvider(i,t,u)),this._proxy.$registerTextEditorProvider((0,n.toExtensionData)(t),i,l.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor})):(s.add(this._editorProviders.addCustomProvider(i,t,u)),this.supportEditing(u)&&s.add(u.onDidChangeCustomDocument(a=>{const E=this.getCustomDocumentEntry(i,a.document.uri);if(d(a)){const R=E.addEdit(a);this._proxy.$onDidEdit(a.document.uri,i,R,a.label)}else this._proxy.$onContentChange(a.document.uri,i)})),this._proxy.$registerCustomEditorProvider((0,n.toExtensionData)(t),i,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument)),_.Disposable.from(s,new _.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,u,l,s){var a;const E=this._editorProviders.get(i);if(!E)throw new Error(`No provider found for '${i}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${i}'`);const R=I.URI.revive(t),g=await E.provider.openCustomDocument(R,{backupId:u,untitledDocumentData:l==null?void 0:l.buffer},s);let b;return this.supportEditing(E.provider)&&this._extensionStoragePaths&&(b=(a=this._extensionStoragePaths.workspaceValue(E.extension))!==null&&a!==void 0?a:this._extensionStoragePaths.globalValue(E.extension)),this._documents.add(i,g,b),{editable:this.supportEditing(E.provider)}}async $disposeCustomDocument(t,i){const u=this._editorProviders.get(i);if(!u)throw new Error(`No provider found for '${i}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${i}'`);const l=I.URI.revive(t),{document:s}=this.getCustomDocumentEntry(i,l);this._documents.delete(i,s),s.dispose()}async $resolveWebviewEditor(t,i,u,l,s,a){const E=this._editorProviders.get(u);if(!E)throw new Error(`No provider found for '${u}'`);const R=y.ViewColumn.to(s),g=this._extHostWebview.createNewWebview(i,l.webviewOptions,E.extension),b=this._extHostWebviewPanels.createNewWebviewPanel(i,u,l.title,R,l.panelOptions,g),C=I.URI.revive(t);switch(E.type){case 1:{const{document:F}=this.getCustomDocumentEntry(u,C);return E.provider.resolveCustomEditor(F,b,a)}case 0:{const F=this._extHostDocuments.getDocument(C);return E.provider.resolveCustomTextEditor(F,b,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,u){this.getCustomDocumentEntry(i,t).disposeEdits(u)}async $onMoveCustomEditor(t,i,u){const l=this._editorProviders.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const a=I.URI.revive(i),E=this._extHostDocuments.getDocument(a);await l.provider.moveCustomTextEditor(E,s,w.CancellationToken.None)}async $undo(t,i,u,l){return this.getCustomDocumentEntry(i,t).undo(u,l)}async $redo(t,i,u,l){return this.getCustomDocumentEntry(i,t).redo(u,l)}async $revert(t,i,u){const l=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(l.document,u),l.disposeBackup()}async $onSave(t,i,u){const l=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(l.document,u),l.disposeBackup()}async $onSaveAs(t,i,u,l){const s=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(s.document,I.URI.revive(u),l)}async $backup(t,i,u){const l=this.getCustomDocumentEntry(i,t),a=await this.getCustomEditorProvider(i).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},u);return l.updateBackup(a),a.id}getCustomDocumentEntry(t,i){const u=this._documents.get(t,I.URI.revive(i));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(t){const i=this._editorProviders.get(t),u=i==null?void 0:i.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function v(o){return typeof o.resolveCustomTextEditor=="function"}function d(o){return typeof o.undo=="function"&&typeof o.redo=="function"}function c(o){const t=o.scheme===P.Schemas.file||o.scheme===P.Schemas.untitled?o.fsPath:o.toString();return(0,D.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[206],Ee([0,1,3,6,2,29,9,50,5,7]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";var A,k,_,f,r,h,p,m,v,d,c,o,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends D.Disposable{constructor(a,E,R,g,b,C,F){super();A.set(this,void 0),k.set(this,void 0),_.set(this,void 0),f.set(this,void 0),r.set(this,void 0),h.set(this,void 0),p.set(this,void 0),m.set(this,void 0),v.set(this,!0),d.set(this,!0),c.set(this,!1),o.set(this,this._register(new w.Emitter)),this.onDidDispose=We(this,o).event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=We(this,t).event,tt(this,A,a),tt(this,k,E),tt(this,_,R),tt(this,r,C),tt(this,m,b),tt(this,h,g),tt(this,f,F)}dispose(){We(this,c)||(tt(this,c,!0),We(this,o).fire(),We(this,k).$disposeWebview(We(this,A)),We(this,f).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,f)}get viewType(){return this.assertNotDisposed(),We(this,_)}get title(){return this.assertNotDisposed(),We(this,h)}set title(a){this.assertNotDisposed(),We(this,h)!==a&&(tt(this,h,a),We(this,k).$setTitle(We(this,A),a))}get iconPath(){return this.assertNotDisposed(),We(this,p)}set iconPath(a){this.assertNotDisposed(),We(this,p)!==a&&(tt(this,p,a),We(this,k).$setIconPath(We(this,A),T.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return We(this,r)}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,m)=="number"&&We(this,m)<0))return We(this,m)}get active(){return this.assertNotDisposed(),We(this,d)}get visible(){return this.assertNotDisposed(),We(this,v)}_updateViewState(a){We(this,c)||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(tt(this,d,a.active),tt(this,v,a.visible),tt(this,m,a.viewColumn),We(this,t).fire({webviewPanel:this}))}reveal(a,E){this.assertNotDisposed(),We(this,k).$reveal(We(this,A),{viewColumn:a?S.ViewColumn.from(a):void 0,preserveFocus:!!E})}assertNotDisposed(){if(We(this,c))throw new Error("Webview is disposed")}}A=new WeakMap,k=new WeakMap,_=new WeakMap,f=new WeakMap,r=new WeakMap,h=new WeakMap,p=new WeakMap,m=new WeakMap,v=new WeakMap,d=new WeakMap,c=new WeakMap,o=new WeakMap,t=new WeakMap;class u{constructor(a,E,R){this.webviews=E,this.workspace=R,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,P.generateUuid)()}createWebviewPanel(a,E,R,g,b={}){const C=typeof g=="object"?g.viewColumn:g,F={viewColumn:S.ViewColumn.from(C),preserveFocus:typeof g=="object"&&!!g.preserveFocus},x=u.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(a),x,E,{title:R,panelOptions:l(b),webviewOptions:(0,I.serializeWebviewOptions)(a,this.workspace,b)},F);const le=this.webviews.createNewWebview(x,b,a);return this.createNewWebviewPanel(x,E,R,C,b,le)}$onDidChangeWebviewPanelViewStates(a){const E=Object.keys(a);E.sort((R,g)=>{const b=a[R],C=a[g];return b.active?1:C.active?-1:+b.visible-+C.visible});for(const R of E){const g=this.getWebviewPanel(R);if(!!g){const b=a[R];g._updateViewState({active:b.active,visible:b.visible,viewColumn:S.ViewColumn.to(b.position)})}}}async $onDidDisposeWebviewPanel(a){const E=this.getWebviewPanel(a);E==null||E.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,E,R){if(this._serializers.has(E))throw new Error(`Serializer for '${E}' already registered`);return this._serializers.set(E,{serializer:R,extension:a}),this._proxy.$registerSerializer(E),new n.Disposable(()=>{this._serializers.delete(E),this._proxy.$unregisterSerializer(E)})}async $deserializeWebviewPanel(a,E,R,g){const b=this._serializers.get(E);if(!b)throw new Error(`No serializer found for '${E}'`);const{serializer:C,extension:F}=b,x=this.webviews.createNewWebview(a,R.webviewOptions,F),le=this.createNewWebviewPanel(a,E,R.title,g,R.panelOptions,x);await C.deserializeWebviewPanel(le,R.state)}createNewWebviewPanel(a,E,R,g,b,C){const F=new i(a,this._proxy,E,R,g,b,C);return this._webviewPanels.set(a,F),F}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=u;function l(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[207],Ee([0,1,3,6,50,5,7]),function(oe,e,w,D,T,P,S){"use strict";var I,y,n,A,k,_,f,r,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends D.Disposable{constructor(c,o,t,i,u,l){super();I.set(this,void 0),y.set(this,void 0),n.set(this,void 0),A.set(this,void 0),k.set(this,!1),_.set(this,void 0),f.set(this,void 0),r.set(this,void 0),h.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=We(this,h).event,p.set(this,this._register(new w.Emitter)),this.onDidDispose=We(this,p).event,tt(this,n,t),tt(this,f,i),tt(this,I,c),tt(this,y,o),tt(this,A,u),tt(this,_,l)}dispose(){We(this,k)||(tt(this,k,!0),We(this,p).fire(),We(this,A).dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,f)}set title(c){this.assertNotDisposed(),We(this,f)!==c&&(tt(this,f,c),We(this,y).$setWebviewViewTitle(We(this,I),c))}get description(){return this.assertNotDisposed(),We(this,r)}set description(c){this.assertNotDisposed(),We(this,r)!==c&&(tt(this,r,c),We(this,y).$setWebviewViewDescription(We(this,I),c))}get visible(){return We(this,_)}get webview(){return We(this,A)}get viewType(){return We(this,n)}_setVisible(c){c===We(this,_)||We(this,k)||(tt(this,_,c),We(this,h).fire())}show(c){this.assertNotDisposed(),We(this,y).$show(We(this,I),!!c)}assertNotDisposed(){if(We(this,k))throw new Error("Webview is disposed")}}I=new WeakMap,y=new WeakMap,n=new WeakMap,A=new WeakMap,k=new WeakMap,_=new WeakMap,f=new WeakMap,r=new WeakMap,h=new WeakMap,p=new WeakMap;class v{constructor(c,o){this._extHostWebview=o,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(P.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,o,t,i){if(this._viewProviders.has(o))throw new Error(`View provider for '${o}' already registered`);return this._viewProviders.set(o,{provider:t,extension:c}),this._proxy.$registerWebviewViewProvider((0,T.toExtensionData)(c),o,i),new S.Disposable(()=>{this._viewProviders.delete(o),this._proxy.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(c,o,t,i,u){const l=this._viewProviders.get(o);if(!l)throw new Error(`No view provider found for '${o}'`);const{provider:s,extension:a}=l,E=this._extHostWebview.createNewWebview(c,{},a),R=new m(c,this._proxy,o,t,E,!0);this._webviewViews.set(c,R),await s.resolveWebviewView(R,{state:i},u)}async $onDidChangeWebviewViewVisibility(c,o){this.getWebviewView(c)._setVisible(o)}async $disposeWebviewView(c){const o=this.getWebviewView(c);this._webviewViews.delete(c),o.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const o=this._webviewViews.get(c);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=v}),define(we[99],Ee([0,1,3,5,2,16,8,4,14]),function(oe,e,w,D,T,P,S,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let n=class Cn{constructor(k){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Cn.InitialState,this._proxy=k.getProxy(D.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(_=>this.$onDidChangeWindowFocus(_))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,_){let f;if(typeof k=="string"){f=k;try{k=T.URI.parse(k)}catch(r){return Promise.reject(`Invalid uri - '${k}'`)}}return(0,S.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,f,_)}async asExternalUri(k,_){if((0,S.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([P.Schemas.http,P.Schemas.https]).has(k.scheme))return Promise.reject(`Invalid scheme '${k.scheme}'`);const f=await this._proxy.$asExternalUri(k,_);return T.URI.from(f)}};n.InitialState={focused:!0},n=je([qe(0,y.IExtHostRpcService)],n),e.ExtHostWindow=n,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(we[208],Ee([0,1,19,5,27,14]),function(oe,e,w,D,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends w.AbstractLogger{constructor(y,n){super();this._proxy=y.getProxy(D.MainContext.MainThreadLog),this._logFile=n.logFile.toJSON(),this.setLevel(n.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...n){this.getLevel()<=w.LogLevel.Trace&&this._proxy.$log(this._logFile,w.LogLevel.Trace,Array.from(arguments))}debug(y,...n){this.getLevel()<=w.LogLevel.Debug&&this._proxy.$log(this._logFile,w.LogLevel.Debug,Array.from(arguments))}info(y,...n){this.getLevel()<=w.LogLevel.Info&&this._proxy.$log(this._logFile,w.LogLevel.Info,Array.from(arguments))}warn(y,...n){this.getLevel()<=w.LogLevel.Warning&&this._proxy.$log(this._logFile,w.LogLevel.Warning,Array.from(arguments))}error(y,...n){this.getLevel()<=w.LogLevel.Error&&this._proxy.$log(this._logFile,w.LogLevel.Error,Array.from(arguments))}critical(y,...n){this.getLevel()<=w.LogLevel.Critical&&this._proxy.$log(this._logFile,w.LogLevel.Critical,Array.from(arguments))}flush(){}};S=je([qe(0,P.IExtHostRpcService),qe(1,T.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(we[209],Ee([0,1,13,20,10,3,6,110,182,96,26]),function(oe,e,w,D,T,P,S,I,y,n,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function _(l,s){try{return JSON.stringify(l,s)}catch(a){return"null"}}function f(l,s){return JSON.stringify(l,s)}function r(l){return l?(s,a)=>a&&a.$mid===1?l.transformOutgoing(a):a:null}var h;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},v=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class c extends S.Disposable{constructor(s,a=null,E=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=a,this._uriTransformer=E,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let R=0,g=n.ProxyIdentifier.count;R<g;R++)this._locals[R]=null,this._proxies[R]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(R=>this._receiveOneMessage(R))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+c.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,I.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:a,sid:E}=s;return this._proxies[a]||(this._proxies[a]=this._createProxy(a,E)),this._proxies[a]}_createProxy(s,a){let E={get:(R,g)=>(typeof g=="string"&&!R[g]&&g.charCodeAt(0)===36&&(R[g]=(...b)=>this._remoteCall(s,g,b)),g===d?a:R[g])};return new Proxy(Object.create(null),E)}set(s,a){return this._locals[s.nid]=a,a}assertRegistered(s){for(let a=0,E=s.length;a<E;a++){const R=s[a];if(!this._locals[R.nid])throw new Error(`Missing actor ${R.sid} (isMain: ${R.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const a=s.byteLength,E=o.read(s,0),R=E.readUInt8(),g=E.readUInt32();switch(R){case 1:case 2:{let{rpcId:b,method:C,args:F}=t.deserializeRequestJSONArgs(E);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(a,g,b,C,F,R===2);break}case 3:case 4:{let{rpcId:b,method:C,args:F}=t.deserializeRequestMixedArgs(E);this._uriTransformer&&(F=(0,I.transformIncomingURIs)(F,this._uriTransformer)),this._receiveRequest(a,g,b,C,F,R===4);break}case 5:{this._logger&&this._logger.logIncoming(a,g,0,"ack"),this._onDidReceiveAcknowledge(g);break}case 6:{this._receiveCancel(a,g);break}case 7:{this._receiveReply(a,g,void 0);break}case 9:{let b=t.deserializeReplyOKJSON(E);this._uriTransformer&&(b=(0,I.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReply(a,g,b);break}case 8:{let b=t.deserializeReplyOKVSBuffer(E);this._receiveReply(a,g,b);break}case 10:{let b=t.deserializeReplyErrError(E);this._uriTransformer&&(b=(0,I.transformIncomingURIs)(b,this._uriTransformer)),this._receiveReplyErr(a,g,b);break}case 11:{this._receiveReplyErr(a,g,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,a,E,R,g,b){this._logger&&this._logger.logIncoming(s,a,1,`receiveRequest ${(0,n.getStringIdentifierForProxy)(E)}.${R}(`,g);const C=String(a);let F,x;if(b){const B=new D.CancellationTokenSource;g.push(B.token),F=this._invokeHandler(E,R,g),x=()=>B.cancel()}else F=this._invokeHandler(E,R,g),x=m;this._cancelInvokedHandlers[C]=x;const le=t.serializeAcknowledged(a);this._logger&&this._logger.logOutgoing(le.byteLength,a,1,"ack"),this._protocol.send(le),F.then(B=>{delete this._cancelInvokedHandlers[C];const H=t.serializeReplyOK(a,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,a,1,"reply:",B),this._protocol.send(H)},B=>{delete this._cancelInvokedHandlers[C];const H=t.serializeReplyErr(a,B);this._logger&&this._logger.logOutgoing(H.byteLength,a,1,"replyErr:",B),this._protocol.send(H)})}_receiveCancel(s,a){this._logger&&this._logger.logIncoming(s,a,1,"receiveCancel");const E=String(a);this._cancelInvokedHandlers[E]&&this._cancelInvokedHandlers[E]()}_receiveReply(s,a,E){this._logger&&this._logger.logIncoming(s,a,0,"receiveReply:",E);const R=String(a);if(!!this._pendingRPCReplies.hasOwnProperty(R)){const g=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R],g.resolveOk(E)}}_receiveReplyErr(s,a,E){this._logger&&this._logger.logIncoming(s,a,0,"receiveReplyErr:",E);const R=String(a);if(!!this._pendingRPCReplies.hasOwnProperty(R)){const g=this._pendingRPCReplies[R];delete this._pendingRPCReplies[R];let b;E&&(E.$isError?(b=new Error,b.name=E.name,b.message=E.message,b.stack=E.stack):b=E),g.resolveErr(b)}}_invokeHandler(s,a,E){try{return Promise.resolve(this._doInvokeHandler(s,a,E))}catch(R){return Promise.reject(R)}}_doInvokeHandler(s,a,E){const R=this._locals[s];if(!R)throw new Error("Unknown actor "+(0,n.getStringIdentifierForProxy)(s));let g=R[a];if(typeof g!="function")throw new Error("Unknown method "+a+" on actor "+(0,n.getStringIdentifierForProxy)(s));return g.apply(R,E)}_remoteCall(s,a,E){if(this._isDisposed)return Promise.reject(T.canceled());let R=null;if(E.length>0&&D.CancellationToken.isCancellationToken(E[E.length-1])&&(R=E.pop()),R&&R.isCancellationRequested)return Promise.reject(T.canceled());const g=t.serializeRequestArguments(E,this._uriReplacer),b=++this._lastMessageId,C=String(b),F=new y.LazyPromise;R&&R.onCancellationRequested(()=>{const le=t.serializeCancel(b);this._logger&&this._logger.logOutgoing(le.byteLength,b,0,"cancel"),this._protocol.send(t.serializeCancel(b))}),this._pendingRPCReplies[C]=F,this._onWillSendRequest(b);const x=t.serializeRequest(b,s,a,g,!!R);return this._logger&&this._logger.logOutgoing(x.byteLength,b,0,`request: ${(0,n.getStringIdentifierForProxy)(s)}.${a}(`,E),this._protocol.send(x),F}}e.RPCProtocol=c,k=v,c.UNRESPONSIVE_TIME=3*1e3;class o{constructor(s,a){this._buff=s,this._offset=a}static alloc(s,a,E){let R=new o(A.VSBuffer.alloc(E+1+4),0);return R.writeUInt8(s),R.writeUInt32(a),R}static read(s,a){return new o(s,a)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const E=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,E}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const E=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,E}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const a=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,a}static sizeMixedArray(s,a){let E=0;E+=1;for(let R=0,g=s.length;R<g;R++){const b=s[R],C=a[R];switch(E+=1,C){case 1:E+=this.sizeLongString(b);break;case 2:E+=this.sizeVSBuffer(b);break;case 3:break}}return E}writeMixedArray(s,a){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let E=0,R=s.length;E<R;E++){const g=s[E];switch(a[E]){case 1:this.writeUInt8(1),this.writeLongString(g);break;case 2:this.writeUInt8(2),this.writeVSBuffer(g);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let a=new Array(s);for(let E=0;E<s;E++)switch(this.readUInt8()){case 1:a[E]=this.readLongString();break;case 2:a[E]=this.readVSBuffer();break;case 3:a[E]=void 0;break}return a}}class t{static _arrayContainsBufferOrUndefined(s){for(let a=0,E=s.length;a<E;a++)if(s[a]instanceof A.VSBuffer||typeof s[a]=="undefined")return!0;return!1}static serializeRequestArguments(s,a){if(this._arrayContainsBufferOrUndefined(s)){let E=[],R=[];for(let g=0,b=s.length;g<b;g++){const C=s[g];C instanceof A.VSBuffer?(E[g]=C,R[g]=2):typeof C=="undefined"?(E[g]=A.VSBuffer.alloc(0),R[g]=3):(E[g]=A.VSBuffer.fromString(f(C,a)),R[g]=1)}return{type:"mixed",args:E,argsType:R}}return{type:"simple",args:f(s,a)}}static serializeRequest(s,a,E,R,g){return R.type==="mixed"?this._requestMixedArgs(s,a,E,R.args,R.argsType,g):this._requestJSONArgs(s,a,E,R.args,g)}static _requestJSONArgs(s,a,E,R,g){const b=A.VSBuffer.fromString(E),C=A.VSBuffer.fromString(R);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(b),F+=o.sizeLongString(C);let x=o.alloc(g?2:1,s,F);return x.writeUInt8(a),x.writeShortString(b),x.writeLongString(C),x.buffer}static deserializeRequestJSONArgs(s){const a=s.readUInt8(),E=s.readShortString(),R=s.readLongString();return{rpcId:a,method:E,args:JSON.parse(R)}}static _requestMixedArgs(s,a,E,R,g,b){const C=A.VSBuffer.fromString(E);let F=0;F+=o.sizeUInt8(),F+=o.sizeShortString(C),F+=o.sizeMixedArray(R,g);let x=o.alloc(b?4:3,s,F);return x.writeUInt8(a),x.writeShortString(C),x.writeMixedArray(R,g),x.buffer}static deserializeRequestMixedArgs(s){const a=s.readUInt8(),E=s.readShortString(),R=s.readMixedArray(),g=new Array(R.length);for(let b=0,C=R.length;b<C;b++){const F=R[b];typeof F=="string"?g[b]=JSON.parse(F):g[b]=F}return{rpcId:a,method:E,args:g}}static serializeAcknowledged(s){return o.alloc(5,s,0).buffer}static serializeCancel(s){return o.alloc(6,s,0).buffer}static serializeReplyOK(s,a,E){return typeof a=="undefined"?this._serializeReplyOKEmpty(s):a instanceof A.VSBuffer?this._serializeReplyOKVSBuffer(s,a):this._serializeReplyOKJSON(s,_(a,E))}static _serializeReplyOKEmpty(s){return o.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,a){let E=0;E+=o.sizeVSBuffer(a);let R=o.alloc(8,s,E);return R.writeVSBuffer(a),R.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,a){const E=A.VSBuffer.fromString(a);let R=0;R+=o.sizeLongString(E);let g=o.alloc(9,s,R);return g.writeLongString(E),g.buffer}static deserializeReplyOKJSON(s){const a=s.readLongString();return JSON.parse(a)}static serializeReplyErr(s,a){return a?this._serializeReplyErrEror(s,a):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,a){const E=A.VSBuffer.fromString(_(T.transformErrorForSerialization(a),null));let R=0;R+=o.sizeLongString(E);let g=o.alloc(10,s,R);return g.writeLongString(E),g.buffer}static deserializeReplyErrError(s){const a=s.readLongString();return JSON.parse(a)}static _serializeReplyErrEmpty(s){return o.alloc(11,s,0).buffer}}var i;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyErrError=10]="ReplyErrError",l[l.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var u;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.Undefined=3]="Undefined"})(u||(u={}))}),define(we[210],Ee([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(P){const S=I=>{self.removeEventListener("message",S);const y=I.data;Object.defineProperties(self,{postMessage:{value(n,A){y.postMessage(n,A)}},onmessage:{get(){return y.onmessage},set(n){y.onmessage=n}}}),y.addEventListener("message",n=>{self.dispatchEvent(new MessageEvent("message",{data:n.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(P)};self.addEventListener("message",S)}.toString();class D extends EventTarget{constructor(P,S,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${w})('${S}'))`,n=new Blob([y],{type:"application/javascript"}),A=URL.createObjectURL(n),k=new MessageChannel,_=A,f={type:"_newWorker",id:_,port:k.port2,url:A,options:I};P(f,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:_};k.port1.postMessage(r),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(r){k.port1.onmessage=r}},onmessageerror:{get(){return k.port1.onmessageerror},set(r){k.port1.onmessageerror=r}}}),k.port1.addEventListener("messageerror",r=>{const h=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(h)}),k.port1.addEventListener("message",r=>{const h=new MessageEvent("message",{data:r.data});this.dispatchEvent(h)}),k.port1.start()}}e.NestedWorker=D}),define(we[211],Ee([0,1,4]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(we[212],Ee([0,1,16,11,21,2,4,211]),function(oe,e,w,D,T,P,S,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let y=class{constructor(A,k){this.localUserHome=A,this.remoteAgentService=k,this.resolveOS=(async()=>{const _=await this.remoteAgentService.getEnvironment();return(_==null?void 0:_.os)||T.OS})(),this.resolveUserHome=(async()=>{const _=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(_==null?void 0:_.userHome)||A})()}async userHome(A){return(A==null?void 0:A.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(A=>A===1?D.win32:D.posix)}async fileURI(A){let k="";if(await this.resolveOS===1&&(A=A.replace(/\\/g,"/")),A[0]==="/"&&A[1]==="/"){const f=A.indexOf("/",2);f===-1?(k=A.substring(2),A="/"):(k=A.substring(2,f),A=A.substring(f)||"/")}return P.URI.from({scheme:w.Schemas.file,authority:k,path:A,query:"",fragment:""})}};y=je([qe(1,I.IRemoteAgentService)],y),e.AbstractPathService=y}),define(we[42],Ee([0,1,15,28,23,38,8,4,11,10]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const A="\u27EA ",k=" characters skipped \u27EB",_=(A.length+k.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var f;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var r;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(r=e.QueryType||(e.QueryType={}));function h(L){return!!L.preview}e.resultIsMatch=h;function p(L){return!!L.resource}e.isFileMatch=p;function m(L){return!!L.message}e.isProgressMessage=m;var v;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(v=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor($){this.resource=$,this.results=[]}}e.FileMatch=d;class c{constructor($,U,Q){this.ranges=U;const N=Array.isArray(U)?U:[U];if(Q&&Q.matchLines===1&&o(N)){$=(0,S.getNLines)($,Q.matchLines);let Z="",ne=0,re=0;const ye=Math.floor(Q.charsPerLine/5),Ae=[];for(const Be of N){const Re=Math.max(Be.startColumn-ye,0),xe=Be.startColumn+Q.charsPerLine;if(Re>re+ye+_){const W=A+(Re-re)+k;Z+=W+$.slice(Re,xe),ne+=Re-(re+W.length)}else Z+=$.slice(re,xe);Ae.push(new i(0,Be.startColumn-ne,Be.endColumn-ne)),re=xe}this.preview={text:Z,matches:Array.isArray(this.ranges)?Ae:Ae[0]}}else{const Z=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:$,matches:(0,w.mapArrayOrNot)(U,ne=>new t(ne.startLineNumber-Z,ne.startColumn,ne.endLineNumber-Z,ne.endColumn))}}}}e.TextSearchMatch=c;function o(L){const $=L[0].startLineNumber;for(const U of L)if(U.startLineNumber!==$||U.endLineNumber!==$)return!1;return!0}class t{constructor($,U,Q,N){this.startLineNumber=$,this.startColumn=U,this.endLineNumber=Q,this.endColumn=N}}e.SearchRange=t;class i extends t{constructor($,U,Q){super($,U,$,Q)}}e.OneLineRange=i;var u;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function l(L,$=!0){const U=L&&L.files&&L.files.exclude,Q=$&&L&&L.search&&L.search.exclude;if(!(!U&&!Q)){if(!U||!Q)return U||Q;let N=Object.create(null);return N=T.mixin(N,T.deepClone(U)),N=T.mixin(N,T.deepClone(Q),!0),N}}e.getExcludes=l;function s(L,$){return L.excludePattern&&D.match(L.excludePattern,$)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&D.match(L.includePattern,$)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(U=>{const Q=U.folder.fsPath;if(P.isEqualOrParent($,Q)){const N=y.relative(Q,$);return!U.includePattern||!!D.match(U.includePattern,N)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var a;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(a=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor($,U){super($);this.code=U}}e.SearchError=E;function R(L){const $=L.message;if((0,n.isPromiseCanceledError)(L))return new E($,a.canceled);try{const U=JSON.parse($);return new E(U.message,U.code)}catch(U){return new E($,a.other)}}e.deserializeSearchError=R;function g(L){const $={message:L.message,code:L.code};return new Error(JSON.stringify($))}e.serializeSearchError=g;function b(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=b;function C(L){return L.type==="success"}e.isSerializedSearchSuccess=C;function F(L){return!!L.path}e.isSerializedFileMatch=F;function x(L,$){const U=L.searchPath?L.searchPath:L.relativePath;return(0,S.fuzzyContains)(U,$)}e.isFilePatternMatch=x;class le{constructor($){this.path=$,this.results=[]}addMatch($){this.results.push($)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=le;function B(L,$){const U=Object.assign(Object.assign({},L||{}),$||{});return Object.keys(U).filter(Q=>{const N=U[Q];return typeof N=="boolean"&&N})}e.resolvePatternsForProvider=B;class H{constructor($,U){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},$.excludePattern||{}),U.excludePattern||{}),this._parsedExcludeExpression=D.parse(this._excludeExpression);let Q=$.includePattern;U.includePattern&&(Q?Q=Object.assign(Object.assign({},Q),U.includePattern):Q=U.includePattern),Q&&(this._parsedIncludeExpression=D.parse(Q))}includedInQuerySync($,U,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression($,U,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression($,U,Q))}includedInQuery($,U,Q){return Promise.resolve(this._parsedExcludeExpression($,U,Q)).then(Z=>!!Z).then(Z=>Z?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression($,U,Q)).then(ne=>!!ne):Promise.resolve(!0)).then(Z=>Z)}hasSiblingExcludeClauses(){return G(this._excludeExpression)}}e.QueryGlobTester=H;function G(L){for(const $ in L)if(typeof L[$]!="boolean")return!0;return!1}}),define(we[31],Ee([0,1,15,13,20,3,22,16,78,24,8,12,2,134,4,19,148,48,49,27,14,7,42,5]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v,d,c,o,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(C,F,x){return new n.ExtUri(le=>E(le,x)).isEqual(C,F)}function l(C,F,x){return u(C.uri,F.uri,x)?0:(0,A.compare)(C.uri.toString(),F.uri.toString())}function s(C,F,x){return C.index!==F.index?C.index<F.index?-1:1:u(C.uri,F.uri,x)?(0,A.compare)(C.name,F.name):(0,A.compare)(C.uri.toString(),F.uri.toString())}function a(C,F,x,le){const B=C.slice(0).sort((G,L)=>x(G,L,le)),H=F.slice(0).sort((G,L)=>x(G,L,le));return(0,w.delta)(B,H,(G,L)=>x(G,L,le))}function E(C,F){const x=F.getCapabilities(C.scheme);return!(x&&x&1024)}class R extends m.Workspace{constructor(F,x,le,B,H,G){super(F,le.map(L=>new m.WorkspaceFolder(L)),B,G);this._name=x,this._isUntitled=H,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(G),le.forEach(L=>{this._workspaceFolders.push(L),this._structure.set(L.uri,L)})}static toExtHostWorkspace(F,x,le,B){if(!F)return{workspace:null,added:[],removed:[]};const{id:H,name:G,folders:L,configuration:$,isUntitled:U}=F,Q=[],N=x;x?L.forEach((ye,Ae)=>{const Be=_.URI.revive(ye.uri),Re=R._findFolder(le||x,Be,B);Re?(Re.name=ye.name,Re.index=ye.index,Q.push(Re)):Q.push({uri:Be,name:ye.name,index:Ae})}):Q.push(...L.map(({uri:ye,name:Ae,index:Be})=>({uri:_.URI.revive(ye),name:Ae,index:Be}))),Q.sort((ye,Ae)=>ye.index<Ae.index?-1:1);const Z=new R(H,G,Q,$?_.URI.revive($):null,!!U,ye=>E(ye,B)),{added:ne,removed:re}=a(N?N.workspaceFolders:[],Z.workspaceFolders,l,B);return{workspace:Z,added:ne,removed:re}}static _findFolder(F,x,le){for(let B=0;B<F.folders.length;B++){const H=F.workspaceFolders[B];if(u(H.uri,x,le))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(F,x){return x&&this._structure.get(F)&&(F=(0,n.dirname)(F)),this._structure.findSubstr(F)}resolveWorkspaceFolder(F){return this._structure.get(F)}}let g=class{constructor(F,x,le,B){this._onDidChangeWorkspace=new P.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidChangeWorkspaceTrustState=new P.Emitter,this.onDidChangeWorkspaceTrustState=this._onDidChangeWorkspaceTrustState.event,this._activeSearchCallbacks=[],this._workspaceTrustState=o.WorkspaceTrustState.Unknown,this._logService=B,this._extHostFileSystemInfo=le,this._requestIdProvider=new y.Counter,this._barrier=new D.Barrier,this._proxy=F.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=F.getProxy(i.MainContext.MainThreadMessageService);const H=x.workspace;this._confirmedWorkspace=H?new R(H.id,H.name,[],H.configuration?_.URI.revive(H.configuration):null,!!H.isUntitled,G=>E(G,le)):void 0}$initializeWorkspace(F,x){this._workspaceTrustState=x,this.$acceptWorkspaceData(F),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?_.URI.from({scheme:I.Schemas.untitled,path:(0,n.basename)((0,n.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(F,x,le,...B){const H=[];if(Array.isArray(B)&&B.forEach(Q=>{_.URI.isUri(Q.uri)&&!H.some(N=>u(N.uri,Q.uri,this._extHostFileSystemInfo))&&H.push({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri)})}),this._unconfirmedWorkspace||[x,le].some(Q=>typeof Q!="number"||Q<0)||le===0&&H.length===0)return!1;const G=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(x+le>G.length)return!1;const L=G.slice(0);L.splice(x,le,...H.map(Q=>({uri:Q.uri,name:Q.name||(0,n.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<L.length;Q++){const N=L[Q];if(L.some((Z,ne)=>ne!==Q&&u(N.uri,Z.uri,this._extHostFileSystemInfo)))return!1}L.forEach((Q,N)=>Q.index=N);const{added:$,removed:U}=a(G,L,s,this._extHostFileSystemInfo);if($.length===0&&U.length===0)return!1;if(this._proxy){const Q=F.displayName||F.name;this._proxy.$updateWorkspaceFolders(Q,x,le,H).then(void 0,N=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,f.localize)(0,null,Q,N.toString()),{extension:F},[])})}return this.trySetWorkspaceFolders(L),!0}getWorkspaceFolder(F,x){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async getWorkspaceFolder2(F,x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(F,x)}async resolveWorkspaceFolder(F){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(F)}getPath(){if(!!this._actualWorkspace){const{folders:F}=this._actualWorkspace;if(F.length!==0)return F[0].uri.fsPath}}getRelativePath(F,x){let le,B="";if(typeof F=="string"?(le=_.URI.file(F),B=F):typeof F!="undefined"&&(le=F,B=F.fsPath),!le)return B;const H=this.getWorkspaceFolder(le,!0);if(!H)return B;typeof x=="undefined"&&this._actualWorkspace&&(x=this._actualWorkspace.folders.length>1);let G=(0,n.relativePath)(H.uri,le);return x&&H.name&&(G=`${H.name}/${G}`),G}trySetWorkspaceFolders(F){this._actualWorkspace&&(this._unconfirmedWorkspace=R.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:F,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:x,added:le,removed:B}=R.toExtHostWorkspace(F,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=x||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:le,removed:B}))}findFiles(F,x,le,B,H=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let G;if(x===null?G=!1:x&&(typeof x=="string"?G=x:G=x.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:L,folder:$}=b(F);return this._proxy.$startFileSearch((0,k.withUndefinedAsNull)(L),(0,k.withUndefinedAsNull)($),(0,k.withUndefinedAsNull)(G),(0,k.withUndefinedAsNull)(le),H).then(U=>Array.isArray(U)?U.map(Q=>_.URI.revive(Q)):[])}async findTextInFiles(F,x,le,B,H=T.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const G=this._requestIdProvider.getNext(),L=typeof x.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:$,folder:U}=b(x.include),Q=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,N={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:L,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:$,excludePattern:Q},Z=!1;if(this._activeSearchCallbacks[G]=ne=>{if(!Z){const re=_.URI.revive(ne.resource);ne.results.forEach(ye=>{(0,t.resultIsMatch)(ye)?le({uri:re,preview:{text:ye.preview.text,matches:(0,w.mapArrayOrNot)(ye.preview.matches,Ae=>new o.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))},ranges:(0,w.mapArrayOrNot)(ye.ranges,Ae=>new o.Range(Ae.startLineNumber,Ae.startColumn,Ae.endLineNumber,Ae.endColumn))}):le({uri:re,text:ye.text,lineNumber:ye.lineNumber})})}},H.isCancellationRequested)return{};try{const ne=await this._proxy.$startTextSearch(F,(0,k.withUndefinedAsNull)(U),N,G,H);return delete this._activeSearchCallbacks[G],ne||{}}catch(ne){throw delete this._activeSearchCallbacks[G],ne}}$handleTextSearchResult(F,x){this._activeSearchCallbacks[x]&&this._activeSearchCallbacks[x](F)}saveAll(F){return this._proxy.$saveAll(F)}resolveProxy(F){return this._proxy.$resolveProxy(F)}get trustState(){return this._workspaceTrustState}requireWorkspaceTrust(F){return this._proxy.$requireWorkspaceTrust(F)}$onDidChangeWorkspaceTrustState(F){this._workspaceTrustState=F.currentTrustState,this._onDidChangeWorkspaceTrustState.fire(Object.freeze(F))}};g=je([qe(0,c.IExtHostRpcService),qe(1,d.IExtHostInitDataService),qe(2,v.IExtHostFileSystemInfo),qe(3,h.ILogService)],g),e.ExtHostWorkspace=g,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function b(C){let F,x;return C&&(typeof C=="string"?F=C:(F=C.pattern,x=C.baseFolder||_.URI.file(C.base))),{includePattern:F,folder:x}}}),define(we[35],Ee([0,1,23,3,31,5,7,150,66,12,13,4,14,19,2]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(i,u){if(u){const l=u.split(".");let s=i;for(let a=0;s&&a<l.length;a++)s=s[l[a]];return s}}function p(i){return i instanceof r.URI}function m(i){return i&&i.uri instanceof r.URI&&i.languageId&&typeof i.languageId=="string"}function v(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function d(i){return i&&i.uri instanceof r.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function c(i){if(p(i))return{resource:i};if(m(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(v(i))return{overrideIdentifier:i.languageId};if(d(i))return{resource:i.uri};if(i===null)return{resource:null}}let o=class{constructor(u,l,s){this._proxy=u.getProxy(P.MainContext.MainThreadConfiguration),this._extHostWorkspace=l,this._logService=s,this._barrier=new A.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new t(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,l){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(u,l))}};o=je([qe(0,_.IExtHostRpcService),qe(1,T.IExtHostWorkspace),qe(2,f.ILogService)],o),e.ExtHostConfiguration=o;class t{constructor(u,l,s,a){this._onDidChangeConfiguration=new D.Emitter,this._proxy=u,this._logService=a,this._extHostWorkspace=l,this._configuration=I.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,l){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(l,s))}getConfiguration(u,l,s){const a=c(l)||{},E=this._toReadonlyValue(u?h(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,a,s==null?void 0:s.identifier);function R(b){if(b==null)return null;if(typeof b=="boolean")return b?1:4;switch(b){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const g={has(b){return typeof h(E,b)!="undefined"},get:(b,C)=>{this._validateConfigurationAccess(u?`${u}.${b}`:b,a,s==null?void 0:s.identifier);let F=h(E,b);if(typeof F=="undefined")F=C;else{let x;const le=(B,H)=>{let G;const L=()=>{x=x||(0,w.deepClone)(E),G=G||h(x,H)};return(0,n.isObject)(B)?new Proxy(B,{get:($,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return L(),()=>G;if(x)return G=G||h(x,H),G[U];const Q=$[U];return typeof U=="string"?le(Q,`${H}.${U}`):Q},set:($,U,Q)=>(L(),G&&(G[U]=Q),!0),deleteProperty:($,U)=>(L(),G&&delete G[U],!0),defineProperty:($,U,Q)=>(L(),G&&Object.defineProperty(G,U,Q),!0)}):B};F=le(F,b)}return F},update:(b,C,F,x)=>{b=u?`${u}.${b}`:b;const le=R(F);return C!==void 0?this._proxy.$updateConfigurationOption(le,b,C,a,x):this._proxy.$removeConfigurationOption(le,b,a,x)},inspect:b=>{var C,F,x,le,B,H,G,L;b=u?`${u}.${b}`:b;const $=(0,w.deepClone)(this._configuration.inspect(b,a,this._extHostWorkspace.workspace));if($)return{key:b,defaultValue:(C=$.default)===null||C===void 0?void 0:C.value,globalValue:(F=$.user)===null||F===void 0?void 0:F.value,workspaceValue:(x=$.workspace)===null||x===void 0?void 0:x.value,workspaceFolderValue:(le=$.workspaceFolder)===null||le===void 0?void 0:le.value,defaultLanguageValue:(B=$.default)===null||B===void 0?void 0:B.override,globalLanguageValue:(H=$.user)===null||H===void 0?void 0:H.override,workspaceLanguageValue:(G=$.workspace)===null||G===void 0?void 0:G.override,workspaceFolderLanguageValue:(L=$.workspaceFolder)===null||L===void 0?void 0:L.override,languageIds:$.overrideIdentifiers}}};return typeof E=="object"&&(0,w.mixin)(g,E,!1),Object.freeze(g)}_toReadonlyValue(u){const l=s=>(0,n.isObject)(s)?new Proxy(s,{get:(a,E)=>l(a[E]),set:(a,E,R)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(a,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(a,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return l(u)}_validateConfigurationAccess(u,l,s){const a=y.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),E=s?`[${s.value}] `:"";if(a===4){typeof(l==null?void 0:l.resource)=="undefined"&&this._logService.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){(l==null?void 0:l.resource)&&this._logService.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,l){const s=new I.ConfigurationChangeEvent(u,l,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,E)=>s.affectsConfiguration(a,c(E))})}_toMap(u){return u.reduce((l,s)=>(l.set(s[0],s[1]),l),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[100],Ee([0,1,2,13,3,5,7,31,40,35,20,41,14,27,4,16,21,19,72,166,10]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v,d,c){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(B){function H(L){if(L!=null)return L}B.from=H;function G(L){if(L!=null)return L}B.to=G})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(B){function H(L){if(L!=null)return L}B.from=H;function G(L){if(L!=null)return L}B.to=G})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var u;(function(B){function H(L){if(L!=null)return L}B.from=H;function G(L){if(L!=null)return L}B.to=G})(u=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var l;(function(B){function H($){if($){const U=$;return U&&!!U.process}else return!1}B.is=H;function G($){if($!=null){const U={process:$.process,args:$.args};return $.options&&(U.options=u.from($.options)),U}}B.from=G;function L($){if($!=null)return new S.ProcessExecution($.process,$.args,$.options)}B.to=L})(l=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(B){function H(L){if(L!=null)return L}B.from=H;function G(L){if(L!=null)return L}B.to=G})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(B){function H($){if($){const U=$;return U&&(!!U.commandLine||!!U.command)}else return!1}B.is=H;function G($){if($!=null){const U={};return $.commandLine!==void 0?U.commandLine=$.commandLine:(U.command=$.command,U.args=$.args),$.options&&(U.options=s.from($.options)),U}}B.from=G;function L($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new S.ShellExecution($.commandLine,$.options):new S.ShellExecution($.command,$.args?$.args:[],$.options)}B.to=L})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var E;(function(B){function H($){if($){let U=$;return U&&U.customExecution==="customExecution"}else return!1}B.is=H;function G($){return{customExecution:"customExecution"}}B.from=G;function L($,U){return U.get($)}B.to=L})(E=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var R;(function(B){function H(G,L){let $;return G.scope!==void 0&&typeof G.scope!="number"?$=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===S.TaskScope.Workspace&&L&&L.workspaceFile?$=L.workspaceFile:$=d.USER_TASKS_GROUP_KEY),{id:G._id,workspaceFolder:$}}B.from=H})(R=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(B){function H($,U){if($==null)return[];const Q=[];for(let N of $){const Z=G(N,U);Z&&Q.push(Z)}return Q}B.fromMany=H;function G($,U){if($!=null){let Q;$.execution instanceof S.ProcessExecution?Q=l.from($.execution):$.execution instanceof S.ShellExecution?Q=a.from($.execution):$.execution&&$.execution instanceof S.CustomExecution&&(Q=E.from($.execution));const N=t.from($.definition);let Z;if($.scope?typeof $.scope=="number"?Z=$.scope:Z=$.scope.uri:Z=S.TaskScope.Workspace,!(!N||!Z)){const ne=$.group?$.group.id:void 0;return{_id:$._id,definition:N,name:$.name,source:{extensionId:U.identifier.value,label:$.source,scope:Z},execution:Q,isBackground:$.isBackground,group:ne,presentationOptions:i.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}}}B.from=G;async function L($,U,Q){if($!=null){let N;l.is($.execution)?N=l.to($.execution):a.is($.execution)?N=a.to($.execution):E.is($.execution)&&(N=E.to($._id,Q));const Z=t.to($.definition);let ne;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?ne=$.source.scope:ne=await U.resolveWorkspaceFolder(w.URI.revive($.source.scope)):ne=S.TaskScope.Workspace),!(!Z||!ne)){const re=new S.Task(Z,ne,$.name,$.source.label,N,$.problemMatchers);return $.isBackground!==void 0&&(re.isBackground=$.isBackground),$.group!==void 0&&(re.group=S.TaskGroup.from($.group)),$.presentationOptions&&(re.presentationOptions=i.to($.presentationOptions)),$._id&&(re._id=$._id),$.detail&&(re.detail=$.detail),re}}}B.to=L})(g=e.TaskDTO||(e.TaskDTO={}));var b;(function(B){function H(L){return L}B.from=H;function G(L){if(!!L)return Object.assign(Object.create(null),L)}B.to=G})(b=e.TaskFilterDTO||(e.TaskFilterDTO={}));class C{constructor(H,G,L){this._id=G,this._task=L,o.set(this,void 0),tt(this,o,H)}get task(){return this._task}terminate(){We(this,o).terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}o=new WeakMap;var F;(function(B){function H(G){return{id:G._id,task:void 0}}B.from=H})(F=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(H,G,L,$,U,Q,N,Z){this._onDidExecuteTask=new T.Emitter,this._onDidTerminateTask=new T.Emitter,this._onDidTaskProcessStarted=new T.Emitter,this._onDidTaskProcessEnded=new T.Emitter,this._proxy=H.getProxy(P.MainContext.MainThreadTask),this._workspaceProvider=L,this._editorService=$,this._configurationService=U,this._terminalService=Q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=N,this._deprecationService=Z,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,G,L){if(!L)return new S.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:G,provider:L,extension:H}),this._proxy.$registerTaskProvider($,G),new S.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(H,G){this._proxy.$registerTaskSystem(H,G)}fetchTasks(H){return this._proxy.$fetchTasks(b.from(H)).then(async G=>{const L=[];for(let $ of G){const U=await g.to($,this._workspaceProvider,this._providedCustomExecutions2);U&&L.push(U)}return L})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(G=>H.push(G)),H}terminateTask(H){if(!(H instanceof C))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,G,L){const $=this._providedCustomExecutions2.get(H.id);if($){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,$),this._terminalService.attachPtyToTerminal(G,await $.callback(L))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const G=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:G})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const G=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:G,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const G=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:G,exitCode:H.exitCode})}$provideTasks(H,G){const L=this._handlers.get(H);if(!L)return Promise.reject(new Error("no handler found"));const $=[],U=(0,D.asPromise)(()=>L.provider.provideTasks(A.CancellationToken.None)).then(Q=>this.provideTasksInternal(G,$,L,Q));return new Promise(Q=>{U.then(N=>{Promise.all($).then(()=>{Q(N)})})})}async $resolveTask(H,G){const L=this._handlers.get(H);if(!L)return Promise.reject(new Error("no handler found"));if(G.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${L.type}].`);const $=await g.to(G,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const U=await L.provider.resolveTask($,A.CancellationToken.None);if(!!U){this.checkDeprecation(U,L);const Q=g.from(U,L.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Q.execution)&&await this.addCustomExecution(Q,U,!0),await this.resolveTaskInternal(Q)}}nextHandle(){return this._handleCounter++}async addCustomExecution(H,G,L){const $=await this._proxy.$createTaskId(H);!L&&!this._providedCustomExecutions2.has($)&&this._notProvidedCustomExecutions.add($),this._providedCustomExecutions2.set($,G.execution)}async getTaskExecution(H,G){if(typeof H=="string"){const U=this._taskExecutionPromises.get(H);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let L=this._taskExecutionPromises.get(H.id);if(L)return L;const $=new Promise(async(U,Q)=>{const N=G||await g.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);N?U(new C(this,H.id,N)):Q("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,$),$.then(U=>(this._taskExecutions.set(H.id,U),U),U=>Promise.reject(U))}checkDeprecation(H,G){H._deprecated&&this._deprecationService.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let L=this._notProvidedCustomExecutions.values(),$=L.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=L.next()}};x=je([qe(0,_.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,I.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,k.IExtHostTerminalService),qe(6,m.ILogService),qe(7,v.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let le=class extends x{constructor(H,G,L,$,U,Q,N,Z){super(H,G,L,$,U,Q,N,Z);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(H,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const L=g.from(G,H);if(L===void 0)throw new Error("Task is not valid");if(E.is(L.execution))await this.addCustomExecution(L,G,!1);else throw new c.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(L),G);return this._proxy.$executeTask(L).catch(U=>{throw new Error(U)}),$}provideTasksInternal(H,G,L,$){const U=[];if($)for(let Q of $){this.checkDeprecation(Q,L),(!Q.definition||!H[Q.definition.type])&&this._logService.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const N=g.from(Q,L.extension);N&&E.is(N.execution)?(U.push(N),G.push(this.addCustomExecution(N,Q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:L.extension}}async resolveTaskInternal(H){if(E.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,G){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(H,G,L){}};le=je([qe(0,_.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,I.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,n.IExtHostConfiguration),qe(5,k.IExtHostTerminalService),qe(6,m.ILogService),qe(7,v.IExtHostApiDeprecationService)],le),e.WorkerExtHostTask=le,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)},an=this&&this.__rest||function(oe,e){var w={};for(var D in oe)Object.prototype.hasOwnProperty.call(oe,D)&&e.indexOf(D)<0&&(w[D]=oe[D]);if(oe!=null&&typeof Object.getOwnPropertySymbols=="function")for(var T=0,D=Object.getOwnPropertySymbols(oe);T<D.length;T++)e.indexOf(D[T])<0&&Object.prototype.propertyIsEnumerable.call(oe,D[T])&&(w[D[T]]=oe[D[T]]);return w};define(we[213],Ee([0,1,15,13,20,3,52,6,23,12,2,29,5,40,14,9,7,31,178,168]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v,d){"use strict";var c,o;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.ExtHostTesting=void 0;const t=(b,C)=>`${b}:${C.toString()}`;let i=class{constructor(C,F,x){this.documents=F,this.workspace=x,this.resultsChangedEmitter=new P.Emitter,this.providers=new Map,this.ownedTests=new v.OwnedTestCollection,this.testSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=C.getProxy(_.MainContext.MainThreadTesting),this.workspaceObservers=new R(this.proxy),this.textDocumentObservers=new g(this.proxy,F)}registerTestProvider(C){const F=(0,k.generateUuid)();this.providers.set(F,C),this.proxy.$registerTestProvider(F);const x=[...this.testSubscriptions.keys()];return setTimeout(()=>{var le;for(const B of x)(le=this.testSubscriptions.get(B))===null||le===void 0||le.subscribeFn(F,C)},0),new p.Disposable(()=>{this.providers.delete(F),this.proxy.$unregisterTestProvider(F)})}createTextDocumentTestObserver(C){return this.textDocumentObservers.checkout(C.uri)}createWorkspaceTestObserver(C){return this.workspaceObservers.checkout(C.uri)}async runTests(C,F=T.CancellationToken.None){const x=le=>le.map(this.getInternalTestForReference,this).filter(n.isDefined).map(B=>({providerId:B.providerId,testId:B.item.extId}));await this.proxy.$runTests({exclude:C.exclude?x(C.exclude).map(le=>le.testId):void 0,tests:x(C.tests),debug:C.debug},F)}publishExtensionProvidedResults(C,F){this.proxy.$publishExtensionProvidedResults(h.TestResults.from((0,k.generateUuid)(),C),F)}$publishTestResults(C){this.results=Object.freeze(C.map(F=>(0,y.deepFreeze)(h.TestResults.to(F))).concat(this.results).sort((F,x)=>x.completedAt-F.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(C,F){const x=A.URI.revive(F),le=t(C,x);if(!this.testSubscriptions.has(le)){const B=new T.CancellationTokenSource;let H;if(C===1){let U=this.documents.getDocument(x);if(!U){const Q=new I.DisposableStore;U=await new Promise(N=>{Q.add((0,D.disposableTimeout)(()=>N(void 0),5e3)),Q.add(this.documents.onDidAddDocuments(Z=>{const ne=Z.find(re=>re.document.uri.toString()===x.toString());ne&&N(ne)}))}).finally(()=>Q.dispose())}if(U){const Q=await this.workspace.getWorkspaceFolder2(x,!1);H=N=>N.provideDocumentTestHierarchy?N.provideDocumentTestHierarchy(U.document,B.token):this.createDefaultDocumentTestHierarchy(N,U.document,Q,B.token)}}else{const U=await this.workspace.getWorkspaceFolder2(x,!1);U&&(H=Q=>Q.provideWorkspaceTestHierarchy(U,B.token))}if(!!H){const G=async(U,Q)=>{var N;try{$.pushDiff([3,1]);const Z=await H(Q);if(!Z){$.pushDiff([3,-1]);return}$.addRoot(Z.root,U),Promise.resolve(Z.discoveredInitialTests).then(()=>$.pushDiff([3,-1])),Z.onDidChangeTest(ne=>$.onItemChange(ne,U)),(N=Z.onDidInvalidateTest)===null||N===void 0||N.call(Z,ne=>{const re=$.getTestByReference(ne);re?this.proxy.$retireTest(re.item.extId):console.warn("Received a TestProvider.onDidInvalidateTest for a test that does not currently exist.")})}catch(Z){console.error(Z)}},L=new I.DisposableStore,$=L.add(this.ownedTests.createForHierarchy(U=>this.proxy.$publishDiff(C,F,U)));L.add((0,I.toDisposable)(()=>B.dispose(!0)));for(const[U,Q]of this.providers)G(U,Q);$.pushDiff([4,-1]),this.testSubscriptions.set(le,{store:L,collection:$,subscribeFn:G})}}}$unsubscribeFromTests(C,F){var x;const le=A.URI.revive(F),B=t(C,le);(x=this.testSubscriptions.get(B))===null||x===void 0||x.store.dispose(),this.testSubscriptions.delete(B)}$acceptDiff(C,F,x){C===1?this.textDocumentObservers.acceptDiff(A.URI.revive(F),x):this.workspaceObservers.acceptDiff(A.URI.revive(F),x)}async $runTestsForProvider(C,F){const x=this.providers.get(C.providerId);if(!!x){const le=C.ids.map(H=>{var G;return(G=this.ownedTests.getTestById(H))===null||G===void 0?void 0:G[1]}).filter(n.isDefined),B=C.excludeExtIds.map(H=>this.ownedTests.getTestById(H)).filter(n.isDefined).filter(([H,G])=>le.some(L=>H.comparePositions(L,G)===1));if(!!le.length)try{await x.runTests({setState:(H,G)=>{for(const[L,$]of B){const U=L.comparePositions($,H.id);if(U===1||U===3)return}this.flushCollectionDiffs(),this.proxy.$updateTestStateInRun(C.runId,H.id,h.TestState.from(G))},tests:le.map(H=>u.unwrap(H.actual)),exclude:B.map(([,H])=>u.unwrap(H.actual)),debug:C.debug},F);for(const{collection:H}of this.testSubscriptions.values())H.flushDiff();return}catch(H){throw console.error(H),H}}}$lookupTest(C){const F=this.ownedTests.getTestById(C.testId);if(!F)return Promise.resolve(void 0);const x=F[1],{actual:le,previousChildren:B,previousEquals:H}=x,G=an(x,["actual","previousChildren","previousEquals"]);return Promise.resolve(G)}flushCollectionDiffs(){for(const{collection:C}of this.testSubscriptions.values())C.flushDiff()}getInternalTestForReference(C){var F,x;return(x=(F=this.workspaceObservers.getMirroredTestDataByReference(C))!==null&&F!==void 0?F:(0,w.mapFind)(this.testSubscriptions.values(),le=>le.collection.getTestByReference(C)))!==null&&x!==void 0?x:this.textDocumentObservers.getMirroredTestDataByReference(C)}async createDefaultDocumentTestHierarchy(C,F,x,le){var B;if(!!x){const H=await C.provideWorkspaceTestHierarchy(x,le);if(!!H){const G=new P.Emitter;(B=H.onDidInvalidateTest)===null||B===void 0||B.call(H,$=>{const U=u.getWrapperForTestItem($,F);U.hasNodeMatchingFilter&&G.fire(U)});const L=new P.Emitter;return H.onDidChangeTest($=>{const U=u.getWrapperForTestItem($,F);if(U.hasNodeMatchingFilter){if(U.reset(),U.hasNodeMatchingFilter){L.fire(U);return}L.fire(U.visibleParent);return}const N=U.visibleParent;U.reset(),!!U.hasNodeMatchingFilter&&(N.reset(),L.fire(N))}),le.onCancellationRequested(()=>{u.removeFilter(F),L.dispose()}),{root:u.getWrapperForTestItem(H.root,F),discoveredInitialTests:H.discoveredInitialTests,onDidInvalidateTest:G.event,onDidChangeTest:L.event}}}}};i=je([qe(0,r.IExtHostRpcService),qe(1,f.IExtHostDocumentsAndEditors),qe(2,m.IExtHostWorkspace)],i),e.ExtHostTesting=i;class u{constructor(C,F,x){this.actual=C,this.filterDocument=F,this.parent=x,this.getWrappedChildren()}static removeFilter(C){this.wrapperMap.delete(C)}static getWrapperForTestItem(C,F,x){let le=this.wrapperMap.get(F);if(le==null?void 0:le.has(C))return le.get(C);le||(le=new WeakMap,this.wrapperMap.set(F,le));const B=new u(C,F,x);return le.set(C,B),B}static unwrap(C){return C instanceof u?C.actual:C}get id(){return this.actual.id}get label(){return this.actual.label}get debuggable(){return this.actual.debuggable}get description(){return this.actual.description}get location(){return this.actual.location}get runnable(){return this.actual.runnable}get children(){return this.getWrappedChildren().filter(C=>C.hasNodeMatchingFilter)}get visibleParent(){return this.hasNodeMatchingFilter?this:this.parent.visibleParent}get hasNodeMatchingFilter(){var C;return this.matchesFilter===void 0&&(this.matchesFilter=!this.parent||((C=this.actual.location)===null||C===void 0?void 0:C.uri.toString())===this.filterDocument.uri.toString()||this.getWrappedChildren().some(F=>F.hasNodeMatchingFilter)),this.matchesFilter}reset(){var C;this!==this.visibleParent&&((C=this.parent)===null||C===void 0||C.reset()),this.matchesFilter=void 0}getWrappedChildren(){var C;return((C=this.actual.children)===null||C===void 0?void 0:C.map(F=>u.getWrapperForTestItem(F,this.filterDocument,this)))||[]}}e.TestItemFilteredWrapper=u,u.wrapperMap=new WeakMap;class l extends d.IncrementalChangeCollector{constructor(C,F){super();this.collection=C,this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(C){this.added.add(C)}update(C){Object.assign(C.revived,h.TestItem.toPlainShallow(C.item)),this.added.has(C)||this.updated.add(C)}remove(C){if(this.added.has(C)){this.added.delete(C);return}if(this.updated.delete(C),C.parent&&this.alreadyRemoved.has(C.parent)){this.alreadyRemoved.add(C.item.extId);return}this.removed.add(C)}getChangeEvent(){const{collection:C,added:F,updated:x,removed:le}=this;return{get added(){return[...F].map(C.getPublicTestItem,C)},get updated(){return[...x].map(C.getPublicTestItem,C)},get removed(){return[...le].map(C.getPublicTestItem,C)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends d.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new P.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(C){let F=[];for(const x of C){const le=this.items.get(x);le&&F.push(this.getPublicTestItem(le))}return F}getMirroredTestDataById(C){return this.items.get(C)}getMirroredTestDataByReference(C){return this.items.get(C.id)}createItem(C,F){return Object.assign(Object.assign({},C),{revived:h.TestItem.toPlainShallow(C.item),depth:F?F.depth+1:0,children:new Set})}createChangeCollector(){return new l(this,this.changeEmitter)}getPublicTestItem(C){return C.wrapped||(C.wrapped=new a(C,this)),C.wrapped}}e.MirroredTestCollection=s;class a{constructor(C,F){c.set(this,void 0),o.set(this,void 0),tt(this,c,C),tt(this,o,F)}get id(){return We(this,c).revived.id}get label(){return We(this,c).revived.label}get description(){return We(this,c).revived.description}get location(){return We(this,c).revived.location}get runnable(){var C;return(C=We(this,c).revived.runnable)!==null&&C!==void 0?C:!0}get debuggable(){var C;return(C=We(this,c).revived.debuggable)!==null&&C!==void 0?C:!1}get children(){return We(this,o).getAllAsTestItem(We(this,c).children)}toJSON(){return{id:this.id,label:this.label,description:this.description,location:this.location,runnable:this.runnable,debuggable:this.debuggable,children:this.children.map(F=>F.toJSON()),providerId:We(this,c).providerId,testId:this.id}}}c=new WeakMap,o=new WeakMap;class E{constructor(){this.resources=new Map}checkout(C){var F,x;const le=C.toString(),B=(F=this.resources.get(le))!==null&&F!==void 0?F:this.createObserverData(C);return(x=B.pendingDeletion)===null||x===void 0||x.dispose(),B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,onDidDiscoverInitialTests:new P.Emitter().event,get tests(){return B.tests.rootTestItems},dispose:(0,S.once)(()=>{--B.observers||(B.pendingDeletion=this.eventuallyDispose(C))})}}getMirroredTestDataByReference(C){for(const{tests:F}of this.resources.values()){const x=F.getMirroredTestDataByReference(C);if(x)return x}}eventuallyDispose(C){return(0,D.disposableTimeout)(()=>this.unlisten(C),10*1e3)}createObserverData(C){const F=new s,x=this.listen(C,B=>F.apply(B)),le={observers:0,tests:F,listener:x};return this.resources.set(C.toString(),le),le}unlisten(C){var F;const x=C.toString(),le=this.resources.get(x);le&&(le.observers=-1,(F=le.pendingDeletion)===null||F===void 0||F.dispose(),le.listener.dispose(),this.resources.delete(x))}}class R extends E{constructor(C){super();this.proxy=C,this.diffListeners=new Map}acceptDiff(C,F){var x;(x=this.diffListeners.get(C.toString()))===null||x===void 0||x(F)}listen(C,F){this.proxy.$subscribeToDiffs(0,C);const x=C.toString();return this.diffListeners.set(x,F),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,C),this.diffListeners.delete(x)})}}class g extends E{constructor(C,F){super();this.proxy=C,this.documents=F,this.diffListeners=new Map}acceptDiff(C,F){var x;(x=this.diffListeners.get(C.toString()))===null||x===void 0||x(F)}listen(C,F){if(!this.documents.getDocument(C))return new p.Disposable(()=>{});const le=C.toString();return this.diffListeners.set(le,F),this.proxy.$subscribeToDiffs(1,C),new p.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,C),this.diffListeners.delete(le)})}}}),define(we[214],Ee([0,1,15,51,28,58,22,16,11,24,8,12,2,113,137,89,48,170,212,42]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let c=class{constructor(R,g,b,C){this.configurationService=R,this.workspaceContextService=g,this.editorGroupsService=b,this.pathService=C}text(R,g,b={}){R=this.getContentPattern(R,b);const C=this.configurationService.getValue(),F=g&&g.some(le=>!this.configurationService.getValue({resource:le}).search.useRipgrep),x=this.commonQuery(g==null?void 0:g.map(p.toWorkspaceFolder),b);return Object.assign(Object.assign({},x),{type:2,contentPattern:R,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:C.search.usePCRE2||F||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles})}getContentPattern(R,g){const b=this.configurationService.getValue();R.isRegExp&&(R.pattern=R.pattern.replace(/\r?\n/g,"\\n"));const C=Object.assign(Object.assign({},R),{wordSeparators:b.editor.wordSeparators});return this.isCaseSensitive(R,g)&&(C.isCaseSensitive=!0),this.isMultiline(R)&&(C.isMultiline=!0),C}file(R,g={}){const b=this.commonQuery(R,g);return Object.assign(Object.assign({},b),{type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey})}handleIncludeExclude(R,g){return R?(R=Array.isArray(R)?R.map(l):l(R),g?this.parseSearchPaths(R):{pattern:t(...Array.isArray(R)?R:[R])}):{}}commonQuery(R=[],g={}){const b=this.handleIncludeExclude(g.includePattern,g.expandPatterns),C=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),F=R.length>1,x=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,g,C)):R.map(H=>this.getFolderQueryForRoot(H,g,C,F))).filter(H=>!!H),le={_reason:g._reason,folderQueries:x,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:C.pattern,includePattern:b.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const G=w.coalesce(w.flatten(this.editorGroupsService.groups.map($=>$.editors.map(U=>U.resource)))).filter($=>(0,d.pathIncludedInQuery)(le,$.fsPath)),L=this.commonQueryFromFileList(G);return Object.assign(Object.assign({},le),L)}const B=g.extraFileResources&&g.extraFileResources.filter(H=>(0,d.pathIncludedInQuery)(le,H.fsPath));return le.extraFileResources=B&&B.length?B:void 0,le}commonQueryFromFileList(R){const g=[],b=new S.ResourceMap,C={};let F=!1;return R.forEach(x=>{var le,B;if(x.scheme!==I.Schemas.walkThrough)if((0,n.isAbsolutePath)(x)){const G=(B=(le=this.workspaceContextService.getWorkspaceFolder(x))===null||le===void 0?void 0:le.uri)!==null&&B!==void 0?B:x.with({path:y.dirname(x.fsPath)});let L=b.get(G);L||(F=!0,L={folder:G,includePattern:{}},g.push(L),b.set(G,L));const $=y.relative(G.fsPath,x.fsPath);(0,k.assertIsDefined)(L.includePattern)[$.replace(/\\/g,"/")]=!0}else x.fsPath&&(F=!0,C[x.fsPath]=!0)}),{folderQueries:g,includePattern:C,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}isCaseSensitive(R,g){if(g.isSmartCase){if(R.isRegExp){if(A.containsUppercaseCharacter(R.pattern,!0))return!0}else if(A.containsUppercaseCharacter(R.pattern))return!0}return!!R.isCaseSensitive}isMultiline(R){return R.isMultiline||R.isRegExp&&(0,f.isMultilineRegexSource)(R.pattern)||R.pattern.indexOf(`
`)>=0?!0:!!R.isMultiline}parseSearchPaths(R){const g=L=>y.isAbsolute(L)||/^\.\.?([\/\\]|$)/.test(L),C=(Array.isArray(R)?R:i(R)).map(L=>{const $=this.pathService.resolvedUserHome;return $?(0,P.untildify)(L,$.scheme===I.Schemas.file?$.fsPath:$.path):L}),F=D.groupBy(C,L=>g(L)?"searchPaths":"exprSegments"),x=(F.exprSegments||[]).map(L=>A.rtrim(L,"/")).map(L=>A.rtrim(L,"\\")).map(L=>(L[0]==="."&&(L="*"+L),u(L))),le={},B=this.expandSearchPathPatterns(F.searchPaths||[]);B&&B.length&&(le.searchPaths=B);const H=w.flatten(x),G=t(...H);return G&&(le.pattern=G),le}getExcludesForFolder(R,g){return g.disregardExcludeSettings?void 0:(0,d.getExcludes)(R,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(R){if(!R||!R.length)return[];const g=w.flatten(R.map(C=>{let{pathPortion:F,globPortion:x}=o(C);x&&(x=s(x));const le=this.expandOneSearchPath(F);return w.flatten(le.map(B=>this.resolveOneSearchPathPattern(B,x)))})),b=new Map;return g.forEach(C=>{const F=C.searchPath.toString(),x=b.get(F);x?C.pattern&&(x.pattern=x.pattern||{},x.pattern[C.pattern]=!0):b.set(F,{searchPath:C.searchPath,pattern:C.pattern?t(C.pattern):void 0})}),Array.from(b.values())}expandOneSearchPath(R){if(y.isAbsolute(R)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==I.Schemas.file?[{searchPath:g[0].uri.with({path:R})}]:[{searchPath:_.URI.file(y.normalize(R))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(R=l(R),R.startsWith("../")||R===".."){const C=y.posix.resolve(g.path,R);return[{searchPath:g.with({path:C})}]}const b=s(R);return[{searchPath:g,pattern:b}]}else{if(R==="./"||R===".\\")return[];{const g=R.match(/\.[\/\\]([^\/\\]+)(?:[\/\\](.+))?/);if(g){const b=g[1],C=this.workspaceContextService.getWorkspace().folders.filter(F=>F.name===b);if(C.length)return C.map(F=>{const x=g[2];return{searchPath:F.uri,pattern:x&&s(x)}});{const F=r.localize(0,null,b);throw new Error(F)}}}}return[]}resolveOneSearchPathPattern(R,g){const b=R.pattern&&g?`${R.pattern}/${g}`:R.pattern||g,C=[{searchPath:R.searchPath,pattern:b}];return b&&!b.endsWith("**")&&C.push({searchPath:R.searchPath,pattern:b+"/**"}),C}getFolderQueryForSearchPath(R,g,b){const C=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(R.searchPath),g,b,!1);return C?Object.assign(Object.assign({},C),{includePattern:R.pattern}):null}getFolderQueryForRoot(R,g,b,C){let F;const x=_.URI.isUri(R)?R:R.uri;if(b.searchPaths){const L=b.searchPaths.filter($=>(0,n.isEqual)($.searchPath,x))[0];if(L&&!L.pattern)return null;L&&(F=L.pattern)}const le=this.configurationService.getValue({resource:x}),B=this.getExcludesForFolder(le,g),H=Object.assign(Object.assign({},B||{}),F||{}),G=_.URI.isUri(R)?(0,n.basename)(R):R.name;return{folder:x,folderName:C?G:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:le.files&&le.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!le.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!le.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!le.search.followSymlinks}}};c=je([qe(0,h.IConfigurationService),qe(1,p.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,v.IPathService)],c),e.QueryBuilder=c;function o(E){const R=E.match(/[\*\{\}\(\)\[\]\?]/);if(R){const g=R.index,b=E.substr(0,g).match(/[/|\\][^/\\]*$/);if(b){let C=E.substr(0,b.index);return C.match(/[/\\]/)||(C+="/"),{pathPortion:C,globPortion:E.substr((b.index||0)+1)}}}return{pathPortion:E}}function t(...E){return E.length?E.reduce((R,g)=>(R[g]=!0,R),Object.create(null)):void 0}function i(E){return T.splitGlobAware(E,",").map(R=>R.trim()).filter(R=>!!R.length)}function u(E){return[`**/${E}/**`,`**/${E}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function l(E){return E.replace(/\\/g,"/")}function s(E){return l(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(E,R){E=w.distinct(E,C=>C.toString());const g=[],b=R.getWorkspace();return E&&E.forEach(C=>{let F;if(R.getWorkbenchState()===2)F=(0,n.relativePath)(b.folders[0].uri,C),F&&F!=="."&&(F="./"+F);else{const x=R.getWorkspaceFolder(C);if(x){const le=x.name;if(b.folders.filter(H=>H.name===le).length===1){const H=(0,n.relativePath)(x.uri,C);H===""?F=`./${x.name}`:F=`./${x.name}/${H}`}else F=C.fsPath}}F&&g.push(F)}),g}e.resolveResourcesForSearchIncludes=a}),define(we[215],Ee([0,1,24,2,20,10,4,214,42,48]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const A=7e3;function k(h,p){const m=p.activationEvents;if(!m)return Promise.resolve(void 0);const v=[],d=[];for(const l of m)if(/^workspaceContains:/.test(l)){const s=l.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||h.forceUsingSearch?d.push(s):v.push(s)}if(v.length===0&&d.length===0)return Promise.resolve(void 0);let c;const o=new Promise((l,s)=>{c=l}),t=l=>c({activationEvent:l}),i=Promise.all(v.map(l=>_(h,l,t))).then(()=>{}),u=f(h,p.identifier,d,t);return Promise.all([i,u]).then(()=>{c(void 0)}),o}e.checkActivateWorkspaceContainsExtension=k;async function _(h,p,m){for(const v of h.folders)if(await h.exists(w.joinPath(D.URI.revive(v),p))){m(`workspaceContains:${p}`);return}}async function f(h,p,m,v){if(m.length===0)return Promise.resolve(void 0);const d=new T.CancellationTokenSource,c=h.checkExists(h.folders,m,d.token),o=setTimeout(async()=>{d.cancel(),v(`workspaceContainsTimeout:${m.join(",")}`)},A);let t=!1;try{t=await c}catch(i){P.isPromiseCanceledError(i)||P.onUnexpectedError(i)}d.dispose(),clearTimeout(o),t&&v(`workspaceContains:${m.join(",")}`)}function r(h,p,m,v){const d=h.get(S.IInstantiationService),c=h.get(y.ISearchService),t=d.createInstance(I.QueryBuilder).file(p.map(i=>(0,n.toWorkspaceFolder)(D.URI.revive(i))),{_reason:"checkExists",includePattern:m,exists:!0});return c.fileSearch(t,v).then(i=>!!i.limitHit,i=>P.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(oe,e,w){if(!e.has(oe))throw new TypeError("attempted to set private field on non-instance");return e.set(oe,w),w},We=this&&this.__classPrivateFieldGet||function(oe,e){if(!e.has(oe))throw new TypeError("attempted to get private field on non-instance");return e.get(oe)};define(we[36],Ee([0,1,129,11,77,24,13,6,22,2,19,5,35,181,75,31,34,179,10,25,16,26,157,7,90,4,27,76,14,65,67,41,3,215,71,158]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v,d,c,o,t,i,u,l,s,a,E,R,g,b,C,F,x,le){"use strict";var B,H,G;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let L=class kn extends I.Disposable{constructor(N,Z,ne,re,ye,Ae,Be,Re,xe,W){super();this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Z,this._extHostContext=ne,this._initData=Be,this._extHostWorkspace=re,this._extHostConfiguration=ye,this._logService=Ae,this._extHostTunnelService=xe,this._extHostTerminalService=W,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new x.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=N.createChild(new R.ServiceCollection([r.IExtHostStorage,this._storage],[x.IExtHostSecretState,this._secretState]));const K=new Set;this._initData.hostExtensions.forEach(J=>K.add(d.ExtensionIdentifier.toKey(J))),this._activator=new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(J,ae)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(J,ae)},actualActivateExtension:async(J,ae)=>{if(K.has(d.ExtensionIdentifier.toKey(J)))return await this._mainThreadExtensionsProxy.$activateExtension(J,ae),new f.HostExtension;const ge=this._registry.getExtensionDescription(J);return this._activateExtension(ge,ae)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),T.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){v.onUnexpectedError(N)}}async deactivateAll(){let N=[];try{N=this._registry.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this._deactivate(ye))}catch(Z){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,Z){return this._activator.activateByEvent(N,Z)}_activateById(N,Z){return this._activator.activateById(N,Z)}activateByIdWithErrors(N,Z){return this._activateById(N,Z).then(()=>{const ne=this._activator.getActivatedExtension(N);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const N=y.TernarySearchTree.forPaths(),Z=this._registry.getAllExtensionDescriptions().map(ne=>{if(!!this._getEntryPoint(ne))return this._hostUtils.realpath(ne.extensionLocation.fsPath).then(re=>N.set(n.URI.file(re).fsPath,ne))});this._extensionPathIndex=Promise.all(Z).then(()=>N)}return this._extensionPathIndex}_deactivate(N){let Z=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return Z;const ne=this._activator.getActivatedExtension(N);if(!ne)return Z;try{typeof ne.module.deactivate=="function"&&(Z=Promise.resolve(ne.module.deactivate()).then(void 0,re=>Promise.resolve(void 0)))}catch(re){}try{(0,I.dispose)(ne.subscriptions)}catch(re){}return Z}async _activateExtension(N,Z){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,Z).then(ne=>{const re=ne.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,Z),this._logExtensionActivationTimes(N,Z,"success",re),ne},ne=>{throw this._logExtensionActivationTimes(N,Z,"failure"),ne})}_logExtensionActivationTimes(N,Z,ne,re){const ye=$(N,Z);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ye),re||{}),{outcome:ne}))}_doActivateExtension(N,Z){const ne=$(N,Z);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ne);const re=this._getEntryPoint(N);if(!re)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value} ${JSON.stringify(Z)}`),this._logService.flush();const ye=new f.ExtensionActivationTimesBuilder(Z.startup);return Promise.all([this._loadCommonJSModule(N.identifier,(0,P.joinPath)(N.extensionLocation,re),ye),this._loadExtensionContext(N)]).then(Ae=>(T.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),kn._callActivate(this._logService,N.identifier,Ae[0],Ae[1],ye))).then(Ae=>(T.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),Ae))}_loadExtensionContext(N){const Z=new t.ExtensionGlobalMemento(N,this._storage),ne=new t.ExtensionMemento(N.identifier.value,!1,this._storage),re=new le.ExtensionSecrets(N,this._secretState),ye=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ae=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([Z.whenReady,ne.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Re;return Object.freeze({globalState:Z,workspaceState:ne,secrets:re,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(xe){return D.join(N.extensionLocation.fsPath,xe)},get storagePath(){var xe;return(xe=Be._storagePath.workspaceValue(N))===null||xe===void 0?void 0:xe.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(N).fsPath},get logPath(){return D.join(Be._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return n.URI.joinPath(Be._initData.logsLocation,N.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(N)},get globalStorageUri(){return Be._storagePath.globalValue(N)},get extensionMode(){return ye},get extension(){return(0,p.checkProposedApiEnabled)(N),Re===void 0&&(Re=new U(this,N.identifier,N,Ae)),Re},get extensionRuntime(){return(0,p.checkProposedApiEnabled)(N),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,Z,ne,re,ye){return ne=ne||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,Z,ne,re,ye).then(Ae=>new f.ActivatedExtension(!1,null,ye.build(),ne,Ae,re.subscriptions))}static _callActivateOptional(N,Z,ne,re,ye){if(typeof ne.activate=="function")try{ye.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${Z.value}`);const Ae=typeof global=="object"?global:self,Be=ne.activate.apply(Ae,[re]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(Be).then(Re=>(ye.activateResolveStop(),Re))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(ne)}_activateOneStartupFinished(N,Z){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:Z}).then(void 0,ne=>{this._logService.error(ne)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(T.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const Z of N.activationEvents)Z==="onStartupFinished"&&this._activateOneStartupFinished(N,Z)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,ye=>{this._logService.error(ye)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ye=>this._handleWorkspaceContainsEagerExtensions(ye.added)));const Z=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ne=this._handleWorkspaceContainsEagerExtensions(Z),re=Promise.all([N,ne]).then(()=>{});return Promise.race([re,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Z=>this._handleWorkspaceContainsEagerExtension(N,Z))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,Z){if(!this.isActivated(Z.identifier)){const ne=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={folders:N.map(Ae=>Ae.uri),forceUsingSearch:ne,exists:Ae=>this._hostUtils.exists(Ae.fsPath),checkExists:(Ae,Be,Re)=>this._mainThreadWorkspaceProxy.$checkExists(Ae,Be,Re)},ye=await(0,F.checkActivateWorkspaceContainsExtension)(re,Z);if(!!ye)return this._activateById(Z.identifier,{startup:!0,extensionId:Z.identifier,activationEvent:ye.activationEvent}).then(void 0,Ae=>this._logService.error(Ae))}}async $extensionTestsExecute(){await this._readyToRunExtensions.wait();try{return this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:Z}=this._initData.environment;if(!N||!Z||Z.scheme!==c.Schemas.file)throw new Error(w.localize(0,null));const ne=(0,P.originalFSPath)(Z),re=await this._loadCommonJSModule(null,Z,new f.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(w.localize(1,null,ne));return new Promise((ye,Ae)=>{const Be=(xe,W)=>{xe?Ae(xe):ye(typeof W=="number"&&W>0?1:0)},Re=re.run(ne,Be);Re&&Re.then&&Re.then(()=>{ye(0)}).catch(xe=>{Ae(xe.toString())})})}async $extensionTestsExit(N){this._logService.info(`extension host terminating: test runner requested exit with code ${N}`),this._logService.info(`exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(N,Z){return this._resolvers[N]=Z,(0,I.toDisposable)(()=>{delete this._resolvers[N]})}async $resolveAuthority(N,Z){const ne=N.indexOf("+");if(ne===-1)throw new Error("Not an authority that can be resolved!");const re=N.substr(0,ne);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1);const ye=this._resolvers[re];if(!ye)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${re}.`,detail:void 0}};try{T.mark(`code/extHost/willResolveAuthority/${re}`);const Ae=await ye.resolve(N,{resolveAttempt:Z});T.mark(`code/extHost/didResolveAuthorityOK/${re}`),this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ye));const Be={authority:N,host:Ae.host,port:Ae.port,connectionToken:Ae.connectionToken},Re={extensionHostEnv:Ae.extensionHostEnv};return{type:"ok",value:{authority:Be,options:Re,tunnelInformation:{environmentTunnels:Ae.environmentTunnels}}}}catch(Ae){if(T.mark(`code/extHost/didResolveAuthorityError/${re}`),Ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:Ae._code,message:Ae._message,detail:Ae._detail}};throw Ae}}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,Z){return Z===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(ne=>this._activateByEvent(N,!1))}async $activate(N,Z){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,Z),!0):!1}async $deltaExtensions(N,Z){N.forEach(re=>re.extensionLocation=n.URI.revive(re.extensionLocation));const ne=await this.getExtensionPathIndex();return await Promise.all(Z.map(async re=>{const ye=this._registry.getExtensionDescription(re);if(!!ye){const Ae=await this._hostUtils.realpath(ye.extensionLocation.fsPath);ne.delete(n.URI.file(Ae).fsPath)}})),await Promise.all(N.map(async re=>{const ye=await this._hostUtils.realpath(re.extensionLocation.fsPath);ne.set(n.URI.file(ye).fsPath,re)})),this._registry.deltaExtensions(N,Z),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let Z=o.VSBuffer.alloc(N),ne=Math.random()%256;for(let re=0;re<N;re++)Z.writeUInt8(ne,re);return Z}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};L=je([qe(0,l.IInstantiationService),qe(1,e.IHostUtils),qe(2,E.IExtHostRpcService),qe(3,h.IExtHostWorkspace),qe(4,_.IExtHostConfiguration),qe(5,A.ILogService),qe(6,s.IExtHostInitDataService),qe(7,a.IExtensionStoragePaths),qe(8,g.IExtHostTunnelService),qe(9,b.IExtHostTerminalService)],L),e.AbstractExtHostExtensionService=L;function $(Q,N){return{id:Q.identifier.value,name:Q.name,extensionVersion:Q.version,publisherDisplayName:Q.publisher,activationEvents:Q.activationEvents?Q.activationEvents.join(","):null,isBuiltin:Q.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class U{constructor(N,Z,ne,re){B.set(this,void 0),H.set(this,void 0),G.set(this,void 0),tt(this,B,N),tt(this,H,Z),tt(this,G,ne.identifier),this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=D.normalize((0,P.originalFSPath)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=re}get isActive(){return We(this,B).isActivated(We(this,G))}get exports(){if(this.packageJSON.api!=="none")return We(this,B).getExtensionExports(We(this,G))}activate(){return We(this,B).activateByIdWithErrors(We(this,G),{startup:!1,extensionId:We(this,H),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=U,B=new WeakMap,H=new WeakMap,G=new WeakMap}),define(we[101],Ee([0,1,11,2,3,13,5,7,164,31,36,40,169,35,165,14,4,12,32]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let d=class{constructor(a,E,R,g,b){this._workspaceService=E,this._extensionService=R,this._editorsService=g,this._configurationService=b,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new T.Emitter,this._onDidTerminateDebugSession=new T.Emitter,this._onDidChangeActiveDebugSession=new T.Emitter,this._onDidReceiveDebugSessionCustomEvent=new T.Emitter,this._debugServiceProxy=a.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new T.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new o(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(C=>{C.onDidChange(F=>{this.registerAllDebugTypes(C)}),this.registerAllDebugTypes(C)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,E){const R=a;if(typeof R.sourceReference=="number"&&R.sourceReference>0){let g=`debug:${encodeURIComponent(R.path||"")}`,b="?";return E&&(g+=`${b}session=${encodeURIComponent(E.id)}`,b="&"),g+=`${b}ref=${R.sourceReference}`,D.URI.parse(g)}else{if(R.path)return D.URI.file(R.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const E=[];for(const R of a.getAllExtensionDescriptions())if(R.contributes){const g=R.contributes.debuggers;if(g&&g.length>0)for(const b of g)(0,r.isDebuggerMainContribution)(b)&&E.push(b.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(E=>a.push(E)),a}addBreakpoints(a){this.startBreakpoints();const E=a.filter(b=>{const C=b.id;return this._breakpoints.has(C)?!1:(this._breakpoints.set(C,b),!0)});this.fireBreakpointChanges(E,[],[]);const R=[],g=new Map;for(const b of E)if(b instanceof I.SourceBreakpoint){let C=g.get(b.location.uri.toString());C||(C={type:"sourceMulti",uri:b.location.uri,lines:[]},g.set(b.location.uri.toString(),C),R.push(C)),C.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof I.FunctionBreakpoint&&R.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this._debugServiceProxy.$registerBreakpoints(R)}removeBreakpoints(a){this.startBreakpoints();const E=a.filter(C=>this._breakpoints.delete(C.id));this.fireBreakpointChanges([],E,[]);const R=E.filter(C=>C instanceof I.SourceBreakpoint).map(C=>C.id),g=E.filter(C=>C instanceof I.FunctionBreakpoint).map(C=>C.id),b=E.filter(C=>C instanceof I.DataBreakpoint).map(C=>C.id);return this._debugServiceProxy.$unregisterBreakpoints(R,g,b)}startDebugging(a,E,R){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,E,{parentSessionID:R.parentSession?R.parentSession.id:void 0,repl:R.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:R.noDebug,compact:R.compact})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,E,R){if(!E)return new I.Disposable(()=>{});const g=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:g,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,R,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,g),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(b=>b.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(a,E,R){if(!R)return new I.Disposable(()=>{});if(!this.definesDebugType(a,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:g,factory:R}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,g),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(b=>b.factory!==R),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(a,E){if(!E)return new I.Disposable(()=>{});const R=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:R,factory:E}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(g=>g.factory!==E)})}async $runInTerminal(a,E){return Promise.resolve(void 0)}async $substituteVariables(a,E){if(!this._variableResolver){const[b,C]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(b||[],this._editorsService,C)}let R;const g=await this.getFolder(a);return g&&(R={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(R,E)}createDebugAdapter(a,E){if(a.type==="implementation")return new u(a.implementation)}createSignService(){}async $startDASession(a,E){const R=this,g=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(g.type),g).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const C=this.convertToDto(b),F=this.createDebugAdapter(C,g);if(!F)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const x=F;return this._debugAdapters.set(a,x),this.getDebugAdapterTrackers(g).then(le=>(le&&this._debugAdaptersTrackers.set(a,le),x.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const H=B,G={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(H.arguments.value);G.body={signature:L},x.sendResponse(G)}else throw new Error("no signer")}catch(L){G.success=!1,G.message=L.message,x.sendResponse(G)}}else le&&le.onDidSendMessage&&le.onDidSendMessage(B),B=(0,r.convertToVSCPaths)(B,!0),R._debugServiceProxy.$acceptDAMessage(a,B)}),x.onError(B=>{le&&le.onError&&le.onError(B),this._debugServiceProxy.$acceptDAError(a,B.name,B.message,B.stack)}),x.onExit(B=>{le&&le.onExit&&le.onExit((0,m.withNullAsUndefined)(B),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,m.withNullAsUndefined)(B),void 0)}),le&&le.onWillStartSession&&le.onWillStartSession(),x.startSession()))})}$sendDAMessage(a,E){E=(0,r.convertToDAPaths)(E,!1);const R=this._debugAdaptersTrackers.get(a);R&&R.onWillReceiveMessage&&R.onWillReceiveMessage(E);const g=this._debugAdapters.get(a);g&&g.sendMessage(E)}$stopDASession(a){const E=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),E&&E.onWillStopSession&&E.onWillStopSession();const R=this._debugAdapters.get(a);return this._debugAdapters.delete(a),R?R.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const E=[],R=[],g=[];if(a.added)for(const b of a.added){const C=b.id;if(C&&!this._breakpoints.has(C)){let F;if(b.type==="function")F=new I.FunctionBreakpoint(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")F=new I.DataBreakpoint(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const x=D.URI.revive(b.uri);F=new I.SourceBreakpoint(new I.Location(x,new I.Position(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}F._id=C,this._breakpoints.set(C,F),E.push(F)}}if(a.removed)for(const b of a.removed){const C=this._breakpoints.get(b);C&&(this._breakpoints.delete(b),R.push(C))}if(a.changed){for(const b of a.changed)if(b.id){const C=this._breakpoints.get(b.id);if(C){if(C instanceof I.FunctionBreakpoint&&b.type==="function"){const F=C;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.functionName=b.functionName}else if(C instanceof I.SourceBreakpoint&&b.type==="source"){const F=C;F.enabled=b.enabled,F.condition=b.condition,F.hitCondition=b.hitCondition,F.logMessage=b.logMessage,F.location=new I.Location(D.URI.revive(b.uri),new I.Position(b.line,b.character))}g.push(C)}}}this.fireBreakpointChanges(E,R,g)}$provideDebugConfigurations(a,E,R){return(0,P.asPromise)(async()=>{const g=this.getConfigProviderByHandle(a);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.getFolder(E);return g.provideDebugConfigurations(b,R)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(a,E,R,g){return(0,P.asPromise)(async()=>{const b=this.getConfigProviderByHandle(a);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const C=await this.getFolder(E);return b.resolveDebugConfiguration(C,R,g)})}$resolveDebugConfigurationWithSubstitutedVariables(a,E,R,g){return(0,P.asPromise)(async()=>{const b=this.getConfigProviderByHandle(a);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const C=await this.getFolder(E);return b.resolveDebugConfigurationWithSubstitutedVariables(C,R,g)})}async $provideDebugAdapter(a,E){const R=this.getAdapterDescriptorFactoryByHandle(a);if(!R)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.getSession(E);return this.getAdapterDescriptor(R,g).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.convertToDto(b)})}async $acceptDebugSessionStarted(a){const E=await this.getSession(a);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(a){const E=await this.getSession(a);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,E){const R=await this.getSession(a);R&&R._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(a,E){const g={session:await this.getSession(a),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(g)}convertToDto(a){if(a instanceof I.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof I.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const E=this._adapterFactories.filter(R=>R.type===a);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(a){const E=this._adapterFactories.filter(R=>R.handle===a);if(E.length>0)return E[0].factory}getConfigProviderByHandle(a){const E=this._configProviders.filter(R=>R.handle===a);if(E.length>0)return E[0].provider}definesDebugType(a,E){if(a.contributes){const R=a.contributes.debuggers;if(R&&R.length>0){for(const g of R)if(g.label&&g.type&&g.type===E)return!0}}return!1}getDebugAdapterTrackers(a){const R=a.configuration.type,g=this._trackerFactories.filter(b=>b.type===R||b.type==="*").map(b=>(0,P.asPromise)(()=>b.factory.createDebugAdapterTracker(a)).then(C=>C,C=>null));return Promise.race([Promise.all(g).then(b=>{const C=b.filter(F=>!!F);if(C.length>0)return new i(C)}),new Promise((b,C)=>{const F=setTimeout(()=>{clearTimeout(F),C(new Error("timeout"))},1e3)})]).catch(b=>{})}async getAdapterDescriptor(a,E){const R=E.configuration.debugServer;if(typeof R=="number")return Promise.resolve(new I.DebugAdapterServer(R));if(a){const b=await this._extensionService.getExtensionRegistry();return(0,P.asPromise)(()=>a.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,b))).then(C=>{if(C)return C})}const g=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,g))}daExecutableFromPackage(a,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,E,R){(a.length>0||E.length>0||R.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:E,changed:R}))}async getSession(a){if(a)if(typeof a=="string"){const E=this._debugSessions.get(a);if(E)return E}else{let E=this._debugSessions.get(a.id);if(!E){const R=await this.getFolder(a.folderUri);E=new c(this._debugServiceProxy,a.id,a.type,a.name,R,a.configuration),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(a){if(a){const E=D.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};d=je([qe(0,h.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,k.IExtHostDocumentsAndEditors),qe(4,f.IExtHostConfiguration)],d),e.ExtHostDebugServiceBase=d;class c{constructor(a,E,R,g,b,C){this._debugServiceProxy=a,this._id=E,this._type=R,this._name=g,this._workspaceFolder=b,this._configuration=C}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,E)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=c;class o{constructor(a){this.value=Object.freeze({append(E){a.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=o;class t extends _.AbstractVariableResolverService{constructor(a,E,R,g){super({getFolderUri:b=>{const C=a.filter(F=>F.name===b);if(C&&C.length>0)return C[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(b,C)=>R.getConfiguration(void 0,b).get(C),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(E){const b=E.activeEditor();if(b)return w.normalize(b.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(E&&g){const b=E.activeEditor();if(b){const C=g.getWorkspaceFolder(b.document.uri);if(C)return w.normalize(C.uri.fsPath)}}},getSelectedText:()=>{if(E){const b=E.activeEditor();if(b&&!b.selection.isEmpty)return b.document.getText(b.selection)}},getLineNumber:()=>{if(E){const b=E.activeEditor();if(b)return String(b.selection.end.line+1)}}},void 0,v.env)}}e.ExtHostVariableResolverService=t;class i{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(E=>E.onError?E.onError(a):void 0)}onExit(a,E){this.trackers.forEach(R=>R.onExit?R.onExit(a,E):void 0)}}class u extends y.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends d{constructor(a,E,R,g,b){super(a,E,R,g,b)}createVariableResolver(a,E,R){return new t(a,E,R)}};l=je([qe(0,h.IExtHostRpcService),qe(1,n.IExtHostWorkspace),qe(2,A.IExtHostExtensionService),qe(3,k.IExtHostDocumentsAndEditors),qe(4,f.IExtHostConfiguration)],l),e.WorkerExtHostDebugService=l}),define(we[216],Ee([0,1,77,2,5,35,34,25,14,27,4,36,32,19]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(d,c,o,t,i,u,l){this._apiFactory=d,this._extensionRegistry=c,this._instaService=o,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=u,this._logService=l,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const c=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,c,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(p)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,c,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let c of d.nodeModuleName)this._factories.set(c,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(c=>d.alternativeModuleName(c))}};r=je([qe(2,A.IInstantiationService),qe(3,P.IExtHostConfiguration),qe(4,k.IExtHostExtensionService),qe(5,n.IExtHostInitDataService),qe(6,f.ILogService)],r),e.RequireInterceptor=r;class h{constructor(d,c,o,t,i){this._apiFactory=d,this._extensionPaths=c,this._extensionRegistry=o,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,c){const o=this._extensionPaths.findSubstr(c.fsPath);if(o){let t=this._extApiImpl.get(I.ExtensionIdentifier.toKey(o.identifier));return t||(t=this._apiFactory(o,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(o.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,u)=>t+=`	${u} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${c.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(d,c){this.nodeModuleName="keytar";const{environment:o}=c,t=d.getProxy(T.MainContext.MainThreadKeytar);if(o.appRoot){let i=o.appRoot.fsPath;_.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,u)=>t.$getPassword(i,u),setPassword:(i,u,l)=>t.$setPassword(i,u,l),deletePassword:(i,u)=>t.$deletePassword(i,u),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(d,c){return this._impl}alternativeModuleName(d){const c=d.length;if(!(c<=7||!this.alternativeNames)){const o=c-7;if((d.charAt(o)==="/"||d.charAt(o)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};p=je([qe(0,y.IExtHostRpcService),qe(1,n.IExtHostInitDataService)],p);let m=class{constructor(d,c,o){this._extensionPaths=d,this._appUriScheme=c,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=o.getProxy(T.MainContext.MainThreadTelemetry);const t=o.getProxy(T.MainContext.MainThreadWindow);this._impl=(i,u)=>{const l=D.URI.parse(i);return u?this.callOriginal(i,u):l.scheme==="http"||l.scheme==="https"?t.$openUri(l,i,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this._appUriScheme?t.$openUri(l,i,{}):this.callOriginal(i,u)}}load(d,c,o){const t=this._extensionPaths.findSubstr(c.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=o(d),this._impl}callOriginal(d,c){return this.sendNoForwardTelemetry(),this._original(d,c)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=je([qe(2,y.IExtHostRpcService)],m)}),define(we[217],Ee([0,1,13,10,77,6,2,5,209,19,61,65,27,147,14,68,36,41]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(c,o,t,i){this._disposables=new P.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const u=new y.RPCProtocol(c,null,i);o=v._transform(o,u);const l=new k.ServiceCollection(...(0,A.getSingletonServiceDescriptors)());l.set(_.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},o)),l.set(r.IExtHostRpcService,new r.ExtHostRpcService(u)),l.set(h.IURITransformerService,new h.URITransformerService(i)),l.set(p.IHostUtils,t);const s=new f.InstantiationService(l,!0),a=s.invokeFunction(b=>b.get(m.IExtHostTerminalService));this._disposables.add(a),this._logService=s.invokeFunction(b=>b.get(n.ILogService)),T.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",o),this._extensionService=s.invokeFunction(b=>b.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const E=new WeakMap;this._extensionService.getExtensionPathIndex().then(b=>{Error.prepareStackTrace=(C,F)=>{let x="",le,B;for(const H of F)x+=`
	at ${H.toString()}`,B=H.getFileName(),!le&&B&&(le=b.findSubstr(B));return E.set(C,le),`${C.name||"Error"}: ${C.message||""}${x}`}});const R=u.getProxy(I.MainContext.MainThreadExtensionService),g=u.getProxy(I.MainContext.MainThreadErrors);D.setUnexpectedErrorHandler(b=>{const C=D.transformErrorForSerialization(b),F=E.get(b);F?R.$onExtensionRuntimeError(F.identifier,C):g.$onUnexpectedError(C)})}terminate(c){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),D.setUnexpectedErrorHandler(t=>{});const o=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),o]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(c,o){c.extensions.forEach(i=>i.extensionLocation=S.URI.revive(o.transformIncomingURIs(i.extensionLocation))),c.environment.appRoot=S.URI.revive(o.transformIncomingURIs(c.environment.appRoot));const t=c.environment.extensionDevelopmentLocationURI;return t&&(c.environment.extensionDevelopmentLocationURI=t.map(i=>S.URI.revive(o.transformIncomingURIs(i)))),c.environment.extensionTestsLocationURI=S.URI.revive(o.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=S.URI.revive(o.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=S.URI.revive(o.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=S.URI.revive(o.transformIncomingURIs(c.logsLocation)),c.logFile=S.URI.revive(o.transformIncomingURIs(c.logFile)),c.workspace=o.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=v}),define(we[218],Ee([0,1,11,20,60,28,24,55,42,32]),function(oe,e,w,D,T,P,S,I,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class A{constructor(f,r,h){this.config=f,this.provider=r,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=f.filePattern,this.includePattern=f.includePattern&&P.parse(f.includePattern),this.maxResults=f.maxResults||void 0,this.exists=f.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=f.excludePattern&&P.parse(f.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(f=>f.cancel()),this.activeCancellationTokens=new Set}search(f){const r=this.config.folderQueries||[];return new Promise((h,p)=>{const m=v=>{this.resultCount++,f(v)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(v=>{const d=v.toString(),c=w.basename(d);this.globalExcludePattern&&this.globalExcludePattern(d,c)||this.matchFile(m,{base:v,basename:c})}),Promise.all(r.map(v=>this.searchInFolder(v,m))).then(v=>{h({limitHit:this.isLimitHit,stats:v[0]||void 0})},v=>{p(new Error((0,T.toErrorMessage)(v)))})})}searchInFolder(f,r){const h=new D.CancellationTokenSource;return new Promise((p,m)=>{const v=this.getSearchOptionsForFolder(f),d=this.initDirectoryTree(),c=new y.QueryGlobTester(this.config,f),o=!c.hasSiblingExcludeClauses();let t;new Promise(i=>(0,n.nextTick)(i)).then(()=>(this.activeCancellationTokens.add(h),t=I.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},v,h.token))).then(i=>{const u=t.elapsed(),l=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(i&&i.forEach(s=>{const a=w.posix.relative(f.folder.path,s.path);if(o){const E=w.basename(s.path);this.matchFile(r,{base:f.folder,relativePath:a,basename:E});return}this.addDirectoryEntries(d,f.folder,a,r)}),this.activeCancellationTokens.delete(h),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,c,r),{providerTime:u,postProcessTime:l.elapsed()})}).then(i=>{h.dispose(),p(i)},i=>{h.dispose(),m(i)})})}getSearchOptionsForFolder(f){const r=(0,y.resolvePatternsForProvider)(this.config.includePattern,f.includePattern),h=(0,y.resolvePatternsForProvider)(this.config.excludePattern,f.excludePattern);return{folder:f.folder,excludes:h,includes:r,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}addDirectoryEntries({pathToEntries:f},r,h,p){if(h===this.filePattern){const v=w.basename(this.filePattern);this.matchFile(p,{base:r,relativePath:this.filePattern,basename:v})}function m(v){const d=w.basename(v),c=w.dirname(v);let o=f[c];o||(o=f[c]=[],m(c)),o.push({base:r,relativePath:v,basename:d})}m(h)}matchDirectoryTree({rootEntries:f,pathToEntries:r},h,p){const m=this,v=this.filePattern;function d(c){const o=P.hasSiblingFn(()=>c.map(t=>t.basename));for(let t=0,i=c.length;t<i;t++){const u=c[t],{relativePath:l,basename:s}=u;if(!!h.includedInQuerySync(l,s,v!==s?o:void 0)){const a=r[l];if(a)d(a);else{if(l===v)continue;m.matchFile(p,u)}if(m.isLimitHit)break}}}d(f)}matchFile(f,r){(!this.includePattern||r.relativePath&&this.includePattern(r.relativePath,r.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||f(r))}}class k{constructor(){this.sessions=new Map}fileSearch(f,r,h,p){const m=this.getSessionTokenSource(f.cacheKey),v=new A(f,r,m&&m.token);let d=0;const c=o=>{d+=o.length,h(o.map(t=>this.rawMatchToSearchItem(t)))};return this.doSearch(v,k.BATCH_SIZE,c,p).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:o.stats}}))}clearCache(f){const r=this.getSessionTokenSource(f);r&&r.cancel()}getSessionTokenSource(f){if(!!f)return this.sessions.has(f)||this.sessions.set(f,new D.CancellationTokenSource),this.sessions.get(f)}rawMatchToSearchItem(f){return f.relativePath?{resource:S.joinPath(f.base,f.relativePath)}:{resource:f.base}}doSearch(f,r,h,p){p.onCancellationRequested(()=>{f.cancel()});const m=d=>{d&&(v.push(d),r>0&&v.length>=r&&(h(v),v=[]))};let v=[];return f.search(m).then(d=>(v.length&&h(v),d),d=>(v.length&&h(v),Promise.reject(d)))}}e.FileSearchManager=k,k.BATCH_SIZE=512}),define(we[219],Ee([0,1,11,15,20,60,24,28,2,42,32,16]),function(oe,e,w,D,T,P,S,I,y,n,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(d,c,o){this.query=d,this.provider=c,this.fileUtils=o,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,c){const o=this.query.folderQueries||[],t=new T.CancellationTokenSource;return c.onCancellationRequested(()=>t.cancel()),new Promise((i,u)=>{this.collector=new r(d);let l=!1;const s=(a,E)=>{if(!l&&!this.isLimitHit){const R=this.resultSize(a);p(a)&&typeof this.query.maxResults=="number"&&this.resultCount+R>this.query.maxResults&&(this.isLimitHit=!0,l=!0,t.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const g=this.resultSize(a);this.resultCount+=g,(g>0||!p(a))&&this.collector.add(a,E)}};Promise.all(o.map((a,E)=>this.searchInFolder(a,R=>s(R,E),t.token))).then(a=>{t.dispose(),this.collector.flush();const E=a.some(R=>!!R&&!!R.limitHit);i({limitHit:this.isLimitHit||E,stats:{type:"textSearchProvider"}})},a=>{t.dispose();const E=(0,P.toErrorMessage)(a);u(new Error(E))})})}resultSize(d){return p(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,c){const o=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:o.slice(0,c),preview:{matches:t.slice(0,c),text:d.preview.text},uri:d.uri}}searchInFolder(d,c,o){const t=new n.QueryGlobTester(this.query,d),i=[],u={report:s=>{if(!!this.validateProviderResult(s)){const a=d.folder.scheme===k.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(s.uri))):void 0,E=S.relativePath(d.folder,s.uri);E&&i.push(t.includedInQuery(E,w.basename(E),a).then(R=>{R&&c(s)}))}}},l=this.getSearchOptionsForFolder(d);return new Promise(s=>(0,A.nextTick)(s)).then(()=>this.provider.provideTextSearchResults(f(this.query.contentPattern),l,u,o)).then(s=>Promise.all(i).then(()=>s))}validateProviderResult(d){if(p(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const c=(0,n.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),o=(0,n.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:y.URI.from(d.folder),excludes:o,includes:c,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=_;function f(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class r{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,c=>this.sendItems(c))}add(d,c){this._currentFileMatch&&(this._currentFolderIdx!==c||!S.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=c,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(h(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=r;function h(v){return p(v)?{preview:{matches:(0,D.mapArrayOrNot)(v.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:v.preview.text},ranges:(0,D.mapArrayOrNot)(v.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function p(v){return!!v.preview}e.extensionResultIsMatch=p;class m{constructor(d,c){this.maxBatchSize=d,this.cb=c,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,c){!d||this.addItemToBatch(d,c)}addItems(d,c){!d||this.addItemsToBatch(d,c)}addItemToBatch(d,c){this.batch.push(d),this.batchSize+=c,this.onUpdate()}addItemsToBatch(d,c){this.batch=this.batch.concat(d),this.batchSize+=c,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(we[102],Ee([0,1,6,5,4,218,14,68,19,2,219]),function(oe,e,w,D,T,P,S,I,y,n,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let k=class{constructor(h,p,m){this.extHostRpc=h,this._uriTransformer=p,this._logService=m,this._proxy=this.extHostRpc.getProxy(D.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new P.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,p){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const m=this._handlePool++;return this._textSearchProvider.set(m,p),this._proxy.$registerTextSearchProvider(m,this._transformScheme(h)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(h,p){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const m=this._handlePool++;return this._fileSearchProvider.set(m,p),this._proxy.$registerFileSearchProvider(m,this._transformScheme(h)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(h,p,m,v){const d=_(m),c=this._fileSearchProvider.get(h);if(c)return this._fileSearchManager.fileSearch(d,c,o=>{this._proxy.$handleFileMatch(h,p,o.map(t=>t.resource))},v);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,p,m,v){const d=this._textSearchProvider.get(h);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const c=_(m);return this.createTextSearchManager(c,d).search(t=>this._proxy.$handleTextMatch(h,p,t),v)}createTextSearchManager(h,p){return new A.TextSearchManager(h,p,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};k=je([qe(0,S.IExtHostRpcService),qe(1,I.IURITransformerService),qe(2,y.ILogService)],k),e.ExtHostSearch=k;function _(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(f),extraFileResources:r.extraFileResources&&r.extraFileResources.map(h=>n.URI.revive(h))})}e.reviveQuery=_;function f(r){return Object.assign(Object.assign({},r),{folder:n.URI.revive(r.folder)})}}),define(we[220],Ee([0,1,126,20,10,3,47,2,120,82,114,59,64,5,186,185,73,187,35,188,189,190,172,191,40,36,192,173,194,195,196,98,176,198,199,200,75,41,201,177,9,7,204,50,99,31,34,51,161,193,91,97,100,101,102,19,68,14,27,197,160,67,72,183,202,159,76,74,207,205,206,184,49,213,203,71,156,93]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v,d,c,o,t,i,u,l,s,a,E,R,g,b,C,F,x,le,B,H,G,L,$,U,Q,N,Z,ne,re,ye,Ae,Be,Re,xe,W,K,J,ae,ge,De,Le,pe,Ce,Te,Ue,be,Ke,V,X,_e,Me,He,Oe,Xe,z,ie,ce,j,Y,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function fe(ve){const $e=ve.get(Le.IExtHostInitDataService),Ne=ve.get(z.IExtHostFileSystemInfo),Ve=ve.get(_e.IExtHostConsumerFileSystem),Qe=ve.get(l.IExtHostExtensionService),Ze=ve.get(ne.IExtHostWorkspace),ct=ve.get(se.IExtHostTelemetry),st=ve.get(v.IExtHostConfiguration),me=ve.get(ge.IURITransformerService),he=ve.get(De.IExtHostRpcService),ue=ve.get(B.IExtHostStorage),q=ve.get(X.IExtensionStoragePaths),Ie=ve.get(ae.ILogService),Pe=ve.get(Te.IExtHostTunnelService),et=ve.get(Ue.IExtHostApiDeprecationService),Ge=ve.get(Z.IExtHostWindow),rt=ve.get(j.IExtHostSecretState);he.set(f.ExtHostContext.ExtHostFileSystemInfo,Ne),he.set(f.ExtHostContext.ExtHostLogService,Ie),he.set(f.ExtHostContext.ExtHostWorkspace,Ze),he.set(f.ExtHostContext.ExtHostConfiguration,st),he.set(f.ExtHostContext.ExtHostExtensionService,Qe),he.set(f.ExtHostContext.ExtHostStorage,ue),he.set(f.ExtHostContext.ExtHostTunnelService,Pe),he.set(f.ExtHostContext.ExtHostWindow,Ge),he.set(f.ExtHostContext.ExtHostSecretState,rt),he.set(f.ExtHostContext.ExtHostTelemetry,ct);const lt=he.set(f.ExtHostContext.ExtHostDecorations,ve.get(xe.IExtHostDecorations)),Je=he.set(f.ExtHostContext.ExtHostDocumentsAndEditors,ve.get(u.IExtHostDocumentsAndEditors)),it=he.set(f.ExtHostContext.ExtHostCommands,ve.get(p.IExtHostCommands)),dt=he.set(f.ExtHostContext.ExtHostTerminalService,ve.get(H.IExtHostTerminalService)),at=he.set(f.ExtHostContext.ExtHostDebugService,ve.get(K.IExtHostDebugService)),Dt=he.set(f.ExtHostContext.ExtHostSearch,ve.get(J.IExtHostSearch)),gt=he.set(f.ExtHostContext.ExtHostTask,ve.get(W.IExtHostTask)),Ct=he.set(f.ExtHostContext.ExtHostOutputService,ve.get(b.IExtHostOutputService)),wt=he.set(f.ExtHostContext.ExtHostEditorTabs,new Y.ExtHostEditorTabs),Et=he.set(f.ExtHostContext.ExtHostUrls,new Q.ExtHostUrls(he)),mt=he.set(f.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(he,Je)),Rt=he.set(f.ExtHostContext.ExtHostDocumentContentProviders,new o.ExtHostDocumentContentProvider(he,Je,Ie)),Ft=he.set(f.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ie,mt,he.getProxy(f.MainContext.MainThreadBulkEdits))),ht=he.set(f.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(he,it,Je,mt,$e.environment,Ie,q)),yt=he.set(f.ExtHostContext.ExtHostEditors,new G.ExtHostEditors(he,Je)),Ut=he.set(f.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(he.getProxy(f.MainContext.MainThreadTreeViews),it,Ie)),$t=he.set(f.ExtHostContext.ExtHostEditorInsets,new Ae.ExtHostEditorInsets(he.getProxy(f.MainContext.MainThreadEditorInsets),yt,$e.environment)),Lt=he.set(f.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(he,Ie)),ut=he.set(f.ExtHostContext.ExtHostLanguageFeatures,new E.ExtHostLanguageFeatures(he,me,mt,it,Lt,Ie,et)),ln=he.set(f.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(he,ut)),It=he.set(f.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(he,Ie,Je)),At=he.set(f.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(he,Ze,it)),Yt=he.set(f.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(he,it,Ie)),un=he.set(f.ExtHostContext.ExtHostComments,new m.ExtHostComments(he,it,mt)),Xt=he.set(f.ExtHostContext.ExtHostProgress,new C.ExtHostProgress(he.getProxy(f.MainContext.MainThreadProgress))),cn=he.set(f.ExtHostContext.ExtHosLabelService,new Be.ExtHostLabelService(he)),Zt=he.set(f.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),Pt=he.set(f.ExtHostContext.ExtHostAuthentication,new be.ExtHostAuthentication(he)),Bt=he.set(f.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,it)),xt=he.set(f.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(he,$e.environment,Ze,Ie,et)),Ht=he.set(f.ExtHostContext.ExtHostWebviewPanels,new Oe.ExtHostWebviewPanels(he,xt,Ze)),dn=he.set(f.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(he,mt,q,xt,Ht)),hn=he.set(f.ExtHostContext.ExtHostWebviewViews,new Me.ExtHostWebviewViews(he,xt)),kt=he.set(f.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(he,Je,Ze)),fn=he.set(f.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(he)),mn=(0,ye.values)(f.ExtHostContext);he.assertRegistered(mn);const zt=new Xe.ExtHostBulkEdits(he,Je),gn=new h.ExtHostClipboard(he),Vt=new g.ExtHostMessageService(he,Ie),Wt=new c.ExtHostDialogs(he),Mt=new le.ExtHostStatusBar(he,it.converter),jt=new R.ExtHostLanguages(he,mt);return r.ExtHostApiCommands.register(it),function(Fe,Ot,qt){const ft=function(){let ee=!Fe.isUnderDevelopment;function de(ke){ee||(Ie.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function ke(O){if(Array.isArray(O))O.forEach(ke);else if(typeof O=="string")de(O);else{const M=O;typeof M.scheme=="undefined"&&de(O),!Fe.enableProposedApi&&typeof M.exclusive=="boolean"&&(0,re.throwProposedApiError)(Fe)}return O}}(),pn={getSession(ee,de,ke){return Pt.getSession(Fe,ee,de,ke)},get onDidChangeSessions(){return Pt.onDidChangeSessions},registerAuthenticationProvider(ee,de,ke,O){return Pt.registerAuthenticationProvider(ee,de,ke,O)},get onDidChangeAuthenticationProviders(){return(0,re.checkProposedApiEnabled)(Fe),Pt.onDidChangeAuthenticationProviders},get providers(){return(0,re.checkProposedApiEnabled)(Fe),Pt.providers},logout(ee,de){return(0,re.checkProposedApiEnabled)(Fe),Pt.removeSession(ee,de)}},en={registerCommand(ee,de,ke){return it.registerCommand(!0,ee,de,ke)},registerTextEditorCommand(ee,de,ke){return it.registerCommand(!0,ee,(...O)=>{const M=yt.getActiveTextEditor();if(!M){Ie.warn("Cannot execute "+ee+" because there is no active text editor.");return}return M.edit(te=>{de.apply(ke,[M,te,...O])}).then(te=>{te||Ie.warn("Edits from command "+ee+" were not applied.")},te=>{Ie.warn("An error occurred while running command "+ee,te)})})},registerDiffInformationCommand:(ee,de,ke)=>((0,re.checkProposedApiEnabled)(Fe),it.registerCommand(!0,ee,async(...O)=>{const M=Je.activeEditor(!0);if(!M){Ie.warn("Cannot execute "+ee+" because there is no active text editor.");return}const te=await yt.getDiffInformation(M.id);de.apply(ke,[te,...O])})),executeCommand(ee,...de){return it.executeCommand(ee,...de)},getCommands(ee=!1){return it.getCommands(ee)}},tn={get machineId(){return $e.telemetryInfo.machineId},get sessionId(){return $e.telemetryInfo.sessionId},get language(){return $e.environment.appLanguage},get appName(){return $e.environment.appName},get appRoot(){var ee,de;return(de=(ee=$e.environment.appRoot)===null||ee===void 0?void 0:ee.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return $e.environment.appUriScheme},get clipboard(){return gn.value},get shell(){return dt.getDefaultShell(!1,qt)},get isTelemetryEnabled(){return ct.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ct.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ee=Date.now()-new Date($e.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,de){return Ge.openUri(ee,{allowTunneling:!!$e.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(ee){return ee.scheme===$e.environment.appUriScheme?Et.createAppUri(ee):Ge.asExternalUri(ee,{allowTunneling:!!$e.remote.authority})},get remoteName(){return(0,Re.getRemoteName)($e.remote.authority)},get uiKind(){return $e.uiKind}};$e.environment.extensionTestsLocationURI||Object.freeze(tn);const nn=$e.remote.isRemote?U.ExtensionKind.Workspace:U.ExtensionKind.UI,Kt={registerTestProvider(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.registerTestProvider(ee)},createDocumentTestObserver(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.createTextDocumentTestObserver(ee)},createWorkspaceTestObserver(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.createWorkspaceTestObserver(ee)},runTests(ee){return(0,re.checkProposedApiEnabled)(Fe),kt.runTests(ee)},publishTestResult(ee,de=!0){return(0,re.checkProposedApiEnabled)(Fe),kt.publishExtensionProvidedResults(ee,de)},get onDidChangeTestResults(){return(0,re.checkProposedApiEnabled)(Fe),kt.onResultsChanged},get testResults(){return(0,re.checkProposedApiEnabled)(Fe),kt.results}},vn={getExtension(ee){const de=Ot.getExtensionDescription(ee);if(de)return new l.Extension(Qe,Fe.identifier,de,nn)},get all(){return Ot.getAllExtensionDescriptions().map(ee=>new l.Extension(Qe,Fe.identifier,ee,nn))},get onDidChange(){return Ot.onDidChange}},_n={createDiagnosticCollection(ee){return Lt.createDiagnosticCollection(Fe.identifier,ee)},get onDidChangeDiagnostics(){return Lt.onDidChangeDiagnostics},getDiagnostics:ee=>Lt.getDiagnostics(ee),getLanguages(){return jt.getLanguages()},setTextDocumentLanguage(ee,de){return jt.changeLanguage(ee.uri,de)},match(ee,de){return(0,k.score)($.LanguageSelector.from(ee),de.uri,de.languageId,!0)},registerCodeActionsProvider(ee,de,ke){return ut.registerCodeActionProvider(Fe,ft(ee),de,ke)},registerCodeLensProvider(ee,de){return ut.registerCodeLensProvider(Fe,ft(ee),de)},registerDefinitionProvider(ee,de){return ut.registerDefinitionProvider(Fe,ft(ee),de)},registerDeclarationProvider(ee,de){return ut.registerDeclarationProvider(Fe,ft(ee),de)},registerImplementationProvider(ee,de){return ut.registerImplementationProvider(Fe,ft(ee),de)},registerTypeDefinitionProvider(ee,de){return ut.registerTypeDefinitionProvider(Fe,ft(ee),de)},registerHoverProvider(ee,de){return ut.registerHoverProvider(Fe,ft(ee),de,Fe.identifier)},registerEvaluatableExpressionProvider(ee,de){return ut.registerEvaluatableExpressionProvider(Fe,ft(ee),de,Fe.identifier)},registerInlineValuesProvider(ee,de){return ut.registerInlineValuesProvider(Fe,ft(ee),de,Fe.identifier)},registerDocumentHighlightProvider(ee,de){return ut.registerDocumentHighlightProvider(Fe,ft(ee),de)},registerLinkedEditingRangeProvider(ee,de){return ut.registerLinkedEditingRangeProvider(Fe,ft(ee),de)},registerReferenceProvider(ee,de){return ut.registerReferenceProvider(Fe,ft(ee),de)},registerRenameProvider(ee,de){return ut.registerRenameProvider(Fe,ft(ee),de)},registerDocumentSymbolProvider(ee,de,ke){return ut.registerDocumentSymbolProvider(Fe,ft(ee),de,ke)},registerWorkspaceSymbolProvider(ee){return ut.registerWorkspaceSymbolProvider(Fe,ee)},registerDocumentFormattingEditProvider(ee,de){return ut.registerDocumentFormattingEditProvider(Fe,ft(ee),de)},registerDocumentRangeFormattingEditProvider(ee,de){return ut.registerDocumentRangeFormattingEditProvider(Fe,ft(ee),de)},registerOnTypeFormattingEditProvider(ee,de,ke,...O){return ut.registerOnTypeFormattingEditProvider(Fe,ft(ee),de,[ke].concat(O))},registerDocumentSemanticTokensProvider(ee,de,ke){return ut.registerDocumentSemanticTokensProvider(Fe,ft(ee),de,ke)},registerDocumentRangeSemanticTokensProvider(ee,de,ke){return ut.registerDocumentRangeSemanticTokensProvider(Fe,ft(ee),de,ke)},registerSignatureHelpProvider(ee,de,ke,...O){return typeof ke=="object"?ut.registerSignatureHelpProvider(Fe,ft(ee),de,ke):ut.registerSignatureHelpProvider(Fe,ft(ee),de,typeof ke=="undefined"?[]:[ke,...O])},registerCompletionItemProvider(ee,de,...ke){return ut.registerCompletionItemProvider(Fe,ft(ee),de,ke)},registerDocumentLinkProvider(ee,de){return ut.registerDocumentLinkProvider(Fe,ft(ee),de)},registerColorProvider(ee,de){return ut.registerColorProvider(Fe,ft(ee),de)},registerFoldingRangeProvider(ee,de){return ut.registerFoldingRangeProvider(Fe,ft(ee),de)},registerSelectionRangeProvider(ee,de){return ut.registerSelectionRangeProvider(Fe,ee,de)},registerCallHierarchyProvider(ee,de){return ut.registerCallHierarchyProvider(Fe,ee,de)},setLanguageConfiguration:(ee,de)=>ut.setLanguageConfiguration(Fe,ee,de),getTokenInformationAtPosition(ee,de){return(0,re.checkProposedApiEnabled)(Fe),jt.tokenAtPosition(ee,de)},registerInlineHintsProvider(ee,de){return(0,re.checkProposedApiEnabled)(Fe),ut.registerInlineHintsProvider(Fe,ee,de)}},bn={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(ee,de,ke){const O=await(I.URI.isUri(ee)?Promise.resolve(rn.openTextDocument(ee)):Promise.resolve(ee));return yt.showTextDocument(O,de,ke)},createTextEditorDecorationType(ee){return yt.createTextEditorDecorationType(ee)},onDidChangeActiveTextEditor(ee,de,ke){return yt.onDidChangeActiveTextEditor(ee,de,ke)},onDidChangeVisibleTextEditors(ee,de,ke){return yt.onDidChangeVisibleTextEditors(ee,de,ke)},onDidChangeTextEditorSelection(ee,de,ke){return yt.onDidChangeTextEditorSelection(ee,de,ke)},onDidChangeTextEditorOptions(ee,de,ke){return yt.onDidChangeTextEditorOptions(ee,de,ke)},onDidChangeTextEditorVisibleRanges(ee,de,ke){return yt.onDidChangeTextEditorVisibleRanges(ee,de,ke)},onDidChangeTextEditorViewColumn(ee,de,ke){return yt.onDidChangeTextEditorViewColumn(ee,de,ke)},onDidCloseTerminal(ee,de,ke){return dt.onDidCloseTerminal(ee,de,ke)},onDidOpenTerminal(ee,de,ke){return dt.onDidOpenTerminal(ee,de,ke)},onDidChangeActiveTerminal(ee,de,ke){return dt.onDidChangeActiveTerminal(ee,de,ke)},onDidChangeTerminalDimensions(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),dt.onDidChangeTerminalDimensions(ee,de,ke)},onDidWriteTerminalData(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),dt.onDidWriteTerminalData(ee,de,ke)},get state(){return Ge.state},onDidChangeWindowState(ee,de,ke){return Ge.onDidChangeWindowState(ee,de,ke)},showInformationMessage(ee,...de){return Vt.showMessage(Fe,S.default.Info,ee,de[0],de.slice(1))},showWarningMessage(ee,...de){return Vt.showMessage(Fe,S.default.Warning,ee,de[0],de.slice(1))},showErrorMessage(ee,...de){return Vt.showMessage(Fe,S.default.Error,ee,de[0],de.slice(1))},showQuickPick(ee,de,ke){return At.showQuickPick(ee,!!Fe.enableProposedApi,de,ke)},showWorkspaceFolderPick(ee){return At.showWorkspaceFolderPick(ee)},showInputBox(ee,de){return At.showInput(ee,de)},showOpenDialog(ee){return Wt.showOpenDialog(ee)},showSaveDialog(ee){return Wt.showSaveDialog(ee)},createStatusBarItem(ee,de){let ke,O,M,te;return ee&&typeof ee!="number"?(ke=ee.id,O=ee.name,M=ee.alignment,de=ee.priority,te=ee.accessibilityInformation):(ke=Fe.identifier.value,O=w.localize(0,null,Fe.displayName||Fe.name),M=ee),Mt.createStatusBarEntry(ke,O,M,de,te)},setStatusBarMessage(ee,de){return Mt.setStatusBarMessage(ee,de)},withScmProgress(ee){return et.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Xt.withProgress(Fe,{location:U.ProgressLocation.SourceControl},(de,ke)=>ee({report(O){}}))},withProgress(ee,de){return Xt.withProgress(Fe,ee,de)},createOutputChannel(ee){return Ct.createOutputChannel(ee)},createWebviewPanel(ee,de,ke,O){return Ht.createWebviewPanel(Fe,ee,de,ke,O)},createWebviewTextEditorInset(ee,de,ke,O){return(0,re.checkProposedApiEnabled)(Fe),$t.createWebviewEditorInset(ee,de,ke,O,Fe)},createTerminal(ee,de,ke){return typeof ee=="object"?"pty"in ee?dt.createExtensionTerminal(ee):dt.createTerminalFromOptions(ee):dt.createTerminal(ee,de,ke)},registerTerminalLinkProvider(ee){return dt.registerLinkProvider(ee)},registerTreeDataProvider(ee,de){return Ut.registerTreeDataProvider(ee,de,Fe)},createTreeView(ee,de){return Ut.createTreeView(ee,de,Fe)},registerWebviewPanelSerializer:(ee,de)=>Ht.registerWebviewPanelSerializer(Fe,ee,de),registerCustomEditorProvider:(ee,de,ke={})=>dn.registerCustomEditorProvider(Fe,ee,de,ke),registerFileDecorationProvider(ee){return lt.registerFileDecorationProvider(ee,Fe.identifier)},registerUriHandler(ee){return Et.registerUriHandler(Fe.identifier,ee)},createQuickPick(){return At.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return At.createInputBox(Fe.identifier)},get activeColorTheme(){return Zt.activeColorTheme},onDidChangeActiveColorTheme(ee,de,ke){return Zt.onDidChangeActiveColorTheme(ee,de,ke)},registerWebviewViewProvider(ee,de,ke){return hn.registerWebviewViewProvider(Fe,ee,de,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,re.checkProposedApiEnabled)(Fe),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeActiveNotebookEditor(ee,de,ke)},get visibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookEditorSelection(ee,de,ke)},onDidChangeNotebookEditorVisibleRanges(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookEditorVisibleRanges(ee,de,ke)},showNotebookDocument(ee,de){return(0,re.checkProposedApiEnabled)(Fe),ht.showNotebookDocument(ee,de)},registerExternalUriOpener(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),fn.registerExternalUriOpener(Fe.identifier,ee,de,ke)},get openEditors(){return(0,re.checkProposedApiEnabled)(Fe),wt.tabs},get onDidChangeOpenEditors(){return(0,re.checkProposedApiEnabled)(Fe),wt.onDidChangeTabs}},rn={get rootPath(){return et.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ze.getPath()},set rootPath(ee){throw T.readonly()},getWorkspaceFolder(ee){return Ze.getWorkspaceFolder(ee)},get workspaceFolders(){return Ze.getWorkspaceFolders()},get name(){return Ze.name},set name(ee){throw T.readonly()},get workspaceFile(){return Ze.workspaceFile},set workspaceFile(ee){throw T.readonly()},updateWorkspaceFolders:(ee,de,...ke)=>Ze.updateWorkspaceFolders(Fe,ee,de||0,...ke),onDidChangeWorkspaceFolders:function(ee,de,ke){return Ze.onDidChangeWorkspace(ee,de,ke)},asRelativePath:(ee,de)=>Ze.getRelativePath(ee,de),findFiles:(ee,de,ke,O)=>Ze.findFiles($.GlobPattern.from(ee),$.GlobPattern.from(de),ke,Fe.identifier,O),findTextInFiles:(ee,de,ke,O)=>{let M,te;return typeof de=="object"?(M=de,te=ke):(M={},te=de,O=ke),Ze.findTextInFiles(ee,M||{},te,Fe.identifier,O)},saveAll:ee=>Ze.saveAll(ee),applyEdit(ee){return zt.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,de,ke,O)=>It.createFileSystemWatcher($.GlobPattern.from(ee),de,ke,O),get textDocuments(){return mt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw T.readonly()},openTextDocument(ee){let de;const ke=ee;if(typeof ee=="string")de=Promise.resolve(I.URI.file(ee));else if(I.URI.isUri(ee))de=Promise.resolve(ee);else if(!ke||typeof ke=="object")de=mt.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(O=>mt.ensureDocumentData(O).then(M=>M.document))},onDidOpenTextDocument:(ee,de,ke)=>mt.onDidAddDocument(ee,de,ke),onDidCloseTextDocument:(ee,de,ke)=>mt.onDidRemoveDocument(ee,de,ke),onDidChangeTextDocument:(ee,de,ke)=>mt.onDidChangeDocument(ee,de,ke),onDidSaveTextDocument:(ee,de,ke)=>mt.onDidSaveDocument(ee,de,ke),onWillSaveTextDocument:(ee,de,ke)=>Ft.getOnWillSaveTextDocumentEvent(Fe)(ee,de,ke),onDidChangeConfiguration:(ee,de,ke)=>qt.onDidChangeConfiguration(ee,de,ke),getConfiguration(ee,de){return de=arguments.length===1?void 0:de,qt.getConfiguration(ee,de,Fe)},registerTextDocumentContentProvider(ee,de){return Rt.registerTextDocumentContentProvider(ee,de)},registerTaskProvider:(ee,de)=>(et.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),gt.registerTaskProvider(Fe,ee,de)),registerFileSystemProvider(ee,de,ke){return ln.registerFileSystemProvider(Fe.identifier,ee,de,ke)},get fs(){return Ve.value},registerFileSearchProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Dt.registerFileSearchProvider(ee,de)),registerTextSearchProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Dt.registerTextSearchProvider(ee,de)),registerRemoteAuthorityResolver:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Qe.registerRemoteAuthorityResolver(ee,de)),registerResourceLabelFormatter:ee=>((0,re.checkProposedApiEnabled)(Fe),cn.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,de,ke)=>It.onDidCreateFile(ee,de,ke),onDidDeleteFiles:(ee,de,ke)=>It.onDidDeleteFile(ee,de,ke),onDidRenameFiles:(ee,de,ke)=>It.onDidRenameFile(ee,de,ke),onWillCreateFiles:(ee,de,ke)=>It.getOnWillCreateFileEvent(Fe)(ee,de,ke),onWillDeleteFiles:(ee,de,ke)=>It.getOnWillDeleteFileEvent(Fe)(ee,de,ke),onWillRenameFiles:(ee,de,ke)=>It.getOnWillRenameFileEvent(Fe)(ee,de,ke),openTunnel:ee=>((0,re.checkProposedApiEnabled)(Fe),Pe.openTunnel(Fe,ee).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,re.checkProposedApiEnabled)(Fe),Pe.getTunnels()},onDidChangeTunnels:(ee,de,ke)=>((0,re.checkProposedApiEnabled)(Fe),Pe.onDidChangeTunnels(ee,de,ke)),registerPortAttributesProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Pe.registerPortsAttributesProvider(ee,de)),registerTimelineProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),Bt.registerTimelineProvider(ee,de,Fe.identifier,it.converter)),get trustState(){return(0,re.checkProposedApiEnabled)(Fe),(0,re.checkRequiresWorkspaceTrust)(Fe),Ze.trustState},requireWorkspaceTrust:ee=>((0,re.checkProposedApiEnabled)(Fe),(0,re.checkRequiresWorkspaceTrust)(Fe),Ze.requireWorkspaceTrust(ee)),onDidChangeWorkspaceTrustState:(ee,de,ke)=>Ze.onDidChangeWorkspaceTrustState(ee,de,ke)},wn={get inputBox(){return et.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),Yt.getLastInputBox(Fe)},createSourceControl(ee,de,ke){return Yt.createSourceControl(Fe,ee,de,ke)}},sn={createCommentController(ee,de){return un.createCommentController(Fe,ee,de)}},En={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(ee,de,ke){return at.onDidStartDebugSession(ee,de,ke)},onDidTerminateDebugSession(ee,de,ke){return at.onDidTerminateDebugSession(ee,de,ke)},onDidChangeActiveDebugSession(ee,de,ke){return at.onDidChangeActiveDebugSession(ee,de,ke)},onDidReceiveDebugSessionCustomEvent(ee,de,ke){return at.onDidReceiveDebugSessionCustomEvent(ee,de,ke)},onDidChangeBreakpoints(ee,de,ke){return at.onDidChangeBreakpoints(ee,de,ke)},registerDebugConfigurationProvider(ee,de,ke){return at.registerDebugConfigurationProvider(ee,de,ke||U.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,de){return at.registerDebugAdapterDescriptorFactory(Fe,ee,de)},registerDebugAdapterTrackerFactory(ee,de){return at.registerDebugAdapterTrackerFactory(ee,de)},startDebugging(ee,de,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(ee,de,{parentSession:ke}):at.startDebugging(ee,de,ke||{})},stopDebugging(ee){return at.stopDebugging(ee)},addBreakpoints(ee){return at.addBreakpoints(ee)},removeBreakpoints(ee){return at.removeBreakpoints(ee)},asDebugSourceUri(ee,de){return at.asDebugSourceUri(ee,de)}},yn={registerTaskProvider:(ee,de)=>gt.registerTaskProvider(Fe,ee,de),fetchTasks:ee=>gt.fetchTasks(ee),executeTask:ee=>gt.executeTask(Fe,ee),get taskExecutions(){return gt.taskExecutions},onDidStartTask:(ee,de,ke)=>gt.onDidStartTask(ee,de,ke),onDidEndTask:(ee,de,ke)=>gt.onDidEndTask(ee,de,ke),onDidStartTaskProcess:(ee,de,ke)=>gt.onDidStartTaskProcess(ee,de,ke),onDidEndTaskProcess:(ee,de,ke)=>gt.onDidEndTaskProcess(ee,de,ke)},Gt={openNotebookDocument:ee=>((0,re.checkProposedApiEnabled)(Fe),ht.openNotebookDocument(ee)),get onDidOpenNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidSaveNotebookDocument},get notebookDocuments(){return(0,re.checkProposedApiEnabled)(Fe),ht.notebookDocuments.map(ee=>ee.notebookDocument)},get onDidChangeActiveNotebookKernel(){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeActiveNotebookKernel},registerNotebookSerializer(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.registerNotebookSerializer(Fe,ee,de,ke)},registerNotebookContentProvider:(ee,de,ke)=>((0,re.checkProposedApiEnabled)(Fe),ht.registerNotebookContentProvider(Fe,ee,de,ke)),registerNotebookKernelProvider:(ee,de)=>((0,re.checkProposedApiEnabled)(Fe),ht.registerNotebookKernelProvider(Fe,ee,de)),createNotebookEditorDecorationType(ee){return(0,re.checkProposedApiEnabled)(Fe),ht.createNotebookEditorDecorationType(ee)},onDidChangeNotebookDocumentMetadata(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookDocumentMetadata(ee,de,ke)},onDidChangeNotebookCells(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeNotebookCells(ee,de,ke)},onDidChangeCellOutputs(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeCellOutputs(ee,de,ke)},onDidChangeCellMetadata(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.onDidChangeCellMetadata(ee,de,ke)},createConcatTextDocument(ee,de){return(0,re.checkProposedApiEnabled)(Fe),new V.ExtHostNotebookConcatDocument(ht,mt,ee,de)},createCellStatusBarItem(ee,de,ke){return(0,re.checkProposedApiEnabled)(Fe),ht.createNotebookCellStatusBarItemInternal(ee,de,ke)}};return{version:$e.version,authentication:pn,commands:en,comments:sn,debug:En,env:tn,extensions:vn,languages:_n,notebook:Gt,scm:wn,tasks:yn,test:Kt,window:bn,workspace:rn,Breakpoint:U.Breakpoint,CallHierarchyIncomingCall:U.CallHierarchyIncomingCall,CallHierarchyItem:U.CallHierarchyItem,CallHierarchyOutgoingCall:U.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:D.CancellationTokenSource,CandidatePortSource:f.CandidatePortSource,CodeAction:U.CodeAction,CodeActionKind:U.CodeActionKind,CodeActionTriggerKind:U.CodeActionTriggerKind,CodeLens:U.CodeLens,Color:U.Color,ColorInformation:U.ColorInformation,ColorPresentation:U.ColorPresentation,ColorThemeKind:U.ColorThemeKind,CommentMode:U.CommentMode,CommentThreadCollapsibleState:U.CommentThreadCollapsibleState,CompletionItem:U.CompletionItem,CompletionItemKind:U.CompletionItemKind,CompletionItemTag:U.CompletionItemTag,CompletionList:U.CompletionList,CompletionTriggerKind:U.CompletionTriggerKind,ConfigurationTarget:U.ConfigurationTarget,CustomExecution:U.CustomExecution,DebugAdapterExecutable:U.DebugAdapterExecutable,DebugAdapterInlineImplementation:U.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:U.DebugAdapterNamedPipeServer,DebugAdapterServer:U.DebugAdapterServer,DebugConfigurationProviderTriggerKind:U.DebugConfigurationProviderTriggerKind,DebugConsoleMode:U.DebugConsoleMode,DecorationRangeBehavior:U.DecorationRangeBehavior,Diagnostic:U.Diagnostic,DiagnosticRelatedInformation:U.DiagnosticRelatedInformation,DiagnosticSeverity:U.DiagnosticSeverity,DiagnosticTag:U.DiagnosticTag,Disposable:U.Disposable,DocumentHighlight:U.DocumentHighlight,DocumentHighlightKind:U.DocumentHighlightKind,DocumentLink:U.DocumentLink,DocumentSymbol:U.DocumentSymbol,EndOfLine:U.EndOfLine,EnvironmentVariableMutatorType:U.EnvironmentVariableMutatorType,EvaluatableExpression:U.EvaluatableExpression,InlineValueText:U.InlineValueText,InlineValueVariableLookup:U.InlineValueVariableLookup,InlineValueEvaluatableExpression:U.InlineValueEvaluatableExpression,EventEmitter:P.Emitter,ExtensionKind:U.ExtensionKind,ExtensionMode:U.ExtensionMode,ExternalUriOpenerPriority:U.ExternalUriOpenerPriority,FileChangeType:U.FileChangeType,FileDecoration:U.FileDecoration,FileSystemError:U.FileSystemError,FileType:_.FileType,FoldingRange:U.FoldingRange,FoldingRangeKind:U.FoldingRangeKind,FunctionBreakpoint:U.FunctionBreakpoint,Hover:U.Hover,IndentAction:A.IndentAction,Location:U.Location,MarkdownString:U.MarkdownString,OverviewRulerLane:n.OverviewRulerLane,ParameterInformation:U.ParameterInformation,PortAutoForwardAction:U.PortAutoForwardAction,Position:U.Position,ProcessExecution:U.ProcessExecution,ProgressLocation:U.ProgressLocation,QuickInputButtons:U.QuickInputButtons,Range:U.Range,RelativePattern:U.RelativePattern,Selection:U.Selection,SelectionRange:U.SelectionRange,SemanticTokens:U.SemanticTokens,SemanticTokensBuilder:U.SemanticTokensBuilder,SemanticTokensEdit:U.SemanticTokensEdit,SemanticTokensEdits:U.SemanticTokensEdits,SemanticTokensLegend:U.SemanticTokensLegend,ShellExecution:U.ShellExecution,ShellQuoting:U.ShellQuoting,SignatureHelp:U.SignatureHelp,SignatureHelpTriggerKind:U.SignatureHelpTriggerKind,SignatureInformation:U.SignatureInformation,SnippetString:U.SnippetString,SourceBreakpoint:U.SourceBreakpoint,StandardTokenType:U.StandardTokenType,StatusBarAlignment:U.StatusBarAlignment,SymbolInformation:U.SymbolInformation,SymbolKind:U.SymbolKind,SymbolTag:U.SymbolTag,Task:U.Task,TaskGroup:U.TaskGroup,TaskPanelKind:U.TaskPanelKind,TaskRevealKind:U.TaskRevealKind,TaskScope:U.TaskScope,TextDocumentSaveReason:U.TextDocumentSaveReason,TextEdit:U.TextEdit,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:U.TextEditorLineNumbersStyle,TextEditorRevealType:U.TextEditorRevealType,TextEditorSelectionChangeKind:U.TextEditorSelectionChangeKind,ThemeColor:U.ThemeColor,ThemeIcon:U.ThemeIcon,TreeItem:U.TreeItem,TreeItemCollapsibleState:U.TreeItemCollapsibleState,UIKind:f.UIKind,Uri:I.URI,ViewColumn:U.ViewColumn,WorkspaceEdit:U.WorkspaceEdit,InlineHint:U.InlineHint,InlineHintKind:U.InlineHintKind,RemoteAuthorityResolverError:U.RemoteAuthorityResolverError,ResolvedAuthority:U.ResolvedAuthority,SourceControlInputBoxValidationType:U.SourceControlInputBoxValidationType,ExtensionRuntime:U.ExtensionRuntime,TimelineItem:U.TimelineItem,NotebookCellRange:U.NotebookCellRange,NotebookCellKind:U.NotebookCellKind,NotebookCellRunState:U.NotebookCellRunState,NotebookDocumentMetadata:U.NotebookDocumentMetadata,NotebookCellMetadata:U.NotebookCellMetadata,NotebookCellData:U.NotebookCellData,NotebookData:U.NotebookData,NotebookRunState:U.NotebookRunState,NotebookCellStatusBarAlignment:U.NotebookCellStatusBarAlignment,NotebookEditorRevealType:U.NotebookEditorRevealType,NotebookCellOutput:U.NotebookCellOutput,NotebookCellOutputItem:U.NotebookCellOutputItem,LinkedEditingRanges:U.LinkedEditingRanges,TestItem:U.TestItem,TestState:U.TestState,TestResult:U.TestResult,TestMessage:U.TestMessage,TestMessageSeverity:U.TestMessageSeverity,WorkspaceTrustState:U.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=fe}),define(we[221],Ee([0,1,61,98,31,97,35,73,40,41,100,101,102,76,75,67,72,99,74,49,71,93]),function(oe,e,w,D,T,P,S,I,y,n,A,k,_,f,r,h,p,m,v,d,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(f.IExtensionStoragePaths,f.ExtensionStoragePaths),(0,w.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,w.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,w.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,w.registerSingleton)(v.IExtHostConsumerFileSystem,v.ExtHostConsumerFileSystem),(0,w.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService),(0,w.registerSingleton)(P.IExtHostDecorations,P.ExtHostDecorations),(0,w.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,w.registerSingleton)(D.IExtHostOutputService,D.ExtHostOutputService),(0,w.registerSingleton)(_.IExtHostSearch,_.ExtHostSearch),(0,w.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,w.registerSingleton)(A.IExtHostTask,A.WorkerExtHostTask),(0,w.registerSingleton)(n.IExtHostTerminalService,n.WorkerExtHostTerminalService),(0,w.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,w.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,w.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace),(0,w.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,w.registerSingleton)(o.IExtHostTelemetry,o.ExtHostTelemetry)}),define(we[222],Ee([0,1,220,36,216,7,13,5]),function(oe,e,w,D,T,P,S,I){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var n;(function(r){var h;const p=(h=self.trustedTypes)===null||h===void 0?void 0:h.createPolicy("TrustedFunctionWorkaround",{createScript:(v,...d)=>{d.forEach(i=>{var u;if(!((u=self.trustedTypes)===null||u===void 0?void 0:u.isScript(i)))throw new Error("TrustedScripts only, please")});const c=d.slice(0,-1).join(","),o=d.pop().toString();return`(function anonymous(${c}) {
${o}
})`}});function m(...v){return p?self.eval(p.createScript("",...v)):new Function(...v)}r.create=m})(n||(n={}));class A extends T.RequireInterceptor{_installInterceptor(){}getModule(h,p){for(let m of this._alternatives){let v=m(h);if(v){h=v;break}}if(this._factories.has(h))return this._factories.get(h).load(h,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class k extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=P.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const h=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);f(h);const p=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(A,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(h){return h.browser}async _loadCommonJSModule(h,p,m){var v,d,c,o,t,i,u,l;p=p.with({path:_(p.path,".js")}),h&&performance.mark(`code/extHost/willFetchExtensionCode/${h.value}`);const s=await fetch(p.toString(!0));if(h&&performance.mark(`code/extHost/didFetchExtensionCode/${h.value}`),s.status!==200)throw new Error(s.statusText);const a=await s.text(),E=`${p.toString(!0)}#vscode-extension`,R=`${a}
//# sourceURL=${E}`;let g;try{g=n.create((d=(v=k._ttpExtensionScripts)===null||v===void 0?void 0:v.createScript("module"))!==null&&d!==void 0?d:"module",(o=(c=k._ttpExtensionScripts)===null||c===void 0?void 0:c.createScript("exports"))!==null&&o!==void 0?o:"exports",(i=(t=k._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&i!==void 0?i:"require",(l=(u=k._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript(R))!==null&&l!==void 0?l:R)}catch(x){throw h?console.error(`Loading code for extension ${h.value} failed: ${x.message}`):console.error(`Loading code failed: ${x.message}`),console.error(`${p.toString(!0)}${typeof x.line=="number"?` line ${x.line}`:""}${typeof x.column=="number"?` column ${x.column}`:""}`),console.error(x),x}const b={},C={exports:b},F=x=>{const le=this._fakeModules.getModule(x,p);if(le===void 0)throw new Error(`Cannot load module '${x}'`);return le};try{return m.codeLoadingStart(),h&&performance.mark(`code/extHost/willLoadExtensionCode/${h.value}`),g(C,b,F),C.exports!==b?C.exports:b}finally{h&&performance.mark(`code/extHost/didLoadExtensionCode/${h.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(h){throw new Error("Not supported")}async _waitForDebuggerAttachment(h=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const p=Date.now()+h;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=k,k._ttpExtensionScripts=(y=self.trustedTypes)===null||y===void 0?void 0:y.createPolicy("ExtensionScripts",{createScript:r=>r});function _(r,h){return r.endsWith(h)?r:r+h}function f(r){h("info","log"),h("log","log"),h("warn","warn"),h("error","error");function h(v,d){console[v]=function(){r.$logExtensionHostMessage({type:"__$console",severity:d,arguments:m(arguments)})}}const p=1e5;function m(v){const d=[],c=[];if(v.length)for(let o=0;o<v.length;o++){if(typeof v[o]=="undefined")v[o]="undefined";else if(v[o]instanceof Error){const t=v[o];t.stack?v[o]=t.stack:v[o]=t.toString()}c.push(v[o])}try{const o=JSON.stringify(c,function(t,i){if(i&&typeof i=="object"){if(d.indexOf(i)!==-1)return"[Circular]";d.push(i)}return i});return o.length>p?"Output omitted for a large object that exceeds the limits":o}catch(o){return`Output omitted for an object that cannot be inspected ('${o.toString()}')`}}}}),define(we[223],Ee([0,1,61,19,36,222,208]),function(oe,e,w,D,T,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(T.IExtHostExtensionService,P.ExtHostExtensionService),(0,w.registerSingleton)(D.ILogService,S.ExtHostLogService)}),define(we[225],Ee([0,1,26,3,180,217,210,11,77,221,223]),function(oe,e,w,D,T,P,S,I,y){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0});const A=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const k=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const p=(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("extensionHostWorker",{createScriptURL:v=>v}),m=self.Worker;Worker=function(v,d){const c=`importScripts('${v}');`;d=d||{},d.name=d.name||I.basename(v.toString());const o=new Blob([c],{type:"application/javascript"}),t=URL.createObjectURL(o);return new m(p?p.createScriptURL(t):t,d)}}else self.Worker=class extends S.NestedWorker{constructor(p,m){super(k,p,Object.assign({name:I.basename(p.toString())},m))}};const _=new class{exit(p){A()}async exists(p){return!0}async realpath(p){return p}};class f{constructor(){const m=new MessageChannel,v=new D.Emitter;let d=!1;k(m.port2,[m.port2]),m.port1.onmessage=c=>{const{data:o}=c;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const t=w.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,T.isMessageOfType)(t,2)){d=!0,h("received terminate message from renderer");return}v.fire(t)},this.protocol={onMessage:v.event,send:c=>{if(!d){const o=c.buffer.buffer.slice(c.buffer.byteOffset,c.buffer.byteOffset+c.buffer.byteLength);m.port1.postMessage(o,[o])}}}}}function r(p){return new Promise(m=>{const v=p.onMessage(d=>{v.dispose();const c=JSON.parse(d.toString());p.send((0,T.createMessageOfType)(0)),m({protocol:p,initData:c})});p.send((0,T.createMessageOfType)(1))})}let h=p=>A();(function(){const m=new f;y.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(v=>{y.mark("code/extHost/didWaitForInitData");const d=new P.ExtensionHostMain(v.protocol,v.initData,_,null);h=c=>d.terminate(c)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/469e4f6e2755b220dae3eccb04d1ddc587b84a5a/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
